<?php
/* -------------------------------------------------------------------------------------
	Resize機能追加 Used jquery/jquery-ui : phpから連動
	 jquery-ui:Resizable :リサイズハンドラーとしてdiv要素を対象要素の子ノードとして追加するが
	 iframeにappendChildできないのでiframeをdivで囲みdivをリサイズ対象にする
	  jQuery UI Resizable : 基本的な書き方
	   $(function(){
	 	$('#{id}').resizable({ handles: 'e, s, se' });
	 	 });
	 	「TakiTakeの日記」を参考に作成
-------------------------------------------------------------------------------------- */
/*
	DispView_Extend_Opt($fldary): Display View Extend Box : 内部拡張Viewer Resize機能追加
	 $fldary   : io : Function compact : Item Array 設定値を含めれば,連動する
	※機能追加用のモジュールを作成時,引数を1個付けておく。
	  引数ダンプ:Array ([width] => 478[height] => 634[minWidth] => 350[minHeight] => 263[frmwidth_def] => 6[frmheight_def] => 8[frmwidth] => 472[frmheight] => 626[func] => DispView_Extend_Opt )       
*/
function DispView_Extend_Opt($fldary="") {
// 初期値 $fldaryで変更されない場合
	$id='#idExtendWap';		// Warpper id: iframeを囲む<divid
	$idfrm='#idExtFrm';		// 同時に動かすiframe id
	$idwork1='#idExtend';		// Widthのみ連動(1) Div id
	$idwork2='#idExtendMe';		// Widthのみ連動(2) Div id

	$width=478;$height=634;$minWidth=350;	// 設定値 全体のWidth :$width , 全体のHeight :$height , Resizable Property 最小Width :$minWidth
	$minHeight=($width/$height)*$minWidth;	// 設定値(計算値) Resizable Property 最小Height:$minHeight $widthと$height比率より$minWidthを元に計算
	if(is_array($fldary)) { extract($fldary,EXTR_OVERWRITE); }	// EXTR_OVERWRITE: 既に同名の変数が存在する場合上書き
	$divwork1='';$divwork2='';
	if ($idwork1 !=="") { $divwork1='$(\''.$idwork1.'\').outerWidth(Wid);'; }	// Widthのみ連動(1):連動のidが不要であれば''を設定
	if ($idwork2 !=="") { $divwork2='$(\''.$idwork2.'\').outerWidth(Wid);'; }	// Widthのみ連動(2):連動のidが不要であれば''を設定

//print_r($fldary); // ※引数の内容確認するとき使用
$JQUERY_JS="jquery-ui-1.12.1/jquery-3.4.0.min.js";
$dateformjs="";
if (file_exists($JQUERY_JS)) {				// Local Serverにjqueryを用意しているかチェック
	 $date = new DateTime();
	 $date->setTimestamp(filemtime($JQUERY_JS));
	 $dateformjs=$date->format('YmdHis');	// 変更時反映
	 $dateformjs="?a=".$dateformjs;
	 }
else {
	 $JQUERY_JS="https://code.jquery.com/jquery-3.4.1.min.js";
	 }
$JQUERY_UI="jquery-ui-1.12.1/jquery-ui.min.js";
$JQUERY_CS="jquery-ui-1.12.1/themes/base/jquery-ui.css";
$dateformui="";
if (file_exists($JQUERY_UI)) {				// Local Serverにjquery-uiを用意しているかチェック
	 $date = new DateTime();
	 $date->setTimestamp(filemtime($JQUERY_UI));
	 $dateformui=$date->format('YmdHis');	// 変更時反映
	 $dateformui="?a=".$dateformui;
	 }
else {
	 $JQUERY_UI="http://code.jquery.com/ui/1.10.3/jquery-ui.min.js";
	 $JQUERY_CS="http://code.jquery.com/ui/1.10.3/themes/cupertino/jquery-ui.min.css";
	 }

echo <<<EOM
<link rel="stylesheet" href="{$JQUERY_CS}">
<script type="text/javascript" src="{$JQUERY_JS}{$dateformjs}"></script>
<script type="text/javascript" src="{$JQUERY_UI}{$dateformui}"></script>

<script type="text/javascript">
/* -------------------------------------------------------------------------------------
	JQuery : $('#idExtendWap').resizable : ExtendView Resize
	参考 http://takitake.hatenablog.com/entry/20090808/p1
-------------------------------------------------------------------------------------- */
$(function()
{
	$('{$id}').resizable({
		handles: 'e, s, se',
		minHeight:{$minWidth},		// Resizable Property 最小Width
	  	minWidth:{$minHeight},		// Resizable Property 最小Height
		alsoResize: '{$idfrm}',
		start: function(event, ui)
		{	// Add frame helpers
    		$("iframe").each(function() {
			var offsetWidth = this.offsetWidth, offsetHeight = this.offsetHeight;
			$('<div class="ui-resizable-iframeFix" style="background: #fff;"></div>')
			.css({
				width: offsetWidth+"px", height: offsetHeight+"px",
				position: "absolute", opacity: "0.001", zIndex: 1000
				})
			.css($(this).offset())
				.appendTo("body")
				.data("resizable", { width: offsetWidth, height: offsetHeight });
				});
			},
			resize: function(event, ui)
			{
				Wid=$('{$id}').outerWidth();			// 動かす<div id
				{$divwork1}
				{$divwork2}
				var self = $('{$id}').data("resizable"), o = self.options, os = self.originalSize, op = self.originalPosition;
				var delta = {
				height: (self.size.height - os.height) || 0, width: (self.size.width - os.width) || 0,
				top: (self.position.top - op.top) || 0, left: (self.position.left - op.left) || 0
				},
			_alsoResize = function(exp, c) {
			$(exp).each(function() {
			var el = $(this), start = $(this).data("resizable"), style = {}, css = c && c.length ? c : ['width', 'height', 'top', 'left'];
			$.each(css || ['width', 'height', 'top', 'left'], function(i, prop) {
			// iframeより少し大きめに設定することで、iframe上でmouseupしてしまったときにmouseupイベント捕捉できない問題解消
			var sum = (start[prop]||0) + (delta[prop]||0) + 5;
			if (sum && sum >= 0)
				style[prop] = sum || null;
				});
			//Opera fixing relative position
			if (/relative/.test(el.css('position')) && $.browser.opera) {
				self._revertToRelativePosition = true;
				el.css({ position: 'absolute', top: 'auto', left: 'auto' });
				}
			el.css(style);
			});
		};
	_alsoResize('div.ui-resizable-iframeFix', ['width', 'height']);
	},
	stop:function(event, ui)
	{
 		// Remove frame helpers
		$("div.ui-resizable-iframeFix")
		.removeData('resizable')
		.each(function() { this.parentNode.removeChild(this); });
		}
	});
});
</script>
EOM;

	}

?>