<?php
ini_set("gd.jpeg_ignore_warning","1");
ignore_user_abort(false);
$width = $_GET["width"];			// 出力する画像サイズの指定
$url = $_GET["url"];				// 画像のURL or Path Localの場合 Pathで指定すること
//readfile($url);
$lib="gd";
if(isset($_GET["lib"])) {			// 使用ライブラリ
	 $lib=$_GET["lib"];
	 }
if ($lib=="gd") {
	 imagelib_gd($width,$url);
	 }
else if ($lib=="Imagick") {
	 imagelib_Image($width,$url);
	 }
exit;

/* -----------------------------------------------------------------------------
	imagelib_gd($width,$url) : Image Library GD
	 $width  : i  : 出力する画像サイズの指定
	 $url    : i  : 画像のURL or Path Localの場合 Pathで指定すること
	                例 url=/var/www/html/Music/NAS/music/Music3/10cc/Folder.jpg&width=100
	install
	  debian系/Volumio2
	  apt-get install php-gd
	確認方法
	  php -i "(command-line 'phpinfo()')" | grep GD

	参考) https://sterfield.co.jp/designer/phpを手軽に使って、画像のサムネイルを出力する/
------------------------------------------------------------------------------ */
function imagelib_gd($width,$url) {
	list($image_w, $image_h) = getimagesize($url);		// 元画像のファイルサイズを取得
	$proportion = $image_w / $image_h;					//元画像の比率を計算し、高さを設定
	$height = $width / $proportion;						//高さが幅より大きい場合は、高さを幅に合わせ、横幅を縮小
	if($proportion < 1){
		$height = $width;
		$width = $width * $proportion;
		}
	if (function_exists("imagecreatetruecolor")===false ) {	// サイズを指定して、背景用画像を生成
		print "imagecreatetruecolor exist";
		exit;
		}
	header('Content-type: image/jpeg');					// content type ヘッダ設定 : image/jpeg
	$canvas = imagecreatetruecolor($width, $height);	// Memory Image Area (背景画像)
	$image = imagecreatefromstring(readfile($url));	// ファイル名から、画像インスタンスを生成(File形式に依らない)
//	$image = imagecreatefromjpeg($url);					// ファイル名から、画像インスタンスを生成(File jpg
	if ($image === false) { 
		 $text_color = imagecolorallocate($canvas,255,255,255);		// Text On Jpg
		 imagestring($canvas, 20, 100, 100,  'imagecreatefromjpeg false',$text_color);
		 }
	else {		// 背景画像に、画像をコピーする
		 imagecopyresampled($canvas,$image,0,0,0,0,$width,$height,$image_w,$image_h);  // 背景画像,コピー元画像,背景画像X座標,背景画像Y座標,コピー元X座標,コピー元Y座標,背景画像幅,背景画像高さ
		 }
	imagejpeg($canvas,NULL,75);							// 背景画像,出力する(ファイル名を省略すると画面に表示する),画像精度
//	imagejpeg($canvas,"/tmp/xxxx.jpg",75);				// 背景画像,出力するファイル名,画像精度
	imagedestroy($canvas);								// メモリを開放する
	}

/* -----------------------------------------------------------------------------
	imagelib_Image($width,$url) : Image Library ImageMagic
	 $width  : i  : 出力する画像サイズの指定
	 $url    : i  : 画像のURL or Path Localの場合 Pathで指定すること
	                例 url=/var/www/html/Music/NAS/music/Music3/10cc/Folder.jpg&width=100
	 元画像のファイルサイズを取得
	 正方形 : $widthx$widthに収まるように縮小

	install
	  debian x64系
	  jpgでの出力に,GDを使用するため上記,GDをインストールする必要がある。(ファイルを作成しないため)
	  apt-get install php-gd
	  apt-get install php-imagick
	( apt-get install imagemagick 動かない場合 PHP7以降:同時にインストールされるもので解決
	  apt-get install libmagickwand-dev 更に動かない場合 )

	  Volumio2などlibmagickwand-devでインストールしても,phpinfoでlibmagickが使用できないケースがあるが,その場合アンインストールすること
	    uninstall : apt-get remove --purge imagemagick
	    uninstall : apt-get remove --purge libmagickwand-dev
	    Imagick() Classが存在すると使用ライブラリの判断ができないため保証できなくなる
	    armではapt-get install imagemagick libmagickwand-devだけでは使用できなかった。
	確認方法
	  php -i "(command-line 'phpinfo()')" | grep GD
	  php -i "(command-line 'phpinfo()')" | grep imagick
	参考) https://symfoware.blog.fc2.com/blog-entry-1579.html
------------------------------------------------------------------------------ */
function imagelib_Image($width,$url) {
//	$image = new Imagick('sample.jpg'); File指定でも可
	$image = new Imagick();
//	$image->readImage($url);
	$imgfile = readfile($url);					// ファイル名から、画像インスタンスを生成
	$image->readImageBlob($imgfile);			// Imagick インスタンス

	list($image_w, $image_h) = getimagesize($url);		// 元画像のファイルサイズを取得
	$proportion = $image_w / $image_h;					//元画像の比率を計算し、高さを設定
	$height = $width / $proportion;						//高さが幅より大きい場合は、高さを幅に合わせ、横幅を縮小
	if($proportion < 1){
		$height = $width;
		$width = $width * $proportion;
		}
	$image->setOption('jpeg:size',$width.'x'.$height);	// オプションを設定する

	$image->scaleImage($width, $height);				// 縮小実行
	$write_image = ImageCreateFromString($image->getImageBlob());	// GDの機能で保存する
	header('Content-type: image/jpeg');
	ImageJpeg($write_image,NULL,75);
	imagedestroy($canvas);
	}
//----- Source End --------------------------------------------------------------
?>
