#!/usr/bin/php
<?php
/*******************************************************************************
	mpddayli.php {all} : Shell mpd D/B Update
	Update方法
	  ≠all : mpd D/B Update     Used:mpdconfig.xml<Mpd_net>
	  all   : All mpd D/B Update Used:mpdmyset.xml <Mpd_net>
    Update制限
	  ignore: mpd D/B Update中でもmpd D/B Update発行
	message
	  onmsg     : Host Openメッセージもsyslog出力
	  onmsg=all : Start/Endも含めメッセージもsyslog出力
	 ※Test時&確認時にSyslogを確認できる
	   Logしない時もConsole出力を行う。

	ex)
	 mpddayli.php all ignore  : :mpdmyset.xml <Mpd_net>全て無条件Update
	 mpddayli.php onmsg

	Logを書き込んでいるが確認方法
	$ journalctl -t mpdweb -f
	$ sudo tail -f /var/log/syslog | grep mpdweb

  ※設定方法
    setting/mpddayli.cron
	  cron.dの編集 {user} /path/to/command
	  *  *  *  *  *
	  分 時 日 月 曜(0-7)

	 0 3 * * * root /usr/local/bin/mpddayli.sh : 毎日3時実行

	start.d/startp_mpddayli.conf.sample → startp_mpddayli.conf
    StartUpで再起動で登録するか即時実行で登録
	/usr/local/bin/mpddayli.shを作成する
	作成するshell
	#!/bin/bash
	cd /var/www/html/mpdweb
	/var/www/html/mpdweb/mpddayli.php
	exit 0
*******************************************************************************/

// syslog output 設定
ini_set('log_errors', '1'); 			// PHPがエラーをログに書くようにする
ini_set('display_errors', '1'); 	    // ユーザー画面にエラーを出さない（本番向け）
ini_set('display_startup_errors', '1'); // 起動時のエラーも表示
error_reporting(E_ALL);           		// すべての種類のエラーを報告対象にする
openlog("mpdweb", LOG_PID | LOG_PERROR, LOG_USER);
// Include Module
$require_hostlib=dirname(__FILE__).'/mpdweb.lib.php';
require_once($require_hostlib);
$require_hostlib=dirname(__FILE__).'/mpdweb.lib_mpd.php';
require_once($require_hostlib);
$require_hostlib=dirname(__FILE__).'/mpdhost.lib.php';		// mpdhost Common Library mpdhost.lib.php
require_once($require_hostlib);
$ARG_ALL="one";$ARG_IGNORE="no";$ARG_ONMSG="no";
	$argv = array_map('strtolower',$_SERVER['argv']);
	if (in_array("all",$argv)) {
		$ARG_ALL="1";
		}
	if (in_array("ignore",$argv)) {
		$ARG_IGNORE="yes";
		}
	if (in_array("onmsg",$argv)) {
		$ARG_ONMSG="yes";
		}
	if (in_array("onmsg=all",$argv)) {
		$ARG_ONMSG="all";
		}
if ($ARG_ALL=="one") {
	 RequestUpdate($ARG_IGNORE,$ARG_ONMSG);		// single Update
	 }
else {
	 RequestAllUpdate($ARG_IGNORE,$ARG_ONMSG);		// All Update
	 }
closelog();
exit;

/* -----------------------------------------------------------------------------
	RequestUpdate($ignore) : mpd D/B Update Used:mpdconfig.xml<Mpd_net>
	$ignore  : i  ; "yes":強制Update | "no":mpd D/B Update中はUpdateしない
----------------------------------------------------------------------------- */
function RequestUpdate($ignore,$onmsg) {
	global $XML_CONF;
	$str= "mpddayli:mpd D/B Update Start Ignore:".$ignore;
	if ($onmsg=="all") {
		 syslog(LOG_INFO,$str);
		 }
	else {
		 print $str."\n";
		 }
	$XML_File = "setting/mpdconfig.xml";
	try {
		$XML_CONF = get_loadconfig($XML_File);										// XML File Get FileNameはLibrary標準
		} catch( Exception $e ) {
		  $ret=$e->getMessage();
		  print "mpddayli:mpd Update Get Error(".$XML_File.")\n";
		  return;
		}
	$mpd=array("host"=>"","port"=>"","pass"=>"");
	get_config("Mpd_net",$mpd);	
	Request_mpd_update($mpd['host'],$mpd['port'],$mpd['pass'],$ignore,$onmsg);

	$str= "mpddayli:mpd D/B Update End";
	if ($onmsg=="all") {
		 syslog(LOG_INFO,$str);
		 }
	else {
		 print $str."\n";
		 }
	}

/* -----------------------------------------------------------------------------
	RequestAllUpdate() : All mpd D/B Update Used:mpdmyset.xml<Mpd_net>
	$ignore  : i  ; "yes":強制Update | "no":mpd D/B Update中はUpdateしない
----------------------------------------------------------------------------- */
function RequestAllUpdate($ignore,$onmsg) {
	global $XML_MPDSRV;

	$str= "mpddayli:Multi mpd D/B Update Start Ignore:".$ignore;
	if ($onmsg=="all") {
		 syslog(LOG_INFO,$str);
		 }
	else {
		 print $str."\n";
		 }

	$result=array();
	GetMyEnv("Mpd_net");
	foreach($XML_MPDSRV as $key=> $val) {						// Session Clearが設定されていないときは追加
		if ((isset($val['host']))&&(isset($val['port']))) {		// <host><port>指定時,mpdweb.php切替設定
			$pass="";
			if(isset($val['pass'])) {
				$pass=$val['pass'];
				}
			Request_mpd_update($val['host'],$val['port'],$pass,$ignore,$onmsg);
			}
		}
	$str= "mpddayli:Multi mpd D/B Update End";
	if ($onmsg=="all") {
		 syslog(LOG_INFO,$str);
		 }
	else {
		 print $str."\n";
		 }
	}

/* -----------------------------------------------------------------------------
	Request_mpd_update() : mpd D/B Update
	$host    : i  : mpd Connect Host
	$port    : i  : mpd Connect Port
	$pass    : i  : mpd Connect Pass  : 現在未実行(Passwordの通過/設定に不明がある)
	$ignore  : i  : "yes":強制Update | "no":mpd D/B Update中はUpdateしない
----------------------------------------------------------------------------- */
function Request_mpd_update($host,$port,$pass,$ignore,$onmsg) {
	global $Net;

	$Net = new Net_Common;
	$Net->c_timeout =5;
	$Net->p_connect['host'] = $host;
	$Net->p_connect['port'] = $port;
	if((isset($val['pass']))&&(rtrim($val['pass']) !=="")) {
		 $str=rtrim($pass);
		 $Net->p_connect['password'] = $str;
		 }
	if (!$Net->connect()) {
		mpd_close();
		$str= "mpddayli:Connect Error Host[".$host."]Port[".$port."]".$Net->p_error;		// 無条件にsysout
		syslog(LOG_INFO,$str);
		return;
		}

	$query_dmy = array();				// Status Get
	$update_go="1";
	$output = $Net->runCommand("status",$query_dmy,2);
	if ((isset($output["updating_db"][0]))&&($ignore=="no")) {
		$update_go="0";
		$str= "mpddayli:Cancelled due to update Host[".$host."]";		// 無条件にsysout
		syslog(LOG_INFO,$str);
		}
	if($update_go=="1") {
		$output = $Net->runCommand("update","",2);
		$str= "mpddayli:mpd D/B Update Host[".$host."]Port[".$port."]";
		if (($onmsg=="yes")||($onmsg=="all")) {
			 syslog(LOG_INFO,$str);
			 }
		else {
			 print $str."\n";
			 }
		}
	mpd_close();
	}
?>
