<?php
/***************************************************************************************
	mpd Host Common Library
	外部I/F
	 setting/mpdmyset.xml : 配布しない設定XML
	Reesource: 
	 mpdweb.lib.php
	  get_loadconf() : 復帰後Callingで<Mpd_net>を変更
****************************************************************************************/
$HOSTLIBVER=basename(__FILE__)." Ver:0.8 (31.08.2021)";

global $XML_MYSETTING;$XML_MYSETTING='setting/mpdmyset.xml';	// MPDHost Setting XML

$require_mod=dirname(__FILE__).'/mpdweb.lib.php';				// Mpd XML Basic Library mpdweb.lib.php
require_once($require_mod);										// Mpd : Original Library mpdwen.lib.php

/* -------------------------------------------------------------------------------------
	GetMyEnv($mode) : Get Setting XML (mpdmyset)
	 $mode   : i  : "":Get All , "1":Get Setting ("Mpd_net"/"Favorites "除く)
	 @return : o  : Normal End true
-------------------------------------------------------------------------------------- */
function GetMyEnv($mode="") {
	global $XML_CONF,$XML_MPDNET,$XML_ALT,$XML_HOSTSET,$XML_MYEXTENDIF,$XML_FRAMESET,$XML_FORMLOAD;
	global $XML_MPDSRV,$XML_MPDFAV,$XML_MPDSRVALT,$XML_MPDFAVALT,$XML_MPDFAVDUP;	// MPDHost, Favorites
	global $XML_MYSETTING;															// MPDHost Setting XML

	$XML_MPDNET=array("host"=>"localhost","port"=>"6600", 'pass' => null);
	get_config("Mpd_net",$XML_MPDNET);
	$XML_MPDNET["netmask"]="";
	get_config("Mpd_exclusive",$XML_MPDNET);
	$XML_ALT=array("XMLAlternative"=>"","Codeset"=>"utf-8");
	get_config("LibConf",$XML_ALT);
	$XML_EXTENDIF=array("IF_DivName"=>"");					// IF_DivName=""はI/F無効
	get_config("ExtendIF",$XML_EXTENDIF);					// XML File, PlayPanel Function設定
	$MPDWEB_IF=$XML_EXTENDIF["IF_DivName"];

	$XMLARY=NULL;
	$XML_File = $XML_MYSETTING;
	$ret="";
	try {													// XML Fileがない場合も初期作成するためエラーを破棄
		$XMLARY = get_loadxml($XML_File);			// XML File Get FileNameはLibrary標準
		} catch( Exception $e ) { }
	$XML_HOSTSET["TagLength"]="10";							// Tag Chracter 設定
	$XML_HOSTSET["TagInhibitChar1"]="!\"#$%&'=^~\|@:;+*,<>/? ()[]{}";	// Tag使用不可文字1
	$XML_HOSTSET["TagInhibitRep1"]="";							// Tag使用不可置換
	$XML_HOSTSET["TagInhibitChar2"]="　”’";					// Tag使用不可文字2
	$XML_HOSTSET["TagInhibitRep2"]="";							// Tag使用不可置換
	$XML_HOSTSET["TagFirstChar"]="1234567890　”’";			// Tag先頭不可文字
	$XML_HOSTSET["TagFirstRep"]="_";
	get_confxml($XMLARY,"XML_Restrict",$XML_HOSTSET);
	if ($XML_HOSTSET["TagLength"] < "3") { $XML_HOSTSET["TagLength"]="10"; }							// Tag Chracter 設定
//	if (($XML_HOSTSET["TagFirstRep"] == "")||($XML_HOSTSET["TagFirstRep"] == " ")) { $XML_HOSTSET["TagFirstRep"]="_"; }	// Tag 先頭文字置換""をデフォルトで使用したい場合この行を生かす

	$XML_MYEXTENDIF=array("IF_DivName"=>"{setting/main}");	// IF_DivName:外部AppliI/F:{setting/main}は呼び元のXMLを使用
	get_confxml($XMLARY,"ExtendIF",$XML_MYEXTENDIF);			// AutoConfigurationでは自動に作成しない
	if ($XML_MYEXTENDIF["IF_DivName"]=="{setting/main}") {
		if (isset($XML_EXTENDIF["IF_DivName"])) {
			 $XML_MYEXTENDIF["IF_DivName"]=$XML_EXTENDIF["IF_DivName"];
			 }
		else {
			 $XML_MYEXTENDIF["IF_DivName"]="";
			 }
		}
	$XML_FRAMESET=array("HostMax"=>"7","FavorMax"=>"7","FavorCharLeng"=>"16","FavorCharSubLeng"=>"16");
	get_confxml($XMLARY,"FrameConfig",$XML_FRAMESET);

	$XML_FORMLOAD=array("Mpd_netFunc"=>"mpdhost_formload()","FavoritesFunc"=>"mpdhost_formload()");
	get_confxml($XMLARY,"FormLoad",$XML_FORMLOAD);

	if ($mode =="1") { return(true); }

	$xmlary=get_xml_Array($XMLARY);
	$ary=array();
	if(isset($xmlary["Mpd_net"])) {
		$ary=$xmlary["Mpd_net"];
		}
	$XML_MPDSRV=array();$XML_MPDSRVALT=array();
	foreach((array)$ary  as $key=> $subary) {			// XML <Link> String
		if ($key=="comment") {continue;}
		foreach($subary as $subkey=> $val) {
			if (($subkey=="@attributes")&&(isset($val["lock"]))) {		// Mpd_net : Attributes "lock"はTag指定と同等にする(3階層は見ないので判定する)
				$XML_MPDSRV[$key]["lock"]=$val["lock"];
				}
			if (is_array($val)) {
				 if (count($val) == 0) {		// Valueがないとき 例)<pass></pass>
					 $XML_MPDSRV[$key][$subkey]="";
					 }
				 }
			else {
				 $XML_MPDSRV[$key][$subkey]=$val;
				 }
		 	}
		}
	$ary=array();
	if(isset($xmlary["Favorites"])) {
		$ary=$xmlary["Favorites"];
		}
	$XML_MPDFAV=array();$XML_MPDFAVALT=array();$XML_MPDFAVDUP=array();
	foreach((array)$ary  as $key=> $subary) {			// XML <Link> String
		if ($key=="comment") {continue;}
		if (!is_array($subary)) {
			$XML_MPDFAV[$key]["url"]=$subary;
			$XML_MPDFAVALT[$key]["url"]["alt"]="1";		// $XML_MPDFAVALT[$key]["url"]["alt"]:Child Tagがない時 代替えとして <url>にセットしているのでマーク
			continue;
			}
		foreach($subary as $subkey=> $val) {			// Favorites : Attributes "lock"は 3階層までforeachしているのでセットされる。
			if (is_array($val)) {
				 if (count($val) == 0) {
					  $XML_MPDFAV[$key][$subkey]="";
					  }
				 else {
					  $dkey=$key;
					  if (is_numeric($subkey)) {		// $subkey[@attributes] or [n]...:重複TagKey
						 if ($subkey > 0) {
							$dkey=$key."(".($subkey+1).")";
							$XML_MPDFAVDUP[$dkey]=$key;	// $XML_MPDFAVDUP[$dkey]:重複時のTag $key OriginalTag
							}
	 					 }
				 	  foreach($val as $okey=> $over) {
							if (($subkey==="close")&&($okey=="style")) {		// Close buttonを使用時 nameを付ける場合,style
								 $XML_MPDFAV[$dkey][$subkey]=$over;
								 continue;
								 }
							elseif (($subkey==="close")&&($okey=="name")) {		// Close buttonを使用時 nameを付ける
								$XML_MPDFAV[$dkey]["closename"]=$over;
								 continue;
								 }
							$XML_MPDFAV[$dkey][$okey]=$over;
				 			}
					  }
				 }
			else {
				 $XML_MPDFAV[$key][$subkey]=$val;
				 }
		 	}
		}
//print '<BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR>';
//print '$XML_MYSETTING['.$XML_MYSETTING."]<BR>";
//print '$XML_ALT<BR>'     ;print_r($XML_ALT);print "<BR>";
//print '$XML_HOSTSET<BR>' ;print_r($XML_HOSTSET);print "<BR>";
//print '$XML_FRAMESET<BR>';print_r($XML_FRAMESET);print "<BR>";
//print '$XML_MPDSRV<BR>'  ;print_r($XML_MPDSRV);print "<BR>";
//print '$XML_MPDFAV<BR>'  ;print_r($XML_MPDFAV);print "<BR>";
//print '$XML_FORMLOAD<BR>';print_r($XML_FORMLOAD);print "<BR>";
	return(true);
	}

?>
