<?php
/***************************************************************************************
	PC Port List
	Function
	※機能的に使い道が考えられるので,"/mpdweb/mpdweb.libcajax.js"以外は自前で行う。
	  他の作成ルールから独立しておく
************************************************************************************** */
$DEBUG=false;
//$DEBUG=1;		// $DEBUG=1:仮画面でテストできる
$MY_PCLVERSION=basename(__FILE__,"")." 1.0 (31.03.2024)";
/***************************************************************************************
	PC Port List Post Proc
************************************************************************************** */
if (isset($_POST['p'])) {
	if ($_POST['p']=="get") {		// MountList Update
		GetPCEnvGlobalCommon();
		PostPCListGet($_POST);
		exit;
		}
	}

/* -------------------------------------------------------------------------------------
	PostPCListGet($get) : Post Display PCListBox
------------------------------------------------------------------------------------- */
function PostPCListGet($get) {
	global $PCL_Top,$PCL_Left,$PCL_Width,$PCL_Height,$PCL_zIndex;
	global $PCL_Port,$PCL_Timeout,$PCL_Bbroadcast,$PCL_IPFrom,$PCL_IPTo;

	print "Function:DisplayPCLInfo('none');\n";
	GetPCEnvGlobalParam($get["port"],$get["timeout"],$get["broadcast"],$get["from"],$get["to"]);
	print "idPCListTbl:";
	DispPCList();
	print "\n";
	}
/* --------------------------- Post End of Source ----------------------------------- */

?>
<?php
/***************************************************************************************
	PC Port List Test Proc
************************************************************************************** */
if ($DEBUG==1) {
	DispPCListTest();
	$pcl_port=139;
	$pcl_title='cifs - Shared List';
	$pcl_timeout=0.01;
	$pcl_broadcast='192.168.0.1';			// GetPCEnvGlobalParamで"192.168.0"にするためIPをセット可
	$pcl_ipfrom=1;
	$pcl_ipto=255;
	$pcl_js='var str="//"+%s;document.getElementById("idSrcDev").value=str;';
	$pcl_pclistbox="idPCListBox";
	$pcl_scanout=30;						// Scan時全てTimeoutになった場合のSec
	DispPCListMain($pcl_port,$pcl_broadcast,$pcl_js,$pcl_timeout,$pcl_ipfrom,$pcl_ipto,$pcl_title,$pcl_pclistbox,$pcl_scanout);
	}

/*
	Using Test , Make HTML
*/
function DispPCListTest() {

echo <<<EOM
<input type="text" id="idSrcDev" class="InText" value="" style="top:50px;left:94px;width:290px;" spellcheck="false" data-ms-editor="true">
<input type="button" name="Submit" value="PCList" onclick="document.getElementById('idPCListBox').style.display='block'" />
<style type="text/css">
/* Common Start */
.box {border: 1px solid #888888;position:fixed;top:200px;left:170px;
      width:300px;height:238px;font-size:10p;z-index:5;
      background-color:#2f2f2f;
      display: none;
      }
.buttn    {border-style:none;width:50px;height:20px;padding:2px 0 2px;font-size:11px;cursor:pointer;-moz-border-radius:4px;-webkit-border-radius:4px;border-radius: 4px;}
.boxbcan  {position:absolute;top:180px;right:6px;}
/* Common End */
</style>
EOM;

$dateform="";
if (file_exists($jscommon)) {
	$date = new DateTime();
	$date->setTimestamp(filemtime($jscommon));
	$dateform=$date->format('YmdHis');
	$dateform="?a=".$dateform;
	}
echo <<<EOM
<script type="text/javascript" src="/mpdweb/mpdweb.libcajax.js{$dateform}"></script>
EOM;
/* --------------------------- Test End of Source ----------------------------------- */
	}

?>

<?php
/***************************************************************************************
	PC Port List Function 
************************************************************************************** */

/* -------------------------------------------------------------------------------------
	DispPCListMain($pcl_port,$pcl_broadcast,$pcl_js,$pcl_timeout,$pcl_ipfrom,$pcl_ipto,$pcl_title,$pcl_pclistbox,$pcl_scanout) : PC List Display
	$pcl_port     : i  : PC List Port Portの使用例参照
	$pcl_timeout  : i  : Portが開いていない場合のWait,Timeout (Defualt:0.01)
	$pcl_broadcast: i  : Scan(Broadcast) Network xxx.xxx.xxx . 例)192.168.0
	$pcl_js       : i  : PC List上 PC List Click時、実行js %sの部分にIPを挿入 例) var str="//"+%s;document.getElementById("idSrcDev").value=str;
	$pcl_ipfrom   : i  : Scan Start IP (Defualt:1)
	$pcl_ipto     : i  : Scan End IP   (Defualt:255)
	$pcl_title    : i  : PCList Box Title
	$pcl_pclistbox: i  : PCList Box HTML-id (Defualt:idPCListBox)
	$pcl_scanout  : i  : Scan時全てTimeoutになった場合のSecを指定(設定入力のチェック3のみで使用することに注意 Defualt:30）

	※Portの使用例)
	 $pcl_title='cifs - Shared List';$pcl_port=139;
	 $pcl_title='mpd - Server List'; $pcl_port=6600;
	 $pcl_title='TaskServer List';   $pcl_port=9050;
------------------------------------------------------------------------------------- */
function DispPCListMain($pcl_port,$pcl_broadcast,$pcl_js="",$pcl_timeout=0.01,$pcl_ipfrom=1,$pcl_ipto=255,$pcl_title="PCList",$pcl_pclistbox="idPCListBox",$pcl_scanout=30) {
	GetPCEnvGlobalParam($pcl_port,$pcl_timeout,$pcl_broadcast,$pcl_ipfrom,$pcl_ipto);
	$pcl_js=str_replace('%s', 'ipstr',$pcl_js);

?>
<style type="text/css">
/***************************************************************************************
	PC Port List Style Sheet
************************************************************************************** */
.PCListTbl { font-size:13px;font-weight:bold;text-decoration:none;top:0px;left:0px;padding:8px 10 2px;color:#CEECF5}
.PCListFrm { overflow-y:scroll;overflow-x:hidden;-ms-overflow-style:none;position:absolute;top:32px;left:10px;font-size:13px;background-color:#2E2E2E;color:#ffffff;border:1px solid #707070; }
.PCListFrm::-webkit-scrollbar { width:6px; } 				/* スクロールバー全体 */
.PCListFrm::-webkit-scrollbar-thumb { background:#808080; } /* スクロールバーつまみ */
.PCListFrmTbl { position:absolute;top:0px;left:0px;font-size:13px;background-color:#2E2E2E;color:#ffffff;border:0px solid #707070;}
.PCListFrmDtl {background-color:#000000;color:#ffffff;font-size:12p;font-weight:bold;text-decoration:none;white-space:nowrap;display:block;text-align:left;vertical-align:middle;padding:2px 0 2px;border:0px solid #333333;cursor:pointer;}
/* .PCListFrm::-webkit-scrollbar-track { background:#000000;box-shadow:inset 0 0 2px #77777; } */	/* スクロールバー背景(デザインにより) */
/* PCList Parameter Box */
.idPCLSetTxt { position:absolute;left:4px;font-size:12px;color:#ffffff; }
.idPCLSetInp { position:absolute;left:58px;font-size:12px;height:16px; }
</style>

<?php
/***************************************************************************************
	PC Port List Main Proc
************************************************************************************** */
	global $PCL_Top,$PCL_Left,$PCL_Width,$PCL_Height,$PCL_zIndex;
	global $PCL_Port,$PCL_Timeout,$PCL_Bbroadcast,$PCL_IPFrom,$PCL_IPTo;

	GetPCEnvGlobalCommon();
	echo <<<EOM
<script type="text/javascript">
/***************************************************************************************
	PCListBox , Script
************************************************************************************** */
var PCL_Timeout ='{$PCL_Timeout}';
var PCL_Bbroadcast ='{$PCL_Bbroadcast}';
var PCL_IPFrom ='{$PCL_IPFrom}';
var PCL_IPTo ='{$PCL_IPTo}';
/* -------------------------------------------------------------------------------------
	EventPCLUnload() : PCListBox Unload
	※$pcl_pclistbox:呼び出し元の名称に考慮し変更可能
------------------------------------------------------------------------------------- */
function EventPCLUnload() {
	document.getElementById('{$pcl_pclistbox}').style.display='none';
	}
/*
	DisplayPCLInfo(mode): PCL Get info
	mode   : i  : block / none
*/
function DisplayPCLInfo(mode) {
	document.getElementById('idPCListInf').style.display=mode;
	}
/*
	ArgPCLIPRep(ipstr) : PCListBox Unload
	ipstr  : i  : IP String
	※$pcl_js:js script calling argument
*/
function ArgPCLIPRep(ipstr) {
	{$pcl_js}
	}

/* -------------------------------------------------------------------------------------
	DisplayPCListInit() : PCListBox Parameter Init
------------------------------------------------------------------------------------- */
function DisplayPCListInit() {
	document.getElementById("idPCLSetIP").value=PCL_Bbroadcast;
	document.getElementById("idPCLSetIPF").value=PCL_IPFrom;
	document.getElementById("idPCLSetIPT").value=PCL_IPTo;
	document.getElementById("idPCLSetIPOut").value=PCL_Timeout;
	document.getElementById('idPCListSet').style.display='block';
	}

/* -------------------------------------------------------------------------------------
	DisplayPCListSet() : PCListBox Parameter Setting
------------------------------------------------------------------------------------- */
function DisplayPCListSet() {
	var str =document.getElementById("idPCLSetIP").value;
	var ary = str.split('.');
	if ((ary.length > 4)||(ary.length <= 2)) {
		DisplayPCLMsgBox("format is different xxx.xxx.xxx");		// 192.168.0.0 || 192.168.0.はOK Lastはなしとする
		return;
		}
	if ((ary.length > 3)&&((ary[3] !="")&&(ary[3] !="0"))) {
		DisplayPCLMsgBox("format is different xxx.xxx.xxx");
		return;
		}
	for (let i = 0; i < 3;++i) {
		if (parseInt(ary[i],10) > 255) {
			DisplayPCLMsgBox("CastIP range is 1 to 255");
			return;
			}
		}
	if ((parseInt(document.getElementById("idPCLSetIPF").value,10) < 1)||(parseInt(document.getElementById("idPCLSetIPF").value,10) > 255)) {
		DisplayPCLMsgBox("Scan range is 1 to 255");
		return;
		}
	if ((parseInt(document.getElementById("idPCLSetIPT").value,10) < 1)||(parseInt(document.getElementById("idPCLSetIPT").value,10) > 255)) {
		DisplayPCLMsgBox("Scan range is 1 to 255");
		return;
		}
	if (parseInt(document.getElementById("idPCLSetIPF").value,10) > parseInt(document.getElementById("idPCLSetIPT").value,10)) {
		DisplayPCLMsgBox("Enter from below to");
		return;
		}
	if (isNaN(document.getElementById("idPCLSetIPOut").value)) {	// Timeout Cheack
		DisplayPCLMsgBox("Enter Timeout as a number");
		return;
		}
	var no = (parseInt(document.getElementById("idPCLSetIPT").value,10) - parseInt(document.getElementById("idPCLSetIPF").value,10))*parseFloat(document.getElementById("idPCLSetIPOut").value);
	if (no > {$pcl_scanout}) {										// 全てTimeoutになった場合の時間が長い
		DisplayPCLMsgBox("If Timeout occurs,the setting is too long Reduce scan range or Timeout");
		return;
		}
	var fstr=document.getElementById("idPCLSetIPOut").value;
	var flottimeout=Number(fstr).toFixed(2);
	if ((flottimeout < 0.01)||(flottimeout > 0.100)) {
		DisplayPCLMsgBox("Timeout range is 0.01 to 0.1");
		return;
		}
	PCL_Bbroadcast=document.getElementById("idPCLSetIP").value;
	PCL_IPFrom=document.getElementById("idPCLSetIPF").value;
	PCL_IPTo=document.getElementById("idPCLSetIPT").value;
	PCL_Timeout=flottimeout;
	document.getElementById('idPCListSet').style.display='none';
	}

/* -------------------------------------------------------------------------------------
	DisplayPCLMsgBox(str) : PCList MessageBox
	str    : i  : Message
------------------------------------------------------------------------------------- */
function DisplayPCLMsgBox(str) {
	document.getElementById('idPCLMsgBox').style.display='block';
	document.getElementById('idPCLMsgStr').innerText=str;
	}
</script>
EOM;
// Display PCListBox
	print '<div id="'.$pcl_pclistbox.'" class="box" style="position:fixed;top:'.$PCL_Top.'px;left:'.$PCL_Left.'px;width:'.$PCL_Width.'px;height:'.$PCL_Height.'px;z-index:'.$PCL_zIndex.';">';
	print '<div align="left" class=PCListTbl style="width:'.($PCL_Width-24).'px;">'.$pcl_title.'</div>';
	DispPCList("init");

	$para="p=get&port=".$pcl_port."&timeout='+PCL_Timeout+'&broadcast='+PCL_Bbroadcast+'&from='+PCL_IPFrom+'&to='+PCL_IPTo+'";
	$prog=dirname($_SERVER['PHP_SELF'])."/".basename(__FILE__);
	$str="RequestByPost('".$prog."','".$para."');";
// Display PCListBox Function
	print '<input type="button" name="Submit" value="Get" onclick="DisplayPCLInfo(\'block\');'.$str.'" class="buttn boxbcan" style="top:'.($PCL_Height-26).'px;left:8px;" />';
	print '<input type="button" name="Submit" value="Set" onclick="DisplayPCListInit();" class="buttn boxbcan" style="top:'.($PCL_Height-26).'px;left:'.($PCL_Width/2-20).'px;width:40px;background:#6495ed;color:#ffffff;" />';
	print '<input type="button" name="Submit" value="Cancell" onclick="EventPCLUnload();" class="buttn boxbcan" style="top:'.($PCL_Height-26).'px;" />';
	print '</div>';

// Display PCList Setting
	$set_height=110;$set_top=$PCL_Top+$PCL_Height-$set_height+2;$set_width=240;$set_left=$PCL_Left+$PCL_Width/2-($set_width/2);$set_zindex=$PCL_zIndex+2;
	print '<div id="idPCListSet" class="box" style="position:fixed;top:'.$set_top.'px;left:'.$set_left.'px;width:'.$set_width.'px;height:'.$set_height.'px;background:#313131;z-index:'.($set_zindex).';">';
// Display PCList Parameter Box
echo <<<EOM
<div class="idPCLSetTxt" style="top:6px;">Cast&nbsp;IP</div>
<input type="text" id="idPCLSetIP" class="idPCLSetInp" maxlength="12" oninput="value = this.value.replace(/[^0-9.]/g, '')" value="" style="top:6px;width:94px;" />
<div class="idPCLSetTxt" style="top:6px;left:158px;">xxx.xxx.xxx</div>
<div class="idPCLSetTxt" style="top:26px;">Scan</div>
<input type="text" id="idPCLSetIPF" class="idPCLSetInp" maxlength="3" oninput="value = this.value.replace(/[^0-9]/g, '')" style="top:26px;width:30px;" />
<div class="idPCLSetTxt" style="top:26px;left:92px;">-</div>
<input type="text" id="idPCLSetIPT" class="idPCLSetInp" maxlength="3" oninput="value = this.value.replace(/[^0-9]/g, '')" style="top:26px;width:30px;left:102px;" />
<div class="idPCLSetTxt" style="top:26px;left:138px;">1-255</div>
<div class="idPCLSetTxt" style="top:46px;">Timeout</div>
<input type="text" id="idPCLSetIPOut" class="idPCLSetInp" maxlength="4" oninput="value = this.value.replace(/[^0-9.]/g, '')" style="top:46px;width:36px;" />
<div class="idPCLSetTxt" style="top:46px;left:98px;">9.99</div>
EOM;
print '<input type="button" name="Submit" value="Set" onclick="DisplayPCListSet();" class="buttn boxbcan" style="top:'.($set_height-34).'px;left:8px;" />';
print '<input type="button" name="Submit" value="Cancell" onclick="document.getElementById(\'idPCListSet\').style.display=\'none\';" class="buttn boxbcan" style="top:'.($set_height-34).'px;" />';
global $MY_PCLVERSION;
print '<div class="idPCLSetTxt" align="right" style="top:'.($set_height-13).'px;width:'.($set_width-10).'px;color:#8fbc8f;font-size:9px">'.$MY_PCLVERSION.'</div>';
print '</div>';
// Display PCList Message Box
$msg_width=240;$msg_height=120;$msg_top=$set_top-(160-$msg_height);$msg_left=$set_left-6;$msg_btn=$msg_width/2-20;$msg_btop=$msg_height-30;$msg_zindex=$set_zindex+2;
echo <<<EOM
<div id='idPCLMsgBox' class=box style="position:fixed;top:{$msg_top}px;left:{$msg_left}px;width:{$msg_width}px;height:160px;background-color:#f5f5f5;z-index:{$msg_zindex}">
<div style="width:{$msg_width}px;height:18px;text-align:center;background-color:#0000FF;color:#CEECF5;font-size:12px;">PCList Message</div>
<div id='idPCLMsgStr'style="position:absolute;top:60px;left:10px;width:200px;height:18px;text-align:center;color:#000000;font-size:14px;"></div>
<input type="button" name="Submit" class="buttn boxbcan" value="OK" onclick="document.getElementById('idPCLMsgBox').style.display='none';" style="top:130px;left:{$msg_btn}px;background-color:#d3d3d3;" />
</div>
EOM;

	}

/* -------------------------------------------------------------------------------------
	GetPCEnvGlobalCommon() : PCListBox Common Item Setteing
	※Display 位置を調整する場合、値を変更することで可能にする。
------------------------------------------------------------------------------------- */
function GetPCEnvGlobalCommon() {
	global $PCL_Top,$PCL_Left,$PCL_Width,$PCL_Height,$PCL_zIndex;

	$PCL_Top=50;$PCL_Left=200;$PCL_Width=200;$PCL_Height=300;$PCL_zIndex=400;
	}

/* -------------------------------------------------------------------------------------
	GetPCEnvGlobalParam($port,$timeout,$broadcast) : PCList Parameter Common Area
	$port     : i  : Cheack Port
	$timeout  : i  : Disable Timeout
	$broadcast: i  : IP Address xxx.xxx.xxx.の形式が必要

	※初期HTML生成 & Postで同じ項目として同じコードができるようにする。
------------------------------------------------------------------------------------- */
function GetPCEnvGlobalParam($port,$timeout,$broadcast,$ipfrom=1,$ipto=255) {
	global $PCL_Port,$PCL_Timeout,$PCL_Bbroadcast,$PCL_IPFrom,$PCL_IPTo;
	$PCL_Port=$port;
	$PCL_Timeout=$timeout;
	$tmp=str_replace(".","",$broadcast);			// 数字以外のIP:自Serverにする。
	if (!is_numeric($tmp)) {
		$broadcast=$_SERVER["SERVER_ADDR"];
		}
	$ary = explode(".",$broadcast);
	if ((count($ary) < 0)||(count($ary) > 4)) {		// IP形式が異なる:自Serverにする
		$broadcast=$_SERVER["SERVER_ADDR"];
		$ary = explode(".",$broadcast);
		}
	$str="";
	for ($i=0;$i < 3;$i++) {						// Format:xxx.xxx.xxx.に構成
		if(isset($ary[$i])) { $tmp=$ary[$i]; } else { $tmp=0; }
		$str=$str.$tmp.".";
		}
	$str=rtrim($str,".");							// Format:trim(xxx.xxx.xxx,".")
	$PCL_Bbroadcast=$str;
	if ($ipfrom <= 0) { $ipfrom=1; }				// 0でも良いが範囲を設定する
	$PCL_IPFrom=$ipfrom;
	$PCL_IPTo=$ipto;
	}

/* -------------------------------------------------------------------------------------
	DispPCList() : Display PCListBox
------------------------------------------------------------------------------------- */
function DispPCList($mode="") {
	global $PCL_Top,$PCL_Left,$PCL_Width,$PCL_Height,$PCL_zIndex;
	global $PCL_Port,$PCL_Timeout,$PCL_Bbroadcast,$PCL_IPFrom,$PCL_IPTo;

	print '<div id="idPCListTbl" class=PCListFrm style="width:'.($PCL_Width-24).'px;height:'.($PCL_Height-64).'px;">';
	print '<table border="0" cellpadding="0" bgcolor="#000000" frame=void class=PCListFrmTbl>';
	if ($mode !=="init") {
		 DispPCListDetail();
		 }
	print '</table>';
	print '</div>';
	if ($mode =="init") {
		 $height=60;$width=100;$zindex=$PCL_zIndex+1;
		 print '<div id="idPCListInf" class="box" style="position:absolute;top:'.(($PCL_Height-($height+40))/2).'px;left:'.($PCL_Width/2-($width/2+4)).'px;width:'.$width.'px;height:'.$height.'px;background-color:#000080;z-index:'.$zindex.';">';
		 print '<div style="position:absolute;top:20px;left:20px;color:#fffff0;font-size:12px;">Get List....</div>';
		 print '</div>';
		 }
	}

/* -------------------------------------------------------------------------------------
	DispPCListDetail() : Display PCListBox Detaile
	※ $broadcast='192.168.0';  SambaServer BroadcastIP
	   $timeout = 0.01;	  :  タイムアウトを設定
------------------------------------------------------------------------------------- */
function DispPCListDetail() {
	global $PCL_Port,$PCL_Timeout,$PCL_Bbroadcast,$PCL_IPFrom,$PCL_IPTo;

	$no=$PCL_IPFrom;$end=$PCL_IPTo;
	if ($PCL_IPFrom < 1) { $no=1; }
	if ($PCL_IPTo > 255) { $end=255; }

	for ($i=$no;$i <= $PCL_IPTo;$i++) {
		$host=$PCL_Bbroadcast.".".$i;
		$result=DispPCPortCheack($PCL_Port,$PCL_Timeout,$host);
		if ($result) {
			$str="ArgPCLIPRep('".$host."');";				// IPを置換&セット関数
			print '<tr id="IP'.$i.'"><td><button type=submit value="'.$host.'" class=PCListFrmDtl onclick="'.$str.'EventPCLUnload();" style="background-color:#2E2E2E;color:#ffffff;">&emsp;'.$host.'</button></td></tr>';
			}
		}
	}

/* **************************************************************************************
	共通化目的の関数
************************************************************************************** */
/* -------------------------------------------------------------------------------------
	DispPCPortCheack($port,$timeout,$host) : Port Open Cheack
	$port    : i  : Cheack Port
	$timeout : i  : Disable Timeout
	$host    : i  : Cheack Host
	@return  : o  : True Port Open False : Port Close
	※ samba:139 mpd:6600 9050:MPDWEB Taskserver
------------------------------------------------------------------------------------- */
function DispPCPortCheack($port=397,$timeout=0.03,$host) {
	$ret=False;
	if (filter_var($host, FILTER_VALIDATE_IP)) {
		$socket = @fsockopen($host,$port,$errno,$errstr,$timeout);	// 接続を試みる
		if ($socket) {
   			fclose($socket);
   			$ret=True;
			}
		}
	return($ret);
	}
/* --------------------------- End of Source ---------------------------------------- */
?>
