<?php
/********************************************************************************
	mpdsetting.php Extend function library
	mpdsetting_hostcnf.php : mpdhost.php : mpd Host Select / Favorites 設定
	Calling          : mpdsetting -> mpdsetting_hostcnf.php:DispHostCnf();
	Make Post Func / Make HTML / mpdhost.php:interface

	Resource:
	 mpdhost.lib.php : mpdhost Common Library
	 mpdsetting      : require Module
                       mpdweb.lib_appli.php / mpdxmlupdate.lib.php
	                   mpdweb.common.css / mpdweb.common.js
	 mpdhost.php     : mpdhost Connect Function

	※ $GURLCONNECT     : mpdsetting.phpシリーズとHeaderFunctionでURL共有部を編集

	WebServer上の"setting/mpdmyset.xml"をUpdateする。

********************************************************************************/
global $XML_MYSETTING;											// mpdhost.lib.phpでPathを設定:globalにする

$require_hostlib=dirname(__FILE__).'/mpdhost.lib.php';			// mpdhost Common Library mpdhost.lib.php GetMyEnv()使用
require_once($require_hostlib);
/*
	HostConfig 設定 $XML_MYSETTING='setting/mpdmyset.xml';
	Calling mpdsetting.php : DispHostCnf()
	  設定モジュール(mpdsetting.php):ヘッダー[DispHeader()]以降,ステータス[DispState()]の間を作成
	  mpdsetting.xml<Function><{Tag} include="./mpdsetting_hostcnf.php">p=extend&f=DispHostCnf で起動
*/

$MY_HOSTVER=basename(__FILE__,"")." 0.7 (10.04.2023)";
/* -------------------------------------------------------------------------------
	PostHostCnf($ARG) : Post Function Controle
	 $ARG        : i  : Argument [p]:extend,[f]:PostHostCnf [cmd]={Command Function}  :mpdsetup.phpで設定
------------------------------------------------------------------------------- */
function PostHostCnf($ARG) {
	global $ARG;

	print "PostHostCnf Start Cmd[".$ARG["cmd"]."]\n";
	$parent=array("MPDHost"=>"Mpd_net","Favorites"=>"Favorites");		// HTML上,Modeを'mpdmyset.xml'のParentTagに変換
	if (!isset($parent[$ARG["mode"]])) {
		print "PostHostCnf Error Cmd[".$ARG["cmd"]."] Mode Noting[".$ARG["mode"]."]\n";
		return;
		}
	$ARG["parent"]=$parent[$ARG["mode"]];
	GetHostCnfEnv();											// Get Host Configureation Env
	if ($ARG["cmd"]=="HostCnfRemove") {
		PostHostCnfRemove($ARG);
		}
	if ($ARG["cmd"]=="HostCnfUpdate") {
		$ret=PostHostCnfUpdate($ARG);
		if ($ret< 0) { return; }
		}
	if ($ARG["cmd"]=="HostCnfMove") {
		PostHostCnfMove($ARG);									// 重複タグの移動は再表示する
		if (!isset($ARG["new"])) {
			print "PostHostCnf End\n";
		 	return;
			}
		}
	print "grpHostCnfDtl:";										// Host Configuration List Detail 再表示
	GetMyEnv();					// Get XML
	DispHostCnfDetail();
	print "\n";
	print "PostHostCnf End\n";
	}

/* -------------------------------------------------------------------------------
	PostHostCnfRemove($ARG) : Host Configuretion Remove [cmd]:HostCnfRemove
	 $ARG  : i  : Argument [parent]:Parent Tag , [tag]:XML Tag
------------------------------------------------------------------------------- */
function PostHostCnfRemove($ARG) {
	global $XML_MYSETTING;

//	$dmyout='setting/test_sav.xml';
	$dmyout='';
	XMLTagRemove($XML_MYSETTING,$dmyout,$ARG["parent"],$ARG["tag"]);
	}

/* -------------------------------------------------------------------------------
	PostHostCnfRemove($ARG) : Host Configuretion Remove [cmd]:HostCnfRemove
	 $ARG  : i  : Argument [parent]:Parent Tag , [tag]:XML Tag
------------------------------------------------------------------------------- */
function PostHostCnfMove($ARG) {
	global $XML_MYSETTING;

//	$dmyout='setting/test_sav.xml';
	$dmyout='';
	$ret=XMLTagMove($XML_MYSETTING,$dmyout,$ARG["parent"],$ARG["from"],$ARG["to"]);
//	print "PostHostCnf Start Cmd[".$ARG["cmd"]."]parent[".$ARG["parent"]."] From[".$ARG["from"]."] To[".$ARG["to"]."] Return[".$ret."]\n";
	}

/* -------------------------------------------------------------------------------
	PostHostCnfUpdate($ARG) : Host Configuretion Update [cmd]:HostCnfUpdate
	 $ARG   : i  : Argument [parent]:Parent Tag , [{ChildTag}]:XML Tag
	 @return: o  : < 0: InputError , Update Error
------------------------------------------------------------------------------- */
function PostHostCnfUpdate($ARG) {
	global $XML_MYSETTING,$IDHSTBOX;

	$xmlary=array();
	foreach($ARG as $key => $val) {
		$ary = explode(":",$key);			// Form : tag:{Tag}={Value}
		if (!isset($ary[1])) { continue; }
		$xmlary[$ary[1]]=$val;
		}
	if (!isset($xmlary["Tag"])) {
		print "Function:RequestMsgBox('MySet HostCfg','Update Nothing Tag',120,70);\n";	// Alias 重複
		return(-1);
		}
	$xmlary["Tag"]=trim(rtrim($xmlary["Tag"]));		// Tag Trim
	$ret=PostHostCnfUpdateTagCheck($ARG["OrgTag"],$xmlary["Tag"]);
	if ($ret !== "") {
		print "Function:RequestMsgBox('MySet HostCfg','".$ret."',120,70);\n";
		return(-1);
		}

	$ret=PostHostCnfExclusiveCheck($xmlary);
	if ($ret !== "") {
		print "Function:RequestMsgBox('MySet HostCfg','".$ret."',120,70);\n";
		return(-1);
		}

	if((isset($ARG["alt"]))&&(count($xmlary) ==2)) {
		$str=$xmlary[$ARG["alt"]];
		$xmlary["#Value"]=$str;
		unset($xmlary[$ARG["alt"]]);
		}
	$dmyout='';
	foreach($xmlary as $key=> &$val) {
		$val=str_replace('"',"&quot;",$val);		// '"'=>&quot;が変換されないので個別対応。[&<>などは自動で変換されている。]
		}
//	$dmyout='setting/test_sav.xml';
/*	Debug Log
ob_start();
print_r($xmlary);print_r($ARG);
$buffer = ob_get_contents();ob_end_clean();
file_put_contents('setting/debuglog.txt',$buffer);
*/
	if ((!isset($ARG["OrgTag"]))||((isset($ARG["OrgTag"]))&&($ARG["OrgTag"] ==""))) {
		 $tmp="Append";
		 $ret = XMLTagAppend($XML_MYSETTING,$dmyout,$ARG["parent"],$xmlary);
		 }
	else if($ARG["OrgTag"]==$xmlary["Tag"]) {
		 $tmp="Update";
		 $ret=XMLTagUpdate($XML_MYSETTING,$dmyout,$ARG["parent"],$xmlary);
		 }
	else {
		 $tmp="Replase";
		 $ret=XMLTagReplase($XML_MYSETTING,$dmyout,$ARG["parent"],$ARG["OrgTag"],$xmlary);
		 }
	if ($ret < 0) {
		 print "Function:RequestMsgBox('MySet HostCfg','Do not allow duplicate tags ,fix Or With the \"Renew\" button latest',120,70);\n";	// Alias 重複
		 }
	else {
		 $unload = 'RequestBoxtUnLoad(\''.$IDHSTBOX.'\');';
		 print "Function:".$unload."\n";	// Alias 重複
		 }
	print "PostHostCnf Start Cmd[".$ARG["cmd"]."]parent[".$ARG["parent"]."] ".$tmp."\n";
	return($ret);
	}

/*
	PostHostCnfUpdateTagCheck($str) : Tag Chracter check
	 $org   : i  : Orignal Tag
	 $str   : i  : Check Chracter :Tag
	 @return: o  : "":OK "{String}";Error Word String
*/
function PostHostCnfUpdateTagCheck($org,$str) {
	global $XML_HOSTSET,$XML_ALT;

	GetMyEnv("1");
	$ret="";
	$ary=preg_split('//u',$XML_HOSTSET["TagInhibitChar1"], -1, PREG_SPLIT_NO_EMPTY);		// Tag 不可Char1
	$tmp=str_replace($ary,$XML_HOSTSET["TagInhibitRep1"],$str);
	$ary=preg_split('//u',$XML_HOSTSET["TagInhibitChar2"], -1, PREG_SPLIT_NO_EMPTY);		// Tag 不可Char2
	$tmp=str_replace($ary,$XML_HOSTSET["TagInhibitRep2"],$tmp);
	if ($str !== $tmp) {
		$ret="Some characters cannot be used in Tag";
		return($ret);
		}
	$chr=mb_substr($str,0,1);
	$ary=preg_split('//u',$XML_HOSTSET["TagFirstChar"], -1, PREG_SPLIT_NO_EMPTY);			// Tag 先頭Char不可
	$tmp=str_replace($ary,$XML_HOSTSET["TagFirstRep"],$chr);
	if ($chr !== $tmp) {
		$ret="The first character cannot be a Tag name";
		return($ret);
		}
	if ($org==$str) { return($ret); }					// Orignal Tagと同じ場合,長さチェックしない
	if (strlen($org) >=strlen($str)) { return($ret); }	// Orignal Tagと同じ長さの以下は,長さチェックしない
	$tmp=mb_substr($str,0,$XML_HOSTSET["TagLength"],$XML_ALT["Codeset"]);					// Tag長カット
	if ($str !== $tmp) {
		$ret="Limited to Tag length (".$XML_HOSTSET["TagLength"]."Ccharacters)";
		return($ret);
		}
	return($ret);
	}

/*
	PostHostCnfExclusiveCheck($xmlary) : Tag Exclusive check
	 $xmlary: i  : Check Array :[Tag]:Value
	 @return: o  : "":OK "{String}";Error Word String
*/
function PostHostCnfExclusiveCheck($xmlary) {
	global $XML_EXCLUD;

	$ret="";
	foreach($xmlary as $key=>$dummy) {
		if(isset($XML_EXCLUD[$key])) {
			foreach($XML_EXCLUD[$key] as $val) {
				if(isset($xmlary[$val])) {
					$ret="Tag combination is incorrect (".$key.",".$val.")";
					break;
					}
				}
			if($ret !=="") { break; }
			}
		}
	return($ret);
	}

//-------------- End of Source:Post --------------------------------------------------
?>

<script type="text/javascript">
<!--
/*************************************************************************************
	Java Script Function
**************************************************************************************/

/* -----------------------------------------------------------------------------------
	HostCnfRemove(tag) : Host Config Remove Source Function
	tag   : i   : Remove Tag
------------------------------------------------------------------------------------ */
function HostCnfRemove(tag) {
	var mode=document.getElementById('idXMLTbl').value;
	RequestSureBox('Host Config Source Remove','Item Remove Execution\n Are you Sure?',function () { RequestLoadDisp();RequestByPost(POSTMOD,'p=extend&f=PostHostCnf&cmd=HostCnfRemove&mode='+mode+'&tag='+tag,''); },100,120);
	}

/* -----------------------------------------------------------------------------------
	Host Configuration Update Function
------------------------------------------------------------------------------------ */
var POSTARY={};										// Post Tag Hash Array {Child Tag}:{Value}
function HostCnfUpdate() {
<?php
GetHostCnfEnv();									// Get Host Configureation Env
print "var idbtxt='".$IDHSTBOXBASE."';\n";
print "var idbsel='".$IDHSTSEL."';\n";
?>
	var post='';var str='';

	var tmp = POSTARY["Tag"];						// Tagの未入力Error
	var tmp=tmp.replace(/\r?\n/g,"");
	if (tmp=="") { RequestMsgBox('MySet HostCfg','Tag input Required !',120,70);return; }

	if (document.getElementById('idOrgTag').innerText !='') {						// XML Original TagName
		post='&OrgTag='+RequestURLEncode(document.getElementById('idOrgTag').innerText);
		}
	var mode=document.getElementById('idXMLTbl').value;
	post=post+'&mode='+mode;

	var i=0;
	for (var key in POSTARY) {
		var idbtxtobj=document.getElementById(idbtxt+key);
		var idbselobj=document.getElementById(idbsel+key);
		if ((POSTARY[key] =='')&&(idbselobj)&&(idbselobj.style.backgroundColor == "")) { continue; }		// TagValue="",TAGName Clickで不要指定
		if (idbtxtobj.style.color != "") {					// 代替えTag:現在1個使用
			str='&alt='+key;
			}
		var tmp=POSTARY[key].replace(/\r?\n/g,"");			// NLを捨てる
		post=post+'&'+'tag:'+key+'='+RequestURLEncode(tmp);
		i=i+1
		}
	if (i < 2) { RequestMsgBox('MySet HostCfg','Enter the settings other than Tag !',120,70);return; }

	post=post+str
	RequestByPost(POSTMOD,'p=extend&f=PostHostCnf&cmd=HostCnfUpdate'+post,RequestUnLoadDisp());
	RequestLoadDisp(0);
	}

/* -----------------------------------------------------------------------------------
	Host Configuration Move Function
------------------------------------------------------------------------------------ */
/*
	HSTCNFMovInit(id) : ove Box Init
	id     : i  : Postion HTML id:'ID'{1～}
*/
function HSTCNFMovInit(id) {
	var pos=document.getElementById(id).innerText;
	document.getElementById("MvPos").innerHTML=pos;
	HSTCNFMovColor();
	}

/*
	HSTCNFMovExit() : Host Configuration Move Box Exit
	 mode   : i   : 0: OneSession終了 /  1: Playlist Move Operetion終了
*/
function HSTCNFMovExit(mode) {
	var tbl =document.getElementById("grpHSTCNFlist");

	if ((mode==1)&&(document.getElementById("MvPos").innerHTML=="")) { return; }
	var idx=document.getElementById("MvPos").innerHTML;
	var i=parseInt(idx)-1;
	tbl.rows[i].cells[0].style.backgroundColor='';	// NoのCellを取得 backgroundColorを初期に戻す
	if (mode == 1) {		// Playlist Move Operetion終了時クリア
		document.getElementById("MvPos").innerHTML="";
		}
	}

/*
	HSTCNFMovTouch(id) : Mouse Move Touch id to No
	 id      : i  : 移動To Disp(画面上Posiston id)
	 MoveBox (From) & Touch(To) Operation
*/
function HSTCNFMovTouch(id) {
	if (document.getElementById("MvPos").innerHTML=="") {
		return;
		}
	var pos=document.getElementById(id).innerText;
	HSTCNFMov(parseInt(pos-1));
	}

/*
	HSTCNFMov(pos) : Host Configuration Move
	 pos     : i  : Move To Positon
	 dropfrom: i  : Move From Positon MoveBox時Null。MoveBoxを使用しない場合設定。現在MouceによるDrop:
*/
function HSTCNFMov(pos,dropfrom) {
	var tbl =document.getElementById("grpHSTCNFlist");
	if (dropfrom == null) {
		 var idx=document.getElementById("MvPos").innerHTML;
		 from = parseInt(idx)-1;
		 if (pos == "-") {					// Reqest to Down(-)
			if(from <= 0) { return; }
			to=from - 1;
			}
		 else if (pos == "+") {				// Reqest to Down(+)
			  if((from+1) >= tbl.rows.length) { return; }
			  to=from + 1;
			  }
		 else {								// Reqest to Positon
			  to = parseInt(pos);
			  }
		 }
	else {
		 from = parseInt(dropfrom);
		 to = parseInt(pos);
		 idx=parseInt(from)+1;
		 }
	var frtag=tbl.rows[from].cells[1].innerText;
	var totag=tbl.rows[to].cells[1].innerText;
	var mode=document.getElementById('idXMLTbl').value;

	var post="";							// Duplicate Tag Check
	var str=tbl.rows[from].cells[1].innerHTML
	var resfr = str.indexOf( 'color:' );
	var str=tbl.rows[to].cells[1].innerHTML
	var resto = str.indexOf( 'color:' );
	if ((resfr > 0)||(resto > 0)) {
		post='&new=on';
		}
	RequestByPost(POSTMOD,'p=extend&f=PostHostCnf&cmd=HostCnfMove&mode='+mode+'&from='+frtag+'&to='+totag+post,'');
	rows_from=tbl.rows[from].outerHTML;		// Fromをセーブ
	rows = tbl.deleteRow(from);				// Fromを削除 (先に消さないとToを空行追加時,カウントが変わる)
	row = tbl.insertRow(to);				// To上段に空行を作成
	tbl.rows[to].outerHTML=rows_from;		// ToにFromセーブを挿入

	var i = from;var lend = to;				// Renumber
	if (from > to) { i = to;var lend = from; }
	for(i=0;i < tbl.rows.length;i++) {
		tbl.rows[i].cells[0].idName="ID"+(i+1);
		tbl.rows[i].cells[0].innerText=(i+1);
		}
	var idx=document.getElementById("MvPos").innerHTML;
	var i=parseInt(idx)-1;

	if(tbl.rows[i]) {
		tbl.rows[i].cells[0].style.backgroundColor='';	// NoのCellを取得 backgroundColorを初期に戻す
		}
	if (dropfrom == null) {
		document.getElementById("MvPos").innerHTML=parseInt(to+1);	// MoveFromをToにする(連続Operation)
		HSTCNFMovColor();
		}

	}
/*
	HSTCNFMovColor() : Move Positon Color
*/
function HSTCNFMovColor() {
	var idx=document.getElementById("MvPos").innerHTML;
	var i=parseInt(idx)-1;
	var tbl =document.getElementById("grpHSTCNFlist");
	tbl.rows[i].cells[0].style.backgroundColor='#008000';	// NoのCellを取得
	}

// -->
</script>

<style type="text/css">
/********************************************************************************
	DispHostCnf CSS
********************************************************************************/
.HCFDtl { overflow:hidden;white-space:nowrap;text-overflow:ellipsis;height:20px;font-size:11px;line-height:170%; }
.HCFUNC { position:relative;right:0px;top:-4px;width:20px;height:23;transform:rotate(-90deg);white-space:normal;color:#ffffff;}
.HCHFUNC { position:relative;right:0px;top:-4px;width:20px;height:23;transform:rotate(-90deg);white-space:normal;background-color:#585858;color:#ffffff;}
.HCHBSEL { background-color:#696969;border:1.2px solid #BDBDBD;cursor:pointer;}	/* HostCnf EditBoxTag Base Color */
.HSTCNFMovBx { width:60px;height:200px;position:fixed;}
.HSTCNFMovNo { text-align:center;width:20px;height:18px;font-size:13px;position:absolute;top:74px;left:10px;padding:8px 10px 2px;}
.HSTCNFMovCt { order:0px;font-size:13px;position:absolute;width:150px;height:12px;line-height:80%;border-radius:4px;opacity:0.70;background-color:#d3d3d3;color:#191970;}
.HSTCNFMovRt  {position:absolute;top:48px;left:8px;width:45px;height:20;transform:rotate(90deg)scale(0.5,2);border-radius:5px;padding:0px 16 0px;}
.HSTNOSCRL { height:150px;overflow-y:scroll; -ms-overflow-style:none;	/* IE, Edge 対応 */
             scrollbar-width: none; }									/* Firefox 対応 */
.HSTNOSCRL::-webkit-scrollbar {  display:none; }						/* Chrome, Safari 対応 */
</style>

<script type="text/javascript">
<!--

/********************************************************************************
	Java Script Event Listener
********************************************************************************/
document.addEventListener("dragstart",function(event) {
	_pldragstart(event);				// store a ref. on the dragstart
},false);

document.addEventListener("dragover", function(event) {
	_pldragover(event);				// store a ref. on the drop over
},false);

document.addEventListener("drop", function(event) {
	_pldrop(event);					// store a ref. on the drop
},false);


/*
	Mouse Event Listener
*/
document.body.addEventListener( "click", function(event) {
	var mouseX = event.pageX ;	// X座標(Wide) (マウス位置を取得する)
	var mouseY = event.pageY ;	// Y座標(Higth)
	EventControle(mouseX,mouseY,event);
} );

/*
	Touch Event Listener
*/
document.body.addEventListener( "touchstart", function(event) {
	var touchObj = event.changedTouches[0] ;	// タッチの情報を含むオブジェクト
	var touchX = touchObj.pageX ;	// X座標	// タッチ位置を取得する
	var touchY = touchObj.pageY ;	// Y座標
	EventControle(touchX,touchY,event);
} );

/* -------------------------------------------------------------------------------------
	Event Controle Edit Function
------------------------------------------------------------------------------------- */
/*
	_pldragstart(event)  : dragstart
	 even : i  : Event : EventListener:dragstart or HTML:<td id=Play{Pos} ondragstart
	 Drag Start  : ドラッグ操作を始めた時のイベント
*/
function _pldragstart(event) {
	var id  = event.dataTransfer.setData("text", event.target.id);
	}

/*
	_pldragover(event) Event : EventListener:dragover or HTML:<td id=Play{Pos} ondragover
	 Drag Over : ドラッグ状態のマウスのポインタがドロップ可能な要素上に重なってる時のイベント。
*/
function _pldragover(event) {
	event.preventDefault();
	}

/*
	_pldrop(event) Event : EventListener:"drop" or HTML: <td id=Play{Pos} ondrop
	 Drop      : ドロップした時のイベント。
*/
function _pldrop(event) {
	if (!event.target.id) {								// Taget(To)のチェック
		return;
		}
	if (event.target.id.indexOf("ID") == -1) {			// Taget(To)のDrop対象のチェック
		return;
		}
	var dropElm = event.target;
	event.stopPropagation();							// イベントの規定のアクションが発生するのを止める
	var qid_to = dropElm.innerHTML;
		qid_to = parseInt(qid_to) - 1;
	var id_drag = event.dataTransfer.getData("text");
	var qid_from = document.getElementById(id_drag).innerHTML;
		qid_from = parseInt(qid_from) - 1;
	event.preventDefault();								// 処理される既定のアクションが動作しなくなる
	HSTCNFMovExit(1);									// Move Mark Coler Reset
	HSTCNFMov(qid_to,qid_from);							// Move Process
	}

/* ------------------------------------------------------------------------------------
	Rect Controle   Mouse/Touch Commn Control
	PostionX : i  : Wide
	PostionY : i  : Higth
	event    : i  : Event Object
------------------------------------------------------------------------------------ */
function EventControle(PostionX,PostionY,event) {
	if (event.target.id.match(/^ID/)) {			// Tagetのidチェック HTML-ID No:pid{n} (MoveBox Touch Event)
		HSTCNFMovTouch(event.target.id)
		}
	}

// -->
</script>

<?php
/*******************************************************************************
	DispHostCnf($exfunc) : Host Configuration HTML Display Controle
	 $exfunc : i  : Call Function
*******************************************************************************/
function DispHostCnf($exfunc="") {
	print '<title>MySet ('.$_SERVER["HTTP_HOST"].')</title>';
	GetHostCnfEnv();												// Get Host Configureation Env
	GetMyEnv();														// Get XML
	DispHostCnfHeader();
	DispHostCnfDetail($exfunc);
	DispHostCnfInfoBox();
	$line="";
	$js=DispHostCnfFuncJs($line,'Edit Tag [New Tag]');				// Make js:BoxClear Function
	print '<script type="text/javascript">';
	print 'function HostCnfFuncBoxClear() {'.$js.'}';
	$js=DispHostCnfPostJs();
	print 'function HostCnfBoxMakeUpdate() {'.$js.'}';
	print '</script>';
	}

/* -----------------------------------------------------------------------------
	GetHostCnfEnv($exfunc) : Host Configuration Env
	 $exfunc : i  : Call Function
----------------------------------------------------------------------------- */
function GetHostCnfEnv($exfunc="") {
	global $ARG,$GURLCONNECT,$XML_TAG,$XML_TAGLNG,$XML_TAGHID,$XML_EXCLUD;		// GetMyEnv():継続項目
	global $IDHSTBOX,$IDHSTBOXBASE,$IDHSTSEL;						// EditBox id
	global $CSSELBCLR,$CSBOXLOKC,$CSBOXALTC;						// EditBoxColor

	$IDHSTBOX='idHstBox';											// EditBox id
	$IDHSTBOXBASE=$IDHSTBOX."_";									// EditBox TextArea id "_{ChindTag}"
	$IDHSTSEL='idHstSel_';											// EditBox TextAreaTagButton id "_{ChindTag}"
	$CSSELBCLR='#0059b3';											// HostCnf EditBoxTag Select Color
	$CSBOXLOKC='#a9a9a9';											// EditBox LockColor(入力禁止)
	$CSBOXALTC='#008080';											// EditBox 代替え表示Color
	// $XML_TAG TagName : $XML_TAG[key]:SortNo $XML_TAGLNG[key]:Tag Length
	if ((isset($ARG["mode"]))&&($ARG["mode"]=="MPDHost")) {				// $XML_TAG:1～n 0:Setting TagName
		 $XML_TAG=array("host"=>"1","remark"=>"1","port"=>"2","pass"=>"3","sudo-s"=>"4");
		 $XML_TAGLNG=array("host"=>"134","remark"=>"134","port"=>"60","pass"=>"60","sudo-s"=>"60");		// HTML Tag width
		 $XML_TAGHID=array("pass","sudo-s");
		 $XML_EXCLUD=array("remark"=>array("host","port","pass","sudo-s"));
		 }
	else {
		 $XML_TAG=array("name"=>"1","url"=>"2","window"=>"3","frame"=>"3","close"=>"4");
		 $XML_TAGLNG=array("name"=>"92","url"=>"110","window"=>"60","frame"=>"60","close"=>"52");		// HTML Tag width
		 $XML_TAGHID=array();
		 $XML_EXCLUD=array("window"=>array("frame","close"));
		 }
	if(isset($ARG["Favor"])) { $GURLCONNECT="&Favor=".$ARG["Favor"]; }	// mpdsetting.phpシリーズとHeaderFunctionでURL共有部を使用する項目
	}

/* -----------------------------------------------------------------------------
	DispHostCnf($exfunc) : Host Configuration Detail Display
	 $exfunc : i  : Call Function
	※GetMyEnv()/GetHostCnfEnvが呼ばれていること
----------------------------------------------------------------------------- */
function DispHostCnfDetail($exfunc="") {
	global $ARG,$XML_TAG,$XML_TAGLNG,$XML_TAGHID;									// GetMyEnv():継続項目
	global $XML_MPDSRV,$XML_MPDFAV,$XML_MPDSRVALT,$XML_MPDFAVALT,$XML_MPDFAVDUP;	// GetMyEnv():継続項目

	// $XML_TAG TagName : $XML_TAG[key]:SortNo $XML_TAGLNG[key]:Tag Length
	if ((isset($ARG["mode"]))&&($ARG["mode"]=="MPDHost")) {				// $XML_TAG:1～n 0:Setting TagName
		 $xmlary=$XML_MPDSRV;			// XML MySet Table Name
		 $xmlaryalt=$XML_MPDSRVALT;		// XML MySet Table Name Altanate Tag
		 $xmlarydup=array();			// XML MySet Table Duplicate Tag (Serverは作成していない)
		 }
	else {
		 $xmlary=$XML_MPDFAV;			// XML MySet Table Name
		 $xmlaryalt=$XML_MPDFAVALT;		// XML MySet Table Name Altanate Tag
		 $xmlarydup=$XML_MPDFAVDUP;		// XML MySet Table Duplicate Tag
		 }
	$TAGARY=array();					// $TAGARY[no][tdno]["key"] / $TAGARY[no][tdno]["val"]

  print '<div id=grpHostCnfDtl>';
	print '<div style="position:fixed;top:48px;left:2px;width:478px;z-index:30;">';		// ---------- Title Line Edit
	print '<table border="3" cellpadding="0" bgcolor="#000000" frame=void style="table-layout:fixed;width:478px;"><tr>';
	foreach($XML_TAG as $key => $val) {
		if (!isset($XML_TAGTITL[$val])) {
			 $XML_TAGTITL[$val]=$key;
			 }
		$XML_TAGTITLLNG[$val]=$XML_TAGLNG[$key];
		}
	print '<td style="width:20px;"><div class="HCFDtl" style="width:20px;background-color:#191970;">No</div></td>';
	print '<td style="width:98px;"><div class="HCFDtl" style="background-color:#191970;">Tag</div></td>';
	foreach($XML_TAGTITL as $key => $val) {
		$lng="98";
		if (isset($XML_TAGTITLLNG[$key])) {
			$lng=$XML_TAGTITLLNG[$key];
			print '<td style="width:'.$lng.'px;"><div class="HCFDtl" style="width:'.$lng.'px;background-color:#191970;">'.(ucfirst($val)).'</div></td>';
			}
		}
	print '<td style="width:18px;"><div style="font-size:12px;width:16px;height:17px;background-color:#191970;font-style:oblique;padding: 1px 0px 0px 2px;">fn</div></td>';
	print '</tr>';
	print '</table>';
	print '</div>';
	print '<div style="position:absolute;top:72px;left:2px;width:478px;">';				// ---------- Detail Line Edit
	print '<table id=grpHSTCNFlist border="3" cellpadding="0" bgcolor="#000000" frame=void style="table-layout:fixed;width:478px;">';
	$no=0;
	foreach($xmlary as $key=> $line) {			// $XML_MPDSRV | $XML_MPDFAV
		foreach($XML_TAG as $k=> $v) {
			$TAGARY[$no][$XML_TAG[$k]]["key"]=$k;
			$TAGARY[$no][$XML_TAG[$k]]["val"]='';
			$TAGARY[$no][$XML_TAG[$k]]["nul"]='on';
			}
		foreach($line as $k=> $l) {
			if (isset($XML_TAG[$k])) {
				$TAGARY[$no][$XML_TAG[$k]]["val"]=$l;
				$TAGARY[$no][$XML_TAG[$k]]["tag"]=$k;
				$TAGARY[$no][$XML_TAG[$k]]["nul"]="off";
				if (isset($xmlaryalt[$key][$k]["alt"])) {			// Child Tagがない時の代替マーク
					$TAGARY[$no][$XML_TAG[$k]]["alt"]=$xmlaryalt[$key][$k]["alt"];
					}
				}
			}
		$TAGARY[$no]["0"]["val"]=$key;
		$no=$no+1;
		}
	$no=0;
	foreach($TAGARY as $n => $line) {
		$dupstyle='';$duplock="";$dupcolor="";
		if (isset($xmlarydup[$line[0]["val"]])) {
			$dupcolor='color:#cd5c5c;';
			$dupstyle=' style="'.$dupcolor.'"';
			$duplock="on";
			}
		elseif (in_array($line[0]["val"],$xmlarydup,true)){
			$dupcolor='color:#f0e68c;';
			$dupstyle=' style="'.$dupcolor.'"';
			}
		print '<tr>';
		print '<td id="ID'.($no+1).'" draggable=true class="HCFDtl" style="width:20px;width:18px;text-align:right;cursor:move;'.$dupcolor.'">'.($no+1).'</td>';
		ksort($line);
		$lock="";
		foreach($line as $k=> $l) {
			$lng="98";
			if ((isset($l["key"]))&&(isset($XML_TAGLNG[$l["key"]]))) {
				$lng=$XML_TAGLNG[$l["key"]];
				}
			if ($dupstyle=="") {										// 重複Tag優先(代替え表示["alt"]と重なったとき)
				 if ((isset($l["alt"]))&&($l["alt"]=="1")) { $style=' style="color:#fffacd;"'; } else { $style=''; }	// 代替え表示["alt"]
	 			 }
			else {
				 $style=$dupstyle;
	 			 }
			if ((isset($l["tag"]))&&(in_array($l["tag"],$XML_TAGHID,true))) {
				 print '<td style="width:'.$lng.'px;"><div class="HCFDtl"'.$style.'>'.(str_repeat("*",strlen($l["val"]))).'</div></td>';
				 }
			else {
				 print '<td style="width:'.$lng.'px;"><div class="HCFDtl"'.$style.'>'.$l["val"].'</div></td>';
				 }
			}
		if (isset($xmlary[$line[0]["val"]]["lock"])) {					// lock : 編集禁止
			$lock=$xmlary[$line[0]["val"]]["lock"];
			}
		$idfunc="idHCF".$n;
		$strcli="";$strstyl="background-color:#800000;";
		if ($lock !=="on") {											// 編集禁止:Function機能しない
			$strcli='onclick="RequestBoxDisp(\''.$idfunc.'\');"';
			$strstyl="cursor:pointer;";
			if ($lock !=="") {
				$strstyl=$strstyl."color:#ee82ee;";
				}
			}
		print '<td style="width:18px;"><div '.$strcli.' style="font-size:12px;width:18px;height:20px;text-align:center;'.$strstyl.'">...</div></td>';
		DispHostCnfFunc($idfunc,$line,($n+1),$lock,$duplock);
		print '</tr>';
		$no=$no+1;
		}
	print '</table>';
	if ((isset($ARG["mode"]))&&($ARG["mode"]=="MPDHost")) {				// $XML_TAG:1～n 0:Setting TagName
		 print '<div style="height:20px;border-style: none;white-space:nowrap;font-size:11px;margin:6px 0 0 6px;">&nbsp;cf:Do not show duplicate tags, edit XML directly</div>';
		 }
	else {
		 print '<div style="height:20px;border-style: none;white-space:nowrap;font-size:11px;margin:6px 0 0 6px;"><span>&nbsp;cf:Do not allow duplicate tags</span><span style="color:#f0e68c;">(xx):</span>Tag can be edited&nbsp;<span style="color:#cd5c5c;">(xx):</span>Edited  prohibited</div>';
		 }
	DispHostCnfBox();													// MysetXML EditBox
	DispHostCnfFuncMove();
	print '<div style="height:100px;"></div>';							// スクロール範囲を設定
	print '</div>';
  print '</div>';

//print "<BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR>";
//print '$xmlaryalt:';print_r($xmlaryalt);;print '<BR>';
//print '$TAGARY:';print_r($TAGARY);;print '<BR>';
//print '$XML_TAG:';print_r($XML_TAG);;print '<BR>';
//print '$xmlary:';print_r($xmlary);print '<BR>';
	}

/* -----------------------------------------------------------------------------
	DispHostCnfFuncMove($top,$left): Disp Current Move
	 $pos   : i  : No
	 $top   : i  : 表示位置 top
	 $left  : i  : 表示位置 left
----------------------------------------------------------------------------- */
function DispHostCnfFuncMove($top=100,$left=413) {
	$id="movebox";
	print '<div id='.$id.' class="box HSTCNFMovBx" style="width:60px;top:'.$top.'px;left:'.$left.'px;9">';
	print '<div class=boxtitle style="width:40px;">'.'Move'.'</div>';
	print '<button type=submit onclick="HSTCNFMov(\'-\')" class="boxline HSTCNFMovRt" style="absolute;top:48px;">&lt;</button>';
	print '<div id=MvPos class=HSTCNFMovNo></div>';
	print '<button type=submit onClick="HSTCNFMov(\'+\')" class="boxline HSTCNFMovRt" style="absolute;top:114px;">&gt;</button>';
	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	print '<input type="button" class=buttn value="Close" onclick="HSTCNFMovExit(1);'.$unload.'" style="position:absolute;top:170px;right:6px;">';
	print '<div class="boxtext HSTCNFMovCt" style="absolute;top:'.($top+106).'px;left:'.($left-522).'px;">or Touch \'No\' of To..</div>';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DispHostCnfFunc($id,$line,$n,$lock) : HostConfig Func
	 $id     : i  : HTML id
	 $line   : i  : Array XML Edit Line
	 $n      : i  : Edit No
	 $lock   : i  : Edit Lock Str:Input inhibit "on":Edit Lock:Callしない。
	 $duplock: i  : Edit Lock Duplicate Tag
----------------------------------------------------------------------------- */
function DispHostCnfFunc($id,$line,$n,$lock,$duplock="") {
	global $XML_DISP,$IDHSTBOX;

	$top=80;$left=170;$mmove="";$point="";
	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	if ($XML_DISP["Func_move"]=="on") {
		$mmove=' onMousedown="MoveDragOn(\''.$id.'\');"';
		$point='cursor:pointer;';
		}
	print '<div id='.$id.' class=box '.$mmove.' style="position:fixed;top:'.$top.'px;left:'.$left.'px;'.$point.'">';
	print '<div class=boxtitle>MySet Source Tag ['.$line[0]["val"].']</div>';

	$boxtitle="Edit Tag [".$line[0]["val"]."]";
	$js=DispHostCnfFuncJs($line,$boxtitle,$lock,$duplock);
	print '<button type=submit onclick="'.$js.'RequestBoxDisp(\''.$IDHSTBOX.'\');'.$unload.'" class="boxline boxblin1" style="background-color:rgb(8, 8, 77);">Edit Source</button>';

	$moveid="movebox";
	$posid="ID".$n;
	print '<button type=submit onclick="HSTCNFMovExit(1);HSTCNFMovInit(\''.$posid.'\');RequestBoxDisp(\''.$moveid.'\');'.$unload.'" class="boxline boxblin2h">Move Source</button>';

	if (($lock !=="")||($duplock!=="")) {
		 $js='this.blur();';
		 $style=' style="color:#c0c0c0;"';
		 }
	else {
		 $js='HostCnfRemove(\''.$line[0]["val"].'\');'.$unload;
		 $style='';
		 }
	print '<button type=submit onclick="'.$js.'" class="boxline boxblin4"'.$style.'>Remove Source</button>';

	print '<input type="button" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" />';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DispHostCnfBoxJs($id,$line,$boxtitle,$lock) : HostConfig XML Display EditBox Make js
	 $id      : i  : HTML Base id
	 $line    : i  : Array XML Edit Line
	 $boxtitle: i  : Box Title
	 $lock    : i  : Edit Lock Str:Input inhibit "on":Edit Lock:Callしない。
	 $duplock : i  : Edit Lock Duplicate Tag
	 @return  : o  : Js String
----------------------------------------------------------------------------- */
function DispHostCnfFuncJs($line,$boxtitle="",$lock="",$duplock="") {
	global $XML_TAG,$IDHSTBOX,$IDHSTBOXBASE,$IDHSTSEL;
	global $CSSELBCLR,$CSBOXLOKC,$CSBOXALTC;

	$srtary=$XML_TAG;
	$srtary["Tag"]=0;
	$js='document.getElementById(\''.$IDHSTBOX.'BTit\').innerText=\''.$boxtitle.'\';';
	$js=$js.'document.getElementById(\''.$IDHSTSEL.'Tag\').style.backgroundColor=\''.$CSSELBCLR.'\';';		// Tagは必須なので必須の色を付ける
	foreach($srtary as $key => $dmy) {
		$val="";$fout="";
		$id_key=$IDHSTBOXBASE.$key;
		$js=$js.'var hstkey=document.getElementById(\''.$id_key.'\');';
		$id_sel=$IDHSTSEL.$key;
		$js=$js.'var hsttag=document.getElementById(\''.$id_sel.'\');';
		if (is_array($line)) {
			foreach($line as $k=> $l) {
				if(($key=="Tag")&&($k==0)) {					// XML TagNameは名称も設定していない。
					 $val=$l["val"];
					 $js=$js.'hsttag.style.backgroundColor=\''.$CSSELBCLR.'\';';
					 $fout="1";
					 break;
					 }
				else if ((isset($l["tag"]))&&($key==$l["tag"])) {
						$val=$l["val"];
						$js=$js.'hsttag.style.backgroundColor=\''.$CSSELBCLR.'\';';
						$fout="1";
						break;
						}
				}
			}
		$val=str_replace("'","\'",$val);
		$js=$js.'hstkey.value=\''.$val.'\';';
		$js=$js.'hstkey.value=\''.$val.'\';';
		if (($lock !=="")||($duplock !=="")) {
			 $js=$js.'hstkey.readOnly=true;';						// EditBox LockColor : 入力禁止
			 $js=$js.'hstkey.style.color=\''.$CSBOXLOKC.'\';';
			 $js=$js.'hsttag.style.pointerEvents=\'none\';';
			 }
		else if ((isset($l["alt"]))&&($l["alt"]=="1")) {			// EditBox 代替え表示
			 $js=$js.'hstkey.readOnly=false;';
			 $js=$js.'hstkey.style.color=\''.$CSBOXALTC.'\';';
			 $js=$js.'hsttag.style.pointerEvents=\'auto\';';
			 }
		else {
			 $js=$js.'hstkey.readOnly=false;';
			 $js=$js.'hstkey.style.color=\'\';';
			 $js=$js.'hsttag.style.pointerEvents=\'auto\';';
			 }
		if(($fout=="")&&($key!=="Tag")) {				// XML Tagなし背景色を消す
			$js=$js.'hsttag.style.backgroundColor=\'\';';
			}
		}
	if (is_array($line)) {									// XML Original TagName
		 $js=$js.'document.getElementById(\'idOrgTag\').innerText=\''.$line[0]["val"].'\';';
		 }
	else {
		 $js=$js.'document.getElementById(\'idOrgTag\').innerText=\'\';';
	 	 }
	if (($lock !=="")||($duplock !=="")) {
		 $js=$js.'RequestBoxtUnLoad(\'idUpdate\');';
		 }
	else {
		 $js=$js.'RequestBoxDisp(\'idUpdate\');';
		 }
	return($js);
	}

/* -----------------------------------------------------------------------------
	DispHostCnfFuncJs() : Make js Post String
----------------------------------------------------------------------------- */
function DispHostCnfPostJs() {
	global $XML_TAG,$IDHSTBOXBASE;

	$srtary=$XML_TAG;
	$srtary["Tag"]=0;
	asort($srtary);
	$js="";
	foreach($srtary as $key => $dmy) {
		$id_key=$IDHSTBOXBASE.$key;
		$js=$js.'POSTARY[\''.$key.'\']=document.getElementById(\''.$id_key.'\').value;';
		}
	$js=$js.'HostCnfUpdate();';
	return($js);
	}

/* -----------------------------------------------------------------------------
	DispHostCnfBox() : HostConfig XML Edit Box
----------------------------------------------------------------------------- */
function DispHostCnfBox() {
	global $XML_DISP,$XML_TAG,$XML_TAGHID,$IDHSTBOX,$IDHSTBOXBASE,$IDHSTSEL;
	global $CSSELBCLR;

	$left=40;$top=36;$mmove="";$point="";				// Box Postion : $left,$top
	$lng=80;$dtll=300;$dtlh=40;							// Detaile Size: TitleLength:$lng,ValueLength:$dtll,Detaileheight:$dtlh
	$cnt=count($XML_TAG)+1;
	$height=$cnt*$dtlh+$top+40;$width=$lng+$dtll+27;	// Compute :BoxHeight:$height,BoxWidth: $width
	$unlclr='document.getElementById(\'idUpdate\').style.backgroundColor=\'\';document.getElementById(\'idUpdate\').style.color=\'\';';
	$unload = 'RequestBoxtUnLoad(\''.$IDHSTBOX.'\');'.$unlclr;
	if ($XML_DISP["Box_move"]=="on") {
		$mmove=' onMousedown="MoveDragOn(\''.$IDHSTBOX.'\');"';
		$point='cursor:pointer;';
		}
	print '<div id='.$IDHSTBOX.' class=box '.$mmove.' style="position:fixed;top:'.$top.'px;left:'.$left.'px;width:'.$width.';height:'.$height.'px;'.$point.'">';
	print '<div class=boxtitle id="'.$IDHSTBOX.'BTit" style="width:'.($width-20).';"></div>';
	$srtary=$XML_TAG;
	$srtary["Tag"]=0;
	asort($srtary);
	$n=0;$k=0;
	$chgstr='document.getElementById(\'idUpdate\').style.backgroundColor=\'#009900\';document.getElementById(\'idUpdate\').style.color=\'#CED8F6\';';
	foreach($srtary as $key => $dmy) {
		$pos=$top+$n*$dtlh;
		$id_key=$IDHSTBOXBASE.$key;
		$id_sel=$IDHSTSEL.$key;
		$n+=1;
		$str="";$js="";$jsc="";
		if ($key!=="Tag") {							// TagをClickでTag色を変える
			$js='if(document.getElementById(\''.$id_key.'\').value ==\'\') { var idbsel=document.getElementById(\''.$id_sel.'\');if (idbsel.style.backgroundColor !==\'\') { idbsel.style.backgroundColor=\'\'; } else{  idbsel.style.backgroundColor=\''.$CSSELBCLR.'\'; }'.$chgstr.' };';
			}
		print '<div id="'.$id_sel.'" onclick="'.$js.'" class="HCHBSEL" style="position:absolute;top:'.$pos.';left:10px;width:'.$lng.'px;height:'.$dtlh.'px;pointer-events:auto;">'.$key.'</div>';
		$jsc='if(document.getElementById(\''.$id_key.'\').value !=\'\') { var idbsel=document.getElementById(\''.$id_sel.'\');idbsel.style.backgroundColor=\''.$CSSELBCLR.'\';'.$chgstr.' };';		// onChangeで入力内容があればTag色を変える
		if (in_array($key,$XML_TAGHID,true)){
			 print '<input type="password" disabled="disabled" style="position:absolute;top:'.($pos+1).';left:'.($lng+14).'px;width:'.$dtll.'px;height:'.($dtlh+2).'px;resize:none;">';
			 print '<input type="password" onChange="'.$jsc.'" id="'.$id_key.'" value="" style="position:absolute;top:'.($pos+1).';left:'.($lng+14).'px;width:'.$dtll.'px;height:20px;font-family:inherit;font-size:11px;resize:none;">';
			 }
		else {
			 if ($k==0) { $deft=0;$defh=1; } else { $deft=1;$defh=2; }
			 print '<textarea id="'.$id_key.'" onChange="'.$jsc.'" class=HSTNOSCRL style="position:absolute;top:'.($pos+$deft).';left:'.($lng+14).'px;width:'.$dtll.'px;height:'.($dtlh+$defh).'px;font-family:inherit;font-size:11px;resize:none;word-break:break-all;"></textarea>';
			 }
		}
	print '<div id="idOrgTag" class="boxbcan" style="left:20px;color:#ffffff;display:none;"></div>';			// XML Original TagName
	print '<input type="button" id="idInfo" value="Info" onclick="RequestBoxDisp(\'idInfobox\');this.blur();" class="buttn boxbcan" style="left:10px;" />';
	print '<input type="button" id="idUpdate" value="Update" onclick="HostCnfBoxMakeUpdate();" class="buttn boxbcan" style="right:100px;display:none;" />';
	print '<input type="button" value="Cancell" onclick="RequestUnLoadDisp();'.$unload.'" class="buttn boxbcan" />';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DispHostCnfInfoBox() : HostConfig Input Info. Box
----------------------------------------------------------------------------- */
function DispHostCnfInfoBox() {
	global $ARG,$XML_DISP;

	$unload = 'RequestBoxtUnLoad(\'idInfobox\');';
	if ($XML_DISP["Box_move"]=="on") {
		$mmove=' onMousedown="MoveDragOn(\'idInfobox\');"';
		$point='cursor:pointer;';
		}
	if ((isset($ARG["mode"]))&&($ARG["mode"]=="MPDHost")) { $str="MPDHost";$width="460";$height="340"; } else { $str="Favorites";$width="460";$height="330"; }
	print '<div id="idInfobox" class=box '.$mmove.' style="position:fixed;top:140px;left:10px;width:'.$width.'px;height:'.$height.'px;background-color:#fff9f5;color:#000000;'.$point.'">';
	print '<div class=boxtitle style="width:'.($width-20).'px;">MySet InfoTag ['.$str.']</div>';
	print '<div style="position:absolute;left:10px;top:30px;"><pre style="font-family:\'MS Gothic\',monospace;font-size:11px;font-weight: bold;">';
	if ((isset($ARG["mode"]))&&($ARG["mode"]=="MPDHost")) {				// $XML_TAG:1～n 0:Setting TagName
echo <<<EOM
Required fields : Tag and 1 other setting
Input item meaning
 -Tag    : XML XML settings Tag & Name
 -host   : mpdServer or Jump destination URL
 -remark : remark
 -port   : mpd port
 -pass   : mpd password
 -sudo-s : Requires sudo-s to enable updates
          sudo-s:requires encoding
          http://{host}/mpdweb/mpdtask.php?b64={Password}
Input combination
 -host,port,pass,sudo-s or remark
  pass,sudo-s is not required
 -host:For mpdServer, port,pass,sudo-s
 -Nothing else needed when host is a URL

Valid items are blue, click to change valid and invalid
-Can be locked by setting in setting/mpdmyset.xml,Do it manually
-&lt;Mpd_net&gt;&lt;{Tag} lock="on"|"show"&gt;
EOM;
		 }
	else {
echo <<<EOM
Required fields : Tag and 1 other setting
Input item meaning
-Tag    : XML XML settings Tag
-name   : Favoriltes's Name
-url    : Jump destination URL
-window : Open URL in Window
          "", or 'windowName','[windowFeatures]'
          windowFeatures:'{top=nn}{,left=nn}{,width=nn}{,height=nn}'
          According to window.open(url,windowName,[windowFeatures])
-frame  : frame css
-close  : Creat close botton's css
Input combination
-window or frame,close
-close is optional

Valid items are blue, click to change valid and invalid
-Can be locked by setting in setting/mpdmyset.xml,Do it manually
-&lt;Favorites&gt;&lt;{Tag} lock="on"|"show"&gt;
EOM;
		 }
	print '</pre></div>';
	print '<input type="button" value="Cancell" onclick="RequestUnLoadDisp();'.$unload.'" class="buttn boxbcan"  style="border:0.5px solid #696969;" />';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DispHostCnfHeader() : Make DispHostCnf Header
----------------------------------------------------------------------------- */
function DispHostCnfHeader() {
	global $ARG,$IDHSTBOX;

	$myUrl=_ArgURLCount($_SERVER["REQUEST_URI"]);
	print '<div class=head style="top:24;height:25px;">';
	$color_self='background-color:#008000;color:#CED8F6;';			// 自身を示す色
	print '<button type=submit class=buttn onclick="RequestLoadDisp();location.href=\''.$myUrl.'\';" style="width:60;'.$color_self.'">Renew</button>';
	$Listquery=array("MPDHost","Favorites");
	$field="Favorites";
	if ((isset($ARG["mode"]))&&($ARG["mode"]=="MPDHost")) {
		$field="MPDHost";
		}
	foreach($Listquery as $key => $val) {
		$select["Text"][]=$val;
		}
	$select["style"]["position"]="position:absolute;";
	$defstr=$field;
	$style="font-size:13px;";
	MakeSelectBox("get",$select,$defstr,"idXMLTbl",0,64,88,"","idXMLTblSel","",$style);
	$str=";";
	if (isset($ARG["Favor"])) {
		$str="+'&Favor=".$ARG["Favor"]."';";
		}
	$url="location.href='".$_SERVER["PHP_SELF"]."?p=extend&f=DispHostCnf&mode='+document.getElementById('idXMLTbl').value".$str;
	print '<button type=submit id=idXMLTblSel onclick="'.$url.'" style="position:absolute;top:0.4px;left:152px;width:42px;border-style:none;height:19px;font-size:9px;cursor:pointer;">Select</button>';
	$edtsrv=$_SERVER["HTTP_HOST"];
	$tmp=trim(rtrim($_SERVER["HTTP_HOST"],"]"),"[");
	if (Commn_isIPv6($tmp)) {
		$ary=Commn_IPv6inf($tmp);
		$edtsrv=$ary["ifid"];
		}
	print '<div style="position:relative;top:-18px;left:198px;height:18px;line-height:150%;width:188px;background-color:#333333;color:#ffffff;font-size:12px;">&nbsp;&nbsp;Host:'.$edtsrv.'</div>';
	$bcolor='background-color:#642EFE;';$color='color:#CED8F6;';			// デフォルト色
	$idfunc="idHCFH";
	$line="";
	$js='HostCnfFuncBoxClear();';
	print '<button type=submit onclick="'.$js.'RequestBoxDisp(\''.$IDHSTBOX.'\');" class=buttn style="position:relative;top:-41px;left:389px;width:60;'.$bcolor.$color.'">Source</button>';
	print '<button type=submit onclick="RequestBoxDisp(\''.$idfunc.'\');" class="comnd HCHFUNC" style="position:relative;top:-41px;left:394px;background-color:#008000;margin:2px 0px 0px 0px;">...</button>';
	DispHostCnfHeaderFunc($idfunc,$js);
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DispHostCnfHeaderFunc($id,$js) : HostConfig Header Func
	 $id   : i  : HTML id
	 $js   : i  : JSP HostConfig XML Edit Box
----------------------------------------------------------------------------- */
function DispHostCnfHeaderFunc($id,$js) {
	global $ARG,$XML_DISP,$MY_HOSTVER,$HOSTLIBVER,$IDHSTBOX,$XML_MYSETTING;

	$top=30;$left=170;$mmove="";$point="";
	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	if ($XML_DISP["Func_move"]=="on") {
		$mmove=' onMousedown="MoveDragOn(\''.$id.'\');"';
		$point='cursor:pointer;';
		}
	print '<div id='.$id.' class=box '.$mmove.' style="position:fixed;top:'.$top.'px;left:'.$left.'px;height:300px;'.$point.'">';
	print '<div class=boxtitle>MySet Source Header Function</div>';
	print '<button type=submit onclick="'.$js.'RequestBoxDisp(\''.$IDHSTBOX.'\');'.$unload.'" class="boxline boxblin1" style="top:36px;background-color:#000000;">Add Edit Source (...NewTag)</button>';
	if (isset($ARG["Favor"])) {						// mpdhost Connect On/Off
		 if ($ARG["Favor"]=="on") {
			  $str="&Favor=off";$sw="OFF";
			  }
		 else {
			  $str="&Favor=on";$sw="ON";
			  }
		 }
	else {
		 $str="&Favor=on";$sw="ON";
		 }
	$url="location.href='".$_SERVER["PHP_SELF"]."?p=extend&f=DispHostCnf&mode='+document.getElementById('idXMLTbl').value+'".$str."';";
	print '<button type=submit onclick="'.$url.$unload.'" class="boxline boxblin3" style="top:82px;background-color:rgb(8, 8, 77);">Favorites(MpdHost) Connect : '.$sw.'</button>';
	print '<button type=submit onclick="RequestBoxDisp(\'idB64Enc\');'.$unload.'" class="boxline boxblin4" style="top:124px;">B64-Plus Encoder</button>';
	print '<button type=submit onclick="RequestBoxDisp(\'idInfobox\');'.$unload.'" class="boxline boxblin4" style="top:162px;">EditTagBox Information</button>';
	print '<div class="boxtext" style="bottom:78px;font-size:9px;color:#ffffff;">Configuration : '.$XML_MYSETTING.'</div>';
	print '<div class="boxtext" style="bottom:50px;font-size:9px;color:#98fb98;">'.$MY_HOSTVER.'</div>';
	print '<div class="boxtext" style="bottom:36px;font-size:9px;color:#ffffff;">'.$HOSTLIBVER.'</div>';
	print '<div class="boxtext" style="bottom:-2px;font-size:9px;color:#ffffff;">'."(C)2020 by Mikio Shiratori".'</div>';
	print '<input type="button" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" />';
	print '</div>';
	DispTaskSetB64Enc();
	}

//-------------- mpdsetting_hostcnf.php End of Source ------------------------
?>

<?php 
// -- Function Box Favorites:on時,以下を組み込む -----------------------------
if ((isset($ARG["Favor"]))&&($ARG["Favor"]!=="on")) { return; } else if (!isset($ARG["Favor"])) { return; }
/* ***************************************************************************
	mpdhost.php Connect Source
	EventListener : mpdhost.php "click" : Div "grpSureBoxfunc" "Get"-> OK (Save Event)
	EventListener : mpdhost.php "load"  : Div "IdState" After Post
*************************************************************************** */
	$require_host=dirname(__FILE__).'/mpdhost.php';			// mpdhost Common Library mpdhost.lib.php

echo <<<EOM
<script type="text/javascript">
/* ---------------------------------------------------------------------------
	 mpdhost.php Get --> OK Check監視
--------------------------------------------------------------------------- */
document.body.addEventListener( "click", function(event) {
	if (event.target.id.match(/^grpSureBoxfunc/)) {			// mpdhost.php OK Buttonを監視
		var tmpstr=document.getElementById('grpSureBoxtitle').innerText;
		if ((document.getElementById('idXMLTbl'))&&(tmpstr.match(/^mpdhost -/))) {			// mpdhost.php SureBox
			var mode=document.getElementById('idXMLTbl').value;
			RequestByPost(POSTMOD,'p=extend&f=PostHostCnf&cmd=HostCnfDisp&mode='+mode,'');
			}
		}

} );

/* ---------------------------------------------------------------------------
	mpdsetting_hostcnf.php Status Check [grpHSTCNFlist監視]
--------------------------------------------------------------------------- */
window.addEventListener('load', function(){
	const observer = new MutationObserver(function(){	// DOMの変化Event
//		console.log('DOMが変化しました');
		HostRequestByPost('HostFavorDisp','');
		});
	const elem = document.getElementById('IdState');	// 監視要素Object
	const config = {									// 監視時のオプション
		childList: true, 
		characterData: true,
		subtree: true,
		};
	observer.observe(elem ,config);							// MutationObserver(要素の変化監視) Start
	}
);
</script>
EOM;
/* ---------------------------------------------------------------------------
	mpdshost include
--------------------------------------------------------------------------- */
	global $G_HOSTPOS,$G_INHIBIT;$G_HOSTPOS=20;
	$edtsrv=$_SERVER["HTTP_HOST"];
	$tmp=trim(rtrim($_SERVER["HTTP_HOST"],"]"),"[");
	if (Commn_isIPv6($tmp)) {
		$ary=Commn_IPv6inf($tmp);
		$edtsrv=$ary["ifid"];
		}
	$G_INHIBIT="SET:".$edtsrv;
	require_once($require_host);
//-------------- End of Connect Source ----------------------------------------
?>

