<?php
/*******************************************************************************
	mpdtask.lib.php : mpd web Scok Lib & Taskserver Client

	 「mpdtaskserver.pl」TaskServerとのI/Fを包括している。TaskServerはServiceで起動させておく。
	  TaskServerとのI/F Library
	Function:
	 GetSessionConfig(); mpdweb.php Session Config
	 GetEnvTaskCommon(): mpdtask.xml , used Session Config
	 ArgMakeSvrCmd()   : Make TaskServer Command , make shell,Search Password

	Require
	 mpdtask.sock.lib.php
 	                   : SockCmdsend()     : Sock Message Send/Receive
	 class Sock Library:Sock_Common()/SockRead()/SockWrite()/SockDisConnect()
*******************************************************************************/
$tasksock_lib=dirname(__FILE__)."/mpdtask.sock.lib.php"; 	// Mpd TaskServer I/F lib
require_once($tasksock_lib);								// require Mpd TaskServer I/F lib

$require_lib=dirname(__FILE__).'/mpdweb.lib.php';		// Mpd XML Library Default
if  (file_exists(dirname(__FILE__)."/".basename(__FILE__,".php").".lib.php")) {		// Mpd XML Library mpd{module}.lib.phpの存在確認
	$require_lib=dirname(__FILE__)."/".basename(__FILE__,".php").".lib.php";
	}
require_once($require_lib);								// Mpd XML Library mpd{module}.lib.php

$appli_lib=dirname(__FILE__).'/mpdweb.lib_appli.php';	// Mpd XML Library Default
if  (file_exists(dirname(__FILE__)."/".basename(__FILE__,".php").".lib_appli.php")) {	// Mpd Application Library mpd{module}.lib_appli.phpの存在確認
	$appli_lib=dirname(__FILE__)."/".basename(__FILE__,".php").".lib_appli.php";
	}
require_once($appli_lib);								// Mpd XML Library mpd{module}.lib.php

$require_ses=dirname(__FILE__).'/mpdcmnses.lib.php';				// Mpd Session id Library
if  (file_exists($require_ses)) { require_once($require_ses); }		// Mpd mpdcmnses.lib.phpの存在確認&require

$MY_VERSION=basename(__FILE__,"")." 1.0 (31.03.2024)";
$DEBUG= false;		// flase , 1:msg 2:msglog
//$DEBUG= 1;		// flase , 1:msg 2:msglog
//$DEBUG= 2;		// flase , 1:msg 2:msglog

/*******************************************************************************
	GetSessionConfig() : mpdweb.php Session Config
	 @return: o  : $SESSION_CONF Session Array
*******************************************************************************/
function GetSessionConfig() {
	global $XML_CONF;

	GetEnvCommon();
	ignore_user_abort(false);							// 切断時終了
	$SESSION_CONF=array("sesion_id"=>"mpdweb","href_waitmsec"=>"50","maxlifetime"=>"1440");
	get_config("php_session",$SESSION_CONF);			// php config php_session
	$SESSION_CONF=ArgSessionConf($SESSION_CONF);		// mpdweb:Session id 作成 : Used mpdcmnses.lib.php
	return($SESSION_CONF);
	}

/* -----------------------------------------------------------------------------
	GetEnvCommon(); Load setting/mpdconfig.xml
	 @return: o  : "":Normal !="":ErrorMessage
----------------------------------------------------------------------------- */
function GetEnvCommon() {
	global $XML_CONF,$CONFARY;

	$XML_File = "setting/mpdconfig.xml";
		$ret="";
	try {
		$XML_CONF = get_loadconfig($XML_File);	// XML File Get FileNameはLibrary標準
		} catch( Exception $e ) {
	  $ret=$e->getMessage();
	  }
	$CONFARY[$XML_File]=$XML_CONF;
	return($ret);
	}

/*******************************************************************************
	GetEnvTaskCommon($ARG) : XML Setting GEt
	$ARG   : i  : Parameter($_POST) : Userd:mpdtask.php ,Other,array()
	return : o  ; true:XML有効 , false:XML無効
*******************************************************************************/
function GetEnvTaskCommon($ARG=array()) {
	global $XML,$XML_CONF,$XML_HOST,$XML_POST,$ARGSTR,$XML_SHELL,$XML_EXCLUDE,$DEBUG;		// $XML:XML Vars , $XML_CONF:XML ,$XML_HOST:TaskServer Setting ,$XML_ALLIF:Command $XML_POST:Post Command , $XML_SHELL:Shell Setting

	$XML_File = "setting/mpdtask.xml";
	$ret="";
	try {
		$XML_CONF = get_loadconfig($XML_File);										// XML File Get FileNameはLibrary標準
		} catch( Exception $e ) {
	 	$ret=$e->getMessage();
		$substr="";
		if ((isset($ARG["id"]))&&($ARG["id"] !=="")) { $substr="[".$ARG["id"]."] "; }
	 	if ((strpos($ret,"Open") !== false)&&(strpos($ret,"File") !== false)) { if ($DEBUG) { DispBox($substr.$ret,"[XML Open Error]"); } } else {
			DispBox($substr.$ret,"[XML Error]");
			}
		return(false);
	    }
	$XML = get_object_vars($XML_CONF);
/* used ; mpdtask.php Argument Default Start [Built-in to avoid Error] */
	if (!isset($ARG["use"])) { $ARG["use"]="mpdweb"; }		// Default:Base Name
	if (!isset($ARG["if"]))   { $ARG["if"]="mpdos"; }		// Default:I/F Name
/* used ; mpdtask.php Argument Default End */
	$poststr=array($ARG["use"]=>"RequestByPost('%server%','%cmd%','status',%callback%);");	// module,%p1%:item,%p2%:message_id,%p3%:callback
	get_config("Post_String",$poststr);
	$XML_POST = str_replace('%server%',$_SERVER['PHP_SELF'],$poststr[$ARG["use"]]);

	$XML_HOST=array("Force"=>"off","Excludesu"=>"on","Host"=>"{setting/mpdconfig.xml:/Mpd_net/host}","Port"=>"9050","Timeout"=>"5","Accunt"=>"login=mpdweb:mpdweb\n","TermStr"=>"\x1b\n");	// Task Server I/F設定
	$sv_host=$XML_HOST["Host"];
	get_config("TaskServer",$XML_HOST);
	if ($XML_HOST["Host"]=="") { $XML_HOST["Host"]=$sv_host; }						// Hostが未設定か""のときはデフォルトを採用
	if ($XML_HOST["Host"]=="localhost") {
		$XML_HOST["Host"] = str_replace("localhost",$_SERVER["SERVER_ADDR"],$XML_HOST["Host"]);	// localhostに設定時,shell実行のAddressを設定
		}
	$XML_HOST["TermStr"] = str_replace("%1b","\x1b",$XML_HOST["TermStr"]);			// TaskSaver TaskEnd Send Character
	$result = preg_match_all('/{(.*?)}/s',$XML_HOST["Host"],$part,PREG_SET_ORDER);	// Result:正規表現:<{}>を検出 $part[n][0]:{Item} [1]:Value
	if (isset($part[0][1])) {
		$XML_HOST["Host"]=GetEnvHost($part[0][1],"/Mpd_net/host");		// Hostが他のXMLにLinkされているときGet
		if ($XML_HOST["Host"] ===false) { return(false); }
		}
	$XML_SHELL=array("sudo-s"=>"dm9sdW1pbw==");							// sudo Password
	get_config("ShellExec",$XML_SHELL);
	$XML_SHELL["sudo-pw"]=base64_decode($XML_SHELL["sudo-s"]);
	$XML_EXCLUDE=array("netmask"=>"{setting/mpdconfig.xml:/Mpd_exclusive/netmask}","cmd"=>"start,stop","cmd_".$ARG["if"]=>NULL);		// 実行除外のnetmask設定
	get_config("Exclude",$XML_EXCLUDE);
	$result = preg_match_all('/{(.*?)}/s',$XML_EXCLUDE["netmask"],$part,PREG_SET_ORDER);	// Result:正規表現:<{}>を検出 $part[n][0]:{Item} [1]:Value
	if (isset($part[0][1])) {
		$XML_EXCLUDE["netmask"]=GetEnvHost($part[0][1],"/Mpd_exclusive/netmask");			// NetMaskが他のXMLにLinkされているときGet
		if ($XML_EXCLUDE["netmask"] ===false) { return(false); }
		}

	if (!is_null($XML_EXCLUDE["cmd_".$ARG["if"]])) {
		$XML_EXCLUDE["cmd"]=$XML_EXCLUDE["cmd_".$ARG["if"]];
		}
	$XML_EXCLUDE["cmdary"]=explode(",",$XML_EXCLUDE["cmd"]);

	GetEnvPass();										// Make Password XML Array

	$ARGSTR="";
	foreach ($ARG as $key=>$val) {						// Parameter($_POST)を復元する
		if ($key=="p") { continue; }
		if ($val=="") { continue; }
		$ARGSTR =$ARGSTR.",".$key."=".$val;
		}
//print '<BR>$XML_HOST:<BR>';print_r($XML_HOST);print '<BR>';
//print '<BR>$XML_SHELL:<BR>';print_r($XML_SHELL);print '<BR>';
	return(true);
	}

/*
	GetEnvHost($str,$def,$defval) : XML Host Get
	 $str   : i  : XML Path String {FilePath}:{Section}/{Item}  : Hostを置換設定(2階層限定)
	 $def   : i  : XML Tag Default , "":Default Non Setting
	 $defval: i  : XML Default Value
	 @return: o  : Host Name
*/
function GetEnvHost($str,$def="",$defval="volumio.local") {
	global $XML,$XML_CONF,$CONFARY;

	$sv_xml=$XML;$sv_xml_conf=$XML_CONF;	// XML globalを保存し終了時戻す(CommonLibを使用するための対処)
	$XML=NULL;$XML_CONF=NULL;
//	print "Host:".$str."\n";
	$tmp = str_replace("|",":",$str);		// CallBack設定
	$xmlset=explode(":",$tmp);
	$xmlpath = $xmlset[0];

	if (isset($CONFARY[$xmlpath])) {		// 取得済のXMLはGetしない
		$XML_CONF=$CONFARY[$xmlpath];
		}
	try {
		$XML_CONF = get_loadconfig($xmlpath);	// XML File Get FileNameはLibrary標準
		} catch( Exception $e ) {
		 	 $ret=$e->getMessage();
	 		 if ((strpos($ret,"Open") !== false)&&(strpos($ret,"File") !== false)) { print DispBox($ret,"[XML Open Error]"); } else {
				DispBox($ret,"[XML Error:".$str."]");
				}
			 return(false);
			 }
	if (!isset($xmlset[1])) { $xmlset[1]=$def; }	// XML以下が未設定時
	$xmlset[1]=trim($xmlset[1],"/");
	$xmlsec=explode("/",$xmlset[1],2);
//	print '$xmlsecXML:';print_r($xmlsec);print "\n";
	$host=array($xmlsec[1]=>$defval);
	get_config($xmlsec[0],$host);
	$ret=$host[$xmlsec[1]];
//$fp=fopen("log/mpdtask.log","a");fwrite($fp,'GetEnvHost [4] $ret['.$ret."]\n");fclose($fp);
	global $XML_SHELL;							// MPD Serverとセットでsudo passwordが設定されているときは有効にする
	get_config("ShellExec",$XML_SHELL);
	$XML_SHELL["sudo-pw"]=base64_decode($XML_SHELL["sudo-s"]);
//	print "RepHost:".$ret."<BR>";
	$XML_CONF=$sv_xml_conf;						// XML globalを戻す
	$XML=$sv_xml;
	return($ret);
	}

/* -----------------------------------------------------------------------------
	GetEnvPass() : Make Password XML Array

	$XML_ENVPASS [GetShell][shell]:{Password Seach Shell};
	$XML_ENVPASS [GetShell][reslut]:[shell]中検出Password 変数名
	$XML_ENVPASS [GetShell][arry]  :Passwordの候補変数名 {shell} {Password変数}
	$XML_ENVPASS [GetShell][phpsu] :実行Command中のsudo {Password}変数名
	$XML_ENVPASS [GetShell][valid]: 1:設定有効,0:設定無効,
	$XML_ENVPASS [{Key}][b64]/[pw] :Password名 b64:Password:b64Encode / pw:Password:b64decode
	b64:表記文字上で変則B64
------------------------------------------------------------------------------- */
function GetEnvPass() {
	global $XML,$XML_ENVPASS,$XML_SHELL;

	global $DEBUG;if($DEBUG==1) {
		print '<div style="position:fixed;top:630px;left:730px;width:760px;height:270px;background:#ffffff;border:2px;font-size:12px;color:#000000;overflow:scroll;z-index:1000;">DebugArea3<BR>';
		}
	$XML_ENVPASS=array();
	$flgExclude=0;$count=0;
	if (isset($XML["EnvironmentPassword"])) {
		$XML_ENVPASS["GetShell"]["shell"]='SETPASS=`find /var/www -name "mpdsetpass.sh"`;PASS=`$SETPASS %argpass%`;';	// Password 検出Shell Default
		$XML_ENVPASS["GetShell"]["reslut"]="PASS";											// Password 検出Shell Shell変数名 Default
		$XML_ENVPASS["GetShell"]["arry"]="%argpass%";										// Password 検出Shell Argument変数 Default
		$XML_ENVPASS["GetShell"]["phpsu"]="%sudo-pw%";										// Password 検出Shell Argument変数 Default
		$XML_ENVPASS["GetShell"]["valid"]="1";												// Password 検出Shell有効
		$ary=get_xml_attri_array($XML["EnvironmentPassword"]);
		foreach($ary["Tag"] as $key=> $env) {												// $key:0～n, $env:TagValue
			if (strcasecmp($env,"GetShell")==0) {
				$XML_ENVPASS["GetShell"]["shell"]=(String)$ary["Val"][$key];				// Password 検出Shell
				if (isset($ary["Att"][$key]["reslut"])) {									// $ary["Att"][$key][{Attribute}]:Attribute Value
					$XML_ENVPASS["GetShell"]["reslut"]=(String)$ary["Att"][$key]["reslut"];	// Password 検出Shell Shell変数名
					}
				if (isset($ary["Att"][$key]["arry"])) {
					$XML_ENVPASS["GetShell"]["arry"]=(String)$ary["Att"][$key]["arry"];		// Password 検出Shell Argument変数
					}
				if (isset($ary["Att"][$key]["phpsu"])) {
					$XML_ENVPASS["GetShell"]["phpsu"]=(String)$ary["Att"][$key]["phpsu"];	// PHP sudo Password 変数
					}
				continue;
				}
			if($env=="MAIN") {
				if (strcasecmp((String)$ary["Val"][$key],"{Exclude}")==0) {					// MAIN Password 除外設定
					$flgExclude=1;
					continue;
					}
				if (strcasecmp((String)$ary["Val"][$key],"{ShellExec}")==0) {				// MAIN Password <ShellExec><sudo-s>を使用
					$XML_ENVPASS[$env]["b64"]=$XML_SHELL["sudo-s"];
					$XML_ENVPASS[$env]["pw"] =$XML_SHELL["sudo-pw"];
					continue;
					}
				}
			$count=$count+1;
			$XML_ENVPASS[$env]["b64"]=(String)$ary["Val"][$key];							// $ary["Val"][$key]:Value
			$XML_ENVPASS[$env]["pw"] =base64_decode((String)$ary["Val"][$key]);
			}
		if (($count > 0)&&($flgExclude==0)&&(!isset($XML_ENVPASS["MAIN"]["b64"]))) {		// Password検出実行設定でMAIN除外なしでMAIN未設定時は強制的にMAIN設定
			$XML_ENVPASS["MAIN"]["b64"]=$XML_SHELL["sudo-s"];
			$XML_ENVPASS["MAIN"]["pw"] =$XML_SHELL["sudo-pw"];
			}
		else if ($count == 0) {
			$XML_ENVPASS["GetShell"]["valid"]="0";											// Password 検出Shell無効
			}
		}
	if($DEBUG==1) { TblDump('$XML_ENVPASS',$XML_ENVPASS,"");print '</div><BR>'; }
	}

/*******************************************************************************
	ArgMakeSvrCmd($cmd) : Make TaskServer Command 
	 $cmd   : i   : Task Server Command
	 @return: o   : change sudo Passwod
	 ※ sudo Passwodがなければ変換しない
*******************************************************************************/
function ArgMakeSvrCmd($cmd) {
	global $XML,$XML_ENVPASS,$XML_SHELL,$DEBUG;

	if($DEBUG==1) { print 'cmd['.$cmd."]<BR>"; }			/* Debug On Display */
	if (strpos($cmd,$XML_ENVPASS["GetShell"]["phpsu"]) === false) {
		return($cmd);
		}
	if ($XML_ENVPASS["GetShell"]["valid"]=="0") {											// Password 検出Shell無効
		$cmd=str_replace($XML_ENVPASS["GetShell"]["phpsu"],$XML_SHELL["sudo-pw"],$cmd);		// <ShellExec><sudo-s>の変換のみ行う
		return($cmd);
		}
	$str="";
	foreach($XML_ENVPASS as $key=> $pass) {				// Password 設定を連結
		if ($key=="GetShell") { continue; } 
		if ($str !=="") { $str=$str." "; }				// Password Array : {Name}={Password} ...
		$str=$str.$key."=".$pass["pw"];
		}
	$str=str_replace($XML_ENVPASS["GetShell"]["arry"],$str,$XML_ENVPASS["GetShell"]["shell"]);		// Password Arrayを置換
	if($DEBUG==1) { print 'cmdstr1['.$str."]<BR>"; }		/* Debug On Display */
	$str=rtrim($str,";").";";
	$cmd=str_replace($XML_ENVPASS["GetShell"]["phpsu"],$XML_ENVPASS["GetShell"]["reslut"],$cmd);	// $cmdの sudo {Password}をPassword変数に置換
	$cmd=rtrim($cmd,";").";";
	if($DEBUG==1) { print 'cmdstr2['.$cmd."]<BR>"; }		/* Debug On Display */
	$str=$str.$cmd;
	if($DEBUG==1) { print 'cmdstr3['.$str."]<BR>"; }
//	if($DEBUG==1) { $str=$str."echo Password[".$XML_ENVPASS["GetShell"]["reslut"]."];"; }		/* テスト用最後にEcho {Password} */
	return($str);
	}
/* -------------- End Of Source --------------------------------------------------------------------------- */
?>
