<?php
/* -----------------------------------------------------------------------------
	mpdtask.php : mpdweb Make Function & Taskserver Client
       mpdwebに TaskServer利用のFunctionを生成するI/F
	   Post関数名は設定で可能としているので,対象となる関数を作成し各拡張を行う構造

	現在の機能は呼び元からPost実行し,Task,Start/Stop/StatusのFunctionを用意している
	 起動1:{host}/mpdtask.php?b64={word}
	 起動2:{host}/mpdtask.php?p={Function}&use={Base Name}&id={HTML-id}&if={I/FName}&cb={cb}&js={js}
	  Functionの遷移
		 (Post)init  →(内部)チェックCommand→ (内部)status : status定義によりHTML-idを作成し対象のidを書き換えて呼び元に機能を実装  start/stop/statusを設定できる
	     (Post)start →(内部)TaskServerにTaskCommand(start)を送信し実行→ (内部)status : status定義によりHTML-idを作成し対象のidを書き換え
	     (Post)stop  →(内部)TaskServerにTaskCommand(stop)を送信し実行 → (内部)status : status定義によりHTML-idを作成し対象のidを書き換え
	     (Post)status→(内部)status : status定義によりHTML-idを作成し対象のidを書き換え
	 mpdtask.xmlを使用する:呼び元の形式 Calling use={Base Name},id={id},if={IFStructure Name},cb={callback},js={AfterRun}
	  Base Name : XML設定の<Post_String>を決定する
	  HTML-id   : 機能設定時,HTMLを書き換えるid default:grpTaskStat"
	  if        : I/Fの設定体系 XML設定の名称 <IFString_{IFStructure Name} default:volumio
	  cb        : Callback JS
	  js        : AfterRun Js Post関数実行後に行うjs
	  <{Base Name}>:PostFunctionForm %server%:内部でPost実行 PCAddressを設定 %cmd%:<IFString_volumio>で設定するFunctionに置換 , %callback:呼び元の形式cb={callback}
	 Sock_Library:mpdtask.if.lib.phpを使用する

	 ※ テストモジュール mpdtasktest.php テスト用Print $DEBUG= 1"<div"を使用する。
------------------------------------------------------------------------------- */
$require_lib=dirname(__FILE__).'/mpdweb.lib.php';		// Mpd XML Library Default
if  (file_exists(dirname(__FILE__)."/".basename(__FILE__,".php").".lib.php")) {		// Mpd XML Library mpd{module}.lib.phpの存在確認
	$require_lib=dirname(__FILE__)."/".basename(__FILE__,".php").".lib.php";
	}
require_once($require_lib);								// Mpd XML Library mpd{module}.lib.php

$appli_lib=dirname(__FILE__).'/mpdweb.lib_appli.php';	// Mpd XML Library Default
if  (file_exists(dirname(__FILE__)."/".basename(__FILE__,".php").".lib_appli.php")) {		// Mpd Application Library mpd{module}.lib_appli.phpの存在確認
	$appli_lib=dirname(__FILE__)."/".basename(__FILE__,".php").".lib_appli.php";
	}
require_once($appli_lib);								// Mpd XML Library mpd{module}.lib.php

$require_ses=dirname(__FILE__).'/mpdcmnses.lib.php';	// Mpd Session id Library ※ mpdtask.if.lib.phpより先にrequireすること
if  (file_exists($require_ses)) { require_once($require_ses); }	// Mpd XML Library mpd{module}.lib.phpの存在確認
$appli_lib=dirname(__FILE__)."/mpdtask.if.lib.php"; 	// Mpd TaskServer I/F lib
require_once($appli_lib);								// require Mpd TaskServer I/F lib

$SESSION_CONF=GetSessionConfig();						// mpdtask.if.lib.php:$XML_MPDLIBを判定する(GetEnvCommon経由)
ArgSessionStart($SESSION_CONF);							// Start Session : Used mpdcmnses.lib.php
$XML_CONF=NULL;											// XML_ALTER機能でSessionデータ反映後変わっているかも知れないのでクリア


$MY_VERSION=basename(__FILE__,"")." 1.07 (20.04.2023)";
$DEBUG= false;		// flase , 1:msg 2:msglog
//$DEBUG= 1;		// flase , 1:msg 2:msglog
//$DEBUG= 2;		// flase , 1:msg 2:msglog
/*-------------------- Used Test Infomation Start -----------------------------
Command
 Volumio Stop   :"/volumio/app/plugins/system_controller/volumio_command_line_client/volumio.sh vstop\n";
 Volumio Start  : "/volumio/app/plugins/system_controller/volumio_command_line_client/volumio.sh vstart\n";
 Volumio Statusd: "ps -ef | grep '/usr/local/bin/node /volumio/index.js' | grep -v grep\n";
 Volumio Valid  : "if [ -d /volumio ]; then echo 'Volumio'; else echo 'Wrong'; fi\n";
 LMS Statusd    :"ps -ef | grep squeezelite | grep -v grep\n";
---------------------- Used Test Infomation End ------------------------------- */
$ARG=PostAnalyze();
if (GetEnvTaskCommon($ARG) ===false) {
	 if ((isset($REQUIRE))&&($REQUIRE=="on")) { $REQUIRE="failed"; } else { exit(); }		// require_onceの時はexitしない
	 }

GetEnvIF($ARG["if"],"",$ARG["distri"]);		//Make IF Part XML <IFString>

if (isset($ARG['p'])) {
	 $distri=$ARG["distri"];
	 if ($ARG['p']=="init") {		// initialize
		 Post_CmdInit();
		 }
	 if ($ARG['p']=="status") {		// Task Server Status
		 Post_CmdState($distri);
		 }
	 else if ($ARG['p']=="start") {	// Task Server Start Command Send
		 Post_CmdStart($distri);
		 }
	 else if ($ARG['p']=="stop") {	//  Task Server Stop Command Send
		 Post_CmdStop($distri);
		 }
	 }
else {
	 print $MY_VERSION."<BR>";		 // 直接URLで開くとversionを表示 http://{self}/mpdtask.php
	 print "mpdtask.xml/TaskServer/Host[".$XML_HOST["Host"]."]<BR>";
	 }

/* -----------------------------------------------------------------------------
	PostAnalyze($param) : Argument Analyze
	$param  : i  : Parameter($_POST) 
	@rerutn : o  : Argument
----------------------------------------------------------------------------- */
function PostAnalyze() {
	if (isset($_POST["p"])) {
		 $param=$_POST;
		 }
	else {
		 $param=$_GET;
		 }
	$arg=array();
	foreach($param as $key => $get) {		// ArgAnalyze($_GET)と同じ形式にする
		$arg[$key]=ArgDecode($get);			// namespace MyProject
		}
	if (!isset($arg["use"]))   { $arg["use"]="mpdweb"; }			// Base Name
	if (!isset($arg["id"]))    { $arg["id"]="grpTaskStat"; }		// Post後,表示 id
	if (!isset($arg["if"]))    { $arg["if"]="mpdos"; }				// I/F Name
	if (!isset($arg["cb"]))    { $arg["cb"]=""; }					// Callback
	if (!isset($arg["js"]))    { $arg["js"]=""; }					// Js AfterRun
	if (!isset($arg["distri"])){ $arg["distri"]=""; }				// XML:Attribute"Distri" p=initでは無効

	if (isset($arg["b64"])) { print "<BR><BR>";print "Input[".$arg["b64"]."] -> b64[".(base64_encode($arg["b64"]))."]<BR><BR>"; }
	return($arg);
	}

/* -----------------------------------------------------------------------------
	GetEnvIF($if,$tag,$distri) : Make IF Part XML <IFString>
	 $if    : i  : I/F ,"volumio"...
	 $tag   : i  : Function:Tag : "init"/"stat"/"start"/"stop"... 未指定時全て
	 $distri: i  : 対象となる Attribute"Distri"，未指定時Attribute"Distri"指定なしを対象

     $XML_ARYIF:Tag Array
	  $XML_ARYIF[{Tag}][0][0～]                       : Tag Value
	  $XML_ARYIF[{Tag}][{Attribute}][0～]             : Attribute
	  $XML_ARYIF[{Tag}][{2ndTag}][0～]                : Tag Value
	  $XML_ARYIFATR[{Tag}][{2ndTag}][{Attribute}][0～]: Attribute
	 $XML_ARYIFATR:Attribute Array
      $XML_ARYIF   ["res_val"][0][0～]                : String
	  $XML_ARYIFATR["res_val"]["cmd"][0～]            : Attribute
	  $XML_ARYIF   ["init"]["cmd"][0～]               : Command String
	  $XML_ARYIFATR["init"]["cmd"][0～]  	          : Attribute
	  $XML_ARYIF   ["init"]["result"][0～]            : Result String
	  $XML_ARYIFATR["init"]["result"][0～]            ; Attribute
------------------------------------------------------------------------------- */
function GetEnvIF($if,$tag="",$distri="") {
	global $XML,$XML_ARYIF,$XML_ARYIFATR;

// mpdtasktest.php テスト用Print Start
global $DEBUG;if($DEBUG==1) {
	print '<div style="position:fixed;bottom:10px;left:10px;width:1480px;height:200px;background:#c0c0c0;border:2px;font-size:12px;color:#000000;overflow:scroll;z-index:1000;">DebugAre2<BR>';
	}
// mpdtasktest.php テスト用Print End

	$XML_ARYIF=array();$XML_ARYIFATR=array();
	$XML_IF=$XML["IFString_".$if];					// 対象のIFを取得

	$XML_ARYIF=array();
	$dxml = dom_import_simplexml($XML_IF);			// XML To HTML

	foreach($dxml->childNodes as $node) {			// DOMNode
		if ($node->nodeName == "#text") { continue; }
		if ($node->nodeName == "#comment") { continue; }
		if (($tag !=="")&&($node->nodeName !== $tag)) { continue; }

		$flgBreak=0;$flgAtriValid=0;$flgAtriOk=0;
		foreach($node->attributes as $attr => $dmy) {
			$attrobj = $node->attributes->getNamedItem($attr);
			if ($attr =="distri") { $flgAtriValid=1; }													// distri:attributesがある
			if (($attr =="distri")&&((string)$attrobj->nodeValue ==$distri)) { $flgAtriOk=1; }			// distri:attribute一致

			if(($distri !=="")&&($attr =="distri")&&((string)$attrobj->nodeValue !==$distri)) { $flgBreak=1;break; }	// Distri指定時は一致しないと対象外
			else {
				 if(($distri =="")&&($attr =="distri")&&($attrobj->nodeValue !==""))  { $flgBreak=1;break; }			// Distri指定なしはDistri指定Tagは対象外
				 }
			}
		if($flgBreak==1) { continue; }

		if ($flgAtriOk==1) {				// DistriDistri一致時，同一Tagを削除
			_GetEnvIF_Remove($node->nodeName);
			}
		if ($flgAtriValid==0) {				// Attributes:distriなしのTagはInsert済は追加しない
			if (!(_GetEnvIF_InsCheck($node->nodeName))) { continue; }
			}
		$flgTagSet=0;						// childNodesをセットしたか
		if (count($node->childNodes) == 0) {
			 if($DEBUG==1) { print '[unset]$node->nodeName['.$node->nodeName.']:$node->nodeValue['.$node->nodeValue.']<BR>'; }
			 }
		else {
			 foreach($node->childNodes as $cnode) {
				 if ($cnode->nodeName == "#text") { continue; }
				 if ($cnode->nodeName == "#comment") { continue; }
				 $n=0;
				 foreach($cnode->childNodes as $val) {						// 同一TagがあるときはLoop
					if ($val->nodeName == "#text") { continue; }
					if ($val->nodeName == "#comment") { continue; }
					$sxml = simplexml_import_dom($val);
					$str=$sxml->asXML();
					$XML_ARYIF[$node->nodeName][$cnode->nodeName][$n]=$str;
					if($DEBUG==1) { print '[T-3]$node->nodeName['.$node->nodeName.']$cnode->nodeName['.$cnode->nodeName.']$n['.$n.']$val->nodeName['.$val->nodeName.']:$val]'.$str.'<BR>'; }
					$flgTagSet=1;
					foreach($cnode->attributes as $attr => $dmy) {			// AttributeはTagと配列構造
						$attrobj = $cnode->attributes->getNamedItem($attr);		// Attributes
						$attval  = $attrobj->nodeValue;							// Attributes Value
						$XML_ARYIFATR[$node->nodeName][$cnode->nodeName][$n][$attr]=$attval;
						if($DEBUG==1) { print '[A-3]$node->nodeName['.$node->nodeName.']$cnode->nodeName['.$cnode->nodeName.']$n['.$n.']$attr['.$attr.'] :$attval['.$attval.']<BR>'; }
						}

					$n=$n+1;
					}
				 if ($n == 0) {												// 同一Tagがない
					 for($i=0;;$i=$i+1) { if(isset($XML_ARYIF[$node->nodeName][$cnode->nodeName][$i])) { } else { break; } }
					 $XML_ARYIF[$node->nodeName][$cnode->nodeName][$i]=$cnode->nodeValue;
					 if($DEBUG==1) { print '[T-2]$node->nodeName['.$node->nodeName.']$cnode->nodeName['.$cnode->nodeName.']$i['.$i.'][:$cnode->nodeValue['.$cnode->nodeValue.']<BR>'; }
					 $flgTagSet=1;
					 foreach($cnode->attributes as $attr => $dmy) {			// AttributeはTagと配列構造
							$attrobj = $cnode->attributes->getNamedItem($attr);		// Attributes
							$attval  = $attrobj->nodeValue;							// Attributes Value
							$XML_ARYIFATR[$node->nodeName][$cnode->nodeName][$i][$attr]=$attval;
							if($DEBUG==1) { print '[A-2]$node->nodeName['.$node->nodeName.']$cnode->nodeName['.$cnode->nodeName.']$i['.$i.']$attr['.$attr.']:$attval['.$attval.']<BR>'; }
							}
					 }
				}

			if ($flgTagSet==0)  {		// Chaid Tagなし
				$XML_ARYIF[$node->nodeName][0][0]=$node->nodeValue;	// [{Tag}][0][0]
				if($DEBUG==1) { print '[T-1]$node->nodeName['.$node->nodeName.'] $node->nodeValue['.$node->nodeValue.']<BR>'; }
				}
				foreach($node->attributes as $attr => $dmy) {				// AttributeはTagと配列構造
					 $attrobj = $node->attributes->getNamedItem($attr);				// Attributes
					 $attval  = $attrobj->nodeValue;								// Attributes Value
					 $XML_ARYIFATR[$node->nodeName][0][][$attr]=$attval;
					 if($DEBUG==1) { print '[A-1]$node->nodeName['.$node->nodeName.'] $key['.$attr.'] $attval['.$attval.']<BR>'; }
					 }
			}
		}

	GetEnv_ResVal($if);			// I/Fの固定値変換をチェック

// mpdtasktest.php テスト用Print Start
	if($DEBUG==1) {
		print '</div>';
		print '<div style="position:fixed;top:60px;left:730px;width:760px;height:560px;background:#ffffff;border:2px;font-size:12px;color:#000000;overflow:scroll;">DebugAre1<BR>';
		print_r($XML_ARYIF);
		print_r($XML_ARYIFATR);
		TblDump('$XML_ARYIF',$XML_ARYIF,"");
		TblDump('$XML_ARYIFATR',$XML_ARYIFATR,"");
		print '<div>';
		}
// mpdtasktest.php テスト用Print End
	}
/*
	_GetEnvIF_Remove($tag) : Same Tag ,Remove
	 $tag   : i  : Check Tag 
*/
function _GetEnvIF_Remove($tag) {
	global $XML_ARYIF,$XML_ARYIFATR;

	foreach($XML_ARYIF as $key => $val) {
		if($key == $tag) {
			unset($XML_ARYIF[$key]);
			}
		}
	foreach($XML_ARYIFATR as $key => $val) {
		if($key == $tag) {
			unset($XML_ARYIFATR[$key]);
			}
		}
	}

/*
	_GetEnvIF_InsCheck($tag) : Same Tag ,Check
	 $tag   : i  : Check Tag 
	 @return: True : Not Same Tag / False : Valid,Same Tag
*/
function _GetEnvIF_InsCheck($tag) {
	global $XML_ARYIF,$XML_ARYIFATR;

	$result=True;
	foreach($XML_ARYIF as $key => $val) {
		if($key == $tag) {
			$result=False;
			berak;
			}
		}
	return($result);
	}

/*
	例
	 $XML_ARYIF [reject][result][0]Volumio
	 $XML_ARYIF [init][cmd][0]if [ -d /volumio ]; then echo 'Volumio'; else echo 'Wrong'; fi
	 $XML_ARYIF [init][result][0]
	 $XML_ARYIF [stat][cmd][0]ps -ef | grep -e '/bin/node
	 $XML_ARYIF [stat][default][0]Volumio
	 $XML_ARYIF [stat][result][0]Volumio
	 $XML_ARYIF [start][cmd][0]/volumio/app/plugins/system_controller/volumio_command_line_client/volumio.sh vstart
	 $XML_ARYIF [stop][cmd][0]/volumio/app/plugins/system_controller/volumio_command_line_client/volumio.sh vstop
	----------------------------------------------------------------------------
	 $XML_ARYIFATR [reject][result][0][show]background-color:#808080;
	 $XML_ARYIFATR [reject][result][0][noshow]background-color:#d3d3d3;display:none;
	 $XML_ARYIFATR [init][result][0][value]volumio
	 $XML_ARYIFATR [stat][default][0][func]start
	 $XML_ARYIFATR [stat][result][0][value]/volumio/
	 $XML_ARYIFATR [stat][result][0][func]stop
	 $XML_ARYIFATR [start][cmd][0][shell]off
	 $XML_ARYIFATR [start][cmd][0][timeout]10
	 $XML_ARYIFATR [start][0][0][distri]volumio
	 $XML_ARYIFATR [stop][cmd][0][shell]off
	 $XML_ARYIFATR [stop][cmd][0][timeout]3
	 $XML_ARYIFATR [stop][0][0][distri]volumio
*/

/* -----------------------------------------------------------------------------
	GetEnv_ResVal($if) : I/Fの固定値変換をチェック(Result Value)
	 $if    : i  : I/F ,"volumio"."mpd"..
------------------------------------------------------------------------------- */
function GetEnv_ResVal($if) {
	global $XML_RESVAL;		// result Conttant設定

	$xml_tmp=array("res_val"=>"");									// result Conttant設定 <res_val>"{res}":"{val}" or {res}:{val}
	get_config("IFString_".$if,$xml_tmp);
	$ary = explode(',',$xml_tmp['res_val']);
	foreach ($ary as $ar) {											// 設定XML最上層の値と属性を取得
		$result = preg_match_all('/"(.*?)"/s',$ar,$part,PREG_SET_ORDER);		// Result:正規表現:<{Item}>を検出 $part[n][0]:{Item} [1]:Value
		if (isset($part[0][1])) {
			 $key=$part[0][1];
			 $val = str_replace('"'.$key.'":',"",$ar);
			 if (($val==$ar)||($val=="")) { continue; }
			 }
		else {
			 $a = explode(':',$ar,2);
			 if (!isset($a[1])) { continue; }
			 $key=$a[0];$val=$a[1];
			 }
		$result = preg_match_all('/"(.*?)"/s',$val,$part,PREG_SET_ORDER);		// Value:正規表現:<{Item}>を検出 $part[n][0]:{Item} [1]:Value
		if (isset($part[0][1])) {
			$val=$part[0][1];
			}
		$XML_RESVAL[$key]=$val;
		}
//print '<BR>$XML_RESVAL:<BR>';print_r($XML_RESVAL);print '<BR>';
	}

/* -----------------------------------------------------------------------------
	Post_CmdInit() : mpdtaskserver Initial Status
	Connectできないときは,以降の機能を使用しないためI/F Buttonを消す
------------------------------------------------------------------------------- */
function Post_CmdInit() {
	global $ARG,$XML_ARYIF,$XML_ARYIFATR;

	$cmd = "";$default ="";			// Volumioを検出時:$cmd = "if [ -d /volumio ]; then echo 'Volumio'; else echo 'Wrong'; fi\n";
	if (isset($XML_ARYIF["init"]["default"][0])) {
		$default =$XML_ARYIF["init"]["default"][0];
		}
	$defaultfunc="init";									// default:未設定時
	if (isset($XML_ARYIFATR["init"]["default"]["func"][0])) {
		$defaultfunc =$XML_ARYIFATR["init"]["default"][0]["func"];
		}
	$post=Post_MakeCmd($defaultfunc,$ARG["cb"],$ARG["js"],"");
	$default = str_replace("%post%",$post,$default);		// CallBack設定
	$mode=1;$html = "";
	if (isset($XML_ARYIF["init"]["cmd"][0])) {
		$cmd=$XML_ARYIF["init"]["cmd"][0]."\n";
		}
	$ret=Post_CmdExec($cmd,$mode,"init",$errno,$errstr);
	if ($ret===false) {
		 Post_NoneTaskServer("None");
		 return;
		 }
	else {
		 if (stripos($ret,'Reject') !== false) {
		 	print "Login failed\n";
			Post_NoneTaskServer("");
		 	return;
		 	}
		 }

	global $DEBUG;if($DEBUG==1) { print 'Post_CmdInit $ARG["if"]['.$ARG["if"].']$ret['.$ret."]\n"; }
	$value=NULL;$distri="";$point=0;$flgBreak=0;				// Shell実行結果をチェック
	if ((isset($XML_ARYIFATR["init"]["result"]))&&(is_array($XML_ARYIFATR["init"]["result"]))) {
		foreach ($XML_ARYIFATR["init"]["result"] as $x=>$ary) {
			if (is_array($ary)) {
				foreach ($ary as $key=>$xval) {					// 実行結果の期待値Get
					if ($key=="value") {
						if (stripos($ret,$xval) !== false) {	// 実行結果と期待値が一致
							$flgBreak=1;
							$point=$x;
							$value=$xval;
							if (isset($ary["distri"])) { $distri=$ary["distri"]; }
							break;
							}
						}
					}
				if ($flgBreak == 1) { break; }
				}
			}
		if ((!is_null($value)))			 {						// 実行結果が有効な場合
			if (isset($XML_ARYIF["init"]["result"][$point])) {
				  $html=$XML_ARYIF["init"]["result"][$point];
				  }
			if ($html!=="") {
				  print "\n";
				  print $ARG["id"].":";
				  $str ='<div id="'.$ARG["id"].'">';
				  $str .=$html;
				  $str .='</div>';
				  print $str;
				  print "\n";
				  }
			  Post_CmdState($distri);
			  return;
			  }
		}
	if ($default !=="") {
		print "\n";
		print $ARG["id"].":";
		$str  ='<div id="'.$ARG["id"].'">';
		$str .=$default;
		$str .='</div>';
		print $str;
		print "\n";
		}
	}

/* -----------------------------------------------------------------------------
	Post_CmdState($distri) : Task Status
	 $distri: i  : XML : Attribute"Distri"，未指定時Attribute"Distri"指定なしを対象
	 @return: o  : 動作チェック時のresult:Active  "":NonActive
	Cmdの結果を判定してHTMLを作成
------------------------------------------------------------------------------- */
function Post_CmdState($distri) {
	global $ARG,$XML_RESVAL,$XML_ARYIF,$XML_ARYIFATR;

	$ret=false;
	if ($distri !=="") { GetEnvIF($ARG["if"],"",$distri); }	// I/F設定 Distriで再作成
	if(!isset($XML_ARYIF["stat"])) { return($ret); }		// 設定なしは対象外

	$cmd = "";	// $value=""; 				// 例)Volumioを動作Check;"ps -ef | grep '/usr/local/bin/node /volumio/index.js' | grep -v grep\n"; $value Volumioを動作String: "/volumio/"; 
	$default ="";							// デフォルトのHTML(button):<button type=submit onclick="%post%" style="height:20px;border:solid 1px #888888;font-size:12px;background-color:#4682b4;color:#c0c0c0;">Volumio</button>';
	if (isset($XML_ARYIF["stat"]["default"][0])) {			// Command(cmd)を発行したときの default(p=init,start,stopの動作が消されることがあるため)
		$default= $XML_ARYIF["stat"]["default"][0];
		}
	$defaultfunc="stop";									// default:未設定時
	if (isset($XML_ARYIFATR["stat"]["default"][0]["func"])) {
		$defaultfunc= $XML_ARYIFATR["stat"]["default"][0]["func"];
		}
	$post=Post_MakeCmd($defaultfunc,$ARG["cb"],$ARG["js"],$distri);
	$default = str_replace("%post%",$post,$default);		// CallBack設定
	$func=$defaultfunc;
	$html ="";$mode=1;	$str="";
	if (isset($XML_ARYIF["stat"]["cmd"][0])) {
		$cmd=$XML_ARYIF["stat"]["cmd"][0]."\n";
		print "Task LiveState Start\n";
		$ret=Post_CmdExec($cmd,$mode,"stat",$errno,$errstr);
//$fp=fopen("log/mpdtask.log","a");fwrite($fp,'Post_CmdState('.$distri.') $cmd['.$cmd.']$ret['.$ret."]\n");fclose($fp);
		if ($ret===false) {
			Post_NoneTaskServer("");
			return($ret);
			}
		if (stripos($ret,'Reject') !== false) {
			print "Login failed\n";
			Post_NoneTaskServer("");
			return($ret);
			}
		$resval="";
		foreach ($XML_RESVAL as $key=>$val) {	// 固定値変換をチェック
			if (stripos($ret,$key) !== false) {
				$resval=$val;
				break;
				}
			}
		if ((isset($XML_ARYIFATR["stat"]["result"]))&&(is_array($XML_ARYIFATR["stat"]["result"]))) {
			$value=NULL;$point=0;$flgBreak=0;						// 実行結果/チェック用項目 Funcはなければdefault($defaultfunc)使用
			foreach ($XML_ARYIFATR["stat"]["result"] as $x=>$ary) {
				if (is_array($ary)) {
					foreach ($ary as $key=>$xval) {					// 実行結果の期待値Get
						if ($key=="value") {
							if (stripos($ret,$xval) !== false) {	// 実行結果と期待値が一致
								$flgBreak=1;
								$point=$x;
								$value=$xval;
								if (isset($ary["func"])) { $func=$ary["func"]; }
									break;
									}
							}
						}
					if ($flgBreak == 1) { break; }
					}
				}
//$fp=fopen("log/mpdtask.log","a");fwrite($fp,'Post_CmdState('.$distri.') $value['.$value.']$point['.$point.']$func['.$func.']$ret['.$ret."]\n");fclose($fp);
			if ((!is_null($value)))			 {								// 実行結果が有効な場合
				if  (isset($XML_ARYIFATR["stat"]["result"]["func"][$point])) {
					$func= $XML_ARYIFATR["stat"]["result"]["func"][$point];
					}
				 $post=Post_MakeCmd($func,$ARG["cb"],$ARG["js"],$distri);
				 if (isset($XML_ARYIF["stat"]["result"][$point])) {
					$html= $XML_ARYIF["stat"]["result"][$point];
					}
				 $str  ='<div id="'.$ARG["id"].'">';
				 $tmp = str_replace("%res_val%",$resval,$html);
				 $str .=$tmp;
				 $str .='</div>';
				 $str = str_replace("%post%",$post,$str);		// CallBack設定
				 $ret =$value;
				 }
			else {											// Volumioが停止している場合
				 $str  ='<div id="'.$ARG["id"].'">';
				 $tmp = str_replace("%res_val%",$resval,$default);
				 $str .=$tmp;
				 $str .='</div>';
				 $ret ="";
				 }
			}
		if ($str!=="") {
			 print "\n";
			 print $ARG["id"].":";
			 print $str;
			 print "\n";
			 print "Task LiveState End\n";
			 }
		else {
			 print "Task LiveState End(Nop)\n";
			 }
		}
	return($ret);
	}

/* -----------------------------------------------------------------------------
	Post_CmdStart($distri) : Post Start
	 $distri: i  : XML : Attribute"Distri"，未指定時Attribute"Distri"指定なしを対象
------------------------------------------------------------------------------- */
function Post_CmdStart($distri) {
	global $XML_ARYIF;

	$cmd = "";		// $value=""; 	// 例)VolumioをStart時;"/volumio/app/plugins/system_controller/volumio_command_line_client/volumio.sh vstart\n";
	$timeout=10;
	if (isset($XML_ARYIFATR["start"]["cmd"]["timeout"])) {
		$timeout=(string)$XML_ARYIFATR["start"]["cmd"]["timeout"];
		}

	print "Task Func[Start] Start\n";
	$mode=1;
	if (isset($XML_ARYIF["start"]["cmd"][0])) {
		$cmd=$XML_ARYIF["start"]["cmd"][0]."\n";
		}
	$ret=Post_CmdExec($cmd,$mode,"start",$errno,$errstr);
	if ($ret===false) {
		Post_NoneTaskServer("");
		return;
		}
	if (stripos($ret,'Reject') !== false) {
		print "Login failed\n";
		Post_NoneTaskServer("");
		return;
		}
	
	print "Task Func[Start] End\n";
	for($cnt=0;$cnt<$timeout;$cnt++) {
		$ret=Post_CmdState($distri);
		if ($ret !=="") { break; }
		sleep(1);
		}
	}

/* -----------------------------------------------------------------------------
	Post_CmdStop($distri) : Post Stop
	 $distri: i  : XML : Attribute"Distri"，未指定時Attribute"Distri"指定なしを対象
------------------------------------------------------------------------------- */
function Post_CmdStop($distri) {
	global $XML_ARYIF,$XML_ARYIFATR;;

	$cmd = ""; 		// $value=""; 	// 例)VolumioをStop時;"/volumio/app/plugins/system_controller/volumio_command_line_client/volumio.sh vstop\n";
	$timeout=3;
	if (isset($XML_ARYIFATR["stop"]["cmd"][0]["timeout"])) {
		$timeout=(string)$XML_ARYIFATR["stop"]["cmd"][0]["timeout"];
		}

	print "Task Func[Stop] Start\n";
	$mode=1;
	if (isset($XML_ARYIF["stop"]["cmd"][0])) {
		$cmd=$XML_ARYIF["stop"]["cmd"][0]."\n";
		}
	$ret=Post_CmdExec($cmd,$mode,"stop",$errno,$errstr);
	if ($ret===false) {
		Post_NoneTaskServer("");
		return;
		}
	if (stripos($ret,'Reject') !== false) {
		print "Login failed\n";
		return;
		}
	print "Task Func[Stop] End\n";
	for($cnt=0;$cnt<$timeout;$cnt++) {
		$ret=Post_CmdState($distri);
		if ($ret =="") { break; }
		sleep(1);
		}
	}

/* -----------------------------------------------------------------------------
	Post_NoneTaskServer($show=) : mpdtaskserver Botton off
	 $show  : i  : "":Grayout / "None":off
------------------------------------------------------------------------------- */
function Post_NoneTaskServer($show="") {
	global $ARG,$XML_ARYIF,$XML_ARYIFATR;

	$html='<button type=submit style="height:20px;border:solid 1px #888888;font-size:12px;color:#c0c0c0;%disp%">Volumio</button>';
	if (isset($XML_ARYIF["reject"]["result"][0])) {
		$html= $XML_ARYIF["reject"]["result"][0];
		}
	$show="background-color:#808080;";
	$noshow="background-color:#d3d3d3;display:none;";
	if (isset($XML_ARYIFATR["reject"]["result"][0]["show"])) {
		$show=(string)$XML_ARYIFATR["reject"]["result"][0]["show"];
		}
	if (isset($XML_ARYIFATR["reject"]["result"][0]["noshow"])) {
		$noshow=(string)$XML_ARYIFATR["reject"]["result"][0]["noshow"];
		}

	if ($show != "") {
		 $show=$noshow;
		 }
	$html = str_replace("%disp%",$show,$html);

	print "\n";
	print $ARG["id"].":";
	$str  ='<div id="'.$ARG["id"].'">';
	$str .=$html;
	$str .='</div>';
	print $str."\n";
	}

/* -----------------------------------------------------------------------------
	Post_MakeCmd($cmd,$callback,$distri) : mpdtaskserver I/F Post String
	 $cmd     : i  : I/F Command
	 $callback: i  : I/F Callback
	 $distri  : i  : XML : Attribute"Distri"，未指定時Attribute"Distri"指定なしを対象
	 @return  : o  : I/F Onclick Post Srting
------------------------------------------------------------------------------- */
function Post_MakeCmd($cmd,$callback="",$js="",$distri="") {
	global $XML_POST,$ARGSTR;				// XML Setting

	$tmp=$ARGSTR;
	if ($distri !=="") {									// PostにXML:Attribute"Distri"を追加
		$tmp=$ARGSTR.",distri=".$distri;
		}
	$str=str_replace(array("\\","'",'"'),array("\\\\","\'",'&quot;'),$tmp);
	$post = str_replace('%cmd%','p='.$cmd.$str,$XML_POST);	// Server 実行モジュールリンクパラメータ作成
	if ($callback == "") {
		 $str="''";
		 }
	else {
		 $str=$callback;
		 }
	$post = str_replace('%callback%',$str,$post);			// CallBack設定

	$str=str_replace(array("\\\\","\'",'&quot;'),array("\\","'",'"'),$js);
	$post=rtrim($post,";").";".$str;
//$fp=fopen("log/mpdtask.log","a");fwrite($fp,'Post_CmdInit $post['.$post."]\n");fclose($fp);
	return($post);
	}

/* -----------------------------------------------------------------------------
	Post_CmdExec($cmd,$mode,$errno,$errstr) : Send Command Exec
	 $cmd      : i  : I/F Command ()
	 $mode     : i  : ReturnMode , 0:Array (LFで区切り配列) , 1:String
	 $kind     : i  : コマンド発行種類 "init","stat","start","stop"
	 $errno    : io : Error No     有効時セット
	 $errstr   : io : Error String 有効時セット
	 @return   : o  : Failure:False / Success:Receive
------------------------------------------------------------------------------- */
function Post_CmdExec($cmd,$mode,$kind,&$errno,&$errstr) {
	global $XML_HOST,$XML_ARYIFATR,$XML_SHELL,$XML_EXCLUDE;

	$EXC_CMD=$XML_EXCLUDE["cmdary"];		// 除外対象Array $EXC_CMD=array("start","stop");
	$key = in_array($kind,$EXC_CMD);
	if ($key) {
//print "mpdtask EXCLUDE[".$kind."][ ".$_SERVER['REMOTE_ADDR']."]\n";
		if (!Commn_Subnet($XML_EXCLUDE['netmask'],$_SERVER['REMOTE_ADDR'])) {
			return("");
			}
		}

	$cmd=ArgMakeSvrCmd($cmd);
//	$cmd=str_replace("%sudo-pw%",$XML_SHELL["sudo-pw"],$cmd);			// Password SearchShellを使わない場合有効し,上Lineの // $cmd=ArgMakeSvrCmd($cmd);コメントアウト

	$errno="";$errstr="";
	$host="";$rhost="";
	if (isset($_SERVER["REMOTE_ADDR"])) {
		$rhost=$_SERVER["REMOTE_ADDR"];
		}
	if (isset($_SERVER["HTTP_HOST"])) {
		$urlary = parse_url($_SERVER["HTTP_HOST"]);		// {host}:{88}
		if (isset($urlary["host"])) { $host=$urlary["host"]; }
		}
// Task Serverが HTTP Serverと同じ場合,Shellで求める
	$shell=0;
	if ($XML_HOST["Force"] == "off") {					// $XML_HOST["Force"]:on時常にTaskServer使用
		if ((isset($XML_ARYIFATR[$kind]["cmd"]["shell"]))&&((string)$XML_ARYIFATR[$kind]["cmd"]["shell"]=="off")) { }
		else {
			 if (($XML_HOST["Host"]=="localhost")||($XML_HOST["Host"]=="127.0.0.1")||(($host !=="")&&($host==$XML_HOST["Host"]))||(($rhost !=="")&&($rhost==$XML_HOST["Host"]))) {
				 $shell=1;
				 }
			 }
		}
	if (($XML_HOST["Excludesu"] == "on")&&(strpos($cmd,"sudo") !== false)) {	// sudoはTaskServerで行う。exec:WebからパーミッションをChildProcessに継承するため
		$shell=0;
		}
	if ($shell==1) {
		if ($mode==1) {
			  msglog('[mpdtask][shell_exec]['.$cmd.']');	// Used Debug
			  $ret = shell_exec($cmd);
			  }
		 else {
			  msglog('[mpdtask][exec]['.$cmd.']');			// Used Debug
			  exec($cmd,$ret);
			  }
		 }
	else {
		 msglog('[mpdtask][SockCmdsend]['.$cmd.']Host['.$XML_HOST["Host"].']Port"]['.$XML_HOST["Port"].']');			// Used Debug
		 $ret=SockCmdsend($XML_HOST["Accunt"],$cmd,$XML_HOST["Host"],$XML_HOST["Port"],$XML_HOST["Timeout"],$XML_HOST["TermStr"],$mode,$errno,$errstr);
		 }
//if (is_array($ret)) {										// Used Debug
//	 print 'Array $ret('.count($ret).'):';print_r($ret);print "<BR>";
//	 }
//else {
//	 print 'String $ret:'.$ret."<BR>";
//	 }
	return($ret);
	}

//$ret=$ret."\x1b\x0a";

/* -----------------------------------------------------------------------------
	DispMsgBox($str,$top,$left,$title): Display Message Box
	 $str   : i  : Message
	 $title : i  : Message Title
----------------------------------------------------------------------------- */
function DispBox($msg="",$title="Message Box") {
	global $ARG;

	$top=20;$left=20;
	$str = explode('/',$_SERVER['PHP_SELF']);
	$mod=$str[(count($str)-1)];
	$width=300;$unload="document.getElementById('".$ARG["id"]."').style.display='none';";
	$html  = '<div id='.$ARG["id"].' style="position:fixed;top:'.$top.'px;left:'.$left.'px;border: 1px solid #888888;width:'.$width.'px;height:160px;background-color:#f5f5f5;">';
	$html .= '<div align=left style="position:absolute;top:0px;left:0px;width:'.($width-20).'px;height:18px;overflow:hidden;word-wrap: break-word;text-overflow:ellipsis;font-size:14px;background-color:#0000FF;color:#CEECF5;padding:8px 10 2px;">'.$mod.' '.$title.'</div>';
	$html .= '<div align=center style="position:absolute;top:40px;left:20px;width:'.($width-40).'px;height:100px;overflow:hidden;word-wrap: break-word;text-overflow:ellipsis;font-size:15px;line-height:20px;text-align:center;color:#000000;">'.$msg.'</div>';
	$html .= '<input type="button" name="Submit" value="OK" onclick="'.$unload.'" style="position:absolute;top:120px;left:'.(($width/2)-20).'px;border: 1px solid #888888;width:60px;height:24px;padding:2px 0 2px;font-size:11px;cursor:pointer;-moz-border-radius:4px;-webkit-border-radius:4px;border-radius: 4px;" />';
	$html .= '</div>';

	print "\n";
	print $ARG["id"].":";
	$str  ='<div id="'.$ARG["id"].'">';
	$str .=$html;
	$str .='</div>';
	print $str."\n";
	print '</div>';
	}

/* -------------- End Of Source --------------------------------------------------------------------------- */
?>
