/* **********************************************************************************
	mpdweb Common jsp Library mpd{module}.common.js
    ---------------------------------------------------------
	 RequestURLEncode()      : URL Encods :コマンドインタフェース・パラメータURLで使用不可文字をEncode (Js版)
	 RequestUnescapeHTML()   : HTML Unescape
	 RequestB64Encode()      : Base-64 Encode
	 RequestB64Decode()      : Base-64 Decode
	 RequestEleScrollStop()  : 指定Elementのスクロールストッパー
	 String.prototype.trim() : String Trim
	 String.prototype.ltrim(): String Left Trim
	 String.prototype.rtrim(): String RigthTrim
	 ArgTime2Sec()           : Time[HMS] To Sec
	 ArgSec2Time()           : Sec To Time[HMS]
	 CharFileName()          : FileNameCheck
	 RequestBoxDisp()        : Upper Box Display
	 RequestBoxtUnLoad()     : Upper Box UnLoad
	 ArgSesStorageSet()      : sessionStorage Set
	 ArgSesStorageGet()      : sessionStorage Get
	 RequestSureBox()        : Message Sure Box Display
	 RequestMessageBox()     : Message Box Display
	 MoveDragOn()            : Object Move ：マウスドラック移動 連続上下Divを一連移動
      +MoveDragImg()/MoveDragOff()
*********************************************************************************** */
MYJS_VERSION="mpdweb.common.js 1.38 (01.03.2025)";
/* ------------------------------------------------------------------------------------
	RequestURLEncode(str) : URL Encods :コマンドインタフェース・パラメータURLで使用不可文字をEncode (Js版)
		str     : i   : Request String
		rep     : i   : 変換Mapの変更,連想配列 (追加はできない)
		@return : o   : Encode String
------------------------------------------------------------------------------------ */
function RequestURLEncode(str,rep) {
	// map:変換パターン連想配列 regex:変換文字設定
	var map= {"%":'%25'," ":'%20',"!":'%21',"\"":'%22',"#":'%23',"$":'%24',"&":'%26',"'":'%27',"(":'%28',")":'%29',"*":'%2A',"+":'%2B',",":'%2C',"/":'%2F',":":'%3A',";":'%3B',"<":'%3C',"=":'%3D',">":'%3E',"?":'%3F',"@":'%40',"[":'%5B',"]":'%5D',"^":'%5E',"`":'%60',"{":'%7B',"|":'%7C',"}":'%7D',"~":'%7E' };
	var regex = /(%| |!|\"|#|\$|&|\'|\(|\)|\*|\+|,|\/|:|;|<|=|>|\?|@|\[|]|\^|`|{|\||}|~)/g;		// 変換文字を|で区切り指定 (" Not Escape)

	if (rep != null) {						// 変換Mapの変更の反映
		for (let key in rep) {
			map[key]=rep[key];
			}
		}
	var rep = function(whole,pl) {			// 無名関数の参照をrepにreturn
		return map[pl];
		}
	var result = str.replace(regex,rep);	// パターンにより変換 regexに指定ない文字は変換されない。
	return result;
	}

/* ------------------------------------------------------------------------------------
	RequestUnescapeHTML(str): HTML Unescape
	str    : i  : String
	@return: o  : Unescape String
	.innerHTML:そのままHTMLが取得 PHPとJavaScriptでHTMLエンティティを扱うために使用する
------------------------------------------------------------------------------------ */
function RequestUnescapeHTML(str) {
	var div = document.createElement("div");
	div.innerHTML = str.replace(/</g,"&lt;")	// innerHTML入れ、textContentで取り出す
				.replace(/>/g,"&gt;")
////////		.replace(/ /g, "&nbsp;")
				.replace(/\r/g, "&#13;")
				.replace(/\n/g, "&#10;");
  	return div.textContent || div.innerText;	//HTMLを取り除く
	}

/* ------------------------------------------------------------------------------------
	B64Encode(str) : Base-64 Encode
	str    : i  : String
	@return: o  : Encode String
	PHPで受けているURL:Base-64に変換する。
	UTF-8の検証:UTF-8はなぜかEscape文字が入るため対応する。unescape(encodeURIComponent(str)
	他のCodesetでEscape文字が入らなければ成功する。
------------------------------------------------------------------------------------ */
function RequestB64Encode(str) {
	if (document.all) {
		var codeset = document.charset;			// Get : <meta charset=utf-8"
	} else {
		var codeset = document.characterSet;	// Get : <meta charset=utf-8"
		}
	// btoa base-64にエンコードされたASCII文字列を生成
	if (codeset.toUpperCase() == 'utf-8'.toUpperCase()) {	// UTF-8 Crom:大文字 / IE:小文字なので揃えて比較
		 ret =  btoa(unescape(encodeURIComponent(str)));	// UTF-8:encodeURIComponent/unescapeしておく)
		 }
	else {
		 ret =  btoa(str);
		 }
	ret = ret.replace(/\+/g,'_');
	ret = ret.replace(/\//g,'-');
	ret = ret.replace(/=/g,'.');
	ret = "B64:"+ret;
	return(ret);
	}

/* ----------------------------------------------------------------------------
	RequestB64Decode(encodedStr) : Base-64 Decode
	 encodedStr: i  : Encode String
	 return    : o  : Decodd String
----------------------------------------------------------------------------- */
function RequestB64Decode(encodedStr) {
    if (encodedStr.startsWith("B64:")) {		    // "B64:"プレフィックスを削除
		encodedStr = encodedStr.substring(4);
		}
    encodedStr = encodedStr.replace(/_/g, '+')		// Base64での置換を元に戻す
						   .replace(/-/g, '/')
						   .replace(/\./g, '=');
	let decodedStr;									// デコード処理
	let decodedBase64 = atob(encodedStr);			// Base64デコード
	decodedStr = decodeURIComponent(escape(decodedBase64)); 
	return(decodedStr);
	}

/* ------------------------------------------------------------------------------------
	RequestEleScrollStop(scrid,ident) : 指定Elementのスクロールストッパー
	 scrid : i  : Scroll Element
	 ident : i  : Postion id (trのidを指定) ※連番になっていること
	 no    : i  : 開始No 未指定:0
	 Windowサイズが固定のボックスで使用する。WindowStopはサイズ固定のためなし(不足を最後に追加しておく)
------------------------------------------------------------------------------------ */
function RequestEleScrollStop(scrid,ident,no) {
	if (no == null) { start_no=0; } else { start_no=no; }

	if (document.getElementById(scrid).style.display=='none') { return; }
	elem_scr=document.getElementById(scrid);
	base = elem_scr.getBoundingClientRect();	// スクロールエリアの先頭位置を取得
	lineid="";
	for (i=start_no;;i++) {						// 最後のidを取得する
		lid=ident+i;
		if (document.getElementById(lid) == null) { break; }
		lineid=lid;
		}
	if (lineid=="") { return; }
	target=document.getElementById(lineid);
	if (target == null) { return; }
	last = target.getBoundingClientRect();
	console.log('last['+last.top+']Base['+base.top+']');
	if (last.top < base.top) {					// 最後のidがスクロールエリアの先頭位置を突破した場合,最後のidを可視化最終にポジション
		elem_scr.scrollTop = target.offsetTop;
		}
	}

/* ------------------------------------------------------------------------------------
	ArgTime2Sec(arghms) : Time[HMS] To Sec
	arghms : i  : Time()Str Form:hh:mm:ss or :mm:ss
	@return: o  : Sec(int)
------------------------------------------------------------------------------------ */
function ArgTime2Sec(arghms) {
	var ressec=0;
	var aryhms = arghms.split(":");
	if (aryhms.length < 3) {
		 var tmpsec=parseInt(aryhms[0])*60+parseInt(aryhms[1]);							// Secを求める(mm:ss)
		 }
	else {
		 var tmpsec=parseInt(aryhms[0])*3600+parseInt(aryhms[1])*60+parseInt(aryhms[2]);	 // Secを求める(hh:mm:ss)
		 }
	ressec=ressec+tmpsec;
	return(ressec);
	}

/*
	ArgSec2Time(argsec) : Sec To Time[HMS]
	argsec  : i  : Sec(int)
	@return: o  : Str Form:hh:mm:ss or :mm:ss
*/
function ArgSec2Time(argsec) {
		 var padm="";var pads="";var ressec="";
		 var h = argsec / 3600 | 0;
		 var m = argsec % 3600 / 60 | 0;
		 var s = argsec % 60;
		 if (m < 10) { padm="0"; }
		 if (s < 10) { pads="0"; }
		 if (h != 0) {
		 	ressec = h + ":"+padm+m+":"+pads+s;
			} else if (m != 0) { ressec =padm+m+":"+pads+s;
			} else if (s != 0) { ressec = "00:"+pads+s;
		 	}
	return(ressec);
	}

/* ------------------------------------------------------------------------------------
	CommonHex2Rgb(hex) : HexColorCode To RGB ColorCode
	 hex     : i  : HexColorCode
	 @return : o  : RGB ColorCode
------------------------------------------------------------------------------------ */
function CommonHex2Rgb(hex) {
	if ( hex.slice(0, 1) == "#" ) hex = hex.slice(1) ;
	if ( hex.length == 3 ) hex = hex.slice(0,1) + hex.slice(0,1) + hex.slice(1,2) + hex.slice(1,2) + hex.slice(2,3) + hex.slice(2,3) ;
	return "rgb("+ [ hex.slice( 0, 2 ), hex.slice( 2, 4 ), hex.slice( 4, 6 ) ].map( function ( str ) { return parseInt( str, 16 ) ; } ) + ")";
	}

/* ------------------------------------------------------------------------------------
	String.prototype.trim()  : String Trim
	String.prototype.ltrim() : String Left Trim
	String.prototype.rtrim() : String RigthTrim
	@return: o  : Trim String
	Versionにより PrototypeTrimがないので実装。PHPと設定を同期し漢字SpaceもTrimする
	※但し、Jspでのテストは、IEで半角用のtrimでも全角がなくなっていた。
	  ロジックとしては、他コードに対応し易くしておく。
------------------------------------------------------------------------------------ */
String.prototype.trim = function() {
	if (PHP_Locale == 'ja_JP.UTF-8') {			// PHP設定と同期させる
		 return this.replace(/^[\s　]+|[\s　]+$/g, "");
		 }
	return this.replace(/^\s+|\s+$/g,'');		// 半角のみ
	}
String.prototype.ltrim = function() {			// PHP設定と同期させる
	if (PHP_Locale == 'ja_JP.UTF-8') {
		return this.replace(/^[\s　]+/, "");
		}
	return this.replace(/^\s+/,'');				// 半角のみ
	}
String.prototype.rtrim = function() {
	if (PHP_Locale == 'ja_JP.UTF-8') {			// PHP設定と同期させる
		return this.replace(/[\s　]+$/, "");
		}
	return this.replace(/\s+$/,'');				// 半角のみ
	}


/* ------------------------------------------------------------------------------------
	CharFileName(str) : FileNameCheck
	str : i  : Chack Character
	return true/false
------------------------------------------------------------------------------------ */
function CharFileName(str) {
	if ((str == null)||(str == "")) {
		return(false);
		}
	if ((str.indexOf('"') != -1)||(str.indexOf('/') != -1)) {
		return(false);
		}
	pattern = /[\\:*?<>|]/
	result = str.match(pattern);
	if (result != null) {
		return(false);
		}
	return(true);
	}

/* ------------------------------------------------------------------------------------
	RequestBoxDisp(boxid) : Upper Box ディスプレイ
		boxid : i  : Box id
------------------------------------------------------------------------------------- */
function RequestBoxDisp(boxid) {
	if (document.getElementById(boxid) == null) {			// idが表示されていれば続行
		return;
		}
	document.getElementById(boxid).style.display='block';	// display: none;→block
	}

/*
	RequestBoxDisp(boxid) : Upper Box ディスプレイ解除
		boxid : i  : Box id
*/
function RequestBoxtUnLoad(boxid) {
	if (document.getElementById(boxid) == null) {		// idが表示されていれば続行
		return;
		}
	document.getElementById(boxid).style.display='none';
	}


/* ------------------------------------------------------------------------------------
	ArgSesStorageSet(prog,key,val) : sessionStorage Set
	 prog   : i  ; Session Key Prog
	 key    : i  ; Session Key
	 val    : i  : Session Data
	 sessionStorage : ["mpdweb/{prog}/{key}]
------------------------------------------------------------------------------------- */
function ArgSesStoragePut(prog,key,val) {
	if (typeof sessionStorage !== "undefined") {
		 sessionStorage["mpdweb/"+prog+"/"+key] = val;
		 }
	}

/*
	ArgSesStorageGet(subkey,val) : sessionStorage Get
	 prog   : i  ; Session Key Prog
	 key    : i  ; Session Key
	 @return: o  : Get Array
	 sessionStorage : ["mpdweb/{prog}/{key}]
*/
function ArgSesStorageGet(prog,key) {
	var ses = new Array();
	if (typeof sessionStorage !== "undefined") {
		for (var seskey in sessionStorage) {
			var result = seskey.indexOf('mpdweb/'+prog+'/'+key,0)
			if (result >=0) {
				ses[seskey]=sessionStorage[seskey];
				}
			}
		}
	return(ses);
	}
/* ---------------------------------------------------------------------------------- */

/* ------------------------------------------------------------------------------------
	RequestSureBox(title,str,func,top,left,funccls,id,strid,funcid,funcclsid) : MessageBoxディスプレイ (mpdweb.lib_appli.php/DispSureBox()をjsで使用可)
	 title    : i  : Box Title
	 str      : i  : SureBox Message
	 func     : i  : OK,function
	 top      : i  : Top (px)
	 left     : i  : Left(px)
	 funccls  : i  : close(cancell),function
	 id       : i  : SureBox id 未設定時:IDSUREBOX設定作成しておく(php global IDSUREBOX)
		             idがなければ"grpSureBox"で作成
	 strid    : i  : SureBox Message String id 未設定時:msgid+"str"
	 funcid   : i  : SureBox Function id 未設定時:msgid+"func"
	 funcclsid: i  : SureBox Close Function id 未設定時:msgid+"cls"
	前提:RequestSureBox idのboxを作成しておく。mpdweb.lib_appli.php/DispSureBox()関数で作成可
	       タイトルid            : sureid+"title"
	       メッセージid          : sureid+"str"
	       OK Function id        : sureid+"func"
	       Canccell  Function id : sureid+"cls"
	     のidで作成
------------------------------------------------------------------------------------- */
function RequestSureBox(title,str,func,top,left,funccls,id,strid,funcid,funcclsid) {
	var sureboxid ="";
	if (typeof IDSUREBOX === "undefined") { sureboxid="grpSureBox"; } else { sureboxid=IDSUREBOX; }
	if (id == null) { } else { sureboxid=id; }
	if (!document.getElementById(sureboxid)) { return(-1); }
	if (title == null) { title="Sure Box"; }
	if (top == null) { top=200; }
	if (left == null) { left=170; }
	RequestBoxDisp(sureboxid);
	document.getElementById(sureboxid).style.top=top;
	document.getElementById(sureboxid).style.left=left;
	if (document.getElementById(sureboxid+"title")) { document.getElementById(sureboxid+"title").innerText=title; }
	if (strid == null) { strid=sureboxid+"str"; }
	if (document.getElementById(strid))   { document.getElementById(strid).innerText=str; }

	if (funcid == null) { funcid=sureboxid+"func"; }		// OK Function
	if (document.getElementById(funcid))   {
		document.getElementById(funcid).onclick=func;
		document.getElementById(funcid).addEventListener('click', (function() {		// Bottonに Eventを追加
			return function f() {							// 無名関数を値にしてremoveEventListener行う。
				RequestBoxtUnLoad(sureboxid);
				document.getElementById(funcid).removeEventListener('click', f, false);
				}
			}).bind(sureboxid) (1), false);					// bindで引数を渡す
		}
	if (funccls !=null) {									// Close Function
		if (funcclsid == null) { funcclsid=sureboxid+"cls"; }
		if (document.getElementById(funcclsid))   {
			document.getElementById(funcclsid).onclick=funccls;
			document.getElementById(funcclsid).addEventListener('click', (function() {		// Bottonに Eventを追加
				return function f() {							// 無名関数を値にしてremoveEventListener行う。
					RequestBoxtUnLoad(sureboxid);
					document.getElementById(funcid).removeEventListener('click', f, false);
		 			}
				}).bind(sureboxid) (1), false);					// bindで引数を渡す
			}
		}
	}

/* ------------------------------------------------------------------------------------
	RequestMessageBox(title,str,top,left,id,strid) : MessageBoxディスプレイ (mpdweb.lib_appli.php/DispMsgBox()をjsで使用可)
	 title: i  : Box Title
	 str  : i  : Message
	 top  : i  : Top (px)
	 left : i  : Left(px)
	 id   : i  : MessageBox id 未設定時:IDMSGBOX設定作成しておく(php global $IDMSGBOX)
	             idがなければ"grpMsgBox"で作成
	 strid: i  : MessageBox Message String id 未設定時:msgid+"str"
	前提:MessageBox idのboxを作成しておく。mpdweb.lib_appli.php/DispMsgBox()関数で作成可
	       タイトルid   : msgid+"title"
	       メッセージid : msgid+"str"
	     のidで作成
------------------------------------------------------------------------------------- */
function RequestMsgBox(title,str,top,left,id,strid) {
	var msgid ="";
	if (typeof IDMSGBOX === "undefined") { msgid="grpMsgBox"; } else { msgid=IDMSGBOX; }
	if (id == null) { } else { msgid=id; }
	if (!document.getElementById(msgid)) { return(-1); }
	if (title == null) { title="Message Box"; }
	if (top == null) { top=200; }
	if (left == null) { left=60; }
	RequestBoxDisp(msgid);
	document.getElementById(msgid).style.top=top;
	document.getElementById(msgid).style.left=left;
	if (document.getElementById(msgid+"title")) { document.getElementById(msgid+"title").innerText=title; }
	if (strid == null) { strid=msgid+"str" }
	if (document.getElementById(strid))   { document.getElementById(strid).innerText=str; }
	}

/* ------------------------------------------------------------------------------------
	Object Div Move : Image Box Display
------------------------------------------------------------------------------------ */
MoveOnFlag = false;
document.onmousemove = MoveDragImg;
document.onmouseup   = MoveDragOff;

/* -------------------------------------------------------------------------------------
	MoveDragOn(n,f,h) : Object Move ：マウスドラック移動 連続上下Divを一連移動
		n    : i  : 移動Div ID
		f    : i  : 付随移動Div
		h    : i  : 付随移動Divまでの高さ(Px)
		l    : i  : 付随移動DivまでのLeft Offset (Px)
		func : i  : Function 移動終了後,実行関数(Callback)
-------------------------------------------------------------------------------------- */
function MoveDragOn(n,f,h,l,func) {
	MoveOnFlag = true;
	MoveDivID = n;
	MoveDragCB=null;
	if (f == null) { MoveAttendID=false; } else { MoveAttendID=f; }
	if (h == null) { MoveAttendDefPX=0;  } else { MoveAttendDefPX=h; }
	offx = event.x - parseInt(document.getElementById(MoveDivID).style.left);
	offy = event.y - parseInt(document.getElementById(MoveDivID).style.top);
	if (l == null) { ofleft=0;  } else { ofleft=l; }
	if (func !==null) { MoveDragCB=func; }
	}

/*
	MoveDragImg(): Object Move
*/
function MoveDragImg() {
	if (!MoveOnFlag) return;
	document.getElementById(MoveDivID).style.top  = event.y - offy;
	document.getElementById(MoveDivID).style.left = event.x - offx;
	if (MoveAttendID) {
		document.getElementById(MoveAttendID).style.top = parseInt(document.getElementById(MoveDivID).style.top) + MoveAttendDefPX;
		document.getElementById(MoveAttendID).style.left= parseInt(document.getElementById(MoveDivID).style.left) + ofleft;
		}
	if (MoveDragCB !== null) { eval(MoveDragCB); }		// After,exec (Callback)
	return false;
	}

/*
	MoveDragOff() : Move Drag OFF
*/
function MoveDragOff() {
	if (MoveOnFlag) {
		MoveOnFlag = false;
		}
	}
/* ------------- End of Source --------------------------------------------------------*/
