<?php
/***************************************************************************************
	mpdweb Function File Addon XMLSetting
	 FileSet_Ver()    : mpdweb Function File Home Path Version
	 FileSet_Update() : mpdweb Function File Home Path (Create/Update)
	 FileSet_Get()    : mpdweb Function File Home Path (Get)
	外部I/F
	 global $XML_FILESETTING : Add Function File XML Setting
****************************************************************************************/
global $FileLibVer;$FileLibVer=basename(__FILE__)." Ver:1.2 (10.04.2023)";
global $XML_FILESETTING;$XML_FILESETTING='setting/mpdweb_file.xml';	// mpdfile Setting XML

/***************************************************************************************
	FileSet_Ver() :  mpdweb Function File Home Path Servion
	 $home: i  : Update , Home Path
****************************************************************************************/
function FileSet_Ver() {
	global $FileLibVer;
	return($FileLibVer);
	}

/***************************************************************************************
	FileSet_Update($home) :  mpdweb Function File Home Path (Create/Update)
	 $home: i  : Update , Home Path
****************************************************************************************/
function FileSet_Update($home) {
	global $XML_FILESETTING;

	$new_file=0;
	$xml = new DOMDocument();

	$string = @file_get_contents($XML_FILESETTING);
	if ($string === false) {
		$string=FileSet_CreateXML();							// XML Fileがない時Create
		$new_file=1;
		}
	$xml->loadXML($string);										// XMLFile読み込み

	$string=FileSet_RepXML($xml,$home);
	$xml->loadXML($string);										// XMLFile読み込み

	$res=$xml->save($XML_FILESETTING);
	if ($new_file==1) {							// New File chmod 0666
		chmod($XML_FILESETTING,0666);
		}
	}

/***************************************************************************************
	FileSet_Get($sts) :  mpdweb Function File Home Path (Get)
	 $sts   : io : XMLFileがない場合"-1"  ※ 呼び元で$stsが未定義のときセットしない
	 @return: o  : Home Path
****************************************************************************************/
function FileSet_Get(&$sts) {
	global $XML_FILESETTING;

	$ret="";
	$xml = new DOMDocument();
	$string = @file_get_contents($XML_FILESETTING);
	if ($string === false) {
		if(isset($sts)) { $sts=-1; }
		return($ret);
		}
	$xml->loadXML($string);										// XMLFile読み込み
	$tagsts="";
	$ret=FileSet_GetXML($xml,$tagsts);
	if ($tagsts == -1) {
		if(isset($sts)) { $sts=-1; }
		}
	return($ret);
	}

/* -------------------------------------------------------------------------------------
	FileSet_CreateXML() :  mpdweb Function File Home Create
	 @return: o  : XML Object
-------------------------------------------------------------------------------------- */
function FileSet_CreateXML() {
	$xml = new DomDocument('1.0', 'UTF-8');
	$xml->loadXML("");

	$root = $xml->appendChild($xml->createElement(basename(__FILE__)));
	$g = new DOMText("\n");
	$root->appendChild($g);

	$rootNode = $root->appendChild($xml->createElement("File"));
	$g = new DOMText("\n\t");
	$rootNode->appendChild($g);
	$g=$xml->createComment(" mpdweb File HomePath ");
	$rootNode->appendChild($g);
	$g = new DOMText("\n\t");
	$rootNode->appendChild($g);

	$rootElem = $xml->getElementsByTagName("File")->item(0);	// 追加のためのTag位置
	$rootNode=$rootElem->appendChild($xml->createElement('HomePath',"/"));
	$g = new DOMText("\n");
	$root->appendChild($g);
	$g = new DOMText("\n");
	$rootElem->appendChild($g);
	return($xml->saveXML());
	}

/* -------------------------------------------------------------------------------------
	FileSet_RepXML($xml,$newhome) :  mpdweb Function File Home Update
	 $xml    : i  ; XML Object
	 $newhome: i  : Rep Home <File><HomePath>{NewHome}
	 @return : o  : New XML Object
-------------------------------------------------------------------------------------- */
function FileSet_RepXML($xml,$newhome) {
	$settmp = $xml->getElementsByTagName("File");
	if ($settmp->length == 0) {
		$tmp=$xml->getElementsByTagName(basename(__FILE__));
		if ($tmp->length == 0) {
			 $rootNode = $xml->appendChild($xml->createElement("File",""));
			 }
		else {
			 $root = $xml->getElementsByTagName(basename(__FILE__))->item(0);
			 $rootNode = $root->appendChild($xml->createElement("File",""));
			 $g = new DOMText("\n");
			 $root->appendChild($g);
			 }
		}
	$root = $xml->getElementsByTagName("File")->item(0);	// BaseTag位置
	$setnode= $root->getElementsByTagName("HomePath");		// New Tagの存在チェック
	if ($setnode->length == 0) {
		$g = new DOMText("\t");
		$root->appendChild($g);
		$rootNode=$root->appendChild($xml->createElement('HomePath',"/"));
		$g = new DOMText("\n");
		$root->appendChild($g);
		}
	$setnode->nodeValue=$newhome;							// XML構造により有効
	foreach($setnode as $kpos => $snode) {					// XML構造によりSearch
		if ($snode->nodeName == "HomePath") {
			$snode->nodeValue=$newhome;
			break;
			}
		}
	return($xml->saveXML());
	}

/* -------------------------------------------------------------------------------------
	FileSet_GetXML($xml) : mpdweb Function File Home Get
	 $sts   : io : XML Tagがない場合"-1"
	 @return: o  : XML Object
-------------------------------------------------------------------------------------- */
function FileSet_GetXML($xml,&$sts) {
	$ret="";
	$settmp = $xml->getElementsByTagName("File");			// BaseTag位置
	if ($settmp->length == 0) {
		$sts=-1;
		return($ret);
		}
	$root = $xml->getElementsByTagName("File")->item(0);	// BaseTag位置
	$setnode= $root->getElementsByTagName("HomePath");		// New Tagの存在チェック
	if ($setnode->length == 0) {
		$sts=-1;
		return($ret);
		}
	foreach($setnode as $kpos => $snode) {					// XML構造によりSearch
		if ($snode->nodeName == "HomePath") {
			$ret=$snode->nodeValue;
			break;
			}
		}
	return($ret);
	}

/* -------------------------------------------------------------------------------------
	FileSet_RemoveXML() : mpdweb Function File Home Remove
-------------------------------------------------------------------------------------- */
function FileSet_RemoveXML() {
	global $XML_FILESETTING;

	$xml=simplexml_load_file($XML_FILESETTING);					// XMLFile読み込み

	$parent="File";
	$rmtag="HomePath";
	$child=$xml->$parent->$rmtag;
	if (!$child) { return; }
	$dom=dom_import_simplexml($child); 
	$dom->parentNode->removeChild($dom);				// Remove Tag
	$str = $xml->saveXML();								// XML String
	$str=str_replace("\t\n","",$str);					// NLを削除
	$ret=file_put_contents($XML_FILESETTING,$str);		// 保存
	chmod($XML_FILESETTING,0666);
	}
//-------------- End of Source ----------------------------------------------
?>
