<?php
/*******************************************************************************
	mpd Common function library (mpd{module}.lib)
*******************************************************************************/
/*
	LibraryでXML FileのRead/Getを用意している。
	get_loadconfig/get_configを使用する。Libraryを使用するには初期でget_loadconfig
	を実行して$XML_CONFをLoadしておく。設定については,Applicationでも使用を前提としている
	 ※ $XML_CONF : XML FileをReadしておくエリア

	MPD コマンド関数(mpd関数)
	<LibConf>                                     : Library 設定
      <Codeset>utf-8</Codeset>                    : 内部コード(mpdは標準'utf-8') mb_strimwidth/mb_strlenに使用するCodeset
	  <Ratio>2.5</Ratio>                          : 全角混じりの計算として表示エリア半角文字数比率
	  <SecEdit>%02d:%02d</SecEdit>                : 秒変換の時間編集 編集方法 %02d:%02d(分3桁でも桁落ちしない) or %02d:%02d:%02d セパレータは":"
	  <Track>|%02s</Track>                        : Trackの編集方法 %02s 1桁のとき,0を付加 (mpd Versionの差異を吸収
	  <Lsinfo_Class>on|off</Lsinfo_Class>         : lsinfo 次階層チェックをするか設定 off|on(ディフォルト) (MusicデータがないDirectoryを次1階層のみチェック)
	  <XMLAlternative>{Filerd}["{Point}"]</XMLAlternative>: XML(このファイル)Load"get_loadconfig()使用"時 設定したglobal項目があれば変更する。２次配列まで設定できる。
	<ExtendLibrary>                               : mpdwebで使用する拡張Libraryを設定。設定で行うため未設定の場合mpdwebを軽くする
	  <module>{Module}<ExtendLibrary>             : mpdwebで使用する拡張Library PHP Moduleを設定
	  <image file="{Compere}">{Function}          : 拡張Library{Function}関数を設定/file=URLの先頭一致 対象文字列
	<Sort_Base>                                   : Sort 基本設定
	  <Sort_Capital>on|off</Sort_Capital>         : Sortに大文字/小文字区別しない
	  <Sort_FieldMode>{Filed}{:D|A},... ....      : Sort方向。Filedのディフォルトを設定。基本ディセンディングを設定","区切りで指定
	  <FieldLength>{Filed}{sprintf Arg} , ...     :  %05s 0:Pading %-5s:Left-justified %.5s:Truncation ※Sort最後のFiledはTrimする(DescendingはTrimしない)
	<Sort_listexclude>                            : List/fileListの定冠詞などを除外
	  <{Field:(Artist)}>{The }</{Field:(Artist)}> : <対象のフィールド名>{定冠詞など}</対象のフィールド名> フィールド名は:directory,file,playlistも可
	<Sort_{filed(List)}>                          : Listコマンドのフィールド設定 <{Sort_フィールド名}> ※単一フィールド用
	  <Default>{Field,Field...}</Default>         : Default:<{Field}>設定がない場合に使用される
	  <{Field}>{Field,Field...}</{Field}          : Filed:ListSelectと一致したとき有効 Artist/AlbumArtist/Genre/Date/Album(単一Filed&Artなし)
	<Sort_{filed(Album)}>                         : Listコマンドのフィールド設定 <{Sort_フィールド名}> ※複数フィールドセレクト時先頭フィールド
	  <Default>{Field,Field...}</Default>         : Default:<{Field}>設定がない場合に使用される
	  <{Field:(Artist)}>{Field,Field...}</Artist> : <{Query}>{Filed},{Filed} :Sort Field :SelectFiledと一致したとき有効
	<Sort_{find|設定値}>                          : Sort Findコマンドのフィールド設定 <{Sort_{設定名}>"find":標準,処理ごとにアプリケーションで定義できる
	  <Default>{Field,Field...}</Default>         : Default:<{Field}>設定がない場合に使用される
	  <{Field}>{Field,Field...}</{Field}>	      : セレクト対象の「Filed」にあった場合に使用される
	<Sort_{Lsinfo}>                               : Sort Findコマンドのフィールド設定 <{Sort_{設定名}>"find":標準,処理ごとにアプリケーションで定義できる
	  <Default>{Field,Field...}</Default>         : Default:<{Field}>設定がない場合に使用される
	  <{Directory|PLaylist}>{Field,Field...}      : Directory|PLaylistセレクト時有効(FiledArrayで判断) ※Fieldに"kindconv"指定:{kindの内容}+":"+{fieldに対応[kind:directory/file/playlist]}に変換される
	<Cmd_para>                                    : コマンド置換設定
	    <{command}_{Field}>{RepField}</{command}_{Field}>
	<Album_art>                                   : アルバムアート設定
	    <path>{Art URL}</path>                    : URL または FilePath 先頭部分を設定。"localhoat" 設定時,php実行サーバとする
	    <timeout>{Timeout(sec)}</timeout>         : Cheack Timeout
	    <netmask>{Mask Bit}</netmask>             : RequestIPはAlbamArtが許可範囲 未設定は全て許可 形式:192.168.1.0/24 (255.255.255.0の形式),192.168.1.0/16 (255.255.0.0の形式)
	    <wanpath>{WanPath}</wanpath>              : WanArtPath 形式: http://{Hostname}:{Port}/{NetPath}
	    <wanPortForward>8850|80</wanPortForward>	wanでのForwardPortを設定 <wanpath>のPortに対して設定 形式: {ForwardPort}|{httpd AccressPort} PHP'SERVER_PORT'はURLのPortが設定されているので,AccressPortを設定
	    <file>{Art File},{Art File}</file>        : アルバムアートファイル名 ZipFile時:%{basename}%(extension含む),%{extension}%,%{filename}%(extension除く)
	    <func>{Function}</func>                   : アルバムアート使用機能 album,find,lsinfo,playlistid,currentsong,listplay
	<File_listexclude>                            : 除外ファイル拡張子
	    <extension>m3u,cue</extension>            : ファイル拡張子複数指定(mpd Playlistは設定とと関係なし)
	<Update>                                      : MPD D/B Update
	    <timeout>360</timeout>                    : Sync時 Update Timeout
	netコマンド関数(Net Cleass)
	<Mpd_exclusive>                               : Mpd Command exclusive(排他)設定 netmaskはAlbumArtと分ける
	<netmask>{Mask Bit}</netmask>                 : RequestIPはCommandが許可範囲 未設定は全て許可 形式:192.168.1.0/24 (255.255.255.0の形式),192.168.1.0/16 (255.255.0.0の形式)
	<cmd>{mpd command}</cmd>                      : Subnetが異なるときブリックする mpd command ","区切り。addlist,update:関数でブロック用に別名定義(mpd:updating_db,add,findadd)
	<Mpd_net>                                     : Mpd Server Connect設定
	    <host>{Hostname}</host>                   :  Hostname
	    <port>{Port}</port>                       :  Port
	    <pass>{Password}</pass>                   :  Password

	Special Setting : 全体で一環して使用していないのでXML設定はない。
	  $LIB_CONF["LoopTimeout"]が設定されていたらループを打ち切る設定として使用。 現在:mpd_list_findで使用

*/

/*
	lib_version()
	@return : o  : Version
*/
function lib_version() {
	$LIB_VERSION=basename(__FILE__)." 1.9 (30.11.2024)";
	return($LIB_VERSION);
	}

/*
	get_loadconfig($xml_file) : XMLパラメータGet
	  $xml_file: i  : XML FileNam
	  @return($XML_CONF)
*/
//----- XML Common function ------------------------------------------------------------
/*
	get_loadconfig($xml_file,$Exception) : XMLパラメータGet
	 $xml_file : i  : XML FileNam
	 $Exception: i  :"on" : Error時停止, "off":Error続行
	 @return   : o  : $XML_CONF(XML Array)  : Error時,Error内容
*/
function get_loadconfig($xml_file="setting/mpdconfig.xml",$Exception="on") {
	global $XML_CONF;

	if (!isset($XML_CONF)) {
		if (file_exists($xml_file)) {
			 $XML_CONF = simplexml_load_file($xml_file);
			 if ($XML_CONF === false) {
				$errstr="Failed loading XML";
				if ($Exception=="on") {
					 throw new Exception("Failed loading XML Parser Error"."\t"."[Warning: See simplexml_load_filew !!]");
					 }
				else {
				 	 $XML_CONF="Failed loading XML Parser Error [See simplexml_load_filew !!]".$xml_file;
				 	 }
				 }
			 }
		else {
			 if ($Exception=="on") {
				  throw new Exception("Failed File Open File Exists Error : ".$xml_file."\n");
				  }
			 else {
				  $XML_CONF="Failed File Open File Exists Error : ".$xml_file;
				  }
			 }
		}
	if (($tmp=_get_loadconfig_Alter($XML_CONF)) !==false) { $XML_CONF=$tmp; }
	return($XML_CONF);
	}

/*
	_get_loadconfig_Alter($XML_CONF) : XML Config Alternative
	$XML_CONF: i  : Config XML Data
	@return  : o  :  $XML_CONF (Config XML Data)

	mpdconfig.xml:<LibConf><XMLAlternative>$XML_ALTER["tmp"]:global変数を設定
	Common Libraryを使用するとき
	  global $XML_ALTER;
	  $XML_ALTER["XMLAlter"]["Mpd_net"]=array("host"=>"192.168.x.xxx","port"=>"6600", 'pass' => "");
	 でXMLの変更を行うことができる。２次配列まで使用できる
*/
function _get_loadconfig_Alter($XML_CONF) {
	$xmltmp=array("XMLAlternative"=>"");
	get_config("LibConf",$xmltmp);
	$xmltmp["XMLAlternative"]=trim($xmltmp["XMLAlternative"],"$");
	if ($xmltmp["XMLAlternative"]=="") { return(false); }
	$pnt="";
	$str=explode("[",$xmltmp["XMLAlternative"]);
	if (isset($str[1])) {
		$result = preg_match_all("/\[\'(.*?)\'\]/s",$xmltmp["XMLAlternative"],$part,PREG_SET_ORDER);		// Result:正規表現:['{Filed}']を検出 $part[0][1]:Filed
		if (isset($part[0][1])) { $pnt=$part[0][1]; }
		else {
			 $result = preg_match_all("/\[\"(.*?)\"\]/s",$xmltmp["XMLAlternative"],$part,PREG_SET_ORDER);	// Result:正規表現:["{Filed}"]を検出 $part[0][1]:Filed
			 if (isset($part[0][1])) { $pnt=$part[0][1]; }
			 else {
				  $result = preg_match_all("/\[(.*?)\]/s",$xmltmp["XMLAlternative"],$part,PREG_SET_ORDER);	// Result:正規表現:[{Filed}]を検出   $part[0][1:]Filed
				  if (isset($part[0][1])) { $pnt=$part[0][1]; }
				  }
			 }
		if ($pnt =="") { return(false); }
		}
	$alt=$str[0];
	global ${$alt};
	if (!isset(${$alt})) { return(false); }
	if ($pnt =="") { $ary=${$alt}; } else  {
		 if (!isset(${$alt}[$pnt])) { return(false); } else
		 	{ $ary=${$alt}[$pnt]; }
		 	}
	if ((!isset($ary))||(!is_array($ary))) { return(false); }
	foreach($ary as $section=> $aryval) {
		foreach($aryval as $key=> $val) {
			if (strpos($key,'link:') === 0) {
				$secstr = str_replace("link:","",$key);	// link:{section}:{key}={val}
				$sec=explode(":",$secstr);
				if (isset($sec[1])) {
//					$XML_CONF->$sec[0]->$sec[1]=$val;				// -- 関連のXML設定を1設定で行うための例外(この動作は以下で行う) --
					$XML_CONF->{$sec[0]}->{$sec[1]}=$val;			// PHP 7以上での書き方(配列が文字列に変換{}で対応)
//print "[$section]".$sec[0]."->".$sec[1]."->[".$val."]<BR>";
					}
				continue;
				}
			$XML_CONF->$section->$key=$val;
//print '$section['.$section.'] $key['.$key.'] $val['.$val.']<BR>';
			}
		}
	return($XML_CONF);
	}

/*
	get_loadxml($xml_file,$XMLARY,$Exception) : XML File Get
	 $xml_file : i  : XML FileNam
	 $Exception: i  :"on" : Error時停止, "off":Error続行
	 @return   : o  : $XMLARY(XML Array)  : Error時,Error内容
*/
function get_loadxml($xml_file,$Exception="on") {
	if (file_exists($xml_file)) {
		 $XMLARY = simplexml_load_file($xml_file);
		 if ($XMLARY === false) {
			$errstr="Failed loading XML";
			if ($Exception=="on") {
				 throw new Exception("Failed loading XML Parser Error"."\t"."[Warning: See simplexml_load_filew !!]");
				 }
			else {
			 	 $XMLARY="Failed loading XML Parser Error [See simplexml_load_filew !!]".$xml_file;
			 	 }
			 }
		 }
	else {
		 if ($Exception=="on") {
			  throw new Exception("Failed File Open File Exists Error : ".$xml_file."\n");
			  }
		 else {
			  $XMLARY="Failed File Open File Exists Error : ".$xml_file;
			  }
		 }
	return($XMLARY);
	}

/*
	get_config($section,$item) : XMLパラメータ設定
	 $section: i  : XML Tag Section
	 $item 	 : io : パラメータ取得項目配列
	 @return : o  : セット数
	global
	  $XML_CONF	: i   : Config XML Data
	※Sumple
	XML <ArtList>List onclick=alert()</ArtList>
	$xmlary=array("ArtList"=>on);		// 初期値 関数呼び出し後,取得値に置き換える
	get_config("DISP_Config",$xmlary);
	print $xmlary["ArtList"];
*/
function get_config($section,&$item) {
	global $XML_CONF;

	$ret=0;
	foreach((array)$item as $key => $val ) {
		if(isset($XML_CONF->$section->$key)) {
		   trim($XML_CONF->$key);
		   $item[$key]=(string)$XML_CONF->$section->$key;
		   $ret+=1;
		   }
		}
	return($ret);
	}

/*
	get_confxml($xml,$section,$item) : XMLパラメータ設定(Free版)
	 $xml    : i  ; XML Array
	 $section: i  : XML Tag Section
	 $item 	 : io : パラメータ取得項目配列
	 @return : o  : セット数
	※ get_config() Free版
*/
function get_confxml($xml,$section,&$item) {
	$ret=0;
	foreach($item as $key => $val ) {
		if(isset($xml->$section->$key)) {
		   trim($xml->$key);
		   $item[$key]=(string)$xml->$section->$key;
		   $ret+=1;
		   }
		}
	return($ret);
	}
/*
	get_library() : Get XML Setting Extend Library
	@return : o  : Libray Array
	※<ExtendLibrary><module>:Library
	  Mainで(array)get_library()を使用してrequireする。設定で行うため未設定の場合mpdwebを軽くする。
	  $XML_IMGFUNC["func"]:Function() Get Image File   $result=pls_ArtURL("{URL}");形式
	  $XML_IMGFUNC["file"] Function ImageFile条件 File名先頭からの文字列 Striming:"http://www....."の場合 "http"が一致
*/
function get_library() {
	global $XML_CONF,$XML_IMGFUNC;

	$i=0;$XML_IMGFUNC=array();$libary=array();
	if (is_object($XML_CONF)) { $XML = get_object_vars($XML_CONF); } else { $XML = []; } // $XML_CONFがnullの場合のデフォルト値
	if(!isset($XML["ExtendLibrary"])) {
		return($libary);
		}
	foreach($XML["ExtendLibrary"]  as $key=> $lib) {
		if($key == "module") {
			$libary[$i]=(string)$lib;
			}
		if($key == "image") {
			$XML_IMGFUNC["func"][]=(string)$lib;
			foreach($lib->attributes() as $arri=>$val){
				if ($arri=="file") {
					$XML_IMGFUNC["file"][$i]=(string)$val;
					break;
					}
				}
			$i=$i+1;
			}
		}
//print "<BR><BR><BR><BR><BR>";print_r($libary);print_r($XML_IMGFUNC);print '<BR>';
	return($libary);
	}

/*
	get_xml_attribute($xml,$tag,$attri,$pnt): XML 指定Sectionの属性配列作成 [get_config():連動用]
	 $xml   : i  : XML Object <tag atri="" atri2="">
	 $tag   : i  : 属性を取得するTag
	 $attri : i  : 属性の配列(初期値を設定) AttributeのKey Ex:$attri=array("width"=>60,"name"=>"");
	 $pnt   : i  : 指定時,同一Tagを考慮し指定Pointで一致Tagを有効(発生番目を指定)。NULL時同一Tagを考慮しない。
	 @return: o  : XMLから設定時 [{Attribute}]"1" をセット 未セット時Keyが作成されない

	※Sumple
	XML <ArtList name="Art List" width="60">List onclick=alert()</ArtList>
	$xmlary=array("ArtList"=>on);
	$sec=$key;
	get_config("DISP_Config",$xmlary);
	$xmlattri=array("width"=>60,"name"=>"Art List");	// attribute 初期値 関数呼び出し後,取得値に置き換える
	$retary=get_xml_attribute($XML["DISP_Config"],"ArtList",$xmlattri);	// XML Keyの属性形式 width={value} name={value}
	print $xmlattri["width"];
	print $xmlattri["name"];
*/
function get_xml_attribute($xml,$tag,&$attri,$pnt=NULL){
	$i=0;$retary=array();
	if (is_null($pnt)) {
		if (isset($xml->$tag)) {
			foreach($xml->$tag->attributes() as $key => $val) {		// TAG Object下の属性を取得する [->attributes()]
				$key_str=(string)$key;
				$attri[$key_str]=(string)$val;
				$retary[$key_str]="1";
				}
			}
		 }
	else {
		 if ((!empty($xml))&&($xml->count()) > 0) {					// 子供の配列を得る
			foreach($xml->children() as $child) {					// $xmlからして番目TAGを取得する [->children()]
				$name = $child->getName(); 
				if (($name == $tag)&&($pnt==$i)) {
					foreach($child->attributes() as $key => $val) {	//  TAG Object下の属性を取得する [->attributes()]
						$key_str=(string)$key;
						$attri[$key_str]=(string)$val;
						$retary[$key_str]="1";
						}
					break;
					}
				$i=$i+1;
				}
			}
		 }
	return($retary);
	}

/*
	get_xml_attri_array($xml): Make XML Array (XMLを扱い易いようにSupport Library)
	 $xml   : i  : 配列を作成するXML / さらに配下のTag求めない
	 @return: o  : XML Arrray | "":XMLが解析できないとき
			       ary[Tag][$i]:TagName
			          [Val][$i]:TagValue [Tag][$i]に属する値
			          [Att][$i][{Attribute}]:Attribute Valus [Tag][$i]に属する属性配列
		              [Cld][$i]:Array Child Valus [Tag][$i]に属する子の配列(呼び元で再起できるように設定)
	※Sumple
	foreach ($ary["Tag"] as $key=>$val) {	// タグを得る
		print "[".$key."] Tag[".$val."] Val[".$ary["Val"][$key]."]<BR>";
		if  (isset($ary["Att"][$key])) {
			foreach ($ary["Att"][$key] as $At=>$AtV) {	// 属性を得る
				print "[".$key."] Attri[".$At."] Val[".$AtV."]<BR>";
				}
			}
		}
*/
function get_xml_attri_array($xml){
//	$ary="";												// PHP7以降では,配列の宣言による初期化が必須
	$ary=array();
	if ((!empty($xml))&&($xml->count()) > 0) {				// 子供の配列を得る
		$i=0;
		foreach ($xml->children() as $child){						// タグ名を得る $xml->children():Tag配列
			$name = $child->getName(); 									// $name=Tag
			foreach($child->attributes() as $attr_name=>$attr_val){		// 属性名とその値を得る $child->attributes():属性配列
				$ary["Att"][$i][$attr_name]=$attr_val;					// $attr_name:属性 / $attr_val:属性の値
				}
			$ary["Val"][$i]=$child;
			$ary["Tag"][$i]=$name;
			if( $child->count() > 0 ) { $ary["Cld"][$i]=$child; }		// さらにTagがあれば、呼び元で再起すれば取得できるように配列を設定
			$i=$i+1;
			}
		}
	if(count($ary) == 0) { $ary=""; }								// PHP5の作成0件のときの互換のため""とする
	return($ary);
	}

/* -----------------------------------------------------------------------------
	get_xml_Array($simpxml) : XMLからArrayを生成する
	 $simpxml: i  : XML (simplexml_load_string 形式) | XML (get_object_vars) (XMLの先頭を指定する)
	 @return : o  : XML Array key [Tag] | [@attributes]:Attribute | [comment]:comment

	※ 使用での注意) XMLでHTMLを定義時,分解されてしまうので他の関数を使用する(再起し全てのTagを配列化する)
	   comment <!-- --> : key[comment]となることにも注意
	   <{tag}></{tag}>:SpaceもArrayとなる(count({val})==0)となりforeachでは取得しない
----------------------------------------------------------------------------- */
/*
  example:
	$xmlary=get_xml_Array($simpxml)
	foreach($xmlary["Link"]  as $key=> $val) {			// XML <Link> String
		if ($key=="comment") {continue;}
		if (is_array($val)) { if (count($val) == 0) {
			print '$key['.$key."<BR>";
			}
			foreach($val as $k=> $v) {
				if (is_array($v)) {
					 if (count($v) == 0) {
						 print '$k['.$k."<BR>";
						 }
					 foreach($v as $ak=> $av) {
					 	print '$ak['.$ak.'] $av['.$av."]<BR>";
						}
					 }
				else {
					 print '$k['.$k.'] $v['.$v."<BR>";
					 }
				}
			 }
		else {
			 print '$key['.$key.'] $v['.$val."]<BR>";
			 }
		}

----------------------------------------------------------------------------- */
function get_xml_Array($simpxml) {
	$xmlary = array();
	if (is_object($simpxml)) {
		 $simpxml = get_object_vars($simpxml);		// XML Object形式
		 }
	else {
		 $simpxml = $simpxml;						// get_object_vars済
		 }
	foreach ((array) $simpxml as $key => $val) {			// $key Tag or Atrribute:"@attributes"
		if (is_object($simpxml[$key])) {			// XML Object形式が検出時,再起
			 $xmlary[$key] = get_xml_Array($val);
			 }
		else if (is_array($val)) {					// XML Arrayは階層を下げる
			 foreach($val as $k => $v) {
				if (is_object($v) || is_array($v)) {	// 下階層:XML Object形式が検出時,再起
					 $xmlary[$key][$k] = get_xml_Array($v);
					 }
				else {
					 $xmlary[$key][$k] = $v;			// Tag->[$key]:$val
					 }
			 	}
			 }
		else {
			 $xmlary[$key] = $val;					// Tag->[$key]:$val
			 }
		}
	return ($xmlary);
	}

/* -----------------------------------------------------------------------------
	get_xml_String($xmlary,$tag,$sel,$out,$rep,$vars,$attri) : XMLの指定Tagを解析しStringを生成する
	 $xmlary  : i  : XML Array
	 $tag     : i  : Select Tag
	 $sel     : i  : $tag下のセレクト対象 Child Tag。 配列指定時:複数条件が指定できる。
	                 配列形式:$sel=array("{文字列}"=>{"0"/"1"}):0:完全一致/1:指定文字列を含む前方一致
	                 配列を指定しない場合:指定文字列を含む前方一致
	 $out     : i  : "0":先頭をセレクト,"1":最後をセレクト,"2":配列 ,指定文字で結合する
	 $rep     : i  : 文字列置換配列。配列を指定しないときは対象なし。 形式:array({Source}=>{Destination},{Source}=>{Destination});
	                 例) $rep=array("{\t"=>"","\n"=>"");
	 $vars    : i  : 1:Used XML Vars 0:Not Vars($xmlary Finished Vars)
	 $attri   : io : 属性編集配列。 NULL時(省略時)属性編集しない。呼び元で参照渡し初期値を設定 ($attri="";)
	                 ary[Tag][$i]:TagName
		                [Val][$i]:TagValue [Tag][$i]に属する値
		                [Att][$i][{Attribute}]:Attribute Valus [Tag][$i]に属する属性配列
		             ※ 共通関数:function get_xml_attri_array($xml)と同じ配列形式
	 @return  : o  : $out="0","1","2"以外は文字列 ,$out="2":配列 -1:Tagが未設定時
	
	参考1) DOMNode Class : element.childNodes:指定した要素の子ノードへの参照を格納した配列を返すプロパティ
	 {node}->nodeName     :Tag名 XML<{Tag}>:Tag      例) node<ViewExtend>:<ViewExtend>下<Thumbnail W="w" Y="y" ><ifreme zzzzz>xxxxx</ifreme>:Return:"Thumbnail"
	 {node}->nodeValue    :TagValue値 <{tag}>Value値 例) node<ViewExtend>:<ViewExtend>下<Thumbnail W="w" Y="y" ><ifreme zzzzz>xxxxx</ifreme>:Return:"xxxxx"
	 {node}->getNodePath():TagのPath             例) node<ViewExtend>:<ViewExtend>下<Thumbnail W="w" Y="y" ><ifreme zzzzz>xxxxx</ifreme>:Return:"{root}/ViewExtend/Thumbnail"
	 {node}->C14N()       :Tag String            例) node<ViewExtend>:<ViewExtend>下<Thumbnail W="w" Y="y" ><ifreme zzzzz>xxxxx</ifreme>:Return:"<Thumbnail W="w" Y="y" ><ifreme zzzzz>xxxxx</ifreme>"
	 {node}->attributes   :Tag Attributes key:Attributes / {node}->attributes->getNamedItem(key):Attributes Value
	参考2) preg_match_all:正規表現
	 preg_match_all('/<{tag}(.*?)>(.*?)<\/{Tag}>/si',{XML String},$out,PREG_SET_ORDER);
	   i:大小文字区別しない/s:改行も有効
	   $out[0][1]:1個目の(.*?),$out[0][2]:2個目の(.*?)
	  例)<{tag} xxxxx><yyy>zzz</yyy></{tag}>
	   $out[0][1]:xxxxx , $out[0][2]:<yyy>zzz</yyy>
	  使用例)
	   $ret=get_xml_String($XML,"ViewExtend","Thumbnail",$out,$rep,0,$attri);
	   $ret=get_xml_String($XML,"ViewExtend","",$out,$rep,0,$attri);
	   $ret=get_xml_String($XML["ViewExtend"],"","",$out,$rep,0,$attri);
	   $ret=get_xml_String($XML_CONF,"ViewExtend","Thumbnail",$out,$rep,1,$attri);
      使用できない例）
	   $ret=get_xml_String($XML_CONF["ViewExtend"],"","",$out,$rep,1,$attri); <--$vars"1"[要vars] 時 $XML[配列指定]はできない。DOMNodeを使用してchildNodesを取得
----------------------------------------------------------------------------- */
function get_xml_String($xmlary,$tag,$sel,$out="",$rep="",$vars=1,&$attri=NULL) {
	$str="";if ($out == "2") { $str=array(); }
	if ($vars == "1") { $xml = get_object_vars($xmlary); }
	else { $xml = $xmlary; }
	if ($tag !=="")  { 
		 if (isset($xml[$tag])) { $xmlary=$xml[$tag]; }
		 else { return(-1); }
		 }
	else { $xmlary=$xml; }
	if (is_array($rep)) { $rep_source = array_keys($rep); }		// Replace配列が指定された
	if ((count($xml[$tag])==0)||(!isset($xml[$tag]))) {
		return(-1);
		}
	$dxml = dom_import_simplexml($xmlary);				// XML To HTML
	$i=0;
	foreach($dxml->childNodes as $node) {				// 変換後のオブジェクトから情報を取得 // Object: XML PAth: $html->getNodePath() / XML Data:$html->C14N()
		if ($node->nodeName == "#text") { continue; }

		if ((is_null($sel))||((!is_array($sel))&&($sel == ""))) { } else {			// 対象Tagの判定
			if (is_array($sel)) {						// 配列で指定
				 $ok=0;
				 foreach($sel as $cmp => $val) {
					if (($val==0)&&($cmp==(string)$node->nodeName)) { $ok=1;break; }					// $sel:$val=0 完全一致
					if (($val==1)&&(strncmp($cmp,$node->nodeName,strlen($cmp)) ==0)) { $ok=1;break; }	// $sel:$val=1 指定文字列を含む
					}
				 if ($ok==0) { continue; }
			 	 }
			else if (strncmp($sel,$node->nodeName,strlen($sel)) !==0) { continue; }	// 引数:$sel 単体での比較 先頭一致があればセレクト
			}
		if (is_null($attri)) { } else {					// 引数 $attri指定時属性を編集
			$j=0;
			$attri["Tag"][$i]=$node->nodeName;
			foreach($node->attributes as $key => $val) {
				$attr = $node->attributes->getNamedItem($key);		// 属性名称
				$attval=$attr->nodeValue;							// 属性値
				$attri["Att"][$i][$j]=$key;
				$attri["Val"][$i][$j]=$attval;
				$j=$j+1;
				}
			}
		$result = preg_match_all('/<'.$node->nodeName.'(.*?)>(.*?)<\/'.$node->nodeName.'>/si',$node->C14N(),$opart,PREG_SET_ORDER);	// <{Tag}>を検出:除外
		if (isset($opart[0][2])) {
			 $value=$opart[0][2];
			 if (is_array($rep)) {
				 $value=str_replace($rep_source,$rep,$value);		// Replace配列で置換
			 	 }
			 }
		else { $value==""; }
		if ($out == "0") { $str=$value;break; }
		else if ($out == "1") { $str=$value; }
		else if ($out == "2") { $str[$i]=$value; }
		else if ($str !=="")  { $str=$str.$out.$value; } else { $str=$value; }
		$i=$i+1;
		}
	return($str);
	}

/* -----------------------------------------------------------------------------
	get_libinit() : library init
	 MPD libraryのパラメータをXMLから設定

	※globalXML設定ファイルmpd Library : 各種外部Programで使用できる項目にする
----------------------------------------------------------------------------- */
function get_libinit() {
	global $LIB_CONF,$DEBUG,$XML_CONF,$ART_CONF,$UPDATE_CONF,$MPD_EXC,$XML_SORTBASE,$XML_SORTEXC,$XML_LISTUNIQUE;

//	$DEBUG= false;	// flase 1:msg 2:logout
//	$DEBUG= 2;  	// flase 1:msg 2:logout
//----- LibConf Config Get --------------------------------------------------
	$LIB_CONF=array("Codeset"=>"utf-8","TimeZone"=>"Asia/Tokyo","Ratio"=>"2.5","SecEdit"=>"%02d:%02d:%02d","Track"=>"","Lsinfo_Class"=>"on|0.20","Lsinfo_Class2nd"=>"off");
	$LIB_CONF["SetNo"]=get_config("LibConf",$LIB_CONF); // LibConf Property mpdconfig.xmlから設定
	$ary=explode("|",$LIB_CONF["Lsinfo_Class"]);
	$LIB_CONF["Lsinfo_Class_mpd"]="";
	if(isset($ary[1])) {
		$LIB_CONF["Lsinfo_Class"]=$ary[0];
		$LIB_CONF["Lsinfo_Class_mpd"]=$ary[1];
		}
	$LIB_CONF["Lsinfo_DirNoLimit"]="";					// 1階層目をチェックするかの設定 Directory数 "":制限なし
	if(isset($ary[2])) {
		$LIB_CONF["Lsinfo_DirNoLimit"]=$ary[2];
		}
//----- Album Art Config Get ------------------------------------------------
	$ART_CONF=array("path"=>"","file"=>"","func"=>"","timeout"=>3,"netmask"=>"","wanpath"=>"","wanPortForward"=>"");
	$ART_CONF["SetNo"]=get_config("Album_art",$ART_CONF);	// Album Art Property mpdconfig.xmlから設定
	$ART_CONF["FileAryZip"] = explode(',',$ART_CONF["file"]);	// Zip対応:Zip用置換を含む配列
	$ART_CONF["FileAry"]=array();								// Zip対応:Zip用置換を含まない配列
	foreach($ART_CONF["FileAryZip"] as $val) {
		$result = preg_match_all('/%(.*?)%/si',$val,$str,PREG_SET_ORDER);				// Zip用 正規表現:%{Item}%を検出し除外
		if ((isset($str[0][1]))&&($str[0][1]!="")) {
			continue;
			}
		$ART_CONF["FileAry"][]=$val;
		}
//----- Update Config Get ---------------------------------------------------
	$UPDATE_CONF=array("timeout"=>360);
	$UPDATE_CONF["SetNo"]=get_config("Update",$UPDATE_CONF); // Update Property mpdconfig.xmlから設定
//----- Mpd Command exclusive(排他) Config Get ------------------------------
	$MPD_EXC=array("netmask"=>"","cmd"=>"play,playid,seekcur,seekid,next,previous,stop,pause,setvol,delete,move,clear,random,repeat,single,save,load,rm,addlist,update");
	$MPD_EXC["SetNo"]=get_config("Mpd_exclusive",$MPD_EXC); // Mpd_exclusive Property mpdconfig.xmlから設定
	if($ART_CONF["netmask"]=="{Mpd_exclusive/netmask}") {	// Album_art->netmaskが{Mpd_exclusive/netmask}は設定を入れ替え
		$mask=explode("|",$MPD_EXC["netmask"]);				// {ipv4}/{bit}|{ipv6}/{bit}
		$ART_CONF["netmask"]=$mask[0];
		}
//----- Mpd Sort Base -------------------------------------------------------
	$XML_SORTBASE=array("Sort_Capital"=>"off","Sort_FieldMode"=>"","FieldLength"=>"Track:%05s,Date:%-8s,kind:%-9s");
	get_config("Sort_Base",$XML_SORTBASE);											// XML Sort Base設定
//----- Sort除外冠詞の設定を呼び元など各所で使用できるようにするため global $XML_SORTEXCに設定する
	$XML = get_object_vars($XML_CONF);						// Sort除外冠詞を設定する。
	foreach($XML["Sort_listexclude"]  as $key=> $part) { 	// Sort除外[Key:Filed]を指定。
		$XML_SORTEXC[$key] = $part;
		}
//----- Mpd Sort Base -------------------------------------------------------
	$tmp=array("Field"=>"");
	get_config("List_FieldUnique",$tmp);					// XML Sort Base設定
	$XML_LISTUNIQUE=array();
	if($tmp["Field"]!=="") {
		$XML_LISTUNIQUE=explode(",",$tmp["Field"]);			// {ipv4}/{bit}|{ipv6}/{bit}
		}
	}

/*
	_get_LsinfoFix() : $LIB_CONF["Lsinfo_Class"] Setting Fix  , connect(),get_libinit()後有効
	 mpdバ―ジョンが指定以上のとき下位層からDirectoryCheck機能off : mpd0.20?では対応されているため
*/
function _get_LsinfoFix() {
	global $Net,$LIB_CONF;

	if($LIB_CONF["Lsinfo_Class"] !=="on") { return; }		// onをoffにする判定なので対象外
	if (!$Net) { return; }
	$var=trim(str_ireplace("MPD","",$Net->ver));			// バージョン形式を整える
	if(($var=="")||$LIB_CONF["Lsinfo_Class_mpd"]=="") { return; }
	$var="0.".str_ireplace(".","",$var);
	$libvar="0.".str_ireplace(".","",$LIB_CONF["Lsinfo_Class_mpd"]);
	if($var >= $libvar) {									// バージョン指定以上は機能off
		$LIB_CONF["Lsinfo_Class"]="off";
		}
	if ($LIB_CONF["Lsinfo_Class2nd"] =="off") { return; }
	$ary = explode('|',$LIB_CONF["Lsinfo_Class2nd"]);	// 2階層目をチェックするかの設定 ["Lsinfo_Class2nd"] : on|{no} or off
	$LIB_CONF["Lsinfo_ClassNoLimit"]="32";
	if(isset($ary[1])) { $LIB_CONF["Lsinfo_ClassNoLimit"]=$ary[1]; }
	$LIB_CONF["Lsinfo_Class2nd"]="on";
	}

//----- Common Function's ---------------------------------------------------------
/*
	edit_time($seconds,$edit) : Seconds To hh:mm:ss
	  $seconds: i  : 秒
	  $edit   : i  : 編集方法 %02d:%02d(分3桁でも桁落ちしない) or %02d:%02d:%02d セパレータは":" 
	  @return : o  : (hh:)mm:ss
*/
function edit_time($seconds,$edit="") {
	global $LIB_CONF;

	$mm_str=$edit;$hh_str="";$hh=0;
	if ($edit == "") { $mm_str=$LIB_CONF["SecEdit"]; }
	$parts = explode(':',$mm_str);
	if (count($parts) == 1) {
		 $time=sprintf($mm_str,$seconds);		// 編集なしと判断 編集に":"がない
		 return($time);
		 }
	if (count($parts) > 2) {					// 時分秒編集
		 $hh_str=$mm_str;
		 $mm_str=$parts[1].":".$parts[2];
		 }
	if ($hh_str !== "") {
		 $hh = floor($seconds / 3600);
		 $mm = floor(($seconds / 60) % 60);
		 }
	else {
		 $mm = floor(($seconds / 60));
		 }
	$ss = $seconds % 60;
	if ($hh == 0) {
		 $time=sprintf($mm_str,$mm,$ss);
		 }
	else {
		 $time=sprintf($hh_str,$hh,$mm,$ss);
		 }
	return($time);
	}

/* 
	 edit_date($wld_date) : Date Edit
	  $wld_date: i  : Date yyyy-mm-ddThh;mm:ssZ グリニッジ標準時(世界標準時)
	  @return  : o  : Date yyyy-mm-dd hh;mm:ss  編集時間
*/
function edit_date($wld_date) {
	global $LIB_CONF;

	$t = new DateTime($wld_date);
	$t->setTimeZone(new DateTimeZone($LIB_CONF["TimeZone"]));
	$jpn_date = $t->format('Y-m-d H:i:s');
	return($jpn_date);
	}

/*
	Commn_LngChar($str,$lng,$padchr,$befor,$trchar,$code,$ratio) : 文字数まるめ
	  $str     : i  : Charactor
	  $lng     ; i  : Length : 指定文字数
	  $padchr  : i  : Padding charactor : 桁が満たない場合のPadding文字 &nbsp;は1文字と見なす。 "":未指定
	  $befor   : i  : Befor Padding =1  / Default 0:After $padchr指定時有効(文字列が指定桁を超えている場合は後ろ削除
	  $trchar  : i  : 指定文字数を超えた部分に付加する文字 Default = ...を付加する。 "":未指定
	  $code    : i  : 内部コード(mpdは標準'utf-8') 指定なし時,LibCong Codeset
	  $ratio   : i  : 全角混じりの計算として表示エリア半角文字数比率  指定なし時,LibCong Ratio
	  @return  : o  : char Last ...付加

	  Commn_LngChar("1234567890A",10);        ---> 1234567... : 超える部分を削除し"..."を付加。指定文字数にする
	  Commn_LngChar("123456",10,"@");         ---> 123456@@@@ : 満たない後桁に"@"をPadding
	  Commn_LngChar("123456",10,"0",1);       ---> 0000123456 : 満たない前桁に"0"をPadding
	  Commn_LngChar("1234567890A",10,"",0,"");---> 1234567890 : 超える部分を削除
	  ※前桁を削除するモードはない
	  ※全角混じりの計算として半角2.5文字の領域を使用としている。(Font size,文字数の誤差がある。
	    精度が悪すぎる場合,係数を引数で設定。
	    文字コードをutf-8としているがXMLSettingで指定できる
	言語圏内の2Byte文字をFontによる比率として調整(Gosickなどは2.0となる)
	エリアオーバ分をカット目的なので厳密でなない(現本システムはFontを指定していない前提)
*/
function Commn_LngChar($str,$lng,$padchr="",$befor=0,$trchar="...",$code='',$ratio='') {
	global $LIB_CONF;

	if ($code == '') {							// 未設定はXML設定よりLibCong Codeset
		$code=$LIB_CONF["Codeset"];
		}
	if ($ratio == '') {							//  未設定はXML設定よりRatio
		$ratio=$LIB_CONF["Ratio"];
		}
	$lng_chr  = mb_strlen($str,$code);			// 文字数
	$lng_byte = strlen($str);					// Byte数
	$lng_def =($lng_byte - $lng_chr)/$ratio;	// (Byte数-文字数)*比率 ...漢字分の不足をByte数の比率(漢字1文字で半角文字数)で文字数を設定

	if ($trchar !== "") {
		 $ret = mb_strimwidth($str, 0,$lng+$lng_def,$trchar,$code);		// 指定文字数を超えた部分に指定文字を付加する
		 }
	else {
		 $ret = mb_strimwidth($str, 0,$lng+$lng_def,$code);
		 }
	if (($padchr !== "")&&(mb_strlen($str) < $lng))  {		// 桁が満たない場合のPadding文字 &nbsp;は1文字と見なす
		if($padchr !== "&nbsp;") {
			 if ($befor = 1) {
			 	  $ret = str_pad($str,$lng,$padchr,STR_PAD_LEFT);
				  }
			 else {
			 	  $ret = str_pad($str,$lng,$padchr);
				  }
			 }
		else {
			 $st="";
			 $padno=$lng-(mb_strlen($str));
			 $ret = str_pad($st,$padno*5,$padchr);
			 if ($befor == 1) {
				  $ret = $ret.$str;
				  }
			 else {
				  $ret = $str.$ret;
				  }
			}
		}
	return($ret);
	}

/*
	Commn_UrlEncode($str) : 必要な部分をURL Encode(ファイルシステム構造をURLにする)
	  $str    : i  : URL
	  @return : o  : URL Encode
	特定の文字列の中で、マルチバイトの文字だけURLエンコード %xxでは対応できない
*/

function Commn_UrlEncode($str) {
 	return preg_replace_callback(
		'/[^\x21-\x7e]+/',
		function($matches) {
			return urlencode($matches[0]);
		},
		$str );
	}

/* PHP 5.3以下の場合 無名関数/Callbackが使えないので以下を代用--Warningになるので取り合えず('display_errors',0)
   再起しないので複数Directryが対象では未対応(完全ではない) 
   ※ 下をコメントをはずし(生かす）,上記 function Commn_UrlEncode($str) { }をコメントにする */
/*
function Commn_UrlEncode($str) {
 	return preg_replace_callback(
		'/[^\x21-\x7e]+/',
		Commn_UrlEncode_recall($matches)
		,$str);
	}

function Commn_UrlEncode_recall($matches) {
	$err=ini_get('display_errors');
	ini_set('display_errors',0);	// エラー表示設定(しない)
	return urlencode($matches[0]);	// URL Encode
	ini_set('display_errors',$err);	//  表示設定を戻す(returnするので戻らない)
	}
*/
/* function Commn_UrlEncode : Comment End */

/* 
	Commn_UrlConvert($str,$mode) : コマンドインタフェース・パラメータURLで使用不可文字をEncode/Decode
	 $str    : i  : URL String
	 $mode   : i  : enc:encode / dec:decode
	 @return : o  : URL Convert String
	html/Js(post/get)とPHPでの$_GET/$_POSTでの相互Encodeがない
	Js/php簡単に変換できる程度の関数 (htmlspecialcharsと同じだが 文字種/コード/変換テーブルなどを指定しないので簡素と判断)
*/
function Commn_UrlConvert($str,$mode="enc") {
	$url_char=array("%",  ' ',  '!',  '"',  '#'  ,"$",  "&",  "'",  "(",  ")",  "*",  "+",  ",",  "/",  ":",  ";",  "<",  "=",  ">",  "?",  "@",  "[",  "]",  "^",  "`",  "{",  "|",  "}",  "~");		// URL Encode
	$spc_char=array('%25','%20','%21','%22','%23','%24','%26','%27','%28','%29','%2A','%2B','%2C','%2F','%3A','%3B','%3C','%3D','%3E','%3F','%40','%5B','%5D','%5E','%60','%7B','%7C','%7D','%7E');		// URL Replace

	if ($mode=="enc") {
		 $ret = str_replace($url_char,$spc_char,$str);	// Encode:$url_char→$spc_char
		 }
	else {
		 $ret = str_replace($spc_char,$url_char,$str);	// Encode:$spc_char→$url_char
		 }
	return($ret);
	}

/* ---- Table Sort Support ---------------------------------------------------------
	Commn_Subnet($netmask,$ip) : NetWorkが許可範囲か
	 $netmask: i  : Netmask Form:{ipv4}/{bit}|{ipv6}/{bit}
	 $ip     : i  : ip Address IPv4 | IPv6
	 @return : o  : true/false
 ---- Table Sort Support -------------------------------------------------------- */
function Commn_Subnet($netmask,$ip) {
	$ret=TRUE;
	$mask=explode("|",$netmask);	// {ipv4}/{bit}|{ipv6}/{bit}
	if(!isset($mask[1])) {			// ipv6 Netmaskがないとき
		$mask[1]="";
		}

	if (!Commn_isIPv6($ip)) {
		 $ret=Commn_SubnetIPv4($mask[0],$ip);
		 }
	else {
		 $ret=Commn_SubnetIPv6($mask[1],$ip);
		 }
	return($ret);
	}

/*
	Commn_Subnet($netmask,$ip) : NetWorkが許可範囲か
	 $netmask: i  : Netmask {IPV4}/{Bit} xxx.xxx.0.0/16 , "":No Check(All TRUE)
	 $ip     : i  : ip Address
	 @return : o  : true/false
	 $netmask:192.168.0.0/24(255.255.255.0の表記),192.168.0.0/16(255.255.0.0の表記)の形式
*/
function Commn_SubnetIPv4($netmask,$ip) {
	if ($netmask == "") {
		return(true);
		}
	if(strpos($netmask,'/') === false){
		return(true);
		}
	list($mask_ip, $mask) = explode('/', $netmask);
	$mask_long = ip2long($mask_ip) >> (32 - $mask);
	$ip_long = ip2long($ip) >> (32 - $mask);
	if  ($mask_long == $ip_long) {
    	 $ret = true;
		 }
 	else {
    	 $ret = false;
		 }
	return($ret);
	}

/*
	Commn_SubnetIPv6($ipaddr,$netmask) : NetWork(IPV6)が許可範囲か
	 $ipaddr   : i  : IP Address IPV6
	 $netmaskip: i  : $Netaddr   {IPV6}/{Bit} xxxx:xxxx:xxxx:xxxx:0:0:0:0/64 , "":No Check(All TRUE)
	 return    : o  : Same Network:TRUE / Other:FALSE

	参考)Usoinfo blog:PHPでIPアドレス＋ネットマスクに適合するかチェック http://blog.usoinfo.info/article/452153155.html
*/
function Commn_SubnetIPv6($netmask,$ipaddr) {
	if ($netmask=="") { return(TRUE); }
	$netmaskbit=0;$netmaskip=$netmask;
	if (($pos = strpos($netmask,"/")) !== FALSE ){
		$netmaskbit = intval(substr($netmask,$pos+1) );
		$netmaskip = substr($netmask,0,$pos);
  		}
	$bitipadr = inet_pton($ipaddr);
	$bitmskip = inet_pton($netmaskip);
	$len  = strlen($bitipadr)*8;
	if($netmaskbit > $len) $netmaskbit = $len;
	$mask = str_repeat('f', $netmaskbit>>2);
	switch($netmaskbit & 3){
		case 3: $mask .= 'e'; break;
		case 2: $mask .= 'c'; break;
		case 1: $mask .= '8'; break;
		}
	$mask = pack('H*',str_pad($mask,$len>>2, '0'));
	return(Commn_SubnetIPv6Mask($mask,$bitipadr) == Commn_SubnetIPv6Mask($mask,$bitmskip));
	}

/*
	Commn_SubnetIPv6Mask($bitip,$bitmask) : NetWork(IPV6)Mask
	 $bitip    : i  : Source IPバイナリ文字列
	 $mask     : i  : NetMask バイナリ文字列
	 return    : o  : Same Network:TRUE / Other:FALSE
*/
function Commn_SubnetIPv6Mask($bitmask,$bitip) {
	$aryip  = str_split($bitip);
	$arymsk = str_split($bitmask);
	$ret  = false;
	for($i=0;$i<count($aryip);$i++){
		$ret  .= $aryip[$i] & $arymsk[$i];
		}
	return($ret);
	}

/*
	Commn_IPv6inf($ip) : IPv6 Info.
	 $ip    : i  : IPV6 形式
	 @return: o  : InfoArray ["kind"]  : v4:IPv4射影アドレス v6:IPv6 , v6link:リンクローカル
	                         ["site"]  : サイトプレフィックス ,v4時スペース
                             ["subnet"]: サブネットID         ,v4時スペース
                             ["ifid"]  : インターフェイスID   ,v4時スペース
	参考)IPv6 xxxx:xxxx:xxxx:ssss:iiii:iiii:iiii:iiii : x:サイトプレフィックス s:サブネットID i:インターフェイスID
*/
function Commn_IPv6inf($ip) {
	$ipv6 =	array("kind"=>"","site"=>"","subnet"=>"","ifid"=>"");
 	if (strpos($ip, ':')===0) {
		$ipv6["kind"]="v4";
		$ipv6["ifid"]=$ip;
		return($ipv6);
        }
	$ipv6["kind"]="v6";
	if ((strlen($ip) >=4 )&&(strncmp(strtolower($ip),"fe80",4)==0)) {	// リンクローカル IPv6 アドレス
		$ipv6["kind"]="v6link";
		}
	$cnt=substr_count($ip,":");
	$str=$ip;
	if ($cnt < 7) {
		$str=str_pad($ip,((strlen($str))+7-$cnt),":","1");
		}
	$ipary = explode(":",$str);
	$ary = array_slice($ipary,0,3);
	$ipv6["site"] = implode(':',$ary);
	$ipv6["subnet"] = $ipary[3];
	$ary = array_slice($ipary,4,4);
	$ipv6["ifid"] = implode(':',$ary);
	return($ipv6);
	}

/*
	Commn_isIPv6($ip) : ipがIPv6かチェック
	 $ip     : i  : ipv6 Address
	 @return : o  : true/false
*/
function Commn_isIPv6($ip) {
    if(filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6)) {
        return true;
    	}
    return false;
	}

/* ---- Table Sort Support ---------------------------------------------------------
	Sort_Para($sortcmd,$field,$query,$mode,$init_srt,$verbs_fld,$verbs_srt,$EXCLUDE,$SORTFLD):SortTableパラメータ取得
	 $sortcmd  : i  : SortCommand パラメータの取得用 XML:"Sort_".$sortcmd
	 $field    : i  : Field Array
	 $query    : i  : Query Array
	 $mode     : i  : 0:パラメータの取得直接指定 "Sort_".$sortcmdを取得 1:パラメータの取得をQueryから検索指定 "Sort_".$sortcmdから検索
	 $init_srt : i  : Sort文字列 初期値(設定がない場合) ","区切り
	 $verbs_fld: i  : Sort対象設定Filedイレギュラーに指定できる。複数$field時有効。XML設定 <Sort_{$field先頭}><$verbs_fld>
	 $verbs_srt: i  : Sort文字列 イレギュラー ","区切り 指定された場合使用する
	 $EXCLUDE  : o  : Sort除外冠詞配列
	 $SORTFLD  : o  : SortFiled配列
	 $SORTMOD  : o  : SortMode配列 ディセンディング時"D"をセット
	 @return   : o  : $XML_SORT_FLD $XML_SORT_FLD[$sortcmd][$key]:設定内容そのまま
	                  $XML_SORT_FLD["SortStr"]:$SORTFLD選択時のSortString","区切り / $XML_SORT_FLD["Sort_on"]:0:自身のFielf以外,有効SortFiledがない。
	※ XML Sortパラメータ検索順 <Sort_{$sortcmd}から直接Or検索,見つからい場合,<Sort_{$sortcmd}><Default>,ない場合,引数:$init_srtを使用
*/
function Sort_Para($sortcmd,$field,$query,$mode=0,$init_srt='',$verbs_fld="",$verbs_srt="",&$EXCLUDE=array(),&$SORTFLD=array(),&$SORTMOD=array()) {
	global $XML_CONF,$XML_SORTBASE,$XML_SORTFILED,$XML_FILEDLENG;	// $XML_SORTFILED:Filed SortMode:A|D,$XML_FILEDLENG:Filed Sort Length %xs

	$sort_on=0;$EXCLUDE=array();$SORTFLD=array();$SORTMOD=array();$XML_SORTFILED=array();$XML_SORT_FLD["SortNo"]=0;

	if ($XML_SORTBASE["FieldLength"] !== "") {			// SortField Length 設定
		$lngestr=explode(",",$XML_SORTBASE["FieldLength"]);
		foreach($lngestr as $val) {
			$str=explode(":",$val);
			if (isset($str[1])) {						// SortField Length {Filed}{:{sprintfのパラメータ形式}}
				$XML_FILEDLENG[$str[0]]=$str[1];
				}
			}
		}
	if (!isset($XML_FILEDLENG["kind"])) { $XML_FILEDLENG["kind"]="%-9s"; }	// Sort Filed kindの長さは必須
	$XML = get_object_vars($XML_CONF);						// Sort除外冠詞を設定する。
	foreach($XML["Sort_listexclude"]  as $key=> $part) { 	// Sort除外[Key:Filed]を指定。
		$EXCLUDE[$key] = explode(",",$part);
		}
	if ($mode == 0) {								// SortFiled 直接指定 Sort Filed
		if ($verbs_fld=="") {								// Sort対象Filedの指定がなければ,Queryの先頭Filedを使用
			 if  (is_array($query)) {
				  $first = reset($query);					// 配列(Query)の先頭
				  $key = array_search($first,$query); }
			 else { $key = $query; }						// 配列でない場合、上位階層のDirectoryなどで指定できる。
			 }
		else { $key = $verbs_fld; }							// Sort対象Filedの指定されている
		}
	if ($verbs_srt == "") {
		if ($mode == 0) {							// SortFiled 直接指定 設定取得
			 $XML_SORT_FLD[$sortcmd][$key]="";				// field拡張対応可能な構造にしておく
			 $XML_SORT_FLD["SortNo"]=get_config("Sort_".$sortcmd,$XML_SORT_FLD[$sortcmd]);	// Album Sort時の条件設定 設定TagのAlbum一覧条件時SortKeyを設定
			 }
		else {										// Query検索モード 設定検索取得
			 foreach($query as $qkey => $val) {				// Album Sort Config
				$str="";
				if($sortcmd=="Search_List") { $str="Album,Date,Disc,Track"; }				// Default:Find:Search;List用
				else if($sortcmd=="Search_Album") { $str="Album,Date,Disc,Track"; }			// Default:Find:Search:Album まとめ用
				else if($sortcmd=="Find_noAlbum") { $str="Album,Disc,Track,Date"; }			// Default:Find:List用
				$XML_SORT_FLD[$sortcmd][$qkey]=$str;
				$XML_SORT_FLD["SortNo"]=get_config("Sort_".$sortcmd,$XML_SORT_FLD[$sortcmd]);	// Album Sort時の条件設定 設定TagのAlbum一覧条件時SortKeyを設定
				if ($XML_SORT_FLD["SortNo"] !== 0) {
					$key=$qkey;break;
					}
				}
			}
		if ($XML_SORT_FLD["SortNo"] == 0) {			// Field対応の設定が見つからない場合、"Default"が設定されていれば使用
			$str="";
			if($sortcmd=="Search_List") { $str="Album,Date,Disc,Track"; }				// Default:Find:Search;List用
			else if($sortcmd=="Search_Album") { $str="Album,Date,Disc,Track"; }			// Default:Find:Search:Album まとめ用
			else if($sortcmd=="Find_noAlbum") { $str="Album,Disc,Track"; }				// Default:Find:List用
			$XML_SORT_FLD[$sortcmd]["Default"]=$str;	
			$XML_SORT_FLD["SortNo"]=get_config("Sort_".$sortcmd,$XML_SORT_FLD[$sortcmd]);	// Album Sort時の条件設定 設定TagのAlbum一覧条件時SortKeyを設定
			if ($XML_SORT_FLD["SortNo"] !== 0) {
				if ($mode == 0) {
					 $XML_SORT_FLD[$sortcmd][$key]=$XML_SORT_FLD[$sortcmd]["Default"]; }
				else {
					 $key="Default";
					 }
				}
			}
		if (($XML_SORT_FLD["SortNo"] == 0)&&($init_srt !== "")) {
			if ($mode == 0) {
				 $XML_SORT_FLD[$sortcmd][$key]=$init_srt;
				 }
			else {
				 $key="Init";
				 $XML_SORT_FLD[$sortcmd][$key]=$init_srt;
				 }
			}
		 }
	else {
		 $XML_SORT_FLD[$sortcmd][$key]=$verbs_srt;		// 呼び出し元から直接SortFiledを指定
		 $XML_SORT_FLD["SortNo"] = 1;
		 }
	if ($XML_SORTBASE["Sort_FieldMode"] !== "") {
		$modestr=explode(",",$XML_SORTBASE["Sort_FieldMode"]);
		foreach($modestr as $val) {
			$str=explode(":",$val);
			if (isset($str[1])) {						// 標準Sortモード {Filed}{:D}ディセンディング
				$XML_SORTFILED[$str[0]]=strtoupper($str[1]);
				}
			}
		}
	if ($XML_SORT_FLD["SortNo"] != 0) {
		$sort_field = str_replace('|',",",$XML_SORT_FLD[$sortcmd][$key]);		// "|" {Filed1}|{Filed2} Filed1が存在しないとき{Filed2を使用
		$sort_item=explode(",",$sort_field);			// Sort Fieldが要求Fieldにあるかチェック
		foreach($sort_item as $skey => $sval) {
			$svaltb=explode(":",$sval);
			if (isset($svaltb[1])) {						// Sortモード {Filed}{:D}ディセンディング
				$SORTMOD[$svaltb[0]]=strtoupper($svaltb[1]);
				}
			if ($svaltb[0] == $field[0]) { continue; }		// Sort Fieldが指定されていても,第1Fieldのみは、mpd_list_findを使用しない
			if (in_array($svaltb[0],$field)) {				// Sort FieldがあるのでSort有効
				$sort_on=1; }
			}
		}
	$XML_SORT_FLD["Sort_on"]=$sort_on;					// 目的Filed以外にSort指定がある。
	if ($XML_SORT_FLD[$sortcmd][$key] !=="") {				// 有効Filed判定&XMLディセンディング配列作成
		$modestr=explode(",",$XML_SORT_FLD[$sortcmd][$key]);
		foreach($modestr as $val) {
			$str=explode(":",$val);							// ":"以下を捨てる
			$SORTFLD[]=$str[0];								// $SORTFLDを設定
			}
		}
	$XML_SORT_FLD["SortStr"]=$XML_SORT_FLD[$sortcmd][$key];
	return($XML_SORT_FLD);
	}

/*
	Sort_Filed($SORTFLD,$EXCLUDE,$input,$key,&$output,$put,$sort_tbl):SortField編集
	 $SORTFLD  : i  : SortFiled配列
	 $EXCLUDE  : i  : Sort除外冠詞配列
	 $SORTMOD  : o  : SortMode配列 ディセンディング時"D"をセット
	 $input    : i  : Sort対象配列
	 $key      : i  : Sort対象配列の対象Key
	 $output   : io : Sort用配列(編集後)
	 $put      : i  : Sort用配列のKey
	 $sort_tbl : i  : Sort用配列(編集後)のテーブル名
*/
function Sort_Filed($SORTFLD,$EXCLUDE,$SORTMOD,$input,$key,&$output,$put,$sort_tbl) {
	if (count($SORTFLD) > 1) {					// Sort指定が複数時
		 foreach($SORTFLD as $SFLD) {
			$field=$SFLD;
			$str=_Sort_Filedline($field,$EXCLUDE,$SORTMOD,$input,$key);
			if ($SFLD === end($SORTFLD)) { $str=rtrim($str); }		// 配列のLastはRTrim
			if (!isset($output[$sort_tbl][$put])) { $output[$sort_tbl][$put]=""; }
			$output[$sort_tbl][$put].="[".$str."\00]";				// Short分を¥00で1文字保管 "]"でSortがずれるため
			}
		 }
	else if ((isset($SORTFLD[0]))&&($SORTFLD[0] !=="")) {											// Sort指定が単数時Loopもしない
		 $field=$SORTFLD[0];
		 $str=_Sort_Filedline($field,$EXCLUDE,$SORTMOD,$input,$key);
		 $str=rtrim($str);
		 $output[$sort_tbl][$put]="[".$str."\00]";			// Short分を¥00で1文字保管"]"でSortがずれるため
		 }
	}

/*
	_Sort_Filedline($SFLD,$EXCLUDE,$input,$key):SortField項目編集
	 $SFLD     : io : SortFiled "|"項目選択,"kindconv"時,使用項目に変換
	 $EXCLUDE  : i  : Sort除外冠詞配列
	 $input    : i  : Sort対象配列
	 $key      : i  : Sort対象配列の対象Key
	 @return   : o  : Sort編集String
*/
function _Sort_Filedline(&$SFLD,$EXCLUDE,$SORTMOD,$input,$key) {
	global $XML_SORTBASE,$XML_SORTFILED,$XML_FILEDLENG;		// $XML_SORTFILED:FiledSortMode:A|D,$XML_FILEDLENG:Filed Sort Length %xs

	$mode_kind=0;$selstr="";
	if ($SFLD == "kindconv") {				// "kindconv":"kind"が示すFile/Directory/Playlistに変換する。
		$mode_kind=1;
		$SFLD=$input["kind"][$key];
		}
	$SFLD_ITEM = explode("|",$SFLD);		// "|"を分解 {Filed1}|{Filed2} Filed1が存在しないとき{Filed2を使用)
	$item_key="";$ret=0;
	if (count($SFLD_ITEM) > 1) {
		 $item_sel="";
		 foreach($SFLD_ITEM as $item) {			// 分解した項目を選択
			if (($item!=="")&&(isset($input[$item][$key]))) {
				$item_sel=$item;
				break; }
			}
		 if ($item_sel == "") { $ret=-1; }		// 対象項目内容なし
		 else  { $SFLD=$item_sel; }
		 }
	if ((!isset($input[$SFLD][$key]))||($ret==-1)) { $selstr=""; }		// Fieldがない場合もSortテーブルに""をセット
	else {
		 if ($XML_SORTBASE["Sort_Capital"] == "on") {					// 大/小文字区別なし
			if(isset($EXCLUDE[$SFLD])) {
				 $str=trim(str_ireplace($EXCLUDE[$SFLD],"",$input[$SFLD][$key]));	// Sort除外冠詞を削除
				 }
			else {
				 $str=$input[$SFLD][$key];
				 }
			 $selstr=strtoupper($str);
			 }
		 else {
			 if (isset($EXCLUDE[$SFLD])) {								// Sort除外冠詞が設定されている
				 $str=trim(str_replace($EXCLUDE[$SFLD],"",$input[$SFLD][$key]));	// Sort除外冠詞を削除
				 }
			else {
				 $str=$input[$SFLD][$key];
				 }
			$selstr=$str;
			}
		}
	$retstr="";
	if (($mode_kind==1)&&(isset($input["kind"][$key]))) {				// $SFLD:"kindconv"のときkind+derectory/fileを付加
		$retstr.=sprintf($XML_FILEDLENG["kind"],$input["kind"][$key]).":";		// "kind"は設定必須
		}
	if (isset($XML_FILEDLENG[$SFLD])) {									// フィールド長が設定されている
		 $selstr=sprintf($XML_FILEDLENG[$SFLD],$selstr);						// %05s 0:Pading %-5s:Left-justified %.5s:Truncation
		 }
	if ((isset($SORTMOD[$SFLD]))&&($SORTMOD[$SFLD] !=="")) {			// 項目にソート指定
		 if ($SORTMOD[$SFLD] =="D") {									// 項目ディセンディングソート
		 	 $selstr=~$selstr; }
		 }
	else if ((isset($XML_SORTFILED[$SFLD]))&&($XML_SORTFILED[$SFLD] =="D")) {	// 標準ディセンディングソート指定
		 $selstr=~$selstr; }
	$retstr.=$selstr;
	return($retstr);
	}

/* ---- Table Sort -----------------------------------------------------------------

	Sort_Table($outlist,$sort) : Table Sort
	 $outlist: i  : 対象Table
	 $sort   : i  : Sort Table
	 @return : o  : Sort Table
*/
function Sort_Table($outlist,$sort) {
	if (!is_array($outlist)) {			// Reqestが配列でない
		return($outlist);
		}
	if (!isset($outlist[$sort])) {		// SortKeyとなる配列がない
		return($outlist);
		}
	$outkey=array_keys($outlist);
	asort($outlist[$sort]);								// Sort List
	$i=0;
	foreach($outlist[$sort] as $key => $val) {			// Sort対象の配列の順で再作成
		foreach($outkey as $keyval) {
			if (isset($outlist[$keyval][$key])) {		// 各配列を順にコピー
				$output[$keyval][$i]=$outlist[$keyval][$key];
				}
			}
		$i+=1;
		}
	return($output);
	}

//----- mpd support Function's ----------------------------------------------------
/*
	_Arg_getImagFunc($file,$base) : Get Image Func Extend Get subLibrary
	 $file    : i  : File path (URL)
	 $base    : io : URLのFile basename
	 @return  : o  : Image File
	※ Mainで(array)get_library()を使用してrequireする。
	  <ExtendLibrary><image>
	  $XML_IMGFUNC["func"]:Function() Get Image File   $result=pls_ArtURL("{URL}");形式
	  $XML_IMGFUNC["file"] Function ImageFile条件 File名先頭からの文字列 Striming:"http://www....."の場合 "http"が一致
*/
function _Arg_getImagFunc($file,&$base="") {
	global $XML_IMGFUNC;

	$ret=false;
	if ((strpos($file,"http")) !== 0) { return($result); } 	// 当関数はURLが対象
	foreach($XML_IMGFUNC["func"]  as $key=> $val) {			// 条件がない場合は一致とする
		if (!isset($XML_IMGFUNC["file"][$key])) { }			// Striming拡張Module条件
		elseif (strpos($file,$XML_IMGFUNC["file"][$key]) !== 0) { continue; }	// Striming拡張Module 条件 URLの先頭一致Word
		$fanc = $val;										// Striming拡張Module (mpdweb.playlist.php:現在2024.03.24)
		if (function_exists($val)) {
			$result = $fanc($file,$base);
			break;
			}
		}
	return($result);
	}
/*
	mpd_editalbumart($file,$mode,$base) : AlbumArt Edit
	 $file    : i  : File path
	 $mode    : i  : "File"/"Directory"
	 $base    : io : URLのFile basename (URL以外は使用しない)
	 @return  : o  : AlbumArt Path
*/
function mpd_editalbumart($file,$mode="file",&$base="") {
	global $ART_CONF;

	if ((strpos($file,"http")) === 0) {		// Striming拡張Module
		$ret=false;
		$ret=_Arg_getImagFunc($file,$base);	// <ExtendLibrary><image>設定関数
		return($ret);
		}
	if ((!isset($ART_CONF["path"]))||($ART_CONF["path"] == "")) {		// 未設定の時 false
		return(false);
		}
	if ($mode == "file") {
		 $filepath = pathinfo($file);  // フルパスを連想配列に格納
		 }
	else {
		 $filepath['dirname']=$file;
		 }
	if (($wan_mode=_mpd_editalbumart_host($wan_path,$imghost)) === false) { return(false); }	// Wan/Lan Host編集
	$dirname=mpd_editZipFile2Dir($filepath['dirname'],$dirstruct);
	if ($dirname != $filepath['dirname']) {	// Zip Fileのとき
		 $dirs[0]=$dirname;
		 $dirs[1]=$filepath['dirname'];		// 仮に.zipを含むDirectoryがある場合にチェック(別Network/ファイル共有時はチェックできないので,「.zip」はディレクトリ名と考えない
		 foreach($dirs as $dir) {
			$ret=_mpd_editalbumart_Search($wan_mode,$wan_path,$imghost,$dir,$dirstruct);
			if ($ret !== false) { break; }
			}
		 }
	else {
		 $dirname=mpd_editCueFile2Dir($filepath['dirname'],$dirstruct);
		 if ($dirname != $filepath['dirname']) {	// Cue Fileのとき
			  $dirs[0]=$dirname;
			  $dirs[1]=$filepath['dirname'];		// 仮に.cueを含むDirectoryがある場合にチェック(別Network/ファイル共有時はチェックできないので,「.cue」はディレクトリ名と考えない
			  foreach($dirs as $dir) {
				 $ret=_mpd_editalbumart_Search($wan_mode,$wan_path,$imghost,$dir,$dirstruct);
				 if ($ret !== false) { break; }
				 }
			  }
		 else {									// 通常のディレクトリ
			  $ret=_mpd_editalbumart_Search($wan_mode,$wan_path,$imghost,$filepath['dirname']);
			  }
		}
	return($ret);
	}

/*
	_mpd_editalbumart_host($wan_path,$imghost) : AlbumArt Host Edit
	 $wan_path: io : Wan Path
	 $imghost : io : Lan Path
	 @return  : o  : Lan Mode:0 / Wan Mode:1 False:無効
*/
function _mpd_editalbumart_host(&$wan_path,&$imghost) {
	global $ART_CONF;

	$wan_path="";$wan_mode=0;
	$aryport=explode("|",$ART_CONF["wanPortForward"]);							// $ART_CONF["wanPortForward"] : {ForwardPort}|{httpd AccressPort}
	if(!isset($aryport[0])) { $aryport[0]=""; } if(!isset($aryport[1])) { $aryport[1]=""; }

	$ipv6=Commn_isIPv6($_SERVER['SERVER_ADDR']);
	if(!$ipv6) {																// IPv4のときはNetMaskでWan/Lan判定 // IPoEではWanからの接続は困難 IPv6は本来Grobal
		if (!Commn_Subnet($ART_CONF["netmask"],$_SERVER['REMOTE_ADDR'])) {
			if ((!isset($ART_CONF["wanpath"]))||($ART_CONF["wanpath"] == "")) {		// wanpathが未設定の時 false
				return(false);
				}
			if(strpos($ART_CONF["wanpath"],$_SERVER["HTTP_HOST"]) === false){		// wanpathがアクセスされたサーバと異なる時 false
				return(false);
				}
			$wan_mode=1;				// WAN Mode
			if (mb_substr($ART_CONF["wanpath"],-1) == "/") {
				 $wan_path=$ART_CONF["wanpath"];
				 }
			else {
				 $wan_path=$ART_CONF["wanpath"]."/";
				 }
			}
		}
	if (mb_substr($ART_CONF["path"],-1) == "/") {
		 $lan_path=$ART_CONF["path"];
		 }
	else {
		 $lan_path=$ART_CONF["path"]."/";
		 }
	$port="";
	if (($_SERVER['SERVER_PORT'] !== "80")&&(strpos($lan_path,"localhost:") === false)) {	// path:localhostに設定時,Portがなければ)
		$tmp=$_SERVER['SERVER_PORT'];							// $_SERVER['SERVER_PORT']はURLのPortが設定されているので,HTTPDのAccressPortが不明
		if (($aryport[0] !=="")||($aryport[1] !=="")) {
			if($tmp==$aryport[0]) { $tmp=$aryport[1]; }			// IPoE対応でPortForwardの設定でPortが一致時,AccressPortに変換
			}
		if ($tmp !=="80") { $port=":".$tmp; }					// Server AccessのPortも付加する
		}
	$server=$_SERVER['SERVER_ADDR'];
	if ($ipv6) { $server="[".$server."]"; }
	$imghost = str_replace("localhost",$server.$port,$lan_path);	// path:localhostに設定時,shell実行のAddressを設定
	return($wan_mode);
	}

/*
	_mpd_editalbumart_Search($wan_mode,$wan_path,$imghost,$filepath) : Albumart 設定のファイル名 Search
	 $wan_mode : i  : Lan Mode:0 / Wan Mode:1 False:無効
	 $wan_path : io : Wan Path
	 $imghost  : io : Lan Path
	 $filepath : i  : File Path (pathinfo構造体 $filepath['dirname']) : mpdからのPath
	 $dirstruct: i  : Zip File部分の構造体  [dirname]:「.」 [basename] =>{FileBase}.zip extension] => 「zip」[filename] => {filename}
	 @return   : o  : AlbumArt Path false:ないとき
	 ※Local Web/Sambaは先頭に設定のArt File
*/
function _mpd_editalbumart_Search($wan_mode,$wan_path,$imghost,$filepath,$dirstruct="") {
	global $ART_CONF;

	$timeout =(integer)$ART_CONF["timeout"];	// Timeout設定
	$url_char=array(' ', '#','&',"'");			// URL Encode  2019.07.07
	$rep_char=array('%20', '%23','%26','%27');	// URL Replace 2019.07.07
	$ret=false;

	if (is_array($dirstruct)) {					// Array(ZipFile)のとき,%{basename}%(extension含む),%{extension}%,%{filename}%(extension除く)
		 foreach($dirstruct as $key => $val) {
			$sor[]='%'.$key.'%';				// ZipFile時の置換配列 現在:File構造体を行う
			$dst[]=$val;
			}
		 $p = str_replace($sor,$dst,$ART_CONF["FileAryZip"]);
		 $parts=array();						// 置換できなかった配列を除外する
		 foreach($p as $val) {
			$result = preg_match_all('/%(.*?)%/si',$val,$str,PREG_SET_ORDER);				// Zip用 正規表現:%{Item}%を検出し除外
			if ((isset($str[0][1]))&&($str[0][1]!="")) { continue; }
			$parts[]=$val;
			}
		 }
	else {
		 $parts = $ART_CONF["FileAry"];
		 }
	foreach($parts as $part) {
		$url=$imghost.$filepath;
		if (mb_substr($url,0,5) !== "file:") {
			 $str=$url."/".$part;
			 $str = str_replace($url_char,$rep_char,$str);
			 $str=Commn_UrlEncode($str);
			 $response = @file_get_contents($str,NULL,stream_context_create(array('http'=>array('timeout'=>$timeout))),0,strlen($str)+20);	// 長く読むと時間が掛かるため取り合えずのLengthを指定 file_get_contentsは全て読むためSizeを指定する
			 if (($response !== false)&&((strpos($response,'doctype')) === false)) {	// Redirectされた場合,doctype文書型の定義にて見なす(UTF-8前提)
				 if ($wan_mode==1) {				// WAN Mode
					 $dirstr = str_replace($url_char,$rep_char,$filepath);
					 $ret=$wan_path.$dirstr."/".$part;
					 break;
					 }
				 $ret=$str;																//  VolmioRc2は存在しないURLはhomeにRedirect 日本語のままの時は条件でRedirect
				 break;
				 }
			 }
		else {
			 $str=$url."\\".$part;				// ファイル指定はClientから存在チェックはできない
			 $ret=str_replace("/","\\",$str);
			 break;
			 }
		}
	return($ret);
	}

/*
	mpd_editZipFile2Dir($dirname,$dirstruct) : split Zip FIle Path To Directory
	 $dirname  : i  : Zip File PAth
	 $dirstruct: o  : Zip File部分の構造体  [dirname]:「.」 [basename] =>{FileBase}.zip extension] => 「zip」[filename] => {filename}
	 @return   : o  : Zip File Directory Not Found, $dirname
*/
function mpd_editZipFile2Dir($dirname,&$dirstruct) {
	$ZIP_EXTENT='.zip';
	$ZIP_EXTENT_LEN=strlen($ZIP_EXTENT);

	$dirstruct=false;
	if(stripos($dirname,$ZIP_EXTENT) === false) {			// Extentionが含まれていなければ,そのまま返す
		return($dirname);
		}
	$del=0;
	$parts = explode('/',$dirname);	
	foreach($parts as $key => $part) {
	if ($ZIP_EXTENT_LEN > strlen($part)) { continue; }
		if(stripos($part,$ZIP_EXTENT,(strlen($part)-$ZIP_EXTENT_LEN)) !== false) {		// 分解したDirectoryにExtention(zip)があるとき以降を削除
			$dirstruct = pathinfo($part); 				 // Zip FileName部分をFaile構造体にセット
			$del=1;
			}
		if ($del==1) {
			unset($parts[$key]);						// Extention(zip)以降を削除
			}
		}
	 if ($del==0) {										//  Extentionが含まれていなければ,そのまま返す
		 $ret=$dirname;
		 }
	else {
		 $ret=implode("/",$parts);						// 削除後のDirectoryを復元
		 }
	return($ret);
	}

/*
	mpd_editCueFile2Dir($dirname,$dirstruct) : split Cue FIle Path To Directory
	 $dirname  : i  : Cue File PAth
	 $dirstruct: o  : Cue File部分の構造体  [dirname]:「.」 [basename] =>{FileBase}.Cue extension] => 「Cue」[filename] => {filename}
	 @return   : o  : Cue File Directory Not Found, $dirname
	※2022.07.09現在では,Zip形式と同等仕様としているが、形態が異なるので関数を分けておく
*/
function mpd_editCueFile2Dir($dirname,&$dirstruct) {
	$CUE_EXTENT='.cue';
	$CUE_EXTENT_LEN=strlen($CUE_EXTENT);

	$dirstruct=false;
	if(stripos($dirname,$CUE_EXTENT) === false) {			// Extentionが含まれていなければ,そのまま返す
		return($dirname);
		}
	$del=0;
	$parts = explode('/',$dirname);	
	foreach($parts as $key => $part) {
	if ($CUE_EXTENT_LEN > strlen($part)) { continue; }
		if(stripos($part,$CUE_EXTENT,(strlen($part)-$CUE_EXTENT_LEN)) !== false) {		// 分解したDirectoryにExtention(cue)があるとき以降を削除
			$dirstruct = pathinfo($part); 				 // Zip FileName部分をFaile構造体にセット
			$del=1;
			}
		if ($del==1) {
			unset($parts[$key]);						// Extention(cue)以降を削除
			}
		}
	 if ($del==0) {										//  Extentionが含まれていなければ,そのまま返す
		 $ret=$dirname;
		 }
	else {
		 $ret=implode("/",$parts);						// 削除後のDirectoryを復元
		 }
	return($ret);
	}

/*
	function mpd_editmusic : Edit Music Line
	  $output: io  : Output List Array
	                 Add:Codec Time/Date/Last-Modified:Edit Date/Time
	                 audio:sumpling/bit/ch bitrate:Edit(kbps)
	  $key   : i   : Edit Point Index
	  $field : i   : Edit Field
*/
function mpd_editmusic(&$output,$key,$field) {
	global $LIB_CONF;

	foreach($field as $fld) {
		if (($fld == "Codec") && (isset($output["file"][$key]))) {
			 $filepath = pathinfo($output["file"][$key]);
			 if (isset($filepath['extension'])) {
			 	  $output[$fld][$key]=$filepath['extension'];
				  }
			 else {
			 	  $output[$fld][$key]="";
				  }
			 }
		else if (($fld == "basename") && (isset($output["file"][$key]))) {
			 $filepath = pathinfo($output["file"][$key]);
			 $output[$fld][$key]=$filepath['basename'];
			 if (isset($filepath['extension'])) {
				  $output[$fld][$key]=str_replace(".".$filepath['extension'],"",$filepath['basename']);
				  }
			 else {
				  $output[$fld][$key]=$filepath['basename'];
				  }
			 }
		else if (($fld == "dirname") && (isset($output["file"][$key]))) {
			 $filepath = pathinfo($output["file"][$key]);
			 if (isset($filepath['dirname'])) {
			 	  $output[$fld][$key]=$filepath['dirname'];
				  }
			 else {
			 	  $output[$fld][$key]="";
				  }
			 }
		else if (!isset($output[$fld][$key])) {
			 continue;
			 }
		else if ($fld == "Time") {
			 $output["Sec"][$key]=$output[$fld][$key];
			 $output[$fld][$key]=edit_time($output[$fld][$key]);
			 }
		else if ($fld == "Date") {
			 $output[$fld][$key]=substr($output[$fld][$key],0,4);
			 }
		else if (($fld == "Track")&&($LIB_CONF["Track"]!=="")) {
			 $output["Track"][$key]=sprintf($LIB_CONF["Track"],$output["Track"][$key]);
			 }
		else if ($fld == "Last-Modified") {
			 $output[$fld][$key]=edit_date($output[$fld][$key]);
			 }
		msglog("[".$key."][".$fld."] ".$output[$fld][$key]);
		}
	}

/* -------------------------------------------------------------------------------
	array_column_extend($ary,$key,$index,$sindex,$append,$exist) : PHP array_column_extend (PHP5.5以下の保管も兼ねる)
	$ary   : i  : Input Array
	$key   : i  : Input Arrayの値: $key="":$aryのKey 指定時は2次元配列のKey
	$index : i  : 生成する配列の値とするKeyとする。省略付加。存在しない場合，作成しない
	$sindex: i  : 指定時サブKey。Key重複を避けるために使用することもできる。
	$append: i  : 同一キーのとき付加する固定値。"":時重複キーは作成されず最終値のみとなる。sprintf形式
	$exist : i  ; $key指定時，存在しないときの値。NULL時作成しない
	@return: o  : Output Array
	2次元配列まで対応
	$key:="":$aryのKey, !="":$aryの配下のKeyをkeyとして配列の値とする。
	例)
	$resary=array_column_extend($array,"val","time");
	$resary=array_column_extend($array,"","time","val","-%04d");
------------------------------------------------------------------------------- */
function array_column_extend($ary,$key="",$index,$sindex="",$append="_%04d",$exist=NULL) {
	$resary=array();
	$cnt=0;
	foreach($ary as $idx =>$ary) {
		$rval=$exist;$skey="";
		if($key=="") {
			$rval=$idx;
			}
		if(isset($ary[$key])) {
			$rval=$ary[$key];
			}
		if(($sindex !=="")&&(isset($ary[$sindex]))) {
			$skey=$ary[$sindex];
			}
		if((is_null($exist))&&(is_null($rval))) {
			continue;
			}
		if(isset($ary[$index])) {
			$rkey=$ary[$index];
		if($skey !=="") { $rkey=$rkey.$skey; }
			$str=sprintf($append,$cnt);
			$rkey=$rkey.$str;
			$resary[$rkey]=$rval;
			$cnt=$cnt+1;
			}
		}
	return($resary);
	}

/*
	function  msglog($msglog) : msglog
	 $msglog: i  : Message
*/
function msglog($msglog) {
	global $DEBUG;

	if ($DEBUG ==1 ) {
		print $msglog."<BR>";
		return; }
	if ($DEBUG !==2) {
		return; }

	$result=ini_get('display_errors');			// 現在のErrorモード
	ini_set('display_errors',0);				// Debug用なのでError抑制
	$debuglog     = "log/debug.log";
	$debuglogsize = 100000;
	$fp = fopen($debuglog, "a");
	$size = filesize($debuglog);
	if ($size > $debuglogsize) {
		@rename($debuglog,$debuglog.".old");
		$fp = fopen($this->filename, "w");
		}
	fwrite($fp,date("Y/m/d H:i:s")." ".$msglog."\n");
    fclose($fp);
	ini_set('display_errors',$result);				// Debug用なのでError抑制を戻す
	}

/*
	tblout($output) : Mpd Output 専用 TablePrint
	  $output: i  : Table
	  [TABLE1][IDX][TABLE2][IDX]....[TABLE1][IDX+1][TABLE2][IDX+1]
*/
function tblout($output) {
	if (!is_array($output)) {		// Out0件
		print "Output:0!!.<BR>";
		return;
		}
	$outkey=array_keys($output);
	foreach($output[$outkey[0]] as $i => $idx) {			// Album Sort Config
		foreach($output as $val => $array) {				// Album Sort Config
			if (isset($output[$val][$i])) {
				print "[".$i."][".$val."] |".$output[$val][$i]."|<BR>";
				}
			}
		}
	}

/*
	TblDump($Ary,$Tbl,$Add) : Table Dump
	  $Ary   : i  : Display Name
	  $Tbl   : i  : Dump Array
	  $Add   : i  : Recall Prefix
	  [TABLE1][IDX][][IDX+1]....[TABLE2][IDX][IDX+1]
*/
function TblDump($Ary,$Tbl,$Add="") {
	global $dsptbl;
	if ($Add=="") {$dsptbl=$Ary;}
	foreach($Tbl as $key => $val) {
		if (is_array($val)) {
			$Addsv=$Add;
			$Add.="[".$key."]";
			TblDump($Ary,$val,($Add));
			$Add=$Addsv;
			continue;
			}
		$str="";
		if ($Add != "") {
			$str=$Add;
			}
		print $Ary.' '.$str.'['.$key."]".$val."<BR>";
		}
	}
//----- Source End --------------------------------------------------------------
?>
