/*************************************************************************
	組込例)
	<!--
	<script type="text/javascript" src="./mpdweb.lib.sort.js"></script>
	var topbak=idTop;idTop=idLast;idLast=topbak;ArgTableSort(\'idlisttbl\',sortcell,cellno,sortrow,rowno,\'D\');
	-->

************************************************************************/
SORTJS_VERSION="mpdweb.lib.sort.js 0.90 (01.03.2024)";
/*************************************************************************
	ArgTableSort(TableId,StartRow,SortCell,DivNo,SortRow,RowNo,SortPara) : HTML Tabke Sort
	 TableId    : i  : Sort Table HTML-id
	 StartRow   : i  : Sort Table STart Row 開始行
	 SortCell   : i  : Sort Table Cell No  SortCellのNo.
	 DivNo      : i  : Sort Table Cell内のDiv番号 先頭[1] "",0:指定なし(cellそのままの値) セパレータ"/"で指定 Exp:"1/2/3"
	 SortRow    : i  : Sort Table Row No   SortCell 一連の行中の位置
	 RowNo      : i  : Sort Table Row      一連の行数
	 SortPara   : i  : Sort "A":Additional Else :Descending
	 ReqTagPurge: i  : td下にButtonなどのTagがあれば分解する(階層チェックはしない) 未指定:"0"
	 listexclude: i  : Sort Exclude String ソート除外の定冠詞を設定 デリミタ"," {string},{string},,, GSORTAaを反映する 未指定:"The "
	 LastRow    : i  : Sort対象の最終要素を指定(row=RowNo*StartRowとなる
	globalg SortNum =1:数値に見える列は数値でソート Call元で定義する。
	globalg GSORTAa =1:英大文字と小文字を区別しない Call元で定義する。
	未定義の場合.ArgTableSort()内で初期値(1)をセットする。

	※ https://webparts.cman.jp/table/sort/ 参考
	CMANさん HTMLのtableをExeclのようにソートする
*************************************************************************/
function ArgTableSort(TableId,StartRow,SortCell,DivNo,SortRow,RowNo,SortPara,ReqTagPurge,listexclude,LastRow) {
if(typeof GSORTNum === 'undefined') { GSORTNum = 1; }	// globalg GSORTNum=1:数値に見える列は数値でソート
if(typeof GSORTAa  === 'undefined') { GSORTAa  = 1; }	// globalg GSORTAa=1:英大文字と小文字を区別しない
GSORTEXEC = "";						// Exclude Stringの配列(ソート除外の定冠詞)
var SItemAry     = [];				// SortCellの配列
var SItemArySort = [];				// SortCellの配列（項目ソート後）
var TmpMoveRow   = [];				// 元の行位置（行削除考慮位置）
var FlgChar = 0;					// Cell判定: 1:数字でない

	if (listexclude == null) { } else { GSORTEXEC = listexclude.split(","); }	// Sort除外Word
	if (ReqTagPurge == null) { TagPurge=0; } else { TagPurge=ReqTagPurge; }		// DivNo指定(Div分解)なし時,1:Tag分解しValueを得る
	var strDivNo=""+DivNo;														// DivNo指定の分解 
	var indiv = strDivNo.split(/\//);
	if (indiv[0]=="0") { strDivNo=""; }											// 0.""は指定なし

	var SrtTblObj = document.getElementById(TableId);
	var wTR       = SrtTblObj.rows;

	if (LastRow !== null) {								// LastRow:SortLast行が指定されたとき
		var LastRowAry=[];n=0;
		for(var i=LastRow*RowNo+StartRow; i < wTR.length;i++){		// Last以降取得し復元用配列作成
			LastRowAry[n] = wTR[i];
			n++;
			}
		var lng=wTR.length;
		for(var i=LastRow*RowNo+StartRow; i < lng; i++){			// OrognalのLast以降を削除
			SrtTblObj.deleteRow(LastRow*RowNo+StartRow);			// 先頭になった行(Orignal)を削除
			}
		}

	for(var i=StartRow; i < wTR.length; i=i+RowNo){		//  クリックされたCellの値を取得しSort用配列作成
		var j = i - StartRow;
		result="";
		if (typeof wTR[i+SortRow].cells[SortCell] === "undefined") { continue }		// 例外)TableCellが見つからない! Argumentが正しければ,形式違いの配列がある
		if (strDivNo !== "") {								// DivNo指定
			 var tmp="";var sp="";
			 for(var x =0;x < strDivNo.length;x++) {
				if (indiv[x] == null) { continue }
				tmp = tmp+sp+ _ArgCellDivPurge(wTR[i+SortRow].cells[SortCell],indiv[x]);	// 各Div"/"で結合
				sp="/"
				}
			 SItemAry[j] = tmp;
			 }
		else if (TagPurge==1) {							// td下にButtonなどのTagがあれば分解する(階層チェックはしない)
			 SItemAry[j]=_ArgCellString(wTR[i+SortRow].cells[SortCell]);
			 }
		else {
			 SItemAry[j] = wTR[i+SortRow].cells[SortCell].innerText.toString();
		 	 }
		SItemAry[j]=_ArgSortExec(SItemAry[j]);				// 定冠詞編集
		if (SItemAry[j].match(/^[-]?[0-9,\.]+$/)){
 			}
		else{
			FlgChar = 1;
			}
		}
	SItemArySort = SItemAry.slice(0, SItemAry.length);		// ソート用に配列をコピー
	if(SortPara == 'A'){									// 列の値でソートを実行
	if((GSORTNum == 1)&&(FlgChar == 0)){
		 SItemArySort.sort(_ArgTableSortNumA);				// 数値で昇順
		 }
	else {
		 SItemArySort.sort(_ArgTableSortStrA);				// 文字で昇順
		 }
		 }
	else {
 		if((GSORTNum == 1)&&(FlgChar == 0)){
			SItemArySort.sort(_ArgTableSortNumD);			// 数値で降順
			}
		else{
			SItemArySort.sort(_ArgTableSortStrD);			// 文字で降順
			}
		}
	var ARYHIT = [];										// 同一値のチェック用
	for(var i=0; i < SItemArySort.length/RowNo;i++){		// 行の入れ替え順を取得
 		for(var j=0; j < SItemAry.length; j=j+RowNo){
			if(SItemArySort[i] == SItemAry[j]){				// ソート前後の列の値を比較して行の移動順を確定
			if (ARYHIT[j+StartRow]) { continue; }			// 同一値で出現済時はさらにSearch
//alert("SItemArySort["+i+"]"+SItemArySort[i]+"| SItemAry["+j+"]"+SItemAry[j]);
 				TmpMoveRow[i] = j + StartRow;
				ARYHIT[j+StartRow]=1;
 				break;
				}
			}
		}
//for(var i=0; i < TmpMoveRow.length;i++){		// 行の入れ替え順を取得
//	alert(TmpMoveRow[i]);
//	}

	var OrgLng=SrtTblObj.rows.length;					// Orignal行数を保存
	for(var i=0; i < TmpMoveRow.length; i++){			// ソート順に行を移動
		var TmpMoveTr = SrtTblObj.rows[TmpMoveRow[i]];				// 移動対象
		var TmpLastTr = SrtTblObj.rows[SrtTblObj.rows.length - 1];	// 最終行
 		TmpLastTr.parentNode.insertBefore(TmpMoveTr.cloneNode(true), TmpLastTr.nextSibling);		// 最終行にコピー
		for(var x=1; x < RowNo;x++){								// 行(一連の行)を移動
			var TmpMoveTr = SrtTblObj.rows[TmpMoveRow[i]+x];			// 移動対象(次行)
			var TmpLastTr = SrtTblObj.rows[SrtTblObj.rows.length - x];	// 最終行
	 		TmpLastTr.parentNode.insertBefore(TmpMoveTr.cloneNode(true), TmpLastTr.nextSibling);	// 最終行にコピー
			}
		}
	for(var i=StartRow; i < OrgLng; i++){							// Orognalを削除
		SrtTblObj.deleteRow(StartRow);								// 先頭になった行(Orignal)を削除
		}

	if (LastRow !== null) {								// LastRow:SortLast行が指定されたとき
		for(var i=0; i < LastRowAry.length; i++){						// 最終行に復元用配列を挿入し復元
			var TmpMoveTr = LastRowAry[i];
			var TmpLastTr = SrtTblObj.rows[SrtTblObj.rows.length - 1];	// 最終行に復元用配列を挿入し復元
		 		TmpLastTr.parentNode.insertBefore(TmpMoveTr.cloneNode(true), TmpLastTr.nextSibling);	// 最終行に挿入
			}
		}

	}

/*
	_ArgTableSortNumA(a,b) : Function Numeric Sort (Ascending)
*/
function _ArgTableSortNumA(a,b) {
	a = parseInt(a.replace(/,/g, ''));
	b = parseInt(b.replace(/,/g, ''));
	return a - b;
	}

/*
	_ArgTableSortNumD(a,b) : Function Numeric Sort (desending)
*/
function _ArgTableSortNumD(a,b) {
	a = parseInt(a.replace(/,/g, ''));
	b = parseInt(b.replace(/,/g, ''));
	return b - a;
	}

/*
	_ArgTableSortStrA(a,b) : Function Alphabet Sort (Ascending)
*/
function _ArgTableSortStrA(a,b){
	a = a.toString();
	b = b.toString();
	if (GSORTAa == 1){			// global GSORTAa=1:英大文字小文字を区別しない
		a = a.toLowerCase();
		b = b.toLowerCase();
		}
	if (a < b){ return -1; }
	else if(a > b){ return  1; }
	return 0;
	}

/*
	_ArgTableSortStrD(a, b) : Function Alphabet Sort (desending)
*/
function _ArgTableSortStrD(a,b){
	a = a.toString();
	b = b.toString();
	if (GSORTAa == 1){			// global GSORTAa=1:英大文字小文字を区別しない
		a = a.toLowerCase();
		b = b.toLowerCase();
		}
   if (b < a){ return -1; }
	else if(b > a){ return  1; }
	return 0;
	}

/*
	_ArgSortExec(str) : 設定のGSORTEXEC配列(定冠詞)を削除　
	 str    : i  : String
	 @return: o  : 置換後String
	Grobal : GSORTEXEC : Sort Exclude String ソート除外の定冠詞を設定 デリミタ"," {string},{string},,,
    GSORTAaを反映する
*/
function _ArgSortExec(str) {
	str=str.replace(/^\s+/,'');	
	for(var i=0;i < GSORTEXEC.length;i++){
		if (GSORTAa == 1){			// global GSORTAa=1:英大文字小文字を区別しない
			 var a = GSORTEXEC[i].toLowerCase();
			 var b = str.toLowerCase();
			 str=b.replace(a,"");
			 }
		else {
			 str=str.replace(GSORTEXEC[i],"");
			 }
		}
	return(str);
	}

/*
	_ArgCellDivPurge(obj,i) : HTML-Object div Purge
	obj     : i  : HTML Object
	i       : i  : 有効Point ,  0:cellとして<div 先頭を1とする 複数</divの位置を設定
	@return : o  : Found:string , notFound : null
*/
function _ArgCellDivPurge(obj,i) {
	var result=null;
	var pnt=i-1;
	var str=obj.innerHTML.match(/<div(.*?)(<\/div>)/gi);
	if ((str)&&(str.length > pnt)) {
		var res=str[pnt].split(/>(.*?)(<\/div>)/gi);
		result="";
		if ((res)&&(res.length > 1)) {
			result=res[1];
//alert(result);
			}
		}
	return(result);
	}

/*
	_ArgCellString(obj) : HTML-Object  Purge
	obj     : i  : HTML Object
	@return : o  : Found:string , notFound : null
	※Get Value<td><button>{Value}</button></td>
*/
function _ArgCellString(obj) {
//alert(obj.innerHTML);
	var result=obj.innerHTML.split(/>(.*?)(<\/)/gi);
	if ((result)&&(result.length > 1)) {
		result=result[1];
		 }
	else {
		 result=obj.innerText.toString();
		 }
	return(result);
	}

/* -----------------------------------------------------------------------
	ArgTableIdSearch(TableId,cellno,cellrow,rows,startrow,mode) : HTML Table Id search Start/End
	TableId : i  : HTML Table Id
	cellno  : i  : id Cell位置  多レイアウトで複数チェックする場合 セパレータ"/"で指定 Exp:"3/2/1"
	cellrow : i  : id Cell 一単位の行位置位置(row) (先頭:0から)
	rows    : i  : 1単位行数
	startrow: i  : 先頭行位置 タイトル1行 1 タイトルなし:0
	mode    : i  : 省略(null) "": Get Start/Last id , "s":Start id "e":Last id
	@return : o  : [0]:Start id [1]:End id , None:[0]/[1]:null
	※cellno:複数指定は,形式をチェックしないので不用意には使用できない
----------------------------------------------------------------------- */
function ArgTableIdSearch(TableId,cellno,cellrow,rows,startrow,mode) {
	if (startrow == null) { startrow = 0 }
	if (mode==null) { mode=""; }
	var strCell=""+cellno;														// DivNo指定の分解 
	var inCell = strCell.split(/\//);
	id=[];var startid=null;var lastid=null;
	var tmptb=document.getElementById(TableId);
	var tblrows=tmptb.rows;
	if (tblrows) {
		if ((mode=="")||(mode=="s")) {
			for(var i=0;i<inCell.length;i++) {							// Get Start id
				var cell=inCell[i];
				if (tblrows[startrow+cellrow].cells[cell]) {
					startid=ArgHTMLIdPurge(tblrows[startrow+cellrow].cells[cell]);
					if (startid !== null) { break; }
					}
				}
//alert("startid["+startid+"]");
			}
		if ((mode=="")||(mode=="e")) {
			for(var i=0;i<inCell.length;i++) {							// Get Last id
				var cell=inCell[i];
				var lastrow=(tmptb.rows.length-1)-(rows-1+cellrow);		// 最終行:1単位の位置を求める
				if (tblrows[lastrow]) {
					lastid=ArgHTMLIdPurge(tblrows[lastrow].cells[cell]);
					if (lastid !== null) { break; }
					}
				}
//alert("lastid["+lastid+"]");
			}
		}
	id[0]=startid;
	id[1]=lastid;
	return(id);
	}

/* -----------------------------------------------------------------------
	ArgHTMLIdPurge(obj) : HTML-Object id Purge
	obj     : i  : HTML Object idの後ろはSpaceが必須 id="{id}" , id={id}(space)
	@return : o  : Found:id , notFound : null
----------------------------------------------------------------------- */
function ArgHTMLIdPurge(obj) {
	var result=null;
	var id=obj.innerHTML.match(/id="(.*?)(")/i);
	if ((id)&&(id.length > 0)) {
		 result=id[1];
		 }
	else {
		 var id=obj.innerHTML.match(/id=(.*?) /i);
		 if ((id)&&(id.length > 0)) {
		 	result=id[1];
		 	}
		 }
	return(result);
	}

/*************************************************************************
    ArgTableSortByTr(tableId,cssPosition,divPosition,SortPara,listexclude) : Table Sort
	 tableId     : i  : Sort Table HTML-id
	 cssPosition : i  : !=="":CSS Classで指定 "{.#}{Class}" divPositionは使用しない "":divPositionを使用する
	 divPosition : i  : Sort Table td DivのNo. 0～
	 SortPara    : i  : Sort "A":Additional Else :Descending
	 listexclude : i  : Sort Exclude String ソート除外の定冠詞を設定 デリミタ"," {string},{string},,, GSORTAaを反映する 未指定:"The "

	 globalg GSORTAa =1:英大文字と小文字を区別しない Call元で定義する。
				       未定義の場合.ArgTableSort()内で初期値(1)をセットする。

	<table>Sort :  Div位置を使用し定冠詞を適用しSort
	Ex:
	 CSSで指定時
	   ArgTableSortByTr('grpAlbum','.AlbmTex',0)                
	   ArgTableSortByTr('grpAlbum','.AlbmTex',0, 'A','The ,A ')
	   ArgTableSortByTr('grpAlbum','.AlbmTex',0, 'D','The ,A ')
	※cssPosition:ArtText部 : '.AlbmTex'
     Divの深さで指定時
	   ArgTableSortByTr('grpAlbum','',1, 'A');
	   ArgTableSortByTr('grpAlbum','' 1, 'A',  "The ,A ");
	   ArgTableSortByTr('grpAlbum','' 1, 'D',  "The ,A ");
	※divIndex:[0]: Date
               [1]: Album
	divPositionで指定時の数え方のイメージ
	<td>
	 divPosition
	 [0]     <div id="idA18" class="AlbmArt" style="width:155.33333333333;height:155.33333333333;">
	 [0][1]    <div onclick="JumpFind('BALLADS')">
			     <img id="idimg18">
	 [0][1][1]   <div class="ArtIfOpi" >2009</div> [0]:でSort ([0]の先頭になる)(Date)
	 [0][1][2]   <div class="ArtIfOpi" >flac</div>
	 [0][1][3]   <div class="ArtIfOpi" >Rock</div>
	 [0][1][4]   <div onclick="flgArtB=1;PostPlAdd(AddPlay,'find,f1=AlbumArtist:B64:RXJpYyBDbGFwdG9u'" class="ArtIfOpt">Play </div>
	           </div>
             </div>
	 [1]     <div style="position:relative;top:3px;"><p class="ellipsis AlbmTex">BALLADS</p></div> : [1]でSort(Album)
     [2]     <div class="artpd" style="margin:-35px 0px 0px 0px;">
	※ChatGPTの<Table>Sortをともに改良
*************************************************************************/
//GSORTAa =1;		// global : 英大文字と小文字を区別しない Call元で定義する。
/* 環境で設定する現環境では Linux,ブラウザでUTF-8設定を前提としている [GSORT_MODE=0で使用] 従って、Config設定では行わない */
GSORT_MODE=0;		// 環境で設定する。 0:Text比較(現環境UTF-8)，1:ブラウザ実装,Linux locale異なる場合(Japanese). 2:1版の他言語
function ArgTableSortByTr(tableId,cssPosition,divPosition,SortPara,listexclude) {

	if(typeof GSORTAa  === 'undefined') { GSORTAa  = 1; }		// globalg GSORTAa=1:英大文字と小文字を区別しない
	if (listexclude == null) { } else { var excludedArticles = listexclude.split(","); }	// Sort除外Word
	if (SortPara=='A') { var sortOrder='asc'; } else { var sortOrder='desc'; }

	var table = document.getElementById(tableId);
	var tdElements = table.getElementsByTagName('td');
	var tdArray = Array.from(tdElements);
	tdArray.sort(function(a, b) {
		if (cssPosition !=="") {
			 var textA = a.querySelector(cssPosition).textContent.trim();
			 var textB = b.querySelector(cssPosition).textContent.trim();
			 }
		else {
			 var textA = a.children[divPosition].textContent.trim();
			 var textB = b.children[divPosition].textContent.trim();
			 }
		if (excludedArticles && Array.isArray(excludedArticles) && excludedArticles.length > 0) {	// 定冠詞を除外する処理
			excludedArticles.forEach(function(article) {
			if (GSORTAa ==1) {									// 英大文字と小文字を区別しないため小文字に揃える
				textA=textA.toLowerCase();
				textB=textB.toLowerCase();
				article=article.toLowerCase();
				}
			if (textA.startsWith(article)) {					// textA:定冠詞を除外する処理
				textA = textA.substring(article.length).trim();
				}
			if (textB.startsWith(article)) {					// textA:定冠詞を除外する処理
				textB = textB.substring(article.length).trim();
				}
			});
		}
		if(GSORT_MODE==1) {		// 現環境では GSORT_MODE:0 テキストでの比較Sort
		     return sortOrder === 'desc' ? compareJapaneseStrings(textB, textA) : compareJapaneseStrings(textA, textB);		// locale:Japanese比較Sort
			 }
		else if(GSORT_MODE==2) {
		     return sortOrder === 'desc' ? compareOtherStrings(textB, textA) : compareOtherStrings(textA, textB);			// locale:Other
			 }
		else {		// 現環境では GSORT_MODE:0
		     return sortOrder === 'desc' ? compareStrings(textB, textA) : compareStrings(textA, textB);		// Text比較Sort
			 }
		});

	var table = document.getElementById(tableId);				// テーブル要素を取得
	var firstRow = table.rows[0]; // 最初の行を取得
	var tdCount = firstRow.getElementsByTagName("td").length;	// <td> 要素の数をカウント

	var tbody = table.getElementsByTagName("tbody")[0];			// 既存のtbody内の要素を削除
	while (tbody.firstChild) {
		tbody.removeChild(tbody.firstChild);
		}

	for (var i = 0; i < tdArray.length; i += tdCount ) {		// ソート済みのセルデータでテーブルを再構築
		var row = document.createElement("tr");
		for (var j = i; j < i + tdCount  && j < tdArray.length; j++) {
			var cell = document.createElement("td");
			cell.innerHTML = tdArray[j].innerHTML;				// 元の文言を表示するためにinnerTextを使用
			row.appendChild(cell);
			}
		tbody.appendChild(row);
		}
	}
	
/*
	compareStrings(a, b) : テキストとして比較(Using Sort)
	a      :i   : string  , b: :i   : string 比較文字列
	return : a < b:-1 , (a > b);1 ,(a = b);0
*/
function compareStrings(a, b) {
    if (a < b) return -1;
    if (a > b) return 1;
    return 0;
	}

/*
	compareJapaneseStrings(a, b) : ブラウザ実装,Linux locale異なる場合(locale:Japanese)比較(Using Sort)
	a      :i   : string  , b: :i   : string 比較文字列
	return : a < b:-1 , (a > b);1 ,(a = b);0
*/
function compareJapaneseStrings(a, b) {
    return a.localeCompare(b, 'ja', { sensitivity: 'variant' });
	}

/*
	compareOtherStrings(a, b) : ブラウザ実装,Linux locale異なる場合(locale:その他の言語)比較(Using Sort)
	a      :i   : string  , b: :i   : string 比較文字列
	return : a < b:-1 , (a > b);1 ,(a = b);0
*/
function compareOtherStrings(a, b) {
    return a.localeCompare(b);
	}
/* ------------- End of Source --------------------------------------------------------*/
