<?php
/* *****************************************************************************
	mpd Application Library mpd{module}.lib_appli.php
    ---------------------------------------------------------
  	  ArgEncode()           : String Encode Request
	  ArgDecode()           : String Decode Request
	  ArgViewport()         : Make Viewport form xmlconfig
	  ArgVendorPrefix()     : Make VendorPrefix form xmlconfig
	  ArgHTMLEncode()       : HTML HTML簡略変換
	  ArgXML2HTMLStr()      : Make XML To HTML Convert
	  ArgErrorEdit()        : PHP Error Edit
	  GetAlterConfig()      : Alternative Section : XMLパラメータ設定
	  _GetAlterConfigAry()  : Make XML File Array
	  GetAlterViewpor()     : Get Alternative Viewport Setting
	  GetAlterVendorPrefix(): Get Alternative VendorPrefix Setting
	  MakeSelectBox()       : Make Select Box
	  DispSureBox()         : Display Sure Box
	  DispMsgBox()          : Display Message Box

	 ※機能縮小/拡張:共通化していないケース
	  ArgImageSize                  : mpdartlist.php(拡張): イメージサイズ編集(サムネイル)
	  GetEnvAddFunc/GetEnvAddFuncSet: mpdweb.php (拡張)   : Function Addシリーズ
	  I/Fは極力合わせてあるので支援関数は使用できる。
	 mpdweb.phpシリーズ 他の同名関数は機能が類似であり,名称を覚える手間よりデバックを考慮。
***************************************************************************** */
/* ----------------------------------------------------------------------------
	AJAX MakeSelectBox() Postで使用時 Post側で起動しこのLibraryで実行し完了(使用方法がトリッキー)
	MakeSelectBox() : Make Select Box Post:mpdweb.libcajax.js/RequestByPostいずれかでAJAXを行う
	※Post/mpdweb.lib.php , mpdweb.lib_mpd.php/mpdweb.lib_mpdshm.phpを引用していること。
----------------------------------------------------------------------------- */
if ((isset($_POST['p']))&&($_POST['p'] == "selectbox")) {
	if (isset($_POST['host'])) { $host=ArgDecode($_POST['host']); }
	if (isset($_POST['port'])) { $port=ArgDecode($_POST['port']); }
	if (isset($_POST['timeout'])) { $timeout=ArgDecode($_POST['timeout']); }
	$Net = new Net_Common;
	$Net->p_connect['host']=$host;
	$Net->p_connect['port']=$port;
	$Net->p_connect['timeout']=$timeout;
	if (isset($_POST['pass'])) { $Net->p_connect['password']=ArgDecode($_POST['pass']); }
	if (!$Net->connect()) {
		exit;
		}
	$ret=PostSelectbox($_POST["para"]);
	exit;
	}


/* ----------------------------------------------------------------------------
	lib_version()
	@return : o  : Version
----------------------------------------------------------------------------- */
function apl_version() {
	$LIB_VERSION=basename(__FILE__)." 1.44 (30.11.2024)";
	return($LIB_VERSION);
	}

/* -----------------------------------------------------------------------------
	ArgEncode($str,$method) : String Encode Request
	 $str   : i  : before Encode Req.String
	 $method: i  : Encode Method Hex Or B64
	 @return: After Encode String
----------------------------------------------------------------------------- */
function ArgEncode($str,$method="B64") {
	if ($method == "Hex") {
		 $enc=bin2hex($str);		// 文字列の文字種が多いためURLをHex変換して連携
		 }
	else if ($method == "B64") {	// 文字列を短くするためURLをBase64変換して連携
		 $base64 = base64_encode($str);
		 $enc=str_replace(array('+', '/', '='),array('_', '-', '.'),$base64);
		 }
	else {
		 return($str);
		 }
	$enc=$method.":".$enc;		// Hex Encode のマークをする
	return($enc);
	}

/* -----------------------------------------------------------------------------
	ArgDecode($strx) : String Decode Request
	 $str : i  : before Decode Req.String
	             Encode Method String  "Hex:" Or "B64:"
	 @return   : After Decode String
----------------------------------------------------------------------------- */
function ArgDecode($strx) {
	$str = explode(':', $strx, 2);
	if ((!isset($str[0]))||(!isset($str[1]))) { // Hex EncodeのマークがなければそのままReturn
		return($strx);
		}
	if ($str[0] == "B64") {				// Base64変換
		$str[1] = str_replace(array('_','-', '.'),array('+', '/', '='),$str[1]);
		$dec=base64_decode($str[1]);
		return($dec);
		}
	if ($str[0] == "Hex") {				// Hex変換
		if (!ctype_xdigit($str[1])) {	// 文字列がHexでなければそのままReturn ($metho追加時テストできるように形式が合わなければRetrun)
			return($strx);
			}
		$str_hex=pack("H*", $str[1]);	// Hex変換を復元する hex2bin PHP Ver5.5からなので代わり
		return($str_hex);
		}
	return($strx);						// 文字列が形式不明ならそのままReturn
	}

/* -----------------------------------------------------------------------------
	ArgHTMLEncode($str) : HTML HTML簡略変換
	 $str : i  : before Encode Req.String
	 @return   : After Encode String
	 簡単な変換とした
----------------------------------------------------------------------------- */
function ArgHTMLEncode($str) {
	$htm_char=array('&',     '"',     "'",     '<',   '>');			// URL Char
	$rep_char=array('&amp;', '&quot;','&apos;','&lt;','&gt;');		// URL Replace
	$ret = str_replace($htm_char,$rep_char,$str);
	return($ret);
	}

/* -----------------------------------------------------------------------------
	ArgViewport($XML_CONF,$count) : Make Viewport form xmlconfig
	 $XML_CONF : i  : xmlconfig
	 $count    : io : 対象が見つからない場合,比較件数("viewport_{word}"の件数)
	 @return   : o  : meta viewport
	 config["Html_config"]<Viewport_{AGENT}>からHTTP_USER_AGENTの一部と{AGENT}が一致する設定を採用
----------------------------------------------------------------------------- */
function ArgViewport($XML_CONF,&$count) {
	$html_viewport="";$count=0;												// Viewport初期値
	if (is_object($XML_CONF)) { $XML = get_object_vars($XML_CONF); } else { $XML = []; } // $XML_CONFがnullの場合のデフォルト値
	if (isset($_SERVER['HTTP_USER_AGENT'])) {
		if (isset($XML["Html_config"])) {
			foreach($XML["Html_config"]  as $key=> $part) {					// XML定義 <Viewport_{AGENT Parts String}>
				$keypt = explode('_',$key, 2);
				if ((stripos($keypt[0],"viewport") !== false)&&(isset($keypt[1]))) {
					$count=$count+1;
					$keypt[1]=str_replace("_","&",$keypt[1]);										// XML定義 {AGENT Parts String}の"_"をSpaceを扱うようにするため"_"を"&"に変更
					$str=str_replace(array(" ","_"),array("&","&"),$_SERVER['HTTP_USER_AGENT']);	// AGENT " ","_" "&"に変更して比較(" ","_"の区別はしなくなるが)
					if (stripos($str,$keypt[1]) !== false) {							// USER_AGENT中に{AGENT Parts String}(Viewport_以下)があれば使用する
						$html_viewport=$part;
						break;
						}
					}
				}
			}
		}
	return($html_viewport);
	}
/*
	ArgVendorPrefix($XML_CONF,$ua_phone,&$count) : Make VendorPrefix form xmlconfig
	 $XML_CONF : i  : xmlconfig
	 $ua_phone : i  : phone判定の文字列","で区切る Ex:iPhone,iPod,Android : <php_config><ua_phone>をセット 
	 $count    : io : 対象が見つからない場合,比較件数(VendorPrefix設定数)

	 global $REQ_UA:PC|Phone $REQ_VENDOR:IE|Chromeなど , $REQ_BROWSER:User任意 ,$REQ_PREFIX;:-ms-|-webkit-などを生成
*/
function ArgVendorPrefix($XML_CONF,$ua_phone,&$count) {
	global $REQ_UA,$REQ_VENDOR,$REQ_BROWSER,$REQ_PREFIX;	// $REQ_UA:PC|Phone , $REQ_VENDOR:IE|Chromeなど,$REQ_BROWSER;User任意,$REQ_PREFIX:-ms-|-webkit-など

	$count=0;												// Counter初期値
	$XML = get_object_vars($XML_CONF);
	$arr_ua = explode(',',$ua_phone);
	$ua=$_SERVER['HTTP_USER_AGENT'];
	$REQ_UA='PC';
	foreach($arr_ua as $key=> $part) {
		if (strpos($ua,$part)!==false) {
			$REQ_UA='Phone';
			break;
			}
		}
	if (isset($XML["VendorPrefix"])) {						// Request Vendorを検索する
		 $vendary=get_xml_attri_array($XML["VendorPrefix"]);		// VendorPrefix:XMLを属性を含め展開
		 }
	else {
		$vendary= array(
			'Tag'=>array(0=>'IE',1=>'IE11',2=>'Edge',3=>'Chrome',4=>'Firefox',5=>'Safari',6=>'Opera',7=>'Other'),
			'Att'=>array(0=>array('Prefix'=>'-ms-','Vendor'=>'IE'),1=>array('Prefix'=>'-ms-','Vendor'=>'IE'),2=>array('Prefix'=>'-webkit-','Vendor'=>'Edge'),3=>array('Prefix'=>'-webkit-','Vendor'=>'Chrome'),4=>array('Prefix'=>'-moz-','Vendor'=>'Firefox'),5=>array('Prefix'=>'-webkit-','Vendor'=>'Safari'),6=>array('Prefix'=>'-o-','Vendor'=>'Opera'),7=>array('Prefix'=>'','Vendor'=>'Other')),
			'Val'=> array(0=>'MSIE',1=>'Trident',2=>'Edge',3=>'Chrome',4=>'Firefox',5=>'Safari',6=>'OPR',  7=>'')
			);
		}
	$REQ_VENDOR="Other";$REQ_BROWSER="Other";$REQ_PREFIX="";
	foreach ($vendary['Tag'] as $key=> $browser) {
		if ((!isset($vendary['Att'][$key]['Vendor']))||($vendary['Att'][$key]['Vendor']=="")) { continue; }		// Aribute:'Vendor'がない。形式が異なる
//print '$browser['.$browser.'] Vendor['.$vendary['Att'][$key]['Vendor'].'] Prefix['.$vendary['Att'][$key]['Prefix'].'] Val['.(string)$vendary['Val'][$key].']<BR>';
	$count=$count+1;
		
		if ((!isset($vendary['Att'][$key]['Vendor']))||($vendary['Att'][$key]['Vendor']=="")) {  continue; }
		if ($vendary['Att'][$key]['Vendor']=='Other') { $REQ_BROWSER=(string)$browser;continue; }
		if ((!isset($vendary['Val'][$key]))||($vendary['Val'][$key]=="")) {  continue; }
		if ((!isset($vendary['Att'][$key]['Prefix']))||($vendary['Att'][$key]['Prefix']=="")) {  continue; }
		if (strstr($_SERVER['HTTP_USER_AGENT'],(string)$vendary['Val'][$key])) {
			$REQ_BROWSER=(string)$browser;
			$REQ_VENDOR=(string)$vendary['Att'][$key]['Vendor'];
			$REQ_PREFIX=(string)$vendary['Att'][$key]['Prefix'];
			break;
			}
		}

	}
/* -----------------------------------------------------------------------------
	ArgXML2HTMLStr($xmlsec,$sel,$fldary,$selif,$change) : Make XML To HTML Convert
	 $xmlsec   : i  : XMLセレクトSectionTag
	 $sel      : i  : XMLセレクトTag Array 配列形式:$sel=array("{文字列}"=>{"0"/"1"}):0:完全一致/1:指定文字列を含む前方一致
	 $fldary   : io : Function compact : Item Array 結果もReturnする
	 $change   : i  : Replace Array 形式 $change[変更前]=>{変更後}
	 $selifinit: i  : Select条件などの初期処理(初期値が必要なときなど:evalで実行)
	 $selif    : i  : Select条件を配列で指定 evalで実行するため if成立 :return true; / if非成立:return false;と設定する
	 @return   : o  : 標準出力用HTML (-1:Tagが未設定時)
 ----------------------------------------------------------------------------- */
function ArgXML2HTMLStr($xmlsec,$sel,&$fldary,$change="",$selifinit="",$selif="") {
	global $XML_CONF,$XML,$REQ_EVAL_INHBIT;						// XML設定
	global $REQ_UA,$REQ_VENDOR,$REQ_BROWSER,$REQ_PREFIX;		// XML設定<VendorPrefix>参照:$REQ_UA:PC|Phone , $REQ_VENDOR:IE|Chromeなど,$REQ_BROWSER;User任意,$REQ_PREFIX:-ms-|-webkit-など

	if (!isset($REQ_EVAL_INHBIT)) { $REQ_EVAL_INHBIT=0; }
	if(is_array($fldary)) { extract($fldary,EXTR_OVERWRITE); }	// EXTR_OVERWRITE: 既に同名の変数が存在する場合上書き
	$out="2";$attri=array();$rep=array("\t"=>"","\n"=>"");
	$ret=get_xml_String($XML_CONF,$xmlsec,$sel,$out,$rep,1,$attri);
	if ((!is_array($ret))&&($ret==-1)) { return(-1); }
//if (is_null($attri)) { } else { print_r($attri); }
// 属性の示す項目に値を設定する。
	$ret_ng=array();					// []: 1:NG(対象外) 0:対象
	if ($selifinit !=="") { eval($selifinit); }				// 呼び元指定の初期
	if ((is_array($attri))&&(isset($attri["Att"]))) {
		foreach($attri["Att"] as $i => $at_itm) {
			$ret_ng[$i]=0;
			if (is_array($selif)) {		// 呼び出し元からの属性セレクト条件
				foreach($selif as $if) {
					if (eval($if)) { } else { $ret_ng[$i]=1;break; }	// Not,Select時,$ret_ng[]=1
					}
				if ($ret_ng[$i] == 1) { continue; }
				}
			foreach($at_itm as $key => $at) {							// 属性を無名変数で項目値を設定	
				$val=$attri["Val"][$i][$key];							//   属性値を取得
				$atname=$at;											//   属性名を項目に設定
				${$atname}=$val;										//     無名変数を活用し属性項目に値を設定
				}
			}
		}
// print '$wdef['.$wdef.']<BR>';	// 属性のダンプ方法
// Source中の変数をListUp
	if (is_array($ret)) {
		 $htmlsrc=array();$htmldic=array();$i=0;			// $htmlsrc:発生順にHTMLを作成(重複Tagは後優先) / $html_dic[Tag]=index
		 foreach($ret as $key => $val) {
			if ((isset($ret_ng[$key]))&&($ret_ng[$key]==1)) { continue; }				// 属性設定で対象外となった
			if (isset($htmldic[$attri["Tag"][$key]])) {		// 同一TagはOverWrite($html_dicにTagが設定されていれば,示す値で,$htmlsrcをOverWrite)
				 $htmlsrc[$htmldic[$attri["Tag"][$key]]]=$val;
				 continue; }
			else {											// 同一Tagがなければ,$htmldic[Tag]追加,$htmlsrc[$i]に追加
				 $htmldic[$attri["Tag"][$key]]=$i;
				 $htmlsrc[$i]=$val;
		 		 }
			$i=$i+1;
			}
//print '$htmlsrc:';print_r($htmlsrc);print '<BR>';print '$htmldic:';print_r($htmldic);print '<BR>';
		 $str = implode("",$htmlsrc);		// 配列を結合
		 }
	else {
		 $str = $ret;
		 }
//print "\nString in:".$str."<BR>\n";
	$result = preg_match_all('/<\?php(.*?)\?>/si',$str,$part,PREG_SET_ORDER);				// 正規表現:<{Item}>を検出 $part[n][0]:{Item} [1]:Value
	$phpstr="";
	foreach($part as $key => $par) {		// PHP String $part[n][1]
		$str=str_replace($par[0],"",$str);
		$phpstr=$phpstr.(trim($par[1]));
		}
	eval($phpstr);						// PHP実行(Error追跡のため1定義ごと)
	if (error_get_last()) {
		if ($REQ_EVAL_INHBIT == 0) { ArgErrorEdit("ArgXML2HTMLStr","eval()","<BR><BR><BR><BR><BR>"); }
		}
	if (is_array($change)) {			// 引数のreplace
		$change_key = array_keys($change);
		$str=str_replace($change_key,$change,$str);
		}
// ヒアドキュメント風replace
	$result = preg_match_all('/{\$(.*?)}/s',$str,$part,PREG_SET_ORDER);				// 正規表現:<{Item}>を検出 $part[n][0]:{Item} [1]:Value
	$i=0;$rp_src=array();$rp_des=array();$invary="";	// $rp_src:Replase Source ,$rp_des:Replase Valu ,$invary:項目がない場合に設定
	foreach($part as $pky => $pary) {
//print "[".$pky."] 0:Def[".$pary[0]."] 1:Item[".$pary[1]."]<BR>";
		$rp_src[$i]=$pary[0];
		$atname=$pary[1];
		if (isset(${$atname})) { $rp_des[$i]=${$atname}; }
		else {
			 $invary['$'.$atname]="No Find Item";
			 $rp_des[$i]=""; }
		$i=$i+1;
		}
	if (is_array($invary)) {
		$ary = array_keys($invary);print '<BR><BR><BR><BR><BR><div style="color:pink">XML:Invalid Item : '.(implode(",",$ary)).'</div>';
		}
//print_r($rp_src);print_r($rp_des);
	$str=str_replace($rp_src,$rp_des,$str);				// Replace配列で置換
// <Load Tag時はURL実行設定:URLをLoadし同行を置換する
	$result = preg_match_all('/<Load(.*?)>(.*?)<\/Load>/si',$str,$part,PREG_SET_ORDER);				// <Load a="b">{URL}</Load>を検出
	foreach($part as $key => $par) {					// <Load Stingを実行
		$htmlpart="";
		$htmlpart = @file_get_contents($par[2]);			// URLを実行する [0]:<Load a="b">{URL}</Load> [2]:{URL}
		$str=str_replace($par[0],$htmlpart,$str);		// Replace配列で置換
		}
	if(is_array($fldary)) {						// 変数を呼び元に返す(変更されていた場合最新化)
		$fieldkey=array_keys($fldary);
		$fldary = compact($fieldkey);
		}
	return($str);
	}

/* -----------------------------------------------------------------------------
	ArgErrorEdit($func,$addstr) : String Decode Request
	 $func   : i  : Error検出関数ルーチン
	 $f      : i  : Error検出関数
	 $addstr : i  : メッセージに追加キャラクタ
----------------------------------------------------------------------------- */
function ArgErrorEdit($func,$f,$addstr="") {
	$EXCL='file_get_contents';			// file_get_contentsはErrorHandolしてもメッセージが消えない

	$erstr="";
	if (is_array(error_get_last())) { foreach ((array)error_get_last() as $e) { $erstr.= $e." "; } } else { $erstr.=error_get_last(); };
	if(stripos($erstr,$EXCL) === false) {						// 大小文字区別なし
		print $addstr.'<div style="color:pink">'.$func.' :'.$f.':PHP Error :';
		print $erstr;
		print '</div>';
		}
	}

/* -----------------------------------------------------------------------------
	GetAlterConfig($section,$item) : Alternative Section : XMLパラメータ設定
	 $section: i   : Section Tag
	 $item 	 : io  : パラメータ取得項目配列 (形式:Array[key:item]->"value":) 配列でなければ,取得しない
	 @return : o   : SetStatus
	                 $setsts["No"]       : セット件数
	                 $setsts["AltNo"]    : Alternativeセット件数
	                 $setsts["AltXml"]   : Alternative XML;
	                 $setsts["altsecton"]: Alternative TagSection
	                 $setsts["error"]    : XML Get Error
	※ $XML_CONF; Config XML Data
----------------------------------------------------------------------------- */
function GetAlterConfig($section,&$item) {
	global $XML_CONF,$XML_CONF_ARY,$STS_MESSAGE;				// $XML_CONF_ARY[{XML FilenName}]=XML_CONF:XMLFile

	$altsec=array("AlterSection"=>"");
	get_config($section,$altsec);	// php config
	$xmlset[0]="";$xmlset[1]="";$altno=0;$no=0;$error="";
	if($altsec["AlterSection"]!=="") {
		$result = preg_match_all('/{(.*?)}/s',$altsec["AlterSection"],$part,PREG_SET_ORDER);	// Result:正規表現:<{}>を検出 $part[n][0]:{Item} [1]:Value
		if (isset($part[0][1])) {
			$xml_sect=_GetAlterConfigAry($part[0][1],$section,$error);					// Hostが他のXMLにLinkされているときGet:$XML_CONF_ARY[XML_Path]
			if ($xml_sect ===false) {						// AlternativeからのXMLFileがない場合も正常と見なし続行
				 $xml_sect="";
				 }
			}
		if($xml_sect!=="") {								// Alternativeがセットされているケース
			$xmlset=explode(":",$xml_sect,2);				// $xmlset[0]:XML File [1]:XML File,TagSection
			$sv_xml_conf=$XML_CONF;							// XML globalを保存し終了時戻す(CommonLibを使用するための対処)
			if (is_array($item)) {
				$XML_CONF=$XML_CONF_ARY[$xmlset[0]];			// GetAlterConfigAry[XMLFile]を使用する。
				$altno=get_config($xmlset[1],$item);			// php config
				$XML_CONF=$sv_xml_conf;							// XML globalを戻す
				}
			}
		}
	if (is_array($item)) {
		$no=get_config($section,$item);							// php config
		}
	if (($STS_MESSAGE=="")&&($error!=="")) { $STS_MESSAGE=$error; }
	$setsts["No"]=$no;
	$setsts["AltNo"]=$altno;
	$setsts["AltXml"]=$xmlset[0];
	$setsts["altsecton"]=$xmlset[1];
	$setsts["error"]=$error;
	return($setsts);
	}

/*
	 _GetAlterConfigAry($str,$section) : Make XML File Array
	  $str    : i  : XML Path String {FilePath}:{Section}  : Hostを置換設定(2階層限定)
	  $section: i  : Tag Section
	  @return : o  : XML Path String
	                Tag Section : <AlterSection>分解後 設定されていないときは,ArgumentをReturn
	※ <AlterSection>{(XMLFile):(TagSection)}
*/
function _GetAlterConfigAry($str,$section,&$error) {
	global $XML_CONF,$XML_CONF_ARY;				// $XML_CONF_ARY[{XML FilenName}]=XML_CONF:XMLFile

	$ret="";$error="";
	$xmlset=explode(":",$str,2);
	$xmlpath = $xmlset[0];
	if (!isset($XML_CONF_ARY[$xmlpath])) {			// 同じXMLファイルは再セットしない
		$error="";
		$sv_xml_conf=$XML_CONF;	// XML globalを保存し終了時戻す(CommonLibを使用するための対処)
		$XML_CONF=NULL;
		try {
			$XML_CONF = get_loadconfig($xmlpath,"off");	// XML File Get FileNameはLibrary標準
			} catch( Exception $e ) {
		 	$error=$e->getMessage();
			$XML_CONF_ARY[$xmlpath]="";				// 無駄にXMLFileをGetしないように配列Keyを作成しておく
		    }
		if ((!is_array($XML_CONF))&&(strpos($XML_CONF,'Failed') === 0)) {
			$error=$XML_CONF;
			$XML_CONF_ARY[$xmlpath]="";				// 無駄にXMLFileをGetしないように配列Keyを作成しておく
			}
		if ($error =="") {
			$XML_CONF_ARY[$xmlpath]=$XML_CONF;
			}
		$XML_CONF=$sv_xml_conf;	// XML globalを戻す
		}
	if (!isset($xmlset[1])) { 						// Sectionは省略できる
		$xmlset[1]=$section;						// XML以下(Tag:Section)が未設定時
		}
	if ($xmlset[1] =="") {
		return("");
		}
	return($xmlset[0].":".$xmlset[1]);
	}

/*
	GetAlterViewport($xmlpath) : Get Alternative Viewport Setting
	 $xmlpath: i  : XML Path
	 @return : o  : meta viewport
*/
function GetAlterViewport($xmlpath) {
	global $XML_CONF,$XML_CONF_ARY;				// $XML_CONF_ARY[{XML FilenName}]=XML_CONF:XMLFile

	$html_viewport="";
	if ((isset($XML_CONF_ARY[$xmlpath]))&&($XML_CONF_ARY[$xmlpath]!=="")) {	// XMLFileが存在しない場合""がセットされている
		$html_viewport=ArgViewport($XML_CONF_ARY[$xmlpath],$count);
		}
	return($html_viewport);
	}

/*
	GetAlterVendorPrefix($xmlpath,$ua_phone) : Get Alternative VendorPrefix Setting
	 $xmlpath: i  : XML Path
	 $ua_phone : i  : phone判定の文字列","で区切る Ex:iPhone,iPod,Android : <php_config><ua_phone>をセット 
*/
function GetAlterVendorPrefix($xmlpath,$ua_phone) {
	global $XML_CONF,$XML_CONF_ARY;				// $XML_CONF_ARY[{XML FilenName}]=XML_CONF:XMLFile

	if ((isset($XML_CONF_ARY[$xmlpath]))&&($XML_CONF_ARY[$xmlpath]!=="")) {	// XMLFileが存在しない場合""がセットされている
		ArgVendorPrefix($XML_CONF_ARY[$xmlpath],$ua_phone,$count);
		}
	}

/* ----------------------------------------------------------------------------
	MakeSelectBox($method,$select,$defstr,$idin,$top,$left,$width,$maxheight,$onclick,$idsubmit) : Make inpit / Select Box
	 $method   : i  : "post":PostでSelectBoxを作成, "get":SelectBoxArrayを使用する($selectに内容をセット)
	 $select   : i  : <Tabel>作成パラメータ
	                  get時 :Select Box Text Array ["Text"]/["Value"]
	                  post時:["Query"]:mpd_list(field);Filed名, ["Sort"],["PostStr"],Post形式 ["Text"]/["Value"]追加配列,$select ["Replase"]["Sour"]/["Replase"]["Dist"]:Value置換,["Postjs"]["Init"]/["Postjs"]["End"]:AddJS ,["Errhtml"]:HTML Message
	                  共通$select["style"]["position"]:style:positionをセット
	 $defstr   : i  : Input Default String  : 選択したTextと異なる場合,$idsubmitの要素のbackground-colorを変化させる
	 $idin     : i  : Input Areaのid名 (SelectBoxは「$idin."Box"」)
	 $top      : i  : Input Area : Position Top
	 $left     : i  : Input Area : Position Left
	 $width    : i  : Input Area : Width
	 $maxheight: i  : Select Box Max Height , 0>$maxheight:最大時上げ幅, "":No Specify  : 共通,複数回Callしても初回の値を使用 (0>時,EventSelectBoxheight()でjs項目maxheight(同じ名称)で使用)
	 $idsubmit : i  : SubmitInput id  指定時,$defstr(DefaultString)と選択したTextと異なる場合,background-colorを変化させる
	 $onclick  : i  : [Event] onclick時,Postを含め,毎回通過のEventSelectBoxheight()で実行)
	                  [Click] onclick時,Click後,EventSelectBox()で実行
	 $style    : i  : Select Input Style
	$method[Post]時呼び元で用意する ,$select形式 :PostString , Post,Callbackを設定
	共通
	  $select["style"]["position"]:style:positionをセット "position:fixed"|"position:absolute"
	Get時
	 $select["Text"]/["Value"]=Select Box Text Array Indexは同じとすること。(Indexで双方リンク) 
	Post時
	  $select ["PostStr"]["String"]  ={String}    : PostString    (Required) "RequestByPost('".$_SERVER['PHP_SELF']."','%p1%','%p2%',%p3%);
	  $select ["PostStr"]["Post"]    ={変数名}    : PostParameter (Required)  String : 上例では"%p1%"
	  $select ["PostStr"]["Callback"]={変数名}    : Post Callback (Required)  String : 上例では"%p3%"
	  $select ["PostStr"]["{任意}"]  ={任意変数名}: Post Optional Setting : str_replace({任意},{任意変数名},{PostString}) 上例では"%p2%"
	  $select ["Postjs"]["Init"]/["Postjs"]["End"]] : Post Before/After Js
	 Post側
	  $select ["Text"]/["Value"]={Value}   : 設定されているとSelectBoxにコンスタントとして設定
	  $select ["Query"]={SelectBox Query} : mpdに発行するQuery : listコマンド用
	  $select ["Sort"] = Sortルールをセット mpdLibray SortParameterに従う
	  $select ["Replase"]["Sour"][]/["Replase"]["Dist"][] ["Sour"]->["Text"]上の["Dist"]["Sour"][]を["Replase"]["Dist"][]の値を["Value"]に置換
	  $select ["Errhtml"]:表示メッセージをHTML形式 %message%;Error時はメッセージを置換
------------------------------------------------------------------------------- */
function MakeSelectBox($method,$select,$defstr,$idin,$top,$left,$width,$maxheight,$idsubmit="",$onclick="",$style="") {
	global $MAKESELECTBOX;

	$height=20;$boxheight=60;					// $height:20:Select(Input)Height $boxheight:Default BoxHeight(Boxを生成時に設定:最大で$maxheight)
	$idsel="grp".$idin;
	$idseltbl=$idin."tbl";
	$val=$defstr;
	$i=array_search($defstr,$select["Text"],true);		// Defaultの$selectValueをSearch
	if (($i !==false)&&(isset($select["Value"]))&&(isset($select["Value"][$i]))) {
		$val=$select["Value"][$i];
		}
	if ($method=="post") {
		 $post=MakeSelectBoxPost($select,$idin,$top,$left,$width,$maxheight,$idsubmit);
		 print '<button type="text" id="'.$idin.'" value="'.$val.'" onclick="this.blur();if (POST_'.$idin.'==0){'.$post.';POST_'.$idin.'=1; } else { EventSelectBoxOnclick(\''.$idin.'\',\''.$idsel.'\'); }" class="SeleBoxin" style="top:'.$top.'px;left:'.$left.'px;width:'.($width-19).'px;height:'.$height.'px;'.$style.'">'.$defstr.'</button>';
		 print '<button type="text" onclick="this.blur();if (POST_'.$idin.'==0){'.$post.';POST_'.$idin.'=1; } else { EventSelectBoxOnclick(\''.$idin.'\',\''.$idsel.'\'); }" class="SeleBoxSl" style="top:'.$top.'px;left:'.($left+$width-24.3).'px;width:'.($height+8.6).'px;height:18px;'.$style.'">&lt;</button>';
		 print '<div id="'.$idsel.'" class="SeleBox" style="top:'.($top+$height+1).'px;left:'.$left.'px;width:'.($width).'px;height:'.$boxheight.'px;display:none;">';
		 print '</div>';
		 }
	else {
		 print '<button type="text" id="'.$idin.'" value="'.$val.'" onclick="this.blur();EventSelectBoxOnclick(\''.$idin.'\',\''.$idsel.'\');" class="SeleBoxin" style="top:'.$top.'px;left:'.$left.'px;width:'.($width-19).'px;height:'.$height.'px;'.$style.'">'.$defstr.'</button>';
		 print '<button type="text" onclick="this.blur();EventSelectBoxOnclick(\''.$idin.'\',\''.$idsel.'\');" class="SeleBoxSl" style="top:'.$top.'px;left:'.($left+$width-24.3).'px;width:'.($height+8.6).'px;height:18px;'.$style.'">&lt;</button>';
		 $boxheight=MakeSelectBoxDetail("none",$select,$idin,$top,$left,$width,$maxheight,$idsubmit);
		 }
	$position="position:fixed";
	if ((isset($select["style"]))&&(isset($select["style"]["position"]))) {
		$position=rtrim($select["style"]["position"],";");
		if ($position !=="") { $position=$position.";"; }
		}
$js_event="";$js_click="";
if (is_array($onclick)) {
	if (isset($onclick["Event"])) {				// Postを含め,毎回通過のEventSelectBoxheight()で実行)
		 $js_event=$onclick["Event"];
		 }
	else if (isset($onclick["Click"])) {		// Click後,EventSelectBox()で実行 ("<select"のEventに似せている)
		 $js_click=$onclick["Click"];
		 }
	}
echo <<<EOM
<script type="text/javascript">
/* Select Box Default Item Select Boxが変わったかチェック用 */
	var {$idin}='{$defstr}';				// Select要素 ,初回はDefault
	var POST_{$idin}=0;						// MethodPost: 0:未Post 1:Post (MethodGet時は常に0)
	var PROT_{$idsel}_h={$boxheight};		// 指定サイズを加味したBoxHight ,Method PostはPostでセット
	var JSEvent_{$idsel}="{$js_event}";
	var JSClick_{$idsel}="{$js_click}";
</script>
EOM;
if ((isset($MAKESELECTBOX))&&($MAKESELECTBOX !=="")) { return; }
echo <<<EOM
<style type="text/css">
.SeleBoxin { {$position}border:0.4px solid #707070;line-height:100%;text-align:left;font-size:12px;overflow:hidden;white-space:nowrap;cursor:pointer; }
.SeleBoxSl { {$position}transform:rotate(-90deg) scale(0.7,1);border:1px solid #707070;margin:1.1px 0 0 0;overflow:hidden;cursor:pointer; }
.SeleBox   { {$position}border:1px solid #888888;background-color:#f5f5f5;overflow:auto; }
.SeleBoxDt { height:18px;font-size:12px;color:#000000;overflow:visible;white-space:nowrap; }
.SeleBoxDt:hover { background-color:#b0c4de; }
</style>
<script type="text/javascript">
var OPEN_idsel="";							// OpenBox:id
/* ----------------------------------------------------------------------------
	EventSelectBoxOnclick(idin,idsel) : Event Input , Make Select Box
	 idin  : i  ; Input Areaのid名
	 idsel : i  : Tabel name , {idsel}+{i} ; TabelCell 要素
----------------------------------------------------------------------------- */
function EventSelectBoxOnclick(idin,idsel) {
	if (document.getElementById(idsel).style.display=='block') {
		document.getElementById(idsel).style.display='none';
		if (OPEN_idsel==idsel) { OPEN_idsel=""; }			// 開いているidをClear
		return;
		}
	if (document.getElementById(idin+"tbl")) {
		document.getElementById(idsel).style.display='block';
		EventSelectBoxMark(idin,idsel);
		EventSelectBoxheight(idsel);
		EventSelectBoxClose(idsel);				// 他のBoxをClose
		}
	}

/*
	EventSelectBoxClose(idsel) : Event SelectBox close ; 他BoxClose
	 idsel : i  : Tabel name , {idsel}+{i} ; TabelCell 要素
*/
function EventSelectBoxClose(idsel) {
	if ((OPEN_idsel !=="")&&(OPEN_idsel !==idsel)) {
		if ((document.getElementById(OPEN_idsel))&&(document.getElementById(OPEN_idsel).style.display !=="none")) {
			document.getElementById(OPEN_idsel).style.display='none';
			}
		}
	OPEN_idsel=idsel;														// 開いているidをセット
	}

/*
	EventSelectBoxMark(idin,idsel) : Event Input Mark Select
	 idin  : i  ; Input Areaのid名
	 idsel : i  : Tabel name , {idsel}+{i} ; TabelCell 要素
*/
function EventSelectBoxMark(idin,idsel) {
	for (var i = 0;; i++) {
		if (document.getElementById(idsel+i) == null) { break; }
		if (document.getElementById(idin).innerHTML == document.getElementById(idsel+i).innerHTML) {
			 document.getElementById(idsel+i).style.backgroundColor='#c0c0c0';
			 }
		else if(document.getElementById(idsel+i).style.backgroundColor !=="") {
			 document.getElementById(idsel+i).style.backgroundColor='';
			 }
		}
	}

/*
	EventSelectBoxheight(idsel) : Event SelectBox Height Set ; Windowのsizeで再設定
	 idsel : i  : Tabel name , {idsel}+{i} ; TabelCell 要素
*/
function EventSelectBoxheight(idsel) {
	var maxheight="{$maxheight}";
	var adjust=0;
	var jsevent="";
	eval("jsevent= JSEvent_"+idsel+";");
	if (jsevent !="") { eval(jsevent+";"); }
	if ((maxheight!="")&&(maxheight < 0)) {
		adjust=parseInt(maxheight);
		}
	var def_hight=60;						// Select[Input]毎の高さ設定
	eval("def_hight="+"PROT_"+idsel+"_h;");										// 指定サイズを加味したBoxHight Get 最大:$boxheight
	set_hight=def_hight;
	var pos=parseInt(document.getElementById(idsel).style.top)+set_hight;		// Select Boxの下位置をGet
	if (pos > window.innerHeight) {												// Browser Windowを超えているかチェック
		var hight=set_hight-(pos-window.innerHeight)+adjust;
		if (hight > 44) {					// 小さすぎるとスクロールに難があるので調整しない
			set_hight=hight;
			}
		}
	document.getElementById(idsel).style.height=set_hight+"px";
	}

/* ----------------------------------------------------------------------------
	EventSelectBox(idin,idsel,id,idsubmit) : Event Select
	 idin    : i  : Input Areaのid名 ( var {idin}
	 idsel   : i  : Tabel name , {idsel}+{i} ; TabelCell 要素
	 id      : i  : Click Event Select id
	 idsubmit: i  : Submit id Name "";not Submit
----------------------------------------------------------------------------- */
function EventSelectBox(idin,idsel,id,idsubmit) {
	var str="";
	eval("str="+idin+";");
	document.getElementById(idsel).style.display='none';
	document.getElementById(idin).innerHTML=document.getElementById(id).innerHTML;
	if (document.getElementById(id+"v")) {
		 document.getElementById(idin).value=document.getElementById(id+"v").value;
		 }
	else {
		 document.getElementById(idin).value=document.getElementById(id).innerHTML;
		 }
	if ((idsubmit !=="")||(idsubmit !==null)) {
		if (str !== document.getElementById(idin).innerHTML) {
			 document.getElementById(idsubmit).style.backgroundColor='#009900';
			 document.getElementById(idsubmit).style.color='#CED8F6';
			 }
		else {
			 document.getElementById(idsubmit).style.backgroundColor='';
			 document.getElementById(idsubmit).style.color='';
			 }
		}
	var jsevent="";
	eval("jsevent= JSClick_"+idsel+";");
	if (jsevent !="") { eval(jsevent+";"); }
	}
</script>
EOM;
	$MAKESELECTBOX="on";		// Boxは複数Openしないため配列にしない
	}

/* ----------------------------------------------------------------------------
	MakeSelectBoxPost($select,$idin,$top,$left,$width,$maxheight,$idsubmit) : Make input / Select Box Detail
	 $select   : i  : ["PostStr"]:Post String Post
	                  Select Box Text Array ["Text"]/["Value"] & ["Query"]["Sort"]:SelectBox Query,["Replase"]:Item Replase ,["Errhtml"]:Error HTML,
	 $idin     : i  : Input Areaのid名 (SelectBoxは「$idin."Box"」)
	 $top      : i  : Input Area : Position Top
	 $left     : i  : Input Area : Position Left
	 $width    : i  : Input Area : Width
	 $maxheight: i  : Select Box Max Height , ( 0>$maxheight:最大時上げ幅。この関数では+のみ), "":No Specify  :
	 $idsubmit : i  : SubmitInput id  指定時,$defstr(DefaultString)と選択したTextと異なる場合,background-colorを変化させる
	 @return   : i  : Post String
	Post 形式 : PostString , Post,Callbackを設定
	 $select ["PostStr"]["String"]  ={String}    : PostString    (Required) "RequestByPost('".$_SERVER['PHP_SELF']."','%p1%','%p2%',%p3%);
	 $select ["PostStr"]["Post"]    ={変数名}    : PostParameter (Required)  String : 上例では"%p1%"
	 $select ["PostStr"]["Callback"]={変数名}    : Post Callback (Required)  String : 上例では"%p3%"
	 $select ["PostStr"]["{任意}"]  ={任意変数名}: Post Optional Setting : str_replace({任意},{任意変数名},{PostString}) 上例では"%p2%"
	 $select ["Replase"]["Sour"][]/["Replase"]["Dist"][] ["Sour"]->["Text"]上の["Dist"]["Sour"][]を["Replase"]["Dist"][]の値を["Value"]に置換
	 $select ["Postjs"]["Init"]/["Postjs"]["End"]] : Post Before/After Js
------------------------------------------------------------------------------- */
function MakeSelectBoxPost($select,$idin,$top,$left,$width,$maxheight,$idsubmit="") {
	global $Net;

	$idsel="grp".$idin;
	if (isset($Net->p_connect['timeout'])) {
		 $str='&host='.ArgEncode($Net->p_connect['host']).'&port='.ArgEncode($Net->p_connect['port'])."&timeout=".ArgEncode($Net->p_connect['timeout']);
		 }
	else {
		 $str='&host='.ArgEncode($Net->p_connect['host']).'&port='.ArgEncode($Net->p_connect['port']);
		 }
	if (isset($Net->p_connect['password'])) {
		$str='&pass='.ArgEncode($Net->p_connect['password']);
		}
	if (isset($select["Text"])) { $selary["Text"]=$select["Text"]; }			// Post側で使用項目を抜粋
	if (isset($select["Value"])) { $selary["Value"]=$select["Value"]; }
	if (isset($select["Query"])) { $selary["Query"]=$select["Query"]; }
	if (isset($select["Sort"])) { $selary["Sort"]=$select["Sort"]; }
	if (isset($select["Errhtml"])) { $selary["Errhtml"]=$select["Errhtml"]; }
	if (isset($select["Replase"])) { $selary["Replase"]=$select["Replase"]; }
	$ary =compact("selary","idin","top","left","width","maxheight","idsubmit");
	$enc=json_encode($ary);
	$para=ArgEncode($enc);
	$poststr='p=selectbox'.$str.'&para='.$para;
	$post=$select["PostStr"]["String"];
	$str="";
	if ((isset($select["Postjs"]))&&(isset($select["Postjs"]["End"]))&&($select["Postjs"]["End"]!=="")) {
		$str=rtrim($select["Postjs"]["End"],";");
		}
	$callback = 'function () { EventSelectBoxMark(\''.$idin.'\',\''.$idsel.'\');EventSelectBoxheight(\''.$idsel.'\');'.$str.' }';	// Callback
	foreach($select["PostStr"] as $key => $val) {
		if ($key=="String")   { continue; }
		if ($key=="Post")     {
			$post = str_replace($val,$poststr,$post);		// 実行後復帰表示エリア名設定
			continue;
			}
		if ($key=="Callback") {
			$post = str_replace($val,$callback,$post);		// 実行後復帰表示エリア名設定
			continue;
			}
		$post = str_replace($val,$key,$post);				// 実行後復帰表示エリア名設定
		}
	if ((isset($select["Postjs"]))&&(isset($select["Postjs"]["Init"]))&&($select["Postjs"]["Init"]!=="")) {
		$post=rtrim($select["Postjs"]["Init"],";").";".$post;
		}
	return($post);
	}

/* ----------------------------------------------------------------------------
	MakeSelectBoxDetail($select,$idin,$top,$left,$width,$maxheight,$idsubmit) : Make inpit / Select Box Detail
	 $disp     : i  : Select Box Display "none"|"block"
	 $select   : i  : Select Box Text Array ["Text"]/["Value"]
	 $idin     : i  : Input Areaのid名 (SelectBoxは「$idin."Box"」)
	 $top      : i  : Input Area : Position Top
	 $left     : i  : Input Area : Position Left
	 $width    : i  : Input Area : Width
	 $maxheight: i  : Select Box Max Height "":No Specify
	 $idsubmit : i  : SubmitInput id  指定時,$defstr(DefaultString)と選択したTextと異なる場合,background-colorを変化させる
	 @return   : o  : Select Box Height
------------------------------------------------------------------------------- */
function MakeSelectBoxDetail($disp,$select,$idin,$top,$left,$width,$maxheight,$idsubmit="") {
	$height=20;
	$idsel="grp".$idin;
	$idseltbl=$idin."tbl";
	$cnt=count($select["Text"]);
	$boxheight=$cnt*(18+4)+6;
	if (($maxheight !=="")&&($maxheight > 0)&&($maxheight < $boxheight)) {			// 指定Max Height超過時,側近から再計算
		$maxheight=(($maxheight -6)/(18+4))*(18+4)+6;
		$boxheight=$maxheight;
		}
	print '<div id="'.$idsel.'" class="SeleBox" style="top:'.($top+$height+1).'px;left:'.$left.'px;width:'.($width).'px;height:'.$boxheight.'px;cursor:pointer;display:'.$disp.';z-index:1;">';
	if ((is_array($select["Text"]))&&(count($select["Text"]) > 0)) {
		print '<table id="'.$idseltbl.'" >';
		foreach($select["Text"] as $key => $val) {
			$id=$idsel.$key;
			$str='';
			if ((isset($select["Value"]))&&(isset($select["Value"][$key]))) {
				$str='<input type="text" id="'.$id.'v" value="'.$select["Value"][$key].'" style="display:none;">';				// Value用の項目
				}
			print '<tr><td><div id="'.$id.'" onclick="EventSelectBox(\''.$idin.'\',\''.$idsel.'\',\''.$id.'\',\''.$idsubmit.'\');" class="SeleBoxDt" style="width:'.($width-6).'px;">'.$val.'</div>'.$str.'</td></tr>';
			}
		print '</table>';
		}
	print '</div>';
	return($boxheight);
	}

/* ----------------------------------------------------------------------------
	PostSelectbox($para) : Make Selectbox (Post)
	$para: $ary =compact("select","idin","top","left","width","maxheight","idsubmit");
	       $enc=json_encode($ary);
	       $para=ArgEncode($enc); この関数前にArgDecode済であること
	compact,json_encodeを使用して項目を配列する。
	 $select   : ["Query"]:mpd_list(field);Filed名をセット ["Sort"]:Sortルールをセット, array ["Text"]/["Value"]先頭に付加する配列
	             ["Replase"]["Sour"][]/["Replase"]["Dist"][] ["Sour"]->["Text"]上の["Dist"]["Sour"][]を["Replase"]["Dist"][]の値を["Value"]に置換
	             ["Errhtml"]:表示メッセージをHTML形式 %message%;Error時はメッセージを置換
	 $idin     : Input Areaのid名 (SelectBoxは「$idin."Box"」)
	 $top      : Input Area : Position Top
	 $left     : Input Area : Position Left
	 $width    : Input Area : Width
	 $maxheight: Select Box Max Height "":No Specify
	 $idsubmit : SubmitInput id  指定時,$defstr(DefaultString)と選択したTextと異なる場合,background-colorを変化させる
------------------------------------------------------------------------------- */
function PostSelectbox($para) {
	$para=ArgDecode($para);

	$top="";$left="";$width="";$maxheight="";$idsubmit="";$select=array();$selary=array();
	$dec=json_decode($para,true);
	$result=extract($dec);
	if (isset($selary)) { $select=$selary; }					// Post元の$select情報を復元
	$idsel="grp".$idin;
	$field=$select["Query"];									// Query/Sortの指定 mpd_list ,List作成
	if (isset($select["Sort"])) {
		 $output=mpd_list($field,($query=array()),"",$select["Sort"]);
		 }
	else {
		 $output=mpd_list($field);
		 }
	$boxheight=0;$stsmsg="";$postmsg="";$errmsg="";if (isset($select["Errhtml"])) { $postmsg=$select["Errhtml"]; }
	if (!is_array($output)) {									// Error Message Edit
		 if ($output == 1) {
			  $errmsg="No Combo Data !! : ".$field;
			  }
		 else {
			  $errmsg="Receive Error : ".$output;
			  }
		 if ($postmsg!=="") {
			  $postmsg=str_replace("%message%",$errmsg,$postmsg);	// Message Edit
			  }
		 else {
			  $stsmsg="PostSelectbox : ".$errmsg."\n";			// $select["Errhtml"]が未設定時 StstusLine
			  }
		 }
	else {
		 $postmsg=str_replace("%message%","",$postmsg);
		 if ((isset($select["Text"]))&&(count($select["Text"]) > 0)) {		// 事前セット値があればマージするする
			  $select["Text"] =array_merge($select["Text"],$output[$field]);
			  $select["Value"]=array_merge($select["Value"],$output[$field]);
			  }
		 else {
			  $select["Text"] =$output[$field];					// OutputをSelect配列にセット
			  $select["Value"]=$output[$field];
			  }
		 if ((isset($select["Replase"]))&&(isset($select["Replase"]["Sour"]))&&(isset($select["Replase"]["Dist"]))) {
			foreach($select["Replase"]["Sour"] as $key => $val) {			// Valueを変えたい指定があれば対応値を設定
				$idx = array_search($val,$select["Text"]);
				$select["Value"][$idx]=$select["Replase"]["Dist"][$key];
				}
			}
		 print $idsel.":";
		 $boxheight=MakeSelectBoxDetail("block",$select,$idin,$top,$left,$width,$maxheight,$idsubmit);
		 print "\n";
		 }
	if ($postmsg!=="") {
		 $result = preg_match_all('/id=(.*?) /s',$postmsg,$part,PREG_SET_ORDER);	// 正規表現:id= 
		 if (isset($part[0][1])) {
			  $str=str_replace(array("'",'"'),array("",""),$part[0][1]);
			  print $str.":".$postmsg."\n";
			  }
		 else {
			  $stsmsg="PostSelectbox End ".$errmsg."\n";
			  }
		 }
	if ($stsmsg !=="") { print $stsmsg; }											// Status Message Output
	print "Function:PROT_".$idsel."_h=".$boxheight.";EventSelectBoxClose('".$idsel."');\n";		// 他のBoxをClose
	}

/* -----------------------------------------------------------------------------
	DispSureBox($id,$okcmd,$ngcmd,$title,$str,$top,$left): Display Sure Box
	 $mode  : i  : on|off|check : off:初期生成モード, on:メッセージ表示モード | check:id を作成したかチェック
	 $id    : i  : id名
	 $okcmd : i  : OK時実行JS
	 $ngcmd : i  : NG時実行JS
	 $title : i  : Message Title
	 $str   : i  : Message
	 $top   : i  : 表示位置 top
	 $left  : i  : 表示位置 left
	 @return: o  : $mode="check"時,Make id(DivCreat)していない場合"-1"
	               $mode=on|off時,"OK"Button id
※使用環境
	 mpdweb.common.js
参考CSS デザイン共通のstyleを用意する
.buttn    :ボタンスタイル
.box      : Box style
.boxtitle : Box Title style
.msgbbtn  { font-size:12px;width:60px;height:24px;background-color:#c0c0c0;border:1.5px ridge #d3d3d3;}
 DispMsgBoxの引数と順序がことなることに注意(php内での使用がメインで省略できない項目が前)
----------------------------------------------------------------------------- */
function DispSureBox($mode,$id="",$okcmd="",$ngcmd="",$title="",$str="Sure Box",$top=200,$left=170) {
	global $IDSUREBOX,$G_SUREBOXID;

	if ($id == "") {
		if (isset($IDSUREBOX)) {
			 $id=$IDSUREBOX;
			 }
		else {
			 $id="grpSureBox";
			 }
		}
	if ($mode !=="on") {
		 $disp="display:none;";
		 }
	else {
	     $disp="display:block;";
		 }
	if ($mode !=="check") {
		 $G_SUREBOXID[$id]=1;
		 }
	else {
		 if (isset($G_SUREBOXID[$id])) { $ret=$G_SUREBOXID[$id]; } else { $ret= -1; }
		 return($ret);
	 	 }
	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	print '<div id='.$id.' class=box style="width:240px;height:160px;position:fixed;top:'.$top.'px;left:'.$left.';background-color:#f5f5f5;z-index:1000;'.$disp.'">';
	print '<div id="'.$id.'title" class=boxtitle align=left style="width:220px;">'.$title.'</div>';
	print '<div id="'.$id.'str" align=left style="overflow:hidden;white-space:nowrap;text-overflow:ellipsis;width:200px;height:100px;font-size:14px;position:absolute;top:40px;left:20px;color:#000000">'.$str.'</div>';
	print '<input id="'.$id.'func"  type="button" name="Submit" class="buttn msgbbtn" value="OK" onclick="'.$okcmd.$unload.'" style="left:30px;" />';
	print '<input id="'.$id.'cls" type="button" name="Submit" class="buttn msgbbtn" value="Cancell" onclick="'.$ngcmd.$unload.'" style="right:30px;" />';
	print '</div>';
	return($id.'func');
	}

/* -----------------------------------------------------------------------------
	DispMsgBox($mode,$str,$top,$left,$title): Display Message Box
	 $mode  : i  : on|off : off:初期生成モード, on:メッセージ表示モード
	 $str   : i  : Message
	 $top   : i  : 表示位置 top
	 $left  : i  : 表示位置 left
	 $title : i  : Message Title
	 $id    : i  : Html Divid 省略時 global $IDMSGBOXがあれば使用、なければ"grpMsgBox"で作成
	 $locat : i  : OK Button Click Action , MssageBoxのunloadは内部で付加する

※使用環境
	 mpdweb.common.js：MoveDragOn() : Object Move

参考CSS デザイン共通のstyleを用意する
.buttn    :ボタンスタイル
.box      : Box style
.boxtitle : Box Title style
.msgbbtn  : MessageBoxに付けたいデザイン
.buttn {border-style:none;width:50px;height:20px;padding:2px 0 2px;font-size:11px;cursor:pointer;-moz-border-radius:4px;-webkit-border-radius:4px;border-radius: 4px;}
.box {border: 1px solid #888888;position:fixed;top:200px;left:170px;width:300px;height:210px;font-size:10p;z-index:5;background-color:#2f2f2f;display:none;}
.boxtitle {background-color:#0000FF;color:#CEECF5;font-size:12px;text-align:left;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;width:280px;height:18px;position:absolute;top:0px;left:0px;padding:8px 10 2px;}
.boxtext  {position:absolute;background-color:#2f2f2;color:#ffffff;font-size:16x;font-weight:bold;text-decoration:none;display:block;text-align:left;vertical-align:middle;border: 0px;width:278px;height:19;padding:3px 10 2px;}
.msgbbtn { font-size:12px;width:60px;height:24px;position:absolute;top:120px;background-color:#c0c0c0;border:1.5px ridge #d3d3d3;}
----------------------------------------------------------------------------- */
function DispMsgBox($mode,$str="",$top=200,$left=60,$title="Message Box",$id="",$locat="") {
	global $IDMSGBOX;

	if ($id == "") {
		if (isset($IDMSGBOX)) {
			 $id=$IDMSGBOX;
			 }
		else {
			 $id="grpMsgBox";
			 }
		}
	$width=340;
	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	if ($locat !=="") { $unload=$unload.$locat; }			// $locatが指定されたとき,unloadを入れ換え
	if ($mode !=="on") {
		 $disp="display:none;";
		 }
	else {
	     $disp="display:block;";
		 }
	print '<div id='.$id.' onMousedown="MoveDragOn(\''.$id.'\');" class=box style="width:'.$width.'px;height:160px;position:fixed;top:'.$top.'px;left:'.$left.';background-color:#f5f5f5;z-index:1000;'.$disp.'">';
	print '<div id="'.$id.'title" class=boxtitle align=left style="width:'.($width-20).'px;cursor:pointer;">'.$title.'</div>';
	print '<div id="'.$id.'str" align=center style="overflow:hidden;word-wrap: break-word;text-overflow:ellipsis;width:'.($width-40).'px;height:100px;font-size:15px;position:absolute;top:60px;left:20px;line-height:20px;text-align:center;color:#000000;">'.$str.'</div>';
	print '<input type="button" name="Submit" class="buttn msgbbtn" value="OK" onclick="'.$unload.'" style="left:'.(($width/2)-20).'px;" />';
	print '</div>';
	}

//----- Source End --------------------------------------------------------------
?>
