<?php
/*******************************************************************************
	mpd Command function (mpd{module}.lib_mpd.php)
*******************************************************************************/
/*
  Calling Sequence
	1.$XML_CONF = get_loadconfig();          XMLFile Loading
	2.get_libinit();                         Library Initialize
	global $XML_CONF,$ART_CONF,$UPDATE_CONF;がLoadされる
  Network
	1.$XML_CONF = get_loadconfig();          XMLFile Loading
	  $Net->timeout=3;						 Timeout (0:No Timeout)
	2.$Net = new Net_Common;                 Net Class Create
	3.get_config("Mpd_net",$Net->p_connect); Parameta Loading
	4.$Net->connect();                       Connect
	5.～各種機能
	6.mpd_close()

	global $Net : Libraryにて$Netで使用している
*/
//----- mpd function's  ----------------------------------------------------------------
/*
	mpd_version()
	@return : o  : Version
*/
function mpd_version() {
	$LIB_VERSION=basename(__FILE__)." 1.37 (31.03.2024)";
	return($LIB_VERSION);
	}

/*
	mpd_list($field,$query,$verbs_fld,$verbs_srt) : mpd list
	 $field    : i  : list Field Artist/AlbumArtist/Album/Genre/Date (先頭はSelect対象を設定する)
	 $query    : i  : query: ["Artist"]={Artist} / ["Genre"]={Genre} / ["Date"]={Date} 組み合わせ
	 $verbs_fld: i  : Sort対象設定Filedイレギュラーに指定できる。複数$field時有効。XML設定 <Sort_{$field先頭}><$verbs_fld>
	 $verbs_srt: i  : SortKeyをイレギュラーに指定できる。 ',':区切り形式。指定がない場合,XML設定ファイルを使用する。
	 $limit    : i  : Size Limit mpd I/FでのLine上限を設定 NULLは制限なし
	 $limit2   : i  : Size Limit2 $verbs_fldArgument/$verbs_srtにより Find(mpd_list_find)に切り替わったときの上限を設定
	 @return   : o  : Output List Array

	  ex 1) $field="Artist";
	     2) $field="Album";
			$query["Artist"]="10cc";

	 array("Album","directory","Artist","AlbumArtist","Date","Art","Time","Sec","No","Genre");
	 array("Album");(高速モードFiled/Sortなし)
	 ※"Time","Sec","No"(曲数):集計値
*/
function mpd_list($field,$query=array(),$verbs_fld="",$verbs_srt="",$limit=NULL,$limit2=NULL) {
	global $Net,$ART_CONF,$XML_SORTBASE,$XML_LISTUNIQUE;

	if (is_array($field)) {		// 先頭は必ずList項目
		 $listcmd=$field[0];
		 $sortcmd=$field[0];	// XML設定:<Sort_{$sortcmd}となる
		 $fieldary=$field;
		 }
	else {						// Listモード(高速モード,Artなし)
		 $listcmd=$field;		// List以外項目が必要なければ配列を使用しない。 
		 $sortcmd="List";$verbs_fld=$field;	// XML設定:<Sort_{$sortcmd}<{$field}>となる
		 $fieldary[]=$field;
		 }
	$ART_ON=$ART_CONF["SetNo"];
	if (stristr($ART_CONF["func"],"album") == false) {		// AlbumArtを必要としない場合(Albumを対象としない)
		 $ART_ON = 0;										//  List 以外はロジックを組めない
		 }
	if (($ART_ON !== 0)&&((is_array($field))&&(!in_array("Art",$field)))||((!is_array($field))&&($field !== "Art"))) {	// AlbumArtを格納Fieldがない場合はArtなしにする
		 $ART_ON = 0;
		 }
	$XML_SORT_FLD=Sort_Para($sortcmd,$fieldary,$query,0,"",$verbs_fld,$verbs_srt,$EXCLUDE,$SORTFLD,$SORTMOD);
	if (($query)&&(($XML_SORT_FLD["Sort_on"] !== 0)||($ART_ON !== 0)||(is_array($field))&&(sizeof($field) > 1))) {		// AlbumArtあり&Field:"Art"あり時，FindコマンドでList作成
		 $outlist=mpd_list_find($fieldary,$query,$XML_SORT_FLD["SortStr"],$ART_ON,0,$limit2);
		 return($outlist);
		 }
	$args = array();							// 条件がないのでListコマンドで作成
	$args[]=$listcmd;
	foreach($query as $key => $val) {
		 $args[]=$key;
		 $args[]=$val;
		 }
	$warning="";
	$outlist = $Net->runCommand("list",$args,1,0,"",$limit);
	if (!is_array($outlist)) {		// Out 0件
		 return($outlist); }
	if(in_array($listcmd,$XML_LISTUNIQUE)) {			// 単一Field取得時，指定のFiledがunUniqueの場合,Unique削除する
		if (isset($outlist[$listcmd])) { $outlist[$listcmd] = array_unique($outlist[$listcmd]); }
		}
	if (isset($output['warning'])) {					// Limit Over
		$warning=reset($output['warning']);
		}
	if ((!is_array($SORTFLD))||(count($SORTFLD) == 0)) {
		$SORTFLD[0]=$listcmd;
		}
	if ((isset($EXCLUDE[$listcmd]))&&(count($EXCLUDE[$listcmd]) > 0)) {						// Sort除外冠詞の確認
		 $SORT_TBL="Sort";
		 foreach($outlist[$listcmd] as $key => $val) {
			Sort_Filed($SORTFLD,$EXCLUDE,$SORTMOD,$outlist,$key,$outlist,$key,$SORT_TBL);
			}
		 $output=Sort_Table($outlist,$SORT_TBL);
		 }
	else {
		 $etc="";
		 if ($XML_SORTBASE["Sort_Capital"] == "on") {			// 大/小文字区別なし
		  	$etc="-Sort";
			foreach($outlist[$listcmd] as $key => $val) {
				Sort_Filed($SORTFLD,$EXCLUDE,$SORTMOD,$outlist,$key,$outlist,$key,$listcmd.$etc);
				}
			}
		 $output=Sort_Table($outlist,$listcmd.$etc);			// Sort条件がない場合でもList対象でSortしておく(mpdは発生順にセレクト)
		 }
	if (($warning !=="")&&(!isset($output['warning']))) {		// Limit Overが(先頭一致:First)のときなくなっていれば再度つける
		$output['warning'][0]=$warning;
		}
	return($output);
	}

/*
	mpd_list_find($field,$query,$XML_SORT_FLD) : list(Used Find) mpd_listから条件によりCallされる。
	 $field         : i  : list Field Artist/AlbumArtist/Album/Genre/Date (先頭はSelect対象を設定する)
	 $query         : i  : query: ["Artist"]={Artist} / ["Genre"]={Genre} / ["Date"]={Date} 組み合わせ
	 $sortstr       : i  : Sort String ","区切り
	 $ART_ON        : i  : {n}:ARTが必要時 0:ART不要(呼び元で$ART_CONFをもとに判定しセット)
	 $direct        : i  : shared 版と位置合わせ(未使用) [$direct:Direct Call:"1"; Else 0(Calld "mpd_list()");]
	 $limit         : i  : mpd read Limit (AlbumのCountではなくファイル数に注意) , NULL制限なし
	 @return        : o  : Output List ArrayList / true(1) : No Data / Warning:Message / false: Network Error
	 array("Album","directory","Artist","AlbumArtist","Date","Art","Time","Sec","No","Genre");
	 ※"Time","Sec","No"(1曲数):集計値
	 $XML_SORTBASE On 大文字/小文字区別なし
*/
function mpd_list_find($field,$query,$sortstr,$ART_ON,$direct=0,$limit=NULL) {
	global $Net,$LIB_CONF,$XML_SORTBASE;
	$SORT_TBL="Sort";

	$Meta_Lng=64;
	$start_time = time();
	$ap_timeout=0;
	if (isset($LIB_CONF["LoopTimeout"])) {
		$ap_timeout=$LIB_CONF["LoopTimeout"];		// Special Setting : $LIB_CONF["LoopTimeout"]が設定されていたらループを打ち切る設定として使用
		}
// 0:加工field,1:Output(引数fieldより追加,追記),2:加工fieldを引数fieldによりOutput ,9:「1」の項目が追記により長くなったとき一時止める
	$res_field=array("directory"=>0,"Art"=>0,"Time"=>0,"Sec"=>0,"No"=>0,"Sort"=>0);	// 要加工OutputField ロジックを組み込んでいるため関数内で設定している
	foreach($field as $key => $val) {			// OutputFieldを設定
		if (isset($res_field[$val])) {
			 $res_field[$val]=2;
			 }
		else {
			 $res_field[$val]=1;
			 }
		}
	$listcmd=$field[0];
	if ($sortstr !== "") {
		 $sortpara=$sortstr;	// 設定のSortFieldを選択
		 }
	else {
		 $sortpara="Album";									// List機能として、SortがなくてもAlbum順にしておく。(大/小文字区別,定冠詞除外も適用される)
		 }
	$XML_SORT_FLD=Sort_Para($listcmd,$field,$query,0,"","",$sortpara,$EXCLUDE,$SORTFLD,$SORTMOD);
	$find_query = array();
	foreach($query as $key => $val) {
		$find_query[]=$key;
		$find_query[]=$val;
		}
	$warning="";
	$find=$Net->runCommand("find",$find_query,1,0,$field,$limit);	// listと同じ条件でFind実行
	if (!is_array($find)) {		// Out 0件
		return($find);
		}
	if (isset($find['warning'])) {					// Limit Over
		$warning=reset($find['warning']);
		}
	$find=Sort_Table($find,$field[0]);				// Select対象(Field第1項目)でSort
	$i=0;
	$save="";$outfind=array();
	foreach($find["file"] as $key => $val) {
		$end_time = time();
		if (($ap_timeout != 0) &&(($end_time - $start_time) > $ap_timeout)) {		// $LIB_CONF["LoopTimeout"]が設定されていたらループを打ち切る
			return("Timeout (loop too long)");
			}
		if (!isset($find[$field[0]][$key])) {		// Fileがあるが、Select対象がない場合
			$find[$field[0]][$key]=" ";				//   対象データを保証する
			}
		if ($save ==$find[$listcmd][$key]) {				// 引数Fieldを集約(例:1アルバム1file)
			foreach ($res_field as $res_key => $res_val) {	// 出力対象の場合追記
				if (($res_val == 1)&&(isset($find[$res_key][$key]))&&(isset($outfind[$res_key][$sv_i]))) {
					if ($outfind[$res_key][$sv_i] !== $find[$res_key][$key]) {		// 前回と内容が違う場合追記
						if ((strlen($outfind[$res_key][$sv_i])) < $Meta_Lng) {
							 $outfind[$res_key][$sv_i].=",".$find[$res_key][$key];	// 引数Field から追記
							 }
						else {
							 $res_field[$res_key]=9;
							 $outfind[$res_key][$sv_i].="...";						// 長い場合
							 }
						}
					}
				}
			if ((isset($find["Time"][$key]))&&(isset($outfind["Sec"][$sv_i]))) {
				$outfind["Sec"][$sv_i]+=$find["Time"][$key];
				$outfind["Time"][$sv_i]=edit_time($outfind["Sec"][$sv_i]);
				}
			if (isset($outfind["No"][$sv_i])) {
				$outfind["No"][$sv_i]+=1;
				}
			continue;
			}
		$save=$find[$listcmd][$key];
		$outfind[$listcmd][$i]=$find[$listcmd][$key];	// 引数Filed
		foreach($res_field as $res_key => $res_val) {	// OutputField Serach
			if (($res_val == 1)|| ($res_val == 9)) {	// 引数Field からOutput
				 $filepath = pathinfo($find["file"][$key]);
				 $find['basename'][$key]=$filepath['basename'];
				 if (isset($filepath['extension'])) {
				 	  $find['Codec'][$key]=$filepath['extension'];
					  }
				if  (isset($find[$res_key][$key])) {
					 $outfind[$res_key][$i]=$find[$res_key][$key];
					 }
				else {
					 $outfind[$res_key][$i]="";
					 }
				$res_field[$res_key]=1;
				}
			}
		if ($res_field["directory"] == 2) {
			$filepath = pathinfo($val);				// FilePathを連想配列に格納
			$outfind["directory"][$i]=$filepath['dirname'];
			}
		if ($res_field["Art"] == 2) {
			if ($ART_ON !== 0) {					// Album Art設定あり時 Album List以外は意味がないので設定しない
				$albumart=mpd_editalbumart($val);
				if ($albumart) {
					$outfind["Art"][$i]=$albumart;
					}
				}
			}
		Sort_Filed($SORTFLD,$EXCLUDE,$SORTMOD,$find,$key,$outfind,$i,$SORT_TBL);
		if (isset($find["Time"])) {
			if ($res_field["Sec"] == 2) {	// 秒Output
				$outfind["Sec"][$i]=$find["Time"][$key];
				}
			if ($res_field["Time"] == 2) {
				$outfind["Time"][$i]=edit_time($find["Time"][$key]);	// 秒→分変換Output
				}
			}
		if ($res_field["No"] == 2) {		// 曲数Output
			$outfind["No"][$i]=1;
			}
		$sv_i=$i;
		$i+=1;
		}
	if (!is_array($outfind)) {				// ファイルがあるが内容が取れないケース :Out0件 (mpd 0.17.0)
		return(0);
		}
	$outlist=Sort_Table($outfind,$SORT_TBL); 	// Sort配列をSort (大文字区別なし、定冠詞除外でSort不要があるが)
	if (($warning !=="")&&(!isset($outlist['warning']))) {		// Limit Overが(先頭一致:First)のときなくなっていれば再度つける
		$outlist['warning'][0]=$warning;
		}
	return($outlist);
	}

/*
	mpd_find($field,$query,$mycmd) : Music Find
	 $field  : i  : list Field Artist/AlbumArtist/Album/Genre/Date
	 $query  : i  : query: ["Artist"]={Artist} / ["Genre"]={Genre} / ["Date"]={Date} 組み合わせ
	 $mycmd  : i  : Sort設定取得の拡張 XML:<Sort_{$mycmd}>を使用する。デフォルトは:"find" "find"設定時XML:<Sort_find>を使用する
	 $cmd    : i  : Command: find(完全一致)/search(部分一致,大小文字区別なし)
	 $match  : i  : "1":タイトル先頭一致(大小文字区別なし) Unmatch:output["Unmatch"][$key]:"1" 一致時は配列なし
	 $mtitle : i  : 先頭一致時のタイトル  ※$cmd:find時は意味がないことに注意 
	 $limit  : i  : NULL:Unspecified  / 指定時Line数上限を指定 (based on the file attribute)
	 @return : o  : Output List Array
	 array("file","basename","Title","Disc","Track","Artist","AlbumArtist","Album","Time","Sec","Date","Genre","Last-Modified","Pos","Codec","Art");
	 ※XML設定 <Sort_{$mycmd}> $mycmd:呼び元と同じ設定を使用する。
	           SortKeyの設定<Sort_find><{$field}>:$fieldと一致すれば一致した設定を使用する。一致$fieldがない場合<Sort_find><Default>を使用する。
	           設定がなければ標準(Date,Album,Disc,Track)を使用。表示順が不明となることを避けている。
*/
function mpd_find($field,$query,$mycmd="find",$cmd="find",$match="",$mtitle="",$limit=NULL) {
	global $Net,$ART_CONF,$XML_SORTBASE;
	$SORT_TBL="Sort";

	$args = array();
	if (is_array($field)) {
		 $fieldary = $field;
		 }
	else {
		 $fieldary[]=$field;
		 }
	foreach($query as $key => $val) {
		$args[]=$key;
		$args[]=$val;
		}
	$XML_SORT_FLD=Sort_Para($mycmd,$field,$query,1,"Date,Album,Disc,Track","","",$EXCLUDE,$SORTFLD,$SORTMOD);
	$ART_ON=$ART_CONF["SetNo"];
	if (stristr($ART_CONF["func"],"find") == false) {	// AlbumArt を必要としない場合
		$ART_ON = 0;									//  List 以外はロジックを組めない
		}
	$output = $Net->runCommand($cmd,$args,1,0,"",$limit);	// Album順に取得が前提
	if (!is_array($output)) {
		return($output);
		}
	$warning="";
	if (isset($output['warning'])) {					// Limit Over
		$warning=reset($output['warning']);
		}
	$svdir="";
	$albumart=false;
	if (isset($output["file"])) {
		foreach($output["file"] as $key => $val) {
			if (($match == "1")&&($mtitle !== "")) {	// タイトル先頭一致
				if ((isset($output["Title"][$key]))&&(0===stripos($output["Title"][$key],$mtitle))) { } else {
					 $output["Unmatch"][$key]="1";
					 continue;
					 }
				}
			$filepath = pathinfo($val);					// フルパスを連想配列に格納
			$str=$filepath['dirname'];
			if (($svdir !== $str)&&($ART_ON !== 0)) {	// レスポンスのため前回と同じDirectoryはアルバムアートを取得しない
				$svdir=$str;
				if (in_array("Art",$fieldary)) {
					$albumart=mpd_editalbumart($svdir,"dir");
					}
				}
			if ($albumart) {
				$output["Art"][$key]=$albumart;
				}
			if ($XML_SORT_FLD["SortNo"] != 0) {			// Sort項目指定がある(Sort設定の意味がなくなるのでOutput設定を見ない)
				Sort_Filed($SORTFLD,$EXCLUDE,$SORTMOD,$output,$key,$output,$key,$SORT_TBL);
				}
			mpd_editmusic($output,$key,$fieldary);
			}
		}
	if ((isset($output[$SORT_TBL]))&&(is_array($output[$SORT_TBL]))) {
		 $outsort=Sort_Table($output,$SORT_TBL); 					// Sort配列をSort
		 $output=$outsort;
		 }
	if (($warning !=="")&&(!isset($output['warning']))) {	// Limit Overが(先頭一致:First)のときなくなっていれば再度つける
		$output['warning'][0]=$warning;
		}
	return($output);
	}

/*
	mpd_lsinfo($field,$query) : lsinfo+listplay
	 $field    : i  : list Field Artist/AlbumArtist/Album/Genre/Date ※セレクトしないkindを設定しない。directory/playlist/file
	 $query    : i  : Directory
	 $verbs_srt: i  : SortKeyをイレギュラーに指定できる。 ',':区切り形式。指定がない場合,XML設定ファイルを使用する。 ※"kindconv":kind+kind内容(directory/playlist/file)
	 $artcond  : i  : 1:条件付きArt：MusicData：FileのみArtを取得する
	 @return   : o  : Output List Array

	 ※ $fieldにplaylist:有/directory:無/file:無 <Sort_Lsinfo><Playlist>を使用。他は<Sort_Lsinfo><Directory>を使用

	 array("kind","directory","playlist","file","Title","Disc","Track","Artist","AlbumArtist","Album","Time","Sec","Date","Genre","Last-Modified","Pos","Codec","Art");
	   "urlbasename":URLがhttpのとき別名の"basename"がとれた時セットする
*/
function mpd_lsinfo($field,$query,$verbs_srt="",$artcond=0) {
	global $Net,$ART_CONF,$XML_SORTBASE,$XML_CONF,$LIB_CONF;

	$SORT_TBL="Sort";
	_get_LsinfoFix();							// $LIB_CONF["Lsinfo_Class"] バージョン指定以上は機能off

	$field_flip=array_flip($field);				// Filedを値をキーに転換(Flip)しておく。
	$XML_SORT_EXC["extension"]="";				// 複数field対応可能な構造にしておく
	$XML_SORT_EXC["No"]=get_config("File_listexclude",$XML_SORT_EXC);	// 除外ファイル拡張子
	if (isset($XML_SORT_EXC["extension"])) {
		$extension = explode(",",$XML_SORT_EXC["extension"]);
		}
	$ART_ON=$ART_CONF["SetNo"];
	if (stristr($ART_CONF["func"],"lsinfo") == false) {		// AlbumArt を必要としない場合
		$ART_ON = 0;										//   List 以外はロジックを組めない
		}
	$verbs_fld="Directory";
	if ((in_array("playlist",$field))&&(!in_array("directory",$field))) { $verbs_fld="Playlist"; }
	Sort_Para("Lsinfo",$field,$query,0,"kindconv",$verbs_fld,$verbs_srt,$EXCLUDE,$SORTFLD,$SORTMOD);		// 設定がないとき"kindconv"を設定。Kind(Directory/File/Playlist)∔対応する名称
	$outlist = $Net->runCommand("lsinfo",$query,1,1);		// $cont = 1 ACK Error時(ディレクトリが存在しない)エラーボックスを表示しない
	if (!is_array($outlist)) {
		return($outlist); }
	$albumart=false;$albumart_file=false;		// $albumart:ディレクトリ下 $albumart_file:自ディレクトリのArtを取得
	$Ones_file=0;
	if (isset($outlist["kind"])) {
		$DirSpCheck="off";
		if ($LIB_CONF["Lsinfo_DirNoLimit"] !=="") {
			if ((isset($outlist["directory"]))&&((count($outlist["directory"]) <= $LIB_CONF["Lsinfo_DirNoLimit"]))) { $DirSpCheck="on"; }
			}
		foreach($outlist["kind"] as $key => $val) {
			if (!isset($field_flip[$val])) { continue; }
			Sort_Filed($SORTFLD,$EXCLUDE,$SORTMOD,$outlist,$key,$outlist,$key,$SORT_TBL);
			if ($val =="directory") {
				if (($LIB_CONF["Lsinfo_Class"] == "on")&&($DirSpCheck=="on")) {
					if (mpd_lscheck($outlist[$val][$key],$outdmy) == 1) {	// 多段階で更にDirectoryが続く場合はチェックしない(Responseのため)
						$outlist["kind"][$key]="delete";
						continue; }
					}
				if ($ART_ON !== 0) {				// "Directory":アルバムアート取得
					if (in_array("Art",$field)) {
						$albumart=mpd_editalbumart($outlist[$val][$key],"dir");
						}
					}
				if ($albumart) {
					$outlist["Art"][$key]=$albumart;
					}
				}
			if ($XML_SORT_EXC["No"] !==0) {			// 除外拡張子チェック
				if (($val == "playlist") || ($val == "file")) { 
					 $filepath = pathinfo($outlist[$val][$key]);  // フルパスを連想配列に格納
					 foreach($extension as $exval) {
					 	if ((isset($filepath['extension']))&&($exval == $filepath['extension'])) { // 拡張子チェック一致で除外
							$outlist["kind"][$key]="delete";
							break; }
						}
					 }
				}
			 if ($outlist["kind"][$key]== "file") {
				 if ($Ones_file == 0) {							// "file":アルバムアート レスポンスのため2度取得しない
					 $Ones_file=1;
				 	 if ($ART_ON !== 0) {
						 if ((in_array("Art",$field))||($artcond == 1)) {
							$albumart_file=mpd_editalbumart($outlist[$val][$key]);
							}
						}
					 }
				if ($albumart_file) {
					$outlist["Art"][$key]=$albumart_file;
					}
				}
			mpd_editmusic($outlist,$key,$field);
			}
		$output=Sort_Table($outlist,$SORT_TBL); 				// Sort directory / Filename / Playlist
		}
	return($output);
	}

/*
	mpd_lscheck($path,$outlist) : mpd directory check
	 $path   : i  : check directory
	 $outlist: o  : Output List Array 不要な場合,名前のみ arrayが必要な場合 $output=array();
	 @return : o  : 0:表示データあり,1:表示データなし
	※下位Directoryに表示データがあるかチェック用
	 output arrayが必要時 $outlist=array();$ret=mpd_lscheck($path,$outlist);
	               不要時 $ret=mpd_lscheck($path,$outlist); $outlistに初期値(値)をセットしない
*/
function mpd_lscheck($path,&$outlist) {
	global $Net,$LIB_CONF;

	$output=$Net->runCommand("lsinfo",$path);
	if (!is_array($output)) { return(1); }

//print "DirCnt[".$dircnt."]<BR>";
	if (isset($outlist)) { $outlist=$output; }
	if ((!isset($output["directory"]))&&(!isset($output["file"]))) {
		return(1);
		}
	if (isset($output["file"])) { return(0); }	// File表示対象あり
	if ($LIB_CONF["Lsinfo_Class2nd"] == "off") { return(0); }
	if (count($output["directory"]) > $LIB_CONF["Lsinfo_ClassNoLimit"]) { return(0); }	// チェック
	$fok=0;
	foreach($output["directory"] as $dir) {		// 2階層目をチェック
		$ary=$Net->runCommand("lsinfo",$dir);
		if ((isset($ary["directory"]))||(isset($ary["file"]))) {
			$fok=1;
			break;
			}
		}
	if($fok==0) { return(1); }
	return(0);
	}

/*
	mpd_playlist($field,$query) : Playlist
	 $field  : i  : list Field Artist/AlbumArtist/Album/Genre/Date
	 $query  : i  : listplayid / currentsong / playlistinfo
	 $pos    : i  : positon When ,$query playlistinfo
	 @return : o  : Output List Array

	 array("file","basename","Title","Disc","Track","Artist","AlbumArtist","Album","Time","Sec","Date","Genre","Last-Modified","Pos","Codec","Art");
	   "urlbasename":URLがhttpのとき別名の"basename"がとれた時セットする
	 Statusが停止中はcurrentsongが帰ってこない。playlistinfoで先頭を取得することで同等に扱うことができる
*/
function mpd_playlist($field,$query,$pos=0) {
	global $Net,$ART_CONF;

	$ART_ON=$ART_CONF["SetNo"];
	if (stristr($ART_CONF["func"],$query) == false) {	// AlbumArt を必要としない場合
		$ART_ON = 0;									//  List 以外はロジックを組めない
		}
	if ($query=="playlistinfo") {	// playlistinfoの場合取得するPositonを設定する。
		 $args[]= $pos;
		 }
	else {
		 $args = array();
		 }
	$output = $Net->runCommand($query,$args);
	if (!is_array($output)) {		// Timeout Out 0件
		return($output);
		}
	$svdir="";$base="";
	$albumart=false;
	if (isset($output["file"])) {
		foreach($output["file"] as $key => $val) {
			$filepath = pathinfo($val); // フルパスを連想配列に格納
			$str=$filepath['dirname'];
			if (($svdir !== $str)&&($ART_ON !== 0)) {	// レスポンスのため前回と同じDirectoryはアルバムアートを取得しない
				$svdir=$str;
				if (in_array("Art",$field)) {
					$albumart=mpd_editalbumart($svdir,"dir");
					}
					if ((strpos($val,"http")) === 0) {			// Striming拡張Module mpdweb.playlist.php
						$base="";
						$albumart=mpd_editalbumart($val,"dir",$base);
						if($base !=="") { $output['urlbasename'][$key]=$base; }
						}
				}
			if ($albumart) {
				$output["Art"][$key]=$albumart;
				if($base !=="") { $output['urlbasename'][$key]=$base; }
				}
			mpd_editmusic($output,$key,$field);
			}
		}
	return($output);
	}

/*
	mpd_listplay($field,$query) : Listplay
	 $field  : io : list Field Artist/AlbumArtist/Album/Genre/Date $forceを指定時超えた場合"Art"を削除する
	 $query  : i  : listplay(m3u)
	 $force  : i  : 数値を設定時,$output件数が超えたとき強制的にArtをOFFにする。
	 @return : o  : Output List Array

	 array("file","basename","Title","Disc","Track","Artist","AlbumArtist","Album","Time","Sec","Date","Genre","Last-Modified","Pos","Codec","Art","No");
*/
function mpd_listplay(&$field,$query,$force="") {
	global $Net,$ART_CONF;

	$ART_ON=$ART_CONF["SetNo"];
	if (stristr($ART_CONF["func"],"listplay") == false) {	// AlbumArt を必要としない場合
		$ART_ON = 0;										//  List 以外はロジックを組めない
		}
	$output = $Net->runCommand("listplaylistinfo",$query);
	if (!is_array($output)) {
		return($output);
		}
	if (($force !=="")&&((count($output["file"]))>=(intval($force)))) {		// $forceが指定されたとき、配列数を超えたとき
		 $ART_ON=0;															// 強制ArtOFF
		 if(($key = array_search("Art",$field)) !== false) { unset($field[$key]); }
		 }
	$svdir="";
	$albumart=false;$base="";
	if (isset($output["file"])) {
		if (($ART_ON !== 0)&&(in_array("Art",$field))) {
			$i=1;
			foreach($output["file"] as $key => $val) {	// AlbumArtをアウトするときは,ファイルでSortするため復元用にナンバリング
				$output["No"][$key]=$i;
				$i++;
				}
			$output=Sort_Table($output,"file"); 			// Sort配列をfileでSortしAlbumArtで同じディレクトリを一括する、
			}
		foreach($output["file"] as $key => $val) {
			$filepath = pathinfo($val); // フルパスを連想配列に格納
			$str=$filepath['dirname'];
			if (($svdir !== $str)&&($ART_ON !== 0)) {	// レスポンスのため前回と同じDirectoryはアルバムアートを取得しない
				$svdir=$str;
				if (in_array("Art",$field)) {
					$albumart=mpd_editalbumart($svdir,"dir");
					}
					if ((strpos($val,"http")) === 0) {			// Striming拡張Module mpdweb.playlist.php
						$base="";
						$albumart=mpd_editalbumart($val,"dir",$base);
						if($base !=="") { $output['urlbasename'][$key]=$base; }
						}
				}
			if ($albumart) {
				$output["Art"][$key]=$albumart;
				if($base !=="") { $output['urlbasename'][$key]=$base; }
				}
			mpd_editmusic($output,$key,$field);
			}
		if (($ART_ON !== 0)&&(in_array("Art",$field))) {
			$output=Sort_Table($output,"No"); 			// AlbumArt時,Sort配列をNoでSortし戻す
			}
		}
	return($output);
	}

/*
	mpd_add($field,$query) : Listplay
	 $field  : i  : find / file
	                or Command table  array : clear[0],find[1],play[]
	 $query  : i  : find same find
	                file  file/directory
	                search same search
	 @return : o  : List
*/
function mpd_add($field,$query) {
	global $Net;

	if (!mpd_exclusive("addlist")) {		// サブネットマスクで不許可のときは動作せず正常で返す
		return(0);
		}
	$output=false;
	if (is_array($query)) {
		 $qry = $query;
		 }
	else {
		 $qry[]=$query;
		 }
	if (!is_array($field)) {
		 $fld[] =$field;
		 }
	else {
		 $fld =$field;
		 }
	foreach($fld as $fid_val) {
		if ($fid_val == "file") {
			 foreach($qry as $val) {
				$output=$Net->runCommand("add",$val,0);
				}
			 }
		else if ($fid_val == "find") {
			 foreach($query as $key => $val) {
				$args[]=$key;
				$args[]=$val;
				}
			 $output=$Net->runCommand("findadd",$args);
			 }
		else if ($fid_val == "search") {
			 foreach($query as $key => $val) {
				$args[]=$key;
				$args[]=$val;
				}
			 $output=$Net->runCommand("searchadd",$args);
			 }
		else if ($fid_val == "first") {
			 $output=mpd_addfirst($field,$query);
			 }
		else {
			 $dmy=array();
			 $output=$Net->runCommand($fid_val,$dmy);
			 }
		}
	return($output);
	}

/*
	mpd_addfirst($field,$query) : Listplay Search First
	 $field  : i  : search Command table  array : clear[0],find[1],play[]
	 $query  : i  : search same search
	 @return : o  : mpd:search:$result
*/
function mpd_addfirst($field,$query) {
	global $Net;

	 $field=array("file","Title","Track","Artist","AlbumArtist","Album","Date","Genre");	// $queryに含まれる項目
	if (isset($query["Title"])) {
		$mtitle=$query["Title"];
		}
	$output=mpd_find($field,$query,"find","search",$match="1",$mtitle);		// Find : Command:search
	if (is_array($output)) {
		foreach($output["file"] as $key => $val) {
			if ((isset($output["Unmatch"][$key]))&&($output["Unmatch"][$i]=="1")) { continue; }
			$result=$Net->runCommand("add",$val,0);
			}
		$output=$result;		// Last Result
		}
	return($output);
	}

/*
	mpd_playlistadd($field,$query) : Playlist Add
	 $file   : i  : Playlist File Name (Except .m3u) Not Find Playlist File ,Crate
	 $query  : i  : find    : same mpd_find()  | search : same mpd_find(..."seacrh")
	                playlist: PlaylistをPalylistに追加する(Copyモード)
	                file    : file/directory (Leading "/" unnecessary,directory:Last "/" unnecessary)
	 @return : o  : Count / directory:Directory No , Find:Max Over '-1'

	 $file:Playlist指定は,拡張子'.m3u'不要
	 file/directory:先頭の"/"不要,Directoryの場合最後の"/"不要
	 findの場合,mpd_find()と同じ形式
	 returnは追加できないとき,カウントしない。Findで追加数がオーバしたとき'-1'
*/
function mpd_playlistadd($file,$query,$max=NULL) {
	global $Net;

	if (!mpd_exclusive("playlistadd")) {		// サブネットマスクで不許可のときは動作せず正常で返す
		return(0);
		}
	$output=false;
	if (is_array($query)) {
		 $qry = $query;
		 }
	else {
		 $qry[]=$query;
		 }
	$count=0;
	foreach($qry as $key => $val) {
		if ($key == "file") {			// Fileの場合そのまま追加できる
			 $args=array();
			 $args[]=$file;
			 $args[]=$val;
			 $output=$Net->runCommand("playlistadd",$args,0);
			 if ($output == "") {		// Fileがない
				continue;
			 	}
			 $count=$count+1;
			 }
		else {
			 if ($key == "playlist") {	// Playlistを追加する
				  $arg=array();
				  $arg[]=$val;
				  $output=$Net->runCommand("listplaylistinfo",$arg);
				  }
			 else if ((isset($qry["cmd"]))&&($qry["cmd"]=="first")) {						// Seacerh;first
				  if (isset($qry["Title"])) {
					  $mtitle=$qry["Title"];
					  }
				  $nqey=array();			// Findを使用して追加する
				  foreach($qry as $fid => $qy) {
					if ($fid=="cmd") { continue; }
						$nqey[$fid]=$arg[]=$qy;
						}
				  $output=mpd_find($field,$nqey,"find","search",$match="1",$mtitle);		// Find : Command:search
				  }
			 else {
				  $cmd="find";			// Find,Seaech:Outputを作成しPlaylistを追加
				  if ((isset($qry["cmd"]))&&($qry["cmd"]=="search")) {
					  $cmd="search";
					  }
				  $arg=array();			// Findを使用して追加する
				  foreach($qry as $fid => $qy) {
					if ($fid=="cmd") { continue; }
					$arg[]=$fid;
					$arg[]=$qy;
					}
				  $output=$Net->runCommand($cmd,$arg);
				  }
			 if (!is_array($output)) {
				break;
				}
			 if (!isset($output["file"])) {
				 break;
				}
			 if ((!is_null($max))&&(!$max=="")) {		// 追加FileがMaxを超えたとき終了
				$nmatchcnt=0;
				if (isset($output["Unmatch"])) {
					$nmatchcnt=count($output["Unmatch"]);
					}
				if (((count($output["file"])-$nmatchcnt)) > $max) {
					$count=-1;
					break;
					}
				}
			 foreach($output["file"] as $k => $music) {		// Findの結果で追加する
				if ((isset($output["Unmatch"][$key]))&&($output["Unmatch"][$i]=="1")) { continue; }
				$args=array();
				$args[]=$file;
				$args[]=$music;
				$output=$Net->runCommand("playlistadd",$args,0);
				if ($output == "") {	// Fileがない
					continue;
					}
				$count=$count+1;
				}
			 break;
			 }
		}
	return($count);
	}

/*
	mpd_status($field,$query) : Status
	 $field : i  : "volume","repeat","random","single","consume","playlist","playlistlength","mixrampdb","state",
	               "song","elapsed_sec","elapsed","songid","nextsong","nextsongid","audio","bitrate","updating_db"
	               ※elapsed_sec:生成中の秒 elapsed_all生成中の曲長:elapsed_allがelapsed_secと共に自動編集 
	 $query : i  : Query Item return
	 @return: o  : List or Query

	 array("volume","repeat","random","single","consume","playlist","playlistlength","mixrampdb","state","song","elapsed_sec","elapsed","songid","nextsong","nextsongid","audio","bitrate","updating_db");
*/
function mpd_status($field,$query="") {
	global $Net;

	if (is_array($field)) {
		 $fieldary = $field;
		 }
	else {
		 $fieldary[] = $field;
		 }
	$query_dmy = array();
	$ret=false;
	$output = $Net->runCommand("status",$query_dmy,2);
	if ((!is_array($output))||(!isset($output["state"]))) {		// Timeout Out 0件
		return("Could not get the status");
		}

	foreach($output["state"] as $key => $val) {
		if ($query !== "") {						// $query
			if ((isset($output[$query])) && ($ret == "")) {
				$ret = $output[$query][$key];
				}
			}
		mpd_editstatus($output,$key,$fieldary);
		}
	if ($query !== "") {
		return($ret);
		}
	return($output);
	}

/*
	mpd_update($field,$query) : MPD D/B Update
	 $field : i  : same Status
	 $query : i  : {Directory}/ignore:無条件更新(Update中でもUpdateを実行する/sync:同期(完了を待つ)
	 @return: o  : List or Query

	 array("volume","repeat","random","single","consume","playlist","playlistlength","mixrampdb","state","song","elapsed_sec","elapsed","songid","nextsong","nextsongid","audio","bitrate","updating_db");
	 ※MpdはUpdate Taskが複数動作できる。UpdateのFiledはStatesとおなじ。Filed:Update時、"updating_db"が含まれる。
*/
function mpd_update($field,$query) {
	global $Net,$UPDATE_CONF;

	if (!mpd_exclusive("update")) {		// サブネットマスクで不許可のときは動作せず正常で返す
		return(0); }
	$sleep=5;
	$Update="updating_db";
	if (!is_array($query)) {
		 $para[]=$query; }
	else {
		 $para=$query; }
	$fignore=0;$fsync=0;		// パラメータセット
	$que_dir=array();
	foreach($para as $key => $quy) {
		if ($quy == "ignore") { $fignore = 1; }			// 無条件更新
		else if ($quy == "sync") { $fsync = 1; }		//非同期(完了を待たない)
		else {
			 $que_dir[0] = $quy;	// 更新ディレクトリ
			 }
		}
	$sttime = time();
	$notask=false;
	if ($fignore ==0) {				// 無条件更新でない場合
		while(1) {
			$query_dmy = array();
			$output=array();
			$output = $Net->runCommand("status",$query_dmy,2);
			mpd_editstatus($output,$key,$field);
			if (!isset($output[$Update])) {
				$notask=1;
				break; }
			if ($fsync==0) {			// 非同期時、Update Taskが動いていれば終了
				return($output); }
			$now = time();
			if (($now - $sttime) > $UPDATE_CONF["timeout"]) {
				break; }
			sleep($sleep);
			}
		if (!$notask) {					// 無条件更新でない場合、Update Taskが動いていれば終了(タイムアウトまで)
			return($output); }
		}
	if (($notask)||($fignore == 1)) {	// 無条件更新、Update TaskがなければUpdateを実行
		$output=array();
		$output = $Net->runCommand("update",$que_dir,2);
		mpd_editstatus($output,$key,$field);
		}
	$task=false;
	$sttime = time();
	if ($fsync==1) {					// 同期モード時、タイムアウトまでUpdate Taskの終了を待つ
		while(1) {
			$query_dmy = array();
			$output=array();
			$output = $Net->runCommand("status",$query_dmy,2);
			mpd_editstatus($output,$key,$field);
			if (!isset($output[$Update])) {
				$task=1;
				break; }
			$now = time();
			if (($now - $sttime) > $UPDATE_CONF["timeout"]) {
				break; }
			sleep($sleep);
			}
		}
	return($output);
	}

/*
	mpd_command($command,$args) : mpd command
	 $command : i  : command play/seekcur/next/previous/stop/pause playid/seekid:{id}
                     volume  deleteid/clear  random/repeat/single:{0/1}  load/save:{listplay}
	 $args    : i  : [{prefix}:{key}]値  [$command][key]の"setting/mpdconfig.xml"より変換項目を取得する。
	                 Exc) $field="move"                         Command
	                 $query["From:Title"]="Twilight Zone"  move_Titleで変換
	                 $query["To:Title"]="Anything Goes";   move_Titleで変換
	 @return  : o  : List or Query
*/
function mpd_command($command,$args = array(),$parse = 0,$cont = 1) {
	global $Net;

	$args_req = array();
	$args_dmy = array();
	if (!mpd_exclusive($command)) {		// サブネットマスクで不許可のときは動作せず正常で返す
		return(0);
		}
	foreach($args as $key => $parts) {
		$keypart = explode(':', $key, 2);
		if (isset($keypart[1])) {
			 $keyalt=$keypart[1];
			 }
		else {
			 $keyalt=$key;
			 }
		$cmd_para[$command."_".$keyalt]="";
		$cmd_para["No"]=get_config("Cmd_para",$cmd_para);	// パラメータ変換設定
		if ($cmd_para["No"] !== 0) {
			$playlist = $Net->runCommand("playlistid",$args_dmy);	// playlistidでパラメータを取得する
			if ((is_array($playlist))&&(isset($parts,$playlist[$keyalt]))) {
				$match = array_search($parts,$playlist[$keyalt]);
				if (($match !==false)&&(isset($playlist[$cmd_para[$command."_".$keyalt]][$match]))) {
					 $val=$playlist[$cmd_para[$command."_".$keyalt]][$match];
					 $args_req[]=$val;
					 continue;
					 }
				}
			}
		$args_req[]=$parts;				// 設定がない or playlistで求まらないとき引数をそのまま使用する
		}
	$output = $Net->runCommand($command,$args_req,$parse,$cont);
	if ($output == 1) {					// $output=1はデータなしなので正常に完了と見なす
		$output=0;
		}
	return($output);
	}

/*
	mpd_close() : mpd close
	@return  : o  : output

*/
function mpd_close() {
	global $Net;

	$arg=array();
	$command="close";
	$output=$Net->runCommand($command,$arg);
	return($output);
	}

/*
	mpd_exclusive($command) : mpd Command Subnet exclusive check
	 $output : i  : Check Mpd Command
	 @return : o  : true/false

	command:play,playid,seekcur,seekid,next,previous,stop,pause,setvol,deleteid,clear,random,repeat,single,consume,save,load,rm,addlist,update(*1)
	*1.add/updateはmpdのコマンドではなく関数を止めるため代表名としてライブラリ内定義。
	原則表示系はチェックしない。(表示もしないのであれば何も見せないのと同じ)
	moveは移動するが、mpdに送信しない。
	deleteは行は消えるが、mpdに送信しない。
*/
function mpd_exclusive($command) {
	global $MPD_EXC;

	if ($MPD_EXC['cmd'] == "") {			// 未設定時チェックしない
		return(true);
		}
	$cmd = explode(",",$MPD_EXC['cmd']);
	if (!in_array($command,$cmd)) {			// mpd Commandが設定されていなければチェックしない
		return(true);
		}
	if (!Commn_Subnet($MPD_EXC['netmask'],$_SERVER['REMOTE_ADDR'])) {
		return(false);
		}
	return(true);
	}

/*
	mpd_editstatus($output,$key,$field) : Edit Music Line
	  $output: io  : Output List Array
	                 time/elapsed_sec ->Time mm:ss & All:elapsed_all mm:ss
	                 audio:sumpling/bit/ch bitrate:Edit(kbps)
	  $key   : i   : Edit Point Index
	  $field : i   : Edit Field
*/
function mpd_editstatus(&$output,$key,$field) {
	foreach($field as $fld) {
		if (($fld == "elapsed_sec") && (isset($output["time"][$key]))) {
			 $parts = explode(':',$output["time"][$key],2);
			 if (isset($parts[0],$parts[1])) {
				  $output[$fld][$key]=$parts[0];
				  $output['elapsed_all'][$key]=$parts[1];
				  }
			 }
		else if (!isset($output[$fld][$key])) {
			 continue;
			 }
		else if ($fld == "elapsed") {
			 $output[$fld][$key]=edit_time($output[$fld][$key]);
			 }
		else if ($fld == "audio") {
			 $parts = explode(':',$output[$fld][$key],3);
			 if (isset($parts[0],$parts[1])) {
			 	 $parts[0]=sprintf("%2.1f",preg_replace( '/[^\p{Nd}]/u', '',$parts[0])/1000);
				 if (!isset($parts[2])) { $parts[2]=""; }
				 $output[$fld][$key]=$parts[0]."kHz,".$parts[1]."Bit,".$parts[2]."ch";
				 }
			 }
		else if ($fld == "bitrate") {
			 $output[$fld][$key]=$output[$fld][$key]."kbps";
			 }
		else {
			 $output[$fld][$key]=$output[$fld][$key];
			 }
		msglog("[".$key."][".$fld."] ".$output[$fld][$key]);
		}
	}

//----- class Net_Common ---------------------------------------------------------
/*  ※ PHP 5.3.0 以降でClassが可能になっている
	Net_Common : Network Common
	  $p_connect : io  : パラメータ
		必要なパラメータは__construct下で$p_connectに初期値を設定する。
	設定XMLより同Keyにセットする

	netコマンド関数(Net Cleass)
	<Mpd_net>                             : Mpd Server Connect設定
	    <host>{Hostname}</host>           :  Hostname
	    <port>{Port}</port>               :  Port
	    <pass>{Password}</pass>           :  Password

  Calling Sequence
	1.$XML_CONF = get_loadconfig();          XMLFile Loading
	2.$Net = new Net_Common;                 Net Class Create
	  $Net->timeout=3;						 Timeout (0:No Timeout)
	3.get_config("Mpd_net",$Net->p_connect); Parameta Loading
	4.$Net->connect();                       Connect
	5.～各種機能
	6.mpd_close()
*/
class Net_Common {
	// Connection & Write Errors
	const CONNECTION_NOT_OPENED   = 100;
	const CONNECTION_FAILED       = 102;
	const WRITE_FAILED            = 103;
	// MPD Errors
	const ACK_PASSWORD            = 3;
	const ACK_COMMAND_FAILED      = -100;
	// MPD Responces
	const RESPONSE_OK             = 'OK';

	public $debug                  = false;
//	public $debug                  = true;
	public $filename               = "log/netmpd.log";
	public $logsize                = 300000;

	private   $_connection        = null;
	protected $_errors            = array();
	private   $_current_error     = array();
	protected $_commands          = array();
    protected $_output            = array();

	public $p_connect = array();
	public $ver                   = '';		// mpd version
	public $p_error               = '';		// Error message
	public $w_message             = '';		// Warning message (続行用)
	public $timeout               = 0;		// 0:Timeoutチェックしない
	public $c_timeout 		      = 4;		// Connect TimeOut

    function __construct($host = 'localhost', $port = 6600, $password = null)  {	//__construct インスタンス生成時に自動コール
		$this->p_connect['host'] = $host;
		$this->p_connect['port'] = $port;
		$this->p_connect['password'] = $password;
		}

/*
	connect() : connection status
	 @return : o  :bool
*/
	public function connect() {
		if ($this->isConnected()) {							// Connect済
			return true;
			}
		$connection = @fsockopen($this->p_connect['host'], $this->p_connect['port'], $errn, $errs, $this->c_timeout);	// Openのタイムアウトは固定
		if ($connection) {
			$this->_connection = $connection;
			while(!feof($this->_connection)) { 				// Read from the source until its ready for commands
				$line = fgets($this->_connection);
				$mpd_str = explode('OK', $line, 2);
				if (isset($mpd_str[1])) {
					$this->ver=$mpd_str[1];
					}
				if (trim(substr($line, 0, 2)) == self::RESPONSE_OK) {
					break;
					}
				}
			if (!is_null($this->p_connect['password'])) {
				if (!$this->runCommand('password', $this->p_connect['password'],0)) {
					$this->p_error = 'Net_Common : Connect Password invalid : ACK_PASSWORD('.self::ACK_PASSWORD.')';		// Error Prosess
					return false;
					}
				}
			return true;
			}
		$this->p_error = 'Net_Common : Connect Error connecting: ErrNo:'.$errn.' : '.$errs.' : CONNECTION_FAILED('.self::CONNECTION_FAILED.')';		// Error Prosess
		return false;
		}

/*
	isConnected() : Check connection status
	 @return : o  : bool
*/
	public function isConnected() {
	if (!is_resource($this->_connection)) {
		return false;
		}
	return true;
	}

/*
	close() : connection close
*/
	public function disConnect() {
	@fclose($this->_connection);
	}

/*
	Run command ($command, $args = array(), $parse = 0)
	  $command : i  : string a command to be executed through MPD
	  $args    : i  : mixed string for a single argument, array for multiple
	  $parse   : i  : 0:Line Output  1:kind('directory'/'playlist'/'file') or 1St Item Countup  2:1St Item Countup
	  $cont    : i  : 1:the output is an ACK error ,No Exception
	  $field   : i  : array of Used mpd get Filed ( Directory / playlist / file required by Case )
	  $limit   : i  : NULL:Unspecified  / Specify the number of lines (based on the file attribute)
	  @return  : o  : array of server output
	                  true(1) : No Data / Warning:Message 
	                  false: Network Error
 */
	public function runCommand($command, $args = array(), $parse = 1,$cont = 0,$field = '',$limit=NULL) {
	if (is_array($args)) {				//Generate the command
		foreach($args as $arg) {
			$command.= ' "'.str_replace('"', '\"', $arg) .'"';
			}
		}
	elseif (!is_null($args)) {
			$command.= ' "'.str_replace('"', '\"', $args) .'"';
        	}
	try {
		$this->write($command);				//Write and then capture the output
		}
		catch( Exception $e ) {
		$this->p_error=$e->getMessage();
		return false;
	}
	try {
		$output = $this->read($cont,$field,$limit,$command);
		}
		catch( Exception $e ) {
		$this->p_error=$e->getMessage();
		return false;
	}
	;
	$this->_output[] = array($command, $output);
	if ($output === array()) {
		if ($this->w_message !== "") {		// return : Warning 
			return $this->w_message;
			}
		return 1;							// return : 1 Data 0件 
		}
	if (($parse != 0)&&(is_array($output))){
		return $this->parseOutput($output,$parse);
		}
	return $output;
	}

/*
	write($data) : Write data to the socket
	 $data  : i  : command : string data to be sent
	 @return: o  :  bool
*/
	function write($data) {
	if (!$this->isConnected()) {							//Are we connected?
	    $this->connect();									// Try to connect
		}
	$display_errors=ini_get('display_errors');
	ini_set('display_errors', 0);
	if (!fwrite($this->_connection, $data."\r\n")) {		//Write the data
		ini_set('display_errors',$display_errors);
		return('Write failed : WRITE_FAILED('.self::WRITE_FAILED.')'.$data);
		}
	ini_set('display_errors',$display_errors);
	$this->_commands[] = $data;
	$this->tcplog("Send  :".$data."\n");
	return true;
	}

/*
	read($cont) : Read data from the socket
	  $cont   : i  : 1:the output is an ACK error ,No Exception
	  $field  : i  : array of Used mpd get Filed ( Directory / playlist / file required by Case )
	  $limit  : i  : NULL:Unspecified  / Specify the number of lines (based on the file attribute)
	  $command: i  : write Command, Valid when Limit is specified ,Decide how to count
	  @return : o  : array of raw output
*/
	function read($cont=1,$field='',$limit=NULL,$command) {

	if (is_array($field)) {					// Make Used mpd get Filed Array
		$infld=array_flip ($field);
		$infld['file']="";
		}
	$fldtop="file";
	if (!is_null($command)) { if (strpos(trim($command),'list') === 0) { $fldtop=""; } }	// Count Filed "" Every Cpinmt Else files Count)
	$display_errors=ini_get('display_errors');
	ini_set('display_errors', 0);
	if (!$this->isConnected()) {			//Are we connected?
		ini_set('display_errors',$display_errors);
		return('Not connected : CONNECTION_NOT_OPENED('.self::CONNECTION_NOT_OPENED.')');
		}
	ini_set('display_errors',$display_errors);
	$this->w_message="";
	$ret=false;
	$output = array();
	if ($this->timeout != 0) {
		socket_set_timeout($this->_connection, $this->timeout);
		}
	$start_time = time();
	$cnt=0;
	while (!feof($this->_connection)) {			//Loop through the connection, putting the data into $line
		$line = fgets($this->_connection);

		if ($this->timeout != 0) {
			$stat = socket_get_status($this->_connection);	// ソケットがタイムアウトか
 			if ($stat["timed_out"]) {
				$this->tcplog("Timeout\n");
				$this->w_message="Timeout";
				$ret="Timeout";
				}
			}
		$end_time = time();
		if (($this->timeout != 0) &&(($end_time - $start_time) > $this->timeout)) {		// 受信メッセージが長すぎる
			$this->disConnect();							// Bufferを捨てるため Disconnect / Connect
			$this->connect();
			$this->tcplog("Timeout (Get too long)\n");
			$this->w_message="Timeout (Get too long)";
			$ret="Timeout (Get too long)";
			break;
			}

		$this->tcplog("Recive:".$line."\n");
		if (($cont)&&(preg_match('/^ACK \[(.*?)\@(.*?)\] \{(.*?)\} (.*?)$/', $line, $matches))) {	//If the output is an ACK error
			$this->w_message="No objective data";
			$ret=$line;
			break;
			}
		if (preg_match('/^ACK \[(.*?)\@(.*?)\] \{(.*?)\} (.*?)$/', $line, $matches)) {		//If the output is an ACK error
			//$this->runCommand('clearerror'); //Cleanup the error
 			$this->_errors[] = $matches;
			$this->_current_error = array('ack' => $matches[1], 'func' => $matches[3], 'error' => $matches[4]);
			throw new Exception('Command Failed : ACK_COMMAND_FAILED('.self::ACK_COMMAND_FAILED.')'.$line);
			}
		elseif (trim($line) == self::RESPONSE_OK) {				//The last line of output was hit, close the loop
			 break;
			 }
		else {
			 if (is_array($field)) {
				 $parts = explode(': ',$line,2);
				 if ((isset($parts[1]))&&(!isset($infld[$parts[0]]))) { continue; }	// When , Not Use Fileds go to continue
				 }
			 if (!is_null($limit)) {							// Line upper limit specified
				if($fldtop =="") {									// One Filed ,Direct Count
					$cnt=$cnt+1;
					 if ($cnt > $limit) {
						  $output[]="warning: line suspended due to upper limit:".$limit;
						  break;
						  }
					 }
				else {
					 $item = explode(': ',$line,2);
					 if ($item[0] =="file") {					// file attribute is the starting point
						$cnt=$cnt+1;
						if ($cnt > $limit) {
						 	$output[]="warning: line suspended due to upper limit:".$limit;
							break;
							}
						}
					 }
				 }
//print 'Line:'.$line.'<BR>';
			$output[] = $line;								//Output from the server added to the return array
			}
		}
	if ($ret){
		return $ret;
		}
	return $output;
	}

/*
	Parse MPD output on a line-by-line basis creating output that is easy to work with
	  $input : array of input from MPD
	  $parsee: 1:kind('directory'/'playlist'/'file') or 1St Item Countup  2:1St Item Countup
	  @return array
*/
	public function parseOutput($input,$parse = 1) {
	if (!is_array($input)) {
		$input = array($input);
		}
	$output = array();
	$key1st="";
	$i=0;
	foreach($input as $line) {
		if (is_array($line)) {
			$this->tcplog("Server output not expected Get Line Array:".print_r($line, true));
			$this->_errors[] = 'Server output not expected: '.print_r($line, true);
			continue;
			}
		$parts = explode(': ', $line, 2);
		if (!isset($parts[0], $parts[1])) {
			$this->tcplog("Server output not expected Nor(:) :".$line);
			$this->errors[] = 'Server output not expected: '.$line;
			continue;
			}
		$key   = trim($parts[0]);
		if ($key=="Title") { $value=preg_replace('/\r\n|\r|\n/','',$parts[1]); } else { $value = trim($parts[1]); }
		if (($parse == 1) && (($key == 'directory') || ($key == 'playlist') || ($key == 'file'))) {	// File/Directory/Playlistいずれかがlsinfo/Findでくる
			 $ix_key="kind";
			 }
		else {
			 $ix_key=$key;
			 }
		if ($key1st == "") {			// 最初のKeyを起点にする
			$key1st=$key;
			}
		else if (($key1st == $key) || ($ix_key == "kind")) {	// 最初のKey,File/Directory/Playlistも起点にする
				 $i+=1;
				 }
		if ($ix_key == "kind") {		// File/Directory/Playlistを抜かないようにする
			$output["kind"][$i] = $key;
			}
		$output[$key][$i] = $value;
		}
	return $output;
	}

/*
	tcplog($log) : MessageLog
	 $log : i  :logmsg
	Parse MPD output on a line-by-line basis creating output that is easy to work with
*/
	public function tcplog($logmsg) {
	if ($this->debug) {
		$fp = fopen($this->filename, "a");
		$size = filesize($this->filename);
		if ($size > $this->logsize) {
			@rename($this->filename,$this->filename.".old");
			$fp = fopen($this->filename, "w");
			}
		fwrite($fp,date("Y/m/d H:i:s")." ".$logmsg);
    	fclose($fp);
		}
	}

//----- class Net_Common End----------------------------------------------------
 }
//----- Source End --------------------------------------------------------------
?>
