<?php
/*******************************************************************************
	mpd Command function Shared Memory library (mpd{module}.lib_mpdshm.php)
	  Shared Memory On/Off いづれでも動作可 (Off時,"mpdclient.lib.php"を使用)
*******************************************************************************/
/*
  Calling Sequence
	1.$XML_CONF = get_loadconfig();          XMLFile Loading
	2.get_libinit();                         Library Initialize
	global $XML_CONF,$ART_CONF,$UPDATE_CONF;がLoadされる
  Network
	1.$XML_CONF = get_loadconfig();          XMLFile Loading
	  $Net->timeout=3;						 Timeout (0:No Timeout)
	2.$Net = new Net_Common;                 Net Class Create
	3.get_config("Mpd_net",$Net->p_connect); Parameta Loading
	4.$Net->connect();                       Connect
	5.～各種機能
	6.mpd_close()

	global $Net : Libraryにて$Netで使用している
*/
/* Shared Memory での組み込みモジュール
	mpd_list()    :SHM_ListGet()/SHM_ListPut()
	mpd_find()    :SHM_ArtGet()/SHM_ArtPut()
	mpd_lsinfo()  :SHM_FileGet()/SHM_FilePut()/SHM_ArtGet()/SHM_ArtPut()
	mpd_playlist():SHM_ArtGet()/SHM_ArtPut()
	mpd_listplay():SHM_ArtGet()/SHM_ArtPut()
	mpd_editstatus()  :SHM_StatClear()
	mpd_editalbumart():Partition function ,_mpd_editalbumart_host
*/
//----- mpd function's  ----------------------------------------------------------------
/*
	mpd_version()
	@return : o  : Version
*/
function mpd_version() {
	$LIB_VERSION=basename(__FILE__)." 1.37 (30.12.2024)";
	return($LIB_VERSION);
	}

/*
	mpd_list($field,$query,$verbs_fld,$verbs_srt) : mpd list
	 $field    : i  : list Field Artist/AlbumArtist/Album/Genre/Date (先頭はSelect対象を設定する)
	 $query    : i  : query: ["Artist"]={Artist} / ["Genre"]={Genre} / ["Date"]={Date} 組み合わせ
	 $verbs_fld: i  : Sort対象設定Filedイレギュラーに指定できる。複数$field時有効。XML設定 <Sort_{$field先頭}><$verbs_fld>
	 $verbs_srt: i  : SortKeyをイレギュラーに指定できる。 ',':区切り形式。指定がない場合,XML設定ファイルを使用する。
	 $limit    : i  : Size Limit mpd I/FでのLine上限を設定 NULLは制限なし
	 $limit2   : i  : Size Limit2 $verbs_fldArgument/$verbs_srtにより Find(mpd_list_find)に切り替わったときの上限を設定
	 @return   : o  : Output List Array

	  ex 1) $field="Artist";
	     2) $field="Album";
			$query["Artist"]="10cc";

	 array("Album","directory","Artist","AlbumArtist","Date","Art","Time","Sec","No","Genre");
	 array("Album");(高速モードFiled/Sortなし)
	 ※"Time","Sec","No"(曲数):集計値
*/
function mpd_list($field,$query=array(),$verbs_fld="",$verbs_srt="",$limit=NULL,$limit2=NULL) {
	global $Net,$ART_CONF,$XML_SORTBASE,$XML_LISTUNIQUE;

	if (is_array($field)) {		// 先頭は必ずList項目
		 $listcmd=$field[0];
		 $sortcmd=$field[0];	// XML設定:<Sort_{$sortcmd}となる
		 $fieldary=$field;
		 }
	else {						// Listモード(高速モード,Artなし)
		 $listcmd=$field;		// List以外項目が必要なければ配列を使用しない。 
		 $sortcmd="List";$verbs_fld=$field;	// XML設定:<Sort_{$sortcmd}<{$field}>となる
		 $fieldary[]=$field;
		 }
	$ART_ON=$ART_CONF["SetNo"];
	if (stristr($ART_CONF["func"],"album") == false) {		// AlbumArtを必要としない場合(Albumを対象としない)
		 $ART_ON = 0;										//  List 以外はロジックを組めない
		 }
	if (($ART_ON !== 0)&&((is_array($field))&&(!in_array("Art",$field)))||((!is_array($field))&&($field !== "Art"))) {	// AlbumArtを格納Fieldがない場合はArtなしにする
		 $ART_ON = 0;
		 }
	$XML_SORT_FLD=Sort_Para($sortcmd,$fieldary,$query,0,"",$verbs_fld,$verbs_srt,$EXCLUDE,$SORTFLD,$SORTMOD);
	if (($query)&&(($XML_SORT_FLD["Sort_on"] !== 0)||($ART_ON !== 0)||(is_array($field))&&(sizeof($field) > 1))) {		// AlbumArtあり&Field:"Art"あり時，FindコマンドでList作成
		 $outlist=mpd_list_find($fieldary,$query,$XML_SORT_FLD["SortStr"],$ART_ON,0,$limit2);
		 return($outlist);
		 }
	$args = array();							// 条件がないのでListコマンドで作成
	$args[]=$listcmd;
	foreach($query as $key => $val) {
		 $args[]=$key;
		 $args[]=$val;
		 }
	$warning="";
	$array=SHM_ListGet($listcmd,$query);		// Shared Memoryから取得(条件が合えば)
	$outlist=$array;
	if ($array==false) {						// Shared Memoryから取得できなかったときはMPDから取得
		$outlist = $Net->runCommand("list",$args,1,0,"",$limit);
		SHM_ListPut($listcmd,$outlist,$query);	// MPDから取得したときShared Memoryに書き込む(条件が合えば)
		}
	SHM_Term();									// Shared Memory Terminate
	if (!is_array($outlist)) {		// Out 0件
		 return($outlist); }
	if(in_array($listcmd,$XML_LISTUNIQUE)) {	// 単一Field取得時，指定のFiledがunUniqueの場合,Unique削除する
		if (isset($outlist[$listcmd])) { $outlist[$listcmd] = array_unique($outlist[$listcmd]); }
		}
	if (isset($output['warning'])) {					// Limit Over
		$warning=reset($output['warning']);
		}
	if ((!is_array($SORTFLD))||(count($SORTFLD) == 0)) {
		$SORTFLD[0]=$listcmd;
		}
	if ((isset($EXCLUDE[$listcmd]))&&(count($EXCLUDE[$listcmd]) > 0)) {						// Sort除外冠詞の確認
		 $SORT_TBL="Sort";
		 foreach($outlist[$listcmd] as $key => $val) {
			Sort_Filed($SORTFLD,$EXCLUDE,$SORTMOD,$outlist,$key,$outlist,$key,$SORT_TBL);
			}
		 $output=Sort_Table($outlist,$SORT_TBL);
		 }
	else {
		 $etc="";
		 if ($XML_SORTBASE["Sort_Capital"] == "on") {			// 大/小文字区別なし
		  	$etc="-Sort";
			foreach($outlist[$listcmd] as $key => $val) {
				Sort_Filed($SORTFLD,$EXCLUDE,$SORTMOD,$outlist,$key,$outlist,$key,$listcmd.$etc);
				}
			}
		 $output=Sort_Table($outlist,$listcmd.$etc);			// Sort条件がない場合でもList対象でSortしておく(mpdは発生順にセレクト)
		 }
	if (($warning !=="")&&(!isset($output['warning']))) {		// Limit Overが(先頭一致:First)のときなくなっていれば再度つける
		$output['warning'][0]=$warning;
		}
	return($output);
	}

/*
	mpd_list_find($field,$query,$XML_SORT_FLD) : list(Used Find) mpd_listから条件によりCallされる。
	 $field         : i  : list Field Artist/AlbumArtist/Album/Genre/Date (先頭はSelect対象を設定する)
	 $query         : i  : query: ["Artist"]={Artist} / ["Genre"]={Genre} / ["Date"]={Date} 組み合わせ
	 $sortstr       : i  : Sort String ","区切り
	 $ART_ON        : i  : {n}:ARTが必要時 0:ART不要(呼び元で$ART_CONFをもとに判定しセット)
	 $direct        : i  : Direct Call:"1"; Else 0(Calld "mpd_list()");
	 $limit         : i  : mpd read Limit (AlbumのCountではなくファイル数に注意) , NULL制限なし
	 @return        : o  : Output List ArrayList / true(1) : No Data / Warning:Message / false: Network Error
	 array("Album","directory","Artist","AlbumArtist","Date","Art","Time","Sec","No","Genre");
	 ※"Time","Sec","No"(1曲数):集計値
	 $XML_SORTBASE On 大文字/小文字区別なし
*/
function mpd_list_find($field,$query,$sortstr,$ART_ON,$direct=0,$limit=NULL) {
	global $Net,$LIB_CONF,$XML_SORTBASE;
	$SORT_TBL="Sort";

	$Meta_Lng=64;
	$start_time = time();
	$ap_timeout=0;
	if (isset($LIB_CONF["LoopTimeout"])) {
		$ap_timeout=$LIB_CONF["LoopTimeout"];		// Special Setting : $LIB_CONF["LoopTimeout"]が設定されていたらループを打ち切る設定として使用
		}
// 0:加工field,1:Output(引数fieldより追加,追記),2:加工fieldを引数fieldによりOutput ,9:「1」の項目が追記により長くなったとき一時止める
	$res_field=array("directory"=>0,"Art"=>0,"Time"=>0,"Sec"=>0,"No"=>0,"Sort"=>0);	// 要加工OutputField ロジックを組み込んでいるため関数内で設定している
	foreach($field as $key => $val) {			// OutputFieldを設定
		if (isset($res_field[$val])) {
			 $res_field[$val]=2;
			 }
		else {
			 $res_field[$val]=1;
			 }
		}
	$listcmd=$field[0];
	if ($sortstr !== "") {
		 $sortpara=$sortstr;	// 設定のSortFieldを選択
		 }
	else {
		 $sortpara="Album";									// List機能として、SortがなくてもAlbum順にしておく。(大/小文字区別,定冠詞除外も適用される)
		 }
	$XML_SORT_FLD=Sort_Para($listcmd,$field,$query,0,"","",$sortpara,$EXCLUDE,$SORTFLD,$SORTMOD);
	$find_query = array();
	foreach($query as $key => $val) {
		$find_query[]=$key;
		$find_query[]=$val;
		}
	$warning="";
	$find=$Net->runCommand("find",$find_query,1,0,$field,$limit,"list");	// listと同じ条件でFind実行
	if (!is_array($find)) {		// Out 0件
		return($find);
		}
	if (isset($find['warning'])) {					// Limit Over
		$warning=reset($find['warning']);
		}
	$find=Sort_Table($find,$field[0]);				// Select対象(Field第1項目)でSort
	$i=0;
	$save="";$outfind=array();
	if (($ART_ON !== 0)&&($res_field["Art"] == 2)) {	// Shared MemoryからAlbum Artを取得
		SHM_ArtGet($find);
		}
	foreach($find["file"] as $key => $val) {
		$end_time = time();
		if (($ap_timeout != 0) &&(($end_time - $start_time) > $ap_timeout)) {		// $LIB_CONF["LoopTimeout"]が設定されていたらループを打ち切る
			return("Timeout (loop too long)");
			}
		if (!isset($find[$field[0]][$key])) {		// Fileがあるが、Select対象がない場合
			$find[$field[0]][$key]=" ";				//   対象データを保証する
			}
		if ($save ==$find[$listcmd][$key]) {				// 引数Fieldを集約(例:1アルバム1file)
			foreach ($res_field as $res_key => $res_val) {	// 出力対象の場合追記
				if (($res_val == 1)&&(isset($find[$res_key][$key]))&&(isset($outfind[$res_key][$sv_i]))) {
					if ($outfind[$res_key][$sv_i] !== $find[$res_key][$key]) {		// 前回と内容が違う場合追記
						if ((strlen($outfind[$res_key][$sv_i])) < $Meta_Lng) {
							 $outfind[$res_key][$sv_i].=",".$find[$res_key][$key];	// 引数Field から追記
							 }
						else {
							 $res_field[$res_key]=9;
							 $outfind[$res_key][$sv_i].="...";						// 長い場合
							 }
						}
					}
				}
			if ((isset($find["Time"][$key]))&&(isset($outfind["Sec"][$sv_i]))) {
				$outfind["Sec"][$sv_i]+=$find["Time"][$key];
				$outfind["Time"][$sv_i]=edit_time($outfind["Sec"][$sv_i]);
				}
			if (isset($outfind["No"][$sv_i])) {
				$outfind["No"][$sv_i]+=1;
				}
			continue;
			}
		$save=$find[$listcmd][$key];
		$outfind[$listcmd][$i]=$find[$listcmd][$key];	// 引数Filed
		foreach($res_field as $res_key => $res_val) {	// OutputField Serach
			if (($res_val == 1)|| ($res_val == 9)) {	// 引数Field からOutput
				 $filepath = pathinfo($find["file"][$key]);
				 $find['basename'][$key]=$filepath['basename'];
				 if (isset($filepath['extension'])) {
				 	  $find['Codec'][$key]=$filepath['extension'];
					  }
				if  (isset($find[$res_key][$key])) {
					 $outfind[$res_key][$i]=$find[$res_key][$key];
					 }
				else {
					 $outfind[$res_key][$i]="";
					 }
				$res_field[$res_key]=1;
				}
			}
		if ($res_field["directory"] == 2) {
			$filepath = pathinfo($val);				// FilePathを連想配列に格納
			$outfind["directory"][$i]=$filepath['dirname'];
			}
		if ($res_field["Art"] == 2) {
			if ($ART_ON !== 0) {					// Album Art設定あり時 Album List以外は意味がないので設定しない
				if (!isset($find["ArtComp"][$key])) {
					 $albumart=mpd_editalbumart($val); }
				else if ($find["ArtComp"][$key]==1){	// Shared Memory AlbumArt== False
					 $albumart=false;
					 $outfind["ArtComp"][$i]=$find["ArtComp"][$key];	// ["ArtComp"]があると SHM_ArtPut()で更新しない
					 }
				else {
					 $albumart=$find["Art"][$key];						// Shared Memory AlbumArt== Hit!!
					 $outfind["ArtComp"][$i]=$find["ArtComp"][$key];	// ["ArtComp"]があると SHM_ArtPut()で更新しない
					 }
				if (($albumart)&&(!isset($outfind["Art"][$i]))) {
					$outfind["Art"][$i]=$albumart;
					}
				}
			}
		Sort_Filed($SORTFLD,$EXCLUDE,$SORTMOD,$find,$key,$outfind,$i,$SORT_TBL);
		if (isset($find["Time"])) {
			if ($res_field["Sec"] == 2) {	// 秒Output
				$outfind["Sec"][$i]=$find["Time"][$key];
				}
			if ($res_field["Time"] == 2) {
				$outfind["Time"][$i]=edit_time($find["Time"][$key]);	// 秒→分変換Output
				}
			}
		if ($res_field["No"] == 2) {		// 曲数Output
			$outfind["No"][$i]=1;
			}
		$sv_i=$i;
		$i+=1;
		}
	if (!is_array($outfind)) {				// ファイルがあるが内容が取れないケース :Out0件 (mpd 0.17.0)
		return(0);
		}
	if (($ART_ON !== 0)&&($res_field["Art"] == 2)) {			// Shared MemoryからAlbum Artを取得
		SHM_ArtPut($outfind);
		}
	$outlist=Sort_Table($outfind,$SORT_TBL); 	// Sort配列をSort (大文字区別なし、定冠詞除外でSort不要があるが)
	if (($warning !=="")&&(!isset($outlist['warning']))) {		// Limit Overが(先頭一致:First)のときなくなっていれば再度つける
		$outlist['warning'][0]=$warning;
		}
	if ($direct !== 0) {						// Direct Call
		SHM_Term();								//   Shared Memory Terminate
		}
	return($outlist);
	}

/*
	mpd_find($field,$query,$mycmd) : Music Find
	 $field  : i  : list Field Artist/AlbumArtist/Album/Genre/Date
	 $query  : i  : query: ["Artist"]={Artist} / ["Genre"]={Genre} / ["Date"]={Date} 組み合わせ
	 $mycmd  : i  : Sort設定取得の拡張 XML:<Sort_{$mycmd}>を使用する。デフォルトは:"find" "find"設定時XML:<Sort_find>を使用する
	 $cmd    : i  : Command: find(完全一致)/search(部分一致,大小文字区別なし)
	 $match  : i  : "1":タイトル先頭一致(大小文字区別なし) Unmatch:output["Unmatch"][$key]:"1" 一致時は配列なし
	 $mtitle : i  : 先頭一致時のタイトル  ※$cmd:find時は意味がないことに注意 
	 $limit  : i  : NULL:Unspecified  / 指定時Line数上限を指定 (based on the file attribute)
	 @return : o  : Output List Array
	 array("file","basename","Title","Disc","Track","Artist","AlbumArtist","Album","Time","Sec","Date","Genre","Last-Modified","Pos","Codec","Art");
	 ※XML設定 <Sort_{$mycmd}> $mycmd:呼び元と同じ設定を使用する。
	           SortKeyの設定<Sort_find><{$field}>:$fieldと一致すれば一致した設定を使用する。一致$fieldがない場合<Sort_find><Default>を使用する。
	           設定がなければ標準(Date,Album,Disc,Track)を使用。表示順が不明となることを避けている。
*/
function mpd_find($field,$query,$mycmd="find",$cmd="find",$match="",$mtitle="",$limit=NULL) {
	global $Net,$ART_CONF,$XML_SORTBASE;
	$SORT_TBL="Sort";

	$args = array();
	if (is_array($field)) {
		 $fieldary = $field;
		 }
	else {
		 $fieldary[]=$field;
		 }
	foreach($query as $key => $val) {
		$args[]=$key;
		$args[]=$val;
		}
	$XML_SORT_FLD=Sort_Para($mycmd,$field,$query,1,"Date,Album,Disc,Track","","",$EXCLUDE,$SORTFLD,$SORTMOD);
	$ART_ON=$ART_CONF["SetNo"];
	if (stristr($ART_CONF["func"],"find") == false) {	// AlbumArt を必要としない場合、
		$ART_ON = 0;									//   List 以外はロジックを組めない
		}
	$output = $Net->runCommand($cmd,$args,1,0,"",$limit,"find");	// Album順に取得が前提
	if (!array($output)) {
		return($output);
		}
	$warning="";
	if (isset($output['warning'])) {					// Limit Over
		$warning=reset($output['warning']);
		}
	if (in_array("Art",$fieldary)) {					// Shared MemoryからAlbum Artを取得
		SHM_ArtGet($output);
		}
	$svdir="";
	$albumart=false;
	if (isset($output["file"])) {
		foreach($output["file"] as $key => $val) {
			if (($match == "1")&&($mtitle !== "")) {	// タイトル先頭一致
				if ((isset($output["Title"][$key]))&&(0===stripos($output["Title"][$key],$mtitle))) { } else {
					 $output["Unmatch"][$key]="1";
					 continue;
					 }
				}
			$filepath = pathinfo($val);					// フルパスを連想配列に格納
			$str=$filepath['dirname'];
			if (($svdir !== $str)&&($ART_ON !== 0)) {	// レスポンスのため前回と同じDirectoryはアルバムアートを取得しない
				$svdir=$str;
				if (in_array("Art",$fieldary)) {
					if (!isset($output["ArtComp"][$key])) {
						 $albumart=mpd_editalbumart($svdir,"dir");
						 }
					else if ($output["ArtComp"][$key]==1) {			// Shared Memory AlbumArt== False
						 $albumart=false;
						 }
					else {
						 $albumart=$output["Art"][$key];			// Shared Memory AlbumArt== Hit!!
						 }
					}
				}
			if (($albumart)&&(!isset($output["Art"][$key]))) {
				$output["Art"][$key]=$albumart;
				}
			if ($XML_SORT_FLD["SortNo"] != 0) {			// Sort項目指定がある(Sort設定の意味がなくなるのでOutput設定を見ない)
				Sort_Filed($SORTFLD,$EXCLUDE,$SORTMOD,$output,$key,$output,$key,$SORT_TBL);
				}
			mpd_editmusic($output,$key,$fieldary);
			}
		}
	if ((isset($output[$SORT_TBL]))&&(is_array($output[$SORT_TBL]))) {
		 $outsort=Sort_Table($output,$SORT_TBL); 		// Sort配列をSort
		 $output=$outsort;
		 }
	if (in_array("Art",$fieldary)) {					// Shared MemoryにAlbum Artを書き込み
		SHM_ArtPut($output);
		}
	if (($warning !=="")&&(!isset($output['warning']))) {	// Limit Overが(先頭一致:First)のときなくなっていれば再度つける
		$output['warning'][0]=$warning;
		}
	SHM_Term();											//   Shared Memory Terminate
	return($output);
	}

/*
	mpd_lsinfo($field,$query) : lsinfo+listplay
	 $field    : i  : list Field Artist/AlbumArtist/Album/Genre/Date ※セレクトしないkindを設定しない。directory/playlist/file
	 $query    : i  : Directory
	 $verbs_srt: i  : SortKeyをイレギュラーに指定できる。 ',':区切り形式。指定がない場合,XML設定ファイルを使用する。 ※"kindconv":kind+kind内容(directory/playlist/file)
	 $artcond  : i  : 1:条件付きArt：MusicData：FileのみArtを取得する
	 @return   : o  : Output List Array

	 ※ $fieldにplaylist:有/directory:無/file:無 <Sort_Lsinfo><Playlist>を使用。他は<Sort_Lsinfo><Directory>を使用

	 array("kind","directory","playlist","file","Title","Disc","Track","Artist","AlbumArtist","Album","Time","Sec","Date","Genre","Last-Modified","Pos","Codec","Art");
*/
function mpd_lsinfo($field,$query,$verbs_srt="",$artcond=0) {
	global $Net,$ART_CONF,$XML_SORTBASE,$XML_CONF,$LIB_CONF;
	$SORT_TBL="Sort";
	_get_LsinfoFix();							// $LIB_CONF["Lsinfo_Class"] バージョン指定以上は機能off

	$field_flip=array_flip($field);				// Filedを値をキーに転換(Flip)しておく。
	$XML_SORT_EXC["extension"]="";				// 複数field対応可能な構造にしておく
	$XML_SORT_EXC["No"]=get_config("File_listexclude",$XML_SORT_EXC);	// 除外ファイル拡張子
	if (isset($XML_SORT_EXC["extension"])) {
		$extension = explode(",",$XML_SORT_EXC["extension"]);
		}
	$ART_ON=$ART_CONF["SetNo"];
	if (stristr($ART_CONF["func"],"lsinfo") == false) {		// AlbumArt を必要としない場合、
		$ART_ON = 0;										//   List 以外はロジックを組めない
		}
	$verbs_fld="Directory";$array=false;
	if ((in_array("playlist",$field))&&(!in_array("directory",$field))) { $verbs_fld="Playlist"; }
	Sort_Para("Lsinfo",$field,$query,0,"kindconv",$verbs_fld,$verbs_srt,$EXCLUDE,$SORTFLD,$SORTMOD);		// 設定がないとき"kindconv"を設定。Kind(Directory/File/Playlist)∔対応する名称
	if ($verbs_fld=="Directory") {
		$array=SHM_FileGet($query);						// Shared Memoryから取得(条件が合えば)
		}
	if ($array==false) {								// Shared Memoryから取得できなかったときはMPDから取得
		 $outlist = $Net->runCommand("lsinfo",$query,1,1);		// $cont = 1 ACK Error時(ディレクトリが存在しない)エラーボックスを表示しない
		 if ($verbs_fld=="Directory") {
			 $outshare = $outlist;
			 if (is_array($outlist)) {
				if (isset($outshare["playlist"])) {
					foreach($outshare["playlist"] as $key => $val) {		// Playlistを多数持っているケースでSharedMemoryを消費するので削除
						unset($outshare["kind"][$key]);
						unset($outshare["Last-Modified"][$key]);
						}
					unset($outshare["playlist"]);
					}
				 }
			}
		 }
	else {
		 $outlist = $array;
		 }
	if (!is_array($outlist)) {
		return($outlist); }
	$albumart=false;$albumart_file=false;		// $albumart:ディレクトリ下 $albumart_file:自ディレクトリのArtを取得
	$Ones_file=0;
	if (($ART_ON !== 0)&&(in_array("Art",$field))) {						// Shared MemoryからAlbum Artを取得
		SHM_ArtGet($outlist);
		}
	if (isset($outlist["kind"])) {
		$DirSpCheck="off";
		if ($LIB_CONF["Lsinfo_DirNoLimit"] !=="") {
			if ((isset($outlist["directory"]))&&((count($outlist["directory"]) <= $LIB_CONF["Lsinfo_DirNoLimit"]))) { $DirSpCheck="on"; }
			}
		foreach($outlist["kind"] as $key => $val) {
			if (!isset($field_flip[$val])) { continue; }
			Sort_Filed($SORTFLD,$EXCLUDE,$SORTMOD,$outlist,$key,$outlist,$key,$SORT_TBL);
			if ($val =="directory") {
				if (($LIB_CONF["Lsinfo_Class"] == "on")&&($DirSpCheck=="on")) {
					if ($array==false) {										// Shared Memoryから取得できなかったときはMPDから取得
						if (mpd_lscheck($outlist[$val][$key],$outdmy) == 1) {	// 多段階で更にDirectoryが続く場合はチェックしない(Responseのため)
							$outlist["kind"][$key] ="delete";
							$outshare["kind"][$key]="delete";
							continue; }
						}
					}
				if (($ART_ON !== 0)&&(in_array("Art",$field))) {		// "Directory":アルバムアート取得
					if  (!isset($outlist["ArtComp"][$key])) {
						 $albumart=mpd_editalbumart($outlist[$val][$key],"dir");
						 }
					else if ($outlist["ArtComp"][$key]==1) {			// Shared Memory AlbumArt== False
						 $albumart=false;
						 }
					else {
						 $albumart=$outlist["Art"][$key];			// Shared Memory AlbumArt== Hit!!
						 }
					}
				if (($ART_ON !== 0)&&($albumart)&&(!isset($outlist["Art"][$key]))) {	// 前回と同じDirectory,前回と同じAlbumArt (Shared Memoryで未セット)
					$outlist["Art"][$key]=$albumart;
					}
				}
			if ($XML_SORT_EXC["No"] !==0) {			// 除外拡張子チェック
				if (($val == "playlist") || ($val == "file")) { 
					 $filepath = pathinfo($outlist[$val][$key]);  // フルパスを連想配列に格納
					 foreach($extension as $exval) {
					 	if ((isset($filepath['extension']))&&($exval == $filepath['extension'])) { // 拡張子チェック一致で除外
							$outlist["kind"][$key]="delete";
							break; }
						}
					 }
				}
			 if ($outlist["kind"][$key]== "file") {
				 if ($Ones_file == 0) {							// "file":アルバムアート レスポンスのため2度取得しない
					 $Ones_file=1;
				 	 if ($ART_ON !== 0) {
						 if ((in_array("Art",$field))||($artcond == 1)) {
							if (!isset($outlist["ArtComp"][$key])) {
								 $albumart_file=mpd_editalbumart($outlist[$val][$key]);
								 }
							else if ($outlist["ArtComp"][$key]==1) {			// Shared Memory AlbumArt== False
								 $albumart_file=false;
								 }
							else {
								 $albumart_file=$outlist["Art"][$key];			// Shared Memory AlbumArt== Hit!!
						 		 }
							}
						}
					 }
				if (($albumart_file)&&(!isset($outlist["Art"][$key]))) {		// 前回と同じDirectory,前回と同じAlbumArt (Shared Memoryで未セット)
					$outlist["Art"][$key]=$albumart_file;
					}
				}
			mpd_editmusic($outlist,$key,$field);
			}
		if ($array==false) {									// Shared Memoryから取得できなかったときはMPDから取得
			if ($verbs_fld=="Directory") {
				SHM_FilePut($query,$outshare);					// Shared Memoryから取得(条件が合えば)
				}
			}
		$output=Sort_Table($outlist,$SORT_TBL); 				// Sort directory / Filename / Playlist
		}
	if (($ART_ON !== 0)&&(in_array("Art",$field))) {			// Shared MemoryにAlbum Artを書き込み
		SHM_ArtPut($output);
		}
	SHM_Term();													// Shared Memory Terminate
	return($output);
	}

/*
	mpd_lscheck($path,$outlist) : mpd directory check
	 $path   : i  : check directory
	 $outlist: o  : Output List Array 不要な場合,名前のみ arrayが必要な場合 $output=array();
	 @return : o  : 0:表示データあり,1:表示データなし
	※下位Directoryに表示データがあるかチェック用
	 output arrayが必要時 $outlist=array();$ret=mpd_lscheck($path,$outlist);
	               不要時 $ret=mpd_lscheck($path,$outlist); $outlistに初期値(値)をセットしない
*/
function mpd_lscheck($path,&$outlist) {
	global $Net,$LIB_CONF;

	$output=$Net->runCommand("lsinfo",$path);
	if (!is_array($output)) { return(1); }

	if (isset($outlist)) { $outlist=$output; }
	if ((!isset($output["directory"]))&&(!isset($output["file"]))) {
		return(1);
		}
	if (isset($output["file"])) { return(0); }	// File表示対象あり
	if ($LIB_CONF["Lsinfo_Class2nd"] == "off") { return(0); }
	if (count($output["directory"]) > $LIB_CONF["Lsinfo_ClassNoLimit"]) { return(0); }	// チェック
	$fok=0;
	foreach($output["directory"] as $dir) {		// 2階層目をチェック
		$ary=$Net->runCommand("lsinfo",$dir);
		if ((isset($ary["directory"]))||(isset($ary["file"]))) {
			$fok=1;
			break;
			}
		}
	if($fok==0) { return(1); }
	return(0);
	}

/*
	mpd_playlist($field,$query) : Playlist
	 $field  : i  : list Field Artist/AlbumArtist/Album/Genre/Date
	 $query  : i  : listplayid / currentsong / playlistinfo
	 $pos    : i  : positon When ,$query playlistinfo
	 @return : o  : Output List Array

	 array("file","basename","urlbasename","Title","Disc","Track","Artist","AlbumArtist","Album","Time","Sec","Date","Genre","Last-Modified","Pos","Codec","Art");
	   "urlbasename":URLがhttpのとき別名の"basename"がとれた時セットする
	 Statusが停止中はcurrentsongが帰ってこない。playlistinfoで先頭を取得することで同等に扱うことができる
*/
function mpd_playlist($field,$query,$pos=0) {
	global $Net,$ART_CONF;

	$ART_ON=$ART_CONF["SetNo"];
	if (stristr($ART_CONF["func"],$query) == false) {	// AlbumArt を必要としない場合、
		$ART_ON = 0;									//   List 以外はロジックを組めない
		}
	if ($query=="playlistinfo") {	// playlistinfoの場合取得するPositonを設定する。
		 $args[]= $pos;
		 }
	else {
		 $args = array();
		 }
	$output = $Net->runCommand($query,$args);
	if (!is_array($output)) {		// Timeout Out 0件
		return($output);
		}
	if (in_array("Art",$field)) {	// Shared MemoryからAlbum Artを取得
		SHM_ArtGet($output);
		}
	$svdir="";
	$albumart=false;$base="";
	if (isset($output["file"])) {
		foreach($output["file"] as $key => $val) {
			$filepath = pathinfo($val); // フルパスを連想配列に格納
			$str=$filepath['dirname'];
			if (($svdir !== $str)&&($ART_ON !== 0)) {	// レスポンスのため前回と同じDirectoryはアルバムアートを取得しない
				$svdir=$str;
				if (in_array("Art",$field)) {
					if (!isset($output["ArtComp"][$key]))  {
						 $albumart=mpd_editalbumart($svdir,"dir");
						 }
					else if ($output["ArtComp"][$key]==1) {			// Shared Memory AlbumArt== False
						 $albumart=false;
						 }
					else {
						 $albumart=$output["Art"][$key];			// Shared Memory AlbumArt== Hit!!
						 }
					if ((strpos($val,"http")) === 0) {			// Striming拡張Module mpdweb.playlist.php
						$base="";
						$albumart=mpd_editalbumart($val,"dir",$base);
						if($base !=="") { $output['urlbasename'][$key]=$base; }
						}
					}
				}
			if (($albumart)&&(!isset($output["Art"][$key]))) {	// 前回と同じDirectory,前回と同じAlbumArt (Shared Memoryで未セット)
				$output["Art"][$key]=$albumart;
				if($base !=="") { $output['urlbasename'][$key]=$base; }
				}
			mpd_editmusic($output,$key,$field);
			}
		}
	if (in_array("Art",$field)) {	// Shared MemoryにAlbum Artを書き込み
		SHM_ArtPut($output);
		}
	SHM_Term();						//   Shared Memory Terminate
	return($output);
	}

/*
	mpd_listplay($field,$query) : Listplay
	 $field  : io : list Field Artist/AlbumArtist/Album/Genre/Date $forceを指定時超えた場合"Art"を削除する
	 $query  : i  : listplay(m3u)
	 $force  : i  : 数値を設定時,$output件数が超えたとき強制的にArtをOFFにする。
	 @return : o  : Output List Array
	   "urlbasename":URLがhttpのとき別名の"basename"がとれた時セットする
	 array("file","basename","Title","Disc","Track","Artist","AlbumArtist","Album","Time","Sec","Date","Genre","Last-Modified","Pos","Codec","Art","No");
	 "urlbasename":URLがhttpのとき別名の"basename"がとれた時セットする
*/
function mpd_listplay(&$field,$query,$force="") {
	global $Net,$ART_CONF;

	$ART_ON=$ART_CONF["SetNo"];
	if (stristr($ART_CONF["func"],"listplay") == false) {	// AlbumArt を必要としない場合、
		$ART_ON = 0;										//  List 以外はロジックを組めない
		}
	$output = $Net->runCommand("listplaylistinfo",$query);
	if (!is_array($output)) {
		return($output);
		}
	if (($force !=="")&&((count($output["file"]))>=(intval($force)))) {		// $forceが指定されたとき、配列数を超えたとき
		 $ART_ON=0;															// 強制ArtOFF
		 if(($key = array_search("Art",$field)) !== false) { unset($field[$key]); }
		 }
	$svdir="";
	$albumart=false;$base="";
	if (isset($output["file"])) {
		if (($ART_ON !== 0)&&(in_array("Art",$field))) {
			$i=1;
			foreach($output["file"] as $key => $val) {	// AlbumArtをアウトするときは,ファイルでSortするため復元用にナンバリング
				$output["No"][$key]=$i;
				$i++;
				}
			$output=Sort_Table($output,"file"); 		// Sort配列をfileでSortしAlbumArtで同じディレクトリを一括する、
			SHM_ArtGet($output);
			}
		foreach($output["file"] as $key => $val) {
			$filepath = pathinfo($val); // フルパスを連想配列に格納
			$str=$filepath['dirname'];
			if (($svdir !== $str)&&($ART_ON !== 0)) {	// レスポンスのため前回と同じDirectoryはアルバムアートを取得しない
				$svdir=$str;
				if (in_array("Art",$field)) {
					if (!isset($output["ArtComp"][$key]))  {
						 $albumart=mpd_editalbumart($svdir,"dir");
						 }
					else if ($output["ArtComp"][$key]==1) {			// Shared Memory AlbumArt== False
						 $albumart=false;
						 }
					else {
						 $albumart=$output["Art"][$key];			// Shared Memory AlbumArt== Hit!!
						 }
					if ((strpos($val,"http")) === 0) {		// Striming拡張Module mpdweb.playlist.php
						$base="";
						$albumart=mpd_editalbumart($val,"dir",$base);
						if($base !=="") { $output['urlbasename'][$key]=$base; }
						}
					}
				}
			if (($albumart)&&(!isset($output["Art"][$key]))) {	// 前回と同じDirectory,前回と同じAlbumArt (Shared Memoryで未セット)
				$output["Art"][$key]=$albumart;
				if($base !=="") { $output['urlbasename'][$key]=$base; }
				}
			mpd_editmusic($output,$key,$field);
			}
		if (($ART_ON !== 0)&&(in_array("Art",$field))) {
			$output=Sort_Table($output,"No"); 			// AlbumArt時,Sort配列をNoでSortし戻す
			}
		}
	if (in_array("Art",$field)) {						// Shared MemoryにAlbum Artを書き込み
		SHM_ArtPut($output);
		}
	SHM_Term();						//   Shared Memory Terminate
	return($output);
	}

/*
	mpd_add($field,$query) : Listplay
	 $field  : i  : find / file
	                or Command table  array : clear[0],find[1],play[]
	 $query  : i  : find same find
	                file  file/directory
	                search same search
	 @return : o  : List
*/
function mpd_add($field,$query) {
	global $Net;

	if (!mpd_exclusive("addlist")) {		// サブネットマスクで不許可のときは動作せず正常で返す
		return(0);
		}
	$output=false;
	if (is_array($query)) {
		 $qry = $query;
		 }
	else {
		 $qry[]=$query;
		 }
	if (!is_array($field)) {
		 $fld[] =$field;
		 }
	else {
		 $fld =$field;
		 }
	foreach($fld as $fid_val) {
		if ($fid_val == "file") {
			 foreach($qry as $val) {
				$output=$Net->runCommand("add",$val,0);
				}
			 }
		else if ($fid_val == "find") {
			 foreach($query as $key => $val) {
				$args[]=$key;
				$args[]=$val;
				}
			 $output=$Net->runCommand("findadd",$args);
			 }
		else if ($fid_val == "search") {
			 foreach($query as $key => $val) {
				$args[]=$key;
				$args[]=$val;
				}
			 $output=$Net->runCommand("searchadd",$args);
			 }
		else if ($fid_val == "first") {
			 $output=mpd_addfirst($field,$query);
			 }
		else {
			 $dmy=array();
			 $output=$Net->runCommand($fid_val,$dmy);
			 }
		}
	return($output);
	}

/*
	mpd_addfirst($field,$query) : Listplay Search First
	 $field  : i  : search Command table  array : clear[0],find[1],play[]
	 $query  : i  : search same search
	 @return : o  : mpd:search:$result
*/
function mpd_addfirst($field,$query) {
	global $Net;

	 $field=array("file","Title","Track","Artist","AlbumArtist","Album","Date","Genre");	// $queryに含まれる項目
	if (isset($query["Title"])) {
		$mtitle=$query["Title"];
		}
	$output=mpd_find($field,$query,"find","search",$match="1",$mtitle);		// Find : Command:search
	if (is_array($output)) {
		foreach($output["file"] as $key => $val) {
			if ((isset($output["Unmatch"][$key]))&&($output["Unmatch"][$i]=="1")) { continue; }
			$result=$Net->runCommand("add",$val,0);
			}
		$output=$result;		// Last Result
		}
	return($output);
	}

/*
	mpd_playlistadd($field,$query) : Playlist Add
	 $file   : i  : Playlist File Name (Except .m3u) Not Find Playlist File ,Crate
	 $query  : i  : find    : same mpd_find()  | search : same mpd_find(..."seacrh")
	                playlist: PlaylistをPalylistに追加する(Copyモード)
	                file    : file/directory (Leading "/" unnecessary,directory:Last "/" unnecessary)
	 @return : o  : Count / directory:Directory No , Find:Max Over '-1'

	 $file:Playlist指定は,拡張子'.m3u'不要
	 file/directory:先頭の"/"不要,Directoryの場合最後の"/"不要
	 findの場合,mpd_find()と同じ形式
	 returnは追加できないとき,カウントしない。Findで追加数がオーバしたとき'-1'
*/
function mpd_playlistadd($file,$query,$max=NULL) {
	global $Net;

	if (!mpd_exclusive("playlistadd")) {		// サブネットマスクで不許可のときは動作せず正常で返す
		return(0);
		}
	$output=false;
	if (is_array($query)) {
		 $qry = $query;
		 }
	else {
		 $qry[]=$query;
		 }
	$count=0;
	foreach($qry as $key => $val) {
		if ($key == "file") {			// Fileの場合そのまま追加できる
			 $args=array();
			 $args[]=$file;
			 $args[]=$val;
			 $output=$Net->runCommand("playlistadd",$args,0);
			 if ($output == "") {		// Fileがない
				continue;
			 	}
			 $count=$count+1;
			 }
		else {
			 if ($key == "playlist") {	// Playlistを追加する
				  $arg=array();
				  $arg[]=$val;
				  $output=$Net->runCommand("listplaylistinfo",$arg);
				  }
			 else if ((isset($qry["cmd"]))&&($qry["cmd"]=="first")) {						// Seacerh;first
				  if (isset($qry["Title"])) {
					  $mtitle=$qry["Title"];
					  }
				  $nqey=array();			// Findを使用して追加する
				  foreach($qry as $fid => $qy) {
					if ($fid=="cmd") { continue; }
						$nqey[$fid]=$arg[]=$qy;
						}
				  $output=mpd_find($field,$nqey,"find","search",$match="1",$mtitle);		// Find : Command:search
				  }
			 else {
				  $cmd="find";			// Find,Seaech:Outputを作成しPlaylistを追加
				  if ((isset($qry["cmd"]))&&($qry["cmd"]=="search")) {
					  $cmd="search";
					  }
				  $arg=array();			// Findを使用して追加する
				  foreach($qry as $fid => $qy) {
					if ($fid=="cmd") { continue; }
					$arg[]=$fid;
					$arg[]=$qy;
					}
				  $output=$Net->runCommand($cmd,$arg);
				  }
			 if (!is_array($output)) {
				break;
				}
			 if (!isset($output["file"])) {
				 break;
				}
			 if ((!is_null($max))&&(!$max=="")) {		// 追加FileがMaxを超えたとき終了
				$nmatchcnt=0;
				if (isset($output["Unmatch"])) {
					$nmatchcnt=count($output["Unmatch"]);
					}
				if (((count($output["file"])-$nmatchcnt)) > $max) {
					$count=-1;
					break;
					}
				}
			 foreach($output["file"] as $k => $music) {		// Findの結果で追加する
				if ((isset($output["Unmatch"][$key]))&&($output["Unmatch"][$i]=="1")) { continue; }
				$args=array();
				$args[]=$file;
				$args[]=$music;
				$output=$Net->runCommand("playlistadd",$args,0);
				if ($output == "") {	// Fileがない
					continue;
					}
				$count=$count+1;
				}
			 break;
			 }
		}
	return($count);
	}

/*
	mpd_status($field,$query) : Status
	 $field : i  : "volume","repeat","random","single","consume","playlist","playlistlength","mixrampdb","state",
	               "song","elapsed_sec","elapsed","songid","nextsong","nextsongid","audio","bitrate","updating_db"
	               ※elapsed_sec:生成中の秒 elapsed_all生成中の曲長:elapsed_allがelapsed_secと共に自動編集 
	 $query : i  : Query Item return
	 @return: o  : List or Query

	 array("volume","repeat","random","single","consume","playlist","playlistlength","mixrampdb","state","song","elapsed_sec","elapsed","songid","nextsong","nextsongid","audio","bitrate","updating_db");
*/
function mpd_status($field,$query="") {
	global $Net;

	if (is_array($field)) {
		 $fieldary = $field;
		 }
	else {
		 $fieldary[] = $field;
		 }
	$query_dmy = array();
	$ret=false;
	$output = $Net->runCommand("status",$query_dmy,2);
	if ((!is_array($output))||(!isset($output["state"]))) {		// Timeout Out 0件
		return("Could not get the status");
		}

	foreach($output["state"] as $key => $val) {
		if ($query !== "") {						// $query
			if ((isset($output[$query])) && ($ret == "")) {
				$ret = $output[$query][$key];
				}
			}
		mpd_editstatus($output,$key,$fieldary);
		}
	if ($query !== "") {
		return($ret);
		}
	return($output);
	}

/*
	mpd_update($field,$query) : MPD D/B Update
	 $field : i  : same Status
	 $query : i  : {Directory}/ignore:無条件更新(Update中でもUpdateを実行する/sync:同期(完了を待つ)
	 @return: o  : List or Query

	 array("volume","repeat","random","single","consume","playlist","playlistlength","mixrampdb","state","song","elapsed_sec","elapsed","songid","nextsong","nextsongid","audio","bitrate","updating_db");
	 ※MpdはUpdate Taskが複数動作できる。UpdateのFiledはStatesとおなじ。Filed:Update時、"updating_db"が含まれる。
*/
function mpd_update($field,$query) {
	global $Net,$UPDATE_CONF;

	if (!mpd_exclusive("update")) {		// サブネットマスクで不許可のときは動作せず正常で返す
		return(0); }
	$sleep=5;
	$Update="updating_db";
	if (!is_array($query)) {
		 $para[]=$query; }
	else {
		 $para=$query; }
	$fignore=0;$fsync=0;		// パラメータセット
	$que_dir=array();
	foreach($para as $key => $quy) {
		if ($quy == "ignore") { $fignore = 1; }			// 無条件更新
		else if ($quy == "sync") { $fsync = 1; }		//非同期(完了を待たない)
		else {
			 $que_dir[0] = $quy;	// 更新ディレクトリ
			 }
		}
	$sttime = time();
	$notask=false;
	if ($fignore ==0) {				// 無条件更新でない場合
		while(1) {
			$query_dmy = array();
			$output=array();
			$output = $Net->runCommand("status",$query_dmy,2);
			mpd_editstatus($output,$key,$field);
			if (!isset($output[$Update])) {
				$notask=1;
				break; }
			if ($fsync==0) {			// 非同期時、Update Taskが動いていれば終了
				return($output); }
			$now = time();
			if (($now - $sttime) > $UPDATE_CONF["timeout"]) {
				break; }
			sleep($sleep);
			}
		if (!$notask) {					// 無条件更新でない場合、Update Taskが動いていれば終了(タイムアウトまで)
			return($output); }
		}
	if (($notask)||($fignore == 1)) {	// 無条件更新、Update TaskがなければUpdateを実行
		$output=array();
		$output = $Net->runCommand("update",$que_dir,2);
		mpd_editstatus($output,$key,$field);
		}
	$task=false;
	$sttime = time();
	if ($fsync==1) {					// 同期モード時、タイムアウトまでUpdate Taskの終了を待つ
		while(1) {
			$query_dmy = array();
			$output=array();
			$output = $Net->runCommand("status",$query_dmy,2);
			mpd_editstatus($output,$key,$field);
			if (!isset($output[$Update])) {
				$task=1;
				break; }
			$now = time();
			if (($now - $sttime) > $UPDATE_CONF["timeout"]) {
				break; }
			sleep($sleep);
			}
		}
	return($output);
	}

/*
	mpd_command($command,$args) : mpd command
	 $command : i  : command play/seekcur/next/previous/stop/pause playid/seekid:{id}
                     volume  deleteid/clear  random/repeat/single:{0/1}  load/save:{listplay}
	 $args    : i  : [{prefix}:{key}]値  [$command][key]の"setting/mpdconfig.xml"より変換項目を取得する。
	                 Exc) $field="move"                         Command
	                 $query["From:Title"]="Twilight Zone"  move_Titleで変換
	                 $query["To:Title"]="Anything Goes";   move_Titleで変換
	 @return  : o  : List or Query
*/
function mpd_command($command,$args = array(),$parse = 0,$cont = 1) {
	global $Net;

	$args_req = array();
	$args_dmy = array();
	if (!mpd_exclusive($command)) {		// サブネットマスクで不許可のときは動作せず正常で返す
		return(0);
		}
	foreach($args as $key => $parts) {
		$keypart = explode(':', $key, 2);
		if (isset($keypart[1])) {
			 $keyalt=$keypart[1];
			 }
		else {
			 $keyalt=$key;
			 }
		$cmd_para[$command."_".$keyalt]="";
		$cmd_para["No"]=get_config("Cmd_para",$cmd_para);	// パラメータ変換設定
		if ($cmd_para["No"] !== 0) {
			$playlist = $Net->runCommand("playlistid",$args_dmy);	// playlistidでパラメータを取得する
			if ((is_array($playlist))&&(isset($parts,$playlist[$keyalt]))) {
				$match = array_search($parts,$playlist[$keyalt]);
				if (($match !==false)&&(isset($playlist[$cmd_para[$command."_".$keyalt]][$match]))) {
					 $val=$playlist[$cmd_para[$command."_".$keyalt]][$match];
					 $args_req[]=$val;
					 continue;
					 }
				}
			}
		$args_req[]=$parts;				// 設定がない or playlistで求まらないとき引数をそのまま使用する
		}
	$output = $Net->runCommand($command,$args_req,$parse,$cont);
	if ($output == 1) {					// $output=1はデータなしなので正常に完了と見なす
		$output=0;
		}
	return($output);
	}

/*
	mpd_close() : mpd close
	@return  : o  : output

*/
function mpd_close() {
	global $Net;

	$arg=array();
	$command="close";
	$output=$Net->runCommand($command,$arg);
	return($output);
	}

/*
	mpd_exclusive($command) : mpd Command Subnet exclusive check
	 $output : i  : Check Mpd Command
	 @return : o  : true/false

	command:play,playid,seekcur,seekid,next,previous,stop,pause,setvol,deleteid,clear,random,repeat,single,consume,save,load,rm,addlist,update(*1)
	*1.add/updateはmpdのコマンドではなく関数を止めるため代表名としてライブラリ内定義。
	原則表示系はチェックしない。(表示もしないのであれば何も見せないのと同じ)
	moveは移動するが、mpdに送信しない。
	deleteは行は消えるが、mpdに送信しない。
*/
function mpd_exclusive($command) {
	global $MPD_EXC;

	if ($MPD_EXC['cmd'] == "") {			// 未設定時チェックしない
		return(true);
		}
	$cmd = explode(",",$MPD_EXC['cmd']);
	if (!in_array($command,$cmd)) {			// mpd Commandが設定されていなければチェックしない
		return(true);
		}
	if (!Commn_Subnet($MPD_EXC['netmask'],$_SERVER['REMOTE_ADDR'])) {
		return(false);
		}
	return(true);
	}

/*
	mpd_editstatus($output,$key,$field) : Edit Music Line
	  $output: io  : Output List Array
	                 time/elapsed_sec ->Time mm:ss & All:elapsed_all mm:ss
	                 audio:sumpling/bit/ch bitrate:Edit(kbps)
	  $key   : i   : Edit Point Index
	  $field : i   : Edit Field
*/
function mpd_editstatus(&$output,$key,$field) {
	foreach($field as $fld) {
		if (($fld == "elapsed_sec") && (isset($output["time"][$key]))) {
			 $parts = explode(':',$output["time"][$key],2);
			 if (isset($parts[0],$parts[1])) {
				  $output[$fld][$key]=$parts[0];
				  $output['elapsed_all'][$key]=$parts[1];
				  }
			 }
		else if (!isset($output[$fld][$key])) {
			 continue;
			 }
		else if ($fld == "elapsed") {
			 $output[$fld][$key]=edit_time($output[$fld][$key]);
			 }
		else if ($fld == "audio") {
			 $parts = explode(':',$output[$fld][$key],3);
			 if (isset($parts[0],$parts[1])) {
			 	 $parts[0]=sprintf("%2.1f",preg_replace( '/[^\p{Nd}]/u', '',$parts[0])/1000);
				 if (!isset($parts[2])) { $parts[2]=""; }
				 $output[$fld][$key]=$parts[0]."kHz,".$parts[1]."Bit,".$parts[2]."ch";
				 }
			 }
		else if ($fld == "bitrate") {
			 $output[$fld][$key]=$output[$fld][$key]."kbps";
			 }
		else {
			 $output[$fld][$key]=$output[$fld][$key];
			 }
		msglog("[".$key."][".$fld."] ".$output[$fld][$key]);
		}
	SHM_StatClear($output);						// Shared MemoryUpdate後のStatusClear
	}

//----- Shared Memory Library -------------------------------------------
/*
	Shared Memory関数(& Shm Cleass)
	設定XMLより同Keyにセットする
	<Shm_Project>
	<Used>on|off</Used>                    : Used Shared Memory off|on
	<Common|List|Art|File|Cmd(Project Name)>{Project},{path},{Size},{有効期間}:12:00,{Encoder},{Decoder},{Comprss}</List> : 
          Project Name : {List}:Single Filed Query List / {Art}:Aubum Art / {File} : lsinfo(Directry/File List) / {Cmd}:runCommand(Mpd Command)
          Project:A Caracter , {Size}:Shared Memory Size  , {有効期間(未設定"":永続,43200:12:00), 
          path:Shmget Call Key;path&idで基づいて作成省略時 モジュール名
	<ListTarget>{Filed},...</ListTarget>   : Used List Commond Filed (,区切り)
	<CmdTarget>list,find,lsinfo</CmdTarget>: Used Command
	<CmdExclude>list "Artist",list "AlbumArtist",list "Date",list "Genre",lsinfo "" : Used Commond Exclude

	Calling
	$XML_SHM:XML SHM Setting,$XML_SHMUSE:XML SHM Setting Used,$SHMID:SHM OBJ識別子,$SHMBUF:SHM ReadBuffer
	 1.  SHM_Init();
	 2.  $ret=SHM_Creat("List");
	 2.1 SHM_{Function}($array) SHM_ListPut/SHM_ArtPut/SHM_FilePut/SHM_CommandPut  (SHM_Compress)
	 2.2 $array=SHM_{Function}  SHM_ListGet/SHM_ArtGet/SHM_FileGet/SHM_CommandGet  (SHM_UnCompress)
	 3.  SHM_PClose("List");
	 4.  SHM_Term();
	 n.  SHM_Unlink()
	     SHM_Creat()

	※ shell での確認 # ipcs -m
	          0x31038027 125140994  www-data   644        20000      0
              0x32038027 125108225  www-data   644        20000      0
	          0x33038027 125075456  www-data   644        20000      0
	          0x34038027 125173763  www-data   644        20000      0
	             +--- {31|32|33|34}:Project / Pathで決定する。

	             削除 # ipcrm -m {shmid} 例）493977600
                  All # ipcs -m | awk '{print $2}' | grep -E '^[0-9]+$' | xargs -I {} ipcrm -m {}
*/
/*
	SHM_ListGet($list) : Used List Shared Memory Get
	 $list   : i  : List Filed
	 $query  : i  : List Query (現在複数Queryは対応しない)
	 @return : o  : Mpd List Output Array , or False on failure.
	※ Shared Memory : |delim|{List}|array|{str array}|Eof| List:AlbumArtist,Artist,Date,Genre
*/
function SHM_ListGet($list,$query) {
	if (count($query) > 0) { return(false); }
	$array=false;
	if (_SHM_ListInit($list) === false) { return(false); }
	if (SHM_Creat("List") !== false) {
		$array=SHM_UnCompress("List",$list);
		}
	SHM_PClose();
	if (isset($array["NoArray"])) {
		$array=$array["NoArray"];
		}
	return($array);
	}

/*
	SHM_ListPut($list,$array) : Used List Shared Memory Put
	 $list   : i  : List Filed
	 $Array  : i  : Mpd List Output Array
	 $query  : i  : List Query (現在複数Queryは対応しない)
	 @return : o  : The size of the written data, or FALSE on failure.
	※ Shared Memory : |delim|{List}|array|{str array}|Eof| List:AlbumArtist,Artist,Date,Genre
*/
function SHM_ListPut($list,&$array,$query) {
	if (count($query) > 0) { return(false); }
	if (_SHM_ListInit($list) === false) { return(false); }
	$size=0;
	if (SHM_Creat("List") !== false) {
		$size=SHM_Compress("List",$list,$array);
		}
	SHM_PClose();
	return($size);
	}

/*
	_SHM_ListInit($list) : Used List Shared Memory Init
	 $list   : i  : List Filed
	 @return : o  : Escape False on failure.
*/
function _SHM_ListInit($list) {
	$XML_SHMList=array("ListTarget"=>"AlbumArtist,Artist,Date,Genre");
	get_config("Shm_Project",$XML_SHMList);				// Shared Memory Project mpdconfig.xmlから設定
	$target=explode(',',$XML_SHMList["ListTarget"]);
	if (array_search($list,$target) === false) { return(false); }	// 設定以外のListは除外
	if (SHM_Init() === false) { return(false); }
	return(true);
	}

/*
	SHM_ArtGet($output) : Used Album Art Shared Memory Get
	 $output : io : mpd output array used "kind" "file" "directory"
	                out:["Art"] / ["Comp"]
	 @return : o  : Count's AlbumArt , or False on failure.
	※ Shared Memory : |delim|"File"|array|{array[{n}]Dir[{dir}]/File[{File(AlbumArt)}]/Comp[1:False,0;Hit] }|Eof|
	 Memoryサイズを下げるため分割して使用
*/
function SHM_ArtGet(&$output) {
	$url_char=array(' ', '#','&',"'");			// URL Encode  2019.07.07
	$rep_char=array('%20', '%23','%26','%27');	// URL Replace 2019.07.07

	if (!is_array($output)){ return(0); }		// 対象ArtNothing

	if (($wan_mode=_mpd_editalbumart_host($wan_path,$imghost)) === false) { return(false); }	// Wan/Lan Host編集
	if (SHM_Init() === false) { return(false); }
	if (SHM_Creat("Art") == false) { return(false); }
	$ret=false;$sv_dir=NULL;$sv_key="";
	if (($array=SHM_UnCompress("Art","File")) !== false) {
		if (isset($output["kind"])) {
			 $loop="kind"; }
		else if (!isset($output["file"])) {
			 $loop="directory"; }
		else if ($loop=="directory") {
			 $dir=$val; }
		else {
			 $loop="file"; }
		$ary_dir=_array_column_flip($array,"Dir");				// DirectoryをKeyとなるArrayを作成
		foreach($output[$loop] as $key => $val) {
			if (($loop=="kind") && ($val=="directory")) {		// "kind"がある場合はDirectoryを直接得る
				 $dir=$output["directory"][$key]; }
			else if (($loop=="kind")&&(isset($output["file"][$key]))) {		// "kind"でLoopしているときは、Fileを選択
				 $file=$output["file"][$key]; }
			else {												// FileでLoopしているときはFileを直接得る
				 $file=$val; }
			if ((($loop=="kind")&&($val=="file"))||($loop=="file")) {
				 $path=explode('/',$file);						// pathinfo($file)が遅いので自前で展開
				 $partfile=$path[(count($path)-1)];				// フルパスを連想配列に格納の代用
				 $dir = str_replace("/".$partfile,"",$file);	//   $filepath = pathinfo($file);$dir=$filepath['dirname'];
				 }
			$dir_real=mpd_editZipFile2Dir($dir,$dirstruct);			// Zipの場合,zipファイル以降を削除して探す
			if (is_array($dirstruct)) {
				 $dir=$dir."/".$dirstruct["basename"];				// SharedMemoryに設定するのは,「.Zip」を含める
				 }
			else {
				 $dir_real=mpd_editCueFile2Dir($dir,$dirstruct);	// Cueの場合,Cueファイル以降を削除して探す
				 if (is_array($dirstruct)) {
					 $dir=$dir."/".$dirstruct["basename"];			// SharedMemoryに設定するのは,「.Cue」を含める
					 }
				 }
			if ($dir==$sv_dir) {								// 前回と一致時は前回結果を使用
				if(isset($output["Art"][$sv_key])) {				// ArtFileがあれば,使用
					$output["Art"][$key]=$output["Art"][$sv_key];
					$output["ArtComp"][$key]=$output["ArtComp"][$sv_key];	// Directoryが一致した場合、["ArtComp"]に成否をセット
					continue;
					}
				}
			$url=$imghost.$dir;
			if (isset($ary_dir[$dir])) {
				$i=$ary_dir[$dir];
				$sv_dir=$dir;$sv_key=$key;
				$output["ArtComp"][$key]=$array[$i]["Comp"];	// Directoryが一致した場合、["ArtComp"]に成否をセット ($output["ArtComp"]:SherdMemoryからセット時設定)
				if ($array[$i]["Comp"]==0) {
					if (mb_substr($url,0,5) !== "file:") {
						 if ($wan_mode==1) {				// WAN Mode
							  $dirstr = str_replace($url_char,$rep_char,$dir_real);			// ファイル名を結合するとき,「.Zip」のときも,ZipFileのDirectory
							  $str=$wan_path.$dirstr."/".$array[$i]["File"];
							  }
						 else {
							  $str=$url."/".$array[$i]["File"];
							  $str = str_replace($url_char,$rep_char,$str);
							  $str=Commn_UrlEncode($str);
							  }
						 }
					else {
						 $str=$url."\\".$array[$i]["File"];		// ファイル指定
						 $str=str_replace("/","\\",$str);
						 }
					$output["Art"][$key]=$str;
					}
				}
			}
		$ret=0;
		if (isset($output["ArtComp"])) {
			$ret=count($output["ArtComp"]);
			}
		}
	SHM_PClose();
	return($ret);
	}

/*
	SHM_ArtPut($output) : Used Album Art Shared Memory Put
	 $output : i  : mpd output array used "kind" "file" "directory" , ["Art"]をSharedMemoryにセット (SHM_ArtGetで["Comp"]をセット)
	 @return : o  : SharedMemory Write Size , or False on failure.
	※ Shared Memory : |delim|"File"|array|{array[{n}]Dir[{dir}]/File[{File(AlbumArt)}]/Comp[1:False,0;Hit] }|Eof|
*/
function SHM_ArtPut(&$output) {
	global $XML_SHM;										// $XML_SHM:XML SHM Setting

	if (!is_array($output)){ return(0); }					// 対象ArtNothing

	if (($wan_mode=_mpd_editalbumart_host($wan_path,$imghost)) === false) { return(false); }	// Wan/Lan Host編集
	if (isset($output["kind"])) {							// 更新用Array生成
		 $loop="kind"; }
	else if (!isset($output["file"])) {
		 $loop="directory"; }
	else {
		 $loop="file"; }
	$addary=array();
	foreach($output[$loop] as $key => $val) {
		$dir="";
		if (isset($output["ArtComp"][$key])) { continue; }	// Shared Momory Add Aray:$addary ($output["ArtComp"]:SherdMemoryにあるもの)
		if (($loop=="kind")&&($val=="directory")) {			// "kind"がある場合はDirectoryを直接得る
			 $dir=$output["directory"][$key]; }
		else if (($loop=="kind")&&(isset($output["file"][$key]))) {							// "kind"でLoopしているときは、Fileを選択
			 $file=$output["file"][$key]; }
		else if ($loop=="directory") {
			 $dir=$val; }
		else {												// FileでLoopしているときはFileを直接得る
			 $file=$val; }
		if ((($loop=="kind")&&($val=="file"))||($loop=="file")) {
			 $path=explode('/',$file);						// pathinfo($file)が遅いので自前で展開
			 $partfile=$path[(count($path)-1)];				// フルパスを連想配列に格納の代用
			 $dir = str_replace("/".$partfile,"",$file);	//   $filepath = pathinfo($file);$dir=$filepath['dirname'];
			 }
		if (!isset($output["Art"][$key])) {					// Shared Momory Add Aray:$addary
			$addary[$dir]["Comp"]=1;
			continue;
			}
		if (mb_substr($output["Art"][$key],0,5) !== "file:") {
			 $parts = explode('/',$output["Art"][$key]);
			 }
		else {
			 $parts = explode("\\",$output["Art"][$key]);
			 }
		$addary[$dir]["File"]=$parts[((count($parts))-1)];
		$addary[$dir]["Comp"]=0;
		}
	if (count($addary) == 0) { return(false); }
	if (SHM_Init() === false) { return(false); }
	if (SHM_Creat("Art") == false) { return(false); }
	if (($array=SHM_UnCompress("Art","File")) == false) { $array=array(); }
	if (count($array) == 0) { $last=0; }				// Last Keyをセット
	else {
		 end($array);
		 $last = key($array);
		 $last=$last+1;
		 }
	$ary_dir=_array_column_flip($array,"Dir");				// DirectoryをKeyとなるArrayを作成
	foreach($addary as $dkey => $dval) {
		if (isset($ary_dir[$dkey])) {						// 同じDjrectoryを削除
			unset($array[$key]);
			}
		$array[$last]["Dir"] =$dkey;						// Lastに今回分を追加
		if (isset($addary[$dkey]["File"])) {
			$array[$last]["File"]=$addary[$dkey]["File"];
			}
		$array[$last]["Comp"]=$addary[$dkey]["Comp"];
		$last=$last+1;
		}
	$array = array_values($array);
	$json = json_encode($array);
	$gzip=_SHM_Compress("Art",$json);
	$rate=strlen($gzip)/strlen($json);						// 圧縮率
	$gleng=(strlen($gzip))+25+(3*count($array));			// 制御文字列 25Byte(23Byte) Array一個当たり3Byte補正(約:保障がない)
	if ($gleng > (intval($XML_SHM["Art"]["Size"]))) {		// Over分を削除
		 $def= $gleng - (intval($XML_SHM["Art"]["Size"]));
//print 'Buffer Length ('.$gleng.') $XML('.(intval($XML_SHM["Art"]["Size"])).') Def('.$def.') array('.count($array).') Rate('.$rate.')<BR>';
		 for ($leng=0;$leng < $def;) {
			if (count($array) <= 1) { break; }
			reset($array);
			$first = key($array);
			$ary[0]=$array[$first];
			array_shift($array);							// 先頭を削除
			$json = json_encode($ary);
			$leng=($leng+(strlen($json))*$rate);			// 先頭のサイズ(≒)
			}
		 $json = json_encode($array);			// Shared Memory Over時再度Compress
		 $gzip=_SHM_Compress("Art",$json);		//  毎回ではないのでレスポンス改善外とする
		 }
//TblDump("Put PJName(Art)",$array);
	$size=SHM_Compress("Art","File",$array,2,$gzip);		// SHM_Compressでgzcompressを行うと "502 Bad Gateway"(nginx環境) なるケースがあるので救済処置
	SHM_PClose();
	return($size);
	}

/*
	array_column_flip($array,$column_key) : array_column & array_flip (PHP 5.5以下にarray_columnがないのでarray_flipの機能を追加)
	 $array     : i  : Input Array (Valid $column_key)
	 $column_key: i  : Input Select Key
	 @return    : o  : $column_key Array
*/
function _array_column_flip(&$array,$column_key) {
	$output=array();
	foreach($array as $key => $val) {
		if (isset($array[$key][$column_key])) {
			$output[$array[$key][$column_key]]=$key;
			}
		}
	return($output);
	}

/*
	SHM_FileGet($path) : Used Command Shared Memory File Get
	 $path   : i  : Path String
	 @return : o  : Mpd Output Array , or False on failure.
	※ Shared Memory : |delim|{Command}|array|{str array}...|Eof|
*/
function SHM_FileGet($path) {
	if (SHM_Init() === false) { return(false); }
	$array=false;
	if (SHM_Creat("File") !== false) {
		$array=SHM_UnCompress("File",$path);
		}
	if ((is_array($array))&&(isset($array["directory"]))) {
		foreach((array)$array["directory"] as $key => $val) {
			$array[$array["kind"][$key]][$key]=$path.$val;
			}
		}
	SHM_PClose();
	if (isset($array["NoArray"])) {
		$array=$array["NoArray"];
		}
	return($array);
	}

/*
	SHM_FilePut($path,&$array) : Used Command Shared Memory File Put
	 $path   : i  : Path String
	 $Array  : i  : Mpd Output Array
	 @return : o  : The size of the written data, or FALSE on failure.
	※ Shared Memory : |delim|{Command}|array|{str array}...|Eof|
	  CommandはMemoryサイズが大きくなるか、汎用的またmpdのI/F重視し受信内容をそのまま配列化しておく
*/
function SHM_FilePut($path,&$array) {
	if (SHM_Init() === false) { return(false); }
	$size=0;
	if (is_array($array)) {
		if(isset($array["directory"])) {
			foreach($array["directory"] as $key => $dir) {
				if ($path=="") { break; }
				$parts = explode($path,$dir,2);
				if (!isset($parts[1])) { continue; }
				$array["directory"][$key]=$parts[1];
				}
			}
		}
	if (SHM_Creat("File") !== false) {
		$size=SHM_Compress("File",$path,$array,1);
		}
	SHM_PClose();
	return($size);
	}

/*
	SHM_CommandGet($command) : Used Command Shared Memory Get
	 $command: i  : Command String
	 $sts    : io : 0:XML Setting valid,1:XML Setting invalid
	 @return : o  : Mpd Output Array , or False on failure.
	※ Shared Memory : |delim|{Command}|array|{str array}...|Eof|
*/
function SHM_CommandGet($command,&$sts) {
	if (_SHM_CommandInit($command) === false) { $sts=1;return(false); }
	$array=false;$sts=0;
	if (SHM_Creat("Cmd") !== false) {
		$array=SHM_UnCompress("Cmd",$command);
		}
	SHM_PClose();
	if (isset($array["NoArray"])) {
		$array=$array["NoArray"];
		}
	return($array);
	}

/*
	SHM_CommandPut($command,$array) : Used Command Shared Memory Put
	 $command: i  : Command String
	 $sts    : io : 0:XML Setting valid,1:XML Setting invalid
	 $Array  : i  : Mpd Output Array
	 @return : o  : The size of the written data, or FALSE on failure.
	※ Shared Memory : |delim|{Command}|array|{str array}...|Eof|
	  CommandはMemoryサイズが大きくなるか、汎用的またmpdのI/F重視し受信内容をそのまま配列化しておく
*/
function SHM_CommandPut($command,&$array,&$sts) {
	if (_SHM_CommandInit($command) === false) { $sts=1;return(false); }
	$size=0;$sts=0;
	if (SHM_Creat("Cmd") !== false) {
		$size=SHM_Compress("Cmd",$command,$array,1);
		}
	SHM_PClose();
	return($size);
	}

/*
	_SHM_CommandInit($command) : Used Command Shared Memory Init
	 $command: i  : Command String
	 @return : o  : Escape False on failure.
*/
function _SHM_CommandInit($command) {
	$XML_SHMCmd=array('CmdTarget'=>'list,find','CmdExclude'=>'list "Artist",list "AlbumArtist",list "Date",list "Genre"');
	get_config("Shm_Project",$XML_SHMCmd);							// Shared Memory Project mpdconfig.xmlから設定
	$target=explode(',',$XML_SHMCmd["CmdTarget"]);					// $target :Target Command
	$exclude=explode(',',$XML_SHMCmd["CmdExclude"]);				// $exclude:Exclude Command
	$incmd=explode(' ',$command);
	$flg_ok=-1;
	foreach($target as $cmd) {									// Commandが対象かチェック
		$chcmd=explode(' ',$cmd);
		if ((count($chcmd)) > (count($incmd))) { break; }		// $target以下のパラメータ
		$flg_same=0;
		foreach($chcmd as $key => $chk) {						// Commandが対象かパラメータまでチェック
			if ($chk != $incmd[$key]) { $flg_same=-1;
			break; }
			}
		if ($flg_same == 0) { $flg_ok=0;break; }				// Commandが一致
		}
	if ($flg_ok !== 0) { 
		return(false); }
	if (array_search($command,$exclude) !== false) {
		return(false); }	// 除外設定に含まれるかチェック
	if (SHM_Init() === false) { return(false); }
	return(true);
	}

/*
	SHM_StatClear($filed) : MPD Stat's Update Clear
	 $output : i  : Mpd Status Filed "updating_db"を判定
	 @return : o  : Mpd List Output Array , or False on failure.
	※Mpd Update中はShared Memoryを使用しない。
	  Updateが短時間で終了または、他タスクで実行時検知できないときは、有効期間でShared Memoryを最新する。
*/
function SHM_StatClear($output) {
	global $XML_SHM,$SHMID;							// $XML_SHM:XML SHM Setting,$SHMID:SHM OBJ識別子

	if (!isset($_SESSION["SHMCMN"])) { $_SESSION["SHMCMN"]=""; }
	SHM_Init();			// Shared Memory:Init～SHM_CommonGet()
	$XML_SHMUSE=array("Used"=>"off");get_config("Shm_Project",$XML_SHMUSE);if (strcasecmp($XML_SHMUSE["Used"],"Off") == 0) { return(false); }	// Not Used Shared Memory
	if (!is_array($output)) {  return(false); }
	$SHMSTMP=_SHM_Convert($_SESSION["SHMCMN"]);
	if (((!isset($SHMSTMP["Update"]))||($SHMSTMP["Update"]=="0"))&&(isset($output["updating_db"]))) {
		 $SHMSTMP["Update"]="1";					// Update中
		 $_SESSION["SHMCMN"]=_SHM_Rest($SHMSTMP);
		 }
	if (((isset($SHMSTMP["Update"]))&&($SHMSTMP["Update"]=="1"))&&(!isset($output["updating_db"]))) {
		 SHM_Unlink();								// Updateが完了後にShared Memory削除
		 $_SESSION["SHMCMN"]="";
		 }
	SHM_PClose();
	SHM_Term();						//   Shared Memory Terminate
	return(true);
	}

/* -----------------------------------------------------------------------------
	SHM_Compress($pjname,$key,$str) : Shared Memory Compress Write
	 $pjname : i  : Shared Memory Project Name
	 $key    : i  : Shared Memory Block Key
	 $str    : i  : Write array or string (Not Array:Array["NoArray"])
	 $dmode  : i  : Mode 0:Same Key, Replase Else Add / 1:Add Mode When Size Over, Old Data Detele / 2:All Replase
	 $optgzip: i  : 呼び元でgzcompressした内容を使用する
	 @return : o  : The size of the written data, or FALSE on failure.
	※ Shared Memory形式:|delim|{$key}|array|{str array}|delim|{$key}|array|{str array}....|Eof|
	   Being Called SHM_Init,SHM_Creat
*/
function SHM_Compress($pjname,$key,$str,$dmode=0,$optgzip=NULL) {
	global $XML_SHM;					// $XML_SHM:XML SHM Setting

	if (is_array($str)) { $ary=$str; } else { $ary["NoArray"]=$str; }
	if (!is_null($optgzip)) {
		 $gzip= $optgzip;
		 }
	else {
		 $json = json_encode($ary);		// 通常は関数内で処理
		 $gzip=_SHM_Compress($pjname,$json);
		 }
	if (((strlen($gzip))+14) > (intval($XML_SHM[$pjname]["Size"]))) { return(false); }
	$svbky="";$buff_size=0;$rep_size=0;
	if  ($dmode == 2) { $buff=""; }
	else {
		 if (($buff=SHM_Get($pjname))==false) { $buff=""; }		// 保存ごとに分離
		 }
	$bufb=explode('|Eof|',$buff);
	$buff_size=(strlen($bufb[0]))+5;	// $buff_size:現在のSize
	$buf=explode('|delim|',$bufb[0]);
	foreach($buf as $bky => $bu) {
		$spre=explode('|array|', $bu);	// Key部と分離
		if ($spre[0]==$key) {			// 同一Keyは入れ換え
			$svbky=$bky;
			if (isset($spre[1])) { $rep_size=strlen($spre[0])+strlen($spre[1]); }		// $rep_size:置換前のSize
			break; }
		}
	$put=$key."|array|".$gzip;
	if ($svbky !== "") {
		 $buf[$svbky]=$put;				// 同一Keyは入れ換え
		 }
	else {
		 $buf[]=$put;					// 最後に追加
		 }
	if ($dmode == 1) {				// $dmode:1のときSizeOverはOld DataからDelete 14:|delim|+|array|
		$deff_size=((strlen($gzip))+14*(count($buf))+(strlen($key))) - ((intval($XML_SHM[$pjname]["Size"])) - $buff_size - $rep_size);
//print 'SHM_Compress('.$pjname.') Deff Size('.$deff_size.') $gzip Size('.strlen($gzip).') SHM('.$buff_size.')<BR>';
		if ($deff_size > 0) {
			foreach($buf as $key => $bu) {				// 超過分を削除
				$deff_size=$deff_size - (strlen($bu)+7);
				unset($buf[$key]);
				if ($deff_size < 0) { break; }
				}
			}
		}
	$bufstr="";
	foreach($buf as $bu) {
		if ($bu !== "") {
			$bufstr.="|delim|".$bu;
			}
		}
	$bufstr.='|Eof|';
	if ((strlen($bufstr)) > (intval($XML_SHM[$pjname]["Size"]))) {
//print "SHM_Compress Size Over Not Used SHM(".$pjname.') '.$pjname.'['.(intval($XML_SHM[$pjname]["Size"]))."] bufstr[".(strlen($bufstr)).'] Over Size('.((intval($XML_SHM[$pjname]["Size"]))-(strlen($bufstr))).')<BR>';
		msglog("SHM_Compress Size Over Not Used SHM(".$pjname.") Over Size(".((intval($XML_SHM[$pjname]["Size"]))-(strlen($bufstr))).')');
 		return(false); }
//TblDump("Put(".$pjname.":".$key.")",$ary);
	$ret=SHM_Put($pjname,$bufstr,0);
	if ($ret !== (strlen($bufstr))) {		// 書き込みサイズが異なるときは、容量不足として、Shard Memory 設定が不適切し削除
		SHM_Unlink($pjname);
		msglog("SHM_Compress Difference Write Size(".$ret.") Buffer Size(".strlen($bufstr).') Unlink SHM('.$pjname.')');
		}
	return($ret);
	}

/*
	_SHM_Compress($pjname,$json) : Json Compress to gzip
	 $pjname : i  : Shared Memory Project Name
	 $json   : i  : json 
	 @return : o  : Compless
	※ Compress module : XML Setting:gzcompress/gzencode/gzdeflate / Rate;XML Setting:
*/
function _SHM_Compress($pjname,$json) {
	global $XML_SHM;										// $XML_SHM:XML SHM Setting

	if ($XML_SHM[$pjname]["Enc"] !== "") {
		 $enc_func  =$XML_SHM[$pjname]["Enc"];				// Encoder Module
		 $enc_arg[0]=$json;
		 $enc_arg[1]=$XML_SHM[$pjname]["Comp"];				// Compress度
		 $gzip=@call_user_func_array($enc_func,$enc_arg);
		 }
	else {
		 $gzip=$json;										// Encoder/Decoder Moduleがないとき
		 }
	return($gzip);
	}

/*
	SHM_UnCompress($pjname,$key) : Shared Memory UnCompress Read
	 $pjname : i  : Shared Memory Project Name
	 $key    : i  : Shared Memory Block Key
	 @return : o  : Read Array or FALSE on failure.  (Array["NoArray"]):Orignal Data Not Array:
	※ Shared Memory形式:|delim|{$key}|array|{str array}|delim|{$key}|array|{str array}....|Eof|
	   Being Called SHM_Init,SHM_Creat
*/
function SHM_UnCompress($pjname,$key) {
	global $XML_SHM;							// $XML_SHM:XML SHM Setting

	if (($buff=SHM_Get($pjname)) !==false) {	// 保存ごとに分離
		$array="";
		$bufb=explode('|Eof|',$buff);	
		$buf=explode('|delim|',$bufb[0]);	
		foreach($buf as $bu) {
			$spre=explode('|array|', $bu);	// Key部と分離
			if ($spre[0]==$key) {			// 入れ換え
				if (isset($spre[1])) {
					$json=_SHM_UnCompress($pjname,$spre[1]);
					if ($json===false) { return(false); }
					$array = json_decode($json,true);
//TblDump("Get(".$pjname.":".$key.")",$array);
					return($array);
					}
				}
			}
		}
	return(false);
	}

/*
	_SHM_UnCompress($pjname,$gzip) : gzip UnCompress to Json
	 $pjname : i  : Shared Memory Project Name
	 $gzip   : i  : Compress
	 @return : o  : Json
	※ UnCompress module : XML Setting:gzuncompress/gzdecode/gzinflate
*/
function _SHM_UnCompress($pjname,$gzip) {
	global $XML_SHM;							// $XML_SHM:XML SHM Setting

	if ($XML_SHM[$pjname]["Dec"] !== "") {
		 $dec_func=$XML_SHM[$pjname]["Dec"];	// Decoder Module
		 $dec_arg[]=$gzip;
		 $json=@call_user_func_array($dec_func,$dec_arg);	// 関数にすると結果がとれない(深いところでMemoryが取れない?)
		 if ($json===false) { return(false); }
		 }
	else {
		 $json=$gzip;							// Encoder/Decoder Moduleがないとき
		 }
	return($json);
	}

/* -----------------------------------------------------------------------------
	Application Function Shared Memory Library
	 1. SHM_Init();
	 2. $ret=SHM_Creat("List");
	 3. SHM_Put("List","{Put Data}"); 
	    $str=SHM_Get("List");
	 4. SHM_PClose();
	 n. SHM_Unlink();
*/
/*
	SHM_Init() : Project's Shared Memory Initialize
	 @return: o  : True or , or False on failure.  or When,Update=1
*/
function SHM_Init() {
	global $XML_SHM,$XML_SHMUSE,$SHMID,$SHMBUF,$SHMCMNBUF;	// $XML_SHM:XML SHM Setting,$XML_SHMUSE:XML SHM Setting Used,$SHMID:SHM OBJ識別子,$SHMBUF:SHM ReadBuffer $SHMCMNBUF:$_SESSION["SHMCMN"] Buffer

	if ((!isset($XML_SHM)) || (!is_array($XML_SHM))) 	{	// $XML_SHM(設定配列)があれば再度行わない
		$XML_SHMUSE=array("Used"=>"off");
		get_config("Shm_Project",$XML_SHMUSE);		
		Shm_Project();													// Shared Memory Get Project
		foreach($XML_SHM["Source"] as $key => $val) {
			$SHMID[$key]=false;											// $SHMID:Crate識別子を初期
			$SHMBUF[$key]=false;										// $SHMID:Read Bufferを初期
			}
		if (isset($_SESSION["SHMCMN"])) { $SHMCMNBUF=$_SESSION["SHMCMN"]; } else { $SHMCMNBUF=""; }
//print '<BR><BR><BR><BR><BR>Init $SHMCMNBUF('.$SHMCMNBUF.')<BR>';
		}
	if (strcasecmp($XML_SHMUSE["Used"],"Off") == 0) { return(false); }	// Not Used Shared Memory
//if (isset($_SESSION["SHMCMN"])) { unset($_SESSION["SHMCMN"]); }		// ************** Test用強制GET
	if (!isset($_SESSION["SHMCMN"])) { SHM_CommonGet(); }
	$SHMSTMP= _SHM_Convert($_SESSION["SHMCMN"]);
	if ((isset($SHMSTMP["Update"]))&&($SHMSTMP["Update"]=="1")) {	// Update中はShared MemoryからGetしない
		 return(false);
		 }
	return(true);
	}

/*
	SHM_Creat($pjname,$flags,$mode) : Project's Shared Memory Open/Creat
	 $pjname : i  : Shared Memory Project Name
	 $flags  : i  : "a":ReadOnly / "c":Creat / "w":Read/Write / "n":新規メモリセグメントの作成用
	 $mode   : i  : Permission
	 @return : o  : resource , or false
	 global $SHMID : o : Common Buffer {Project}:{TimeStump};....
	※ $XML_SHM: [$share] ["Proj"]:Project,["Size"]:Size,["Life"]:Life Sec
*/
function SHM_Creat($pjname,$flags="c",$mode=0644) {
	global $XML_SHM,$SHMID;					// $SHMID:SHM OBJ識別子,$SHMBUF:SHM ReadBuffer

	$proj=Shm_Project($pjname);
	if (!isset($XML_SHM[$pjname])) { return(false); }					// Not Used Project
	$SHMID[$pjname] = new Shm_Common($proj,$XML_SHM[$pjname]["Size"]);	// Open 識別子を$SHMID[$pjname]に格納
	if ((isset($XML_SHM[$pjname]["Path"]))&&($XML_SHM[$pjname]["Path"] !== "")) {
		$SHMID[$pjname]->shm_const['path']=$XML_SHM[$pjname]["Path"];
		}
	if (($SHMID[$pjname]->shm_open($flags,$mode)) === false) {
		 $SHMID[$pjname]=false; }
	return($SHMID[$pjname]);
	}

/*
	SHM_Put($pjname,$string,$offset) : Project's Shared Memory Write (Put)
	 $pjname   : i  : Shared Memory Project Name
	 $string   : i  : Write String
	 $FlgOffset: i  : Numeric, offset ,Flags "c":Creat (Tractation)" you can specify other(a/w) but it makes no sense
	 $mode     : i  : When $FlgOffset Flags ,Used
	 @return   : o  : The size of the written data, or FALSE on failure.
*/
function SHM_Put($pjname,$string,$FlgOffset="c",$mode=0644) {
	global $SHMID,$SHMBUF;					// $SHMID:SHM OBJ識別子,$SHMBUF:SHM ReadBuffer

	if (!isset($_SESSION["SHMCMN"])) { $_SESSION["SHMCMN"]=""; }
	if ($string == "") {					// Stringがないとき削除する
		 $ret=0;
		 $SHMID[$pjname]->shm_delete();
		 $SHMSTMP= _SHM_Convert($_SESSION["SHMCMN"]);
		 $SHMSTMP[$pjname]="";
		 $_SESSION["SHMCMN"]=_SHM_Rest($SHMSTMP);
		 }
	else {
		 if (is_numeric($FlgOffset)) {		// Write String以降は前の内容が残るので、$FlgOffset='c'時,CreatWrite (Trancation Mode)
		 	   $offset=$FlgOffset;
		  	   }
		  else {
			   $SHMID[$pjname]->shm_delete();
			   $SHMID[$pjname]->shm_close();
			   if (SHM_Creat($pjname,$FlgOffset,$mode) == false) {
				   return(false);
				   }
			   $offset=0;
			   }
		 $ret=$SHMID[$pjname]->shm_write($string,$offset);			// Shared Memory Write
		 if (($offset==0)&&($SHMBUF[$pjname] !==  false)) {			// Offsetが0のときRead Bufferを補完
			if ((strlen($string)) < (strlen($SHMBUF[$pjname]))) {			// Read Bufferより書き込みが短いとき
				$SHMBUF[$pjname]=substr_replace($SHMBUF[$pjname],$string,0,strlen($string));	// Bufferの後ろを残す。
				}
			else if ($offset==0) {
				$SHMBUF[$pjname]=$string;
				}
			}
		 if ($offset > 0) {				// $offset指定時は,レスポンスを考慮してコーディングいると判断しRead Bufferを補完しない。
			$SHMBUF[$pjname]=false;
			}
		 $SHMSTMP= _SHM_Convert($_SESSION["SHMCMN"]);
		 $SHMSTMP[$pjname]=time();
		 $_SESSION["SHMCMN"]=_SHM_Rest($SHMSTMP);
		 }
	return($ret);
	}

/*
	SHM_Get($pjname,$count=NULL,$offset=0) : Project's Shared Memory Read (Get)
	 $pjname  : i  : Shared Memory Project Name
	 $count   : i  : The number of bytes to read 
	 $offset  : i  : Offset
	 @return  : o  : Returns the data  or FALSE on failure.
*/
function SHM_Get($pjname,$count=NULL,$offset=0) {
	global  $XML_SHM,$SHMID,$SHMBUF;			// $XML_SHM:XML SHM Setting,$SHMID:SHM OBJ識別子,$SHMBUF:SHM ReadBuffer

//echo '<BR><BR><BR><BR>Get:'.$pjname.' Start('.($start_time=microtime(true)).')<BR>';
	$buf = false;
	if (!isset($_SESSION["SHMCMN"])) { $_SESSION["SHMCMN"]=""; }
	if ($SHMID[$pjname]!==false) {
		$SHMSTMP= _SHM_Convert($_SESSION["SHMCMN"]);
		if (isset($SHMSTMP[$pjname])) {
			if (($XML_SHM[$pjname]["Life"]=="")||((int)(time() - $SHMSTMP[$pjname]) < (int)$XML_SHM[$pjname]["Life"])) {
				 $SHMSTMP= _SHM_Convert($_SESSION["SHMCMN"]);		// Life Secが永続か以内の場合、再セット
				 $SHMSTMP[$pjname]=time();
				 $_SESSION["SHMCMN"]=_SHM_Rest($SHMSTMP);
				 if ($SHMBUF[$pjname] === false) {					// Get後はSaveデータを使用する
				 	  $buf = $SHMID[$pjname]->shm_read($count,$offset);
					  if ($offset == 0) {			// $offset0は,無意識にレスポンスを考慮するためRead Bufferを保存
					 	   $SHMBUF[$pjname] = $buf;
						   }
					  else {	// $offset指定時は,レスポンスを考慮してコーディングいると判断しRead Bufferを補完しない。
					 	   $SHMBUF[$pjname] = false;
						   }
					  }
				 else {
				 	  $buf=$SHMBUF[$pjname];
					  }
				 }
			else {
				 $SHMID[$pjname]->shm_delete();			// Life Secを超えた場合は削除
				 $SHMSTMP= _SHM_Convert($_SESSION["SHMCMN"]);
				 $SHMSTMP[$pjname]="";
				 $_SESSION["SHMCMN"]=_SHM_Rest($SHMSTMP);
				 $SHMBUF[$pjname] = false;
				 }
			}
		}
//echo 'Get:'.$pjname.'   End('.($End_time=microtime(true)).') Sec('.($End_time-$start_time).')<BR>';
	return($buf);
	}

/*
	SHM_PClose($pjname) : Project's Shared Memory Project Close
	 $pjname : i  : All:""  or ProjctName:Projct Delete
*/
function SHM_PClose($pjname="") {
	global $SHMID;				// $SHMID:SHM OBJ識別子

	if ($SHMID != null && is_array($SHMID)) {
		foreach($SHMID as $key => $val) {
			if (($pjname=="")||($pjname==$key)) {
				if ($val !== false) {
					$val->shm_close();
					}
				unset($SHMID[$key]);
				}
			}
		}
	}

/*
	SHM_PClose($pjname) : Project's Shared Memory Terminate
	 $pjname : i  : All:""  or ProjctName:Projct Delete
*/
function SHM_Term() {
	global $SHMCMNBUF;	// $SHMCMNBUF:$_SESSION["SHMCMN"] Buffer

	if (isset($SHMCMNBUF)) {
		if (((isset($_SESSION["SHMCMN"])))&&($SHMCMNBUF !== $_SESSION["SHMCMN"])) {
			SHM_CommonPut();
			SHM_PClose("SHMCMN");
			$SHMCMNBUF=$_SESSION["SHMCMN"];		// Renew $_SESSION["SHMCMN"] Buffer
			}
		}
	}

/*
	SHM_Unlink($pjname,$cond) : Project's Shared Memory Delete
	 $pjname : i  : All:""  or ProjctName:Projct Delete
	 $cond   : i  : 0:No Check / 1:When Update, Not Remove
*/
function SHM_Unlink($pjname="",$cond=0) {
	global $XML_SHM,$SHMID,$SHMBUF;			// $XML_SHM:XML SHM Setting,$SHMID:SHM OBJ識別子,$SHMBUF:SHM ReadBuffer

	$update=0;
	if (!isset($_SESSION["SHMCMN"])) { $_SESSION["SHMCMN"]=""; }
	if ($cond == 1) {
		$SHMSTMP=_SHM_Convert($_SESSION["SHMCMN"]);
		if ((isset($SHMSTMP["Update"]))&&($SHMSTMP["Update"]=="1")) {
			$update=1;
			}
		}
	if ($update==0) {
		$_SESSION["SHMCMN"]="";
		}
	if (is_array($SHMID)) {				// SHM_Init()を経由している場合
		 $ary=$XML_SHM["Source"];
		 }
	else {
		 Shm_Project("","del");			// Shared Memory Delete ここ削除しなくても同じと思うが, File Artで複数使用時,Open/Closeが混じるので強制
		 $ary=$XML_SHM["Source"];
		 }
	if (is_array($SHMID)) {				// SHM_Init()を経由している場合
		foreach($SHMID as $key => $val) {	// OpenをKeepしDelete
			if ($val !== false) {
				if (($pjname=="")||($pjname==$key)) {
					$val->shm_delete();
					$SHMBUF[$key] = false;
					if (isset($ary[$key])) { unset($ary[$key]); }
//print 'Shared Memory Delete $SHMID:'.$key."<BR>";
					}
				}
			}
		}
	foreach($ary as $key => $val) {
		if (($pjname=="")||($pjname==$key)) {
			$proj=Shm_Project($key,"del");	// 元は,下のshm_delete()で削除していたが,修正時リスクを考慮し下も残しておく。
			$id = new Shm_Common($proj);	// OpenしてDelete
			if ((isset($XML_SHM[$key]["Path"]))&&($XML_SHM[$key]["Path"] !== "")) {
				$id->shm_const['path']=$XML_SHM[$key]["Path"];
				}
			$id->shm_open();
			$id->shm_delete();				// Shared Memory Delete (リークしないように削除方法を組み込んでおく)
			$id->shm_close();
//print 'Shared Memory Delete $XML_SHM:'.$key."<BR>";
			}
		}
	}

/*
	SHM_CommonGet() : Shared Memory To $_SESSION["SHMCMN"]
	 ※有効期間:Commonが設定されている場合は,$_SESSION["SHMCMN"]がセッション有効期限でなくなるとShared Memoryからセットする。
	   Shared Memoryが期待ほど早くないので読み込みを可能な減らす。
*/
function SHM_CommonGet() {
	global $XML_SHM,$SHMID;					// $SHMID:SHM OBJ識別子,$SHMBUF:SHM ReadBuffer

	$_SESSION["SHMCMN"]="";
	$array=false;
	if (SHM_Creat("Common") !== false) {
		$_SESSION["SHMCMN"]="Common:".time();
		if (($array=SHM_UnCompress("Common","SHMCMN")) !== false) { 
			if (isset($array["NoArray"])) {
				$_SESSION["SHMCMN"]=$array["NoArray"];
				$SHMSTMP= _SHM_Convert($_SESSION["SHMCMN"]);
				if (!isset($SHMSTMP["Common"])) { $SHMSTMP["Common"]=time(); }
				$_SESSION["SHMCMN"]=_SHM_Rest($SHMSTMP);
//$SHMSTMP["Common"]=(int)(time()-(int)$XML_SHM["Common"]["Life"]);		// ************** Test用強制 Remove
				if (($XML_SHM["Common"]["Life"]=="")||((int)(time() - $SHMSTMP["Common"]) < (int)$XML_SHM["Common"]["Life"])) {
					 }
				else {
					 $SHMID["Common"]->shm_delete();			// Life Secを超えた場合は削除
					 $_SESSION["SHMCMN"]="";
					 }
//print "<BR><BR><BR><BR><BR><BR>GET SHMCMN[".$_SESSION["SHMCMN"]."]Life[".$XML_SHM["Common"]["Life"]."](".((int)(time()-$SHMSTMP["Common"])).")<BR>";
				}
			}
		}
	}

/*
	SHM_CommonPut() : $_SESSION["SHMCMN"] To Shared Memory
	 @return : o  : The size of the written data, or FALSE on failure.
*/
function SHM_CommonPut() {
	global $XML_SHM,$SHMID;					// $SHMID:SHM OBJ識別子,$SHMBUF:SHM ReadBuffer

	$size=0;
	if ((isset($_SESSION["SHMCMN"]))&&($_SESSION["SHMCMN"]!=="")) {
		if (SHM_Creat("Common") !== false) {
			$SHMSTMP= _SHM_Convert($_SESSION["SHMCMN"]);
			if (!isset($SHMSTMP["Common"])) { $SHMSTMP["Common"]=time(); }
			$_SESSION["SHMCMN"]=_SHM_Rest($SHMSTMP);
//$SHMSTMP["Common"]=(int)(time()-(int)$XML_SHM["Common"]["Life"]);		// ************** Test用強制 Remove
			if (($XML_SHM["Common"]["Life"]=="")||((int)(time() - $SHMSTMP["Common"]) < (int)$XML_SHM["Common"]["Life"])) {
				 $size=SHM_Compress("Common","SHMCMN",(trim($_SESSION["SHMCMN"])),2);
				 }
			else {
				 $SHMID["Common"]->shm_delete();			// Life Secを超えた場合は削除
				 $_SESSION["SHMCMN"]="";
				 }
//print "<BR><BR><BR><BR><BR><BR>PUT SHMCMN[".$_SESSION["SHMCMN"]."]Life[".$XML_SHM["Common"]["Life"]."](".((int)(time()-$SHMSTMP["Common"])).")Size(".$size.")<BR>";
			}
		}
	return($size);
	}

/*
	SHM_Convert($SHMCMN) : Common Shared Memory Convert
	 $SHMCMN : i  : Common Shared Memory {Project}:{TimeStump};....
	 @return : o  : Array $SHMSTMP [Project]{TimeStump}
*/
function _SHM_Convert($SHMCMN) {
	$SHMSTMP=array();
	$str = explode(";",$SHMCMN);
	foreach($str as $val) {
		$item = explode(":",$val);
		$up="";
		if (isset($item[1])) { $up=$item[1]; }
		$SHMSTMP[$item[0]]=$up;
		}
	return($SHMSTMP);
	}

/*
	SHM_Convert($SHMCMN) : Common Shared Memory Restore
	 $SHMSTMP: o  : Array $SHMSTMP  [Project]{TimeStump}
	 $SHMCMN : i  : Common Shared Memory {Project}:{TimeStump};....
*/
function _SHM_Rest($SHMSTMP) {
	$SHMCMN="";
	foreach($SHMSTMP as $key => $val) {
		if ($val !=="") {
			$SHMCMN.=$key.":".$val.";";
			}
		}
	return($SHMCMN);
	}

/* -----------------------------------------------------------------------------
	Shared Memory Library
	Shm_Project() : Get Projcst
	 $pjname : i  : All:""  or ProjctName:Projct Delete
	 $compel : i  : "":通常モード "del":強制削除
	※ $XML_SHM[$share] ["Proj"]:Project,["Size"]:Size,["Life"]:Life Sec
-------------------------------------------------------------------------------*/
function Shm_Project($pjname="",$compel="") {
	global $XML_SHM;									// $XML_SHM:XML SHM Setting

	if ((!isset($XML_SHM)) || (!is_array($XML_SHM))) {	// $XML_SHM(設定配列)があれば再度行わない
		$XML_SHM["Source"]=array("Common"=>"0,,128,43200,gzcompress,gzuncompress,9","List"=>"1,,20000,43200,gzcompress,gzuncompress,9","Art"=>"2,,20000,43200,gzcompress,gzuncompress,9","File"=>"3,,20000,43200,gzcompress,gzuncompress,9","Cmd"=>"4,,20000,43200,gzcompress,gzuncompress,9");
		$keep=$XML_SHM["Source"];
		foreach($keep as $key => $val) {						// 省略時の初期値のためKeep
			$part=explode(",",$val);
			$keep[$key]=$part;
			}
		foreach($XML_SHM["Source"] as $key => $val) {
			$cnf[$key]=$val;
			$setno=get_config("Shm_Project",$cnf);				 // Shared Memory Project mpdconfig.xmlから設定
			$XML_SHM["Source"][$key]=$cnf[$key];
			}
		foreach($XML_SHM["Source"] as $key => $val) {
			if ($val=='') { unset($XML_SHM[$key]);continue; }	// <Shm_Project><Art></Art>の設定は使用しない扱い
			$pshm=explode(",",$val);
			$XML_SHM[$key]["Proj"]=trim($pshm[0]);				// Key:Project Name :Project Code
			$XML_SHM[$key]["Size"]=0;							// Project Size
			$XML_SHM[$key]["Life"]="";							// Life Sec "":永続
			$XML_SHM[$key]["Enc"]=$keep[$key][4];				// 省略時の初期値 Encoder
			$XML_SHM[$key]["Dec"]=$keep[$key][5];				// 省略時の初期値 DEcorder
			$XML_SHM[$key]["Comp"]=$keep[$key][6];				// 省略時の初期値 Compress
			if (isset($pshm[1])) { $XML_SHM[$key]["Path"]=$pshm[1]; }
			if($compel != "del") {
				if (isset($pshm[2])) { $XML_SHM[$key]["Size"]=$pshm[2]; }
				}
			if (isset($pshm[3])) { $XML_SHM[$key]["Life"]=$pshm[3]; }
			if (isset($pshm[4])) { $XML_SHM[$key]["Enc"] =$pshm[4]; }
			if (isset($pshm[5])) { $XML_SHM[$key]["Dec"] =$pshm[5]; }
			if (isset($pshm[6])) { $XML_SHM[$key]["Comp"]=$pshm[6]; }
			if (!function_exists($XML_SHM[$key]["Enc"])) { $XML_SHM[$key]["Enc"]="";$XML_SHM[$key]["Dec"]=""; }	// Encodeモジュールなし
			if (!function_exists($XML_SHM[$key]["Dec"])) { $XML_SHM[$key]["Enc"]="";$XML_SHM[$key]["Dec"]=""; }	// Decodeモジュールなし
			if (($XML_SHM[$key]["Size"]==0)&&($XML_SHM[$key]["Proj"]!=="")) {	// <{ProjectName}>{Project}</{ProjectName}>形式 (例) <List>1</List>)
				$id = new Shm_Common($XML_SHM[$key]["Proj"]);					//   Shared Memory Delete (リークしないように削除方法を組み込んでおく)
				if ((isset($XML_SHM[$key]["Path"]))&&($XML_SHM[$key]["Path"] !== "")) {
					$id->shm_const['path']=$XML_SHM[$key]["Path"];
					}
				$id->shm_open();
				$id->shm_delete();				// Size 0byte指定時は初期時点でShared Memoryを作らない。(途中で設定を変えた場合)
				$id->shm_close();
				unset($XML_SHM[$key]);
				}
			}
		}
//print '<BR><BR><BR><BR><BR><BR>$XML_SHM '.$pjname."<BR>";
//TblDump('$XML_SHM',$XML_SHM);
	$ret=true;
	if (isset($XML_SHM[$pjname]["Proj"])) {
		$ret=$XML_SHM[$pjname]["Proj"];
		}
	return($ret);
	}

//----- class Shm_Common Shared Memory -----------------------------------------
/*  ※ PHP 5.3.0 以降でClassが可能になっている
	class Shm  : Shared Memory Common

	Calling Sequence
	 1. $Shm = new Shm_Common($proj,$size,$life);
	 2. $Shm->shm_open("c",0644);
	 3. $Shm->shm_write({Write Data);
	 4. {ReadData} = $Shm->shm_read();
	 5. $Shm->shm_delete();
	 6. $Shm->shm_close();
*/
class Shm_Common {
//	public $path      = "/tmp";
	public $path      = __FILE__;						// __FILE__:'/var/www/mpdweb/mpdweb.php'
	public $shm_const = array();
	public $debug     = false;
//	public $debug     = true;
	public $filename  = "log/shmmpd.log";
	public $logsize   = 300000;

/*
	__construct($proj,$size) : __construct インスタンス生成
	 $proj  : i  : Shared Memory Creat Project : 1byte
	 $size  : i  : Shared Memory Creat Size
	※ Shm = new Shm_Common("2");
*/
	function __construct($proj="a",$size=100)  {		//__construct インスタンス生成時に自動コール
		$this->shm_const['path'] = $this->path;
		$this->shm_const['proj'] = $proj;
		$this->shm_const['size'] = $size;
		$this->shm_const['key']  = null;
		$this->shm_const['id']   = null;
		}

/*
	shm_open($flags,$mode) : Shared Memory Open
	 $flags  : i  : "a":ReadOnly / "c":Creat / "w":Read/Write / "n":新規メモリセグメントの作成用
	 $mode   : i  : Permission
	 @return : o  : resource , or false
	※ "n":同じフラグのセグメントが 存在するときには失敗させたい場合使用
*/
	public function shm_open($flags="c",$mode=0644) {
		if (isset($this->shm_const['id'])) { return($this->shm_const['id']); }
		if (($this->shm_const['key'] = @ftok($this->shm_const['path'],$this->shm_const['proj'])) == -1) {
			 $this->shm_const['id']=false;
			 }
		else {
			 $this->shm_const['id']  = @shmop_open($this->shm_const['key'],$flags,$mode,$this->shm_const['size']);
			 if ($this->shm_const['id'] === false) {
				  $this->shmlog("open Failed to open shared memory segment ProjID(".$this->shm_const['proj'].")\n");
				  }
			 }
		return($this->shm_const['id']);
		}

/*
	shm_close() : Shared Memory Close
*/
	public function shm_close() {
		if ($this->shm_const['id'] != "") {
			shmop_close($this->shm_const['id']);
			}
		}

/*
	shm_delete() : Shared Memory Delete
*/
	public function shm_delete() {
		if ($this->shm_const['id'] != "") {
			shmop_delete($this->shm_const['id']);
			$this->shmlog("delete:Proj(".$this->shm_const['proj'].")\n");
			}
		}

/*
	shm_write($string,$offset) : Shared Memory Write
	 $string  : i  : Write String
	 $offset  : i  : Offset
	 @return  : o  : The size of the written data, or FALSE on failure.
*/
	public function shm_write($string,$offset=0) {
		$bytes = shmop_write($this->shm_const['id'],$string,$offset);
		$this->shmlog("Write:Size(".$bytes.")ProjID(".$this->shm_const['proj'].") Offset(".$offset.")Buffer:".$string."\n");
		return($bytes);
		}

/*
	shm_read($count,$offset) : Shared Memory Read 省略時:Shared Memory Creat Size (全件)
	 $count   : i  : The number of bytes to read 
	 $offset  : i  : Offset
	 @return  : o  : Returns the data  or FALSE on failure.
*/
	public function shm_read($count=NULL,$offset=0) {
		if (is_null($count)) {
			 $no=$this->shm_const['size'];
			 }
		else {
			 $no=$count;
			 }
		$shm_data = shmop_read($this->shm_const['id'],$offset,$no);
		$this->shmlog("Read:Offset(".$offset.")No(".$no.") Buffer:".$shm_data."\n");
		return($shm_data);
		}
/*
	shmlog($log) : MessageLog
	 $log : i  :logmsg
	Parse MPD output on a line-by-line basis creating output that is easy to work with
*/
	public function shmlog($logmsg) {
		if ($this->debug) {
			$fp = fopen($this->filename, "a");
			$size = filesize($this->filename);
			if ($size > $this->logsize) {
				@rename($this->filename,$this->filename.".old");
				$fp = fopen($this->filename, "w");
				}
			fwrite($fp,date("Y/m/d H:i:s")." ".$logmsg);
		 	fclose($fp);
			}
		}
//----- class shm_Common End----------------------------------------------------
	}

//----- class Net_Common ---------------------------------------------------------
/*  ※ PHP 5.3.0 以降でClassが可能になっている
	Net_Common : Network Common
	  $p_connect : io  : パラメータ
		必要なパラメータは__construct下で$p_connectに初期値を設定する。
	設定XMLより同Keyにセットする

	netコマンド関数(Net Cleass)
	<Mpd_net>                             : Mpd Server Connect設定
	    <host>{Hostname}</host>           :  Hostname
	    <port>{Port}</port>               :  Port
	    <pass>{Password}</pass>           :  Password

  Calling Sequence
	1.$XML_CONF = get_loadconfig();          XMLFile Loading
	2.$Net = new Net_Common;                 Net Class Create
	  $Net->timeout=3;						 Timeout (0:No Timeout)
	3.get_config("Mpd_net",$Net->p_connect); Parameta Loading
	4.$Net->connect();                       Connect
	5.～各種機能
	6.mpd_close()

 * Shared Memory での組み込みモジュール
	runCommand : SharedMemory ["Cmd"] Get/Put
*/
class Net_Common {
	// Connection & Write Errors
	const CONNECTION_NOT_OPENED   = 100;
	const CONNECTION_FAILED       = 102;
	const WRITE_FAILED            = 103;
	// MPD Errors
	const ACK_PASSWORD            = 3;
	const ACK_COMMAND_FAILED      = -100;
	// MPD Responces
	const RESPONSE_OK             = 'OK';

	public $debug                  = false;
//	public $debug                  = true;
	public $filename               = "log/netmpd.log";
	public $logsize                = 300000;

	private   $_connection        = null;
	protected $_errors            = array();
	private   $_current_error     = array();
	protected $_commands          = array();
    protected $_output            = array();

	public $p_connect = array();
	public $ver                   = '';		// mpd version
	public $p_error               = '';		// Error message
	public $w_message             = '';		// Warning message (続行用)
	public $timeout               = 0;		// 0:Timeoutチェックしない
	public $c_timeout 		      = 4;		// Connect TimeOut
    function __construct($host = 'localhost', $port = 6600, $password = null)  {	//__construct インスタンス生成時に自動コール
		$this->p_connect['host'] = $host;
		$this->p_connect['port'] = $port;
		$this->p_connect['password'] = $password;
		}

/*
	connect() : connection status
	 @return : o  :bool
*/
	public function connect() {
		if ($this->isConnected()) {							// Connect済
			return true;
			}
		$connection = @fsockopen($this->p_connect['host'], $this->p_connect['port'], $errn, $errs, $this->c_timeout);	// Openのタイムアウトは固定
		if ($connection) {
			$this->_connection = $connection;
			while(!feof($this->_connection)) { 				// Read from the source until its ready for commands
				$line = fgets($this->_connection);
				$mpd_str = explode('OK', $line, 2);
				if (isset($mpd_str[1])) {
					$this->ver=$mpd_str[1];
					}
				if (trim(substr($line, 0, 2)) == self::RESPONSE_OK) {
					break;
					}
				}
			if (!is_null($this->p_connect['password'])) {
				if (!$this->runCommand('password', $this->p_connect['password'],0)) {
					$this->p_error = 'Net_Common : Connect Password invalid : ACK_PASSWORD('.self::ACK_PASSWORD.')';		// Error Prosess
					return false;
					}
				}
			return true;
			}
		$this->p_error = 'Net_Common : Connect Error connecting: ErrNo:'.$errn.' : '.$errs.' : CONNECTION_FAILED('.self::CONNECTION_FAILED.')';		// Error Prosess
		return false;
		}

/*
	isConnected() : Check connection status
	 @return : o  : bool
*/
	public function isConnected() {
	if (!is_resource($this->_connection)) {
		return false;
		}
	return true;
	}

/*
	close() : connection close
*/
	public function disConnect() {
	@fclose($this->_connection);
	}

/*
	Run command ($command,$args,$parse,$cont,$field,$limit,$shmsub)
	  $command : i  : string a command to be executed through MPD
	  $args    : i  : mixed string for a single argument, array for multiple
	  $parse   : i  : 0:Line Output  1:kind('directory'/'playlist'/'file') or 1St Item Countup  2:1St Item Countup
	  $cont    : i  : 1:the output is an ACK error ,No Exception
	  $field   : i  : array of Used mpd get Filed ( Directory / playlist / file required by Case )
	  $limit   : i  : NULL:Unspecified  / Specify the number of lines (based on the file attribute)
	  $shmsub  : i  : Sheard Memory Subkey : Sheard Memory:$command || $command[$shmsub]
	  @return  : o  : array of server output
	                  true(1) : No Data / Warning:Message 
	                  false: Network Error
*/
	public function runCommand($command, $args = array(), $parse = 1,$cont = 0,$field = '',$limit=NULL,$shmsub="") {
	if (is_array($args)) {				//Generate the command
		foreach($args as $arg) {
			$command.= ' "'.str_replace('"', '\"', $arg) .'"';
			}
		}
	elseif (!is_null($args)) {
			$command.= ' "'.str_replace('"', '\"', $args) .'"';
        	}
	$sts=0;$subkey="";
	if ($shmsub !=="") { $subkey="[".$shmsub."]" ; }
	$array=SHM_CommandGet($command.$subkey,$sts);		// Shared Memoryから取得(条件が合えば)
	$output=$array;
	if ($array==false) {						// Shared Memoryから取得できなかったときはMPDから取得
// Get Mpd Command -----
		try {
			$this->write($command);		//Write and then capture the output
			}
			catch( Exception $e ) {
			$this->p_error=$e->getMessage();
			return false;
		}
		try {
			$output = $this->read($cont,$field,$limit,$command);
			}
			catch( Exception $e ) {
			$this->p_error=$e->getMessage();
			return false;
			}
		;
// Get Mpd Command End -----
		SHM_CommandPut($command.$subkey,$output,$sts);	// Shared Memoryに書き込み
		}
	if ($sts == 0) { SHM_Term(); }				// Shared Memory Terminate
	$this->_output[] = array($command, $output);

	if ($output === array()) {
		if ($this->w_message !== "") {		// return : Warning 
			return $this->w_message;
			}
		return 1;							// return : 1 Data 0件 
		}
	if (($parse != 0)&&(is_array($output))){
		return $this->parseOutput($output,$parse);
		}
	return $output;
	}

/*
	write($data) : Write data to the socket
	 $data  : i  : command : string data to be sent
	 @return: o  :  bool
*/
	function write($data) {
	if (!$this->isConnected()) {							//Are we connected?
	    $this->connect();									// Try to connect
		}
	$display_errors=ini_get('display_errors');
	ini_set('display_errors', 0);
	if (!fwrite($this->_connection, $data."\r\n")) {		//Write the data
		ini_set('display_errors',$display_errors);
		return('Write failed : WRITE_FAILED('.self::WRITE_FAILED.')'.$data);
		}
	ini_set('display_errors',$display_errors);
	$this->_commands[] = $data;
	$this->tcplog("Send  :".$data."\n");
	return true;
	}

/*
	read($cont) : Read data from the socket
	  $cont  : i  : 1:the output is an ACK error ,No Exception
	  $field : i  : array of Used mpd get Filed ( Directory / playlist / file required by Case )
	  $limit : i  : NULL:Unspecified  / Specify the number of lines (based on the file attribute)
	  $command: i  : write Command, Valid when Limit is specified ,Decide how to count
	  @return: o  : array of raw output
*/
	function read($cont=1,$field='',$limit=NULL,$command=NULL) {

	if (is_array($field)) {					// Make Used mpd get Filed Array
		$infld=array_flip ($field);
		$infld['file']="";
		}
	$fldtop="file";
	if (!is_null($command)) { if (strpos(trim($command),'list') === 0) { $fldtop=""; } }	// Count Filed "" Every Cpinmt Else files Count)
	$display_errors=ini_get('display_errors');
	ini_set('display_errors', 0);
	if (!$this->isConnected()) {			//Are we connected?
		ini_set('display_errors',$display_errors);
		return('Not connected : CONNECTION_NOT_OPENED('.self::CONNECTION_NOT_OPENED.')');
		}
	ini_set('display_errors',$display_errors);
	$this->w_message="";
	$ret=false;
	$output = array();
	if ($this->timeout != 0) {
		socket_set_timeout($this->_connection, $this->timeout);
		}
	$start_time = time();
	$cnt=0;
	while (!feof($this->_connection)) {			//Loop through the connection, putting the data into $line
		$line = fgets($this->_connection);

		if ($this->timeout != 0) {
			$stat = socket_get_status($this->_connection);	// ソケットがタイムアウトか
 			if ($stat["timed_out"]) {
				$this->tcplog("Timeout\n");
				$this->w_message="Timeout";
				$ret="Timeout";
				}
			}
		$end_time = time();
		if (($this->timeout != 0) &&(($end_time - $start_time) > $this->timeout)) {		// 受信メッセージが長すぎる
			$this->disConnect();							// Bufferを捨てるため Disconnect / Connect
			$this->connect();
			$this->tcplog("Timeout (Get too long)\n");
			$this->w_message="Timeout (Get too long)";
			$ret="Timeout (Get too long)";
			break;
			}

		$this->tcplog("Recive:".$line."\n");
		if (($cont)&&(preg_match('/^ACK \[(.*?)\@(.*?)\] \{(.*?)\} (.*?)$/', $line, $matches))) {	//If the output is an ACK error
			$this->w_message="No objective data";
			$ret=$line;
			break;
			}
		if (preg_match('/^ACK \[(.*?)\@(.*?)\] \{(.*?)\} (.*?)$/', $line, $matches)) {		//If the output is an ACK error
			//$this->runCommand('clearerror'); //Cleanup the error
 			$this->_errors[] = $matches;
			$this->_current_error = array('ack' => $matches[1], 'func' => $matches[3], 'error' => $matches[4]);
			throw new Exception('Command Failed : ACK_COMMAND_FAILED('.self::ACK_COMMAND_FAILED.')'.$line);
			}
		elseif (trim($line) == self::RESPONSE_OK) {				//The last line of output was hit, close the loop
			 break;
			 }
		else {
			 if (is_array($field)) {
				 $parts = explode(': ',$line,2);
				 if ((isset($parts[1]))&&(!isset($infld[$parts[0]]))) { continue; }	// When , Not Use Fileds go to continue
				 }
			 if (!is_null($limit)) {							// Line upper limit specified
				if($fldtop =="") {									// One Filed ,Direct Count
					$cnt=$cnt+1;
					 if ($cnt > $limit) {
						  $output[]="warning: line suspended due to upper limit:".$limit;
						  break;
						  }
					 }
				else {
					 $item = explode(': ',$line,2);
					 if ($item[0] ==$fldtop) {					// file attribute is the starting point
						$cnt=$cnt+1;
						if ($cnt > $limit) {
						 	$output[]="warning: line suspended due to upper limit:".$limit;
							break;
							}
						}
					 }
				 }
//print 'Line:'.$line.'<BR>';
			$output[] = $line;								//Output from the server added to the return array
			}
		}
	if ($ret){
		return $ret;
		}
	return $output;
	}

/*
	Parse MPD output on a line-by-line basis creating output that is easy to work with
	  $input : array of input from MPD
	  $parsee: 1:kind('directory'/'playlist'/'file') or 1St Item Countup  2:1St Item Countup
	  @return array
*/
	public function parseOutput($input,$parse = 1) {
	if (!is_array($input)) {
		$input = array($input);
		}
	$output = array();
	$key1st="";
	$i=0;
	foreach($input as $line) {
		if (is_array($line)) {
			$this->tcplog("Server output not expected Get Line Array:".print_r($line, true));
			$this->_errors[] = 'Server output not expected: '.print_r($line, true);
			continue;
			}
		$parts = explode(': ', $line, 2);
		if (!isset($parts[0], $parts[1])) {
			$this->tcplog("Server output not expected Nor(:) :".$line);
			$this->errors[] = 'Server output not expected: '.$line;
			continue;
			}
		$key   = trim($parts[0]);
		if ($key=="Title") { $value=preg_replace('/\r\n|\r|\n/','',$parts[1]); } else { $value = trim($parts[1]); }
		if (($parse == 1) && (($key == 'directory') || ($key == 'playlist') || ($key == 'file'))) {	// File/Directory/Playlistいずれかがlsinfo/Findでくる
			 $ix_key="kind";
			 }
		else {
			 $ix_key=$key;
			 }
		if ($key1st == "") {			// 最初のKeyを起点にする
			$key1st=$key;
			}
		else if (($key1st == $key) || ($ix_key == "kind")) {	// 最初のKey,File/Directory/Playlistも起点にする
				 $i+=1;
				 }
		if ($ix_key == "kind") {		// File/Directory/Playlistを抜かないようにする
			$output["kind"][$i] = $key;
			}
		$output[$key][$i] = $value;
		}
	return $output;
	}

/*
	tcplog($log) : MessageLog
	 $log : i  :logmsg
	Parse MPD output on a line-by-line basis creating output that is easy to work with
*/
	public function tcplog($logmsg) {
	if ($this->debug) {
		$fp = fopen($this->filename, "a");
		$size = filesize($this->filename);
		if ($size > $this->logsize) {
			@rename($this->filename,$this->filename.".old");
			$fp = fopen($this->filename, "w");
			}
		fwrite($fp,date("Y/m/d H:i:s")." ".$logmsg);
    	fclose($fp);
		}
	}

//----- class Net_Common End----------------------------------------------------
 }
//----- Source End --------------------------------------------------------------
?>
