/* **********************************************************************************
	mpdweb Common jsp Library mpdweb.libcajax.js
    ---------------------------------------------------------
	RequestByPost() : AJAX
*********************************************************************************** */
MYJSVER_AJAX="mpdweb.libcajax.js 1.1 (31.05.2022)";
/* -----------------------------------------------------------------------------
	RequestByPost(module,para,callback) : Post Request
		module  : i  : Post Module
		para    : i  : Post Parameter
		callback: i  : Callback
	 Post reception format
	  Value: {string}={string} : Set constant in JS item JS定数設定
	  Function:{function}      : Performing JS functions JS関数実行
	  {HTML ID}]:{Display-HTML}: HTML ID Display
	  String                   : Status Line Display

	 Call prerequisites
	  ERSTR    : 定数エラー時扱いのString
	  IDSTS    : 定数 Status表示用HTML-id("status")
	  HTML-id  : IDSTS("status") を用意しておく。 StatusLine

	※mpdweb.phpと同じ関数名となっていることに注意(後定義で本関数を有効にする)
	  mpdweb.phpは条件付き,reCallback/FormからのAJAXを可能にするなど他アプリで使用するには
	  OverSpecなので,簡易に使用できるように独立している。
------------------------------------------------------------------------------ */
function RequestByPost(module,para,callback) {
	if (typeof ERSTR === "undefined") {
		var ERSTR = 'ERR';
		}
	if (typeof IDSTS === "undefined") {
		var IDSTS = 'status';
		}

	if (callback == null) { callback=''; }

	if(window.addEventListener) {									// Firefox
		  var request = new XMLHttpRequest();						// Ajax Request Function
		  }
	 else {															// IE
		  var request =  new ActiveXObject("Microsoft.XMLHTTP");	// Ajax Request Function
		  }
	/* ステータス( 読み込み中なのか完了したのか) が変更されたら readyStateChangeHandler を実行 */
	request.open("POST", module , true);
	request.onreadystatechange = readyStateChangeHandler;
	request.setRequestHeader( "Content-Type" ,  "application/x-www-form-urlencoded");
	request.send(para);
	function readyStateChangeHandler(){								// Receive Completion
		switch(request.readyState){
			case 4:
				if(request.status == 200) {							// 完了時
					var res_ans = request.response.split("\n");
					var response = "";var last_msg = "";var err_msg = "";
					for(var i=0; i < res_ans.length ; i++ ) {
						if (res_ans[i] == "") {  continue; }
						var htm_id = res_ans[i].split(":",2);
						var htm_id_str = res_ans[i].replace(htm_id[0]+":","");
					// Form : Value Value:が検出されたときは，変数の変更 : "^"先頭一致
						if ((htm_id.length>=2)&&(htm_id[0].match(RegExp("^value","i")))) {		// Receive: Value: {string}={string}
							var valstr = htm_id[1].split("=",2);
							if (valstr.length >=2) {
								var chgstr=res_ans[i].replace(htm_id[0]+":"+valstr[0]+"=","");		// splitは切り捨てのためValue:{string}を""に置換
								eval(valstr[0] + "= "+chgstr);
								continue; 
								}
							}
					// Form : Function Function:が検出されたときは，以下をFunctionと扱う : "^"先頭一致
						if (res_ans[i].match(RegExp("^Function","i"))) {						// Receive: Function:{function}
							try {
								eval(htm_id_str);
								} catch (e) {
								response=response+"Callback:Errror "+e+"\n";					// エラーを検知
								}
							continue;
							}
					// Form : {HTML ID}]:{Display} HTML IDが存在時に表示
						if (htm_id.length>=2) {
							if (document.getElementById(htm_id[0]) != null) {					//  HTML-IDがあれば表示する。
								var idobj = document.getElementById(htm_id[0]);
								idobj.outerHTML=htm_id_str;
								continue;
								}
							}
						response=response+res_ans[i]+"\n";			// 形式なしはメッセージとする
						if  (res_ans[i].match(RegExp(ERSTR,"i"))) {	// 引数のError MessageWordと一致？
							 err_msg  = res_ans[i]; }
						else {
							 last_msg = res_ans[i]; }
						}
				// Case End Process
					var out = document.getElementById(IDSTS);
					if (err_msg != "") {						// 先頭はErrorの行を優先し表示
					 	 out.innerHTML = err_msg  + "\n"; }
					else {
						 out.innerHTML = last_msg + "\n"; }
					out.innerHTML += response;
				// Call Back
					if (callback != '') {
						callback();
						}
					}
			break;
			}
		}
	}
/* ------------- End of Source --------------------------------------------------------*/
