<?php
/***************************************************************************************
	mpdweb.list.php : mpdweb 拡張 List
     mpdweb.list.php?p=extend|list ...{List機能同じ} : mpdwebをLibrary機能を使用し拡張する
	 mpdweb.php List機能を拡張する:List機能にArtを付加

	起動) http:{host}/mpdweb/mpdweb.list.php?p=extend|list mpdweb?p=listと同じパラメータが必要

      Ex)
	    http:{Host}/mpdweb/mpdweb.list.php?p=extend|list
	    http:{Host}/mpdweb/mpdweb.list.php?p=extend|list&f=Date&q1=Date:B64:MjAyMg..&q2=field:AlbumArtist

	MusicData Tag:とDirectoryに対応した画像ファイルを選択表示する。
	Tagは，Artist,AlbumArtist,Date,Genreに対応するが，mpdweb_list.xml:デフォルトではArtist,AlbumArtistとしている。
	Artist/AlbumArtistは別々の画像ファイルは同じ画像ファイルを使用するかは設定できる。
	LinkPath/ArtDirectoryで固定ファイル名(Folder.jpgなど)，Tag同様.jpgの設定ができる。
	LinkTextでテキストファイルでTag/画像ファイル対応もできる。選択表示順序は設定することができる。

	$_SESSION : ExtendListArt/list : list/album    : mpdweb基本ルール命名とする
	                                                 mpdweb_list.xmlで設定<ExtendFunction><continue>ExtendListArt/list|list</continue>
	                                                 mpdconfig.xml  で設定<ListExtend>    <continue>ExtendListArt/list|album</continue>として合わせること
	            ExtendListArt/TbNo : {TBNo} 1～10  :  一列の画像数
	            ExtendListArt/Renew: on/off他)     : on:画像Fileがない場合強制サーチ

	※1. ?p=extend|listはmpdweb.phpの延長で使用。mpdweb.php?p=nopで関数のみ使用できるが，追加機能を作成
	     延長で使用するが無駄ロジックも含まれるが，mpdweb.php本体は必要としないようにしている。
	※2. mpdweb.php/mpdconfig.xmlがShared Memory<Shm_Project>を使用する設定時,mpdweb.list.phpも使用可能
	     Shared Memory使用のLibraryは，MPD DBUpdateで，Memoryクリアするが，当処理はクリアしない。
	     Tag/Direcrotyの構成に依存するので，Tag名が変更されても，ファイル配置で対応できる。
	     セッション有効な期間，サイズの削除で無効設定が整理できる。
/************************************************************************************* */
$BASENAME=basename(__FILE__);							// テスト時basenameを一連モジュール合わせて実行可能にしておく
$ary=explode(".",$BASENAME);
$ORIGIN=$ary[0];										// OriginName:"mpdweb"
$MPDWEB=$ORIGIN.".php";									// $MPDWEB:"mpdweb.php":標準
// mpdweb libray
$require_lib=dirname(__FILE__).'/'.$ORIGIN.'.lib.php';	// mpd XML Library Default
if  (file_exists($require_lib)) {						// mpd Session id Libraryの存在確認
	require_once($require_lib);
	}
// mpdweb session libray
$require_ses=dirname(__FILE__).'/mpdcmnses.lib.php';	// mpd Session id Library
if  (file_exists($require_ses)) {						// mpd Session id Libraryの存在確認
	require_once($require_ses);							// mpd Mpd Session id Library
	}
// PHP/HTML変数取得
$STS_MESSAGE="";
$SESSION_CONF=GetSessionConfigListArt();				// php Session Config
//ArgSessionStart($SESSION_CONF);//						// mpdweb.phpの延長で使用のため使用しないこと:require_once("mpdweb.php")で行う : Used mpdcmnses.lib.php
// mpdweb library
$require_web=dirname(__FILE__).'/'.$MPDWEB;				// mpdweb.php(必須) LibraryModeで使用(URL:&extend指定)
require_once($require_web);
// Version
$MY_LISTARTVERSION=basename(__FILE__,"")." 1.1 (31.3.2024)";

// ※ $DEBUG= 2 ケースにより,ファイルアウトに掛かる負担でTimeoutがあり得ることに注意。Art切り替えを繰り返すときなど
$DEBUG= false;	// flase 1:msg 2:logout 3:User
//$DEBUG= 2;  	// false 1:msg 2:logout 3:User // 2:にするときは、Directory Permissionを書き込み許可にすること。
//$DEBUG= 3;  	// false 1:msg 2:logout 3:User
//GetEnvCommon();										// mpdweb.phpの延長で使用のためGetEnvCommon();はCall不要
/* -------------------------------------------------------------------------------------
	mpdweb.list.php HTML CSS
-------------------------------------------------------------------------------------- */
	echo <<<EOM
<script type="text/javascript">
/* Parent Moduleに設定 */
POST_MOD = POST_MOD.replace("{$BASENAME}","{$MPDWEB}");
PHP_SELF = PHP_SELF.replace("{$BASENAME}","{$MPDWEB}");
</script>

<style type="text/css">
/*
.LstNImg :No Image Frame
.LstNIgC :No Image Character Parts
.LstHead :DispList Header
.LstSele :DispList Header SelectBox
.AlbmFrm :Album Text Frame
.AlbmBFr :Album Button Frame
.AlbmBtn :Album Text Button
.AlbmTex :DispAlbum(Common) Text Part
.AlbmArt :DispAlbum Art Cursor
*/
.LstNImg { overflow:hidden;border:0px solid #333333; }
.LstNIgC { margin:7px 0px 0px 0px; }
.LstHead { float:left;overflow:hidden;white-space:nowrap;font-size:12px;}
.LstSele { font-size:11px;background-color:#d3d3d3;color:#3d3d3d;cursor:pointer;}
.AlbmFrm { position:relative;top:3px; }
.AlbmBFr { margin:-35px 0px 0px 0px; }
.AlbmBtn { height:34px;border:1px solid #333333; }
.AlbmTex { font-size:10px;height:30px;line-height:16px;margin:2px 1px 4px 0px;word-break:break-all;}			/* line-height:Phone基準 */
.AlbmArt { cursor:pointer;font-size:11px;}
</style>
EOM;

?>

<?php
//ini_set('display_errors',1);
/***************************************************************************************
	mpdweb.list.php
************************************************************************************** */
GetEnvListArt();									// ListArtApplication設定
if($STS_MESSAGE !=="") { DispErrorBox("mpdweb.list<BR>GetEnvListArt Error:".$STS_MESSAGE);exit; }
GetArgAnalyzeListArt($_GET,$ARG);					// Argument  Analyze & Module$_GET["p"] Decide For Heredoc

$PHP_CONFIG=array("php_timeout"=>130,"php_looptime"=>120,"php_locale"=>"ja_JP.UTF-8","memory_limit"=>"160M");
get_config("php_config",$PHP_CONFIG);				// php config
set_time_limit($PHP_CONFIG["php_timeout"]);
setlocale(LC_ALL,$PHP_CONFIG["php_locale"]);
ini_set('memory_limit',$PHP_CONFIG["memory_limit"]);
//----- mpd library init --- ---------------------------------------------------
get_libinit();
if (isset($PHP_CONFIG["php_looptime"])) {						// Special Setting : $LIB_CONF["LoopTimeout"]が設定されていたらループを打ち切る設定として使用 
	$LIB_CONF["LoopTimeout"]=$PHP_CONFIG["php_looptime"];		// XMLに設定していないので"php_looptime"を活用。現在:mpd_list_find()で使用。
	}
//----- mpd network  -----------------------------------------------------------
$Net = new Net_Common;
$tout=array("DispTimeout"=>0,"ConnectTimeout"=>4);	// Timeoutは局面で変える可能性かあるので共通化としていない
$no=get_config("Net_Timeout",$tout);
if ($no != 0) {
	$Net->timeout=$tout["DispTimeout"];				// Used Disp Timeout
	$Net->c_timeout=$tout["ConnectTimeout"];
	}
get_config("Mpd_net",$Net->p_connect);				// Net_Common Property mpdconfig.xmlから設定
if (!$Net->connect()) {
	$str="mpdweb.list<BR>Connect Error [".$Net->p_connect['host']."]";
	DispErrorBox($str);
	}

/* -----------------------------------------------------------------------------
	mpdlistart MainProsess
------------------------------------------------------------------------------ */
ArgPostPlaylistInit();								// ArgPostPlaylis Series initialize
//----- List Art ---------------------------------------------------------------
if ((strpos($ARG["p"],"extend") !== false)&&(strpos($ARG["p"],"list") !== false)) {
	$value = "";$query = "";$jssort=1;
	if  ((!is_array($ARG['f']))&&($ARG['f'] !== "" )) {		// $field : "Artist" "AlbumArtist" "Date" "Genre"
		 $field = $ARG["f"];
		 if (isset($ARG["m"][$field])) {					// $value : $field : Positoning Point
			 $value = $ARG["m"][$field];
			 }
		 }
	else if ((isset($_SESSION["List"]))&&($_SESSION["List"] !== "" )) {	// $_SESSIONがあれば使用する
		 $field=$_SESSION["List"];
		 }
	else if ($XML_DCONF["DefaultList"] == "DefaultArtist") {	// ListのFieldの初期値が"DefaultList"のとき
			  $field=$XML_DCONF["DefaultArtist"];
			  }
		 else {
			  $field=$XML_DCONF["DefaultList"];				// DefaultのFiledを設定する
			  }
	if (isset($_SESSION["ExtendListArt/Position/".$field])) {
		 $pos=$_SESSION["ExtendListArt/Position/".$field];
		 }
	else {
		 $pos=$XML_POSTION["List_Position_".$field];
		 $_SESSION["ExtendListArt/Position/".$field]=$pos;
		 }
	JsPHPSession("ExtendListArt/Position/".$field,$pos);	// $_SESSION同等をJSで使用する
	if (isset($ARG["d"][$field])) {
		$query=$ARG["d"][$field];
		}
	$requery=array();
	if (isset($ARG["key"]["q"])) {						// 再Queryを引数より設定
		$requery["Query"][$field]=$ARG["q"][$field];	// $requery["Query"][$field] : 再Query条件
		$requery["Filed"]=$ARG["q"]["field"];			// $requery["Filed"]         : 再QueryのOut Field
		$query=$ARG["q"]["field"];						// $query : 初期の引数を復元
		}
	if (count($requery) == 0) {	$requery=""; }			// PHP Version5での作成時 配列を作成しないときは,""としていたのでロジックを合わせる
	if  ((!is_array($ARG['f']))&&($ARG['f'] == "" )) { $ARG['f']=$field; }		// 外部I/F用に設定
	if  (!isset($_SESSION["ExtendListArt/TbNo"])) {		// 1Line ArtNo
		 $_SESSION["ExtendListArt/TbNo"]=$XML_LISTART["List_ArtNo"];
		 $tbno=$XML_LISTART["List_ArtNo"];
		 }
	else {
		 $tbno=$_SESSION["ExtendListArt/TbNo"];
		 }
	DispListArt($field,$query,$requery,$pos,$value,$tbno);

	if (($XML_JSSORT["JsSort"] == "on")&&($jssort==1)) {	// JS ItemSort Libを$ARG[P]を合わせてLoad
		$dateform="";										// mpdweb.php Common Library : JSSort Library
		$date = new DateTime();
		$date->setTimestamp(filemtime($csscommon));
		$dateform=$date->format('YmdHis');
		$dateform="?a=".$dateform;
		$jssort=dirname($_SERVER['PHP_SELF']).'/'.$ORIGIN.'.lib.sort.js';		// mpdweb.lib.sort.js mpd{module}.js
		print '<script type="text/javascript" src="'.$jssort.$dateform.'"></script>';
		}
	}
mpd_close();	// Disconnect
exit();

/* -----------------------------------------------------------------------------
	GetSessionConfigListArt() : php Session Config
	 @return: o  : "":$SESSION_CONF Session Array
	※ require(mpdweb.php)の前に設定を取得する
----------------------------------------------------------------------------- */
function GetSessionConfigListArt() {
	global $XML_CONF,$STS_MESSAGE;

	$XML_File = "setting/mpdconfig.xml";
	$ret="";$STS_MESSAGE="";
	try {
		$XML_CONF = get_loadconfig($XML_File);			// XML File Get FileNameはLibrary標準
		} catch( Exception $e ) {
	  $STS_MESSAGE=$e->getMessage();
	  $ret=False;
	  }

	ignore_user_abort(false);							// 切断時終了
	$SESSION_CONF=array("sesion_id"=>"mpdweb","href_waitmsec"=>"50","maxlifetime"=>"1440");
	get_config("php_session",$SESSION_CONF);			// php config php_session
	$SESSION_CONF=ArgSessionConf($SESSION_CONF);		// mpdweb:Session id 作成 : Used mpdcmnses.lib.php

	return($SESSION_CONF);
	}

/* -----------------------------------------------------------------------------
	GetEnvListArt() : Environment Application Set
	@return: o  : End Status "":No Error , {Error Message}:Error
	※ require(mpdweb.php)後ListArt Application用
----------------------------------------------------------------------------- */
function GetEnvListArt() {										// mpdweb.phpの延長で使用のためGetEnvCommon();はCall不要
	global $XML_CONF,$XML_LISTCONF,$XML_LISTART,$XML_DLISTARTCOMB,$XML_FILENAME,$XML_ORDER,$XML_CONF_ARY,$XML_FiledGroup,$XML_SHMOPT,$XML_JSSORT;
	global $XML_POSTION,$XML_SHMLISTART,$XML_IMGThread,$XML_EXTENDFUNC,$STS_MESSAGE;

	$XML_ListArt = "setting/mpdweb_list.xml";					// XML File ListArt Setting
	try {
		$XML_LISTCONF=get_loadxml($XML_ListArt);
		} catch( Exception $e ) {
	  $STS_MESSAGE=$e->getMessage();
	  }
	$XML_POSTION=array("List_Position_Artist"=>"on","List_Position_AlbumArtist"=>"on","List_Position_Date"=>"on","List_Position_Genre"=>"on","List_Position_Album"=>"off");
	get_confxml($XML_LISTCONF,"DISP_Config",$XML_POSTION);
	$XML_LISTART=array("List_ArtNo"=>"3","List_Space"=>"Artist:off,AlbumArtiston:on");	// ListArt 1Line:ArtNo 
	get_confxml($XML_LISTCONF,"DISP_Config",$XML_LISTART);
	$ary = explode(",",$XML_LISTART["List_Space"]);
	foreach($ary as $ar) {
		$tmp = explode(":",$ar);
		if(isset($tmp[1])) { $XML_LISTART["List_Space_Filed"][$tmp[0]]=$tmp[1]; }
		}
	$XML_DLISTARTCOMB=array("ListArt_Comb"=>"Artist,AlbumArtist","List_Comb"=>"Artist,AlbumArtist,Date,Genre ","List_Field"=>",Artist,AlbumArtist,Date,Genre,Album");		// XML File,Display Function設定
	get_confxml($XML_LISTCONF,"DISP_Config",$XML_DLISTARTCOMB);			// ListArt_Comb : この機能で扱うFiled
	if (strpos($XML_DLISTARTCOMB["ListArt_Comb"],"setting/mpdconfig.xml") !== false) {
		$cnf_filed["filed"]="Artist,AlbumArtist";
		get_config("ListExtend",$cnf_filed);							// mpdconfig.xml:"ListExtend"から"filed"をセット
		$XML_DLISTARTCOMB["ListArt_Comb"]=$cnf_filed["filed"];
		}
	if (strpos($XML_DLISTARTCOMB["List_Comb"],"setting/mpdconfig.xml") !== false) {
		$XML_DLISTARTCOMB["List_Comb"]="Artist,AlbumArtist";
		get_config("DISP_Config",$XML_DLISTARTCOMB);					// mpdconfig.xml:"DISP_Config"から"List_Comb"をセット
		}
//  ArtFile設定
//  文字置換: $XML_FILENAME["RepChar"]["a"][]=>$XML_FILENAME["RepChar"]["b"][]
//	Extend  : $XML_FILENAME["Extend"][]
//  FileName: $XML_FILENAME["FileName"][]
//  WebRoot : $XML_FILENAME["WebRoot"] : Web Root
	$XML_FILENAME=array("ArtDirectoryRepChar"=>"&|/","LinkPathFileName"=>"Folder.jpg,folder.jpg","Directory"=>"\\","ArtDirectoryExtend"=>"jpg,png","WebRoot"=>"%DOCUMENT_ROOT%","XML_LISTART_Order"=>"setting/mpdweb_list_myset.xml");		// ListArt FileName: {before}\t{After}\n{before}\t{After}\n...
	get_confxml($XML_LISTCONF,"LISTART_Filename",$XML_FILENAME);
	$ary=explode('\n',$XML_FILENAME["ArtDirectoryRepChar"]);
	$XML_FILENAME["RepChar"]=array();$XML_FILENAME["FileName"]=array();
	foreach($ary as $key=> $ar) {
		$ary=explode('\t',$ar);
		$XML_FILENAME["RepChar"]["a"][$key]=$ary[0];
		$str="";
		if(isset($ary[1])) {
			$str=$ary[1];
			}
		$XML_FILENAME["RepChar"]["b"][$key]=$str;
		}
	$XML_FILENAME["FileName"]=explode(',',$XML_FILENAME["LinkPathFileName"]);		// FileName Setting
	$XML_FILENAME["Extend"]=explode(',',$XML_FILENAME["ArtDirectoryExtend"]);		// FileExtend
	$XML_FILENAME["WebRoot"]=str_replace("%DOCUMENT_ROOT%",$_SERVER['DOCUMENT_ROOT'],$XML_FILENAME["WebRoot"]);
////////////////////////////////////////////////////////////////////////////////////////
//  $XML_FILENAME["XML_LISTART_Order"]: MySettingがなければ，mpdweb_list.xmlを使用する
//  $XML_ORDER["key"][]: LinkText    :MetaTag:ArtFileName設定ファイル
//                       LinkPath    :検索Directory下のFileNameを使用 : Webroot下にあること
//                       ArtDirectory:指定Directory下のMetaTagをFile名として使用する。RepCharの変換を行う
//  $XML_ORDER["val"][]: $XML_ORDER["key"]に対応するValue
//  $XML_ORDER["att"][]: $XML_ORDER["key"]に対応するAttribute:Filed
	try {
		$XML_LISTARTORDER=get_loadxml($XML_FILENAME["XML_LISTART_Order"]);
		} catch( Exception $e ) {
//	  print "<BR><BR><BR><BR><BR>".$e->getMessage()."<BR>";
	  $XML_LISTARTORDER=null;
	  }
	if(!is_null($XML_LISTARTORDER)) {
		$XML_ORDER=GetEnvListArt_Order($XML_LISTARTORDER);
		}
	if ((!isset($XML_ORDER["key"]))||(count($XML_ORDER["key"])) == 0) {
		$XML_ORDER=GetEnvListArt_Order($XML_LISTCONF);
		}
// Shm_Project Get
	$tmpary=array("FiledGroup"=>"");
	get_confxml($XML_LISTCONF,"Shm_Project",$tmpary);
	$ary=explode(',',$tmpary["FiledGroup"]);
	foreach($ary as $val) {											// FiledGroup設定
		$ary=explode(':',$val);
		if(isset($ary[1])) { $XML_FiledGroup[$ary[0]]=$ary[1]; }
		}
	$XML_SHMOPT=array("FileExist"=>"off");							// Fileが存在しないときもSharedMemoryにセット
	get_confxml($XML_LISTCONF,"Shm_Project",$XML_SHMOPT);
	$XML_CONF_ARY["setting/mpdconfig.xml"]=$XML_CONF;				// AlterSectionでmpdconfig.xmlの内容を取得
	$XML_CONF_ARY["setting/mpdweb_list.xml"]=$XML_LISTCONF;
	$tempary=array("Used"=>"off","Common"=>"0,/tmp,128,43200,,,");
	GetAlterConfig("Shm_Project",$tempary);			// Alternative get_config
	$XML_SHMLISTART=array("Used"=>$tempary["Used"],"Common"=>$tempary["Common"],"ListArt"=>"5");		// mpdweb_list.xml:"Shm_Project"で個別に設定時取得
	get_confxml($XML_LISTCONF,"Shm_Project",$XML_SHMLISTART);
	if($tempary["Used"]=="off") { $XML_SHMLISTART["Used"]="off"; }	// mpdconfig.xml:Shm_ProjectがUsed:off時,onにできないようにする。(LibrayがShared Memory未使用)
// イメージファイルスレッド設定
	$XML_IMGThread=array("no"=>30,"Thread"=>"on","Loop2nd"=>100,"Forcing"=>20);							// ImageThreadNo数
	get_confxml($XML_LISTCONF,"DispIMGThread",$XML_IMGThread);
	if ($XML_IMGThread["no"] < 1) { $XML_IMGThread["no"]=1; }
// $XML_JSSORT mpdweb.php用を優先
	$tmp=$XML_CONF;								// AlterConfigを使用するため$XML_CONFをkeepしておく
	$XML_CONF=$XML_LISTCONF;
	$XML_JSSORT=array("JsSort"=>"off","List"=>"Artist,AlbumArtist");
	GetAlterConfig("JsItemSort",$XML_JSSORT);
	$XML_CONF=$tmp;
// Button/Function設定 : 変数:$BASENAME[mpdweb.list.php]/$MPDWEB[mpdweb.php]/$RESULT:onclick変数
	$XML_EXTENDFUNC["Func"]="Art";				// [Func]:拡張Button [event]:拡張Button JS [compel]:Tag内容が取れないとき強制復帰JS "return":List Button URL
	$XML_EXTENDFUNC["color"]="background-color:#008000;color:#CED8F6;";
	$XML_EXTENDFUNC["event"]='$RESULT=str_replace($BASENAME,$MPDWEB,$_SERVER["REQUEST_URI"]);$RESULT=str_replace("p=extend|list","p=list",$RESULT);$RESULT="RequestLoadDisp();location.href=\'".$RESULT."\'";';
	$XML_EXTENDFUNC["compel"]='$RESULT=str_replace($BASENAME,$MPDWEB,$_SERVER["REQUEST_URI"]);$RESULT=str_replace("p=extend|list","p=list",$RESULT);$RESULT="RequestLoadDisp();location.href=\'".$RESULT."\'";';
	$XML_EXTENDFUNC["return"]='$RESULT=str_replace($BASENAME,$MPDWEB,$_SERVER["PHP_SELF"]);$RESULT=$RESULT."?p=list&f=".$field."&m=".$field.":".$FILEDSELECT;';
	$XML_EXTENDFUNC["continue"]='ExtendListArt/list|list';			// 拡張を継続させる場合の項目($_SESSION[{continue}])。Orignalに合わせる。他のlist/albumと同じルール。
	get_confxml($XML_LISTCONF,"ExtendFunction",$XML_EXTENDFUNC);
//print "<BR><BR><BR><BR><BR><BR><BR>";
//print_r($XML_POSTION);print "<BR>";
//print_r($XML_DLISTARTCOMB);print_r($XML_LISTART);print "<BR>";
//TblDump('$XML_FILENAME,',$XML_FILENAME,"");
//TblDump('$XML_ORDER,',$XML_ORDER,"");print '<BR>LISTART_Order Filename['.$XML_FILENAME["XML_LISTART_Order"].'] SetingNo['.count($XML_ORDER["key"]).']<BR>';
//print_r($XML_SHMLISTART);
//print_r($XML_FiledGroup);print_r($XML_SHMOPT);
//print_r($XML_IMGThread);print_r($XML_EXTENDFUNC);
	return($STS_MESSAGE);
	}

/*
  GetEnvListArt_Order($xmlarray) : Make XML:LISTART_Order
   $xmlarray : i  : XMLSettingFile:Array , get_loadxml({XMLSettingFile})形式
   @return   : o  :  Array : LISTART_Order

 作成形式)
  $order["key"][]: LinkText    :MetaTag:ArtFileName設定ファイル
                   LinkPath    :検索Directory下のFileNameを使用 : Webroot下にあること
                   ArtDirectory:指定Directory下のMetaTagをFile名として使用する。RepCharの変換を行う
  $order["val"][]: $order["key"]に対応するValue
  $order["att"][]: $order["key"]に対応するAttribute:Filed
*/
function GetEnvListArt_Order($xmlarray) {							// mpdweb.phpの延長で使用のためGetEnvCommon();はCall不要
	$xml = get_object_vars($xmlarray);
	$order["key"]=array();$order["val"]=array();$order["attr"]=array();
	$dxml = dom_import_simplexml($xml["LISTART_Order"]);			// XML To HTML
	$i=0;
	foreach($dxml->childNodes as $node) {							// Search順設定
		if ($node->nodeName == "#text") { continue; }
		if ($node->nodeName == "#comment") { continue; }
		$str=str_replace("%DOCUMENT_ROOT%",$_SERVER['DOCUMENT_ROOT'],$node->nodeValue);
		$order["key"][$i]=(string)$node->nodeName;
		$order["val"][$i]=(string)$str;
		foreach($node->attributes as $attr => $dmy) {
			if ($attr =="Filed") {
				$attrobj = $node->attributes->getNamedItem($attr);
				$order["attr"][$i]=(string)$attrobj->nodeValue;
				}
			}
		$i=$i+1;
		}
	return($order);
	}

/* -----------------------------------------------------------------------------
	GetArgAnalyzeListArt($Link,$ARG) : Argument  Analyze & Module$_GET["p"] Decide
	 $Link   : i  : $_GET or $_POST
	 $ARG    : o  : Analyze Argument
----------------------------------------------------------------------------- */
function GetArgAnalyzeListArt($Link,&$ARG) {
	global $ARG,$MPDWEB;								// $XML_CONF:XML $ARG:Argument

	$prog = "current";
	ArgInitialize($ARG);								// Argument Table Argument Table初期化
	if (isset($ARG["p"])) {
		$prog=$ARG["p"];
		}
	$PHP_CONFIG=array("referer_new"=>"on","related_link"=>"on");
	get_config("php_config",$PHP_CONFIG);				// php config

	ArgAnalyze($Link,$ARG);
	if (isset($ARG["p"])) {
		if(strpos($ARG["p"],"extend") !== false) {
			 $prog=$Link["p"];
			 }
		}
	if($PHP_CONFIG["referer_new"] == "on") {			// Session有効以降,パラメータ付で起動時パラメータ初期
		if(($PHP_CONFIG["related_link"] == "on")&&($ARG["url"] !=="")) { }	// 関連Link on時, mpdweb.phpシリーズからのLinkは初期化しない
		else if(!isset($_SESSION["REFERER"])) {			// initパラメータ時は例外 前URLSession[REFERER"データ]がない場合、初期モード
			 ArgInitialize($ARG);						// Argument Table Argument Table初期化
			 $prog = "current";
			 }
		}
	if (isset($ARG["clear"])) {							// 引数に"clear"指定時Shared Memory Delete
		SHM_ListArtProj();
		SHM_ListArtUnlink();
		$url=str_replace('&clear',"",$_SERVER['REQUEST_URI']);
		header("Location: $url");
		}
	if ($prog=="current") {								// Session有効以降，Top指定時URLを切り替える
		header("Location:./".$MPDWEB."?p=current");
		exit;
		}
	if(strpos($prog,"extend") === false) {				// 内部で指定の機能にJump時指定時URLを切り替える
		header("Location:./".$MPDWEB."?p=".$prog);
		exit;
		}
	$ARG["p"]=$prog;
	}

/* -----------------------------------------------------------------------------
	DispListArt($field,$query,$requery,$pos,$value,$tbno) : Edit List
	$filed  : i  : List Filed
	$query  : io : 初回SelectFieldの内容
	$requery: i  : 初回選択内容 $requery["Filed"]:初回List(Field) $requery["Query"]["Filed"]初回Fieldの結果の選択内容
	$pos    : i  : Positioning "on"/"off"
	$value  : i  : Positioning 位置
	$tbno   : i  : DispAlbum TableNo Art数(Combo/XMLConfif)

	※global $LIST_FIELD:一覧表示のFiled : 各種外部Programで使用できる項目
----------------------------------------------------------------------------- */
function DispListArt($field="AlbumArtist",$query="",$requery="",$pos="",$value="",$tbno) {
	global $ARG,$REQ_UA,$XML_LISTART,$XML_UPPER,$LIST_FIELD,$XML_HTMLBUILT_EVENT,$XML_IMGThread,$XML_JSSORT;

//-- 拡張モジュールの無効判定
	global $BASENAME,$MPDWEB,$XML_DLISTARTCOMB,$XML_EXTENDFUNC;				// XML Config:$XML_DLISTARTCOMB:List Combobox
	$select="";					// $select mpd Query後決定したいが,拡張先でQueryする予想でここで仮決定する
	if (is_array($requery)) {
		$select=$requery["Query"][$field];
		}
	if ((($select=="")&&(strpos($XML_DLISTARTCOMB["ListArt_Comb"].",",$field)===false ))||(($select!=="")&&(strpos($XML_DLISTARTCOMB["ListArt_Comb"].",",$query)===false ))) {
		$RESULT="";eval($XML_EXTENDFUNC["compel"]);										// 表示fieldがなければBase:MPDWEBにReturn(他タスク操作に起因)
		if ($XML_EXTENDFUNC["continue"] !=="") {						// 拡張を継続する。他のlist/albumと同じルール。
			 $ary = explode("|",$XML_EXTENDFUNC["continue"]);		//   Format:{item}|{value}
			 if (!isset($ary[1])) { $ary[1]="off"; }
			 $post=ArgPostSession($ary[0],$ary[1],$RESULT);
			 }
		else {
			 $post=$RESULT;
			 }
		print '<script type="text/javascript">'.$post.'</script>';					//   DispListで mpd-I/F ListをGetしているので戻ったら再度 mpd-I/F ListをGetし2重になる。
		return;
		}
//-- mpd Query/ReQuery
	$select="";$fadd="";
	if (!is_array($requery)) {
		 $LIST_FIELD=$field;										// $LIST_FIELD:各種機能Programで使用できるI/Fを設定
		 if (($field=="Album")&&($XML_UPPER["List_Album"] > 0)) {
			  $output=mpd_list($field,array(),"","",$XML_UPPER["List_Album"]);	// 再Query $query:初回SelectFieldの内容,$requery:[初回List(Field)]初回Fieldのの結果の選択内容
			  }
		 else {
		 	  $output=mpd_list($field);								// 最初のQuery
			  }
		 $outkey=$field;
		 }
	else {
		 $LIST_FIELD=$requery["Filed"];							// $LIST_FIELD:各種機能Programで使用できるI/Fを設定
		 if (($requery["Filed"]=="Album")&&($XML_UPPER["List_Album"] > 0)) {
			  $output=mpd_list($requery["Filed"],$requery["Query"],"","",$XML_UPPER["List_Album"]);	// 再Query $query:初回SelectFieldの内容,$requery:[初回List(Field)]初回Fieldのの結果の選択内容
			  }
		 else {
			  $output=mpd_list($requery["Filed"],$requery["Query"]);	// 再Query $query:初回SelectFieldの内容,$requery:[初回List(Field)]初回Fieldのの結果の選択内容
			  }
		 $select=$requery["Query"][$field];						// $select:再Queryのセレクト条件(初回のList($field)を使用したSelect結果 mpd Filed内容)
		 $outkey=$requery["Filed"];								// $outkey:今回mpd Listに対するSelect Field
		 $str=ArgEncode($select);
		 $fadd=$field.":".$str;									// $fadd  :今回mpd Listに対する検索条件HTML部分
		 }
//print "<BR><BR><BR><BR><BR>------------------";		// Debug時:実行時変数をDump
//print '$field['.$field.'] $LIST_FIELD['.$LIST_FIELD.'] $query['.$query.'] $select['.$select.'] $requact['.$requact.'] $outkey['.$outkey.'] $fadd['.$fadd.']<BR>';
//if (is_array($requery)) { print_r($requery ); } else { print 'Not Array $requery'; }
	ob_end_flush();
	ob_start('mb_output_handler');

	print '<title>ListArt:'.$field.' ('.$_SERVER["HTTP_HOST"].')</title>';
	DispHeader("list",$field,"");
//-- Dispplay List
	$count="";$requact="";
	if (is_array($output)) {
		$count=count($output[$outkey])."p";
		}
	if (isset($output['warning'])) { $count="Over!"; }	// Limit Over
	DispListArtHeader($field,$query,$select,$requact,$count,$tbno);	// 画面で表示に使用したQuery($query)が復帰
	ob_end_flush();
//-- SortParameter
 	if ($select !== "") { $sortfld=$query; } else { $sortfld=$field; }											// Sort Fieldの決定
	if (($XML_JSSORT["JsSort"] !=="off")&&(strpos(",".$XML_JSSORT["List"].",",",".$sortfld.",") !== false)) {	// Sort設定でMaskか判断
		 $SRTITM=array($sortfld=>array("cell"=>"TR","css"=>".AlbmTex","divno"=>1));								// Sort Parameter(Tr用)
		 DispState($SRTITM,"idlisttbl",0,1);			// Starus & PostionBar &Item Sort
		 }
	else {
		 DispState();									// Starus & PostionBar
		 }
	DispListMake($field,$query,$select,$outkey,$fadd);
	DispListArtMake($output,$outkey);					// ArtFile Match
	$threadon=0;
	if ($XML_IMGThread["Thread"] =="on") {				// Thread表示の判定
		if ((isset($output["Art"]))&&((count($output["Art"]) > $XML_IMGThread["no"]))) {
			$threadon=1;
			}
		}
	$str="";
	if (($value!=="")&&($pos == "on")) {				// 表示後，Positionすると先頭が一瞬見えるので"display:none;"
		 $str="display:none;";							// 指定位置Positionのため最後に表示のため非表示にする
		 }
	else {
		 $str="display:block;";							// display:block;にする。スクロール域の選択サイズを行間にする。
		 }
	print '<table border="0" id="idlisttbl" cellpadding="0" bgcolor="#000000" frame=void style="table-layout:fixed;'.$str.'">';
	JsListLoadDisp($pos,$value,"idlisttbl");			// 時計マーク表示
	$tbcnt=999;
	$heightadjust=4;		// Album Artがないとき,Art部にOverleyボタンの高さ調整(微妙にずれる)
	$widthadjust=3;			// 幅がBorder分ずれるので部調整   1:474 2:471 3:468,4:465,5:462 3pxきざみ
	if ($tbno > 10) {
		$tbno=10;
		}
	$tbwidth=(475-$tbno*$widthadjust)/$tbno;			// Album Art基準は:1行(117px) 4アルバム表示 //	$tbno=4;	//	$tbwidth=117;
	$idtop=NULL;$idlast="";$disp_no=0;
	foreach($output[$outkey] as $i => $idx) {
		if ((isset($XML_LISTART["List_Space_Filed"][$outkey]))&&($XML_LISTART["List_Space_Filed"][$outkey]=="on")&&($idx=="")) { continue; }
		if ($tbcnt >= $tbno) {
			if ($tbcnt !== 999) {
				print '</tr>';
				}
			print '<tr>';								// n個置きに tr /tr
			$tbcnt=0;
			}
		$tbcnt=$tbcnt+1;
		print '<td>';
		$idscrl="idL".$i;					// Art部HTML-id  ($idscrl="idA".$i; DispListに合わせるとidA{n}になるがiListI/FのHTML-id)
		$fldid ="idA".$i;					// Text部HTML-id ($fldid ="idL".$i;)
		$func_adds="";						// FunctionBox : 追加セレクション {Filed}:{Value}形式
		if (is_null($idtop)) {				// 指定位置Position 先頭,最後のid設定
			$idtop=$idscrl;
			}
		$idlast=$idscrl;
//print '<BR>$idtop['.$idtop.'] $idlast['.$idlast.']<BR>';
		if (rtrim($value) == rtrim($output[$outkey][$i])) {
			$idpostion=$idscrl;
			}
		$func_field=$outkey;				// FunctionBox : Field
		$func_name=$output[$outkey][$i];	// FunctionBox : Name
		if  ($output[$outkey][$i] == "") {
			 $str=' ';
			 }
		else {
			 $str=$output[$outkey][$i];
			 }
		$fldvalue=ArgEncode($str);
		if (($field !== 'Album')&&($select == "")&&($query == "Content")) {			// Query:Contentは直接Find
			 $url=$findjs.'JumpURL(\'?p=find&f1=%outkey%:%fldid%&b=list'.'\',\''.$fldid.'\',\'\')';
			 }
		else if (($query !== "")&&($select == "")&&($output[$outkey][$i] == "")) { continue; }	// mpd "list"をとるためのMetaがないので取れない
		else if (($query !== "")&&($select == "")) {				// 再Queryの引数を作成
				  $url='JumpURL(\'?p=list&f=%field%&q1=%field%:%fldid%&q2=field:%query%\',\''.$fldid.'\',\'\')'; 
				  $func_field=$field;							// FunctionBox : Field
				  $func_adds=$outkey.":".$output[$outkey][$i];	// FunctionBox : 追加セレクション {Filed}:{Value}形式
			 	  }
		else if (($field == 'Album')&&($query == "")) {			// List:Album Select: - を選択
				  $url='JumpURL(\'?p=find&f1=%outkey%:%fldid%&b=list'.'\',\''.$fldid.'\',\'\')';
			 	  }
		else if (($field == 'Album')&&($query !== "")) {		// 初回List:Album Select:選択の結果に対してのリストを選択
				  $url='JumpURL(\'?p=find&f1=%field%:%select%&b=list'.'\',\'\',\''.$fldid.'\')';
				  $func_field=$field;							// FunctionBox : Field
				  $func_name=$select;							// FunctionBox : Name
			 	  }
		else if (($query == 'Album')&&($select !== "")) {		// 初回List:各種(Album以外) Select:Album 選択の結果に対してのリストを選択
				  $url='JumpURL(\'?p=find&f1=%outkey%:%fldid%&b=list'.'\',\''.$fldid.'\',\''.$fldid.'\')';
			 	  }
		else if (($select !== "")&&($requact =="Content")) {	// 初回List:各種(Album以外) Select:Album 選択の結果に対してのリストを選択
				  $backid="";
				  if ($fadd !=="") {
					 $backid=$fldid;
					 }
				  $url=$findjs.'JumpURL(\'?p=find&f1=%outkey%:%fldid%%fadd%&b=list'.'\',\''.$fldid.'\',\''.$backid.'\')';
				  }
			 else {
				  $backid="";
				  if ($fadd !=="") {
					 $backid=$fldid;
					 }
				  $url='JumpURL(\'?p=album&f1=%outkey%:%fldid%%fadd%&b=list'.'\',\''.$fldid.'\',\''.$backid.'\')';
				  if ($select !== "") {
					  $func_adds=$field.":".$select;
					  }
			 	  }
		if ($output[$outkey][$i] == "") { $str ="&nbsp;"; } else {
			 $str = ArgHTMLEncode($output[$outkey][$i]);		 // HTML簡略変換
			 }
		if (!isset($output["Art"][$i])) {
			 $str = ArgAlbumArtString($tbno,$idx,$Font,$Br);
			 if ($idx =="") { $str='<div style="color:#a9a9a9;">[no Tag]</div>'; }
			 print '<div id="'.$idscrl.'" align=center class="noImg LstNImg" style="font-size:'.$Font.'px;width:'.$tbwidth.'px;height:'.$tbwidth.'px;">';
			 print '<div class="LstNIgC">'.$Br.$str.'</div></div>';
			 print '<div onclick="'.$url.'" class=artpd style="margin:-'.($tbwidth+4).'px 0px 0px 0px;cursor:pointer;">';
			 print '<div class="music artno" style="border:0px;width:'.$tbwidth.'px;height:'.($tbwidth+$heightadjust).'px;"></div>';	// <img部分を代替え NoImageのデザイン部分
			 }
		else {
		 	 print '<div id="'.$idscrl.'" class=AlbmArt style="width:'.$tbwidth.';height:'.$tbwidth.';">';
			 print '<div onclick="'.$url.'">';
			 $clip="";
			 ArgImageSize($output["Art"][$i],$tbwidth.":fix","Album",$imgwidth,$imghigth,$clip);
			 $style="";if (!is_null($clip)) { if ($clip !== "") { $style='style="'.$clip.'"'; } }
			 $idimg="idimg".$i;								// 外部接続用に'<img'のid
			 $IDIMG_ARY[]=$idimg;
			 if($threadon ==0) {
				 print '<img id="'.$idimg.'" src="'.$output["Art"][$i].'" alt="" width="'.$imgwidth.'" height='.$imghigth.' border="0" '.$style.' />';
				 }
			else {
				 $DSP_SEQID[$idimg]["inx"]=$i;				// 出現位置
				 $DSP_SEQID[$idimg]["id"]=$idscrl;			// 対応のMain(Postion)Id
				 print '<img id="'.$idimg.'" path="'.$output["Art"][$i].'"  alt="" width="'.$imgwidth.'" height='.$imghigth.' border="0" '.$style.' />';
				 }
			 }
		print '</div></div>';								// $output["Art"][$i]あり(/div:2個)/なし(/div:1個)で合わないが合わせると、どこかおかしくなる。!!
		$text_font=DispAlbumTextFsize($tbno);
		$id='func_'.$i;
		print '<div class="AlbmFrm">';
		if ($REQ_UA =='PC') { $hdef="line-height:15px;"; } else { $hdef=""; }
		print '<p id='.$fldid.' class="ellipsis AlbmTex" style="width:'.$tbwidth.'px;'.$text_font.$hdef.'">'.$idx.'</p>';
		print '</div>';
		print '<div class="artpd AlbmBFr">';
		print '<button type=submit onclick="RequestBoxDisp(\''.$id.'\');" class="music artfn AlbmBtn" style="width:'.$tbwidth.';"></button>';
		print '</div>';
		print '<div class=artpu>';
		DispListFunc($func_field,$func_name,$func_adds,$id,$fldid,$fadd,200,100);		// List Function
		print '</div>';
		print '</td>';
		$disp_no=$disp_no+1;								// continueがあるので件数カウント
		}
	print '</table>';
	$msg="";
	if (isset($output['warning'])) {						// Limit Over
		print '<div style="position:relative;left:20px;width:360px;font-size:14px;color:#f08080;">Warning : '.(reset($output['warning'])).'</div>';
		$msg="Over!";
		}
	ob_flush();
	flush();

//print '<div style="position:fixed;top:10px;left:500px"><BR>-----------------------------------$idtop['.$idtop.'] $idlast['.$idlast.']<BR></div>';
	print <<< EOM
<script type="text/javascript">
<!--
var RecCount = "{$disp_no}p";
d=document.getElementById('idCount');
if ("{$msg}" !=="") {
	 d.innerHTML="{$msg}";
	 }
else {
	 d.innerHTML=RecCount;
	 }
// -->
</script>
EOM;
	JsListLastPosition($idtop,$idlast,50);					// 最終位置Position
	if(!isset($ARG["m"][$field])) {							// 指定位置Positionがなければ先頭
		$idpostion=$idtop;
		}
	JsListPosition($pos,$idpostion,'idlisttbl',50,-7);		// 時計マークUnload,指定位置Position	}
	if($threadon!==0) {										// Imageをスレッド単位で表示
		ArgMakeJSImage($DSP_SEQID,$pos,$idpostion,$tbno,$disp_no);
		}
	if ((isset($XML_HTMLBUILT_EVENT["List"]))&&($XML_HTMLBUILT_EVENT["List"]!=="")) { ArgJsBuiltin($XML_HTMLBUILT_EVENT["List"]); }	// HTMLBuiltin:HTML Style After Output
// 画像FileがないTagの強制サーチは1回有効
print <<< EOM
<script type="text/javascript">
RequestByPost(POST_MOD,'p=session,m1=key:ExtendListArt/Renew,m2=val:off',POST_SYSOUT,"");			// ExtendListArt/Renew:off(一回限り機能)
</script>
EOM;

	}

/* -----------------------------------------------------------------------------
	DispListArtMake($output,$outkey) : ArtFile Match
	 $output : io : Output Array
	 $outkey : i  : Select Field

	※1.ArtFile設定
	  文字置換:$XML_FILENAME["RepChar"]["a"][]=>$XML_FILENAME["RepChar"]["b"][]
	  FileName:$XML_FILENAME["FileName"][]
    ※2.$XML_ORDER: LinkText    :MetaTag:ArtFileName設定ファイル
	                LinkPath    :検索Directory下のFileNameを使用
	                ArtDirectory:指定Directory下のMetaTagをFile名として使用する。RepCharの変換を行う
----------------------------------------------------------------------------- */
function DispListArtMake(&$output,$outkey) {
	global $XML_ORDER,$XML_FiledGroup,$XML_SHMLISTART,$XML_SHMOPT,$XML_FILENAME,$TXT_ORDER;

	$TXT_ORDER=array();
	foreach($XML_ORDER["key"] as $key => $val) {														// LinkTextファイル設定を展開
		if ($val !=="LinkText") { continue; }
		if ((isset($XML_ORDER["attr"][$key]))&&($XML_ORDER["attr"][$key]!==$outkey)) { continue; }		// Fieldが異なる設定
		$homedir=dirname($XML_ORDER["val"][$key]);
		
		$fp= fopen($XML_ORDER["val"][$key],"r");
		if($fp){
			while ($line = fgets($fp)) {
				$line=rtrim($line,"\n");
				if (strpos($line,"#")===0) { continue; }		// コメント行
				$ary=explode('|',$line);
				if(!isset($ary[1])) { continue; }
				if ((dirname($ary[1])==".")||(dirname($ary[1])=="")) {
	 				$TXT_ORDER[$ary[0]]=$homedir."/".$ary[1];
					continue;
					}
				$str=str_replace("%DOCUMENT_ROOT%",$_SERVER['DOCUMENT_ROOT'],$ary[1]);		// WebRootを置換
				$str=str_replace($XML_FILENAME["Directory"],"/",$str);						// Directory文字扱いを置換
	 			$TXT_ORDER[$ary[0]]=trim(rtrim($str));
				}
			}
		}
	$time=time();$grp="";										// Shared Memory Filed Group/TimeStump設定
	if(isset($XML_FiledGroup[$outkey])) { $grp=$XML_FiledGroup[$outkey]; }
	$shmary=False;												// Shared Memoroy off時/ No Array時 False
	if ($XML_SHMLISTART["Used"] =="on") {
		SHM_ListArtProj("ListArt");								// Shared Memoroy Project 
		$shmary=SHM_ListArtGet("FiledArt");						// Shared Memoroy Get
		}
	$EXISTRENEW="";												// 画像Fileがない場合のサーチ機能(SharedMemory外を使用する機能:1回限り)
	if ((isset($_SESSION["ExtendListArt/Renew"]))&&($_SESSION["ExtendListArt/Renew"]=="on")) {	// $_SESSION["ExtendListArt/Renew"]=="on":画像Fileがない場合強制サーチ
		$EXISTRENEW="on";
		$_SESSION["ExtendListArt/Renew"]="off";
		}

	global $ARY_ARTDIR,$ARY_ARTDIR_ON;							// ファイルチェックを配列で行う
	$ARY_ARTDIR=array();$ARY_ARTDIR_ON="";						// ArtDirectoryのFile配列を作成 有効:$ARY_ARTDIR_ON="1"
	if (!is_array($shmary)) {									// Shared Memory Groupを見ない(File配列作成時Flag:1にする)
		foreach($XML_ORDER["key"] as $key => $val) {
			if ($val == "ArtDirectory") {						// ArtDirectory:File名がField
				$artpath[$XML_ORDER["val"][$key]]="";
				}
			}
		$command="";
		foreach($artpath as $key => $val) {
			$command=$command."find ".(rtrim($key,"/")."/")." -maxdepth 1 -type f -exec basename {} \\;;";
			}
		exec($command,$ARY_ARTDIR);								// Exec Command List ,Finename
		$ARY_ARTDIR=array_flip($ARY_ARTDIR);					// Key:Finename
		$ARY_ARTDIR_ON="1";
		}
//print "<BR>GET:";print_r($shmary);print "<BR>-------------------------------------------------------<BR>";
	foreach($output[$outkey] as $i => $tag) {
		if($tag=="") { continue; }
		foreach($XML_ORDER["key"] as $key => $val) {
			if ((isset($XML_ORDER["attr"][$key]))&&($XML_ORDER["attr"][$key]!==$outkey)) { continue; }		// Fieldが異なる設定
			if ((is_array($shmary))&&((isset($shmary[$tag]))&&($shmary[$tag]["grp"]==$grp))) {				// Shared Memory Get
				 if (($EXISTRENEW=="")&&($XML_SHMOPT["FileExist"] =="on")&&($shmary[$tag]["val"]=="")) {	// Fileがないとき "FileExist":on 検索OK
					 break;
					 }
				 if ($shmary[$tag]["val"] !=="") {											// Shared MemoryでHit
					 $output["Art"][$i]=$shmary[$tag]["val"];
					 $shmary[$tag]["time"]=(string)$time;
					 break;
					 }
				 }
			if($val == "LinkPath") {
				if($str=_DispListArtMake_LinkPath($tag,$XML_ORDER["val"][$key],$outkey)) {			// LinkPath : 参照Directory設定(Directory最下位がField)
					 $output["Art"][$i]=$str;
					 break;
					 }
				else {
					 continue;
					 }
				}
			if ($val == "ArtDirectory") {													// ArtDirectory:File名がField
				if($str=_DispListArtMake_ArtDirectory($tag,$XML_ORDER["val"][$key])) {
					 $output["Art"][$i]=$str;
					 break;
					 }
				else {
					 continue;
					 }
				}
			if ($val == "LinkText") {														// Link Text
				if($str=_DispListArtMake_ArtLinkText($tag)) {
					 $output["Art"][$i]=$str;
					 break;
					 }
				}
			}
		if ($XML_SHMLISTART["Used"] =="on") {
			if (isset($output["Art"][$i])) {					// File名を,Shard Memory Set
				 $shmary[$tag]["val"]=$output["Art"][$i];		// ShardMemory Set
				 $shmary[$tag]["time"]=(string)$time;
				 $shmary[$tag]["grp"]=$grp;
				 }
			else if ((!isset($output["Art"][$i]))&&($XML_SHMOPT["FileExist"] =="on")) {		// Fileがないとき "FileExist":on時,Shard Memory Set
				 $shmary[$tag]["val"]="";						// Shard Memory Set
				 $shmary[$tag]["time"]=(string)$time;
				 $shmary[$tag]["grp"]=$grp;
				 }
			}
		}
	if ($XML_SHMLISTART["Used"] =="on") {
		$ret=SHM_ListArtPut($shmary);							// Shared Memory Put
// print '$ret['.$ret."]<BR>";
		}
	}

/*
	_DispListArtMake_LinkPath($tag,$path,$outkey) : ArtFile Match LinkPath
	 $tag    : i  : Output Array Tag
	 $path   : i  : Search Directory
	 $outkey : i  : Select Field
	 @return : o  : ArtFilePath / invalid:False

	※1.ArtFile設定
	  文字置換:$XML_FILENAME["RepChar"]["a"][]=>$XML_FILENAME["RepChar"]["b"][]
	  WebRoot :$XML_FILENAME["WebRoot"]
*/
function _DispListArtMake_LinkPath($tag,$path,$outkey) {
	global $XML_FILENAME;

	$result=False;
	$tag=str_replace($XML_FILENAME["RepChar"]["a"],$XML_FILENAME["RepChar"]["b"],$tag);

	foreach($XML_FILENAME["FileName"] as $val) {
		if (strpos($val,'%'.$outkey.'%') !==false) {
			 $val=str_replace('%'.$outkey.'%',$tag,$val);
			 }
		$str=$path."/".$tag."/".$val;
		if (file_exists($str)) {
			$str=str_replace($XML_FILENAME["WebRoot"],"",$str);
			$result=$str;
			break;
			}
		}
	return($result);
	}

/*
	_DispListArtMake_ArtDirectory($tag,$path) : ArtFile Match LinkPath
	 $tag    : i  : Output Array Tag
	 $path   : i  : ArtHomeDirectory
	 @return : o  : ArtFilePath / invalid:False

	※1.ArtFile設定
	  文字置換:$XML_FILENAME["RepChar"]["a"][]=>$XML_FILENAME["RepChar"]["b"][]
	  FileName:$XML_FILENAME["FileName"][]
	  WebRoot :$XML_FILENAME["WebRoot"]
*/
function _DispListArtMake_ArtDirectory($tag,$path) {
	global $XML_FILENAME,$ARY_ARTDIR,$ARY_ARTDIR_ON;

	$result=False;
	$tag=str_replace($XML_FILENAME["RepChar"]["a"],$XML_FILENAME["RepChar"]["b"],$tag);
	foreach($XML_FILENAME["Extend"] as $val) {
		if($ARY_ARTDIR_ON=="1") {
			if (isset($ARY_ARTDIR[$tag.".".$val])) {
				$str=$path."/".$tag.".".$val;
				$str=str_replace($XML_FILENAME["WebRoot"],"",$str);
				$result=$str;
				break;
				}
			 }
		else {
			$str=$path."/".$tag.".".$val;
			if (file_exists($str)) {
				$str=str_replace($XML_FILENAME["WebRoot"],"",$str);
				$result=$str;
				break;
				}
			}
		}
	return($result);
	}

/*
	_DispListArtMake_ArtLinkText($tag) : ArtFile Text Match Setting
	 $tag    : i  : Output Array Tag
	 @return : o  : ArtFilePath / invalid:False
	※Text File : Tag/ArtFile変換設定
	 $TXT_ORDER[{tag}]:FileName
*/
function _DispListArtMake_ArtLinkText($tag) {
	global $XML_FILENAME,$TXT_ORDER;

	$result=False;
	if(isset($TXT_ORDER[$tag])) {
		if (file_exists($TXT_ORDER[$tag])) {
			$str=str_replace($XML_FILENAME["WebRoot"],"",$TXT_ORDER[$tag]);
			$result=$str;
			}
		}
	return($result);
	}

/* -----------------------------------------------------------------------------
	DispListArtHeader($field,$query,$select,$requact,$count,$tbno) : List Art Header
	 $filed  : i  : List Filed
	 $query  : io : 初回SelectFieldの内容/復帰時,SelectFieldの選択内容
	 $select : i  : 再Queryのセレクト条件(初回のList($field)を使用したSelect結果)
	 $requact: io : 再QueryAction
	 $count  : i  : Select Count
	 $tbno  : i  : DispListArt TableNo Art数(Combo/XMLConfif)
----------------------------------------------------------------------------- */
function DispListArtHeader($field,&$query,$select,&$requact,$count="",$tbno) {
	global $BASENAME,$MPDWEB,$XML_DLISTARTCOMB,$XML_EXTENDFUNC;				// XML Config:$XML_DLISTARTCOMB:List Combobox

//-- 拡張モジュールの判定しLayout調整
	$ext_width=0;$ext_sp='&nbsp;&nbsp';$ext_widthcnt=0;$ext_nosel=0;$ext_sel=0;		// Extend Function Button有効用の調整値
	if ($XML_EXTENDFUNC["Func"] !=="") {
		$ext_width=50;$ext_sp='&nbsp;';$ext_widthcnt=3;$ext_nosel=26;$ext_sel=50;
		}
//-- Header Function
	$Listquery = explode(",",$XML_DLISTARTCOMB["List_Comb"]);				// Listの選択項目 $Listquery=array("Artist","AlbumArtist","Date","Genre","Album");
	if ($select == "") {
		 $str=$field;
		 }
	else {
		 $str=$field." : ".$select;
		 }
	print '<div class=head style="top:24;height:25px;z-index:3;">';
	if ($select !== "") {													// 再Query時の戻りボタン
		 $FILEDSELECT=ArgEncode($select);										
		 if(in_array($field,$Listquery)) {									// 1次Queryに戻ったとき表示fieldがあれば継続
			  $RESULT=$_SERVER['PHP_SELF']."?p=extend|list&f=".$field."&m=".$field.":".$FILEDSELECT;
			  }
		 else {																// 1次Queryに戻ったとき表示fieldがないのでBase:MPDWEBにReturn
			  $RESULT="";eval($XML_EXTENDFUNC["return"]);
			  }
		 print '<button type=submit value=Back onclick="RequestLoadDisp();location.href=\''.$RESULT.'\'" class="LstHead buttn" style="width:60;background-color:#349961;color:#CED8F6;margin:0px 3px 0px 0px;">List</button>';
		 if ($XML_EXTENDFUNC["Func"] !=="") {						// 拡張Function(Button)
			eval($XML_EXTENDFUNC["event"]);
			if ($XML_EXTENDFUNC["continue"] !=="") {						// 拡張を継続する。他のlist/albumと同じルール。
				 $ary = explode("|",$XML_EXTENDFUNC["continue"]);			//   Format:{item}|{value}
				 $post=ArgPostSession($ary[0],"list",$RESULT);				//   List/AlbumBottunクリック時はListに戻す
				 }
			else {
				 $post=$RESULT;
				 }
			print '<button type=submit onclick="this.blur();'.$post.'" class="LstHead buttn" style="width:'.$ext_width.'px;margin:0px 3px 0px 3px;'.$XML_EXTENDFUNC["color"].'">'.$XML_EXTENDFUNC["Func"].'</button>';
			}
		 print '<div class=LstHead style="text-overflow:ellipsis;line-height:150%;width:84px;height:18px;background-color:#333333;color:#DDDDD;border:#808080 solid 0.5px;margin:1px 0px 0px 2px;">&nbsp;'.$query.'</div>';
		 $width=216-$ext_sel;
		 }
	else {
		 print '<button type=submit onclick="this.blur();" class="LstHead buttn" style="width:60;background-color:#008000;color:#CED8F6;margin:0px 3px 0px 0px;">List</button>';
		 $width=109-$ext_nosel;
		 if ($XML_EXTENDFUNC["Func"] !=="") {						// 拡張Function(Button)
			$RESULT="";eval($XML_EXTENDFUNC["event"]);
			if ($XML_EXTENDFUNC["continue"]!=="") {							// 拡張を継続する。他のlist/albumと同じルール。
				 $ary = explode("|",$XML_EXTENDFUNC["continue"]);			//   Format:{item}|{value}
				 $post=ArgPostSession($ary[0],"list",$RESULT);				//   List/AlbumBottunクリック時はListに戻す
				 }
			else {
				 $post=$RESULT;
				 }
			print '<button type=submit onclick="this.blur();'.$post.';" class="LstHead buttn" style="width:'.$ext_width.'px;margin:0px 3px 0px 3px;'.$XML_EXTENDFUNC["color"].'">'.$XML_EXTENDFUNC["Func"].'</button>';
			}
		 }
	print '<div class=LstHead style="text-overflow:ellipsis;line-height:150%;width:'.$width.'px;height:18px;background-color:#333333;color:#DDDDD;border:#808080 solid 0.5px;margin:1px 0px 0px 3px;">'.$ext_sp.$str.'</div>';
	if(strpos($count,'Over') !== false){ $color="#b22222"; } else { $color="#333333"; }
	print '<div id=idCount class=LstHead style="text-align:center;line-height:140%;width:'.(54-$ext_widthcnt).'px;height:18px;background-color:'.$color.';color:#c0c0c0;margin:2px 0px 0px 3px;">'.$count.'</div>';
	$id="funclistArt";
	DispListArtHeaderFunc($field,$query,$select,$requact,$id,$tbno,54,174);

	if ($select == "") {													// 再Query時の戻りボタン
		print '<div class=LstHead style="width:24px;margin-right:auto;color:#c0c0c0;margin:3px 3px 0px 5px;">List</div>';
		$jssel = <<< EOM
	if (document.getElementById('idListSel').style.backgroundColor =='') { document.getElementById('idListHidon').style.display='none'; }
	else { document.getElementById('idListHidon').style.display='block'; }
EOM;
		$jssel=str_replace(array("\n","\t"),"",$jssel);
		foreach($Listquery as $key => $val) {
			if ($val==$field) {
				$defstr=$val;
				}
			$selary["Text"][]=$val;
			}
		$selary["style"]["position"]="position:absolute;";
		$onclick["Click"]=$jssel;
		MakeSelectBox("get",$selary,$defstr,"idf",1,(262+$ext_nosel),(130-$ext_nosel),"","idListSel",$onclick,"");
		$tmp = explode(",",$XML_DLISTARTCOMB["ListArt_Comb"]);					// ListArt_Comb:対象となるFiled
		$str='const FiledAry=[\''.implode('\',\'',$tmp).'\'];';					// ListArt_CombにないFiledを選択の場合OrignalにJump
		$orginal=str_replace($BASENAME,$MPDWEB,$_SERVER['PHP_SELF']).'?p=list';
		$str=$str.'var reslut=FiledAry.indexOf(document.getElementById(\'idf\').value);if(reslut < 0) { callback=function () { location.href = \''.$orginal.'\'; } } else { callback=function () { location.href = \''.$_SERVER['PHP_SELF'].'?p=extend|list\'; } };';
		print '<button type=submit name=p id=idListSel value="extend|list" class="comnd LstSele" onclick="'.$str.'XMLHttpRequestByPost(POST_MOD,\'p=session&m1=key:List&m2=val:\'+document.getElementById(\'idf\').value,POST_SYSOUT,POST_ERRCHAR,callback,\'\',\'\');RequestLoadDisp();" style="position:absolute;top:1.4px;left:392px;width:35px;height:19px;margin:0px 5px 0px 0px;">Select</button>';
		}
	$idh="idHistory";
	$post=DispHistoryBoxMake($idh,"List History","List",$field,40,64,410);								// History Function Box
	print '<button type=submit name=history value=history onclick="RequestBoxDisp(\''.$idh.'\');'.$post.';this.blur();" class="comnd hfunc">h</button>';	// History Button
	print '<button type=submit name=filecmd value=filecmd onclick="RequestBoxDisp(\''.$id.'\');this.blur();" class="comnd afunc">...</button>';
	print '</div>';
	print '<div style="clear:both;width:150px;height:25;"></div>';
	}

/* -----------------------------------------------------------------------------
	DispListArtHeader($field,$query,$select,$requery,$id,$top,$left): DispListHeader Function Display
	 $filed  : i  : List Filed
	 $query  : io : 初回SelectFieldの内容/復帰時,SelectFieldの選択内容
	 $requery: io : 再QueryAction
	 $select : i  : 再QueryAction (Album,Content)
	 $id     : i  : buttonのid名
	 $top    : i  : 表示位置 top
	 $left   : i  : 表示位置 left
----------------------------------------------------------------------------- */
function DispListArtHeaderFunc($field,&$query,$select,&$requact,$id,$tbno=NULL,$top=200,$left=170) {
	global $ARG,$XML_SHMLISTART,$XML_SHMOPT,$XML_FILENAME,$MY_LISTARTVERSION;

	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	if ($XML_SHMLISTART["Used"] =="on") {
		$high_on=50;
		}
	print '<div id='.$id.' class=box style="position:fixed;top:'.$top.'px;left:'.$left.';height:'.(290+$high_on).'px;">';
	print '<div class=boxtitle>'.$field.'</div>';
	$id="idListPosition";
	$post=JsDispPosition("ExtendListArt/Position/".$field,$id,$val,$field);
	print '<input type=button onclick="'.$post.$unload.'" value="'.$val.'" id='.$id.' class="boxline boxblin1">';

	if (!is_null($tbno)) {
		if (is_numeric($tbno)) {
			 print DispListArtHeaderFuncTbno($tbno);
			 }
		else {
			 print $tbno;
			 }
		}
	$req_uri=str_replace("&m=","&&m=",$_SERVER["REQUEST_URI"]);				// Shared Memory Clearのとき&=m{Postion}を削除する
	$req_uri=preg_replace('/&m=(.*?)&/', '',$req_uri.'&');					//   DispListArtで初期表示する
	$req_uri=rtrim($req_uri,'&'); 
	if (($XML_SHMLISTART["Used"] =="on")&&($XML_SHMOPT["FileExist"] =="on")) {				// Shared Memory:on ,FileExistがないときも Shared Memory使用 Function
		$New_uri = preg_replace('/(&cnt=)[0-9]{1,2}/','',$req_uri);
		$New_uri=$New_uri."&".(ArgURLCounter());
		$post="RequestLoadDisp();RequestByPost(POST_MOD,'p=session,m1=key:ExtendListArt/Renew,m2=val:on',POST_SYSOUT,function () { location.href='".$New_uri."' });";
		print '<button type=submit onClick="'.$post.'" class=boxline style="position:absolute;top:129px;left:0px;">No File Exists , Cash Renew</button>';
		}
	if ($XML_SHMLISTART["Used"] =="on") {													// Shared Memory:on Function
		 if (isset($ARG["clear"])) { $str=""; } else { $str="&clear"; }
		 $clearurl='RequestLoadDisp();location.href=\''.$req_uri.$str.'\'';	// Shared Memory Clear	Used : Shared Memory
		 print '<button type=submit onClick="'.$clearurl.'" class=boxline style="position:absolute;top:176px;left:0px;">Cash Clear (Shared Memory:ListArt)</button>';
		 }

	$mod=str_replace(".php","",$_SERVER["PHP_SELF"]).'.setting.php';		// 設定Module
	$url='RequestLoadDisp();location.href=\''.$mod.'\'';
	print '<button type=submit onClick="'.$url.'" class=boxline style="position:absolute;top:'.(170+$high_on).'px;left:0px;background-color:#08084d;border: 1px solid #acacac;">List Art Setting (XML)</button>';

	$idinfo="idinfo";
	print '<button type=submit onClick="RequestBoxDisp(\''.$idinfo.'\');'.$unload.'" class=boxline style="position:absolute;top:'.(210+$high_on).'px;left:0px; letter-spacing: 0.08em;">Information</button>';

	print '<div class="boxtext SrhBoxS" style="bottom:29px;color:#add8e6;">'.$MY_LISTARTVERSION.'</div>';
	print '<input type="button" name="Submit" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" style="top:'.(260+$high_on).'px;" />';
	print '<div class="SrhBoxL" style="position:absolute;bottom:10px;left:4px">'."(C)2023 by Mikio Shiratori".'</div>';
	print '</div>';
	ob_flush();
	flush();
	print <<< EOM
<style>
.h3 { line-height: 0.7;font-size:13px; }
.p1 { line-height: 0.5; }
.cf1 { height:20px;border:1px solid #333333;background-color:#dcdcdc; }
.cf2 { height:20px;border:1px solid #333333;background-color:#7fffd4; }
.cf3 { height:20px;border:1px solid #333333;background-color:#87cefa; }
.cf4 { height:20px;border:1px solid #333333;background-color:#ffc0cb; }
</style>
<div id="{$idinfo}" class="box" style="position:fixed;top:48px;left:20px;width:440px;height:330px;background-color:#ffffff;">
<div class="boxtitle" style="width:420px;line-height:80%;">How ListArt works</div>
<div style="position:absolute;top:20px;left:10px;color:#000000;font-size:13px;">
<h3 class="h3">Function:ListArt Setting</h3>
<p class="p1">./{mpdweb}/{$XML_FILENAME["XML_LISTART_Order"]}</p>
<p class="p1">[Pattern.1]</p>
<p class="p1"><span class="cf1">{WebRoot}/{MusicDirectory}</span><span>/</span><span class="cf2">{metaTag}</span><span>/</span><span class="cf3">Folder.jpg<span></p>
<p class="p1"><span class="cf1">{WebRoot}/{MusicDirectory}</span><span>/</span><span class="cf2">{metaTag}</span><span>/{Album}/{MusicFile}<span></p>
<p class="p1"><span class="cf1" style="padding: 0% 10px;"></span><span>:LinkPath</span></p>
<p class="p1">[Pattern.2]</p>
<p class="p1"><span class="cf1">{WebRoot}</span>/<span class="cf4">{Directory}</span><span>/</span><span  class="cf3">{metaTag}.jpg</span></p>
<p class="p1"><span  class="cf1" style="padding: 0% 10px;"></span><span>:ArtDirectory</span></p>
<p class="p1">*cf.</p>
<p class="p1"><span  class="cf2">{metaTag}</span><span>:MusicFile metaTag,Artist,AlbumArtist...etc.</span></p>
<p class="p1"><span class="cf1">{WebRoot}</span><span>:%DOCUMENT_ROOT%</span></p>
<p class="p1"><span class="cf4">{Directory}</span><span>:Default:'ListArt'&nbsp;Changeable</span></p>
<p class="p1"><span class="cf3">{?????}.jpg</span><span>:Picture File</span></p>
</div>
<button onClick="RequestBoxtUnLoad('{$idinfo}');" class="buttn boxbcan" style="top:300px;background-color:#dcdcdc;border:1px solid #333333;">Cancell</button>
</div>
EOM;
	}

/* -----------------------------------------------------------------------------
	DispListArtHeaderFuncTbno($tbno): DispAlbum Function Display TableNo (Art数)
	 $tbno  : i  : DispListArt TableNo Art数(Combo/XMLConfif)
----------------------------------------------------------------------------- */
function DispListArtHeaderFuncTbno($tbno) {
	print '<div class="boxline boxblin3" style="width:278px;height:18px;cursor:auto;">Art No';
	for($i = 1;$i < 11 ;$i++) { $select["Text"][]=$i; }
	$defstr=$tbno;
	$select["style"]["position"]="position:absolute;";
	$style="background-color:#d3d3d3;color:#3d3d3d;font-size:15px;";
	MakeSelectBox("get",$select,$defstr,"idtbno",1.5,160,80,"","idListArtNoSel","",$style);
	$New_uri = preg_replace('/(&cnt=)[0-9]{1,2}/','',$_SERVER["REQUEST_URI"]);
	$New_uri=$New_uri."&".(ArgURLCounter());
	$post ="RequestByPost(POST_MOD,'p=session,m1=key:ExtendListArt/TbNo,m2=val:'+document.getElementById('idtbno').value,POST_SYSOUT,function () { location.href='".$New_uri."' }); ";
	print '<form action="javascript:RequestLoadDisp(0)">';			// 処理中マーク
	print '<button type=submit name="TbnoSubmit" id=idListArtNoSel onclick="'.$post.'" value="Submit" style="position:absolute;top:2px;left:242px;border-style:none;width:56px;height:20px;cursor:pointer;">Submit</button>';
	print '</form>';
	print '</div>';
	}

/* ----- Shared Memory Extend Library- -------------------------------------------
	Shared Memory Extend Library : 
	SHM_ListArtInit($pjname="",$compel="") : Get Projcst
	 $pjname : i  : All:""  or ProjctName:Projct Delete
	 $compel : i  : "":通常モード "del":強制削除
	※ $XML_SHM[$share] ["Proj"]:Project,["Size"]:Size,["Life"]:Life Sec
	   mpdweb.lib_mpdshm.phpと構成を同じにしておく。但し,Commonを削除しない。
	Linux上で確認は $ ipcs -m
-------------------------------------------------------------------------------*/
function SHM_ListArtProj($pjname="",$compel="") {
	global $XML_SHMLISTART,$XML_SHMEXTEND,$XML_SHM;

	if ((!isset($XML_SHMEXTEND)) || (!is_array($XML_SHMEXTEND))) {	// $XML_SHMEXTEND(設定配列)があれば再度行わない
		$XML_SHMEXTEND["Source"]=array("Common"=>"0,,128,43200,gzcompress,gzuncompress,9","ListArt"=>"5,,20000,43200,gzcompress,gzuncompress,9");
		$keep=$XML_SHMEXTEND["Source"];
		foreach($keep as $key => $val) {							// 省略時の初期値のためKeep
			$part=explode(",",$val);
			$keep[$key]=$part;
			}
		foreach($XML_SHMEXTEND["Source"] as $key => $val) {
			if (isset($XML_SHMLISTART[$key])) {
				$XML_SHMEXTEND["Source"][$key]=$XML_SHMLISTART[$key];
				}
			}
		foreach($XML_SHMEXTEND["Source"] as $key => $val) {
			if ($val=='') { unset($XML_SHMEXTEND[$key]);continue; }	// <Shm_Project><Art></Art>の設定は使用しない扱い
			$pshm=explode(",",$val);
			$XML_SHMEXTEND[$key]["Proj"]=trim($pshm[0]);			// Key:Project Name :Project Code
			$XML_SHMEXTEND[$key]["Size"]=0;							// Project Size
			$XML_SHMEXTEND[$key]["Life"]="";							// Life Sec "":永続
			$XML_SHMEXTEND[$key]["Enc"]=$keep[$key][4];				// 省略時の初期値 Encoder
			$XML_SHMEXTEND[$key]["Dec"]=$keep[$key][5];				// 省略時の初期値 DEcorder
			$XML_SHMEXTEND[$key]["Comp"]=$keep[$key][6];				// 省略時の初期値 Compress
			if (isset($pshm[1])) { $XML_SHMEXTEND[$key]["Path"]=$pshm[1]; }
			if($compel != "del") {
				if (isset($pshm[2])) { $XML_SHMEXTEND[$key]["Size"]=$pshm[2]; }
				}
			if (isset($pshm[3])) { $XML_SHMEXTEND[$key]["Life"]=$pshm[3]; }
			if (isset($pshm[4])) { $XML_SHMEXTEND[$key]["Enc"] =$pshm[4]; }
			if (isset($pshm[5])) { $XML_SHMEXTEND[$key]["Dec"] =$pshm[5]; }
			if (isset($pshm[6])) { $XML_SHMEXTEND[$key]["Comp"]=$pshm[6]; }
			if (!function_exists($XML_SHMEXTEND[$key]["Enc"])) { $XML_SHMEXTEND[$key]["Enc"]="";$XML_SHMEXTEND[$key]["Dec"]=""; }	// Encodeモジュールなし
			if (!function_exists($XML_SHMEXTEND[$key]["Dec"])) { $XML_SHMEXTEND[$key]["Enc"]="";$XML_SHMEXTEND[$key]["Dec"]=""; }	// Decodeモジュールなし
			if (($XML_SHMEXTEND[$key]["Size"]==0)&&($XML_SHMEXTEND[$key]["Proj"]!=="")) {	// <{ProjectName}>{Project}</{ProjectName}>形式 (例) <List>1</List>)
				$id = new Shm_Common($XML_SHMEXTEND[$key]["Proj"]);							//   Shared Memory Delete (リークしないように削除方法を組み込んでおく)
				if ((isset($XML_SHMEXTEND[$key]["Path"]))&&($XML_SHMEXTEND[$key]["Path"] !== "")) {
					$id->shm_const['path']=$XML_SHMEXTEND[$key]["Path"];
					}
				$id->shm_open();
				if($key !== "Common") {
					$id->shm_delete();								// Size 0byte指定時は初期時点でShared Memoryを作らない。(途中で設定を変えた場合)
					}
				$id->shm_close();
				unset($XML_SHMEXTEND[$key]);
				}
			}
		$XML_SHM=$XML_SHMEXTEND;			// mpdweb.lib_mpdshm.phpと構成を合わせる(現在下階層のLibraryを使用しているので効果はない)。
		}
//SHM_ListArtUnlink();			// 強制的にSharedMemoryを削除
//print '<BR><BR><BR><BR><BR><BR>$XML_SHMEXTEND '.$pjname."<BR>";
//TblDump('$XML_SHMEXTEND',$XML_SHMEXTEND);
	}

/* -------------------------------------------------------------------------------
	SHM_ListArtGet($key,$count,$flags,$mode) : Used Command Shared Memory ListArt Get
	 $key    : i  : Shared Memory ,Used User Application Key
	 $count  : i  : The number of bytes to read 
	 $flags  : i  : "a":ReadOnly / "c":Creat / "w":Read/Write / "n":新規メモリセグメントの作成用
	 $mode   : i  : Permission
	 @return : o  : Mpd Output Array , or False on failure.
	※ Shared Memory : |delim|filedArt|array|{str array}...|Eof|
------------------------------------------------------------------------------- */
function SHM_ListArtGet($key="FiledArt",$count=NULL,$flags="c",$mode=0644) {
	global $XML_SHMEXTEND;

	$ret=False;$time=0;
	$SHMIDLART = new Shm_Common($XML_SHMEXTEND["ListArt"]["Proj"],$XML_SHMEXTEND["ListArt"]["Size"]);	// Open 識別子を$SHMID[$pjname]に格納
	if ((isset($XML_SHMEXTEND["ListArt"]["Path"]))&&($XML_SHMEXTEND["ListArt"]["Path"] !== "")) {
		$SHMIDLART->shm_const['path']=$XML_SHMEXTEND["ListArt"]["Path"];
		}
	if (($SHMIDLART->shm_open($flags,$mode)) === False) {
		 $SHMIDLART=False;
		 return(False);
		 }
	$buff = $SHMIDLART->shm_read(NULL,0);
	$SHMIDLART->shm_close();
//print "Get[".$buff."]<BR>";
	$array="";
	$bufb=explode('|Eof|',$buff);	
	$buf=explode('|delim|',$bufb[0]);	
	foreach($buf as $bu) {
		$spre=explode('|array|', $bu);	// Key部と分離
		if ($spre[0]==$key) {			// 対象Array
			if (isset($spre[1])) {
				$gzip=$spre[1];
				if ($XML_SHMEXTEND["ListArt"]["Dec"] !== "") {
					$dec_func=$XML_SHMEXTEND["ListArt"]["Dec"];	// Decoder Module
					$dec_arg[]=$gzip;
					$json=@call_user_func_array($dec_func,$dec_arg);	// 関数にすると結果がとれない(深いところでMemoryが取れない?)
					if ($json===false) { return(false); }
						 }
					else {
						 $json=$gzip;									// Encoder/Decoder Moduleがないとき
						 }
				if ($json===false) { return(false); }
				$array = json_decode($json,true);
				$ret=$array;
				}
			}
		if ($spre[0]=="Time") {			// Make Time
			$time=$spre[1];
			}
		}
	$now=(string)time();												// 有効時間以上は,SharedMemory Unlink
	$def=$now - $time;
	if ($def > $XML_SHMEXTEND["ListArt"]["Life"]) {
		SHM_ListArtUnlink();
		$ret=False;
		}
	return($ret);
	}

/* -------------------------------------------------------------------------------
	SHM_ListArtPut($array,$flags,$mode) : Used Command Shared Memory ListArt Put
	 $Array  : i  : Shared Memory Output Array
	 $flags  : i  : "a":ReadOnly / "c":Creat / "w":Read/Write / "n":新規メモリセグメントの作成用
	 $mode   : i  : Permission
	 @return : o  : The size of the written data, or FALSE on failure.
	※ Shared Memory : |delim|{filedArt|array|{str array}...|Eof|
	  CommandはMemoryサイズが大きくなるか、汎用的またmpdのI/F重視し受信内容をそのまま配列化しておく
------------------------------------------------------------------------------- */
function SHM_ListArtPut(&$array,$flags="c",$mode=0644) {
	global $XML_SHMEXTEND;

	if((!is_array($array))||(count($array)==0)) {			// 書き込み内容がないときSharedMemory削除
		SHM_ListArtUnlink();
		return(False);
		}
	$SHMIDLART = new Shm_Common($XML_SHMEXTEND["ListArt"]["Proj"],$XML_SHMEXTEND["ListArt"]["Size"]);	// Open 識別子を$SHMID[$pjname]に格納
	if ((isset($XML_SHMEXTEND["ListArt"]["Path"]))&&($XML_SHMEXTEND["ListArt"]["Path"] !== "")) {
		$SHMIDLART->shm_const['path']=$XML_SHMEXTEND["ListArt"]["Path"];
		}
	if (($SHMIDLART->shm_open($flags,$mode)) === False) {
		 $SHMIDLART=False;
		 return(False);
		 }
	$gzip=_SHM_ListArtCompress($array);
	if(strlen($gzip) > (int)$XML_SHMEXTEND["ListArt"]["Size"]) {
		$Reduct=strlen($gzip) - (int)$XML_SHMEXTEND["ListArt"]["Size"];
		$tmpary=_SHM_ListArtReduct($array,$Reduct);
		$gzip=_SHM_ListArtCompress($tmpary);
		}
	$time=(string)time();
	$buf="|delim|FiledArt|array|".$gzip."|delim|Time|array|".$time."|Eof|";
//print "Put".$buf."<BR>";
	$ret=$SHMIDLART->shm_write($buf,0);						// Shared Memory Write
	$SHMIDLART->shm_close();
//print '$ret['.$ret."]<BR>";
	return($ret);
	}

/*
	_SHM_ListArtCompress($array) : Shared Memory Compress
	 $Array  : i  : Shared Memory Output Array
	 @return : o  : Shared Memory Compress
	設定ファイルの指定($XML_SHMEXTEND["Enc"]/["Comp"])で圧縮する
*/
function _SHM_ListArtCompress($array) {
	global $XML_SHMEXTEND;

	$json = json_encode($array);
	if ($XML_SHMEXTEND["ListArt"]["Enc"] !== "") {
		 $enc_func  =$XML_SHMEXTEND["ListArt"]["Enc"];		// Encoder Module
		 $enc_arg[0]=$json;
		 $enc_arg[1]=$XML_SHMEXTEND["ListArt"]["Comp"];		// Compress度
		 $gzip=@call_user_func_array($enc_func,$enc_arg);
		 }
	else {
		 $gzip=$json;										// Encoder/Decoder Moduleがないとき
		 }
	return($gzip);
	}

/*
	_SHM_ListArtReduct($array,$Reduct) : Shared Memory Reduction
	 $Array  : i  : Shared Memory Output Array
	 $Reduct : i  : Size of Reduction
	 @return : o  : Shared Memory Reduction
	※Shared Memory 設定サイズを超えたときの削除
	  再圧縮時レスポンスが低下する。DirectoryPath長，Tag長にもよるが
	  720Artis/Path長40Byteで約14Kなのでデフォルト2M(2000K)Byte確保で不足時Tag整理をした方が良い
*/
function _SHM_ListArtReduct($array,$Reduct) {
	$resary=array_column_extend($array,"","time","val","-%04d");
	ksort($resary);
	$str="";$cnt=0;
	$rsize=$Reduct/1.6;										// 1.6倍圧縮率として(正確の必要性より)
	foreach($resary as $idx =>$ary) {
		$str=$str.(json_encode($ary));
		unset($resary[$idx]);
		$cnt=$cnt+1;
		if (strlen($str) > $Reduct) {
//			print "Unlink(".$cnt.")strlen(".strlen($str).")<BR>";
			break;
			}
		}
//	TblDump('$resary',$resary,"");
	return($resary);
	}

/* -------------------------------------------------------------------------------
	SHM_ListArtUnlink() : Used Command Shared Memory ListArt Unlink
------------------------------------------------------------------------------- */
function SHM_ListArtUnlink() {
	global $XML_SHMEXTEND;

	$id = new Shm_Common($XML_SHMEXTEND["ListArt"]["Proj"]);
	if ((isset($XML_SHMEXTEND["ListArt"]["Path"]))&&($XML_SHMEXTEND["ListArt"]["Path"] !== "")) {
		$id->shm_const['path']=$XML_SHMEXTEND["ListArt"]["Path"];
		}
	$id->shm_open();
	$id->shm_delete();
	$id->shm_close();
	}

//----- Source End --------------------------------------------------------------
?>
</body
</html>
