<?php
/***************************************************************************************
	mpdweb.playlist.php : mpdweb 拡張 PLS Playlist
	    http:{Host}/mpdweb/mpdweb.playlist.php?p=extend|playlist

	moOdeAudioのPLSを参考にPLS形式/Imageの関連をどう仕様にしている。
	PLS plsPlaylist採用について：プレイリストを介してラジオストリームを再生するメディアプレーヤーはあるので作成に至った。

	Module  : Make HTML/PostModule/Cooperation,Function を含む構成
	          SESSIONはmpodweb同様,mpodweb.phpの関数を使用している
	ArtImage: PLS FileNameと同様なFileName.{画像拡張子}
	         例)
	          /var/lib/mpd/music/RADIO/NHK-FM.pls             NHK-FM.
	          /var/local/www/imagesw/radio-logos/NHK-FM.jpg   NHK-FM.{画像拡張子}
	          Pathは設定できる。画像拡張子も設定できる。

	PLSPlaylist形式(.pls)
	    Tag:"File","Title","Length","NumberOfEntries","Version","Favorite"
	        "File","Title","Length"は1ファイル複数可
	    mpdweb拡張PLSPlaylist形式では"Favorite"を追加した。:お気に入りにより再生するサイトを選択を容易にする。
	    "File"Tagは位置を特定するため、1ファイル中に同じ名前を複数定義しないこと。
	ファイル例) NHK-FM.pls
	     [playlist]
	      File1=https://radio-stream.nhk.jp/hls/live/2023507-b/nhkradiruakfm/master48k.m3u8
	      Title1=NHK-FM
	      Length1=-1
	      File2=https://radio-stream.nhk.jp/hls/live/2023507/nhkradiruakfm/master.m3u8
	      Title2=NHK-FM-Station
	      Length2=-1
	      NumberOfEntries1=1
	      Version1=2
	      Favorite={拡張} : お気に入りを拡張
	 $_SESSION定義:
	   "ExtendPlaylist/list":list|album
	設定により,mpdweb:TaskServerでNetworkに対応する。
	再生デバイスと別に設定可能/画像/pls/mpdを分けて設定できる。
	外部からの連結用関数
	  pls_ArtURL($url,$base) : URLから対象のPLS Fileに対応するImageを取得

	※Playlistの拡張モジュール:mpdでサポートがない.plsを扱うため独立して動く
	  JSSortモジュールなどはモジュール内で定義。
	  (mpdweb.list.phpは一体で動作するため本体の条件で動作)
     呼ぶ出し側から不要にrequireしないためのモジュールとRequestの関係
	  mpdweb.php(mpdweb.lib.php)から実行時:[SCRIPT_NAME] => /mpdweb/mpdweb.php          [REQUEST_URI] => /mpdweb/mpdweb.php?p={Prog}
	  mpdweb.php.list.php から実行時      :[SCRIPT_NAME] => /mpdweb/mpdweb.list.php     [REQUEST_URI] => /mpdweb/mpdweb.list.php?p=extend|list
      mpdweb.playlist.php Calling URL     :[SCRIPT_NAME] => /mpdweb/mpdweb.playlist.php [REQUEST_URI] => /mpdweb/mpdweb.playlist.php?p=extend|playlist 
      mpdweb.playlist.php Calling Post    :[SCRIPT_NAME] => /mpdweb/mpdweb.playlist.php [REQUEST_URI] => /mpdweb/mpdweb.playlist.php?p=extend|playlist 
	  [DOCUMENT_URI]==[SCRIPT_NAME]:$_SERVER['REQUEST_URI')互換性の高いコードに
	  [REQUEST_URI]:BrowserからのCallingURL
/************************************************************************************* */
$PLS_BASENAME=basename(__FILE__);							// テスト時basenameを一連モジュール合わせて実行可能にしておく
$ary=explode(".",$PLS_BASENAME);
$ORIGIN=$ary[0];										// OriginName:"mpdweb"
$MPDWEB=$ORIGIN.".php";									// $MPDWEB:"mpdweb.php":標準
$RTEQUEST_URI=$_SERVER["REQUEST_URI"];

// mpdweb libray
$require_lib=dirname(__FILE__).'/'.$ORIGIN.'.lib.php';	// mpd XML Library Default
if  (file_exists($require_lib)) {						// mpd Session id Libraryの存在確認
	require_once($require_lib);
	}

$require_appli_lib=dirname(__FILE__).'/mpdweb.lib_appli.php';								// mpd Application Library アプリケーション層
if  (file_exists(dirname(__FILE__)."/".basename(__FILE__,".php").".lib_appli.php")) {		// Mpd XML Library mpd{module}.lib_appli.phpの存在確認
	$require_appli_lib=dirname(__FILE__)."/".basename(__FILE__,".php").".lib_appli.php";
	}
require_once($require_appli_lib);						// Mpd XML Library mpd{module}.lib.php

// mpdweb session libray
$require_ses=dirname(__FILE__).'/mpdcmnses.lib.php';	// mpd Session id Library
if  (file_exists($require_ses)) { require_once($require_ses); }		// mpd Mpd Session id Library

// PHP/HTML変数取得
$STS_MESSAGE="";
$SESSION_CONF=GetSessionConfigPLSPlaylist();			// php Session Config
//ArgSessionStart($SESSION_CONF);//						// mpdweb.phpの延長で使用のため使用しないこと:require_once("mpdweb.php")で行う : Used mpdcmnses.lib.php

// mpdweb library : このModule(mpdweb.playlist.php)はmpdweb.phpの関数を使用している。
if ($PLS_BASENAME == basename($_SERVER['SCRIPT_NAME'])) {
//	print '<BR><BR><BR><BR>$PLS_BASENAME['.$PLS_BASENAME.']basename($_SERVER[DOCUMENT_URI]'.basename($_SERVER['DOCUMENT_URI']).']<BR>';
	$require_mpdweb=dirname(__FILE__).'/'.$MPDWEB;		// mpdweb.php(必須) LibraryModeで使用(URL:&extend指定)
	require_once($require_mpdweb);						// 本ModuleをMainで使用する場合,mpdweb.phpの環境/関数を使用している。
	}

// TaskSErver I/F
$tasksock_lib=dirname(__FILE__)."/mpdtask.sock.lib.php"; 	// Mpd TaskServer I/F lib
require_once($tasksock_lib);								// require Mpd TaskServer I/F lib

// Version
$MY_PLSVERSION=basename(__FILE__,"")." 1.1 (30.11.2024)";

// PHP Configuration
$PHP_CONFIG=array("php_timeout"=>130,"php_looptime"=>120,"php_locale"=>"ja_JP.UTF-8","memory_limit"=>"160M");
get_config("php_config",$PHP_CONFIG);				// php config
set_time_limit($PHP_CONFIG["php_timeout"]);
setlocale(LC_ALL,$PHP_CONFIG["php_locale"]);
ini_set('memory_limit',$PHP_CONFIG["memory_limit"]);

// ※ $DEBUG= 2 ケースにより,ファイルアウトに掛かる負担でTimeoutがあり得ることに注意。Art切り替えを繰り返すときなど
$DEBUG= false;	// flase 1:m+sg 2:logout 3:User
//$DEBUG= 2;  	// false 1:msg 2:logout 3:User // 2:にするときは、Directory Permissionを書き込み許可にすること。
//$DEBUG= 3;  	// false 1:msg 2:logout 3:User
//ini_set('display_errors',1);							// エラー表示設定

/* --------------- mpdweb PLS plslaylist 初期 ------------------------- */
GetEnvPlaylistPLS();									// PlaylistPLS設定

/* *************************************************************************************
	mpdweb.playlist.php Post Proc
	p:"Extend|PLS{PostCommand}" Extend|がない場合mpdwebのPostCommand 
    POST:RequestはModule名で行うので実行FileNameが一致の場合に本PostRequestと判断
************************************************************************************** */
if ((isset($_POST['p']))&&((basename(__FILE__)==basename($_SERVER["SCRIPT_FILENAME"])))) {
	if (($ret = GetEnvCommon()) !== "") {
		DispErrorBox($ret);
		exit; }
	if($_POST['p']=="Extend|PLSAdd") {									// PLS Playlist Add
		$Net = new Net_Common;
		$tout=array("PostTimeout"=>0,"ConnectTimeout"=>4);				// Timeoutは局面で変える可能性かあるので共通化としていない
		$no=get_config("Net_Timeout",$tout);
		if ($no != 0) {
			$Net->timeout=$tout["PostTimeout"];							// Usind Post Timeout
			$Net->c_timeout=$tout["ConnectTimeout"];
			}
		get_config("Mpd_net",$Net->p_connect);							// Net_Common Property mpdconfig.xmlから設定
		if (!$Net->connect()) {
			msglog($Net->p_error."\n");
			}
		 PostPLSPLAdd($_POST);
		 mpd_close();
		 }
	if($_POST['p']=="Extend|PLSFav") {									// PLS Playlist Favorite Update
		 PostPLSPLFav($_POST);
		 }
	if($_POST['p']=="Extend|PLSDTL") {									// PLS Playlist Display Detaile
		 PostDispPLSDTL($_POST);
		 }
	}

/* -----------------------------------------------------------------------------
	PostPLSPLAdd($arg) : Post PLS Playlist PLAdd
	 $arg  : i  : Parameter Array
	              $arg[cmd]  : Playlist Add Command Add,ClearAdd,AddPlay
	              $arg[kind] : pls / file
	              $arg[file] : $kind=pls:pls file / $kind=file:Play file (URL/File)
------------------------------------------------------------------------------ */
function PostPLSPLAdd($arg) {
	global $Net,$XML_PATH;

	$cmd="";$kind="";$file="";
	if(isset($arg["cmd"])) { $cmd=$arg["cmd"]; }
	if(isset($arg["kind"])) { $kind=$arg["kind"]; }
	if(isset($arg["file"])) { $file=$arg["file"]; }
	print "Post PLSPLAdd Start\n";
	if($cmd=="ClearAdd") {
		 $mpdcmd[]="clear";$mpdcmd[]="file"; }
	else if($cmd=="AddPlay") {
		 $mpdcmd[]="clear";$mpdcmd[]="file";$mpdcmd[]="play"; }
	else {
		 $mpdcmd[]="file";
		 }
	$query=array();
	$field=array("pls","File","tag");
	$output=pls_read($XML_PATH["Directory"],$field,"",$file);
	if ($kind=="pls") {
		 foreach ($output["pls"] as $i => $ary) {
			if(isset($output["File"][$i])) {
				foreach ($output["File"][$i] as $key => $val) {
					$query[]=$val;
					}
				}
			}
		 }
	else {
		 $query[]=$file;
		 }
	mpd_add($mpdcmd,$query);

	foreach($mpdcmd as $cmd) {						// ClearCommand Super Global Playlist Clear
		if ($cmd == "clear") {
			_PostSendNowMusicPlClear();
		 	PostSendPLExpansion("clear","");	//  Super Global Playlist Extend PlayPanel Clear
			break;
			}
		}

	print "Post PLSPLAdd End\n";
	}

/* -----------------------------------------------------------------------------
	PostPLSPLFav($arg) : Post PLS Playlist Favorite Update
	 $arg  : i  : Parameter Array
	              $arg[file] : pls file
	              $arg[fav]  : Favorite Value
------------------------------------------------------------------------------ */
function PostPLSPLFav($arg) {
	global $XML_HOST,$XML_PATH,$XML_NETMASK;

	$file="";$fav="";
	if(isset($arg["file"])) { $file=$arg["file"]; }
	if(isset($arg["fav"])) { $fav=$arg["fav"]; }

	print "Post PLSPLFav Start\n";
	if (!Commn_Subnet($XML_NETMASK['netmask'],$_SERVER['REMOTE_ADDR'])) { return($result); }	// NetMaskで更新のように見えるだけ
	$new="Favorite=".$fav;
	$XML_PATH["Directory"]=rtrim($XML_PATH["Directory"],"/");
$str = <<< EOM
ORGN=`awk -F '[[:space:]]*=[[:space:]]*' '$1=="Favorite" {print}' "{$XML_PATH["Directory"]}/{$file}"`;
if [ -n "\$ORGN" ]; then
	if [ -n "{$fav}" ]; then
		sed -i -e "s/\${ORGN}/{$new}/g" "{$XML_PATH["Directory"]}/{$file}";
	else
		sed -i -e "/\${ORGN}/d" "{$XML_PATH["Directory"]}/{$file}";
	fi;
else
	sed -i -e "\$ a {$new}" "{$XML_PATH["Directory"]}/{$file}";
fi;
EOM;
	if ((isset($XML_HOST["Host"]))&&($XML_HOST["Host"] !=="")) {
		 $str=str_replace("\n"," ",$str);
		 $ret=pls_Sockexec($str."\n");
		 }
	else {
		 exec($str,$ret);
		 }

	_pls_FavoriteUpdate($XML_PATH["Directory"]."/",$file,$fav);
//	SHM_PLSProj("PlaylistPLS");				// Shared Memoroy Project 
//	SHM_PLSUnlink();						// Update後はShared Memoroyを削除し再作成させる場合は，コメント解除

	print "Post PLSPLFav End\n";
	}
/*
	_pls_MakePLSArray($plsary,$directory,$file,$fav) :  Update PLS(File)をSharedMemoryに反映する
	 $directory: i  : PLS Directory
	 $file     : i  : Update PLSFile
	 $fav      : i  : Update Favorite
*/
function _pls_FavoriteUpdate($directory,$file,$fav) {
	global $XML_SHMPLS;

	$shmary=False;											// Shared Memoroy off時/ No Array時 False
	if ($XML_SHMPLS["Used"] =="on") {
		 SHM_PLSProj("PlaylistPLS");						// Shared Memoroy Project 
		 $shmary=SHM_PLSGet("FiledPLS");					// Shared Memoroy Get
		 }
	if(!$shmary) { return; }
	$ary=array();
	$newline=$directory.$file.":Favorite=".$fav;			// New Line
	$cmp=0;
	foreach($shmary as $val) {
		$pattern = '/' . preg_quote($directory, '/') . '/i';
		$str=preg_replace($pattern,'',$val,1);
		if (stripos($str,$file) === 0)  {					// FileCompure
			$cmp=1;
			if (stripos($str,$file.":Favorite=") === 0)  {	// Rep Line
				 if($fav !=="") {								// Favoriteなしは除外
					$ary[]=$newline;
					}
				 $cmp=0;
				 continue;
				 }
			 }
		else if($cmp==1) {									// Add Favorite
				 if($fav !=="") {
					$ary[]=$newline;
					}
			 $cmp=0;
			 }
		$ary[]=$val;
		}
	if ($cmp==1) {											// Lastで追加
		if($fav !=="") {
			$ary[]=$newline;
			}
		}
	$ret=SHM_PLSPut($ary);									// Shared Memory Put
	}

/* -----------------------------------------------------------------------------
	PostDispPLSDTL($arg) : Post PLS Playlist PLS Playlist Display Detaile
	 $arg  : i  : Parameter Array
	              $arg[file] : pls file
	              $arg[fav]  : Favorite Value
------------------------------------------------------------------------------ */
function PostDispPLSDTL($arg) {
	$file="";$fav="";
	if(isset($arg["file"])) { $file=$arg["file"]; }
	if(isset($arg["fav"])) { $fav=$arg["fav"]; }
	print "Post DispPLSDTL Start\n";
	print "grpPLSDTL:";

	ob_start();												// Standerd Out , Buffer in
	DispPlaylistPLSDT($file,$fav);
	$str = ob_get_contents();
	ob_end_clean();
	$str=str_replace("\n","",$str);							// Delete NewLine
	print $str;

	print "\n";
	print "Function:RequestBoxDisp('grpPLSDTL');\n";		// Update Run mode
	print "Post DispPLSDTL End\n";
	}

/* -------------------------------------------------------------------------------------
	Howto Dubug
	$fp = fopen("log/pllog.txt", "a");
		fwrite($fp,"Post PLSPLAdd Start(".$cmd.":".$kind.":".$file.")\n");
	Array Output
		ob_start();
		print_r($output);
		$str = ob_get_contents();
		ob_end_clean();
		fwrite($fp,$str."\n");
	fclose($fp);
*/

/* -------------------------------------------------------------------------------------
	mpdweb.playlist.php HTML CSS
-------------------------------------------------------------------------------------- */
if ((isset($_GET['p']))&&($_GET['p']=="extend|playlist")) {
	echo <<<EOM
<script type="text/javascript">
/* Parent Moduleに設定 */
POST_MOD = POST_MOD.replace("{$PLS_BASENAME}","{$MPDWEB}");
PHP_SELF = PHP_SELF.replace("{$PLS_BASENAME}","{$MPDWEB}");
POST_MYMOD="{$_SERVER['PHP_SELF']}";
</script>
<style type="text/css">
/* CSS 
.PLSHEAD : Header Text
.PLSHDB  : Header Button
.PLSDTL  : Detaile Text
.PLSDTLUL: Detaile Under Text
.PLSPBTN : Detaile Function Button
.PLSBOXT : PLS FileBox Text
.PLSBOXD : PLS FileBox Text Detaile Text
*/
.PLSHEAD { float:left;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;font-size:12px;line-height:160%;height:18px;background-color:#333333;color:#DDDDDD;}
.PLSHDB { height:19px;width:50;color:#CED8F6; background:linear-gradient(to bottom, #642EFE,#003366);}
.PLSDTL { overflow:hidden;white-space:nowrap;text-overflow:ellipsis;height:20px;font-size:14px;padding:3px 5 7px;width:407px; }
.PLSDTLUL { float:left;height:14px;line-height:170%;}
.PLSPBTN { height:27px;line-height:200%;text-align:center;width:33;font-size:10px;background-color:#000022;color:#ffffff;}
.PLSBOXT { position:absolute;top:40px;left:10px;height:20px;line-height:180%;border:1px solid #333333;background-color:#1c1c1c;color:#ffffff;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;font-size:12px;padding: 0px 0em 0 4px; } 
.PLSBOXD { height:20px;line-height:180%;color:#ffffff;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;font-size:12px;padding: 0px 0em 0 4px; } 
</style type="text/css">
EOM;
	if ($XML_JSSORT["JsSort"] == "on") {			// JS ItemSort Libを$ARG[P]を合わせてLoad
		$jssort = rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'."mpdweb.lib.sort.js";		// Include:mpdweb.lib.sort.js
		if  (file_exists(rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename(__FILE__,".php").".lib.sort.js")) {
			$jssort = rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename(__FILE__,".php").".lib.sort.js";		// mpdweb.lib.sort.js mpd{module}.js
			}
		print '<script type="text/javascript" src="'.$jssort.$dateform.'"></script>';
		}
	}

if ((isset($_GET['p']))&&($_GET['p']=="extend|playlist")) {
	echo <<<EOM
<script type="text/javascript">
/* -------------------------------------------------------------------------------------
	mpdweb.playlist.php JavaScript Module
-------------------------------------------------------------------------------------- */

/* ------------------------------------------------------------------------------------
	RequestPostPLSAdd(AddCmd,Addkind,file): Post Playlist Add
	 AddCmd   : i  : Playlist Command Add,ClearAdd,AddPlay
	 Addkind  : i  : pls|file pls:「.pls」ファイル指定  file:「.pls」内ファイル
	 file     : i  : Addkind=pls:「.pls」ファイル, Addkind=file:内部定義ファイル
	PHPからの使用例)
	 RequestPostPLSAdd("ClearAdd","{pls|file}","{file}");
------------------------------------------------------------------------------------ */
function RequestPostPLSAdd(AddCmd,Addkind,file) {
	file=encodeURIComponent(file);
	str="p=Extend|PLSAdd&cmd="+AddCmd+"&kind="+Addkind+"&file="+file;
	RequestByPost(POST_MYMOD,str,POST_SYSOUT);
	}

/* ------------------------------------------------------------------------------------
	RequestPostFavorite(file,fav) : Post Favorite Update
	 file   ; i  : Addkind=pls:「.pls」ファイル
	 fav    : i  : HTML-id:Favorite
------------------------------------------------------------------------------------ */
function RequestPostFavorite(file,fav) {
	file=encodeURIComponent(file);
	str="p=Extend|PLSFav&file="+file+"&fav="+fav;
	RequestByPost(POST_MYMOD,str,POST_SYSOUT);
	var id=document.getElementById("idPLSFavid").textContent
	var str="";
	if (fav !=="") {
		str=fav+"fav";
	 	}
	document.getElementById(id).textContent=str;
	if (document.getElementById('frFavVal')) {
		document.getElementById('frFavVal').textContent=str;
		}
	}

/* ------------------------------------------------------------------------------------
	RequestPostDTLDisp(file,fav) : Post pls detaile
	 file   ; i  : Addkind=pls:「.pls」ファイル
	 fav    : i  : HTML-id:Favorite
------------------------------------------------------------------------------------ */
function RequestPostDTLDisp(file,fav) {
	file=encodeURIComponent(file);
	str="p=Extend|PLSDTL&file="+file+"&fav="+fav;
	RequestByPost(POST_MYMOD,str,POST_SYSOUT);
	}

/* -----------------------------------------------------------------------------
	DisplayFavorite(idscr,idFav) : DisplaylistPLS Function Radio Display
	 idscr   : i  : HTML-id Title(PLS Name)
	 idFav   : i  : HTML-id Favorite
----------------------------------------------------------------------------- */
function DisplayFavorite(idscr,idFav) {
	var str=document.getElementById(idFav).textContent;
	var favno="";
	if(str !== "") {
		no = str.split('fav');
		favno=no[0];
		}
	document.getElementById("idPLSname").textContent=document.getElementById(idscr).textContent;
	document.getElementById('idFavno').textContent=favno;
	document.getElementById('idFavno').value=favno;
	document.getElementById('idFavNoSel').style.backgroundColor = "";
	document.getElementById('idFavNoSel').style.color = "";
	document.getElementById("idPLSFavid").textContent=idFav;
	RequestBoxDisp('PLSFav');
	}

/* -----------------------------------------------------------------------------
	DisplayPLSDTFunc(id,idFav) : DisplaylistPLS Function Radio Display
	 idscr   : i  : HTML-id Title(PLS Name)
	 idFav   : i  : HTML-id Favorite
----------------------------------------------------------------------------- */
function DisplayPLSDTFunc(idtitle,idfile) {
	RequestBoxDisp('fnPLSDBox');
	document.getElementById('fnPLSDBoxT').textContent=document.getElementById(idtitle).textContent;
	document.getElementById('fnPLSDBoxF').textContent=document.getElementById(idfile).textContent;
	}
</script>

EOM;
	}

/* *************************************************************************************
	mpdweb.playlist.php PHP Main Proc
	URL : p=extend|playlist
************************************************************************************** */
if ((isset($_GET['p']))&&($_GET['p']=="extend|playlist")) {
	if (isset($_GET['clear'])) {							// 引数に"clear"指定時Shared Memory Delete
		 GetPlylisPLSCashClear();
		 }
	if  (!isset($_SESSION["ExtendPlaylist/list"])) {
		 $list=$XML_HEADER["Detaile"];						// detail設定より初期値
		 $_SESSION["ExtendPlaylist/list"]=$list;
		 }
	else {
		 $list=$_SESSION["ExtendPlaylist/list"];
		 }
	DispPlylisPLS($list);
	$iListTBL="grpPLSList";		// 対象となるTable
	$iListARG="id=idPLS";		// 対象をidで指定
	$iListDefHigh=54;			// Haeder高さの位置補正 */
	$iListListExc=$XML_DETAILE["SortExc"];			// Select Filed
	$iListCapital=$XML_SORTBASE["Sort_Capital"];	// 大文字/小文字区別の設定
	$iListBoxCss="z-index:4";
	require_once("mpdilist.php");

	echo <<<EOM
</body
</html>
EOM;
	exit();
	}

/* -----------------------------------------------------------------------------
	GetSessionConfigPLSPlaylist() : php Session Config
	 @return: o  : "":$SESSION_CONF Session Array
	※ require(mpdweb.php)の前に設定を取得する
----------------------------------------------------------------------------- */
function GetSessionConfigPLSPlaylist() {
	global $XML_CONF,$STS_MESSAGE;

	$XML_File = "setting/mpdconfig.xml";
	$ret="";$STS_MESSAGE="";
	try {
		$XML_CONF = get_loadconfig($XML_File);			// XML File Get FileNameはLibrary標準
		} catch( Exception $e ) {
	  $STS_MESSAGE=$e->getMessage();
	  $ret=False;
	  }

	ignore_user_abort(false);							// 切断時終了
	$SESSION_CONF=array("sesion_id"=>"mpdweb","href_waitmsec"=>"50","maxlifetime"=>"1440");
	get_config("php_session",$SESSION_CONF);			// php config php_session
	$SESSION_CONF=ArgSessionConf($SESSION_CONF);		// mpdweb:Session id 作成 : Used mpdcmnses.lib.php

	return($SESSION_CONF);
	}

/* -----------------------------------------------------------------------------
	GetEnvPlaylistPLS() : PlaylistPLS設定
----------------------------------------------------------------------------- */
function GetEnvPlaylistPLS() {
	global $XML_CONF,$XML_PLSCONF,$XML_HOST,$XML_PATH,$XML_WEB,$XML_HEADER,$XML_NETMASK,$XML_DETAILE,$XML_SHMPLS,$XML_PlaylistPLS;

	$XML_PlaylistPLS="setting/mpdweb_playlist_myset.xml";
	if  (!file_exists($XML_PlaylistPLS)) {
		$XML_PlaylistPLS="setting/mpdweb_playlist.xml";
		}
	try {
		$XML_PLSCONF=get_loadxml($XML_PlaylistPLS);
		} catch( Exception $e ) {
	  $XML_PLSCONF=array();
	  }

	global $XML_CONF_ARY;
	$XML_CONF_ARY["setting/mpdconfig.xml"]=$XML_CONF;							// AlterSectionでmpdconfig.xmlの内容を取得
	$XML_CONF_ARY["setting/mpdweb_playlist_myset.xml"]=$XML_PLSCONF;
	$XML_CONF_ARY["setting/mpdweb_playlist.xml"]=$XML_PLSCONF;

	$XML_HOST=array("AlterSection"=>"","Host"=>"","Port"=>"9050","Timeout"=>"5","Accunt"=>"login=mpdweb:mpdweb\n","TermStr"=>"\x1b\n");
	get_confxml($XML_PLSCONF,"TaskServer",$XML_HOST);
	$XML_HOST=GetEnvPlaylistHost($XML_HOST);
	$XML_HOST["TermStr"] = str_replace("%1b","\x1b",$XML_HOST["TermStr"]);			// TaskSaver TaskEnd Send Character

	$XML_PATH=array("Directory"=>"/var/lib/mpd/music/RADIO/","ARTPath"=>"%DOCUMENT_ROOT%/imagesw/radio-logos");
	get_confxml($XML_PLSCONF,"PLSPath",$XML_PATH);

	$XML_DETAILE=array("DTLNO"=>"4","SortExc"=>"The ");
	get_confxml($XML_PLSCONF,"Detaile",$XML_DETAILE);

	$XML_WEB=array("DOCROOT"=>"/var/local/www","WEBPath"=>"localhost","ImgExtend"=>"jpg,png");
	get_confxml($XML_PLSCONF,"WebPath",$XML_WEB);
	if (strpos($XML_WEB["WEBPath"],"localhost") !==false) {
		$XML_WEB["WEBPath"]="http://".str_replace("localhost",$_SERVER["SERVER_ADDR"],$XML_WEB["WEBPath"]);	// localhostに設定時,IPAddressを設定
		}
	$XML_WEB["Extend"]=explode(",",$XML_WEB["ImgExtend"]);

	$XML_HEADER=array("Detaile"=>"album","ButtonName"=>"Playlist","BackURL"=>"");
	get_confxml($XML_PLSCONF,"Header",$XML_HEADER);
// Exclude NetMask
	$XML_NETMASK=array("netmask"=>"","artmask"=>"");
	get_confxml($XML_PLSCONF,"Exclude",$XML_NETMASK);
	foreach($XML_NETMASK as $key=> $val) {
		$val=GetEnvAlerGet("Exclude",$key,$val);
		$XML_NETMASK[$key]=$val;
		}
//  Shm_Project Get
	$tmpary=array("Used"=>"off");
	get_confxml($XML_CONF,"Shm_Project",$tmpary);
	$cnf_shmuse=$tmpary["Used"];
	$tmpary=array("Used"=>"off","Common"=>"0,/tmp,128,43200,,,");
	GetAlterConfig("Shm_Project",$tmpary);										// Alternative get_configd:off時,onにできないようにする。(LibrayがShared Memory未使用)
	$XML_SHMPLS=$tmpary;
	get_confxml($XML_PLSCONF,"Shm_Project",$XML_SHMPLS);
	$tmpary=array("PlaylistPLS"=>"6,/tmp,20000,43200,gzcompress,gzuncompress,9");
	get_confxml($XML_PLSCONF,"Shm_Project",$tmpary);
	$XML_SHMPLS["PlaylistPLS"]=$tmpary["PlaylistPLS"];
	if($cnf_shmuse=="off") {
		$XML_SHMPLS["Used"]=$cnf_shmuse;
		}
//print "<BR><BR><BR><BR><BR><BR><BR>";
//print_r($XML_HOST);
//print_r($XML_NETMASK);
//print_r($XML_SHMPLS);
	}

/* -----------------------------------------------------------------------------
	GetEnvPlaylistHost($XML_HOST) : PlaylistPLS TaskServer Host設定
	 $XML_HOST : i  : XML設定 Array
----------------------------------------------------------------------------- */
function GetEnvPlaylistHost($XML_HOST) {
	global $XML_CONF,$XML_PLSCONF;

	global $XML_CONF_ARY;
	if (!is_array($XML_CONF_ARY)) { $XML_CONF_ARY=array(); }
	$ary=$XML_HOST;
	$xmlget=array();
	$XML = get_object_vars($XML_PLSCONF);
	foreach($XML["TaskServer"]  as $key=> $valxml) {					// XML定義 <Bodyfont_{AGENT Parts String}>
		$val=(string)$valxml;
		$result = preg_match_all('/{(.*?)}/s',$val,$part,PREG_SET_ORDER);
		if (($result > 0)&&($key=="AlterSection")) {					// "AlterSection"の要所置換
			if (isset($XML_CONF_ARY[$part[0][1]])) {
				 $tmpary=$XML_CONF_ARY[$part[0][1]];
				 }
			else {
				 try {
					 $tmpary=get_loadxml($part[0][1]);
					 } catch( Exception $e ) { $tmpary=array(); }
				 $XML_CONF_ARY[$part[0][1]]=$tmpary;
				 }
			 $xmlget[$part[0][1]]=$tmpary;								// 設定の初期値
			 $filed=array("Host"=>"","Port"=>"","Timeout"=>"","Accunt"=>"","TermStr"=>"");
			 get_confxml($tmpary,"TaskServer",$filed);
			 foreach ($filed as $k => $v) {
				if(isset($ary[$k])) {
					$ary[$k]=(string)$v;
					}
				}
			 continue;
			 }
		 if(isset($ary[$key])) {
			$ary[$key]=$val;
			}
		 }
	foreach ($ary as $key => $val) {
		if ($key=="AlterSection") { continue; }
		$result = preg_match_all('/{(.*?)}/s',$val,$part,PREG_SET_ORDER);
		if ($result == 0) { continue; }
		$part[0][1]=str_replace("|",":",$part[0][1]);			// {XMLFile|{Section}/{key}}または,{XMLFile:{Section}/{Key}}
		$tmp=explode(":",$part[0][1]);
		if(!isset($xmlget[$part[0][1]])) {
			 if (isset($XML_CONF_ARY[$part[0][1]])) {
				  $tmpary=$XML_CONF_ARY[$part[0][1]];
				  }
			 else {
				 try {
					 $tmpary=get_loadxml($tmp[0]);
					 } catch( Exception $e ) { $tmpary=array(); }
				 $XML_CONF_ARY[$part[0][1]]=$tmpary;
				 }
			 $xmlget[$part[0][1]]=$tmpary;
			 }
		else {
			 $tmpary=$xmlget[$part[0][1]];
			 }
		if(isset($tmp[1])) {
			 $t=explode("/",$tmp[1]);
			 if(isset($t[1])) {
				  $filed=array($t[1]=>"");
				  get_confxml($tmpary,(string)$t[0],$filed);
				  $ary[$key]=(string)$filed[(string)$t[1]];
//				  print '[4]['.$key.']$filed['.(string)$t[0].']['.(string)$t[1].']'.$filed[$t[1]]."<BR>";
				  }
			 else {
				  $filed=array($key=>"");
				  get_confxml($tmpary,(string)$t[0],$filed);
				  $ary[$key]=(string)$filed[$key];
//				  print '[3]$filed['.$key.']['.(string)$t[0]."]".$filed[$key]."<BR>";
				  }
			 }
		else {
			 $filed=array($key=>"");
			 get_confxml($tmpary,"TaskServer",$filed);
			 $ary[$key]=$filed[$key];
//			 print '[2]$filed['.$key.']['.$filed[$key]."]<BR>";
			 }
//		print '$key['.$key.'] $val['.$val.']<BR>';
		}
	if(($ary["Host"]=="localhost")||($ary["Host"]=="127.0.0.1")||($ary["Host"]=="::1")) {
		$ary["Host"]="";
		}
//	foreach ($XML_CONF_ARY as $key => $val) {
//		print '$XML_CONF_ARY['.$key."]<BR>";
//		}
//print_r($ary);
	return($ary);
	}

/* -----------------------------------------------------------------------------
	GetEnvAlerGet($key,$val) : Get Alter Setting (Section/Value)
	 $set : i  : TopTag (目的の親Tag)
	 $key : i  : XML設定 Array
	 $val : i  : Value
	<$key>$val</$key>設定の分解
	$valの形式
	 <$key>{XMLFile}:{Section}/{key}</$key>
	 <$key>{XMLFile}:{Section}</$key>
	 <$key>{XMLFile}</$key> TopTag($setを使用)
	 セパレータ「:」または「|」
	※類似関数が複数あるが効率性より修正の機会があれば纏める
	  mpdtask.php <Exclude>取得，本処理の<TaskServer>取得(追記設定で変更可能、更にAlterできる点が異なる)
	  作成当初考えていなかった点より、現在の設定を満たす関数が要。
----------------------------------------------------------------------------- */
function GetEnvAlerGet($set,$key,$val) {
	global $XML_CONF_ARY;

	if (!is_array($XML_CONF_ARY)) { $XML_CONF_ARY=array(); }
//print '$set['.$set.'] $key['.$key.'] $val['.$val.']<BR>';
	$result = preg_match_all('/{(.*?)}/s',$val,$part,PREG_SET_ORDER); // {XMLFile}:分離
	if ($result == 0) { return($val); }						// 直接値の場合は終了
	$part[0][1]=str_replace("|",":",$part[0][1]);			// {XMLFile|{Section}/{key}}または,{XMLFile:{Section}/{Key}}
	$tmp=explode(":",$part[0][1]);							// $tmp:$tmp[0]:XMLFile $tmp[1]:{Section}/{Key}
	if (isset($XML_CONF_ARY[$tmp[0]])) {
		 $tmpary=$XML_CONF_ARY[$tmp[0]];
		 }
	else {
		 try {
			 $tmpary=get_loadxml($tmp[0]);					// XMLFile Get
		   } catch( Exception $e ) {
			 $tmpary=array();
			 }
		 $XML_CONF_ARY[$tmp[0]]=$tmpary;					// AlterSectionでXMLFilelの内容をセット
		 }
	if(isset($tmp[1])) {					// {Section}/{Key}形式
		 $t=explode("/",$tmp[1]);
		 if(isset($t[1])) {					// {Key}:$t[1]
			  $filed=array($t[1]=>"");
			  get_confxml($tmpary,(string)$t[0],$filed);
			  $str=(string)$filed[(string)$t[1]];
//			  print '[1]$filed['.$t[0].']$key['.$t[1].']$str['.$str.']<BR>';
			  }
		 else {
			  $filed=array($key=>"");
			  get_confxml($tmpary,$t[0],$filed);
			  $str=(string)$filed[$key];
//			  print '[2]$filed['.$t[0].']$key['.$key.']$str['.$str.']<BR>';
			  }
		 }
	else {
		 $filed=array($key=>"");
		 get_confxml($tmpary,$set,$filed);
		 $str=$filed[$key];
//		 print '[3]$filed['.$set.']$key['.$key.']$str['.$str."]<BR>";
		 }
	return($str);
	}

/* -----------------------------------------------------------------------------
	GetPlylisPLSCashClear() : Shared Memory Unlink
----------------------------------------------------------------------------- */
function GetPlylisPLSCashClear() {
	SHM_PLSProj("PlaylistPLS");				// Shared Memoroy Project 
	SHM_PLSUnlink();						// Update後はShared Memoroyを削除し再作成させる場合は，コメント解除

	$url=str_replace('&clear',"",$_SERVER['REQUEST_URI']);
	header("Location: $url");
	}
/* -----------------------------------------------------------------------------
	DispPlylisPLS($list,$pos,$value) : Display PlaylistPLS 
	 $list   : i  : album|list
	 $pos    : i  : Positioning "on"/"off"
	 $value  : i  : Positioning 位置
	※共通として$pos,$valueを引数/機能を盛り込んでいるが、現在使用対象がない。(2024/03/16)
----------------------------------------------------------------------------- */
function DispPlylisPLS($list="",$pos="",$value="") {
	global $XML_CONF,$XML_JSSORT,$XML_SORTBASE,$ARG,$XML_PATH,$XML_DETAILE;;

	ob_end_flush();
// Make HTML Header/Footer

// mpdconfig.xmlに"PLS"がないので追加 : 参照例 $XML_CONF->Sort_listexclude->{Tag};(playlist[0])
	if (isset($XML_DETAILE['SortExc'])) {  // 存在する場合のみaddChildを実行
		$item = $XML_CONF->Sort_listexclude->addChild("PLS",$XML_DETAILE['SortExc']);		// 参照:$XML_CONF->Sort_listexclude->PLS[0];
		}
	DispHeader("playlist","list",$list);
	if($list !== "album") {									// Filed Array: "tag","Title","Length"は1ファイル(PLS)複数
		 $field=array("pls","File","tag","Title","Length","NumberOfEntries","Version","Favorite");
		 }
	else {
		 $field=array("pls","Art","File","tag","Title","Length","NumberOfEntries","Version","Favorite");
		 }
	if ($XML_JSSORT["JsSort"] !=="off") {					// Sort設定でMaskか判断
		if ($list !== "album") {							// listexc Detail Js Sort 設定
			  $SRTROW=2;$TBLID=1;$SRTITM=array("PLS"=>array("cell"=>1,"cellno"=>0,"row"=>0),"URL"=>array("cell"=>0,"cellno"=>1,"row"=>1),"Fav"=>array("cell"=>1,"cellno"=>0,"row"=>1)); }
		 else {												// list Art&Detail Js Sort 設定
		 	  $SRTROW=2;$TBLID=1;$SRTITM=array("PLS"=>array("cell"=>1,"cellno"=>0,"row"=>0),"URL"=>array("cell"=>0,"cellno"=>1,"row"=>1),"Fav"=>array("cell"=>1,"cellno"=>0,"row"=>1)); }
		 DispState($SRTITM,"grpPLSList",$TBLID,$SRTROW);	// Starus & PosBar & ItemSort
		 }
	else {
		 DispState();										// Starus
		 }
	$urlary=array();
	$output=pls_read($XML_PATH["Directory"],$field,$XML_PATH["ARTPath"],"",$urlary,$XML_SORTBASE["Sort_Capital"]);
// PLSFile Header Make
	ob_end_flush();
	ob_start('mb_output_handler');
	print '<title>[PLS]Playlist ('.$_SERVER["HTTP_HOST"].')</title>';
	DisplaylistPLSHeader($list,$output);
	print '<div style="clear:both;">';
	if (!is_array($output)) {
		print '</div>';
		$errmsg='There is no playlist !!';
		if (($output !== 1)||(count($output["pls"])==0)) {
			$errmsg=$errmsg." : ".$output;
			}
		print '<div style="position:fixed !important;position:absolute;left:60px;top:100px;width:400px;font-size:14px;color:#f08080;">'.$errmsg.'</div>';
		return;
		}
	$str="";
	if (($value!=="")&&($pos == "on")) {
		$str="display:none;";								// 指定位置Positionは最後に表示するので非表示にする要求
		}
	print '<table border="3" id="grpPLSList" cellpadding="0" bgcolor="#000000" frame=void style="table-layout:fixed;'.$str.'">';
	$idtop=NULL;$idlast="";

	JsListLoadDisp($pos,$value,"grpPLSList");				// 時計マーク表示
// PLSFile Details Loop
	foreach ($output["pls"] as $i => $val) {
		$idscrl="idPLS".$i;
		if (is_null($idtop)) { $idtop=$idscrl; }			// 指定位置Position 先頭,最後のid設定
		$idlast=$idscrl;
		print '<tr>';
		print '<td rowspan="2">';
		$width='';
		if ($list == "album") {								// Display:2Line Upper
			$width=' style="width:367px;"';
			if (isset($output["Art"][$i])) {					// Display Image Art
				 print '<div style="font-size:11px;width:40">';
				 $clip="";
				 ArgImageSize($output["Art"][$i],"40:fix","listart",$imgwidth,$imghigth,$clip);
				 $style="";if (!is_null($clip)) { if ($clip !== "") { $style='style="'.$clip."margin:-20px 0px 0px 0px;".'"'; } }
				 print '<img src="'.$output["Art"][$i].'" alt="" width='.$imgwidth.' height='.$imghigth.' border="0" '.$style.' />';
				 print '</div>';
				 }
			else {
				 $str= "No Image";
				 print '<div align=center class=noImg style="font-size:8px;border:0px solid #333333;width:40px;height=40px;">';
				 print '<p style="font-size:9px;width:40px;height:40px;line-height:14px;">'.$str.'</p>';
				 print '</div>';
				 }
			}
		print '</td>';
		$idFav='inPLSFav_'.$i;
		$js="RequestPostDTLDisp('".$val."','".$idFav."');";
		print '<td><button id="'.$idscrl.'" type=submit class="music PLSDTL"'.$width.' onclick="'.$js.'">'.$val.'</button></td>';
		$play = "RequestPostPLSAdd('AddPlay','pls','".$val."');RequestLoadDisp(1);PostNowMusic('');";		// Play Button
		print '<td><button type=submit class="music PLSPBTN" onclick="'.$play.'">Play</button></td>';
		$id='fPLS_'.$i;												// Display Function
		$js="";
		if (isset($output["File"][$i][0])) {
			$js=' onclick="RequestBoxDisp(\''.$id.'\');"';
			}
		print '<td rowspan="2"><button type=submit class="music bfunc"'.$js.'>...</button></td>';
		if (isset($output["File"][$i][0])) {
			DisplaylistPLSFunc($val,$id,$output["File"][$i][0],$idscrl,$idFav);
			}
		print '</tr>';
		print '<tr>';										// Display:2Line Under
		print '<td>';
		if (isset($output["File"][$i][0])) {
			 $listwidth=0;$titlewidth=110;
			 if($list !=="album") { $listwidth=42;$titlewidth=107; }
			 $dtlwidth=300;
			 if (count($output["File"][$i]) > 1) {
				 if (stripos($output["File"][$i][0],"http")===0) {
				 	  $ary=parse_url($output["File"][$i][0]);
					  $tmp=explode($ary["host"],$output["File"][$i][0]);
					  $str=$tmp[0].$ary["host"];
					  }
				 else {
					  $str=dirname($output["File"][$i][0]);
					  }
				  print '<div class="uline PLSDTLUL" style="width:'.($dtlwidth+$listwidth).';color:#e6e6fa;margin:0px 0px 0px 6px;">'.$str.'</div>';
				  $str=count($output["File"][$i])."pieces";
				  print '<div class="uline PLSDTLUL" align="right" style="width:50px;color:#7fffd4;margin:0px 0px 0px 6px;">'.$str.'</div>';
				  }
			 else {
				  $str=$output["File"][$i][0];
				  if (isset($output["Title"][$i][0])) {
					   $str2=$output["Title"][$i][0];
					   $dtlwidth=244;
					   }
				  else {
					   $str2="";
					   $dtlwidth=360;
					   }
				  print '<div class="uline PLSDTLUL" style="width:'.($dtlwidth+$listwidth).';color:#e6e6fa;margin:0px 0px 0px 6px;">'.$str.'</div>';
				  if ($str2 !=="") {
					    print '<div class="uline PLSDTLUL" style="width:'.$titlewidth.'px;color:#e6e6fa;margin:0px 0px 0px 6px;">'.$str2.'</div>';
						}
				  }
			 $str="";
			 if (isset($output["Favorite"][$i][0])) {
				 $str=$output["Favorite"][$i][0]."fav";
				 }
			 print '<td><div class="uline PLSDTLUL" id="'.$idFav.'" align="right" style="width:28px;color:#e6e6fa;margin:0px 0px 0px 6px;">'.$str.'</div></td>';
			 }
		else {
			 $str="FIle definition not found";
			 print '<div class="uline PLSDTLUL" style="width:300px;color:#e6e6fa;margin:0px 0px 0px 6px;">'.$str.'</div>';
			 }
		print '</td>';
		print '</tr>';
		}
	print '</table>';
	DisplaylistPLSFuncRadio();							// MakeFrame:AudioTagBox
	DisplaylistPLSFavorite();							// MakeFrame:Favorite
	DispPlaylistPLSDT("off");							// MakeFrame:PLSDetale
	DisplaylistPLSDTLFunc();							// MakeFrame:PLSDetale Function
	print '</div>';
	JsListLastPosition($idtop,$idlast,50);				// 最終位置Position
	JsListPosition($pos,$idpostion,'grpPLSList',50);	// 時計マークUnload,指定位置Position
	ob_flush();
	flush();
	}

/* -----------------------------------------------------------------------------
	DisplaylistPLSFunc($playlist,$id,$file,$top,$left): DisplaylistPLS Function Display
	 $playlist : i  : PLSPlaylist FileName
	 $id       : i  : HTML-id
	 $file     : i  : StormingURL / FilePath
	 $top      : i  : Box Position:Top
	 $left     : i  : Box Position:Left
----------------------------------------------------------------------------- */
function DisplaylistPLSFunc($playlist,$id,$file,$idscrl,$idFav,$top=200,$left=170) {
	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	$heigh=28*8;

	$post  = "RequestPostPLSAdd('add','pls','".$playlist."');";			// Post String PlaylistAdd
	$clear = "RequestPostPLSAdd('ClearAdd','pls','".$playlist."');";	// Post String Playlist Clear&Add
	$play  = "RequestPostPLSAdd('AddPlay','pls','".$playlist."');";		// Post String Playlist Clear&Add&play

	print '<div id='.$id.' class=box style="position:fixed;top:'.$top.'px;left:'.$left.';height:'.($heigh+28).'px;">';
	print '<div class=boxtitle>'.$playlist.'</div>';
	print '<button type=submit onClick="'.$post.$unload.'" class="boxline boxblin1">Add Playlist</button>';
	print '<button type=submit onClick="'.$clear.$unload.'" class="boxline boxblin2">Add and replace</button>';
	print '<button type=submit onClick="'.$play.$unload.';PostNowMusic(\'\');" class="boxline boxblin3">Add and replace and play</button>';

	print '<button type=submit onClick="'.'DisplayFavorite(\''.$idscrl.'\',\''.$idFav.'\');'.$unload.'" class="boxline boxblin4">Favorite Edit</button>';

	$post='mysrc=document.getElementById(\'PLSRadioSrc\');mysrc.setAttribute(\'src\',\''.$file.'\');document.getElementById(\'PLSRadioVal\').textContent=\''.$playlist.'\';RequestBoxDisp(\'PLSRadio\');';
	print '<button type=submit onclick="'.$post.$unload.'" class="boxline boxblin6">Play Radio (This terminal) Top item</button>';
	print '<input type="button" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" style="top:'.($heigh).'px;" />';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DisplaylistPLSFunc($top,$left): DisplaylistPLS Function Radio Display
	 $top      : i  : Box Position:Top
	 $left     : i  : Box Position:Left
----------------------------------------------------------------------------- */
function DisplaylistPLSFuncRadio($top=200,$left=100) {
	$id="PLSRadio";
	$unload = 'mysrc=document.getElementById(\'PLSRadioSrc\');mysrc.setAttribute(\'src\',\'\');RequestBoxDisp(\'PLSRadio\');RequestBoxtUnLoad(\''.$id.'\');';
	$heigh=110;
	$post="";
	print '<div id='.$id.' class=box style="position:fixed;top:'.$top.'px;left:'.$left.';height:'.($heigh+28).'px;background-color:#0b0b33;z-index:1000;">';
	print '<div id="PLSRadioVal" style="position:absolute;left:10px;top:8px;left:6px;"></div>';
	print '<div style="position:absolute;left:10px;top:40px;">';
	print '<audio controls="" id="PLSRadioSrc" src="" autoplay="" preload="auto" name="media" controlslist="nodownload" style="width:280px">';
	print '<p>Your browser does not support audio playback</p>';
	print '</audio>';
	print '</div>';
	print '<input type="button" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" style="top:'.($heigh).'px;" />';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DisplaylistPLSFavorite(): DisplaylistPLS Favorite Edit
	 $top      : i  : Box Position:Top
	 $left     : i  : Box Position:Left
----------------------------------------------------------------------------- */
function DisplaylistPLSFavorite($top=200,$left=170) {
	$id="PLSFav";
	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	$heigh=140;

	print '<div id='.$id.' class=box style="position:fixed;top:'.$top.'px;left:'.$left.';height:'.($heigh+28).'px;z-index:900;">';
	print '<div class=boxtitle>Favorite</div>';
	print '<div id=idPLSname class="boxtext SrhBoxS" style="top:28px;left:1px;height:12px;font-size:13px;color:#dcdcdc;"></div>';
	print '<button type=submit onClick="'."".'" class="boxline boxblin2">&nbsp;&nbsp;&nbsp;Favorite</button>';

	$select["Text"][]="";
	for($i = 1;$i < 6 ;$i++) { $select["Text"][]=$i; }
	$defstr=$tbno;
	$select["style"]["position"]="position:absolute;";
	$style="background-color:#d3d3d3;color:#3d3d3d;font-size:15px;";
	MakeSelectBox("get",$select,$defstr,"idFavno",62.5,140,80,"","idFavNoSel","",$style);

	print '<form action="javascript:RequestLoadDisp(1)">';	// 処理中マーク
	print '<button type=submit name="TbnoSubmit" id=idFavNoSel onclick="RequestPostFavorite(document.getElementById(\'idPLSname\').textContent,document.getElementById(\'idFavno\').value);'.$unload.'" value="Submit" style="position:absolute;top:63px;left:222px;border-style:none;width:56px;height:20px;cursor:pointer;">Update</button>';
	print '</form>';
	print '<div id=idPLSFavid style="position:absolute;top:'.($heigh-30).'px;left:1px;font-size:0.1px;color:#2f2f2f;"></div>';
	print '<input type="button" value="Cloce" onclick="'.$unload.'" class="buttn boxbcan" style="top:'.($heigh).'px;" />';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DisplaylistPLSHeader($list,$output) : Display PLSPlayList Header Display
	 $list  : i  : album|list
	 $output: i  : Array (PLSPlaylist Array)
----------------------------------------------------------------------------- */
function DisplaylistPLSHeader($list,$output=array()) {
	global $MPDWEB,$PLS_BASENAME,$XML_HEADER;						// OriginName:"mpdweb"

	$New_uri = preg_replace('/(&cnt=)[0-9]{1,2}/','',$_SERVER["REQUEST_URI"]);
	$New_uri=$New_uri."&".(ArgURLCounter());
	$url="location.href='".$New_uri."'";
	print '<div class=head style="top:24;height:23px;z-index:2;">';
	$liststr='PlayList';
	$width='198px;';
	$btn_color='background-color:#008000;color:#CED8F6;';
	print '<div style="float:left;">';
	print '<button type=submit name=detail value=detail class=buttn onclick="RequestLoadDisp(0);'.$url.'" style="width:60px;'.$btn_color.'margin:0px 2px 0px 1px;" >List</button>';
	print '</div>';
	$post=ArgPostSession("Playlist/list","album",$url);
	$btn_color='background-color:#642EFE;color:#CED8F6;';
	print '<div style="float:left;">';
	if ($list =="album") {
		 $post=ArgPostSession("ExtendPlaylist/list","list",$url);
		 $btn_color='background-color:#008000;color:#CED8F6;';
		 }
	else {
		 $post=ArgPostSession("ExtendPlaylist/list","album",$url);
		 $btn_color='background-color:#642EFE;color:#CED8F6;';
		 }
	print '<button type=submit name=art id="idPLArt" value=art class=buttn onclick="RequestLoadDisp(0);'.$post.'" style="width:52px;'.$btn_color.'margin:0px 0px 0px 2px;" >Art</button>';
	print '</div>';
	print '<div class=PLSHEAD style="width:8px;margin:2px 0px 0px 3px;"></div>';
	print '<div class=PLSHEAD style="width:189px;margin:2px 2px 0px -1px;">PLS - Playlist</div>';
	$url="location.href='".$XML_HEADER["BackURL"]."'";
	if($XML_HEADER["BackURL"]=="") {
		$url=str_replace($PLS_BASENAME,$MPDWEB,$_SERVER['REQUEST_URI']);
		$url="location.href='".str_replace('?p=extend|','?p=',$url)."'";
		}
	print '<button class="buttn PLSHDB" onclick="'.$url.'" align=center style="font-size:11px;margin:1px 0px 0px 0px;line-height:160%;width:50px;">'.$XML_HEADER["ButtonName"].'</button>';
	$no="";
	if (is_array($output)) {
		if (isset($output["pls"])) {
			$no = sizeof($output["pls"]);
			$no=$no."lists";
			}
		}
	print '<div id=idpnos class=PLSHEAD align=right style="font-size:11px;width:80px;margin:2px 2px 0px 2px;">'.$no.'&nbsp;</div>';
	$id="idPLSFunc";
	print '<button type=submit name=filecmd value=filecmd onclick="RequestBoxDisp(\''.$id.'\');this.blur();" class="comnd afunc">...</button>';
	DisplaylistPLSHeaderFunc("PLS - Playlist Function",$id,54,174);
	print '</div>';
	print '<div style="clear:both;width:150px;height:23px;"></div>';
	ob_flush();
	flush();
	}

/* -----------------------------------------------------------------------------
	DisplaylistPLSHeaderFunc($field,$id,$top,$left):  Display PLSPlayListHeader Function
	 $field    : i  : Box Title
	 $id       : i  : Box id
	 $top      : i  : Box Position:Top
	 $left     : i  : Box Position:Left
----------------------------------------------------------------------------- */
function DisplaylistPLSHeaderFunc($field,$id,$top=200,$left=170) {
	global $XML_PATH,$XML_HOST,$XML_WEB,$XML_SHMPLS,$MY_PLSVERSION,$XML_PlaylistPLS;

	$heigh=28*8;
	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	print '<div id='.$id.' class=box style="position:fixed;top:'.$top.'px;left:'.$left.';height:'.($heigh+28).'px;">';
	print '<div class=boxtitle>'.$field.'</div>';
	$id="idPListPosition";
	$post="";

$idinfo="idPLSinfo";

	print '<button type=submit onClick="RequestBoxDisp(\''.$idinfo.'\');'.$unload.'" class="boxline boxblin1" style="top:38px;">PLS Information</button>';
	if ($XML_SHMPLS["Used"] =="on") {
		$req_uri=$_SERVER["REQUEST_URI"];
		if (isset($_GET["clear"])) { $str=""; } else { $str="&clear"; }
		$clearurl='RequestLoadDisp();location.href=\''.$req_uri.$str.'\'';	// Shared Memory Clear	Used : Shared Memory
		print '<button type=submit onClick="'.$clearurl.'" class="boxline boxblin3" style="top:74px;">Cash Clear (Shared Memory:PlaylistPLS)</button>';
		print '<div class="boxtext SrhBoxS" style="bottom:'.(28*3-0).'px;color:#dcdcdc;">PLS TAG:"File","Title","Length","Favorite"</div>';
		print '<div class="boxtext SrhBoxS" style="bottom:'.(28*3-14).'px;color:#dcdcdc;">"Favorite":SpeciaTag(mpwweb Extend)</div>';
		}
	if($XML_HOST["Host"]=="") {
		 $str="localhost";
		 }
	else {
		 $str=$XML_HOST["Host"];
		 }
	print '<div class="boxtext SrhBoxS" style="bottom:130px;color:#add8e6;">PLSHost:'.$str.'</div>';
	print '<div class="boxtext SrhBoxS" style="bottom:118px;color:#add8e6;">PLSPath:'.$XML_PATH["Directory"].'</div>';
	$str=str_replace("%DOCUMENT_ROOT%",(rtrim($XML_WEB["DOCROOT"],"/")),$XML_PATH["ARTPath"]);
	print '<div class="boxtext SrhBoxS" style="bottom:106px;color:#add8e6;">ArtPath:'.$str.'</div>';
	print '<div class="boxtext SrhBoxS" style="bottom:40px;color:#98fb98;">'.$MY_PLSVERSION.'</div>';
	print '<div class="boxtext SrhBoxS" style="bottom:29px;color:#add8e6;">'.SockCmdversion().'</div>';
	print '<input type="button" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" style="top:'.($heigh).'px;" />';
	print '<div class="SrhBoxL" style="position:absolute;bottom:10px;left:4px">'."(C)2023 by Mikio Shiratori".'</div>';
	print '</div>';
	ob_flush();
	flush();

	print <<< EOM
<style>
.h3 { line-height: 0.7;font-size:13px; }
.p1 { line-height: 1.2;word-wrap:break-word; }
</style>
<div id="{$idinfo}" class="box" style="position:fixed;top:48px;left:20px;width:440px;height:280px;background-color:#ffffff;">
<div class="boxtitle" style="width:420px;line-height:80%;">How PLSPlaylist works</div>
<div style="position:absolute;top:20px;left:10px;color:#000000;font-size:13px;">
<h3 class="h3">Function:Current configuration XMLFile</h3>
<p class="p1" style="color:#006400;font-weight: bold;">./{mpdweb}/{$XML_PlaylistPLS}</p>
<h3 class="h3">PLSPlaylist Setting</h3>
<p class="p1">When doing moOdea settings, please copy mpdweb_playlist.xml and use it as mpdweb_playlist_myset.xml</span></p>
<p class="p1" style="color:#b22222;font-weight: bold;font-size:12px;">If there is mpdweb_playlist_myset.xml, use it with priority.</span></p>
<h3 class="h3">When using moOdeAudio's .pls (broadcast)</h3><!-- ' -->
<p class="p1">If using moOdeAuio .pls mpdweb_playlist.xml.moodeaudioPlease use it as mpdweb_playlist_myset.xml.</span></p>

</div>
<button onClick="RequestBoxtUnLoad('{$idinfo}');" class="buttn boxbcan" style="top:250px;background-color:#dcdcdc;border:1px solid #333333;">Cancell</button>
</div>
EOM;


	}
/* -----------------------------------------------------------------------------
	DispPlaylistPLSDT($file,fav): DisplaylistPLS Function Display
	 $file  : i  : pls file
	 $fav   : i  : HTML-id Favorite (Main PLS,HTML)
----------------------------------------------------------------------------- */
function DispPlaylistPLSDT($file,$fav="") {
	global $XML_PATH,$XML_DETAILE;

	$id="grpPLSDTL";
	if($file=="off") {										// Make Space Box
		print '<div id='.$id.' class=box style="position:fixed;top:100px;left:10px;border:1.5px solid #a9a9a9;width:450px;height:10px;background-color:100;" ></div>';
		}
	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';

	$field=array("pls","Art","File","tag","Title","Length","NumberOfEntries","Version","Favorite");
	$output=pls_read($XML_PATH["Directory"],$field,$XML_PATH["ARTPath"],$file,$urlary);

	$boxheight=160;$dtlheight=0;
	if (isset($output["File"][0])) {
		$dtlheight=count($output["File"][0]);
		if($dtlheight > $XML_DETAILE["DTLNO"]) { $dtlheight=$XML_DETAILE["DTLNO"]; }
		$dtlheight=$dtlheight*55;
		}
	$boxheight=$dtlheight+$boxheight;

	print '<div id='.$id.' class=box style="position:fixed;top:100px;left:10px;border:1px solid #808080;width:450px;height:'.$boxheight.'px;background-color:#000000;" >';
	print '<div class=boxtitle style="line-height:100%;border:0;width:430px;border:1px solid #a9a9a9" >PLS - Playlist&nbsp;:&nbsp'.$file.'</div>';
// Header
	print '<div class=PLSBOXT id="idPLSDTLFile" style="width:340px;">'.$file.'</div>';
	if (isset($output["Art"][0])) {
		 print '<div class=PLSBOXT style="left:360px;font-size:11px;width:78px;height:78px;">';
		 $clip="";
		 ArgImageSize($output["Art"][0],"76:fix","Album",$imgwidth,$imghigth,$clip);
		 $style="";if (!is_null($clip)) { if ($clip !== "") { $style='style="'.$clip."margin:-20px 0px 0px 0px;".'"'; } }
		 print '<img src="'.$output["Art"][0].'" alt="" width='.$imgwidth.' height='.$imghigth.' border="0" '.$style.' />';
		 print '</div>';
		 }
	else {
		 $str= "No Image";
		 print '<div class=PLSBOXT style="left:360px;font-size:11px;width:80px;height:78px;">';
		 print '<p style="font-size:10px;width:76px;height:76px;line-height:60px;text-align:center;">'.$str.'</p>';
		 print '</div>';
		 }
	print '<div class=PLSBOXT style="top:68px;width:60px;background-color:#070707;">Version</div>';
	print '<div class=PLSBOXT style="top:68px;left:76px;width:60px;text-align:center;color:#00ff7f;">';
	if(isset($output["Version"][0])) { print $output["Version"][0]; }
	print '</div>';
	print '<div class=PLSBOXT style="top:68px;left:144px;width:120px;background-color:#070707;">NumberOfEntries</div>';
	print '<div class=PLSBOXT style="top:68px;left:270px;width:80px;text-align:center;color:#00ff7f;">';
	$no=0;
	if (isset($output["NumberOfEntries"][0])) { print $output["NumberOfEntries"][0];$no=intval($output["NumberOfEntries"][0]); } else { print '&nbsp;&nbsp;'; }
	if (isset($output["File"][0])) {
		if (($no==0)||(count($output["File"][0]) !==$no)) {
			print '&nbsp;&nbsp;('.(count($output["File"][0])).')';
			}
		}
	print '</div>';
	print '<div class=PLSBOXT style="top:92px;width:60px;background-color:#070707;">Favorite</div>';
	$js="DisplayFavorite('idPLSDTLFile','".$fav."');";
	print '<div class=PLSBOXT id=frFavVal onclick="'.$js.'" style="top:92px;left:76px;width:60px;text-align:center;background-color:#404040;color:#00ff00;cursor:pointer">';
	if(isset($output["Favorite"][0])) { print $output["Favorite"][0].'Fav'; }
	print '</div>';
	print '<input type="button" value="Close" onclick="'.$unload.'" class="buttn boxbcan" style="position:absolute;right:10px;top:'.($boxheight-26).'px" />';

	print '<div style="position:absolute;top:124px;left:8px;height:'.$dtlheight.'px;overflow-y:scroll;">';
	print '<table border="3" id="grpPLSList" cellpadding="0" bgcolor="#070707" frame=void style="table-layout:fixed;">';
	foreach ($output["File"][0] as $key => $val) {
		$iddtfile="idPLSDtF".$key;$iddttitle="idPLSDtT".$key;
		print '<tr>';
		print '<td rowspan="2">';
		print '<div class="PLSBOXD" style="width:36px;">'.$output["tag"][0][$key].'</div>';
		print '</td>';
		print '<td><div id='.$iddtfile.' class="PLSBOXD" style="width:310px;">'.$val.'</div></td>';
		$play = "RequestPostPLSAdd('AddPlay','file','".$val."');RequestLoadDisp(1);";		// Play Button
		print '<td><button type=submit class="music PLSPBTN" onclick="'.$play.'">Play</button></td>';
		$js='DisplayPLSDTFunc(\''.$iddttitle.'\',\''.$iddtfile.'\');';
		print '<td rowspan="2"><button type=submit class="music bfunc" onclick="'.$js.'" >...</button></td>';
		print '</tr>';
		print '<tr>';
		print '<td><div id='.$iddttitle.' class="PLSBOXD" style="width:310px;color:#90ee90;">';
		if(isset($output["Title"][0][$key])) { print $output["Title"][0][$key]; }
		print '</div>';
		print '<td><div class="PLSBOXD" style="width:33px;text-align:center;">';
		if(isset($output["Title"][0][$key])) {
			 if($output["Length"][0][$key] <= 0) {
				  print '-</div>';
				  }
			 else {
				  print $output["Length"][0][$key].'</div>';
				  }
			 }
		print '</tr>';
		print '</tr>';
		}
	print '</table>';
	print '</div>';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DisplaylistPLSDTLFunc(): DisplaylistPLS Function Display
	 $playlist : i  : PLSPlaylist FileName
	 $id       : i  : HTML-id
	 $file     : i  : StormingURL / FilePath
	 $top      : i  : Box Position:Top
	 $left     : i  : Box Position:Left
----------------------------------------------------------------------------- */
function DisplaylistPLSDTLFunc($top=200,$left=170) {
	$id="fnPLSDBox";
	$idtitle="fnPLSDBoxT";
	$idfile ="fnPLSDBoxF";
	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	$heigh=28*7;
	$file="file=document.getElementById('".$idfile."').textContent;";
	$titile="title=document.getElementById('".$idtitle."').textContent;";
	$post  = $file."RequestPostPLSAdd('add','file',file);";			// Post String PlaylistAdd
	$clear = $file."RequestPostPLSAdd('ClearAdd','file',file);";	// Post String Playlist Clear&Add
	$play  = $file."RequestPostPLSAdd('AddPlay','file',file);";		// Post String Playlist Clear&Add&play

	print '<div id='.$id.' class=box style="position:fixed;top:'.$top.'px;left:'.$left.';height:'.($heigh+28).'px;">';
	print '<div id='.$idtitle.' class=boxtitle></div>';
	print '<button type=submit onClick="'.$post.$unload.'" class="boxline boxblin1">Add Playlist</button>';
	print '<button type=submit onClick="'.$clear.$unload.'" class="boxline boxblin2">Add and replace</button>';
	print '<button type=submit onClick="'.$play.$unload.'" class="boxline boxblin3">Add and replace and play</button>';

	$post=$titile.$file.'mysrc=document.getElementById(\'PLSRadioSrc\');mysrc.setAttribute(\'src\',file);document.getElementById(\'PLSRadioVal\').textContent=title;RequestBoxDisp(\'PLSRadio\');';
	print '<button type=submit onclick="'.$post.$unload.'" class="boxline boxblin5">Play Radio (This terminal)</button>';
	print '<input type="button" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" style="top:'.($heigh).'px;" />';

	print '<div id='.$idfile.' style="position:absolute;bottom:20px;height:5px;width:3px;overflow:hidden;font-size:10px;color:#2f2f2f;">/div>';

	print '</div>';
	}

/* -----------------------------------------------------------------------------
	pls_read($directory,$field,$artpath,$search,$urlary,$sort,$query) : Make PLS Directory Array
	 $directory: i  : PLS Directory
	 $field    : i  : Tag Filed
	 $artpath  : i  : 画像Path WebPath下に配置 指定しない場合,""|NULL
	 $search   : i  : 検索Path "":All , WildCard可
	 $urlary   : iO : 逆引き配列  $urlary[URL]:FileName
	 $sort     : i  : Sort on:大文字/小文字区別しない
	 $query    : i  : 0:Use HTML / 1:Make ImageArry($imgary)
	 @return   : o  : $query=0: $output, PLS Array 
	                         1: $imgary  $imgary[Imagefile]:PLSFile
	※ $field: Max "pls","Art"."File","tag","Title","Length","NumberOfEntries","Version","Favorite"
	           "pls":FileName,"tag":File TagNameはファイル行を示すため無条件で作成する。
	           "Art":画像ファイル:$fieldに"Art"が在り、$artpathが指定された場合に有効
	           "Favorite":mpdweb拡張としてお気に入りを追加
	$output Array
	 $output["pls"]    [i]  :pls File Name
	 $output["File"]   [i][]:Playlist File (URL) 1 File複数
	 $output["{filed}"][i][]:FIled 1 File複数

	※$XML_HOST/$XML_WEBが必要 GetEnvPlaylistPLS()で作成しておく
	pls_read()/pls_Sockexec():$XML_HOST[Host]設定時
	  $XML_HOST= Host/Port/Timeout/Accunt/TermStr
	pls_ArtPath()/pls_ArtURL()
	  $XML_WEB=DOCROOT/WEBPath/ImgExtend
----------------------------------------------------------------------------- */
function pls_read($directory,$field=array(),$artpath="",$search="",&$urlary=null,$sort="",$query=0) {
	global $XML_HOST,$XML_WEB,$XML_SHMPLS,$XML_DETAILE;

	$sfiled=array("NumberOfEntries","Version","Favorite");						// OneFile1個の項目
	if ((!is_array($field))||(count($field)==0)) {					// Filed 省略時Max
		$field=array("pls","Art","File","tag","Title","Length","NumberOfEntries","Version","Favorite");
		}
	$ArtMode="";
	if (($artpath =="")||(is_null($artpath ))) { } else {	// ArtMode指定
		if (in_array("Art",$field)) {						// ArtPathが指定,$field:Artが設定されているときArtMode
			$ArtMode="1";
			}
		}
	$EXTEND="*.pls";
	$output=array();
	if ($search == "") {
		 $str=$EXTEND;
		 }
	else {
		 $str='"'.$search.'"';
		 }
	$directory=rtrim($directory,"/")."/";
	$artpath=rtrim($artpath,"/")."/";
	$command='grep -H "" '.$directory.$str;					// [.pls] List {Fileame}:{Line}
// PLSFile Get
	$shmary=False;											// Shared Memoroy off時/ No Array時 False
	if ($XML_SHMPLS["Used"] =="on") {
		 SHM_PLSProj("PlaylistPLS");						// Shared Memoroy Project 
		 $shmary=SHM_PLSGet("FiledPLS");					// Shared Memoroy Get
		 }
	if (!$shmary) {
		 if (($ArtMode=="1")||($XML_SHMPLS["Used"] =="on")) {	// SharedMemoryModeのときは,ArtFileを対象にする
			$XML_WEB["WEBPath"]=rtrim($XML_WEB["WEBPath"],'/');
			$path=str_replace("%DOCUMENT_ROOT%",$XML_WEB["DOCROOT"],$artpath);		// DocRootを置換
			$path=rtrim($path,"/")."/*";
			if ($search !== "") {
				$str=pathinfo($search,PATHINFO_FILENAME);
				$path=$path.'/"'.$str.'"*';
				}
			$command=$command.";echo [Path_Image];find ".$path." -maxdepth 1 -type f -exec basename {} \\;";
			}
		 if ((isset($XML_HOST["Host"]))&&($XML_HOST["Host"] !=="")) {
			 $result=pls_Sockexec($command."\n");
			 if(!is_array($result)) { return($result); }
			 }
		 else {
			 exec($command,$result);
			 }
		 }
	else {
		 $result=$shmary;
		 }
	$plsary=array();
	$imgary=array();
	$point = array_search('[Path_Image]',$result);
	if ($point !==false) {
		 $plsary=array_slice($result,0,$point);
		 $tmpary=array_slice($result,$point);
		 $imgary=_pls_MakeArtArray($tmpary);
		 }
	else {
		 $plsary= $result;
		 }
	if($search !== "") {
		$plsary=_pls_MakePLSArray($plsary,$directory,$search);
		}

	if ((!is_array($plsary))||(count($plsary)) ==0) { } else {
		$plsary=_pls_SortArray($directory,$plsary,$XML_DETAILE["SortExc"],$sort);
		$i=0;$pls="";
		foreach($plsary as $idx => $line) {
			$ary=explode(":",$line,2);
			if (isset($ary[1])) {
				$a=explode("=",$ary[1],2);							// pls Format {Tag}={Data}
				if (!isset($a[1])) { continue; }
				}
//			print "[".$idx ."][".$ary[0]."]".$ary[1]."<BR>";
			if ($pls !== $ary[0]) {
				if ($pls !="") { $i=$i+1; }
				$str=str_replace($directory,"",$ary[0]);			// FileName Edit
				$str = trim($str,"/");
				$output["pls"][$i]=$str;
				if ($ArtMode=="1") {								// ArtMode
					$artfile=pls_ArtPath($imgary,$artpath,$str);			// Pathから画像をGet
					if($artfile) {
						$output["Art"][$i]=$artfile;
						}
					}
				$pls=$ary[0];
				}
			foreach($field as $key => $val) {
				if(stripos($a[0],$val) === 0){						// Filedが含まれているか
					if (in_array($val,$sfiled)) {						// OneFile1個の項目
						 $output[$val][$i]=$a[1];
						 }
					else {
						 $output[$val][$i][]=$a[1];						// OneFile複数個の項目
						 if($val=="File") {
						 	$output["tag"][$i][]=$a[0];				// FileのTagNameを設定
							}
						 }
					if(isset($urlary)) {							// $urlaryが指定されたとき逆引き配列を作成
						if($val=="File") {
							$str=str_replace($directory,"",$ary[0]);
							$urlary[$a[1]]=$str;					// $urlary[URL]:FileName
							}
						}
					break;
					}
				}
			}
		}

	if (($XML_SHMPLS["Used"] =="on")&&($search=="")&&(!$shmary)) {
		$ret=SHM_PLSPut($result);					// Shared Memory Put
		}
	if($query ==1) {
		return($imgary);
		}
	return($output);
	}

/*
	_pls_SortArray($directory,$inary,$exclusion,$sort) :  Table Sort
	 $directory: i  : Mask String(先頭の不要部カット)
	 $inary    : i  : Input Array
	 $exclusion: i  : Sort除外String(定冠詞) "The ,..." ,でセパレート
	 $sort     : i  : on:大文字/小文字区別しない
	 @return   : o  : Output Array
	 ライブラリのSortと構造が違うのでPLS専用TableSort
*/
function _pls_SortArray($directory,$inary,$exclusion="",$sort="on") {
	if ($sort=="on") {
		$exclusion=strtoupper($exclusion);				// 大文字/小文字区別しない
		}
	$excary=explode(",",$exclusion);					// Sort除外String","で分離
	$ary=array();
	$result=array();
	foreach($inary as $key => $val) {
		$tmp=explode($directory,$val);
		$str="";
		if(isset($tmp[1])) { $str=$tmp[1]; }
		if ($sort=="on") {								// 大文字/小文字区別しない
			$str=strtoupper($str);
			}
		$str=str_replace($excary,"",$str);				// Sort除外StringでMask
		if(isset($ary[$str])) { $str=$str.$key; }
		$ary[$str]=$key;								// SortStringをKeyにセット
		}
	ksort($ary);										// KeySort
	foreach($ary as $key => $val) {
		$result[]=$inary[$val];							// Sort順に再配列
		}
	return($result);
	}

/*
	_pls_MakePLSArray($plsary,$directory,$search) :  Search(File)から対象のArrayを作成
	 $plsary   : i  : PLS Array (grep -H "")
	 $directory: i  : PLS Directory
	 $search   : i  : 検索PLSFile
	 @return   : o  : Search FileArray
*/
function _pls_MakePLSArray($plsary,$directory,$search) {
	$ary=array();
	foreach($plsary as $val) {
		$pattern = '/' . preg_quote($directory, '/') . '/i';
		$str=preg_replace($pattern,'',$val,1);
		if (stripos($str,$search) === 0)  {
			$ary[]=$val;
			}
		}
	return($ary);
	}

/*
	_pls_MakeArtArray($imgary) :  FileNameから画像Pathを取得Array
	 $imgary   : i  : 画像Path Array (FullPath)
	 @return   : o  : Art FilePath Array
*/
function _pls_MakeArtArray($imgary) {
	$ary=array();
	foreach($imgary as $val) {
		$ary[$val]="";
		}
	return($ary);
	}

/*
	pls_ArtPath($imgary,$artpath,$file) :  Pathから画像Get
	 $imgary   : i  : 画像Path Array (FullPath)
	 $artpath  : i  : 画像Path WebPath下に配置
	 $file     : i  : FileName(Directory除く)
	 @return   : o  : Art FilePath
*/
function pls_ArtPath($imgary,$artpath,$file) {
	global $XML_WEB,$XML_NETMASK;

	$result=null;
	if (!Commn_Subnet($XML_NETMASK['artmask'],$_SERVER['REMOTE_ADDR'])) { return($result); }
	$XML_WEB["WEBPath"]=rtrim($XML_WEB["WEBPath"],'/');								// Web用のPathを生成
	$XML_WEB["DOCROOT"]=rtrim($XML_WEB["DOCROOT"],'/');								// Web用のRootを生成
	$filename=pathinfo('\\'.$file,PATHINFO_FILENAME);			// setlocale(LC_ALL,ja_JP.UTF-8)を明記セットしても日本語から始まるファイル名は日本語が無くなる。
	$filename=trim($filename,'\\');								// (*1)ファイル名にできない\\を先頭にセットして取り合えず回避した
	$path=str_replace("%DOCUMENT_ROOT%",$XML_WEB["DOCROOT"],$artpath);				// DocRootを置換
	$filename=rtrim($path,"/")."/".$filename;
	$base=pathinfo('\\'.$file,PATHINFO_FILENAME);									// BaseNameから画像Pathを逆引き
	$base=trim($base,'\\');										// (*1)ファイル名にできない\\を先頭にセットして取り合えず回避した
	foreach($XML_WEB["Extend"] as $val) {
		if (isset($imgary[$base.".".$val])) {
			$result=$filename.".".$val;
			$result=str_replace($XML_WEB["DOCROOT"],$XML_WEB["WEBPath"],$result);	// WebRootを置換
			break;
			}
		}
	return($result);
	}

/* -------------------------------------------------------------------------------
	pls_ArtURL($url,$base) : URL & PLS Directory から画像Get
	 $url     : i  : URL
	 $base    : io : URLのFile basename PLS FileのBasename
	 @return  : o  : Art FilePath
-------------------------------------------------------------------------------*/
function pls_ArtURL($url,&$base="") {
	global $XML_WEB,$XML_PATH,$XML_NETMASK,$XML_SORTBASE,$XML_SHMPLS;

	$result=null;
	if (!Commn_Subnet($XML_NETMASK['artmask'],$_SERVER['REMOTE_ADDR'])) { return($result); }
	$field=array("pls","Art","File","tag","Title","Length","NumberOfEntries","Version","Favorite");
	$directory=rtrim($XML_WEB["WEBPath"],'/')."/";					// ArtPathを生成
	$artpath=rtrim($XML_PATH["ARTPath"],"/");						// Web用のPathを生成
	$docroot=rtrim($XML_WEB["DOCROOT"],"/");						// Web用のRootを生成
	$urlary=array();
	$imgary=pls_read($XML_PATH["Directory"],$field,$artpath,"",$urlary,$XML_SORTBASE["Sort_Capital"],1);
	if(isset($urlary[$url])) {
		$filename=pathinfo('\\'.$urlary[$url],PATHINFO_FILENAME);	// setlocale(LC_ALL,ja_JP.UTF-8)を明記セットしても日本語から始まるファイル名は日本語が無くなる。
		$filename=trim($filename,'\\');								// (*1)ファイル名にできない\\を先頭にセットして取り合えず回避した
		$path=str_replace("%DOCUMENT_ROOT%",$docroot,$artpath);		// DocRootを置換
		$imagepath=rtrim($path,"/")."/".$filename;
		foreach($XML_WEB["Extend"] as $val) {
			if (isset($imgary[$filename.".".$val])) {
				$result=$imagepath.".".$val;
				$result=str_replace($docroot,rtrim($directory,"/"),"/".trim($result,"/"));		// WebRootを置換
				break;
				}
			}
		if ((isset($base))&&($result)) {
			$base=$filename;
			}
		if ($XML_SHMPLS["Used"] =="on") {							// 速度優先より，ShredMemory使用しタイトルを取得する
			$output=pls_read($XML_PATH["Directory"],$field,$artpath,$filename,$urlary);
			if(is_array($output)) {
				foreach($output["File"][0] as $key => $val) {
					if($val==$url) {								// URLが一致するTitleを使用する
						if (isset($output["Title"][0][$key])) {
							$base=$output["Title"][0][$key];
							break;
							}
						}
					}
				}
			}
		}
	return($result);
	}

/* -------------------------------------------------------------------------------
	pls_Sockexec($cmd) : Exec Command Net Taskserver (Network)
	 $cmd      : i  : Command
	 @return   : o  : Normal Array , Error String
-------------------------------------------------------------------------------*/
function pls_Sockexec($cmd) {
	global $XML_HOST;

	$errno="";$errstr="";$mode=0;
	$ary=SockCmdsend($XML_HOST["Accunt"],$cmd,$XML_HOST["Host"],$XML_HOST["Port"],$XML_HOST["Timeout"],$XML_HOST["TermStr"],$mode,$errno,$errstr);
	if ((is_array($ary))&&(bin2hex($ary[(count($ary))-1])=="1b")) {
		unset($ary[count($ary)-1]);
		}
	if ((!is_array($ary))&&($errstr!=="")) {
		$ary="Task Exec Error(".$errno.") ".$errstr;
		}
	return($ary);
	}

/*  MoOdeAudio
	  Image       : /var/local/www/imagesw/radio-logos
      plsPlaylist : /var/lib/mpd/music/RADIO/
	  Title と画像はLinkしている
	mpd Playlist:URLを取得 / Titleは再生都度変わる
*/

/* ----- Shared Memory Extend Library- -------------------------------------------
	Shared Memory Extend Library : 
	SHM_PLSProj($pjname="",$compel="") : Get Projcst
	 $pjname : i  : All:""  or ProjctName:Projct Delete
	 $compel : i  : "":通常モード "del":強制削除
	※ $XML_SHM[$share] ["Proj"]:Project,["Size"]:Size,["Life"]:Life Sec
	   mpdweb.lib_mpdshm.phpと構成を同じにしておく。但し,Commonを削除しない。
	Linux上で確認は $ ipcs -m
-------------------------------------------------------------------------------*/
function SHM_PLSProj($pjname="",$compel="") {
	global $XML_SHMPLS,$XML_SHMEXTEND,$XML_SHM;

	if ((!isset($XML_SHMEXTEND)) || (!is_array($XML_SHMEXTEND))) {	// $XML_SHMEXTEND(設定配列)があれば再度行わない
		$XML_SHMEXTEND["Source"]=array("Common"=>"0,,128,43200,gzcompress,gzuncompress,9","PlaylistPLS"=>"6,,20000,43200,gzcompress,gzuncompress,9");
		$keep=$XML_SHMEXTEND["Source"];
		foreach($keep as $key => $val) {							// 省略時の初期値のためKeep
			$part=explode(",",$val);
			$keep[$key]=$part;
			}
		foreach($XML_SHMEXTEND["Source"] as $key => $val) {
			if (isset($XML_SHMPLS[$key])) {
				$XML_SHMEXTEND["Source"][$key]=$XML_SHMPLS[$key];
				}
			}
		foreach($XML_SHMEXTEND["Source"] as $key => $val) {
			if ($val=='') { unset($XML_SHMEXTEND[$key]);continue; }	// <Shm_Project><Art></Art>の設定は使用しない扱い
			$pshm=explode(",",$val);
			$XML_SHMEXTEND[$key]["Proj"]=trim($pshm[0]);			// Key:Project Name :Project Code
			$XML_SHMEXTEND[$key]["Size"]=0;							// Project Size
			$XML_SHMEXTEND[$key]["Life"]="";							// Life Sec "":永続
			$XML_SHMEXTEND[$key]["Enc"]=$keep[$key][4];				// 省略時の初期値 Encoder
			$XML_SHMEXTEND[$key]["Dec"]=$keep[$key][5];				// 省略時の初期値 DEcorder
			$XML_SHMEXTEND[$key]["Comp"]=$keep[$key][6];				// 省略時の初期値 Compress
			if (isset($pshm[1])) { $XML_SHMEXTEND[$key]["Path"]=$pshm[1]; }
			if($compel != "del") {
				if (isset($pshm[2])) { $XML_SHMEXTEND[$key]["Size"]=$pshm[2]; }
				}
			if (isset($pshm[3])) { $XML_SHMEXTEND[$key]["Life"]=$pshm[3]; }
			if (isset($pshm[4])) { $XML_SHMEXTEND[$key]["Enc"] =$pshm[4]; }
			if (isset($pshm[5])) { $XML_SHMEXTEND[$key]["Dec"] =$pshm[5]; }
			if (isset($pshm[6])) { $XML_SHMEXTEND[$key]["Comp"]=$pshm[6]; }
			if (!function_exists($XML_SHMEXTEND[$key]["Enc"])) { $XML_SHMEXTEND[$key]["Enc"]="";$XML_SHMEXTEND[$key]["Dec"]=""; }	// Encodeモジュールなし
			if (!function_exists($XML_SHMEXTEND[$key]["Dec"])) { $XML_SHMEXTEND[$key]["Enc"]="";$XML_SHMEXTEND[$key]["Dec"]=""; }	// Decodeモジュールなし
			if (($XML_SHMEXTEND[$key]["Size"]==0)&&($XML_SHMEXTEND[$key]["Proj"]!=="")) {	// <{ProjectName}>{Project}</{ProjectName}>形式 (例) <List>1</List>)
				$id = new Shm_Common($XML_SHMEXTEND[$key]["Proj"]);							//   Shared Memory Delete (リークしないように削除方法を組み込んでおく)
				if ((isset($XML_SHMEXTEND[$key]["Path"]))&&($XML_SHMEXTEND[$key]["Path"] !== "")) {
					$id->shm_const['path']=$XML_SHMEXTEND[$key]["Path"];
					}
				$id->shm_open();
				if($key !== "Common") {
					$id->shm_delete();								// Size 0byte指定時は初期時点でShared Memoryを作らない。(途中で設定を変えた場合)
					}
				$id->shm_close();
				unset($XML_SHMEXTEND[$key]);
				}
			}
		$XML_SHM=$XML_SHMEXTEND;			// mpdweb.lib_mpdshm.phpと構成を合わせる(現在下階層のLibraryを使用しているので効果はない)。
		}
//SHM_PLSUnlink();			// 強制的にSharedMemoryを削除
//print '<BR><BR><BR><BR><BR><BR>$XML_SHMEXTEND '.$pjname."<BR>";
//TblDump('$XML_SHMEXTEND',$XML_SHMEXTEND);
	}

/* -------------------------------------------------------------------------------
	SHM_PLSGet($key,$count,$flags,$mode) : Used Command Shared Memory ListArt Get
	 $key    : i  : Shared Memory ,Used User Application Key
	 $count  : i  : The number of bytes to read 
	 $flags  : i  : "a":ReadOnly / "c":Creat / "w":Read/Write / "n":新規メモリセグメントの作成用
	 $mode   : i  : Permission
	 @return : o  : Mpd Output Array , or False on failure.
	※ Shared Memory : |delim|filedArt|array|{str array}...|Eof|
------------------------------------------------------------------------------- */
function SHM_PLSGet($key="FiledPLS",$count=NULL,$flags="c",$mode=0644) {
	global $XML_SHMEXTEND;

	$ret=False;$time=0;
	$SHMIDLART = new Shm_Common($XML_SHMEXTEND["PlaylistPLS"]["Proj"],$XML_SHMEXTEND["PlaylistPLS"]["Size"]);	// Open 識別子を$SHMID[$pjname]に格納
	if ((isset($XML_SHMEXTEND["PlaylistPLS"]["Path"]))&&($XML_SHMEXTEND["PlaylistPLS"]["Path"] !== "")) {
		$SHMIDLART->shm_const['path']=$XML_SHMEXTEND["PlaylistPLS"]["Path"];
		}
	if (($SHMIDLART->shm_open($flags,$mode)) === False) {
		 $SHMIDLART=False;
		 return(False);
		 }
	$buff = $SHMIDLART->shm_read(NULL,0);
	$SHMIDLART->shm_close();
//print "Get[".$buff."]<BR>";
	$array="";
	$bufb=explode('|Eof|',$buff);	
	$buf=explode('|delim|',$bufb[0]);	
	foreach($buf as $bu) {
		$spre=explode('|array|', $bu);	// Key部と分離
		if ($spre[0]==$key) {			// 対象Array
			if (isset($spre[1])) {
				$gzip=$spre[1];
				if ($XML_SHMEXTEND["PlaylistPLS"]["Dec"] !== "") {
					$dec_func=$XML_SHMEXTEND["PlaylistPLS"]["Dec"];	// Decoder Module
					$dec_arg[]=$gzip;
					$json=@call_user_func_array($dec_func,$dec_arg);	// 関数にすると結果がとれない(深いところでMemoryが取れない?)
					if ($json===false) { return(false); }
						 }
					else {
						 $json=$gzip;									// Encoder/Decoder Moduleがないとき
						 }
				if ($json===false) { return(false); }
				$array = json_decode($json,true);
				$ret=$array;
				}
			}
		if ($spre[0]=="Time") {			// Make Time
			$time=$spre[1];
			}
		}
	$now=(string)time();												// 有効時間以上は,SharedMemory Unlink
	$def=$now - $time;
	if ($def > $XML_SHMEXTEND["PlaylistPLS"]["Life"]) {
		SHM_PLSUnlink();
		$ret=False;
		}
//SHM_PLSUnlink();
//$ret=False;
	return($ret);
	}

/* -------------------------------------------------------------------------------
	SHM_PLSPut($array,$flags,$mode) : Used Command Shared Memory ListArt Put
	 $Array  : i  : Shared Memory Output Array
	 $flags  : i  : "a":ReadOnly / "c":Creat / "w":Read/Write / "n":新規メモリセグメントの作成用
	 $mode   : i  : Permission
	 @return : o  : The size of the written data, or FALSE on failure.
	※ Shared Memory : |delim|{filedArt|array|{str array}...|Eof|
	  CommandはMemoryサイズが大きくなるか、汎用的またmpdのI/F重視し受信内容をそのまま配列化しておく
------------------------------------------------------------------------------- */
function SHM_PLSPut(&$array,$flags="c",$mode=0644) {
	global $XML_SHMEXTEND;

	if((!is_array($array))||(count($array)==0)) {			// 書き込み内容がないときSharedMemory削除
		SHM_PLSUnlink();
		return(False);
		}
	$SHMIDLART = new Shm_Common($XML_SHMEXTEND["PlaylistPLS"]["Proj"],$XML_SHMEXTEND["PlaylistPLS"]["Size"]);	// Open 識別子を$SHMID[$pjname]に格納
	if ((isset($XML_SHMEXTEND["PlaylistPLS"]["Path"]))&&($XML_SHMEXTEND["PlaylistPLS"]["Path"] !== "")) {
		$SHMIDLART->shm_const['path']=$XML_SHMEXTEND["PlaylistPLS"]["Path"];
		}
	if (($SHMIDLART->shm_open($flags,$mode)) === False) {
		 $SHMIDLART=False;
		 return(False);
		 }
	$gzip=_SHM_PLSCompress($array);
	if(strlen($gzip) > (int)$XML_SHMEXTEND["PlaylistPLS"]["Size"]) {
		$Reduct=strlen($gzip) - (int)$XML_SHMEXTEND["PlaylistPLS"]["Size"];
		$tmpary=_SHM_PLSReduct($array,$Reduct);
		$gzip=_SHM_PLSCompress($tmpary);
		}
	$time=(string)time();
	$buf="|delim|FiledPLS|array|".$gzip."|delim|Time|array|".$time."|Eof|";
//print "Put".$buf."<BR>";
	$ret=$SHMIDLART->shm_write($buf,0);						// Shared Memory Write
	$SHMIDLART->shm_close();
//print '<BR><BR><BR><BR><BR><BR><BR>$ret['.$ret."]<BR>";
	return($ret);
	}

/*
	_SHM_PLSCompress($array) : Shared Memory Compress
	 $Array  : i  : Shared Memory Output Array
	 @return : o  : Shared Memory Compress
	設定ファイルの指定($XML_SHMEXTEND["Enc"]/["Comp"])で圧縮する
*/
function _SHM_PLSCompress($array) {
	global $XML_SHMEXTEND;

	$json = json_encode($array);
	if ($XML_SHMEXTEND["PlaylistPLS"]["Enc"] !== "") {
		 $enc_func  =$XML_SHMEXTEND["PlaylistPLS"]["Enc"];		// Encoder Module
		 $enc_arg[0]=$json;
		 $enc_arg[1]=$XML_SHMEXTEND["PlaylistPLS"]["Comp"];		// Compress度
		 $gzip=@call_user_func_array($enc_func,$enc_arg);
		 }
	else {
		 $gzip=$json;										// Encoder/Decoder Moduleがないとき
		 }
	return($gzip);
	}

/*
	_SHM_PLSReduct($array,$Reduct) : Shared Memory Reduction
	 $Array  : i  : Shared Memory Output Array
	 $Reduct : i  : Size of Reduction
	 @return : o  : Shared Memory Reduction
	※Shared Memory 設定サイズを超えたときの削除
	  再圧縮時レスポンスが低下する。DirectoryPath長，Tag長にもよるが
	  720Artis/Path長40Byteで約14Kなのでデフォルト2M(2000K)Byte確保で不足時Tag整理をした方が良い
*/
function _SHM_PLSReduct($array,$Reduct) {
	$resary=array_column_extend($array,"","time","val","-%04d");
	ksort($resary);
	$str="";$cnt=0;
	$rsize=$Reduct/1.6;										// 1.6倍圧縮率として(正確の必要性より)
	foreach($resary as $idx =>$ary) {
		$str=$str.(json_encode($ary));
		unset($resary[$idx]);
		$cnt=$cnt+1;
		if (strlen($str) > $Reduct) {
//			print "Unlink(".$cnt.")strlen(".strlen($str).")<BR>";
			break;
			}
		}
//	TblDump('$resary',$resary,"");
	return($resary);
	}

/* -------------------------------------------------------------------------------
	SHM_PLSUnlink() : Used Command Shared Memory ListArt Unlink
------------------------------------------------------------------------------- */
function SHM_PLSUnlink() {
	global $XML_SHMEXTEND;

	$id = new Shm_Common($XML_SHMEXTEND["PlaylistPLS"]["Proj"]);
	if ((isset($XML_SHMEXTEND["PlaylistPLS"]["Path"]))&&($XML_SHMEXTEND["PlaylistPLS"]["Path"] !== "")) {
		$id->shm_const['path']=$XML_SHMEXTEND["PlaylistPLS"]["Path"];
		}
	$id->shm_open();
	$id->shm_delete();
	$id->shm_close();
	}
//----- Source End --------------------------------------------------------------
?>
