<?php
/***************************************************************************************
	mpdframe.php : Make Frame Library PHP JS
	 Function 
	  FrmView_Init()   : Initialize 
	  FrmView_Create() : Frame ViewCreate

	※ 起点となるHistoryStateを書き込み起点とする。
	  ・window.addEventListener('popstate')で起点を監視し,再度イニシャライズ
	   resize:JQueryをAddさせて使用可にした場合,Resize可能になる
	  ・window.addEventListener('resize')でResize

	Frame位置サイズを指定
	  require_once("./mpdweblink/mpdframe.php");
	  $top=60;$left=2;$width=474;$height=640;$fldary = compact("top","left","width","height");
	  FrmView_Init("html",$fldary);
************************************************************************************** */
$_FILE_=GetMyHome();
$require_mod=$_FILE_.'/mpdweb.lib.php';						// mpd Application Library
require_once($require_mod);									// Mpd : Original Library mpdwen.lib.php
$require_api=$_FILE_.'/mpdweb.lib_appli.php';				// mpd Application Library
require_once($require_api);									// Mpd : Original Library mpdwen.lib.php
global $FRAME_VERSION;$FRAME_VERSION=basename(__FILE__)." 1.2 (01.03.2024)";

/* -----------------------------------------------------------------------------
	GetMyHome() :Get My HomePath
	 @return : o  : HomePath
----------------------------------------------------------------------------- */
function GetMyHome() {
	$path=rtrim(dirname($_SERVER['DOCUMENT_ROOT'].$_SERVER['REQUEST_URI']),"/");	// RequestPath
	$mypath=rtrim(dirname(__FILE__),"/");											// 自ModulePath
	if ($path !== $mypath) {							// RequestPathと自ModulePathが違えば,
		 $_FILE_=$path;									// $_FILE_ : RequestPathに共通Libraryがある
	 	}
	else {
		 $dary= explode('/',trim(dirname($_SERVER['PHP_SELF']),"/"));					// 自身のモジュールより, count =< 2 : 同じ階層に配置と見なす count > 2 : mpdwebより一階層下に配置と見なす
		 if (count($dary) > 1) { $dir="/".$dary[count($dary)-1]; } else { $dir=""; }	// $_FILE_ : mpd Library Directory
		 $_FILE_=str_replace($dir,"",dirname(__FILE__));
		 }
	return($_FILE_);
	}

/* -----------------------------------------------------------------------------
	GetEnvCommon($mode) : Environment Common Set
	 $mode  : i  : Frame Mode XMLTag:Frame_{$mode}

	$XML_File = "/setting/mpdweblink.xml";←変更可能
----------------------------------------------------------------------------- */
function GetEnvFrame($mode="") {
	global $XML,$XML_File,$XML_CONF,$XML_FRAME,$FRAMEADDIN_HTML;	// $XML_CONF:XMLArray , $XML_FRAME:Frame Function , $FRAMEADDIN_HTML:Addin HTML
	
	$ret="";
	$tmp_file=$XML_File;
	$tmp_xml=$XML;
	$tmp_conf=$XML_CONF;
	$XML_CONF=NULL;
	try {
		$XML_File=dirname(__FILE__)."/setting/mpdweblink.xml";
		$XML_CONF = get_loadconfig($XML_File);								// XML File Get FileNameはLibrary標準
		} catch( Exception $e ) {
	  $ret=$e->getMessage();
	  }
	$XML = get_object_vars($XML_CONF);
	if ($mode=="") {
		 $tag="Frame";
		 }
	else {
 		 $tag="Frame_".$mode;
		 }
	$XML_FRAME=array("FrameFunc"=>"","FrameEscape"=>"off");					// FrameFunc : Frame Function: Max:top,history , FrameEscape:off;Frameを脱出しない,on:Frameを脱出
	$XML_FRAME["SetNo"]=get_config($tag,$XML_FRAME);
	if (($XML_FRAME["SetNo"] == 0)&&($tag !== "Frame")) {
		$tag="Frame";
		$XML_FRAME=array("FrameFunc"=>"","FrameEscape"=>"off");				// 指定の設定がない時 Default設定を使用,なければProgram Default
		get_config($tag,$XML_FRAME);
		}
	$ary= explode(',',$XML_FRAME["FrameFunc"]);
	$XML_FRAME["Func"]["top"]="";$XML_FRAME["Func"]["history"]="";
	foreach ($ary as $key =>$val) {
		if ($val!=="") {
			$XML_FRAME["Func"][$val]="on";
			}
		}

	$FRAMEADDIN_HTML="";
	$_FILE_=GetMyHome();													// My HomePath
	$sel=array("Addin"=>"0");												// XML:セレクト対象Tag , 1:指定文字列を含む前方一致
	$change=array("%home%"=>(rtrim($_FILE_,"/")),"%mypath%"=>(rtrim(dirname(__FILE__),"/")));
	$home=$change["%home%"];
	$mypath=$change["%mypath%"];
	$fldary = compact("home","mypath");
	$ret=ArgXML2HTMLStr("FrameAddin",$sel,$fldary,$change);
	if ($ret !==-1) { $FRAMEADDIN_HTML=$ret; }

	$tmp_frame=array("Property"=>"");										// Frame Function: Frame Property
	$tmp_frame["SetNo"]=get_config($tag,$tmp_frame);
	if (($tmp_frame["SetNo"] == 0)&&($tag !== "Frame")) {
		$tag="Frame";
		$tmp_frame=array("Property"=>"");									// 指定の設定がない時 Default設定を使用,なければProgram Default
		get_config($tag,$tmp_frame);
		}
	$XML_FRAME=$XML_FRAME+$tmp_frame;
	$ret=$XML_File;
	$XML_File=$tmp_file;
	$XML=$tmp_xml;
	$XML_CONF=$tmp_conf;
	}

/* -----------------------------------------------------------------------------
	FrmView_Init($mode): Display View Extend Box : 内部拡張Viewer
	 $mode  : i  : Frame Mode XML </Frame_{mode}>
	 $argary: i  : Filed Array 変数に値を設定
----------------------------------------------------------------------------- */
function FrmView_Init($mode="",$argary="") {
	global $XML_FRAME,$XML_EVAL,$FRAMEADDIN_HTML,$REQ_UA;		// $XML_FRAME:Frame Function

// Viewerの初期値 XML設定されない場合の値
	$top=66;$left=3;$width=478;$height=634;						// 設定値
	$bar=24;$top_def=-12;$frmwidth_def=6;$frmheight_def=8;		// 設定固定値 $bar:タイトルバーの高さ, $top_def:タイトルバー下の調整値 ,$frmwidth_de,$frmheight_def:iFreme内の調整値

	$ret=GetEnvFrame($mode);
	$fldary=explode(";",$XML_FRAME["Property"]);
	foreach ($fldary as $key =>$val) {
		$fld=explode("=",$val);
		if(isset($fld[1]))  {
			$varfld=str_replace(array(" ","$"),array("",""),$fld[0]);
			$$varfld=$fld[1];
			}
		}
	if(is_array($argary)) { extract($argary,EXTR_OVERWRITE); }	// EXTR_OVERWRITE: 既に同名の変数が存在する場合上書き
	$waptop=$top+($bar+$top_def);$frmwidth=$width-$frmwidth_def;$frmheight=$height-$frmheight_def;	// $argaryにセット:設定値と設定固定値で計算
	
	$FRM_HEIGTT="97vh";if ((isset($REQ_UA))&&($REQ_UA=="PC")) { $FRM_HEIGTT="98vh"; }
echo <<<EOM
<script type="text/javascript">
exd_top={$top};exd_left={$left};exd_width={$width};				// タイトルバー[-]クリック時戻すサイズ(初期値)。XMLでの設定で変更できる
waptop={$waptop};wapheight={$height};frmwidth={$frmwidth};frmheight={$frmheight};

/* -------------------------------------------------------------------------------------
	Extend View   : タイトルバー各機能（拡張ビューワ)
-------------------------------------------------------------------------------------- */
FrameWinMax=false;							// false:最大化していない , true:最大化化
FrameSource="";								// iFrame Source Keep
FrameEscape="{$XML_FRAME['FrameEscape']}";	// HistoryBack off:iFrame脱出を抑制 ,on:iFrame脱出を可
/* -------------------------------------------------------------------------------------
	FrmView_Create(title,source) : ExtendViewをCreate
	 title  : ExtendView Title Bar Name
	 source : View Source (Path:URL形式) 必要に応じ,source=encodeURI(source);でEncodeされていること
-------------------------------------------------------------------------------------- */
function FrmView_Create(title,source) {
	document.getElementById('idFrmVieTit').innerText=decodeURI(decodeURIComponent(title));
	document.getElementById('idFrmVieTitMax').innerText=decodeURI(decodeURIComponent(title));
	document.getElementById('idFrmSrc').src=source;
	if (FrameWinMax) {
		 RequestBoxDisp('idFrmVieMax');
		 }
	else {
		 RequestBoxDisp('idFrmVie');
		 }
	RequestBoxDisp('idFrmVieWap');
	FrameSource=source;
	if (document.getElementById('idtop') !== null) {		// idが表示されていれば続行
		document.getElementById('idtop').onclick= function () {
			FrmSourceInit();
			this.blur();
			}
		}
	if (document.getElementById('idtopmax') !== null) {		// idが表示されていれば続行
		document.getElementById('idtopmax').onclick= function () {
			FrmSourceInit();
			this.blur();
			}
		}
	FrmLoad_Disp();
	FrmEventListener();
	}

/*
	FrmSourceInit() : Frm Initialize , Source Reset&set
*/
function FrmSourceInit() {
	document.getElementById('idFrmLoadMsgInit').style.display="block";
	FrmLoad_Disp();
	document.getElementById('idFrmSrc').src="";
	document.getElementById('idFrmSrc').src=FrameSource;
	}

/* -------------------------------------------------------------------------------------
	FrmEventListener() : EventListener
	 resize   : JQueryをAddさせて使用可にした場合,Resize可能になる
	 popstate : HistoryView Event
-------------------------------------------------------------------------------------- */
function FrmEventListener() {
	//window.addEventListener( 'resize',function f() { console.log(document.body.clientWidth); },false );	// リサイズ時に行う処理
	window.addEventListener( 'resize',function f() { mpdframebodyresize() },false );						// リサイズ時に行う処理 BODY Eventを追加する。

	// iframe:ブラウザの戻るボタンを無効にする
	if (FrameEscape =='off') {
		history.pushState(null, null,location.href); 
		window.addEventListener('popstate',function f() { history.pushState(null, null,location.href); });
		}
	}

/*
	bodyresize() : Body Resize  Start
	※ResizeEventでのActionを記述
*/
function mpdframebodyresize() {		// Window Resize Event
	FrmView_WinMaxChg();	// ExtendBox(内部拡張Viewer) 最大化時Resize
	}

/*
	FrmRemoveListener() : Remove EventListener
	 resize   : JQueryをAddさせて使用可にした場合,Resize可能になる
	 popstate : HistoryView Event
*/
function FrmRemoveListener() {
	window.removeEventListener('resize',f(),false);

	if (FrameEscape =='off') {	// iframe:ブラウザの戻るボタンを無効にする
		window.removeEventListener('popstate',f(),false);
		}
	}

/* -------------------------------------------------------------------------------------
	FrmOnload() : iFrmae Onload
-------------------------------------------------------------------------------------- */
function FrmOnload(iframeurl) {

try {	// 内部のウィンドウへの参照 セキュリティエラー(別オリジン)を検知
	if (iframeurl=="about:blank") {		// 他をリンクした場合は,オリジナルHTMLにゆだねるため,Errorを無視する。
		FrmSourceInit();				// 自ServerのURLをHistory.Backしたとき,「about:blank」まで戻したとき初期化する
		}
	}	catch(e) {	// SecurityError: Blocked a frame with origin from accessing a cross-origin frame.
//	alert(e);
	}
	FrmLoad_noDisp();
	}

/* -------------------------------------------------------------------------------------
	Frm_Unload() : iFrame Unloaad
-------------------------------------------------------------------------------------- */
function Frm_Unload() {
	if (FrameWinMax) {
		 RequestBoxtUnLoad('idFrmVieMax');
		 }
	else {
		 RequestBoxtUnLoad('idFrmVie');
		 }
	RequestBoxtUnLoad('idFrmVieWap');
	document.getElementById('idFrmSrc').src="";

	FrmRemoveListener();
	}

/* -------------------------------------------------------------------------------------
	FrmView_WinDef() : ExtendViewを最大化
-------------------------------------------------------------------------------------- */
function FrmView_WinMax() {
// タイルルバー,iframe内部,iframe枠をKeep
// Max前の内容をKeep
	if (!FrameWinMax) {
		idExtFrm_width       = document.getElementById('idFrmVie').style.width;
		idFrmVieWap_width    = document.getElementById('idFrmVieWap').style.width;
		idFrmVieWap_height   = document.getElementById('idFrmVieWap').style.height;
		idFrmVieWap_position = document.getElementById('idFrmVieWap').style.position;
		idFrmVieWap_top      = document.getElementById('idFrmVieWap').style.top;
		idFrmVieWap_left     = document.getElementById('idFrmVieWap').style.left;
		}
	FrameWinMax=true;								// ResizeMode
	FrmView_WinMaxChg();
	}

/*
	FrmView_WinMaxChg() : 最大化時,WindowSizeに追従
*/
function FrmView_WinMaxChg() {
	if (FrameWinMax) {
// タイルルバーを変更
		document.getElementById('idFrmVieBar').style.width=document.body.clientWidth +'px';		// スクロールバーを含めず最大化
		document.getElementById('idFrmVieBar').style.position='Fixed';
		document.getElementById('idFrmVieBar').style.top=0+'px';
		document.getElementById('idFrmVieBar').style.left=0+'px';
// iframe内部変更
		document.getElementById('idFrmSrc').style.width=(document.body.clientWidth-5)+'px';		// 5:iFreme Inner スクロールバーの幅
		document.getElementById('idFrmSrc').style.height='{$FRM_HEIGTT}';						// 下位部が入りきれないので
// iframe枠変更
		document.getElementById('idFrmVieWap').style.width=document.body.clientWidth +'px';
		document.getElementById('idFrmVieWap').style.height=document.body.clientHeight +'px';
		document.getElementById('idFrmVieWap').style.position='Fixed';
		document.getElementById('idFrmVieWap').style.top=24+'px';
		document.getElementById('idFrmVieWap').style.left=0+'px';
		document.getElementById('idFrmLoadMsg').style.left=(parseInt(document.getElementById('idFrmVieWap').style.width)/2-30)+"px";
		}
	}

/*
	FrmView_WinDef() : ExtendViewを最大化前に戻す
*/
function FrmView_WinDef() {
// iframe内部変更
	document.getElementById('idFrmSrc').style.width       = idExtFrm_width;
// iframe枠変更
	document.getElementById('idFrmVieWap').style.width    = idFrmVieWap_width;
	document.getElementById('idFrmVieWap').style.height   = idFrmVieWap_height;
	document.getElementById('idFrmVieWap').style.position = idFrmVieWap_position;
	document.getElementById('idFrmVieWap').style.top      = idFrmVieWap_top;
	document.getElementById('idFrmVieWap').style.left     = idFrmVieWap_left;
	document.getElementById('idFrmLoadMsg').style.left=(parseInt(document.getElementById('idFrmVieWap').style.width)/2-30)+"px";
	FrameWinMax=false;
	}

/*
	FrmView_WinRst() : ExtendViewを元に戻す
*/
function FrmView_WinRst() {
// MenuBar変更
	document.getElementById('idFrmVie').style.top       = exd_top +'px';
	document.getElementById('idFrmVie').style.left      = exd_left +'px';
	document.getElementById('idFrmVie').style.width     = exd_width +'px';
	document.getElementById('idFrmVieMe').style.width   = exd_width +'px';
// iframe枠変更
	document.getElementById('idFrmVieWap').style.top    = waptop +'px';
	document.getElementById('idFrmVieWap').style.left   = exd_left +'px';
	document.getElementById('idFrmVieWap').style.width  = exd_width +'px';
	document.getElementById('idFrmVieWap').style.height = wapheight+'px';
// iframe変更
	document.getElementById('idFrmSrc').style.width     = frmwidth+'px';
	document.getElementById('idFrmSrc').style.height    = frmheight+'px';
	document.getElementById('idFrmLoadMsg').style.left=(parseInt(document.getElementById('idFrmVieWap').style.width)/2-30)+"px";
	FrameWinMax=false;
	}

EOM;
$info_width=400;					// Info 幅
echo <<<EOM
/* -------------------------------------------------------------------------------------
	FrmInfo_Left(size) : Info Box Left算出
	 size   : i  : 0:通常サイズ , 1:Maxsize
-------------------------------------------------------------------------------------- */
function FrmInfo_Left(size) {
	var id="idFrmVie";		// 通常時の補正値
	var def=20;
	var top_def=8
	if (size == 1) {		// Max時の補正値
		id="idFrmVieBar";
		def=40;
		var top_def=20;
		}
	var top=parseInt(document.getElementById(id).style.top)+top_def;	// Top計算
	document.getElementById('FrmInfo').style.top=top;
	var left_def=parseInt(document.getElementById(id).style.left);		// 移動時のLeft
	var left=parseInt(document.getElementById(id).style.width)-{$info_width}-def+left_def;
	if (left >0) {
		 document.getElementById('FrmInfo').style.left=left;			// 範囲内のLeft
		 }
	else {
		 document.getElementById('FrmInfo').style.left=0;				// 画面内に調整
		 }
	return;
	}

/* -------------------------------------------------------------------------------------
	FrmLoad_noDisp() : Loading Message Unload
	Frameが不要になったときはCallする
-------------------------------------------------------------------------------------- */
function FrmLoad_noDisp() {
	document.getElementById('idFrmLoadMsg').style.zIndex="";
	document.getElementById('idFrmLoadMsgInit').style.display="none";
	}

/*
	FrmLoad_Disp(waitsec) : Loading Message Load Wait Time
	 waitsec: i  ; Wait Time (Sec)
*/
function FrmLoad_Disp(waitsec){
	document.getElementById('idFrmLoadMsg').style.zIndex="1100";
	if (document.getElementById('idFrmVieWap') !== null) {
		document.getElementById('idlodingmsg').style.left=(parseInt(document.getElementById('idFrmVieWap').style.width)/2-30)+"px";
		}
	if (waitsec==null) { return; }
	sleep=waitsec*1000;
	setTimeout( function() { FrmLoad_noDisp(); }, sleep );
	}
</script>

<style type="text/css">
.idlodingmsg {
    position:absolute;top:210px;left:210px;z-index:4;
    margin-left: auto;
    margin-right: auto;
    width: 40px; /*ローディングアイコンの横サイズ*/
    height: 40px; /*ローディングアイコンの縦サイズ*/
    border-radius: 50%;  /*CSS3で円を書く*/
    border: 8px solid #ffffff;       /*円に○の白枠をつける*/
    border-right-color: transparent; /*円の右にC状の空きをつける*/
    animation: spin 1s linear infinite; /*1秒毎にくるくる回転するアニメーション*/
    display:block;
	}
@keyframes spin {
    0% { transform: rotate(0deg);   opacity: 0.2; } /*0%の時は20％の透明度*/
    50%  { transform: rotate(180deg); opacity: 1.0; } /*50%の時は透明度なし*/
    100%   { transform: rotate(360deg); opacity: 0.2; } /*100%の時に20％の透明度に戻る*/
}
.rotat {width:24px;height:24px;padding:2px 0 2px;font-size:11px;cursor:pointer;background-color:#4169e1;color:#ffffff;border:1px solid #3cb371;-moz-border-radius:12px;-webkit-border-radius:12px;border-radius:12px;}
.func { position:absolute;bottom:9px;height:20px;color:#000080;border: 1px solid #888888;border-radius:6px;background:#e6e6fa;cursor:pointer; }
</style>

<!-- タイトルバー(通常) -->
<div id="idFrmVie" onMousedown="MoveDragOn('idFrmVie','idFrmVieWap',10);" class="box" style="position:fixed;top:{$top}px;left:{$left}px;width:{$width}px;height:{$bar}px;border:#000000 solid 0.7px;background:rgba(0,0,0,0.0);border-style:none;cursor:pointer;z-index:999;">
EOM;
$tit_left=10;						// Bar Title位置
$info_width=400;					// Info 幅
if ($XML_FRAME["Func"]["top"]=="on") {
	$tit_left=$tit_left+20;
echo <<<EOM
   <input id=idtop type=button onclick="this.blur();" value="<" class=rotat style="position:relative;top:-12px;left:2px;font-size:18px;z-index:5">
EOM;
	}

if ($XML_FRAME["Func"]["history"]=="on") {
	$tit_left=$tit_left+70;
echo <<<EOM
   <input type=button onclick="FrmLoad_Disp(1);history.back();this.blur();" value="<" class=func style="position:relative;top:-11px;left:6px;font-size:18px;z-index:5">
   <input type=button onclick="FrmLoad_Disp(1);history.forward();this.blur();" value=">" class=func style="position:relative;top:-11px;left:12px;font-size:18px;z-index:5">
EOM;
	}
echo <<<EOM
 <div id="idFrmVieMe" style="position:absolute;left:0px;top:{$top_def}px;width:{$width}px;height:{$bar}px;background-color:#f5f5f5;">
  <div id="idFrmVieTit" style="position:absolute;left:{$tit_left}px;font-size:11px;color:#000000;margin:6px 0px 0px 10px;width:calc({$width}px - 180px);white-space:nowrap;overflow:hidden;"></div>
  <div style="position:absolute;right:10px;width:80px;height:{$bar}px;background-color:#f5f5f5;color:#f5f5f5;font-size:9px;">&nbsp;</div>
  <div class="select" onclick="FrmInfo_Left(0);RequestBoxDisp('FrmInfo');" style="position:absolute;right:70px;font-size:15px;color:#000000;margin:3px 0px 0px 10px;">?</div>
  <div class="select" onclick="FrmView_WinRst();" style="position:absolute;right:50px;font-size:15px;color:#000000;margin:3px 0px 0px 10px;">-</div>
  <div class="select" onclick="FrmView_WinMax();RequestBoxtUnLoad('idFrmVie');RequestBoxDisp('idFrmVieMax');" style="position:absolute;right:30px;border: 1px solid #333333;width:11px;height:11px;margin:6px 0px 0px 0px;"></div>
  <div class="select" onclick="Frm_Unload();" style="position:absolute;right:10px;font-size:15px;color:#000000;margin:3px 0px 0px 10px;">X</div>
 </div>
</div>
<!-- フレーム -->
<div id="idFrmVieWap" class="box" style="position:fixed;top:{$waptop}px;left:{$left}px;width:{$width}px;height:{$height}px;background-color:#000000;overflow:hidden;display:none;z-index:999;">
<div id="idFrmLoadMsg" class="idlodingmsg" style="z-index:10;"></div>
<div id="idFrmLoadMsgInit" style="position:absolute;top:5px;left:5px;width:200px;height:20px;background-color:rgba(135,206,235,0.9);border-radius:6px 6px 6px 6px;border: 0.7px solid #696969;font-size:13px;color:#000000;padding:0 0 0 12px;z-index:1001;display:none">Frame initialize:First page</div>
<iframe id="idFrmSrc" src="" width="{$width}px" height="{$height}px" style="left: 0px; top: 0px; position: absolute;z-index:11;" onload="var frameurl=this.contentWindow.location;if (document.getElementById('idFrmVieWap').style.display !=='none') { FrmOnload(frameurl); }">iframe対応ブラウザで見てください。</iframe>
</div>
<!-- タイトルバー(最大化) -->
<div id="idFrmVieMax" class="box" style="position:fixed;top:0px;left:3px;width:{$width}px;height:{$bar}px;border:#000000 solid 0.7px;background:rgba(0,0,0,0.0);border-style:none;cursor:pointer;z-index:999;">
EOM;
$tit_left=10;						// Bar Title位置
if ($XML_FRAME["Func"]["top"]=="on") {
	$tit_left=$tit_left+20;
echo <<<EOM
   <input id=idtopmax type=button onclick="this.blur();" value="<" class=rotat style="position:relative;top:0px;left:0px;font-size:18px;z-index:5">
EOM;
	}

if ($XML_FRAME["Func"]["history"]=="on") {
	$tit_left=$tit_left+70;
echo <<<EOM
   <input type=button onclick="FrmLoad_Disp(1);history.back();this.blur();" value="<" class=func style="position:relative;top:1px;left:6px;font-size:18px;z-index:5">
   <input type=button onclick="FrmLoad_Disp(1);history.forward();this.blur();" value=">" class=func style="position:relative;top:1px;left:12px;font-size:18px;z-index:5">
EOM;
	}

echo <<<EOM
 <div id="idFrmVieBar" style="position:fixd;top:0px;left:0px;width:{$width}px;height:{$bar}px;background-color:#f5f5f5;">
  <div id="idFrmVieTitMax" style="position:absolute;left:{$tit_left}px;font-size:11px;color:#000000;margin:6px 0px 0px 10px;width:calc({$width}px - 180px);white-space:nowrap;overflow:hidden;"></div>
  <div style="position:absolute;right:30px;border: 1px solid #333333;width:11px;height:11px;margin:6px 4px 0px 0px;"></div>
  <div style="position:absolute;right:50px;width:40px;height:{$bar}px;background-color:#f5f5f5;color:#f5f5f5;font-size:9px;">&nbsp;</div>
  <div class="select" onclick="FrmInfo_Left(1);RequestBoxDisp('FrmInfo');" style="position:absolute;right:70px;font-size:15px;color:#000000;margin:3px 0px 0px 10px;width:11px;background-color:#f5f5f5;">?</div>
  <div class="select" onclick="RequestBoxtUnLoad('idFrmVieMax');FrmView_WinRst();RequestBoxDisp('idFrmVie');" style="position:absolute;right:54px;font-size:15px;color:#000000;margin:3px 0px 0px 10px;width:11px;background-color:#f5f5f5;">-</div>
  <div class="select" onclick="FrmView_WinDef();RequestBoxDisp('idFrmVie');RequestBoxtUnLoad('idFrmVieMax');" style="position:absolute;right:30px;border: 1px solid #333333;width:11px;height:11px;margin:4px 2px 0px 0px;"></div>
  <div class="select" onclick="Frm_Unload();" style="position:absolute;right:10px;font-size:15px;color:#000000;margin:3px 0px 0px 10px;">X</div>
 </div>
</div>

EOM;
global $FRAME_VERSION;
$inf_titl=$info_width-20;
echo <<<EOM
<div id="FrmInfo" style="position:absolute;top:20px;left:20px;width:{$info_width}px;height:160px; border: 1px solid #888888;font-size:12p;background-color:#ffffff;color:#000000;display:none;z-index:1000;">
 <div style="position:absolute;top:0px;left:0px;background-color:#4682b4;color:#ffffff;font-size:14px;text-align:left;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;height:18px;padding:6px 10px 4px;width:{$inf_titl}px;">mpdframe Information</div>
 <div style="position:absolute;top:40;font-size:14px;padding:6px 10px 4px;">{$FRAME_VERSION}</div>
 <div style="position:absolute;bottom:3px;left:6px;font-size:12px;padding:6px 10px 4px;">(C)2020 by Mikio Shiratori</div>
 <button onclick="document.getElementById('FrmInfo').style.display='none';" style="position:absolute;bottom:6px;right:10px;">Close</button>
</div>
EOM;

if ($FRAMEADDIN_HTML !=="") {
echo <<<EOM
{$FRAMEADDIN_HTML}
EOM;
		}
	}
?>
