<?php
/***************************************************************************************
	mpdweblink.php : web Link Parameter

	 mpdweblink.php?use={set}search={item1}:{val1};{item2}:{val2}&id={Fremeid}&bid={bid}
	  use   : {set}         : mpdweblink.xml mpdweblink.php設定部分のパラメータを指定 <{XMLTag}_{set}としてパラメータ設定する
	  search: {item1}:{val1}: item1を変,valを Part分解してWebパラメータを作成する。";"で区切り複数設定できる
	  id    : {id}          : Prerent Event Frame HTML-id 指定されていると自身のサイズを親Frame-idもサイズ変更する
	  bid   : {bid}         : Prerent Event Close HTML-id 指定されているとClose時,親HTML-idのonclickEventを発生させる

	 ex, mpdweblink.php?use=mpdweb&search=Artist:anmi2;Album:paer

************************************************************************************* */
$MY_VERSION="1.1 (01.03.2024)";
$dary= explode('/',trim(dirname($_SERVER['PHP_SELF']),"/"));
if (count($dary) > 1) { $dir="/".$dary[count($dary)-1]; } else { $dir=""; }		// 自身のモジュールより, count =< 2 : 同じ階層に配置と見なす count > 2 : mpdwebより一階層下に配置と見なす
$_FILE_=str_replace($dir,"",dirname(__FILE__));									// $_FILE_   : mpd Library Directory
$PHP_SELF=str_replace($dir,"",dirname($_SERVER['PHP_SELF']));					// $PHP_SELF : JS Library Directory

$require_mod =$_FILE_.'/mpdweb.lib.php';					// mpd Application Library
$require_liba=$_FILE_.'/mpdweb.lib_appli.php';				// mpd Application Library
require_once($require_mod);									// Mpd : Original Library mpdweb.lib.php
require_once($require_liba);								// Mpd : Original Library mpdweb.lib_appli.php
$ARG=GetArgument();
if (($ret = GetEnvCommon()) !== "") {
	DispMsgBox("on",$ret,100,60,"Error Message");
	}
/* *****************************************************************************
	HTML
***************************************************************************** */

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<?php
$jscommon=rtrim($PHP_SELF,'/').'/'.'mpdweb.common.js';		// Common Library : mpdweb.common.js
$dateform="";
if (file_exists($jscommon)) {
	$date = new DateTime();
	$date->setTimestamp(filemtime($jscommon));
	$dateform=$date->format('YmdHis');
	$dateform="?a=".$dateform;
	}

echo <<<EOM
<script type="text/javascript" src="{$jscommon}{$dateform}"></script>
EOM;
?>

<script type="text/javascript">
/* -------------------------------------------------------------------------------------
	EventOnload() : Onload Event
------------------------------------------------------------------------------------- */
/* Weblink Suport Module : URLEncode(encodeURI)を行わないモジュールを設定
   複数設定方法
   SUPORT_MOD = /A.php|B.php/ 正規表現に従い設定 |で区切る
*/
let SUPORT_MOD = /mpdgethtml.php/;

/* Weblink Item & Onload */
var ORGHEIGTH;		// iframeのHeigh Orignal
var ORGWIDTH;		// iframeのWidth Orignal
function EventOnload() {
	ORGHEIGTH="";
	ORGWIDTH="";
	if (FREMEID !="") {
		 if (window.parent.document.getElementById(FREMEID)) {				// 現在Frameは mpdframe.php:FrmView_Init()で生成のみ対応
			  ORGHEIGTH=window.parent.document.getElementById(FREMEID).style.height;			// iframeのHeightをKeep
			  ORGWIDTH=window.parent.document.getElementById(FREMEID).style.width;				// iframeのWidthをKeep
			  window.parent.document.getElementById(FREMEID).style.height = LINKHEIGTH + 'px';	// iframeのHeightを変更
			  window.parent.document.getElementById(FREMEID).style.width  = LINKWIDTH + 'px';	// iframeのWidthを変更
			  }
		 }
	}

window.onload = EventOnload;

/*
	Event UnLoad() : UnLoad Event
*/
function EventUnload() {
	PutWinClose();
	}
window.onbeforeunload = EventUnload;

/* -------------------------------------------------------------------------------------
	EventGo() : Go Weblink , onclick Event
------------------------------------------------------------------------------------- */
function EventGo() {
	var native=document.getElementById('WebLinkURL').value;
	var title="";var sp="";
	for (var i=0;i < ARYEDIT.length;i++) {	// 選択状態の値を取得
		var str =document.getElementById('WLnkTxt'+ARYEDIT[i]).value;
		var re = new RegExp(decodeURI("%C2%A0"),"g");			// UTF-8の半角スペース
		var repstr="%"+ARYEDIT[i]+"%";							// 変換文字列:%{filed}%
		if (native.indexOf(repstr) >= 0) {
			 str = str.replace(re," ");
			 if ((native.indexOf(repstr) != -1)&&(str=="")) {
				 RequestMsgBox("Input Warning","Requires Input ["+ARYEDIT[i]+"]!!",70,70);
				 return;
				 }
			 }
		else {
			 var repstr="#"+ARYEDIT[i]+"#";		// 変換文字列:#{filed}#
			 if (native.indexOf(repstr) >= 0) {
				 str = str.replace(re," ");
				 if ((native.indexOf(repstr) != -1)&&(str=="")) {
					 RequestMsgBox("Input Warning","Requires Input ["+ARYEDIT[i]+"]!!",70,70);
					 return;
					 }
				 str=encodeURI(str);
				 }
			 }
		var tmpstr=native;
		let rep= { " ":"+" };					// 変換Mapの変更連想配列
		str=RequestURLEncode(str,rep);
		native=native.replace(repstr,str);
		if (tmpstr !==native) { var title =title+sp+str;sp=" , "}
		}

	res=native.match(RegExp(/\\(.*?)\\/g));		// \\で囲まれた文字列を取得
	if (res !== null) {							// Select配列をチェック
		for (var i=0;i <res.length;i++) {
			var enc=res[i];
			var enc=enc.replace(RegExp(/^\\+|\\+$/g),'');	// Selectから\\を削除
			enc=encodeURI(enc);								// \\の文字間をEncode
			native=native.replace(res[i],enc);				// SelectをReplace
			}
		}
	if(SUPORT_MOD.test(native) ==false) {		// Weblink Suport Module:URLEncode(encodeURI)を行わないモジュールチェック
		native=encodeURI(native);
		}
	var val=GetCheckURL();
	if (document.getElementById('WebLinkLBL'+val) == null) { } else {
		var tmp =document.getElementById('WebLinkLBL'+val).innerHTML;
		if (tmp !== "") { title = tmp +" : "+ title; }
		}
	if ((ARYFRAME[val] == "frame")&&(typeof window.parent.FrmView_Create == 'function')) {		// 現在Frameは mpdframe.php:FrmView_Init()で生成のみ対応
		 window.parent.FrmView_Create(title,native);
		 }
	else if (ARYFRAME[val] == "inline") {
		 location.href = native;					// Frame内で開く
		 }
	else if (ARYFRAME[val] == "parent") {
		 top.location.href=native;					// 全フレームを解除
		 }
	else {
		 PutWinClose();								// Close Window
		 SUBWIN=window.open(native, '_blank');		// Open Window
		 }
	}

/* -------------------------------------------------------------------------------------
	EventClose() : Close Button , onclick Event
------------------------------------------------------------------------------------- */
function EventClose() {
	if (ORGHEIGTH !=="") {
		window.parent.document.getElementById(FREMEID).style.height=ORGHEIGTH;				// iframeのHeightを戻す
		window.parent.document.getElementById(FREMEID).style.width=ORGWIDTH;				// iframeのWidthを戻す
		}
	if (BUTTONID !== "") {				// Prerentから Button idが指定時ClickEventでClose
		window.parent.document.getElementById(BUTTONID).onclick();
		}

	if (typeof window.parent.FrmView_WinUld == 'function') {								// 現在Frameは mpdframe.php:FrmView_Init()で生成のみ対応
		window.parent.FrmView_WinUld();
		}
	PutWinClose();
	document.getElementById('WeblinkBox').style.display='none';
	}

/* -------------------------------------------------------------------------------------
	EventSW(id,textid) : Parts Button , onclick Event
	 id     : i  : Click Part
	 textid : i  : Input Text id
------------------------------------------------------------------------------------- */
var BCOLOR_NSEL="silver";						// Non Select BackGroundColer
function EventSW(id,textid) {
	var idstr=document.getElementById(id).innerText;				// Click 文字列
	var orgstr=document.getElementById(textid).innerText;			// Orignal 文字列

	if (document.getElementById(id).style.backgroundColor !== BCOLOR_NSEL) {
		 document.getElementById(id).style.backgroundColor = BCOLOR_NSEL;
		 document.getElementById(id).style.color = 'black';
		 document.getElementById(id).style.borderStyle='outset';
		 }
	else {
		 document.getElementById(id).style.backgroundColor = '';
		 document.getElementById(id).style.color = '';
		 document.getElementById(id).style.borderStyle='';
		 }
	Edit_String(id,textid);
	}

/*
	Edit_String(id,textid) : Parts Words build
	 id     : i  : Click Part
	 textid : i  : Input Text id
*/
function Edit_String(id,textid) {
	var no  = id.replace(/[^0-9]/g,"");
	var nitvid  = id.replace(no,"");
	var str = "";var sp="";
	for(var i = 0;i < 20;i++) {
		if (document.getElementById(nitvid+i) == null) { continue; };
		if (document.getElementById(nitvid+i).style.backgroundColor == BCOLOR_NSEL) { continue; }
		var tmp=document.getElementById(nitvid+i).innerText;
		if (tmp.length <=  1) { sp= ""; }
		str=str+sp+tmp;
		if (tmp.length > 1) { sp= " "; } 
		}
	document.getElementById(textid).value=str;
	}

/* -------------------------------------------------------------------------------------
	GetWebItemOrg(key) : WebItemTit Original , onclick Event
	 key    : Item (Artist/Album.. Argument's Item)
------------------------------------------------------------------------------------- */
function GetWebItemOrg(key) {
	var val=document.getElementById('WOrgTxt'+key).innerText;
	document.getElementById('WLnkTxt'+key).value=val;
	for(var i = 0;i < 20;i++) {						// 文字列Buttonを戻す
		var id='WPW'+key+i;
		if (document.getElementById(id) == null) { continue; };
		document.getElementById(id).style.backgroundColor = '';
		document.getElementById(id).style.color = '';
		document.getElementById(id).style.borderStyle='';
		}
	}

/* -------------------------------------------------------------------------------------
	GetWebLink() : Weblink , onchange Event
------------------------------------------------------------------------------------- */
function GetWebLink() {
	var val=GetCheckURL();
	document.getElementById('WebLinkURL').value=ARYURL[val];
	}

/* -------------------------------------------------------------------------------------
	GetCheckURL() : Weblink , onchange Event
	 @return: o  : Check URL No id:WeblinkSel
------------------------------------------------------------------------------------- */
function GetCheckURL() {
	var elements = document.getElementsByName("WeblinkSel");
	for (var val="",i=0;i < elements.length;i++) {	// 選択状態の値を取得
		if (elements[i].checked) {
			val = elements[i].value;
			break;
			}
		}
	return(val);
	}

/* -------------------------------------------------------------------------------------
	PutWinClose() : SubWindow Close
------------------------------------------------------------------------------------- */
function PutWinClose() {
	if (SUBWIN && !SUBWIN.closed) {				// SubWindow Check
		SUBWIN.close(); 						// SubWindow Close
		}
	}

</script>

<meta http-equiv="Content-Type" content="text/html; charset=utf-8" >
<meta http-equiv="Expires" content="1000">
<meta name="viewport" content="width=380px,initial-scale=1.2,maximum-scale=1.7" >

<style>
/* -------------------------------------------------------------------------------------
	style
------------------------------------------------------------------------------------- */
 body { color:#ffffff;margin-left:4px;font-family:Verdana,"Meiryo UI",sans-serif;font-size:80%; }
 html,body { scrollbar-base-color:#707070;scrollbar-track-color:#A4A4A4;scrollbar-arrow-color:#707070; }
/* Common */
.buttn { border-style:none;width:50px;height:20px;padding:2px 0 2px;font-size:11px;cursor:pointer;-moz-border-radius:4px;-webkit-border-radius:4px;border-radius: 4px;border:1px solid; }
.box { border: 1px solid #888888;position:fixed;top:200px;left:170px;width:300px;height:210px;font-size:10p;z-index:5;background-color:#2f2f2f;display:none; }
.boxtitle { background-color:#0000FF;color:#CEECF5;font-size:12px;text-align:left;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;width:280px;height:18px;position:absolute;top:0px;left:0px;padding:8px 10 2px; }
.boxtext  { position:absolute;background-color:#2f2f2;color:#ffffff;font-size:16x;font-weight:bold;text-decoration:none;display:block;text-align:left;vertical-align:middle;border: 0px;width:278px;height:19;padding:3px 10 2px; }
.msgbbtn  { font-size:12px;width:60px;height:24px;position:absolute;top:120px;background-color:#c0c0c0;border:1.5px ridge #d3d3d3; }
/* Freme */
.WeblinkBox { position:fixed;top:8px;left:3px;width:460px;background:rgba(61,47,77,0.3);font-family:Verdana,"Meiryo UI",sans-serif;font-size:80%; }
/* Link Freme */
.Weblinkfrm { position:relative;top:2px;left:1px;width:456px;height:68px;border: 1px solid #888888;background:rgba(192,192,192,0.9);color:#4d4d4d;border-radius:6px;font-size:12px; }
.WeblinkSfm { position:relative;top:9px;left:8px;height:25px;width:112px; }
.WeblinkSel { height:23px;width:112px;background:#d3d3d3;border: 1.2px solid #808080;font-size:13px; }
.WebLinkLBL { position:relative;top:16px;left:10px;width:72px;height:16px;background:rgba(192,192,192,0.9);text-align:center;font-size:10.5px; }
.WebLinkURL { position:relative;top:-1px;left:86px;width:300px;height:20px;background-color:#d3d3d3;font-size:14px;word-break:break-all;line-height:110%;resize: none; }
.WebLinkBtn { position:absolute;top:40px;left:402px;width:46px;height:23px;font-size:14px;text-align:center;cursor:pointer; }
.WebLinkInf { position:absolute;bottom:8px;left:6px;width:360px;height:16px;line-height:16px;background:#4682b4;border-radius:3px;border-style:inset;font-size:12px;padding-left:4px; }
.WebLinkCls { position:absolute;bottom:8px;left:402px;width:46px;height:23px;font-size:12px;cursor:pointer; }

.WeblinkRadio input[type="radio"] { display:none; }
.WeblinkRadio label { display:inline-block;color:#fff; background-color:#696969;padding:4px 10px;height:13px;border:1px inset; }
.WeblinkRadio input[type="radio"]:checked + label { background-color:#2780e3;border:2px inset; }
.WeblinkRadLb { cursor:pointer; }

/* Edit Freme */
.WebEditfrm { position:relative;top:1px;left:1px;width:456px;height:234px;border: 1px solid #888888;background:rgba(192,192,192,0.9);border-radius:6px;font-size:11px; }
/* Item Freme */
.WebEditTfm { position:relative;top:-10px; }
.WebEditTbl { position:relative;top:3px;left:2px; }
.WebEditTit { position:relative;top:5px;left:4px;width:109px;height:16px;background:rgba(176,196,222,0.9);color:#4d4d4d;border: 1px solid #888888;text-align:center;line-height:140%;font-size:10.5px; }
.WebEditAfm { position:relative;top:-17px;left:116px;height:10px;width:346px; }
.WebEditAra { position:relative;top:3px;left:3px;width:322px;height:22px;color:#000000;font-size:14px;word-break:break-all;line-height:120%;resize:none; }

.WebItemTbl { position:relative;top:5px;left:0px; }		/* Original */
.WebItemTit { position:relative;top:1px;left:7px;width:70px;height:16px;background:rgba(192,192,192,0.9);color:#4d4d4d;font-size:12px;text-align:center;line-height:130%; }
.WebItemBtn { position:relative;top:5px;left:10px;width:364px;height:24px;cursor:pointer; }
/* Parts Word Freme */
.WebPartTfm { position:relative;top:-10px;left:0px;width:100px;height:54px; }
.WebPartTit { position:relative;top:9px;left:7px;width:70px;height:16px;background:rgba(192,192,192,0.9);color:#4d4d4d;font-size:12px;text-align:center;line-height:130%; }	/* Parts */
.WebPartBfm { position:relative;top:-9px;left:84px;height:50px;width:363px;overflow-x:scroll;border:1px solid #a9a9a9; }
.WebPartBtn { position:relative;top:2px;left:-3px;float:left;height:24px;cursor:pointer;background:#2780e3;color:#27e0e3;-ms-border-style:2px inset;border:2px inset;border-color:#dcdcdc; }			/* IE border-style:inset;  webkit:border:inset; */

.TxEllipsis { overflow:hidden;text-overflow:ellipsis;white-space:nowrap; }		/* Overfolw ...付加 */
</style>

</head>
<body>

<?php
/* -------------------------------------------------------------------------------------
	Make Body HTML
------------------------------------------------------------------------------------- */
// ------------ Argument Parts
if (isset($ARG["search"])) {
	 $search=$ARG["search"];		// Form {url}?search={item1}:{val1};{item2}:{val2}
	 $ary= explode(';',$search);
	 foreach($ary as $str) {
		$tmp= explode(':',$str,2);
		if (isset($tmp[1])) {
			$tmp[1]=str_replace(" ","&nbsp;",$tmp[1]);
			$SET[$tmp[0]]=$tmp[1];
			}
		}
	 }
else {
	 $SET=array();
	 }

print '<script type="text/javascript">';				// JS Make array,Link URL
print 'var ARYURL= { ';
$sp="";
foreach($URL as $key => $val) {
	print $sp.$key.':\''.$URL[$key]["url"].'\'';		// url=ARYURL[key];
	$sp=",";
	}
print ' };';

print 'var ARYFRAME= { ';
$sp="";
foreach($URL as $key => $val) {
	if (isset($URL[$key]["open"])) { $tmp=$URL[$key]["open"]; } else { $tmp="subwin"; }
	print $sp.$key.':\''.$tmp.'\'';		// open=ARYFRAME[key];
	$sp=",";
	}
print ' };';

print 'var ARYEDIT= [ ';
$sp="";
foreach($SET as $key => $val) {
	print $sp.'"'.$key.'"';		// Edit Item;
	$sp=",";
	}
print ' ];';

print '</script>';

// ------------ Make Link Box
print <<<EOM
<div id="WeblinkBox" class="WeblinkBox">
 <div class="Weblinkfrm">
   <div class="WeblinkSfm" style="width:2000px;">
    <div class="WeblinkRadio">
EOM;
$checkkey="0";
print '<form id="Weblink" onchange="GetWebLink();">';		// onchangeで変更時のみ編集
foreach($URL as $key => $val) {
	$check="";
	if ($URL[$key]["check"]=="check") {
		 $check=" checked";
		 $checkkey=$key;
		 }
	print ' <input id="Weblink'.$key.'" type="radio" name="WeblinkSel" value="'.$key.'"'.$check.'><label id="WebLinkLBL'.$key.'" for="Weblink'.$key.'" class="WeblinkRadLb">'.$URL[$key]["name"].'</label>';		// <inputの前に" "必要(次のradioとの間を空ける)
	}
print '</form>';
$defurl=$URL[$checkkey]["url"];
print <<<EOM
    </div>
   </div>
   <div class="WebLinkLBL">
   <label>Link URL</label>
   </div>
   <textarea id="WebLinkURL" readonly class="WebLinkURL">{$defurl}</textarea>
   <button id="WebLinkGo" class="buttn WebLinkBtn" onclick="EventGo();">Go</button>
 </div>
EOM;

// ------------ Make Item Box
$height=30;$str="";
foreach($SET as $key => $val) {
	$height +=66;
	$str .= '<div>';											// Make Item Input
	$str .= '<table id="WebEdit'.$key.'" border="0" cellpadding="0" class="WebEditTbl">';
	$str .= '<tr><td><div id="WLnk'.$key.'" class="WebEditTit">'.$key.'</div></td></tr>';
	$str .= '</table>';
	$str .= '</div>';
	$str .= '<div class="WebEditAfm">';
	$str .= '<table border="0" cellpadding="0">';
	$str .= '<tr><td><textarea id="WLnkTxt'.$key.'" class="WebEditAra">'.$val.'</textarea></td></tr>';
	$str .= '</table>';
	$str .= '</div>';

	$str .= '<div class="WebEditTfm">';									// Make Item Button
	$str .= '<table border="0" cellpadding="0" class="WebItemTbl">';
	$str .= '<tr>';
	$str .= '<td><div class="WebItemTit">Orignal</div></td>';
	$str .= '<td><button id="WOrgTxt'.$key.'" onclick="GetWebItemOrg(\''.$key.'\');this.blur();" class="WebItemBtn TxEllipsis">'.$val.'</button></td>';
	$str .= '</tr>';
	$str .= '</table>';
	$str .= '</div>';

	$pattern=$XML_SEARCH["SearchWordsPurge"];									// 正規表現 "([,;\-\/\s])" "(\bthe\b|[,:\-\/\s]|\&nbsp;)"
	$val = str_replace("&nbsp;"," ",$val);
	$words = preg_split("/".$pattern."/i",$val, -1,PREG_SPLIT_DELIM_CAPTURE);	// PREG_SPLIT_DELIM_CAPTURE:分割文字も含める
	if ((isset($words[0]))&&($words[0] !==$val)) {								// Make Word Parts
		$height +=56;
		$str .= '<div class="WebPartTfm">';
		$str .= '<table border="0" cellpadding="0" class="WebItemTbl">';
		$str .= '<tr><td><div class="WebPartTit">Parts</div></td></tr>';
		$str .= '</table>';

		$str .= '<div id="idPart'.$key.'" class="WebPartBfm">';
		$str .= '<table border="0" cellpadding="0">';
		$str .= '<tr>';
		foreach($words as $i => $word) {
			if (($word=="&nbsp;")||($word==" ")||($word=="")) { continue; }
			$str .=  '<td><button id="WPW'.$key.$i.'" class="WebPartBtn" onclick="EventSW(\'WPW'.$key.$i.'\',\'WLnkTxt'.$key.'\');this.blur();">'.$word.'</button></td>';
			}
		$str .= '</tr>';
		$str .= '</table>';
		$str .= '</div>';

		$str .= '</div>';
		}
	}
print '<div class="WebEditfrm" style="height:'.	$height.'px;">';
print $str;
print '<div class="WebLinkInf">'.$XML_DISP["Title"].' : '.basename(__FILE__).$MY_VERSION.'</div>';
print '<button class="buttn WebLinkCls" onclick="EventClose();">Close</button>';
print '</div>';
print '</div>';

DispMsgBox("off");

$height=$height+85;$fremeid="";$bid="";
if (isset($ARG["id"])) {		// Prevent Frame idが指定時 Prevent Frameのサイズを調整する。
	$fremeid=$ARG["id"];
	}
if (isset($ARG["bid"])) {		// Prevent On/Off Button idが指定時,Click Eventで消去する
	$bid=$ARG["bid"];
	}
print <<<EOM
<script type="text/javascript">
var LINKHEIGTH={$height};		// Self Freme: Height
var LINKWIDTH=464;				// Self Freme: Width
var FREMEID="{$fremeid}";		// Self Freme: Width
var BUTTONID="{$bid}";		// Self Freme: Width
var SUBWIN;						// Open SubWindow
</script>
EOM;

?>

<?php
/* -----------------------------------------------------------------------------
	GetArgument();
	 @return: o  : 起動引数 $_POST|$ARG $GET優先
----------------------------------------------------------------------------- */
function GetArgument() {
	$ARG=array();				// &useは必須パラメータ
	if ((isset($_GET["search"]))||(isset($_GET["bid"]))||(isset($_GET["id"]))||(isset($_GET["use"]))) {
		 $ARG=$_GET;			// $_GETにパラメータが設定されているので採用
		 }
	else {
		 $ARG=$_POST;			// $_POSTにパラメータが設定されているので採用
		 }
	if (!isset($ARG["use"])) { $ARG["use"]=""; }
	return($ARG);
	}

/* -----------------------------------------------------------------------------
	GetEnvCommon() : Environment Common Set
	 $XML_File = "/setting/mpdweblink.xmll";←変更可能
----------------------------------------------------------------------------- */
function GetEnvCommon() {
	global $ARG,$URL,$XML_SEARCH,$XML_DISP;						// $URL:XMLSetting  URL ,$XML_SEARCH:Search Setting ,$XML_DISP:XML DisplayCongig

	$ret="";
	try {
		$XML_File=dirname(__FILE__)."/setting/mpdweblink.xml";
		$XML_CONF = get_loadconfig($XML_File);										// XML File Get FileNameはLibrary標準
		} catch( Exception $e ) {
	  $ret=$e->getMessage();
	  }
	$xmlary=get_xml_Array($XML_CONF);
//  $URL[][url]:Edit URL / $URL[][name]:Display Name / $URL[][open]:frame:表示 ,subwin:Tab表示 ,parent:同じTabに表示 , 省略:subwin /  $URL[][check]:[]Default Check
	$i=0;$URL=array();
	if ($ARG["use"]=="") {
		 $extend="";
		 }
	else {
		 $extend="_".$ARG["use"];
		 }

	$xml_url=array();
	if (isset($xmlary["Link"])) {					// XML <Link>URL Parameterが設定されているときDefeat
		$xml_url=$xmlary["Link"];
		}
	if (isset($xmlary["Link".$extend])) {			// XML <Link_{use}>URL Parameterが設定されているときは採用
		$xml_url=$xmlary["Link".$extend];
		}
	if (isset($xml_url)) {
		foreach($xml_url as $key=> $val) {			// XML <Link> String
			if ($key=="comment") {continue;}
			if (is_array($val)) { if (count($val) == 0) { $URL[$i][$key]=""; }
				foreach($val as $k=> $v) {					// XML Attribute: "@attributes"
					if (is_array($v)) {
						 if (count($v) == 0) { $URL[$i][$k]=""; }
						 foreach($v as $atrk=> $atrv) {		// XML定義 Attribute Get
						 	$URL[$i][$atrk]=$atrv;
							}
						 }
					else { $URL[$i][$k]=$v; }
					}
				 }
			else {
				 $URL[$i][$key]=$val;
				 }
			if (!isset($URL[$i]["name"])) { $URL[$i]["name"]=$key; }
			if ((isset($URL[$i]["check"]))&&($URL[$i]["check"]=="")) { $URL[$i]["check"]="check"; }
			else if (!isset($URL[$i]["check"])) { $URL[$i]["check"]=""; }
			$i+=1;
			}
		}
	if (count($URL)==0) { $URL=array ( array("url"=>"/mpdweb/mpdweblink/mpdgethtml.php?url=https://www.last.fm/ja/music/%Artist%/+wiki","name"=>"last.fm in","open"=>"frame","check"=>"check") ); }	// last.fm Artist検索 frame
// Purge 正規表現 Exp: ([,;\-\/\s]) / (\bthe\b|[,:\-\/\s]|\&nbsp;) : を想定
	$XML_SEARCH=array("SearchWordsPurge"=>"([,;\-\/\s])");
	get_config("Search",$XML_SEARCH);												// OrignalをDefeat Purge 正規表現
	if ($extend !=="") {
		get_config("Search".$extend,$XML_SEARCH);									// &use={extend}が指定されたとき入れ換え ""も許可に注意
		}
// DispConfig
	$XML_DISP=array("Title"=>"URL using Meta");										// OrignalをDefeat Disp_Confiug
	get_config("DISP_Config",$XML_DISP);
	if ($extend !=="") {															// &use={extend}が指定されたとき入れ換え ""も許可に注意
		get_config("DISP_Config".$extend,$XML_DISP);
		}

//print '<div style="color:#000000;"><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR>------------------------------------------------<BR>';
//print '$ARG:';print_r($ARG);print "<BR>";
//print '$ARG["use"]extend['.$extend."]<BR>";
//print '$XML_SEARCH:';print_r($XML_SEARCH);print "<BR>";
//print '$XML_DISP:';print_r($XML_DISP);print "<BR>";
//print '$URL:';print_r($URL);print "<BR>";
//print "</div>";
	return($ret);
	}

/* -----------------------------------------------------------------------------
	Make Addin mpdweblink.xml <LinkAddin>から PHP/HTML/Js/CSSを展開する
----------------------------------------------------------------------------- */
$sel=array("Addin"=>"1");												// XML:セレクト対象Tag , 1:指定文字列を含む前方一致
$change=array("%home%"=>(rtrim($_FILE_,"/")),"%mypath%"=>(rtrim(dirname(__FILE__),"/")));
$home=$change["%home%"];
$mypath=$change["%mypath%"];
$fldary = compact("home","mypath");

if ($ARG["use"]=="") {
	 $extend="";
	 }
else {
	 $extend="_".$ARG["use"];
	 }
$html=ArgXML2HTMLStr("LinkAddin".$extend,$sel,$fldary,$change);		// "LinkAddin_{use}"をAddin
if ($html ==-1) {
	$html=ArgXML2HTMLStr("LinkAddin",$sel,$fldary,$change);			// "LinkAddin_{use}"がなければ OrignalをDefeatとする
	}
if ($html !==-1) {
	echo <<<EOM
{$html}
EOM;
  }
//////////////// End Of Source /////////////////////////////////////////////////////////

?>

</body>
</html>
