<?php
/* ******************************************************************************
	 mpdxmlupdate.lib.php : Mpdweb XML Update Library
****************************************************************************** */
/*
	Common Argument:
	  $xmlary = array(
	     "Tag"  =>"{TagName}",     : ArrayのTag
	     "#Value" =>"{Valuse}",    : Child Tagなし値のみ
	     "{ChildTag}" =>"{Value}", : ChildTag , Value
	     )
	  $loadxml,$savexml: $savexml  ="" のときは,$loadxmlを更新,変更前を{$loadxml}.orgで保存する。
	                     $savexml !=""のときは,$savexmlで作成。既に存在すれば,OverWrite。{$loadxml}.orgは作成しない。
	  $parent          : ParentTag mpdwebシリーズを対象にしているので階層を制限している。2階層を対象。
	                     <{RouteTag:Module}><{$parent:1階層}><{Tag}><{ChildTag}>の構造<{Tag}><{ChildTag}>を子更新する。
	Function :
	  XMLTagReplase() : Tag Replase Tag名変更:ArrayTagとXMLのTag入れ換え:
	  XMLTagAppend()  : Tag Append 最後に追加
	  XMLTagUpdate()  : Tag Update ArrayのTag内容に置き換える
	  XMLTagRemove()  : Tag Remove Tag削除
	  XMLSetValue()   : Tag Value Set 値セット , Option : ArrayのChildを作成,Arrayになければ削除
	  XMLTagMove()    : Tag Move From/To
	 *cf* Attribute:XMLSetValue()以外はChildTagのAttributeは保証しない。

	2階層の編集Function
	 XMLEditUpdate()  : XML Update XMLFile Edit (2階層までの編集 例:<Mpd_net><host>)

	global : システムの許可範囲として設定する
	  $XMLLIB_NVALUE  :Tag Value Nullを許可, off:Nullを許可しない($xmlaryのNULLは作成しない) TagValueがNull <{tag} />
	                      Dedult:$XMLLIB_NVALUE='on';変更する場合,require後,呼び元で設定する。
	  $DEBUG          : Debug用、"2":メッセージアウト。require後,呼び元で設定する。

	※使用上の制約
	(1) "#Value"を使用のときは$xmlary=array("Tag"=>"{Tag}","#Value"=>"{value}")の2個にすること。
	      PHPのLibraryUpdateでErrorにならないのでチェックしないが,何らかで破綻する。
          <{parent}><{Tag}>{value}<name>{value}</name></{Tag}>はXMLよして対応していない。=> <{parent}><{Tag}>{value}</{Tag}>で使用すること。
	  (2)PHPのLibraryでValueの文字 "&" "<" ">" "'" "\n" はエンティティ変換されるが,'"'は変換しない。PHPLibrayのままとする。
	      '"'文字をそのまま使用するとXML上破綻する場合がある。
	     必要に応じ、呼び元で '"' => '&quot;'に変換して対応する。例)$val=str_replace('"',"&quot;",$val);
	  エンティティの対応は勝手にしているので,当ライブラリではしない。PHPLibrayのままとする。
****************************************************************************** */
$DEBUG= false;	// flase 1:msg 2:logout 3:User

$require_mod=dirname(__FILE__).'/mpdweb.lib_appli.php';		// Mpd XML Basic Library mpdweb.lib.php
require_once($require_mod);									// Mpd : Original Library mpdwen.lib.php
global $XMLLIB_NVALUE;$XMLLIB_NVALUE='on';					// $XMLLIB_NVALUE:Tag Value null:on , off:not Value null , Make;<{tag} />

global $DEBUG;if (!isset($DEBUG)) { $DEBUG=2; };if ($DEBUG==2) { print "mpdxmlupdat Debug Start<BR>"; }	// 呼び元より継続 1:msg // 未定義はMessageOut

/*
	lib_version()
	@return : o  : Version
*/
function xmlupdate_version() {
	$LIB_VERSION=basename(__FILE__)." 1.1 (31.08.2021)";
	return($LIB_VERSION);
	}

/* -------------------------------------------------------------------------------
	XMLTagReplase($loadxml,$savexml,$parent,$orgtag,$parent,$xmlary) : XML Tag Replase
	 $loadxml: XML Load FilePath
	 $savexml: XML Save FilePath "":Used loadxml
	 $parent : Parent TagName
	 $orgtag : Orignal Tag
	 $xmlary : XML Update Array Key:tagname : [Tag] NewTag Value:value , Key:'#Value':ChindTagを作成しない
	 @return : -2:$xmlary not Array , $xmlary["Tag"] Nothing
	           -1:Argument Tag False ,$xmlary["Tag"](New) XML Contains is there $orgtag(old) No Contains
	           >0:Output Bytes
------------------------------------------------------------------------------ */
function XMLTagReplase($loadxml,$savexml,$parent,$orgtag,$xmlary) {
	global $XMLLIB_NVALUE;

	if ((!is_array($xmlary))||(!isset($xmlary["Tag"]))) { return(-2); }			// NewTagがない:Paramter Error
	$xml = new DOMDocument();
	$string = @file_get_contents($loadxml);					// XMLFile読み込み
	$xml->loadXML($string);

	$root = $xml->getElementsByTagName($parent)->item(0);	// BaseTag位置
	$check= $root->getElementsByTagName($orgtag);			// Orignal Tagの存在チェック
	if ($check->length == 0) { return(-1); }
	$newtag=$xmlary["Tag"];
	$check =$root->getElementsByTagName($newtag);			// New Tagの存在チェック
	if ($check->length > 0) { return(-1); }

	$f = $xml->createDocumentFragment();
	$orgnode = $root->getElementsByTagName($orgtag)->item(0);

	$str="";
	$i=0;$sp="";
	foreach($xmlary as $key=> $val) {						// AddTagのString編集
		if ($key == "Tag") { continue; }
		if (($XMLLIB_NVALUE=="off")&&($val == "")) { continue; }			// Tag:Null Value作成しない
		$tmp=ArgHTMLEncode($val);
		if($i > 0) { $sp="\n\t\t\t"; }
		$last="";
		if ($key == "#Value") {								// Key#Value:Valueのみ作成
			 $str=$str.$sp.$tmp;							// <val>追加
			 $last="1";
			 }
		else {
			 $str=$str.$sp."<".$key.">".$tmp."</".$key.">";	// <{Tag}><val>追加
			 }
		$i+=1;
		}
	if($last=="") { $str=$str."\n\t"; }
	$f->appendXML("<".$newtag.">".$str."</".$newtag.">");	// <{NewTag}><String>追加
	$h = $xml->documentElement->appendChild($f);
	$root->appendChild($h);
	$newnode = $root->getElementsByTagName($newtag)->item(0);
	$root->replaceChild($newnode,$orgnode);

	global $DEBUG;if ($DEBUG==2) { print "xmlupdate :XMLTagReplase:<BR>";print $xml->saveXML(); };	// XML Save Test
	$savefile=$savexml;
	if ($savexml =="") {
		rename($loadxml,$loadxml.".".org);
		$savefile=$loadxml;
		}
 	$ret=$xml->save($savefile);								// 別名で保存
	chmod($savefile,0666);
	return($ret);
	}

/* -------------------------------------------------------------------------------
	XMLTagAppend($loadxml,$savexml,$parent,$xmlary) : XML Tag Append
	 $loadxml: XML Load FilePath
	 $savexml: XML Save FilePath "":Used loadxml
	 $parent : Parent TagName
	 $xmlary : XML Update Array Key:tagname : [Tag] NewTag Value:value , Key:'#Value':ChindTagを作成しない
	 @return : -2:$xmlary not Array , $xmlary["Tag"] Nothing
	           -1:Argument Tag False ,$xmlary["Tag"] XML Contains is there
	           >0:Output Bytes
------------------------------------------------------------------------------ */
function XMLTagAppend($loadxml,$savexml,$parent,$xmlary) {
	global $XMLLIB_NVALUE;

	if ((!is_array($xmlary))||(!isset($xmlary["Tag"]))) { return(-2); }			// NewTagがない:Paramter Error
	$xml = new DOMDocument();
	$string = @file_get_contents($loadxml);					// XMLFile読み込み
	$xml->loadXML($string);

	$newtag=$xmlary["Tag"];

	$root = $xml->getElementsByTagName($parent)->item(0);	// BaseTag位置
	$check =$root->getElementsByTagName($newtag);			// New Tagの存在チェック
	if ($check->length > 0) { return(-1); }

	$f = $xml->createDocumentFragment();
	$str="";
	$i=0;$sp="";$last="";
	foreach($xmlary as $key=> $val) {						// AddTagのString編集
		if ($key == "Tag") { continue; }
		if (($XMLLIB_NVALUE=="off")&&($val == "")) { continue; }		// Tag:Null Value作成しない
		$tmp=ArgHTMLEncode($val);
		if($i > 0) { $sp="\n\t\t\t"; }
		$last="";
		if ($key == "#Value") {								// Key#Value:Valueのみ作成
			 $str=$str.$sp.$tmp;							// <val>追加
			 $last="1";
			 }
		else {
			 $str=$str.$sp."<".$key.">".$tmp."</".$key.">";	// <{Tag}><val>追加
			 }
		$i+=1;
		}
	$g = new DOMText("\t");									// Tag追加
	$root->appendChild($g);
	if($last=="") { $str=$str."\n\t"; }
	$f->appendXML("<".$newtag.">".$str."</".$newtag.">");	// <{NewTag}><String>追加
	$h = $xml->documentElement->appendChild($f);
	$root->appendChild($h);
	$g = new DOMText("\n");									// 改行
	$root->appendChild($g);

	global $DEBUG;if ($DEBUG==2) { print "xmlupdate : XMLTagAppend:<BR>";print $xml->saveXML(); };		// XML Save Test
	$savefile=$savexml;
	if ($savexml =="") {
		rename($loadxml,$loadxml.".".org);
		$savefile=$loadxml;
		}
 	$ret=$xml->save($savefile);								// 別名で保存
	chmod($savefile,0666);
	return($ret);
	}

/* -------------------------------------------------------------------------------
	XMLTagUpdate($loadxml,$savexml,$parent,$xmlary) : XML Tag Update
	 $loadxml: XML Load FilePath
	 $savexml: XML Save FilePath "":Used loadxml
	 $parent : Parent TagName
	 $xmlary : XML Update Array Key:tagname : [Tag] UpdateTag Value:value , Key:'#Value':ChindTagを作成しない
	 @return : -2:$xmlary not Array , $xmlary["Tag"] Nothing
	           -1:Argument Tag False ,$xmlary["Tag"] No Contains
	           >0:Output Bytes
------------------------------------------------------------------------------ */
function XMLTagUpdate($loadxml,$savexml,$parent,$xmlary) {
	global $XMLLIB_NVALUE;

	if ((!is_array($xmlary))||(!isset($xmlary["Tag"]))) { return(-2); }			// NewTagがない:Paramter Error
	$xml = new DOMDocument();
	$string = @file_get_contents($loadxml);						// XMLFile読み込み
	$xml->loadXML($string);

	$reptag=$xmlary["Tag"];

	$root = $xml->getElementsByTagName($parent)->item(0);		// BaseTag位置
	$check= $root->getElementsByTagName($reptag);				// New Tagの存在チェック
	if ($check->length == 0) { return(-1); }

	$bfnode = $root->getElementsByTagName($reptag)->item(0);	// 追加のためのTag位置
	$orgnode = $root->getElementsByTagName($reptag)->item(0);	// Orignal Tag位置

	$f = $xml->createDocumentFragment();
	$str="";
	$i=0;$sp="";$last="";
	foreach($xmlary as $key=> $val) {							// RepTagのString編集
		if ($key == "Tag") { continue; }
		if (($XMLLIB_NVALUE=="off")&&($val == "")) { continue; }		// Tag:Null Value作成しない
		$tmp=ArgHTMLEncode($val);
		if($i > 0) { $sp="\n\t\t\t"; }
		$last="";
		if ($key == "#Value") {									// Key#Value:Valueのみ作成
			 $str=$str.$sp.$tmp;								// <val>追加
			 $last="1";
			 }
		else {
			 $str=$str.$sp."<".$key.">".$tmp."</".$key.">";		// <{Tag}><val>追加
			 }
		$i+=1;
		}
	if($last=="") { $str=$str."\n\t"; }
	$f->appendXML("<".$reptag.">".$str."</".$reptag.">");		// <{RepNewTag}><String>追加
	$root->insertBefore($f,$bfnode);							// 作成Tagを挿入し,旧Tagをremove
	$root->removeChild($orgnode);

	global $DEBUG;if ($DEBUG==2) { print "xmlupdate : XMLTagUpdate:<BR>";print $xml->saveXML(); };		// XML Save Test
	$savefile=$savexml;
	if ($savexml =="") {
		rename($loadxml,$loadxml.".".org);
		$savefile=$loadxml;
		}
 	$ret=$xml->save($savefile);									// 別名で保存
	chmod($savefile,0666);
	return($ret);
	}

/* -------------------------------------------------------------------------------
	XMLTagAppend($loadxml,$savexml,$parent,$rmtag) : XML Tag remove
	 $loadxml: XML Load FilePath
	 $savexml: XML Save FilePath "":Used loadxml
	 $parent : Parent TagName
	 $rmtag  : XML Remove Tag
	 @return : -2:$rmtag Nothing
	           -1:Argument Tag False ,rmtag No Contains
	           >0:Output Bytes
------------------------------------------------------------------------------ */
function XMLTagRemove($loadxml,$savexml,$parent,$rmtag) {
	if($rmtag=="") { return(-2); }
	$xml=simplexml_load_file($loadxml);					// XMLFile読み込み

	$child=$xml->$parent->$rmtag;
	if (!$child) { return(-1); }
	$dom=dom_import_simplexml($child); 

	$dom->parentNode->removeChild($dom);				// Remove Tag

	$str = $xml->saveXML();								// XML String
	$str=str_replace("\t\n","",$str);					// NLを削除

	global $DEBUG;if ($DEBUG==2) { print "xmlupdate : XMLTagRemove:<BR>";print $str; };		// XML Save Test
	$savefile=$savexml;
	if ($savexml =="") {
		rename($loadxml,$loadxml.".".org);
		$savefile=$loadxml;
		}
	$ret=file_put_contents($savefile,$str);				// 別名で保存
	chmod($savefile,0666);
	return($ret);
	}

/* -------------------------------------------------------------------------------
	XMLSetValue($loadxml,$savexml,$parent,$xmlary,$add=1,$rm=0) : XML Tag Set Value
	 $loadxml: XML Load FilePath
	 $savexml: XML Save FilePath "":Used loadxml
	 $parent : Parent TagName
	 $xmlary : XML Update Array Key:tagname : [Tag] NewTag Value:value
	 $add    : "1":$xmlaryにあるTagは生成する
	 $rm     : "1":XML上,$xmlaryにないときRemove
	 @return : -2:$xmlary not Array , $xmlary["Tag"] Nothing
	           -1:Argument Tag False ,From/To Nothing $xmlary["Tag"] No Contains
	           >0:Output Bytes
------------------------------------------------------------------------------ */
function XMLSetValue($loadxml,$savexml,$parent,$xmlary,$add=1,$rm=0) {
	global $XMLLIB_NVALUE;

	if ((!is_array($xmlary))||(!isset($xmlary["Tag"]))) { return(-2); }			// NewTagがない:Paramter Error
	$xml = new DOMDocument();
	$string = @file_get_contents($loadxml);					// XMLFile読み込み
	$xml->loadXML($string);

	$settag=$xmlary["Tag"];

	$root = $xml->getElementsByTagName($parent)->item(0);	// BaseTag位置
	$check= $root->getElementsByTagName($settag);			// New Tagの存在チェック
	if ($check->length == 0) { return(-1); }

	$setnode = $root->getElementsByTagName($settag);		// RepのためのTag位置
	$f = $xml->createDocumentFragment();
	foreach($setnode as $kpos => $snode) {
		$ary=array();
		foreach($snode->childNodes as $key=> $child) {
			if ($child->nodeName=="#text") { continue; }	// Textは対象にしない
			if (isset($xmlary[$child->nodeName])) {			// NodeName:$child->nodeName / NodeValue:$child->nodeValue
				 $ary[]=$child->nodeName;
				 $child->nodeValue=$xmlary[$child->nodeName];
				 }
			else if($rm == 1) {								// $rm:1 $xmlaryにないTagを削除する
				 $child->parentNode->removeChild($child);
				 }
			}
		if ($add==1) {
			foreach($xmlary as $akey => $val) {				// $xmlary ChildTagは追加
				if ($akey == "Tag") { continue; }
				if ($akey == "#Value") { continue; }
				if (($XMLLIB_NVALUE=="off")&&($val == "")) { continue; }		// Tag:Null Value作成しない
				if (!isset($ary[$akey])) {
					$f = $xml->createElement($akey,$val);
					$snode->appendChild($f);
					$g = new DOMText("\n\t\t\t");			// Tag追加
					$snode->appendChild($g);
					}
				}
			}
		}

	global $DEBUG;if ($DEBUG==2) { print "xmlupdate : XMLSetValue:<BR>";print $xml->saveXML(); };		// XML Save Test
	$savefile=$savexml;
	if ($savexml =="") {
		rename($loadxml,$loadxml.".".org);
		$savefile=$loadxml;
		}
 	$ret=$xml->save($savefile);								// 別名で保存
	chmod($savefile,0666);
	return($ret);
	}

/* -------------------------------------------------------------------------------
	XMLTagMove($loadxml,$savexml,$parent,$from,$to) : XML Tag Move
	 $loadxml: XML Load FilePath
	 $savexml: XML Save FilePath "":Used loadxml
	 $parent : Parent TagName
	 $from   : XML Update Array Key:tagname : [Tag] NewTag Value:value
	 $to     : "1":$xmlaryにあるTagは生成する
	 @return : -1:Argument Tag False ,From/To  No Contains
	           >0:Output Bytes
------------------------------------------------------------------------------ */
function XMLTagMove($loadxml,$savexml,$parent,$from,$to) {
	$xml = new DOMDocument();
	$string = @file_get_contents($loadxml);					// XMLFile読み込み
	$xml->loadXML($string);

	$root = $xml->getElementsByTagName($parent)->item(0);	// BaseTag位置
	$check =$root->getElementsByTagName($from);				// New Tagの存在チェック
	if ($check->length == 0) { return(-1); }
	$check =$root->getElementsByTagName($to);				// New Tagの存在チェック
	if ($check->length == 0) { return(-1); }

	$croot = $xml->getElementsByTagName($parent);			// Parent以下 Tag位置check 
	$chk_from="";$chk_to="";$grt_from="0";$after_to="";
	foreach($croot as $k => $rnode) {
		foreach($rnode->childNodes as $key=> $child) {
			if ($child->nodeName=="#text") { continue; }	// Textは対象にしない
			if (($chk_to !=="")&&($after_to=="")) {			// Toの次のTagを検出
				$after_to=$child->nodeName;
				if ($chk_from !=="") { break; }
				}
			if (($child->nodeName == $from)&&($chk_to !=="")) {		// To位置が小さいとき
				$grt_from= "1";
				break;
				}
			if ($child->nodeName == $from) {
				$chk_from=$from;
				}
			if ($child->nodeName == $to) {
				$chk_to=$to;
				}
			}
		}

	$frnode = $root->getElementsByTagName($from)->item(0);	// FromのTag位置
	$doppel = $frnode->cloneNode(true);						// From Tag Copy

	if ($grt_from !=="0") {
		 $tonode = $root->getElementsByTagName($to)->item(0);			// ToのTag位置
		 $root->insertBefore($doppel,$tonode);							// 作成Tagを挿入
		 }
	else if ($after_to!=="") {								// insertAfterを行う。
		 $tonode = $root->getElementsByTagName($after_to)->item(0);		// Toの次のTag位置
		 $root->insertBefore($doppel,$tonode);							// 作成Tagを挿入
		 }
	else {													// insertAfter:最後に追加
		 $f = $xml->createDocumentFragment();
		 $g = new DOMText("\t");
		 $root->appendChild($g);
		 $f->appendChild($doppel);							// Copyを最後に追加
		 $h = $xml->documentElement->appendChild($f);
		 $root->appendChild($h);
		 }

	$root->removeChild($frnode);							// From Tagをremove

	$str = $xml->saveXML();									// XML String
	$str=str_replace("\t\n","",$str);						// NLを削除
	$str=str_replace("</".$from."><","</".$from.">\n\t<",$str);	// NLを挿入

	global $DEBUG;if ($DEBUG==2) { print "xmlupdate : XMLTagMove:<BR>";print $str; };		// XML Save Test
	$savefile=$savexml;
	if ($savexml =="") {
		rename($loadxml,$loadxml.".".org);
		$savefile=$loadxml;
		}
	$ret=file_put_contents($savefile,$str);					// 別名で保存
	chmod($savefile,0666);
	return($ret);
	}

/*********************************************************************************
	XMLEditUpdate($loadxml,$savexml,$xmlary) : XML Update XMLFile Edit
	                                          (2階層までの編集 例:<Mpd_net><host>)
	 $loadxml: XML Load FilePath
	 $savexml: XML Save FilePath "":Used loadxml
	 $xmlary : XML Update Array Section:Tagname=>Value : [Sec][Tag]:UpdateTag Value
	 @return : -1:Argument Tag False ,$xmlary["Tag"] No Contains
	           >0:Output Bytes
	 ※ Sectionの設定がない場合はErrorとなる
	 例)
	 $xmlary = array( "Mpd_exclusive"  => array( "netmask" =>"xxx.168.0.0/16|2400",),
			         "Mpd_net"        => array( "host" =>"xxx.xxx.x.xxx","port"  =>"xxxx" ),
					);
********************************************************************************/
function XMLEditUpdate($loadxml,$savexml,$xmlary) {
	$xml = new DOMDocument();
	$string = @file_get_contents($loadxml);						// XMLFile読み込み
	$xml->loadXML($string);
	foreach($xmlary as $section=> $nodeary) {
		$secnode = $xml->getElementsByTagName($section);			// Sction Cheak
		if ($secnode->length == 0) { return(-1); }
		$secnode = $xml->getElementsByTagName($section)->item(0);	// Sction Positioning
		if (!is_array($nodeary)) { continue; }
		foreach($nodeary as $tag=> $val) {						// RepTagのString編集
			$val=ArgHTMLEncode($val);								// Value Encode
			$repnode= $secnode->getElementsByTagName($tag);
			if ($repnode->length == 0) {							// Tagの存在チェック
				 $g = new DOMText("\t");							// Tag追加
				 $secnode->appendChild($g);
				 $secnodeNode=$secnode->appendChild($xml->createElement($tag,$val));
				 $g = new DOMText("\n");
				 $secnode->appendChild($g);
				 }
			else {
				 foreach($repnode as $kpos => $node) {			// Tag Search
					if ($node->nodeName == $tag) {					// 変更TagFind
						$str=$node->nodeValue;
						if ($str == $val) { continue; }				// Valueが同じ場合変更しない
						$node->nodeValue=$val;
						}
					}
				 }
			}
		}
//	print "xmlupdate :XMLTagReplase:<BR>";print $xml->saveXML();	// XML Save Test
	$savefile=$savexml;
	if ($savexml =="") {
		rename($loadxml,$loadxml.".".org);
		$savefile=$loadxml;
		}
 	$ret=$xml->save($savefile);									// 別名で保存
	chmod($savefile,0666);
	return($ret);
	}

/* ------------------------ End of Source ------------------------------------ */
?>
