#!/bin/bash
# ***********************************************************************************
#  Update Playlist to Roon Playlist
#
#   mpd2roon.sh {File}
#
#   mpd Playlist        Roon Playlist
#     NAS/music/Music1/    Music1/
#
# ***********************************************************************************

# Setting (l:ARGUMENT_SOURCEȂ͎gp)
SOURCE_DIR="/mnt/playlists"
MPD_PATH="/mnt/NAS"
ROON_PATH="/mnt/NAS/music"
REGEX='s|^NAS/music/||'

#ARGUMENT_SOURCE="/var/www/html/mpdweb/setting/mpd2roon.conf"
ARGUMENT_SOURCE=`find /var/www -name "mpd2roon.conf"`
source $ARGUMENT_SOURCE

# Initialization
if [ -z "$1" ]; then
	echo "Usage: $0 <playlist filename>"
	exit 1
fi

INPUT_FILE="$SOURCE_DIR/$1"
OUTPUT_FILE="$ROON_PATH/$1"

# Input File Cheack
if [ ! -f "$INPUT_FILE" ]; then
	echo "Error: Input file not found.['$INPUT_FILE']"
	exit 2
fi

# --- Conversion process ---
#sed 's|^NAS/music/||' "$INPUT_FILE" > "$OUTPUT_FILE"
sed "$REGEX" "$INPUT_FILE" > "$OUTPUT_FILE"

echo "Complete : $OUTPUT_FILE"
