#!/bin/bash
# ***********************************************************************************
#  Playlist Directory Monitoring
#
#  変更Faile検知 : mpdweb/shell/mpd2roon.sh {File}
#
#  Install
#   ArchLinuxの場合, (Ubuntu/DebianはInstall済)
#     pacman -S rsync
#
#  ※ NASをMountすると検知しないため inotify-toolsは使用しない
# ***********************************************************************************

# Setting (初期値:ARGUMENT_SOURCEが取れない時は使用)
SOURCE_DIR="/mnt/playlists"
LOCAL_CACHE="/dev/shm/playlists_Cache"
MONSLRRP=8

#PROCESS_SCRIPT="/var/www/html/mpdweb/shell/mpd2roon.sh"
PROCESS_SCRIPT=`find /var/www -name "mpd2roon.sh"`
#ARGUMENT_SOURCE="/var/www/html/mpdweb/setting/mpd2roon.conf"
ARGUMENT_SOURCE=`find /var/www -name "mpd2roon.conf"`
source $ARGUMENT_SOURCE

# Initialization
if [[ ! -d "$LOCAL_CACHE" ]]; then
	echo "`date '+%Y/%m/%d %H:%M:%S'`: Creating initial Cache..."
	mkdir -p "$LOCAL_CACHE"
	rsync -rt --delete "$SOURCE_DIR/" "$LOCAL_CACHE/"
fi

# Monitoring Loop
while true; do
	CHANGES=$(rsync -rtni --delete "$SOURCE_DIR/" "$LOCAL_CACHE/" | grep -v '/$')

	if [[ -n "$CHANGES" ]]; then
		echo "`date '+%Y/%m/%d %H:%M:%S'`: Difference detection:"
#		echo "$CHANGES"

		# Cache Update
		rsync -rt --delete "$SOURCE_DIR/" "$LOCAL_CACHE/"  > /dev/null

		# Process changed files
		echo "$CHANGES" | awk '{print $NF}' | while read REL_PATH; do
			echo "`date '+%Y/%m/%d %H:%M:%S'`: Processing: $REL_PATH"
			"$PROCESS_SCRIPT" "$REL_PATH"
		done
	fi
	sleep $MONSLRRP
done
