#!/bin/bash
# mpdweb Extend Module Use/Not Use Set
# Update Section:ExtendModule
# mpdextendset tag={<ExtendModule><{tag}>} flag={<ExtendModule><{tag}><{flag}>}
#  flagがUpdate対象と同じ場合Updateしない
# mpdextendset tag={<ExtendModule><{tag}>} get
#  Get tag : Tag内容をOutput Format : flag:{on|off}

# Argc 2未満の場合、exit
if [ $# -lt 2 ]; then
    echo "Usage: $0 tag= flag="
    exit 1
fi
GET="";
# tagとflagに分割
for arg in "$@"; do
    case "$arg" in
        tag=*)
            TAG="${arg#tag=}"
            ;;
        flag=*)
            FLAG="${arg#flag=}"
            ;;
        get)
            GET="on"
            ;;
       *)
            echo "Invalid argument: $arg"
            ;;
    esac
done

# echo "tag: $TAG / flag: $FLAG"
if [ -z "$TAG" ]; then
	echo "tag={ExtendModule:tag name} is required"
	exit 1
fi
# FilePath Set
FILEPATH=`find /var/www -name "mpdconfig.xml"`
echo "Target:$FILEPATH"
# Target Section Buffer In
SECTION=$(awk '/<ExtendModule>/,/<\/ExtendModule>/ { print }' "$FILEPATH")
# FLAG変数から<Playlist>Valueを取得
TAG_STATUS=$(echo "$SECTION" | awk -v tag="$TAG" '
  BEGIN {
    start_tag = "<" tag ">"
    end_tag = "</" tag ">"
  }
  $0 ~ start_tag {
    if ($0 ~ /on/) {
      printf "on"
    } else {
      printf "off"
    }
  }
')

if [ "$GET" == "on" ];then
	echo "flag:$TAG_STATUS"
	exit 0
fi

# on/off でなければtagが見つからない
if [ "$TAG_STATUS" != "on" ] && [ "$TAG_STATUS" != "off" ]; then
	echo "Tag Not Found"
	exit 1
fi

if [ "$TAG_STATUS" == "$FLAG" ]; then
	echo "Don't Update,it's the same value"
	exit 1
fi

echo "Update Start : ReuestFlag:$FLAG => <ExtendModule><$TAG>:$TAG_STATUS"

# Update
sed -i '/<ExtendModule>/,/<\/ExtendModule>/ { 
    /<'"$TAG"'>/ {
        s/<'"$TAG"'>[^<]*<\/'"$TAG"'>/<'"$TAG"'>'$FLAG'<\/'"$TAG"'>/
    }
}' "$FILEPATH"
echo "Update End"
exit 0
