#!/usr/bin/perl
# mpdmount.pl
# ------------------------------------------------------------------------
#   mount
#    mpdmount.pl path={Shell Path} mount|umount chmod={mode} {test}
#      全ての項目は省略可能。全て省略時 "mount"のみ指定と同じ動作
#       path         : MountShell pathをshell で指定 省略時:cat $(find /var/www/ -name mount.d)/*.conf
#       mount|umount : mount マウント動作 chmodを指定可 , umount:マウント解除 省略時:mount
#       chmod        : chmodを指定 省略時,chmod実行しない
#       test         : 動作テスト用 実行せずPrint
# ------------------------------------------------------------------------
my %PARAM = get_param(\@ARGV);
$path =$PARAM{'path'};
my @result = `$path`;

my $i=0;my $cmd="";
foreach my $line(@result) {
	$line =~ s/^ *(.*?) *$/$1/;		# 前後Space Trim
	if ($line =~ /^#/){ next;}		# 先頭#はコメント
	@word = split /\s+/,$line;		# SpaceでPurge
	$i=0;$cmd="";
	foreach my $var(@word) {
		if (($var =~ /^-r/)||($var =~ /^-w/)) { $i=1;next;}	# -からの位置(-の後にパラメータがある前提
		if ($var =~ /^-/){ $i=0;next;}	# -からの位置(-の後にパラメータがある前提
		$i++;
		if (($i eq 3)&&($PARAM{'mount'}eq "on")) {
			if (!-d $var) {
				my $cmdstr="mkdir $var";
				if ($PARAM{'test'} eq "on") {
					 print "shell:$cmdstr\n";
					 }
				else {
					 my @tmp=`$cmdstr`;
					 }
				}
			if ($PARAM{'chmod'} ne "") {
				my $cmdstr="chmod $PARAM{'chmod'} $var";
				if ($PARAM{'test'} eq "on") {
					 print "shell:$cmdstr\n";
					 }
				else {
					 my @tmp=`$cmdstr`;
					 }
				}
			$cmd=$line;
			last;
			}
		elsif ($i eq 3) {
			$cmd="umount $var\n";
			last;
			}
		}
	if ($PARAM{'test'} eq "on") {
		 print "shell:$cmd";
		 }
	else {
		 my @tmp=`$cmd`;
		 }
    }
exit(0);

# ------------------------------------------------------------------------
#   get_param : コマンドライン引数解析
#	 $argv  : i  : Command Line Argument Array
#	 @return: o  : %{hash} : Parameter
# ------------------------------------------------------------------------
sub get_param {
	my ($argv)=@_;
	my %PARAM=( "path"=>'cat $(find /var/www/ -name mount.d)/*.conf',"chmod"=>"","mount"=>"on","umount"=>"off","test"=>"off" );
	foreach my $arg (@$argv) {
		if ($arg =~ m/^path=/i) {		# path
			my @edtstr = split(/=/,$arg);
			if (defined $edtstr[1]) {
				$PARAM{"path"}=$edtstr[1];
				}
			}
		if ($arg =~ m/^chmod=/i) {		# chmod
			my @edtstr = split(/=/,$arg);
			if (defined $edtstr[1]) {
				$PARAM{"chmod"}=$edtstr[1];
				}
			}
		if ($arg =~ m/^mount$/i) {		# mount
			$PARAM{"mount"}="on";
			$PARAM{"umount"}="off";
			}
		if ($arg =~ m/^umount$/i) {		# umount
			$PARAM{"umount"}="on";
			$PARAM{"mount"}="off";
			}
		if ($arg =~ m/^test$/i) {		# test
			$PARAM{"test"}="on";
			}
#		print "$arg\n";
		}
	return(%PARAM);
	}
# ---------- End of Source ------------------------------------------------

# - Debug --------------------------------------------------------------
use Data::Dumper;
print Dumper %PARAM;
exit(0);

