<?php
/***************************************************************************************
	viewerjs.php : viewer.js Frontend
	viewerjs-master.zipには含まれていないモジュールであり,PHPからviewerjsを使用する目的で
	作成。外部から,viewer.jsのパラメータを指定し起動される
	viewerjs.php?id={id},file={ImageFile}&fit&widthmax={Pixel}&delimiter={char}&childdelim={char}&options={......}
	 id        : iframe childのとき, "<img" tagのParent idを指定 delimiterで区切れば複数指定可 (fileを無視する) Ex) idImg001;idImg002
	 imgtag    : <img要素 attribute (src以外に指定TagでURLを取得)
	 file      : ImageFilePath (idが未指定時有効) ※ "&の変換に注意" , FilePathは長くなるので複数指定できない
	 amper     : "&"を変換するか。 FilePathをURLに含めるため簡易にできるようにする。
	 noselect  : 起動時Viewerを開かない(手動で開く)
	 select    : 起動時Viewerを開く。false:開かない(未指定時のDefault) true/"":{id}を開く。id:指定idを開く
	 slide     : Viewer.jsをを開く。(先頭画像をクリックする)
	 fit       : 画像をWindowsのwidthに収めて表示する
	 widthmax  : 画像を指定サイズ最大とする。
	 delimiter : optionsを複数指定時,各optionsを区切る文字。未指定時";" Ex)toolbar#navbar
	 childdelim: optionsと値の区切り文字。未指定時":" Ex)toolbar:true#navbar:false
	 options   : viewer.jsのパラメタを指定。複数指定時はdelimiter{文字}で区切る。パラメタと値はchilddelim{文字}で区切る。
	             値を指定しないときは"true"を設定する。動作は,viewer.jsの解説を参照
	             Ex)toolbar#navbarの場合,値がないので"true"を設定
	                toolbar:false
	 funcdelim : evetn Function間区切り文字 未指定時"|"
	 event     : Eventで実行する関数を指定。複数指定時はfuncdelim{文字}で区切る。パラメタと値はchilddelim{文字}で区切る。
	             Event ready,built,shown,view,viewed,zoom,zoomed,hide:Close;

	   i/F Function : viewer.js Frontendで用意し使用できる関数
	             RequestParentUnload(id) : Parent HTML Unload

	※fitとwidthmaxを指定した場合,小さいほうが優先される。
	※viewerjsに渡すImageFileをLoad完了ごとに開くようにしている。
	  呼び元でもLoadしていない場合は,このProgramで一機に開くと,ネットワークリソース,パフォーマンスを取ってしまうことを制限している。
****************************************************************************************/
?>
<!DOCTYPE html>
<html lang="ja">
<head>
<link  href="viewer.min.css" rel="stylesheet">
<script src="viewer.min.js"></script>
<meta charset="UTF-8">
<style type="text/css">
body {background-color:#000000;color:#ffffff;margin-left:4px;font-family:Verdana,"Meiryo UI",sans-serif;font-size:80%;overflow-x:hidden;}
.head  {position:fixed !important;top:0;width:480px;height:24px;font-size:11px;background-color:#000000;}

.viewer-button { background-color:#333333; }					/* viewer.js :CSS Close Button */
.viewer-container { background-color: rgba(0, 0, 16, 0.8); }	/* viewer.js :CSS background (red green blue) */
/* Custmaize Style */ 
/* viewer-button : 右上に表示される閉じるボタンのstyle */
/* .viewer-button { position: absolute; overflow: hidden; cursor: pointer; background-color: #000; top: 0; left: 0; width: 100%; height: 100%; background-color: rgba(0, 0, 0, 0); } */
/* .viewer-canvas, .viewer-footer { z-index: 2000; } */ /* canvasとメニューよりも閉じるボタンが前面に来てるので、z-indexで前面に指定 */
/* .viewer-container { background-color: rgba(0, 0, 0, .9); } */
</style>
</head>
<body>

<?php
	$idimg="";$imgtag="path";$file="";$fit=0;$widthmax=0;$widthfix=0;$heightfix=0;$select="null";$param="";$amper_row="&";$slide="";
	$delimiter=';';$childdelim=":";$funcdelim="|";$amper="null";
	$Eventready="";$Eventbuilt="";$Eventshown="";$Eventview="";$Eventviewed="";$Eventzoom="";$Eventzoomed="";$Eventhide="";
	$MY_VERSION=basename(__FILE__,"")." 1.02 (30.06.2022)";

	foreach($_GET as $key => $get) {
		if(strtolower($key)=="id") {			// <img idが指定された
			$idimg = $get;
			continue;
			}
		if(strtolower($key)=="imgtag") {		// <img要素 attribute (src以外に指定TagでURLを取得)
			$imgtag = $get;						// 未指定時 attribute pathもチェック <img path="{URL}"
			continue;
			}
		if(strtolower($key)=="file") {			// FilePathが指定された
			$file = $get;
			continue;
			}
		if(strtolower($key)=="noselect") {		// 起動時Viewerを開かない
			$select = "null";
			continue;
			}
		if(strtolower($key)=="select") {		// 起動時Viewerを開く
			if ($get == "false") { continue; }	// same, noselectl
			$select="";									// "":{id}を開く
			if (($get !== "")&&($get !== "true")) {		// {select}をidとして開く
				$select = $get;
				}
			}
		if(strtolower($key)=="fit") {			// Window幅にFit
			$fit = 1;
			continue;
			}
		if(strtolower($key)=="width") {			// Widthを指定(Sourceは混在を回避のためfixを付加)
			if (is_numeric($get)) {
				$widthfix = $get;
				}
			continue;
			}
		if(strtolower($key)=="height") {		// Heightを指定(Sourceは混在を回避のためfixを付加)
			if (is_numeric($get)) {
				$heightfix = $get;
				}
			continue;
			}
		if(strtolower($key)=="amper") {			// Ampersandを変換対応
			$amper='"'.$get.'"';
			if ($get !=="") { $amper_row=$get; }
			}
		if(strtolower($key)=="widthmax") {		// width最大を指定
			if (is_numeric($get)) {
				$widthmax = $get;
				}
			continue;
			}
		if(strtolower($key)=="slide") {			// SlideShowModeを指定
			$slide="on";
			continue;
			}
		if(strtolower($key)=="delimiter") {		// options 区切り文字
			$delimiter=$get;
			continue;
			}
		if(strtolower($key)=="childdelim") {	// Parameter区切り文字
			$childdelim=$get;
			continue;
			}
		if(strtolower($key)=="funcdelim") {		// Function区切り文字
			$funcdelim=$get;
			continue;
			}
		if(strtolower($key)=="options") {		// optionsを設定
			$part = explode($delimiter,$get);
			foreach($part as $par) {
				$p = explode($childdelim,$par);
				if ((isset($p[1]))&&($p[1] !== "")) {
					 $param = $param."options['".$p[0]."']=".$p[1].";";
					 }
				else {
					 $param = $param."options['".$p[0]."']=".'true'.";";
					 }
				}
			continue;
			}
		if(strtolower($key)=="event") {			// Event Functionを設定
			$event=$get;
			$part = explode($funcdelim,$get);
			foreach($part as $par) {
				$p = explode($childdelim,$par);
				$func_event=strtolower($p[0]);
				$func="Event".$func_event;
				if (isset($p[1])) { ${$func}=$p[1]; }
				}
			}
		}
/***************************************************************************************
	heredocument HTML
	 {$widthmax}: 画像を指定サイズを最大とする。
	 {fit}      : 画像をWindowsのwidthに収めて表示する
	 {$param}   : viewer.js Parameter
	 {$idimg}   : When iframe, Display parent id  , Specify id or file ,Priority id.
	 {$file}    : Display File , Specify id or file ,Priority idmsg.
	 {$select}  : viewer.js ImageFile Select
	              起動時Viewerを開く。false:開かない(未指定時のDefault) true/"":{id}を開く。id:指定idを開く
************************************************************************************* */

print <<<EOM
<!--<div id="imggrp" style="visibility:hidden;">-->
<div id="imggrp" style="cursor: pointer;">
<img id="imgsrc" src="">
</div>

<div id="imgload" style="position:fixed;top:6px;left:3px;width:280px;height:20px;border: 1px solid #888888;font-size:10p;z-index:5;background-color:#2f2f2f;display:none;">
<div style="position:absolute;top:3px;left:100px;color:#ffa07a;">Loading</div>
</div>

<script type="text/javascript">
<!--
var options = {
	inline		: false,	// 右上ボタン: true:拡大ボタン , false:閉じるボタン
	title		: false,
	tooltip		: true,
	movable		: true,
	zoomable	: true,
	rotatable	: true,
	scalable	: true,
	fullscreen	: false,	// Android:Hermetが最大化でWhiteScreenのまま(最大化許可で止まっている?)
	toolbar		: true,
	interval	:3000,
	navbar		: false,	// 最下Thumbnail
	ready		: function (e) { EventReady(e); },		// 起動時
	built		: function (e) { EventBuilt(e); },
	shown		: function (e) { EventShown(e); },		// 画像クリック Event:show→shown→view→viewed
	view		: function (e) { EventView(e); },
	viewed		: function (e) { EventViewed(e); },		// [<][>]ボタンクリック Event:view→viewed
	zoom		: function (e) { EventZoom(e); },		// [+][:][-]ボタンクリック Event:zoom→zoomed
	zoomed		: function (e) { EventZoomed(e); },
	hide		: function (e) { EventHide(e); }		// 閉じたときのアクション Event:zoom→zoomed→hide
	};

	console.log("Parameter["+"{$param}"+"]");
	{$param}					// 起動元からのパラメータ
var	delimiter="{$delimiter}";	// Parametaer Delimiter
var	amper={$amper};				// ファイル名"&"対応(引数に&が使えないため)
var	widthmax={$widthmax};		// Widthを指定WidthにFit URLからに状態
var	fit={$fit};					// WidthをWindowSizeにFit URLからに状態
var	idimg='{$idimg}';			// <img要素 id
var	imgtag='{$imgtag}';			// <img要素 attribute (src以外に指定TagでURLを取得)
var	select="{$select}";			// URLからのセレクト状態要求id null , "" , id
var	selid="imgsrc";				// <img要素セレクト状態にするid 初期値
var	dspid="imgsrc";				// 表示要求id 初期値 HTMLのidをURLからid指定時変更のため遷移をkeep
var	file="{$file}";				// FilePathで要求
var	widthfix={$widthfix};
var	heightfix={$heightfix};
var	slidemode='{$slide}';		// URLからのslide指定時:slide:'on' 先頭の画像をClick状態にする
var	slidetop="";				// slide:'on'時先頭のHTML-idを設定

	console.log("id["+idimg+"] imgtag["+imgtag+"] select["+select+"] widthmax["+widthmax+"fit["+fit+"] widthfix["+widthfix+"] heightfix["+heightfix+"] file["+file+"] delimiter["+delimiter+"] amper["+amper+"]");

	if (idimg !=="") {			// iframe(親)から"<img"Tagidが指定されたときファイル名を取得する
		 DispViewId(idimg);
		 if (idary.length > 0) {														// EventListener 作成
			for (var i=0;i< idary.length;i++) {
				if ((slidemode == 'on') &&(i==0)) { slidetop=idary[i]; }				// URLからのslide指定時,先頭画像HTML-id
				document.getElementById(idary[i]).addEventListener("load",				// Image Load後発火
				function ArgImgEnd(event) {
//					alert(event.target.id);		// idを取得
					event.currentTarget.removeEventListener(event.type,ArgImgEnd);		// IE未対応のため removeEventListener
					DispViewId_Event();
					},
				{ once: true }
				);
				}
			}
		 idcnt=0;													// Image Onload EventのTrigger
		 DispViewId_Event();
		 }
	else if (file !=="") {
		 DispViewFile(file);	// global array:idaryを作成
		 }
	const id = document.getElementById('imggrp');
	const viewer = new Viewer(id , options);		// viewer.js kick
	if (select !== 'null') {
		document.getElementById(selid).click();		// 画像をClick
		}
	if (slidetop !== '') {							// URLからのslide指定時,先頭画像HTML-id
		document.getElementById(slidetop).click();	// 先頭画像をClick
		}
/* ---------- Event Function -------------------------------------------------------------- */
/*
	Event{EventName}(e) : Event Action
	 e : i  : Custom EventObect
*/
function EventReady(e) {
	console.log(e.type);
	{$Eventready}
	}
function EventBuilt(e) {
	console.log(e.type);
	{$Eventbuilt}
	}
function EventShown(e) {
	console.log(e.type);
	{$Eventshown}
	}
function EventView(e) {
	console.log(e.type);
	{$Eventview}
	}
function EventViewed(e) {
	console.log(e.type);
	{$Eventviewed}
	}
function EventZoom(e) {
	console.log(e.type);
	{$Eventzoom}
	}
function EventZoomed(e) {
	console.log(e.type);
	{$Eventzoomed}
	}
function EventHide(e) {
	console.log(e.type);
	{$Eventhide}
	}

/* **********************************************************************************
              viewerjs.php Call Function
*************************************************************************************/
var idary;					// Image File id Array
var idcnt;
/* ----------------------------------------------------------------------------------
	DispViewId(idimg) : Image File Display id指定
	  idimg      : i  : Display id delimiterで複数指定可 Ex)idImg001;idImg002
	   delimiter : {$delimiter} : Parametaer Delimiter
	   amper     : {$amper}     : ファイル名"&"対応(引数に&が使えないため)
	   widthmax  : {$widthmax}  : Widthを指定WidthにFit URLからに状態
	   fit       : {$fit};      : WidthをWindowSizeにFit URLからに状態
	   select    : {$select}    : URLからのセレクト状態要求id null , "" , id
------------------------------------------------------------------------------------ */
function DispViewId(idimg) {
	idary=res_ans = idimg.split(delimiter);
	document.getElementById("imgload").style.display ="block";
	for(var i=0; i < idary.length ; i++ ) {				// viewer.jsにidを読ませるため src=""を作成しておく 
		if (i == 0) {
			 document.getElementById("imgsrc").id=idary[i];
			 }
		else {
			 var img = document.createElement('img');
			 img.id=idary[i];
			 img.src="";
			 document.getElementById('imggrp').appendChild(img);
			 }
		RequestFileDisp("",idary[i],widthmax,fit);
		}

	if ((select != null)&&(select !== "")) {			// Select状態を作るためのセレクトidをチェック
		 selid=select;
		 }
	else if (idary.length ==1) {						// idが1個のみの場合
		 selid=idary[0];
		 }
	}

/*
	DispViewId() : Image File Display id指定 Event
	 Display id : idary[idcnt:counter]
*/
function DispViewId_Event() {
	if (idcnt >= 1) { _DispViewId_Event_nodisp(); }		// idarv#1表示完了Event,HTMLがBlockをnone(非表示)(src=""時のリンク切れを隠す)
	imgobj=DispViewId_Image(idcnt);						// Image Display
	if(imgobj) {
		if ((fit == 1)||(widthmax > 0)) {				// fit/widthmax指定時は表示終了後にサイズを判定
			RequestFileSizeSet(idary[idcnt]);
			}
		if (idcnt < idary.length) {
			 idcnt++;
			 }
		 }
	else {												// FilePathが""のとき,有効までカウント
		 idcnt++;
		 if (i < idary.length) {
			 DispViewId_Event(idcnt);					// 全ての画像Kickまで再起
			 }
		 }
	if (idcnt < idary.length) { } else { _DispViewId_Event_nodisp(); }	// idarv#1表示完了Event,HTMLがBlockをnone(非表示)(src=""時のリンク切れを隠す)
	}

/*
	_DispViewId_Event_nodisp() : HTMLがBlockをnone(非表示)
	※src=""時のリンク切れを隠す
*/
function _DispViewId_Event_nodisp() {
	if (document.getElementById("imgload").style.display =="block") {
		document.getElementById("imgload").style.display ="none";
		}
	}

/*
	DispViewId(i) : Image File Display id指定 HTML-id display
	  i    : i  : idary : counter idary[i]
	              [0]: parent object / [n]:appendChild
*/
function DispViewId_Image(i) {
	parentWin=window.parent;
	if (parentWin.document.getElementById(idary[i]).getAttribute(imgtag)) {
		 file=parentWin.document.getElementById(idary[i]).getAttribute(imgtag);
		 }
	else {
		 file=parentWin.document.getElementById(idary[i]).src;
		 }
	var regex = /(&)/g;		// iframe(親)からLocalFileを読んでいるとき&が変換されていないとき変換する
	if (amper !== null) {
		if (amper !== "") {
			file = file.replace(/{$amper_row}/g,'&');		// パターンにより変換 regexに指定ない文字は変換されない。
			}
		file=RequestURLEncode(file,regex);					// URL Encode
		}
	if (file !== "") {
		 imgobj=RequestFileDisp(file,idary[i],widthmax,fit);
		 }
	else {
		 imgobj=false;
		 }
	return(imgobj);
	}

/* ----------------------------------------------------------------------------------
	DispViewFile(file) : Image File Display File指定
	  file     : i  : Image Path (URL Encodeされていること)
	   delimiter : {$delimiter} : Parametaer Delimiter
	   amper     : {$amper}     : ファイル名"&"対応(引数に&が使えないため)
	   widthmax  : {$widthmax}  : Widthを指定WidthにFit URLからに状態
	   fit       : {$fit};      : WidthをWindowSizeにFit URLからに状態
------------------------------------------------------------------------------------ */
function DispViewFile(file) {
	var regex = /(&)/g;							// iframe(親)からLocalFileを読んでいて"&"が変換されていないとき変換する
	if (amper !== null) {
		if (amper !== "") {
			file = file.replace(/{$amper_row}/g,'&');		// パターンにより変換 regexに指定ない文字は変換されない。
			}
		file=RequestURLEncode(file,regex);					// URL Encode
		}
	if (file !== "") {
		 RequestFileDisp(file,dspid,widthmax,fit);
		 }
	if ((fit == 1)||(widthmax > 0)) {						// fit/widthmax指定時は表示終了後にサイズを判定
		var images = document.getElementsByTagName('img');
		RequestFileSizeSet(dspid);
		}
	if (select != null) {						// Select状態を作るためのセレクトidをチェック
		 selid=dspid;
		 }
	}

/* **********************************************************************************
              viewerjs.php Function
*************************************************************************************/
/*
	RequestFileDisp(file,id,widthmax,fit) : Image File Display & Size設定
	  file    : i  : Image Path (URL Encodeされていること)
	   id       : i  : Display id
	   widthfix :{widthfix} : Width Fix 固定値
	   heightfix:{heightfix}: heightFix 固定値
*/
function RequestFileDisp(file,id) {
	var imgobj = document.getElementById(id); 
	if (widthfix > 0) {
		imgobj.style.width=widthfix+'px';
		}
	if (heightfix > 0) {
		imgobj.style.height=heightfix+'px';
		}
	if (file !="") {										// Fileの説明をセット
		var str=unescape(file);
		var ary=str.split('/');
		imgobj.alt=ary[((ary.length)-1)];
		}
	imgobj.src=file;
	return(imgobj)
 	}

/*
	RequestFileSizeSet(id) : Image File Style File Prporatyから設定
	  id      : i  : Display id
	   widthmax : {$widthmax}  : Widthを指定WidthにFit URLからに状態
	   fit      : {$fit};      : WidthをWindowSizeにFit URLからに状態
	※ 画像サイズを起動パラメタから設定する {$fit}:Window Fit / {$widthmax}:Size Fit
*/
function RequestFileSizeSet(id) {
	console.log("fit["+fit+"] widthmax["+widthmax+"] window.innerWidth["+window.innerWidth+"] window.innerHeight["+window.innerHeight+"]");

	if ((fit == 1)||(widthmax > 0)) {
		if (widthmax > window.innerWidth) {
			widthmax = window.innerWidth;
			}
		if (widthmax > document.getElementById(id).width) {
			 if (window.innerHeight < document.getElementById(id).height) {
				document.getElementById(id).style.height=window.innerHeight+'px';
				}
			 }
		else if (widthmax == document.getElementById(id).width) {
			 }
		else {
			 document.getElementById(id).style.width=widthmax+'px';
			 }
		}
	}

/*
	RequestURLEncode(str,exmap) : URL Encods :URLで使用不可文字をEncode
	  str     : i   : Request String
	  exmap   : i   : Extend Map 特定文字をEncode時指定する 変換文字を|で区切り指定 Ex)var regex = /(&| |!/g;
	  @return : o   : Encode String
*/
function RequestURLEncode(str,exmap) {
	// map:変換パターン連想配列 regex:変換文字設定
	var map= {"%":'%25'," ":'%20',"!":'%21',"\"":'%22',"#":'%23',"$":'%24',"&":'%26',"'":'%27',"(":'%28',")":'%29',"*":'%2A',"+":'%2B',",":'%2C',"/":'%2F',":":'%3A',";":'%3B',"<":'%3C',"=":'%3D',">":'%3E',"?":'%3F',"@":'%40',"[":'%5B',"]":'%5D',"^":'%5E',"`":'%60',"{":'%7B',"|":'%7C',"}":'%7D',"~":'%7E' ,"&":'%26' };
	var regex = /(%| |!|\"|#|\$|&|\'|\(|\)|\*|\+|,|\/|:|;|<|=|>|\?|@|\[|]|\^|`|{|\||}|~|&)/g;		// 変換文字を|で区切り指定 (" Not Escape)

	if (exmap == null) { }
	else {
		 regex=exmap;
		 }
	var rep = function(whole,pl) {			// 無名関数の参照をrepにreturn
		return map[pl];
		}
	var result = str.replace(regex,rep);	// パターンにより変換 regexに指定ない文字は変換されない。
	return result;
	}

/*
	RequestParentUnload(id) : Parent HTML Unload 
	  id     : i   : Request ParentUnload HTML-id
*/
function RequestParentUnload(id) {
	window.parent.document.getElementById(id).style.display='none';
	}

-->
</script>
<div><BR>Click the image to open the viewer</div>
<div style="text-align:right;font-size:9px;"><BR>{$MY_VERSION}</div>
EOM;

?>

</body>
</html>
