<?php
/***************************************************************************************
	mpdartlist.php : Directory Image File Display

	Linkage Source
	 ApplicationLibrary   :require:{SelfDirectory}/{CallSourceModule}.lib_appli.php →(ファイルがない時) {SelfDirectory}/mpdweb.lib_appli.php
	 mpdweb Series Library:require:{SelfDirectory}/{CallSourceModule}.lib.php       →(ファイルがない時) {SelfDirectory}/mpdweb.lib.php
	 mpdweb Series StyleSheet:link:{SelfDirectory}/{CallSourceModule}.common.css    →(ファイルがない時) {SelfDirectory}/mpdweb.common.css
	 mpdweb Series Jsp       :src :{SelfDirectory}/{CallSourceModule}.common.js     →(ファイルがない時) {SelfDirectory}/mpdweb.common.js
	呼び元のモジュール名に合わせたSourceをリンクする。本シリーズを同一ディレクトリ下に配置する必要がある
	  デバック時の環境作成/複数環境の作成
	  呼び元のデザインに合わせることができる(本モジュールは呼び元に対しての設定をすることができる)
	を考えてのことだが,各モジュールのFunction/HTML idなど名称を合わせる必要がある

	既存の問題
	 1. HistoryBackでmpdweb.phpと行き来で,URLが大きくなると,戻り機能が不可
	 2.Androidで表示時,サムネイルの比率設定時、横が大きくなった時,全体のWidthが大きくなっている。
****************************************************************************************/
namespace MyProject;
/*
	Same Mpdule : mpdweb.lib_appli.php:ArgDecode() / mpdweb.lib.php: , get_config()
*/
/***************************************************************************************
	mpdartlist.php Post Process
	ajax(javascript) からのPostを受信しトランザクション処理
****************************************************************************************/
if (isset($_POST['p'])) {
	$ARG=PostAnalyze();
	$require_mod=dirname(__FILE__).'/mpdweb.lib.php';						// Mpd XML Basic Library mpdweb.lib.php
	$require_liba=dirname(__FILE__).'/mpdweb.lib_appli.php';				// mpd Application Library
	if ($REQ_MODULE !=="") {												// $REQ_MODULEは最終的には,GetEnvCommonで決定するが,index.phpに対してのlib.phpは作成しないため、ここで決定する。
		if  (file_exists(dirname(__FILE__).'/'.basename($REQ_MODULE,".php").'.lib.php')) {
			$require_mod=dirname(__FILE__).'/'.basename($REQ_MODULE,".php").'.lib.php';		// Mpd XML Library mpd{module}.lib.php
			}
		if   (file_exists(dirname(__FILE__).'/'.basename($REQ_MODULE,".php").'.lib_appli.php')) {
			$require_liba=dirname(__FILE__).'/'.basename($REQ_MODULE,".php").'.lib_appli.php';	// Mpd XML Library mpd{module}.lib.php
			}
		}
	require_once($require_mod);				// Mpd : Original Library mpdweb.lib.php
	require_once($require_liba);			// Mpd : Original Library mpdweb.lib_appli,php
	GetEnvCommon();
	foreach($XML_ViewExtend["mode"] as $key => $mode) {					// GetEnvCommon()で外部定義があるときの処理
		if ($mode=="1") { require_once($XML_ViewExtend["source"][$key]); }
		if ($mode=="2") { include_once($XML_ViewExtend["source"][$key]); }
		}
	if ($ARG["p"]=="imgsize") {
		 $imgfile="";
		 if (isset($ARG["file"])) {
			$imgfile=$ARG["file"];
			}
		 PostImgsize($imgfile);
		 }
	if ($ARG["p"]=="imginfo") {
		 $imgfile="";
		 if (isset($ARG["file"])) {
			$imgfile=$ARG["file"];
			}
		 PostImginfo($imgfile);
		 }
	exit;
	}
/* -----------------------------------------------------------------------------
	PostAnalyze() : Argument Analyze
	@rerutn : o  : Argument
----------------------------------------------------------------------------- */
function PostAnalyze() {
	global $REQ_MODULE;

	$ARG=array();
	foreach($_POST as $key => $get) {		// ArgAnalyze($_GET)と同じ形式にする
		$ARG[$key]=\MyProject\ArgDecode($get);	// namespace MyProject
		}
	$REQ_MODULE="";
	if (isset($ARG["mod"])) {
		$REQ_MODULE=$ARG["mod"];
		}
	return($ARG);
	}

/* -----------------------------------------------------------------------------
	 PostImgsize($Img_file) : Post ImageFile Size
	 $Img_file :i  : Image File
	 StanderdOut value: imgwidth:ImageWidth/imgheight:Imageheight/dispsize:DisplaySize
----------------------------------------------------------------------------- */
function PostImgsize($Img_file) {
	global $GImgfile,$Gimagesize;

	print "PostSend PostImgsize Start\n";
	$GImgfile=NULL;$Gimagesize=NULL;
	$retwidth="";$rethigth="";$clip=NULL;$EditAspect="";
	$dispsize=ArgImageSize($Img_file,"474:aspect","Image",$imgwidth,$imghigth,$clip,$retwidth,$rethigth);	// 速度の点より,LocalPathでサイズを求める
	$EditAspect=_DispDirAlbumEditAspect($retwidth,$rethigth);
	print "value:imgwidth=".$retwidth."\n";			// 幅
	print "value:imgheight=".$rethigth."\n";		// 高
	print "value:dispsize=".$dispsize."\n";			// 表示サイズ
	print "value:EditAspect='".$EditAspect."'\n";	// 表示サイズ

	print "PostSend PostImgsize End\n";
	}

/* -----------------------------------------------------------------------------
	PostImginfo($Img_file) : Post ImageFile Attri
	 $Img_file :i  : Image File
	 StanderdOut value:imgsize:FileSize/imgmodi:FileModifi Date time
----------------------------------------------------------------------------- */
function PostImginfo($Img_file) {
	PostImgsize($Img_file);
	print "PostSend PostImginfo Start\n";
	$size=filesize($Img_file);
	$time=filemtime($Img_file);
	print "value:imgsize='Size\&nbsp;\&nbsp;\&nbsp;\&nbsp;\&nbsp;:\&nbsp;".(floor($size/10)/100)."\&nbsp;kbyte'\n";		// &はEscapeする\&
	print "value:imgmodi='Modifi\&nbsp;\&nbsp;:\&nbsp;".(date('Y\/m\/d H:i:s',$time))."';\n";
	print "PostSend PostImginfo End\n";
	}
///////// Post Process End ////////////////////////////////////////////////////////////
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<?php
/***************************************************************************************
	Eenvironment
	<Html_config><lang>jp</lang>     : html lang={lang}
	             <favicon></favicon> : html <link {favicon}> : rel="shortcut icon" href=/mpdwebfavicon.ico>
****************************************************************************************/
ini_set('display_errors',0);						// エラー表示設定
$ERR_MESSAGE="";
$STS_MESSAGE="";

GetEnvCommon("load");							// 初期で"$XML_HISTORY"を使用するためXML設定をLoadする
$XML_HISTORY=array("BackTag"=>"burl");			// HistoryBackの設定 BackURL Tagを得る
\MyProject\get_config("History",$XML_HISTORY);	// 後にGetEnvCommon()で設定し直すArgAnalyzeを有効にする
$ARG=ArgAnalyze();
ini_set('display_errors',1);			// エラー表示設定
$require_mod=dirname(__FILE__).'/mpdweb.lib.php';						// Mpd XML Basic Library mpdweb.lib.php
$require_liba=dirname(__FILE__).'/mpdweb.lib_appli.php';				// mpd Application Library アプリケーション層は即使用する
if ($REQ_MODULE !=="") {												// $REQ_MODULEは最終的には,GetEnvCommonで決定するが,index.phpに対してのlib.phpは作成しないため、ここで決定する。
	if  (file_exists(dirname(__FILE__).'/'.basename($REQ_MODULE,".php").'.lib.php')) {
		$require_mod=dirname(__FILE__).'/'.basename($REQ_MODULE,".php").'.lib.php';		// Mpd XML Library mpd{module}.lib.php
		}
	if   (file_exists(dirname(__FILE__).'/'.basename($REQ_MODULE,".php").'.lib_appli.php')) {
		$require_liba=dirname(__FILE__).'/'.basename($REQ_MODULE,".php").'.lib_appli.php';	// Mpd XML Library mpd{module}.lib.php
		}
	}
require_once($require_mod);				// Mpd : Original Library mpdweb.lib.php
require_once($require_liba);			// Mpd : Original Library mpdweb.lib_appli.php
$require_ses=dirname(__FILE__).'/mpdcmnses.lib.php';	// Mpd Session id Library
if  (file_exists($require_ses)) { require_once($require_ses); }		// Mpd mpdcmnses.lib.phpの存在確認&require
$SESSION_CONF=GetSessionConfig();									// php Session Config
ArgSessionStart($SESSION_CONF);										// Start Session : Used mpdcmnses.lib.php

$ERR_MESSAGE=GetEnvCommon();
if ($XML_DISP["MagnifyRatio"] == '0') { 	// 0設定時固定値を設定
	$XML_DISP["MagnifyRatio"]='5';
	}
if ($XML_DISP["MagnifySize"] == '0') {
	$XML_DISP["MagnifySize"]='2000';
	}
ini_set('display_errors',0);			// エラー表示設定

foreach($XML_ViewExtend["mode"] as $key => $mode) {		// GetEnvCommon()で外部定義があるときの処理
	if ($mode=="1") { require_once($XML_ViewExtend["source"][$key]); }
	if ($mode=="2") { include_once($XML_ViewExtend["source"][$key]); }
	}

$HTML_CONFIG=array("lang"=>"ja","favicon"=>"");
GetAlterConfig("Html_config",$HTML_CONFIG);	// Alternative get_config

echo <<<EOM
<html lang="{$HTML_CONFIG["lang"]}">
<head>
EOM;
if ($HTML_CONFIG["favicon"] !== "") {
	print '<link '.$HTML_CONFIG["favicon"].'>';
	}
ArgJsBuiltin("InitLoad");							// Initial Load Setting Output

/***************************************************************************************
	mpdartlist.php Jsp Process
****************************************************************************************/
echo <<<EOM
<script type="text/javascript">
<!--
var REQUEST_UA ='{$REQ_UA}';					// Used JS USER_AGENT
var IMG_CLOSE  ='{$XML_DISP["ImgCloseMin"]}';	// DispImage Image Close when enlarged and displayed at minimum : Cloce:on / off
var IMG_CONTI  ='{$XML_DISP["ImgSelectConti"]}';	// DispImage Prev|Next|ImageView表示中にThumbnailSelect :on / off
var MAGNIFY_RATIO  = parseInt('{$XML_DISP["MagnifyRatio"]}');	// DispImage Image Maximum magnification factor
var MAGNIFY_SIZE   = parseInt('{$XML_DISP["MagnifySize"]}');	// DispImage Image Maximum expanded size (MagnifyRatioで計算時の上限)
var ERSTR = '{$ERSTR}'
var IDMSGBOX = '{$IDMSGBOX}'
var LoadDispWSec= parseInt('{$XML_DISP["LoadDispWSec"]}');		// Disp Loading Icon WaitSec
-->
</script>
EOM;

print '<script type="text/javascript"><!--';					// PHP自URL関連JS化
JsPHPServerVar();
print '--></script>';

?>
<script type="text/javascript">
<!--
var slide_min=0;
rotate_val   =0; 

window.onscroll = function() { RequestScrollStop(); }	// 標準のMouse 最終位置監視

/* ------------------------------------------------------------------------------------
	RequestScrollStop() : Last Scroll Stoper : HTML全体のスクロールに対して有効
	  Windowサイズが不定の場合に使用する。RequestScrollPositon()と共に使用
	起動時:window.onscroll  PHPから値設定後実行:JsListLastPosition()
------------------------------------------------------------------------------------- */
//	PHPから実行。使用時設定する : PHP:JsListLastPosition()
//	I/F Public Item
//	  var HeadPos={Pos};    先頭のHtml Posiston
//	  var idTop={1St id};   先頭のHtml id
//	  var idLast={Last id}; 最後のHtml id
//	  var lastleft={leftL}; Postion時 Left位置 "auto"時自動,他(数値時)はLeftを強制的にセットする
function RequestScrollStop() {
	if ('idTop' in this) {						// 変数'idTop'が定義されていないかチェック
		} else {
		return;
		}
	if (document.getElementById(idTop) == null) {		// 先頭のidをチェック
		return;
		}
	if (document.getElementById(idLast) == null) {		// 最後のidをチェック
		return;
		}
	var elemTop = document.getElementById(idTop);		// 先頭の位置を求める
	var Top = elemTop.getBoundingClientRect();
	var elemLast = document.getElementById(idLast);		// 最後の位置を求める
	var Last = elemLast.getBoundingClientRect();

	if (HeadPos >= Last.top) {							// 最後の要素を超えたスクロールを判定
		var scroll=Last.top -Top.top
		if (lastleft == "auto") {
			 window.scrollTo(Last.left,scroll);				// 最後にスクロール
			 }
		else {
			 window.scrollTo(lastleft,scroll);				// 最後にスクロール
			 }
		}
	}

/* ------------------------------------------------------------------------------------
	RequestScrollPositon() : Last Scroll Positon 指定位置にPosition HTML全体をスクロール(Postion Fixdは移動しない)
	  Windowサイズが不定の場合に使用する。RequestScrollStop()と類似 
	PHPから表示内容完了時:JsListPosition() PostCallback:JsDispPosition()  DispSearch:SearchScrollStop()
------------------------------------------------------------------------------------- */
val = "";		// 指定位置,初期値
// 	 PHPから実行。使用時設定する : PHP:JsListPosition()
//		var val = {str};      : 指定位置
//		var valhigh  = {pos}; : Headからの補正値(Header Higth)
//		var valleft = {left}; : Leftからの補正値
function RequestScrollPositon() {
	if (document.getElementById(val)) {
		var element = document.getElementById(val);		// スクロール要素の位置を取得
		var rect = element.getBoundingClientRect();
		var topval = rect.top- valhigh;					// Headまでを補正
		var leftval=rect.left;
		if (valleft != 0) {								// Left補正が指定されたときは補正
			leftval=rect.left + valleft;
			}
		if (topval < 0) {							// 大きすぎる値が設定された場合でも0を最低にする(ロジック的にはしなくても良いが)
			topval=0;
			}
		window.scrollTo(leftval,topval);			// スクロール
		}
	RequestUnLoadDisp();
	}

/* ------------------------------------------------------------------------------------
	RequestBoxDisp(boxid) : Upper Box ディスプレイ
		boxid : i  : Box id
------------------------------------------------------------------------------------- */
function RequestBoxDisp(boxid) {
	if (document.getElementById(boxid) == null) {		// idが表示されていれば続行
		return;
		}
	document.getElementById(boxid).style.display='block';	// idlodingmsgを表示にする display: none;→block
	}

/*
	RequestBoxDisp(boxid) : Upper Box ディスプレイ解除
		boxid : i  : Box id
*/
function RequestBoxtUnLoad(boxid) {
	if (document.getElementById(boxid) == null) {		// idが表示されていれば続行
		return;
		}
	document.getElementById(boxid).style.display='none';
	}

var GObjSTime;				// 起動待ちの時計マーク Objectid
/* ------------------------------------------------------------------------------------
	RequestLoadDisp(waitsec) : 起動待ちの時計マークディスプレイ
		waitsec : i  : Display Timeout(Sec) 0:Limit(Net Timeoutまで),null:defult,{n}:指定時{n}sec
		styleを使用し id=idlodingmsgをOn/Offする
		id=idlodingmsgは<BODY>などに設定しておく
			style:#idlodingmsg:待ちのイメージをこの名前で作成しておく
			<body><div id="idlodingmsg"></div>
------------------------------------------------------------------------------------- */
function RequestLoadDisp(waitsec){
	if (waitsec == 0) {
		 sleep=LoadDispWSec*1000;
		 }
	else if (waitsec == null) {
		 sleep=10000;
		 }
	else {
		 sleep=waitsec*1000;
		 }
	document.getElementById('idlodingmsg').style.display='block';	// idlodingmsgを表示にする display: none;→block

	var element = document.createElement('div'); 					// ロック用のdivを生成 透明，最大画面を最上位に表示
	element.id = "screenLock"; 										// ロック用のスタイル
	element.style.height = '100%'; 
	element.style.left = '0px'; 
	element.style.position = 'fixed';
	element.style.top = '0px';
	element.style.width = '100%';
	element.style.zIndex = '100';									// PlayPanel(id=idFormCtl)よりz-indexを下げている
	element.style.opacity = '0';
	var objBody = document.getElementsByTagName("body").item(0); 
	objBody.appendChild(element);

	if(GObjSTime) { clearTimeout(GObjSTime);GObjSTime=null; }			// Timer Unloak
	GObjSTime=setTimeout( function() { RequestUnLoadDisp(); },sleep);	// ロック画面の削除
	}

/*
	RequestUnLoadDisp() 起動待ちの時計マーク解除
*/
function RequestUnLoadDisp(){
	document.getElementById('idlodingmsg').style.display='none';

	id_name='screenLock';
	if (document.getElementById(id_name) == null) {
		return;
		}

	if(GObjSTime) { clearTimeout(GObjSTime);GObjSTime=null; }			// Timer Unloak
	var dom_obj = document.getElementById(id_name);
	var dom_obj_parent=dom_obj.parentNode;
	dom_obj_parent.removeChild(dom_obj);
	}

/* ------------------------------------------------------------------------------------
	RequestBoxDisp(boxid) : Upper Box ディスプレイ
		boxid : i  : Box id
------------------------------------------------------------------------------------- */
function RequestBoxDisp(boxid) {
	if (document.getElementById(boxid) == null) {			// idが表示されていれば続行
		return;
		}
	document.getElementById(boxid).style.display='block';	// display: none;→block
	}

/*
	RequestBoxDisp(boxid) : Upper Box ディスプレイ解除
		boxid : i  : Box id
*/
function RequestBoxtUnLoad(boxid) {
	if (document.getElementById(boxid) == null) {		// idが表示されていれば続行
		return;
		}
	document.getElementById(boxid).style.display='none';
	}

/* -------------------------------------------------------------------------------------
	RequestHTMLLength(id,font_size,lineHeight) : 文字数に対応したfont-size,line-Height指定
	 id         : i  : HTML-id
	 font_size  : i  : Font-sizeをStyle形式で指定   "":HTML-idのFont-Size   例)"12px"
	 lineHeight : i  : HTML-idに入るときのline-HeightをStyle形式で指定 "":HTML-idの Default
------------------------------------------------------------------------------------- */
function RequestHTMLLength(id,font_size,lineHeight) {
	var RollFontSize=font_size;
	var divElement = document.getElementById(id);
	var text = divElement.innerHTML;
	var divWidth = divElement.offsetWidth;
	var spanElement = document.createElement("span");
	spanElement.innerHTML = text;
	spanElement.style.visibility = "hidden";
	spanElement.style.whiteSpace = "nowrap";
	if (font_size=="") {
	  	 spanElement.style.fontSize = window.getComputedStyle(divElement).getPropertyValue("font-size");
		 }
	else {
		 spanElement.style.fontSize = RollFontSize;
		 }
	document.body.appendChild(spanElement);
	var textWidth = spanElement.offsetWidth;
	document.body.removeChild(spanElement);
	if (textWidth > divWidth) {
		document.getElementById(id).style.fontSize="";
		return(1);
		}
	else
		{
		document.getElementById(id).style.fontSize=spanElement.style.fontSize;
		document.getElementById(id).style.lineHeight=lineHeight;
		}
	return(0);
	}

/* ------------------------------------------------------------------------------------
	RequestBoxImage(imgfile,size) : Image Box Display
		imgfile : i  : Image File
		size    : i  : Width Size
------------------------------------------------------------------------------------ */
var imgbarleft="";var imgbartop="";						// TitleBarの初期Keep
function RequestBoxImage(imgfile,size,title) {
	if ((IMG_CONTI=="on")&&(document.getElementById("image").style.display=="block")) {		// SlideBarを開いた状態での画像選択は状態を継続する
		document.getElementById("boximg").src =imgfile;
		return;
		}
														//  SlideBarを閉じた状態では初期に戻す。
	document.getElementById("image").style.width = size+'px';
	document.getElementById("boximg").src =imgfile;
	document.getElementById("boximg").style.width = size+'px';
	document.getElementById("boximg").onclick = BOXIMG_FUNC;
	if (document.getElementById("idimgbar")) {
		if (imgbarleft !== "") {							// TitleBarを初期に戻す
			 document.getElementById("idimgbar").style.left=imgbarleft;
			 document.getElementById("idimgbar").style.top=imgbartop;
			 }
		else {												// TitleBarの初期をKeep
			 imgbarleft=document.getElementById("idimgbar").style.left;
			 imgbartop=document.getElementById("idimgbar").style.top;
			 }
		document.getElementById("idimgbartit").innerText=title;
		}
	document.getElementById("boxslide").min = size;		// Input Range Property
	slide_min=size;

	var mag_size= MAGNIFY_RATIO * size;
	if (mag_size > MAGNIFY_SIZE) {
		mag_size=MAGNIFY_SIZE;
		}
	document.getElementById("boxslide").max = mag_size;
	document.getElementById("boxslide").value = size;

	document.getElementById("imgrande").innerHTML = size;
	if (REQUEST_UA == 'PC') {
		 init_point=-44;
		 }
	else {
		 init_point=-14;
		 }
	RequestBoxDisp("image");
	RequestBoxDisp("imgFrame");
	if (document.getElementById("idimgbar")) {
		changeSize(size);				// 一旦表示しているが,Resizeし引数sizeの大きさにする
		}
	changeRotate(0);					// 前回の値で初期回転する
	}

/*
	changeSize(size) : Slide Bar Image Resize
		size  : i  : Slide Resize
*/
function changeSize(size) {
	document.getElementById("boximg").style.width = size;
	document.getElementById("imgrande").innerHTML = size;		// WidthをSlid左に表示
	if ((slide_min >= size)&&(IMG_CLOSE =="on")) {				// <ImgCloseMin>最小時のみCloceの設定時unLoad
		 document.getElementById("boximg").onclick = function() { RequestBoxtUnLoad('image');RequestBoxtUnLoad('imgFrame'); };
		 }
	else {
		 document.getElementById("boximg").onclick=BOXIMG_FUNC;
		 }

	if ((rotate_val == 90)||(rotate_val == 270)) {
		 changeRotate(0);
		 }
	else {
		 changeBarSize();
		 }
	}

/*
	changeRotate(rotate) : Slide Bar Image Resize
		rotate : i  : Rotate 90度単位で指定 0/90/180/270 (補正値:表示中の回転に加算値)
	※現在 90度単位の回転のみ対応。回転できるがPostionが未対応

	webkitTransformOrigin / transformOrigin
*/
function changeRotate(rotate) {
	rotate_val = document.getElementById("idrotate").value;
	rotate_val=parseInt(rotate_val)+rotate;
	if (rotate_val >= 360) {
		rotate_val=0;
		}
	document.getElementById("idrotate").value = rotate_val;				// 回転角度をボタンに表示
	pos_top=-16;
	if (REQUEST_UA == 'PC') {
		 pos_top=-46;
		 if ((rotate_val == 0)||(rotate_val == 180)) {
			  document.getElementById("boximg").style.transformOrigin = "50% 50%";
			  }
		 else {
			  document.getElementById("boximg").style.transformOrigin = "top left";
			  }
		 document.getElementById("boximg").style.transform = "rotate("+rotate_val+"deg)";	// PC時の回転
		 if ((rotate_val == 0)||(rotate_val == 180)) {						// 回転後のPositon移動
			  document.getElementById("imgFrame").style.left = 0;
			  document.getElementById("imgFrame").style.top  = pos_top;
			  }
		 else if (rotate_val == 90) {
			  document.getElementById("imgFrame").style.left = parseInt(document.getElementById("imgFrame").getBoundingClientRect().height);
			  document.getElementById("imgFrame").style.top  = pos_top;
			  }
		 else {
			  document.getElementById("imgFrame").style.left = 0;
			  document.getElementById("imgFrame").style.top  = parseInt(document.getElementById("boximg").style.width)+pos_top+4;
			  }
		 }
	else if ((rotate_val == 0)||(rotate_val == 180)) {						// 携帯端末の回転
		 document.getElementById("boximg").style.webkitTransform = "rotate("+rotate_val+"deg)";
		 }
	else {
		 var rot_width=parseInt(document.getElementById("boximg").style.width);
		 var raito=imgwidth/rot_width;
		 var rot_height=imgheight/raito;
		 document.getElementById("boximg").style.webkitTransform = "translate("+(rot_height-rot_width)/2+"px,"+(rot_width-rot_height)/2+"px) rotate("+rotate_val+"deg)";
		 }
	if ((rotate_val == 0)||(rotate_val == 180)) {						// 回転後のPositon移動
		 document.getElementById("imgFrame").style.left = 0;
		 document.getElementById("imgFrame").style.top  = pos_top;
		 }
	bar_top=74;bar_left=5;
	document.getElementById("idimgbar").style.left = bar_left;
	document.getElementById("idimgbar").style.top  = bar_top;
	changeBarSize();
	}

/*
	changeBarSize() :TitleBar Resize
*/
function changeBarSize() {
	rotate=document.getElementById("idrotate").value;
	size=document.getElementById("imgrande").innerHTML;

	if ((rotate == 0)||(rotate == 180)) {						// 回転後のPositon移動
		 bar_size=parseInt(size)+4;
		 }
	else {
		 raito=imgwidth/parseInt(document.getElementById("boximg").style.width);
		 bar_size=imgheight/raito;
		 }
	if ((REQUEST_UA !== 'PC')&&(bar_size >= SCREEN_WIDTH)) {									// PCのときはタイトルバーもReSize
		 document.getElementById("idimgbar").style.width = SCREEN_WIDTH;
		 }
	else {
		 document.getElementById("idimgbar").style.width = bar_size;
		 }
	}

/*
	changeMoveObj() : TitleBar ,Image Move
	 MoveDragOn/MoveDragImgのCallBack 回転した場合の位置補正
*/
function changeMoveObj() {
	if (document.getElementById("idrotate").value == '90') {
		movedef=parseInt(document.getElementById("imgFrame").getBoundingClientRect().height);
		document.getElementById("imgFrame").style.left=parseInt(document.getElementById("imgFrame").style.left)+movedef;
		}
	if (document.getElementById("idrotate").value == '270') {
		movedef=parseInt(document.getElementById("imgFrame").getBoundingClientRect().width);
		document.getElementById("imgFrame").style.top=parseInt(document.getElementById("imgFrame").style.top)+movedef;
		}
	}

/*
	changeMoveBar() : Image Move ,TitleBar
	 MoveDragOn/MoveDragImgのCallBack 回転した場合の位置補正
*/
function changeMoveBar() {
	movetop=parseInt(document.getElementById("imgFrame").style.top);
	moveleft=parseInt(document.getElementById("imgFrame").style.left);
	if ((document.getElementById("idrotate").value == '0')||(document.getElementById("idrotate").value == '180')) {
		 document.getElementById("idimgbar").style.top=movetop+120;
		 document.getElementById("idimgbar").style.left=moveleft+5;
		 }
	else if (document.getElementById("idrotate").value == '90') {
		 movedef=parseInt(document.getElementById("imgFrame").getBoundingClientRect().height);
		 document.getElementById("idimgbar").style.top=movetop+120;
		 document.getElementById("idimgbar").style.left=moveleft-movedef+5;
		 }
	else if (document.getElementById("idrotate").value == '270') {
		 movedef=parseInt(document.getElementById("imgFrame").getBoundingClientRect().width);
		 document.getElementById("idimgbar").style.top=movetop+120-movedef;
		 document.getElementById("idimgbar").style.left=moveleft+7;
		 }
	}

/* -------------------------------------------------------------------------------------
	Extend View : タイトルバー各機能（拡張ビューワ)
	ExtendWinMax : ExtendWinMax=false:最大化していない , true:最大化
-------------------------------------------------------------------------------------- */
ExtendWinMax=false;									// ExtendWinMax=false:最大化していない, true:最大化
exd_top=60;exd_left=3;exd_width=478;				// タイトルバー[-]クリック時戻すサイズ(初期値)。XMLでの設定で変更できる
waptop=74;wapheight=634;frmwidth=exd_width-6;frmheight=634-8;

/*
	DispExtendWinCreate(title,source) : ExtendViewをCreate
	 title  : ExtendView Title Bar Name
	 source : View Source (Path:URL形式)
*/
function DispExtendWinCreate(title,source) {
	document.getElementById('idExtendTit').innerText=title;
	document.getElementById('idExtendTitMax').innerText=title;
	document.getElementById('idExtFrm').src=source;							// sourceの形式がJSでなぜが http:/Music.. -> http://{Server}/Musicに変換される(Keepする場合iframe.srcを使用する)
	if (document.getElementById('idExtendTool')) {							// ViewerのToolBox
		document.getElementById('idExtendTool').file=document.getElementById('idExtFrm').src;	// iframeのSourceをidExtendTool;file=""にKeep
		}
	if (ExtendWinMax) {
		 RequestBoxDisp('idExtendMax');
		 }
	else {
		 RequestBoxDisp('idExtend');
		 }
	RequestBoxDisp('idExtendWap');
	}

/*
	DispExtendWin() : ExtendViewを最大化
*/
function DispExtendWinMax() {
// タイルルバー,iframe内部,iframe枠をKeep
// Max前の内容をKeep
	if (!ExtendWinMax) {
		idExtFrm_width  = document.getElementById('idExtFrm').style.width;
		idExtFrm_height = document.getElementById('idExtFrm').style.height;
		idExtendWap_width    = document.getElementById('idExtendWap').style.width;
		idExtendWap_height   = document.getElementById('idExtendWap').style.height;
		idExtendWap_position = document.getElementById('idExtendWap').style.position;
		idExtendWap_top      = document.getElementById('idExtendWap').style.top;
		idExtendWap_left     = document.getElementById('idExtendWap').style.left;
		}
	ExtendWinMax=true;								// ResizeMode
	DispExtendWinMaxChamge();
	}

/*
	DispExtendWinMaxChamge() : 最大化時,WindowSizeに追従
*/
function DispExtendWinMaxChamge() {
	if (ExtendWinMax) {
// タイルルバーを変更
		document.getElementById('idExtendBar').style.width=document.body.clientWidth +'px';		// スクロールバーを含めず最大化
		document.getElementById('idExtendBar').style.position='Fixed';
		document.getElementById('idExtendBar').style.top=0+'px';
		document.getElementById('idExtendBar').style.left=0+'px';
// iframe内部変更
		document.getElementById('idExtFrm').style.width=(document.body.clientWidth-5)+'px';		// 5:iFreme Inner スクロールバーの幅
		document.getElementById('idExtFrm').style.height='98vh';			// 下位部が入りきれないので
// iframe枠変更
		document.getElementById('idExtendWap').style.width=document.body.clientWidth +'px';
		document.getElementById('idExtendWap').style.height=document.body.clientHeight +'px';
		document.getElementById('idExtendWap').style.position='Fixed';
		document.getElementById('idExtendWap').style.top=24+'px';
		document.getElementById('idExtendWap').style.left=0+'px';
		}
	}

/*
	DispExtendWin() : ExtendViewを最大化前に戻す
*/
function DispExtendWin() {
// iframe内部変更
	document.getElementById('idExtFrm').style.width       = idExtFrm_width;
	document.getElementById('idExtFrm').style.height      = idExtFrm_height;
// iframe枠変更
	document.getElementById('idExtendWap').style.width    = idExtendWap_width;
	document.getElementById('idExtendWap').style.height   = idExtendWap_height;
	document.getElementById('idExtendWap').style.position = idExtendWap_position;
	document.getElementById('idExtendWap').style.top      = idExtendWap_top;
	document.getElementById('idExtendWap').style.left     = idExtendWap_left;
	ExtendWinMax=false;
	}

/*
	DispExtendWinRst() : ExtendViewを元に戻す
*/
function DispExtendWinRst() {
// MenuBar変更
	document.getElementById('idExtend').style.top       = exd_top +'px';
	document.getElementById('idExtend').style.left      = exd_left +'px';
	document.getElementById('idExtend').style.width     = exd_width +'px';
	document.getElementById('idExtendMe').style.width   = exd_width +'px';
// iframe枠変更
	document.getElementById('idExtendWap').style.top    = waptop +'px';
	document.getElementById('idExtendWap').style.left   = exd_left +'px';
	document.getElementById('idExtendWap').style.width  = exd_width +'px';
	document.getElementById('idExtendWap').style.height = wapheight+'px';
// iframe変更
	document.getElementById('idExtFrm').style.width     = frmwidth+'px';
	document.getElementById('idExtFrm').style.height    = frmheight+'px';
	ExtendWinMax=false;
	}

/* -----------------------------------------------------------------------------
	DispImagePositon(pos) : 内蔵画像Viewer Positon
	 pos    : i  : Select Viewr Image id sidimg{n}
	TNUMGARY : ViewrImageid Array HTML作成時に展開
------------------------------------------------------------------------------ */
var NOWTNUMGISX;							// Select Viewr Image id
function DispImagePos(pos) {
	var result = TNUMGARY.indexOf(pos);
	var rgbbc=CommonHex2Rgb("#808080");		// gray
	var rgbc=CommonHex2Rgb("#696969");		// darkgray
	NOWTNUMGISX=pos;
	if (result <= 0) {
		 document.getElementById("idprev").style.backgroundColor = rgbbc;
		 document.getElementById("idprev").style.color = rgbc;
		 document.getElementById("idprev").style.cursor = 'default';
		 }
	else {
		 document.getElementById("idprev").style.backgroundColor = '';
		 document.getElementById("idprev").style.color = '';
		 document.getElementById("idprev").style.cursor = '';
		 }
	if (((result+1) >= TNUMGARY.length)||(result < 0)) {
		 document.getElementById("idnext").style.backgroundColor = rgbbc;
		 document.getElementById("idnext").style.color = rgbc;
		 document.getElementById("idnext").style.cursor = 'default';
		 }
	else {
		 document.getElementById("idnext").style.background = '';
		 document.getElementById("idnext").style.color = '';
		 document.getElementById("idnext").style.cursor = '';
		 }
	}

/*
	DispImagePosReload() : 内蔵画像Viewer Reload
*/
function DispImagePosReload() {
	document.getElementById("image").style.display="none";
	document.getElementById("idrotate").value=0;
	var idx = TNUMGARY.indexOf(NOWTNUMGISX);
	document.getElementById(TNUMGARY[idx]).click();
	}

/*
	DispImagePosPrev() : 内蔵画像Viewer Positon Prev
*/
function DispImagePosPrev() {
	var result = TNUMGARY.indexOf(NOWTNUMGISX);
	if (result > 0) {
		idx=result -1;
		document.getElementById(TNUMGARY[idx]).click();
		}
	}

/*
	DispImagePosNext() : 内蔵画像Viewer Positon Next
*/
function DispImagePosNext() {
	var result = TNUMGARY.indexOf(NOWTNUMGISX);
	if ((result+1) < TNUMGARY.length) {
		idx=result +1;
		document.getElementById(TNUMGARY[idx]).click();
		}
	}

/****** JSP End of source ***************************************************************/

</script>

<?php
ArgJsBuiltin("InitLoadAdd");							// Initial Load:HTML Style Before Output
?>

<?php
/***************************************************************************************
	mpdartlist.php Meta / Style Item
****************************************************************************************/
/* -------------------------------------------------------------------------------------
	Eenvironment
	HTML <meta>設定
	<Html_config>                                 : HTMLの設定
        <Viewport>{ViewPort}</Viewport>           : ViewPort Default"content="を設定
	    <Viewport_{AGENT}>{..}</Viewport_{AGENT}> :'HTTP_USER_AGENT'と一致文字列があれば採用 (deviceごとに設定できる)
													{AGENT}の_はSpaceとする(AGENTの" ","_"の区別はしない)
		<ViewportRate> 							  : Phoneの時有効 0:未設定。画面高/幅の比率が設定値を超えたとき設定値を使用(サンプルが少ないので見た目で設定)
	<LibConf>                                     : Library 設定
        <Codeset>utf-8</Codeset>                  : 内部コード(mpdは標準'utf-8')
-------------------------------------------------------------------------------------- */
$LIB_CONF=array("Codeset"=>"utf-8","TimeZone"=>"Asia/Tokyo");
GetAlterConfig("LibConf",$LIB_CONF);			// Alternative get_config
print '<meta http-equiv="Content-Type" content="text/html; charset='.$LIB_CONF["Codeset"].'" >';

$CACHE_SEC=array("CacheContent"=>"86400");								// キャッシュ有効時間 初期値24時間
GetAlterConfig("Html_config",$CACHE_SEC);			// Alternative get_config
print '<meta http-equiv="Expires" content="'.$CACHE_SEC["CacheContent"].'">';

$HTML_CONFIG=array("Viewport"=>"width=380px,initial-scale=1.2,maximum-scale=1.7","ViewportRate"=>"");	// Viewport初期値
$setsts=GetAlterConfig("Html_config",$HTML_CONFIG);			// Alternative get_config
$ViewportRate=$HTML_CONFIG["ViewportRate"];								// Phoneの時画面高/幅の比率の設定
if (is_numeric($ViewportRate)) { } else {								// 数値以外は0:未設定
	$ViewportRate ="0";
	}
if ($REQ_UA !== "PC") {		// PC時のPlay ProgressTime(Sec) Style
	$HTML_CONFIG=array("ViewportPhone"=>"");							// ViewportPhone初期値
	$tmpsts=GetAlterConfig("Html_config",$HTML_CONFIG);					// Html_config mpdconfig.xmlより設定
	if ($HTML_CONFIG["ViewportPhone"] !=="") {
		$HTML_CONFIG["Viewport"]=$HTML_CONFIG["ViewportPhone"];
		$setsts=$tmpsts;
		}
	}
$SCR_WIDTH=480;															// mpdart HTML : WIDTH

$html_viewport=ArgViewport($XML_CONF,$count);
if (($setsts["No"]==0)&&($count==0)&&($setsts["AltXml"]!=="")) {
	 $html_viewport=GetAlterViewport($setsts["AltXml"]);
	 }
if ($html_viewport=="") { $html_viewport=$HTML_CONFIG["Viewport"]; }

if(stripos($html_viewport,'%scale%') === false) {						// %scale%:initial-scale計算
	 print '<meta name="viewport" content="'.$html_viewport.'" >';
	 }
else {
	 $str=str_replace('%scale%','1.0',$html_viewport);
	 print '<meta id="idMeta" name="viewport" content="'.$str.'" >';
	 echo <<<EOM
<script type="text/javascript">
	var viewportContent="{$html_viewport}";
	var vportrate=window.outerHeight/window.outerWidth;
	if (('{$REQ_UA}' !=="PC")&&({$ViewportRate} > 0)&&({$ViewportRate} > vportrate)) {
		 var scale={$ViewportRate};										// 縦横比を余白分にする
		 if (window.outerWidth < ({$SCR_WIDTH}*scale)) {				// Viewが画面幅を超えるときは適用しない
		 	scale=Math.floor((window.outerWidth/{$SCR_WIDTH})*100)/100;	// 幅比率で表示(小数3位切り捨て)
			}
		 }
	else {
		 var scale=Math.floor((window.outerWidth/{$SCR_WIDTH})*100)/100;	// 小数3位切り捨て
		 }
	var viewportContent=viewportContent.replace('%scale%',scale);
	document.getElementById('idMeta').setAttribute('content',viewportContent);
</script>
EOM;
	 }

?>
<?php
ArgJsBuiltin("InitStyleBefore");					// Initial Load:HTML Style Before Output
?>

<?php
/***************************************************************************************
	Common CSS Style Sheet
****************************************************************************************/

$csscommon=rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.'mpdweb.common.css';						// Common CSS Style Sheet : mpdweb.common.css
if ($REQ_MODULE !=="") {
	if (file_exists(rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename($REQ_MODULE,".php").'.common.css')) {
		 $csscommon=rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename($REQ_MODULE,".php").'.common.css';		// mpdweb Common Style CSS Sheet mpd{module}.common.css
		 }
	}
$dateform="";
if (file_exists($csscommon)) {
	$date = new DateTime();
	$date->setTimestamp(filemtime($csscommon));
	$dateform=$date->format('YmdHis');
	$dateform="?a=".$dateform;
	}

echo <<<EOM
<link rel="stylesheet" href="{$csscommon}{$dateform}" type="text/css">
EOM;
?>


<style type="text/css">
/*
 body    : body
.head    :固定位置ヘッダ
.botom   :固定位置フッダ
.buttn   :操作ボタン フラットStyle
.comnd   :コマンド用ボタン Playなど
.music   :曲選択などのbutton はみ出し文字を削除
.noImg   :No Image
.rotat   :丸線
.fpos    :方向Button
*/
body {background-color:#000000;color:#ffffff;margin-left:4px;font-family:Verdana,"Meiryo UI",sans-serif;font-size:80%;overflow-x:hidden;}

/* IOSのStyle 無効 */
button { background-color:#ffffff;color:#000000; }
input,select,textarea { font-size:98%;font-family: inherit; }
input[type="button"] { -webkit-appearance: none; border-radius: 0; }
input[type="submit"] { -webkit-appearance: none; border-radius: 0; }

.head  {position:fixed !important;top:0;width:480px;height:24px;font-size:11px;background-color:#000000;}
.botom {position:fixed;bottom:0px;width:476px;background-color:#000000;}

.buttn {border-style:none;width:50px;height:20px;padding:2px 0 2px;font-size:11px;cursor:pointer;-moz-border-radius:4px;-webkit-border-radius:4px;border-radius: 4px;}
.comnd {border-style:none;padding:2px 0 2px;font-size:8p;cursor:pointer;-moz-border-radius:2px;-webkit-border-radius:2px;border-radius:2px;text-align:center;}
.music {background-color:#000000;color:#ffffff;font-size:12p;font-weight:bold;text-decoration:none;white-space:nowrap;display:block;text-align:left;vertical-align:middle;padding:2px 0 2px;border:0px solid #333333;cursor:pointer;}
.noImg {background-color:#585858;}

.rotat {width:24px;height:24px;padding:2px 0 2px;font-size:11px;cursor:pointer;background-color:#008000;color:#dbebc4;border:1px solid #3cb371;-moz-border-radius:12px;-webkit-border-radius:12px;border-radius:12px;}
.relod {width:30px;height:20px;background-color:#008000;color:#dbebc4;border:1px solid #3cb371;}
.fpos  {width:30px;height:20px;background-color:#642EFE;color:#ffffff;border:1px solid #3cb371;}

/*
.StatusL :DispState Line
*/
.StatusL { border:1.4px solid #000000;width:480px;height:20;font-size:10px;color:#BDBDBD;line-height:140%;padding:4 6 6 6;background-color:#2E2E2E;resize:none;}

/*
.HDFUNC :Header Function
.HDCNST :DispFile Header Constant
.HDPATH :DispFile Header Path
.HDTEXT :DispFile Header Text
.DTBOTN :DispDirAlbum Header Directory Button
.DTTEXT :DispDirAlbum Text Part
.RollTex:Rollover Text
*/
.HDFUNC { position:relative;right:0px;top:-4px;width:20px;height:23;transform:rotate(-90deg);white-space:normal;background-color:#585858;color:#ffffff;}
.HDCNST { overflow:hidden;white-space:nowrap;text-overflow;font-size:11px;line-height:160%;width:24px;height:20px;background-color:#000000;color:#c0c0c0;margin:2px 0px 0px 8px;}
.HDPATH { overflow:hidden;white-space:nowrap;text-overflow:ellipsis;font-size:11px;line-height:160%;width:286px;height:16px;background-color:#242424;color:#DDDDDD;border:#707070 solid 0.7px;margin:0px 0px 0px 3px;}
.HDTEXT { overflow:hidden;white-space:nowrap;text-overflow:ellipsis;font-size:11px;line-height:160%;width:286px;height:16px;background-color:#333333;color:#DDDDDD;margin:0px 0px 0px 5px;}
.DTPREV { overflow:hidden;white-space:nowrap;text-overflow:ellipsis;width:477px;height:28px;font-size:12px;background-color:#424242;color:#CED8F6;border:#666666 solid 0.7px;padding:5px 5 7px;margin:0px 0px 0px -3px;}
.DTBOTN { overflow:hidden;white-space:nowrap;text-overflow:ellipsis;width:477px;height:28px;font-size:14px;background-color:#000000;color:#ffffff;border:#666666 solid 0.7px;padding:5px 5 7px;margin:0px 0px 0px -3px;}
.DTTEXT { color:#ffffff;font-size:9px;word-wrap:break-word;height:10px;margin:2px 1px 4px 0px;}
.RollTex { word-break:break-all;word-wrap:break-word;font-size:10px;margin:2px 1px 4px 0px;}

/*
.DIRBAD  : Add Function Header Botton
.DIRBAD  : Add Function Directory Botton
*/
.HEDBAD { height:19px;width:50;color:#CED8F6; background:linear-gradient(to bottom, #642EFE,#003366);}
.DIRBAD { height:28px;line-height:170%;text-align:center;width:32;font-size:10px;background-color:#11114d;color:#ffffff;;margin:-1px 0px 0px -1px;}

/*
.select       : Extend Viewer Title Bar No select
.select:hover : Extend Viewer Title Bar On Mouse
*/
.select { background-color:#f5f5f5;text-align:center;width:14px; } /* 通常時の背景色 */
.select:hover { background-color:#a9a9a9;text-align:center;width:14px; }	/* マウスオーバー時の背景色 */

/*
.artpd   :ArtText Priority (Under)
.artfn   :Image Found Founction
.rollo   :Rollover Bottun
.stbno   :Select Image Table No
.bfunc   :Detail Function Button
*/
.artpd {z-index:1;position:absolute;}
.artfn {background-color:rgba(240,240,240,0.4);padding:0px 0 0px;border-radius:7px 7px 7px 7px;}
.rollo {border:0px solid #333333;cursor:pointer;background-color:rgba(0,0,0,0.0);padding:0px 0 0px;}
.stbno {width:60px;height:22;font-size:13px;background-color:#d3d3d3;color:#3d3d3d;border:1px solid #707070;margin:-3px 0px 0px 20px;}
.bfunc {width:20px;text-align:center;font-size:16px;padding:1px 0 7px;margin:0px 0px 0px 0.3px;}

/*
.box     :Upper Box Default Off
.boxtitle:Upper Box Title
.boxtext :Upper Box Button Text
.boxline :Upper Box Line(Button)
.boxblin{n}:Upper Box Command Line
.boxbcan :Upper Box Cancel Button
.boxattri:FunctionBox Attribute
.boxefunc:FunctionBox Extend Fucntion
.boxencnm:FunctionBox EncoderName
.msgbbtn :Upper Box Message Box Botton
*/
.box {border: 1px solid #888888;position:fixed;top:200px;left:170px;
      width:300px;height:210px;font-size:10p;z-index:5;
      background-color:#2f2f2f;
      display: none;
      }

.boxtitle {background-color:#0000FF;color:#CEECF5;font-size:14px;text-align:left;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;width:280px;height:18px;position:absolute;top:0px;left:0px;padding:8px 10 2px;}
.boxtext  {position:absolute;background-color:#2f2f2;color:#ffffff;font-size:12px;font-weight:bold;text-decoration:none;display:block;text-align:left;vertical-align:middle;border: 0px;width:278px;height:19;padding:3px 10 2px;}
.boxline  {background-color:#000000;color:#ffffff;font-size:14px;font-weight:bold;text-decoration:none;white-space:nowrap;display:block;text-align:left;vertical-align:middle;cursor:pointer;border: 1px solid #acacac;width:300px;height:25;padding:3px 10 2px;}
.boxblin1 {position:absolute;left:0px;top:32px;font-size:12px;}
.boxblin2 {position:absolute;left:0px;top:60px;font-size:12px;}
.boxbcan  {position:absolute;bottom: 5;right:6px;}
.boxattri {width:278px;background-color:#000000;border: 1px solid #acacac;}
.boxefunc {width:278px;background-color:#08084d;border: 1px solid #acacac;cursor:pointer;}
.boxencnm {bottom:2px;left:2px;font-size:9px;color:#b0c4de;}
.msgbbtn { font-size:12px;width:60px;height:24px;position:absolute;top:120px;background-color:#c0c0c0;border:1.5px ridge #d3d3d3;}

/* IE:スクロールバーの色 */ /* バウンススクロール禁止 : overscroll-behavior IOSはIOS16以降有効 */
html,body { scrollbar-base-color :#707070;scrollbar-track-color:#A4A4A4;scrollbar-arrow-color:#707070;overscroll-behavior:none; }
/* Edge Chome スクロールバーの色 */
::-webkit-scrollbar { width: 10px; }					/* スクロールバー全体 */
::-webkit-scrollbar-track { background: #1c1c1c; box-shadow: inset 0 0 1px #2e2e2e; }	/* スクロールバー背景 */
::-webkit-scrollbar-thumb { background: #2f4f4f; }		/* スクロールバーつまみ */

/* Range Style IE Start */
input[type=range]:focus { outline: none; }
/* Edge・IE向け 溝のスタイル */
input[type=range]::-ms-track { cursor: pointer;animate: 0.2s;width: 100%;height: 10px;
  background: transparent;border-color: transparent;border-width: 16px 0;color: transparent; }
/* Edge・IE向け 溝の色（つまみより左側） */
input[type=range]::-ms-fill-lower { background: #cccccc;border: 0.2px solid #010101;border-radius: 2.6px;box-shadow: 1px 1px 1px #000000, 0px 0px 1px #0d0d0d; }
/* Edge・IE向け 溝の色（つまみより右側） */
input[type=range]::-ms-fill-upper { background: #cccccc;border: 0.2px solid #010101;border-radius: 2.6px;box-shadow: 1px 1px 1px #000000, 0px 0px 1px #0d0d0d; }
/* Edge・IE向け つまみのスタイル */
input[type=range]::-ms-thumb { box-shadow: 1px 1px 1px #000000, 0px 0px 1px #0d0d0d;border: 1px solid #000000;
  height: 16px;width: 8px;border-radius: 3px;background: #ffffff;cursor: pointer;}
input[type=range]:focus::-ms-fill-lower { background: #999999; }	/* Edge・IE向け focus時の色（つまみより左側） */
input[type=range]:focus::-ms-fill-upper { background: #999999; }	/* Edge・IE向け focus時の色（つまみより右側） */
input[type=range]::-ms-tooltip { display: none; }	/* Edge・IE向け ポップアップを非表示に */
/* Range Style IE End */

.loading-icon { /* 画像 loading-icon */
    margin-left: auto;
    margin-right: auto;
    width: 20px; /*ローディングアイコンの横サイズ*/
    height: 20px; /*ローディングアイコンの縦サイズ*/
    border-radius: 50%;  /*CSS3で円を書く*/
    border: 5px solid #ffffff;       /*円に○の白枠をつける*/
    border-right-color: transparent; /*円の右にC状の空きをつける*/
    animation: spin 1s linear infinite; /*1秒毎にくるくる回転するアニメーション*/
    display:block;
	}
@keyframes spin {
    0% { transform: rotate(0deg);   opacity: 0.2; } /*0%の時は20％の透明度*/
    50%  { transform: rotate(180deg); opacity: 1.0; } /*50%の時は透明度なし*/
    100%   { transform: rotate(360deg); opacity: 0.2; } /*100%の時に20％の透明度に戻る*/
}

</style>
<?php
/***************************************************************************************
 HTML / PHP / javascript
	<body> OnLoad Event StartUp
***************************************************************************************/
ArgJsBuiltin("InitStyleAfter");						// Initial Load:HTML Style After Output
?>
</head>
<body onresize="bodyresize();">
<?php
ArgJsBuiltin("InitBody");							// Initial Load:Body Setting Output

$loadstr="";
$loadstr=ArgMacroBuiltin("EventListener");			// HTMLBuiltin:HTML Style After Output
if ($loadstr !== "") {
		echo <<<EOM
<script type="text/javascript">
window.addEventListener('load', function() {
{$loadstr}

})
</script>

EOM;
	}
?>
<div id="idlodingmsg"></div>

<?php
/***************************************************************************************
	Jsp Common Library 
****************************************************************************************/

$jscommon=rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.'mpdweb.common.js';						// Common Library : mpdweb.common.js
if ($REQ_MODULE !=="") {
	if (file_exists(rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename($REQ_MODULE,".php").'.common.js')) {
		  $jscommon=rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename($REQ_MODULE,".php").'.common.js';		// mpdweb Common jsp mpd{module}.common.js
		  }
	}

$jslibcajax = rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'."mpdweb.libcajax.js";		// mpdweb Common js
if  (file_exists(rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename(__FILE__,".php").".libcajax.js")) {
	$jslibcajax = rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename(__FILE__,".php").".libcajax.js";	// mpdweb Common jsp mpd{module}.js
	}

$dateform="";
if (file_exists($jscommon)) {
	$date = new DateTime();
	$date->setTimestamp(filemtime($jscommon));
	$dateform=$date->format('YmdHis');
	$dateform="?a=".$dateform;
	}

echo <<<EOM
<script type="text/javascript" src="{$jscommon}{$dateform}"></script>
<script type="text/javascript" src="{$jslibcajax}{$dateform}"></script>
<!-- REQ_MODULE:{$REQ_MODULE} -->
EOM;
?>

<script language="JavaScript">
<!--
/***************************************************************************************
	mpdartlist.php JSP EventListener
****************************************************************************************/
/* ------------------------------------------------------------------------------------
	bodyresize() : Body Resize  Start
	※ResizeEventでのActionを記述
------------------------------------------------------------------------------------ */
function bodyresize() {		// Window Resize Event
	DispExtendWinMaxChamge();		// ExtendBox(内部拡張Viewer) 最大化時Resize
	}

/* ------------------------------------------------------------------------------------
	onLoadFunc() : Initial Start
	 XML InitBody : onLoad を追記
------------------------------------------------------------------------------------ */
function onLoadFunc() {		// 初期設定

<?php
ArgJsBuiltin("onLoad",1);							// Initial Load:Body onLoad Setting Output
?>
	DispLoadImage();
	}
// Initial Load
window.onload=onLoadFunc;
//-->
</script>

<?php
/***************************************************************************************
	mpdartlist.php Main Process
****************************************************************************************/
//----- PHP Config Get & 初期値--------------------------------------------------
//ini_set('display_errors',1);
$MY_VERSION=basename(__FILE__,"")." 1.12 (01.03.2025)";

$PHP_CONFIG=array("php_timeout"=>130,"php_locale"=>"ja_JP.UTF-8","memory_limit"=>"160M");
GetAlterConfig("php_config",$PHP_CONFIG);			// Alternative get_config
set_time_limit($PHP_CONFIG["php_timeout"]);
setlocale(LC_ALL,$PHP_CONFIG["php_locale"]);
ini_set('memory_limit',$PHP_CONFIG["memory_limit"]);
if (isset($ARG[$XML_HISTORY["BackTag"]])) { $burl=$ARG[$XML_HISTORY["BackTag"]]; } else { $burl=""; }
$str=ArgPartURL($burl,$_SERVER['QUERY_STRING'],$_SERVER['REQUEST_URI']);
if ($str !=="") {
	$ARG[$XML_HISTORY["BackTag"]]=$str;
	}
//----- DispDirAlbum ------------------------------------------------------------
$home="";$trns="";$val="";$burl="";
if (isset($ARG["home"])) {
	 $home=$ARG["home"];			// Home Directory
	 }
if (isset($ARG["trns"])) {
	 $trns=$ARG["trns"];			// Display Directory
	 }
if (isset($ARG[$XML_HISTORY["BackTag"]])) {
	 $burl=$ARG[$XML_HISTORY["BackTag"]];	// back URL
	 }
if (isset($ARG["pos"])) {
	 $pos=$ARG["pos"];				// Positing on/off
	 }
else {
	 $pos=$XML_DISP["Position"];
	 }
if (isset($ARG["val"])) {
	 $val=$ARG["val"];				// Positing Point
	 }
if (isset($ARG["tbno"])) {
	 $tbno=$ARG["tbno"];			// Positing Point
	 }
else {
	 $tbno=$XML_DISP["ArtNo"];
	 }
DispDirAlbum($home,$trns,$burl,$tbno,$pos,$val);
if ($ERR_MESSAGE !== "") {
	DispErrorBox($ERR_MESSAGE);
	}
DispMsgBox("off");
exit();

/* -----------------------------------------------------------------------------
	ArgAnalyze()() :  : Argument Analyze
----------------------------------------------------------------------------- */
function ArgAnalyze() {
	global $REQ_MODULE,$REQ_PATH,$XML_HISTORY;		// 起動情報 $REQ_MODULE:Request Module , $REQ_PATH:Request Path&Module

	foreach($_GET as $key => $get) {		// ArgAnalyze($_GET)と同じ形式にする
		$ARG[$key]=\MyProject\ArgDecode($get);	// namespace MyProject
		}

	$REQ_MODULE="";
	if (isset($ARG[$XML_HISTORY["BackTag"]])) {
		$part = explode('?',$ARG[$XML_HISTORY["BackTag"]],2);
		$par = explode('/',$part[0]);
		$REQ_MODULE=$par[count($par)-1];
		$REQ_PATH=$part[0];
		}
//print "<BR><BR><BR><BR><BR>-------------------------------------------------<BR>";
//print '$_SERVER[REQUEST_URI]('.$_SERVER['REQUEST_URI'].')<BR>';
//print '$REQ_MODULE['.$REQ_MODULE.']<BR>';
//print_r($ARG);
	return($ARG);
	}

/* -----------------------------------------------------------------------------
	ArgPartURL($burl,$url,$uri): HistoryCount以下を削除する。最後は最終URLを置き換え有効にする
	 $burl   : i  : Bacl URL ARG[{BackURL}]からの値
	 $url    : io : URL  Query : $_SERVER['QUERY_STRING']形式
	 $uri    : io : Path Query : $_SERVER['REQUEST_URI']形式
	 @return : o  : Back URL Parameter : ARG[$burl]  , "":HistoryCount以下を削除しなかった
	 形式：URL.....&burl=B64:{BackURL Parameter}から展開しURLをカットする
	※$_SERVER['QUERY_STRING']/$_SERVER['REQUEST_URI']は,原因不明だが300Byte付近でと欠落することが発生。そのときも$_GETは正常
----------------------------------------------------------------------------- */
function ArgPartURL($burl,&$url,&$uri) {
	global $XML_HISTORY;						// History Back 設定

	$uri_leng=strlen($uri);$destruction=0;						// URIの長さを取得(最大長を超えないように)
	if (strlen($burl) > $uri_leng) { $uri_leng=strlen($burl);$destruction=1; }	// ブラウザのURI最大長を超えたとき$_GETは正常なときがある
	$HistoryBack=$XML_HISTORY["HistoryBack"];				// History Back 設定
	$URL_BPR=$XML_HISTORY["BackTag_Ary"];					// 0:自身(mpdartlllist.php)Parameter,起動モジュールの戻りParameter
	$maxleng=intval($XML_HISTORY["URL_Length"]);			// URL最大長
//print '<BR><BR><BR><BR><BR>$burl('.strlen($burl).')'.$burl.'<BR>$url('.strlen($url).')'.$url.'<BR>';
// Pre Parameter Proc. : home=&trns=music&burl=B64:{Parameta} -> &burl=B64:{Parameta}が目的のBackURL($_SERVER['REQUEST_URI']/ARG['burl']を復元するためQUERY_STRINGから展開
	$ret="";
	if ($burl=="") { return(""); }
	$str="";
	$upart=explode('&'.$URL_BPR[0].'=',$url,2);			// URLを'&burl=分離
	if (!isset($upart[1])) {
		$upart=explode('?'.$URL_BPR[0].'=',$url,2);		// URLを'?burl=分離
		}
	if (isset($upart[1])) {
		$up=explode('&',$upart[1],2);					// burlを{para}& 以降を分離
		}
	$last="";$d=0;
	$dec=ArgDecode($burl);
	$dec=Commn_UrlConvert($dec,"dec");					// &burlが目的のBackURLなので伸長し戻す
// Develop Parameter
	if ($dec !=="") {
		$urlary[0]=$dec;
		$s=$dec;
		for ($i=0;; $i++) {								// '&url='(BackURL)を展開しLastURLを探す。(見失う可能性もあるがURLを短くするためショートする)
			$bl="";
			$p=explode('&'.$URL_BPR[1].'=',$s,2);			// URLを'&burl=分離しURLがあるかチェック
			if (!isset($p[1])) {
				 $p=explode('&'.$URL_BPR[0].'=',$s,2);		// URLを'&url=分離しURLがあるかチェック
				 if (!isset($p[1]))  { break; }
				 else { $bl='&'.$URL_BPR[1].'='; }
				 }
			else { $bl='&'.$URL_BPR[0].'='; }
			$last=$p[1];
			$d=ArgDecode($last);							// 次のNestを検索
			$d=Commn_UrlConvert($d,"dec");					// &burlが目的のBackURLなので伸長し戻す
			$last=$bl.$last;								// B64:形式でLastURLをキープしておく
			$s=$d;
			}
		$urlkind[0]=$URL_BPR[0];							// 最新戻りをKeep
		$urlkind[1]=$URL_BPR[0];
		}
	$str=$burl;
	for ($i=1;; $i++) {									// '&url='(BackURL)をEncodeして先頭まで戻す。(&url=B64:{p=xxx,f=xxxx=&url=.....}
		$dec=ArgDecode($str);
//		$dec=Commn_UrlConvert($dec,"dec");	// URLをURLエンコードしている場合はコメントを生かす
		$hit=0;
		foreach($URL_BPR as $burl) {						// Call元の戻りParameterと自戻り(Self)Parameterを検出
			$pt=explode('&'.$burl.'=',$dec,2);				// URLを'&url='分離 先頭部:$url_b
			if (isset($pt[1])) {
				$urlkind[$i+1]=$burl;						// BackのURL元を配列に格納
				$urlary[$i]=$pt[0];							// Back Parameter
//print "[$i][".$urlkind[$i+1]."]".$urlary[$i]."<BR>";
				$str=$pt[1];
				$hit=1;
				break;
				}
			}
		if ($hit== 0) {
			break;
			}
		}
// Debug Table Dump
//foreach($urlkind as $key => $val) {
//	if (isset($urlary[$key])) { $s=$urlary[$key]; } else { $s='Noting'; }
//	print $key.'['.$val.']'.$s.'<BR>';
//	}
//print '$last:'.$last.'<BR>';
	$short=0;$backurlstr="";
	if ($uri_leng > $maxleng) {								// URIの長さが指定長を超えた場合,カウントを短縮する。
		if ($XML_HISTORY["URL_ForceTop"] == "on") {
//print 'URL Lengch Over['.$uri_leng.']Stting['.$maxleng.']<BR>';
			 $backurlstr=_ArgPartURL_ComSearh($urlary,$urlkind,$last,$URL_BPR);		// URL強制Topへ
			 if ($backurlstr !="") { $short=1; }
			 }
		else {
			 $arycnt= count($urlary);
			 if (($arycnt > 2)&&($arycnt <= $HistoryBack)) {		// $HistoryBack:1以下の設定はできない
				$HistoryBack=$arycnt-1;
				}
			 }
		}
	if ((count($urlary) > $HistoryBack)&&($short==0)) {				// 戻り設定回数を超えたときは戻り回数を短縮する
		$short=1;
		for ($i=$HistoryBack;$i > 1; $i--) {				// '&url='(BackURL)をEncodeして先頭まで戻す。(&burl=B64:{p=xxx,f=xxxx=&url=.....}
			if ($urlkind[$i]==$URL_BPR[0]) {
				$urlkind[$i]=$urlkind[count($urlary)];		// 最終位置を戻り設定回数以内,自戻り(Self)Parameter位置に移動しカットする
				$urlary[$i-1]=$urlary[count($urlary)-1];
				$HistoryBack=$i-1;							// HistyoryBackを再設定
				break;
				}
			}
		$urlary[$HistoryBack-1]=$urlary[$HistoryBack-1].$last;		// 展開(前処理)で確保したBackURLを追記する
		for ($i=($HistoryBack-1);$i > 0; $i--) {		// '&url='(BackURL)をEncodeして先頭まで戻す。(&url=B64:{p=xxx,f=xxxx=&url=.....}
			$enc="";
			if ($backurlstr !== "") {
				$enc=ArgEncode($backurlstr);						// &burl:パラメータを配列に設定
				$backurlstr='&'.$urlkind[$i+1].'='.$enc;
				}
			$backurlstr=$urlary[$i].$backurlstr;
			}
		}
	if($short==1) {										// HistoryBackをショートが決定
		if ($backurlstr !== "") {
			if (($destruction==1)&&($XML_HISTORY["URL_ForceDel"]!="")) {			// ブラウザのURIがURL最大長で壊れている
				$del=explode($XML_HISTORY["URL_ForceDel"],$backurlstr,2);			// urlを指定位置以降を削除する
				$backurlstr=$del[0];
				}
			$ret=$backurlstr;										// Back Parameter 
			$enc=ArgEncode($backurlstr);							// &burl:パラメータを配列に設定
			$backurlstr='&'.$urlkind[1].'='.$enc;
			}
		$p=explode('&'.$URL_BPR[0].'=',$url,2);				// urlを'&burl=分離
		$url=$p[0].$backurlstr;									// $_SERVER['QUERY_STRING']形式を作成
		$p=explode('?',$uri,2);								// uriを'?'分離
		$uri=$p[0].'?'.$url;								// $_SERVER['REQUEST_URI']形式を作成
		}
//print 'Return('.(strlen($ret)).')['.$ret.']<BR>';
	return($ret);
	}

/*
	_ArgPartURL_ComSearh($urlary,$urlkind,$last,$URL_BPR) : 強制Top,URL Search
	 $urlary : i  : URL History Array
	 $urlkind: i  : URL History Kind Array (burl/url)
	 $last   : i  : 最後の戻りURL(&burl/&url)パラメータ
	 $URL_BPR: i  : $URL_BPR[0]:自身(mpdartlllist.php)Parameter(&burl) $URL_BPR[1] :起動モジュールの戻りParameter(&url) :({Default Tag})
	 @return : o  : Top URL
*/
function _ArgPartURL_ComSearh($urlary,$urlkind,$last,$URL_BPR) {
	$def=1;$str="";$lstr="";
	$l=explode('&'.$URL_BPR[0].'=',$last,2);				// urlを'&burl=分離
	if($last!=="") {
		if (!isset($l[1])) {
			$def=2;
			}
		if (isset($l[1])) {
			$lstr='&'.$URL_BPR[1].'='.$l[1];
			}
		}
	for ($i=(count($urlary)-$def);$i >= 0; $i--) {
		if ($urlkind[$i]==$URL_BPR[0]) {
			$str=$urlary[$i].$lstr;
			break;
			}
		}
	return($str);
/*
    $urlary $urlkind
$i:0 [burl]  http://{Host}/mpdweb/mpdweb.php?p=file&f=path:&url=B64:aHR0cDovLzE5Mi4xNjguMS4yMDAvbXBkd2ViL21wZGFydGxpc3QucGhwP2hvbWU9JnRybnM9JmJ1cmw9QjY0OmFIUjBjRG92THpFNU1pNHhOamd1TVM0eU1EQXZiWEJrZDJWaUwyMXdaSGRsWWk1d2FIQS1jRDFtYVd4bEptSTliR2x6ZEEuLg..
$i:1 [burl]  http://{Host}/mpdweb/mpdweb.php?p=file&f=path:
$i:2 [url]   http://{Host}/mpdweb/mpdartlist.php?home=&trns=
$i:3 [burl]
$last:&url=B64:aHR0cDovLzE5Mi4xNjguMS4yMDAv←&urlはパラメ－タ不足なので使用できないのでパラメータ付きを探す $i=0:[burl]And'&url'付き
$last:&burl=の場合,最後の[burl]+$las$i=1を使用
※[burl]のURLが使用可能
*/
	}

/* -----------------------------------------------------------------------------
	ArgURLCounterRep($uri) : URL Counter Increment
	 $uri     : i  : Jump URL
	 @return  : o  : New URL Counter Increment
	※URLパラメータ cnt={99}をSearchし Increment cntがない場合,cnt=1を付加
	 ブラウザによっては、URLが同じ場合,最新化されないための対応
----------------------------------------------------------------------------- */
function ArgURLCounterRep($uri) {
	$result = preg_match_all('/(cnt=)[0-9]{1,2}/s',$uri,$part,PREG_SET_ORDER);
	if (isset($part[0][1])) {
		 $cnt=str_replace($part[0][1],"",$part[0][0]);
		 if ($cnt >= (100-1)) { $cnt=0; } $cnt=$cnt+1;
		 $New_uri=str_replace($part[0][0],"cnt=".$cnt,$uri);
		 }
	else {
		 $cnt=1;$str="?";
		 if(strpos($uri,$_SERVER['PHP_SELF']."?") !== false) { $str='&'; }
		 $New_uri=$uri.$str."cnt=".$cnt;
		 }
	return($New_uri);
	}

/* -----------------------------------------------------------------------------
	ArgJsBuiltin($sel,$js_mode=0,$chgary) : XML設定からHTMLを生成 :For Initial Load
	 $sel    : i  : Select Tag Name
	 $js_mode: i  : 0:Not JS (Comment Line <!-- -->) , 1:JS (Comment Line // )
	 $chgary : i  : HTML変換ワード用配列 指定した場合,変換配列を入れ替える。
	 @return : o  : HTML | -1:Error
----------------------------------------------------------------------------- */
function ArgJsBuiltin($sel,$js_mode=0,$chgary="") {
	$ret=_ArgJsBuiltin($sel,$js_mode,$chgary);
	if ($ret == -1) { return; }
	$htmlstr=str_replace('&amp;','&',$ret);		// XML '&'→'&amp;'となっているのを'&'に戻す
	if ($htmlstr=="") { return; }
	if ($js_mode == 1) {
		 $comb = "//";$coma="\n";
		 }
	else {
		 $comb = "<!--";$coma="-->";
		 }
echo <<<EOM
{$comb} Message  [mpdartlist.php] Include External Source Start XML[{$sel}] {$coma}
{$htmlstr}
{$comb} Message  [mpdartlist.php] Include External Source End XML[{$sel}] {$coma}
EOM;

	}

/* -----------------------------------------------------------------------------
	ArgMacroBuiltin($sel,$chgary) : XML設定からJsMacroを生成 :For Initial Event Function
	 $sel    : i  : Select Tag Name
	 $chgary : i  : HTML変換ワード用配列 指定した場合,変換配列を入れ替える。
	 @return : o  : HTML | "":Error
----------------------------------------------------------------------------- */
function ArgMacroBuiltin($sel,$chgary="") {
	$js_mode=1;
	$ret=_ArgJsBuiltin($sel,$js_mode,$chgary);
	if ($ret == -1) { return(""); }
	$ret=str_replace('<script>','',$ret);	// Eventのみ実行なので,JSのみにする
	$ret=str_replace('</script>','',$ret);
	$ret=str_replace("\n",'',$ret);			// Post,CallBackは\nで終了するので削除する
	$ret=str_replace('&amp;','&',$ret);		// XML '&'→'&amp;'となっているのを'&'に戻す
	return($ret);
	}

/*
	ArgJsBuiltin($sel,$js_mode=0,$chgary) : XML設定からHTMLを生成
	 $sel    : i  : Select Tag Name
	 $js_mode: i  : 0:Not JS 1:JS
	 $chgary : i  : HTML変換ワード用配列 指定した場合,変換配列を入れ替える。
	 @return : o  : HTML | -1:Error
*/
function _ArgJsBuiltin($sel,$js_mode,$chgary) {
	global $ARG,$REQ_MODULE,$REQ_PATH,$XML_CONF,$XML_HISTORY;		// XML Setting

	if (!is_array($chgary)) {
		 $TBLCHG=GetReserveStruct("php");							// 自URL,変換配列を設定
		 }
	else {
		 $TBLCHG=$chgary;
		 }
	global $REQ_EVAL_INHBIT;$REQ_EVAL_INHBIT=1;						// ArgXML2HTMLStr():Error抑制
	$ret = -1;		// 初期値として
	$selary=array($sel=>"0");	// XML:セレクト対象Tag , 1:指定文字列を含む前方一致
	$fldary = compact("sel","js_mode");
	if ((isset($ARG[$XML_HISTORY["BackTag"]]))&&($REQ_MODULE !=="")) {
		$ret=ArgXML2HTMLStr("HTMLBuiltin_".$REQ_MODULE,$selary,$fldary,$TBLCHG);
		}
	if ($ret == -1) {
		$ret=ArgXML2HTMLStr("HTMLBuiltin",$selary,$fldary,$TBLCHG);
		}
	return($ret);
	}

/* -----------------------------------------------------------------------------
	ArgImageSize($imgfile,$dispwidth,$disp,$imgwidth,$imghigth,$clip,$retwidth,&$rethigth) : 画像表示サイスを求める
	 $imgfile  : i  : Image File
	 $dispwidth: i  : 基準となる横サイズ {Size}{:fix|aspect} fix:指定時XML設定ではSize変更不可(Higth=""も正方形にする) aspect:$retwidth,$rethigthに幅/高さをセットする。
	                  <div style="width:{width} : 表示エリアのサイズ(プロブラム上で設定している値)
	 $Disp     : i  : 設定対象
	 $imgwidth : o  : Width表示サイス
	 $imghigth : o  : Higth表示サイス
	 $clip     : io : 正方形扱いとならない場合,カットする。カット用のStyleを返す。NULL:セット時Styleをセットしない。
	 $retwidth : o  : $dispwidtに ":aspect" を設定時、幅をセットする。強制的に値を決定したときは、速度優先と判断しwidthの5倍を返す。
	 $rethigth : o  : $dispwidtに ":aspect" を設定時、高さをセットする。強制的に値を決定したときは、速度優先と判断しwidthの5倍を返す。
	 @return   : o  : 採用したWidth(Width=の幅)
	※正方形の領域に表示する機能を充実させている。速度は遅くなるが、画像からサイズを取得し判定している。
	  速度の面で強制正方形,比率を変えない設定も用意している。(表示エリアが正方形以外では画像をカットFitさせる機能はない。)
	※XML設定 <ImageRatio_{Func}>min,max,size,correct(補正率)|noclip|aspect(,min:{CompRatio}%)
	  XML設定でMinとMaxを逆にセットすると高さ基準でWidth値をHigthにセットしWidthを計算
	   correct(補正率):半分カットの場合など、カットしたか判り難いので補正率を指定し補正する
	   "noclip":縦横比変更せずに基準となる横サイズを基準にWidth値,Higthを計算する
	   "aspect":基準となる横サイズ以上の縦画像のときHigthを基準にWidth値を計算するが,縦/横$dispwidthに必ず入るようにする。
	   "min"   :基準となる横サイズより指定の{CompRatio}%より小さいとき、オリジナルサイズで表示
	            min:{InnerRatio}%:{MagnifyRatio}%:InnerRatio  :画像が基準となる横サイズに対してInnerRatio以下を判定
	                                              MagnifyRatio:InnerRatioの対象のときの拡大率
----------------------------------------------------------------------------- */
function ArgImageSize($imgfile,$dispwidth,$disp,&$imgwidth,&$imghigth,&$clip=NULL,&$retwidth=NULL,&$rethigth=NULL) {
	global $XML_IMAGE,$GImgfile,$Gimagesize;

	$fix="";$size_fix=0;$aspect=0;$minleave="";				// $fix:パラメータ簡略時判定用 $size_fix:XML設定でのSize変更不可,
	$min=0.80;$max=1.13;$correct=0.20;$clip_mod="noclip";	// $min/$max正方形と扱うRateoの範囲 ,$correct補正値:Ratioに対しての補正率,$clip_mod:正方形と扱わない場合,画像クリップするか設定

	$pr_size=explode(':',$dispwidth);					// $dispwidthの形式{width}:{fix}でFixが指定されていればSize変更不可
	if ((isset($pr_size[1]))&&($pr_size[1]=='fix')) { $size_fix=1; }
	if ((isset($pr_size[1]))&&($pr_size[1]=='aspect')) { $aspect=1; }
	$width=$pr_size[0];									// 引数のWidthかXMLのWidth設定を返すのが基本
	if(!is_null($clip)) { $clip=""; }					// Cut時のStyle
	if(isset($XML_IMAGE["ImageRatio"][2])) {			// Default値を設定
		 $min=$XML_IMAGE["ImageRatio"][1];
		 $max=$XML_IMAGE["ImageRatio"][2];
		 if ((isset($XML_IMAGE["ImageRatio"][3]))&&($XML_IMAGE["ImageRatio"][3] !=="")&&($size_fix==0)) {		// "Album","File"は画面を壊すので設定のWidthを使用しない
			$width=$XML_IMAGE["ImageRatio"][3];				// Width Size  表示する画像Size (同一形式で設定できるため指定できるがDefaultなのであまり意味がない)
			}
		 if (isset($XML_IMAGE["ImageRatio"][4])) {			// Ratio Min/max Over時カットの補正
			$correct=$XML_IMAGE["ImageRatio"][4];
			}
		 if (isset($XML_IMAGE["ImageRatio"][5])) {			// Ratio Min/max Over時カットの補正
			$minleave=$XML_IMAGE["ImageRatio"][5];
			$tmp=explode(':',$minleave);					// min:{CompRatio}% : 画像が小さいときの扱い
			if ($tmp[0] == "min") {							// XML設定がminのとき、widthが%で指定したサイズ以下を判定するための値
				$minleave="min";$minleave_size=90;$minleave_magnify=100;
				if (isset($tmp[1])) { $min_size=$tmp[1];			// Sizeの大きさ判定用の率
					$minleave_size=str_replace('%', '',$minleave_size);
					}
				if (isset($tmp[2])) { $minleave_magnify=$tmp[2];	// Sizeの大きさ拡大率
					$minleave_magnify=str_replace('%', '',$minleave_magnify);
					}
				}
			}
		 }
	if(isset($XML_IMAGE["ImageRatio"][0])) {
	 	$fix=$XML_IMAGE["ImageRatio"][0];				// Fix "":幅(Width)を基準,1: 同一比率で表示
	 	}
	if(isset($XML_IMAGE["ImageRatio_".$disp][2])) {		// 処理ごとの設定
		 $min=$XML_IMAGE["ImageRatio_".$disp][1];
		 $max=$XML_IMAGE["ImageRatio_".$disp][2];
		 if ((isset($XML_IMAGE["ImageRatio_".$disp][3]))&&($XML_IMAGE["ImageRatio_".$disp][3] !=="")&&($size_fix==0)) {
			$width=$XML_IMAGE["ImageRatio_".$disp][3];	// Width Size  表示する画像Size 
			}
		 if (isset($XML_IMAGE["ImageRatio_".$disp][4])) {	// Ratio Min/max Over時カットの補正率
			$correct=$XML_IMAGE["ImageRatio_".$disp][4];
			}
		 if (isset($XML_IMAGE["ImageRatio_".$disp][5])) {	// Ratio Min/max Over時カットの補正
			$minleave=$XML_IMAGE["ImageRatio_".$disp][5];
			$tmp=explode(':',$minleave);					// min:{CompRatio}% : 画像が小さいときの扱い
			if ($tmp[0] == "min") {							// XML設定がminのとき、widthが%で指定したサイズ以下を判定するための値
				$minleave="min";$minleave_size=90;$minleave_magnify=100;
				if (isset($tmp[1])) { $min_size=$tmp[1];			// Sizeの大きさ判定用の率
					$minleave_size=str_replace('%', '',$minleave_size);
					}
				if (isset($tmp[2])) { $minleave_magnify=$tmp[2];	// Sizeの大きさ拡大率
					$minleave_magnify=str_replace('%', '',$minleave_magnify);
					}
				}
			}
		 }
	if(isset($XML_IMAGE["ImageRatio_".$disp][0])) {			// XML 1行の内容未設定判定用
		$fix=$XML_IMAGE["ImageRatio_".$disp][0];
	 	}
// パラメータからフラグ設定
	if ($correct !=="noclip") { $clip_mod=""; }				// Clip補正($correct)が"noclip":(Clipしない)
	if ($clip_mod =="noclip") { $clip=NULL; }
// 初期(デフォルトをセット))
	$imgwidth=$width;										// 幅(Width)は基準をそのままセット
	$imghigth='""';
// プログラムの値を使用する設定省略(getimagesizeを使用しないので速度は速い) $fixはXML 1行イメージ
	if ($aspect == 1) { $retwidth=$width*5;$rethigth=$width*5; }							// aspect指定時,width/higthを返す 精度を上げるため取り合えず５倍)
	if (($fix == "1")||(($size_fix==1)&&($fix == ""))) { $imghigth=$width;return($width); }	// 同一比率とする設定 (強制正方形)	// 高さ(higth)は幅(Width)をセット
	if ($fix == "")  { return($width); }
// 設定より強制的に値を決定(プログラムでブロックすること)
	if (($min=="1")&&($width!=="")) { $imgwidth=$width;$imghigth=$width;return($width); }	// 設定が"1,,500"の場合はサイズを有効にする(正方形)
	if (($size_fix==1)&&(($min=="")&&($width!==""))) { $imgwidth=$width;$imghigth=$width;return($width); }	// SizeFix時 Higth:""はサイズが固定できないので許可しない
	if (($min=="")&&($width!=="")) {						// 設定が",,500" の場合はサイズを有効にする
		$imgwidth=$width;$imghigth='""';
		if ($aspect == 1) {
			if((isset($GImgfile))&&(isset($Gimagesize))&&($GImgfile==$imgfile)) {			// 前回と同じイメージは連続してGetしない
				 $imagesize=$Gimagesize;
				 }
			else {
				 $imagesize = @getimagesize($imgfile);	// 正方形でないので実の値を得る
				 $GImgfile=$imgfile;
				 $Gimagesize=$imagesize;
				 }
			if (($imagesize)&&($imagesize[1] > 0)) {	$retwidth=$imagesize[0];$rethigth=$imagesize[1]; }				// 幅[0] 高[1]
			}
		return($width); }
// max,minが逆にセット時higth基準とする
	$mode=1;
	if ($max < $min) {
		 $mode=2;$i=$max;
		 $max=$min;$min=$i;
		 }
// 画像から表示情報を設定
	if((isset($GImgfile))&&(isset($Gimagesize))&&($GImgfile==$imgfile)) {					// 前回と同じイメージは連続してGetしない
		 $imagesize=$Gimagesize;
		 }
	else {
		 $imagesize = @getimagesize($imgfile);		// $imagesize [0]:width,[1]:height,[2]:kind(1=gif 2=jpg 3=png 4=swf)
		 $GImgfile=$imgfile;
		 $Gimagesize=$imagesize;
		 }
	if(!$imagesize){ return($width); }				// 画像サイズがとれない:$imgwidth=基準,$imghigth=""
	if ($imagesize[1] <= 0) { return($width); }		// 画像高さ(higth)が0:$imgwidth=基準,$imghigth=""
	if ($aspect == 1) { $retwidth=$imagesize[0];$rethigth=$imagesize[1]; }	// aspect指定時,width/higthを返す 精度を上げるため取り合えず５倍)
	if ($correct == "aspect") {						// XML設定が "aspect"を指定時 Sizeを求める
		if ($minleave =="min") {						// XML設定が "aspect"&"min"を指定時
			if($imagesize) {
				$comp_size=$width*($minleave_size/100);
				if (($comp_size >= $imagesize[0])||($comp_size >= $imagesize[1])) {		// "aspect","min"の計算値以下かの画像かチェック
					if ((($minleave_magnify/100)*$imagesize[0]) >= $comp_size) {			// 拡大率を加味した値が"aspect","min"の計算値以下かを確認
						 $width=$comp_size;													// "aspect","min"以上なので、"aspect","min"の計算値を使用
						 }
					else {
						 $width=($minleave_magnify/100)*$imagesize[0];						// 画像サイズに拡大率を計算
						 }
					}
				}
			}
		if ($imagesize[0] < $imagesize[1]) {		// 縦横比を保ち,指定"width"に入るように縦が大きいときは縦基準で計算する。
			 $ratio=$width/$imagesize[1];
			 $imgwidth=floor($imagesize[0]*$ratio);
			 $imghigth=$width;
			 $width=$imgwidth;						// 縦基準
			 }
		else {
			 $ratio=$width/$imagesize[0];
			 $imghigth=$imagesize[1]*$ratio;
			 $imgwidth=$width;
			 }
		return($width);								// XML設定に"aspect"が指定のとき、以下は行わない
		}
	if ($minleave =="min") {						// XML設定が "min"を指定時
		if($imagesize) {
			$comp_size=$width*($minleave_size/100);
			if (($comp_size >= $imagesize[0])||($comp_size >= $imagesize[1])) {
				if (((($minleave_magnify/100)*$imagesize[0]) >= $comp_size)||((($minleave_magnify/100)*$imagesize[1]) >= $comp_size)) {			// 拡大率を加味した値が"aspect","min"の計算値以下かを確認
					 if ($imagesize[0] > $imagesize[1]) {
						  $ratio_tmp =floor(($comp_size / $imagesize[0])*100)/100;
						  }
					 else {
						  $ratio_tmp =floor(($comp_size / $imagesize[1])*100)/100;
						  }
					 $imghigth=$imagesize[1]*$ratio_tmp;	// 画像サイズに拡大率を計算
					 $imgwidth=$imagesize[0]*$ratio_tmp;
					 }
				else {
					 $imghigth=$imagesize[1]*($minleave_magnify/100);	// 画像サイズに拡大率を計算
					 $imgwidth=$imagesize[0]*($minleave_magnify/100);
					 }
				return($width);							// XML設定に"aspect"が指定のとき、以下は行わない
				}
			}
		}
	$ratio=floor($imagesize[0]/$imagesize[1]*100)/100;		// 縦横比率=幅[0]/高[1]
	if ($ratio==1) { return($width); }						// 正方形は補正なし(設定は正方形に対する内容)
	if (($ratio > $min) && ($ratio < $max)) {		// 縦横比率が許容範囲であれば強制的に縦横同じにする
		 $imghigth=$imgwidth;
		 return($width); }
	if (is_null($clip)) {
		if ($mode==1) {
			 $ratio2=floor($imagesize[1]/$imagesize[0]*100)/100;	// Width基準:率を再計算
			 $imghigth=$imgwidth*($ratio2); }						// 幅(Width)を基準に高さ(higth)をセット
		else {											// higth基準(WidthをhigthにしてWidthを計算)(max,minが逆にセット時)
			 $imghigth=$imgwidth;						// Widthをhigth)
			 $imgwidth=$imgwidth*$ratio; }				// 率でをWidth計算
		return($width); }
	if ($imagesize[1] > $imagesize[0]) {			// 高さが大きければ幅サイズを調整し枠に収める
		 $ratio2=floor($imagesize[1]/$imagesize[0]*100)/100;	// 縦が大きいので基準を逆にする:縦横比率=高[1]/幅[0]
		 $rat=$ratio2*$correct;						// 表示エリア(正方形)に対して扁平にクリップと表示をし、見た目の縦横比を戻す。(higthが表示域より大きくなる)
		 $imghigth=$imgwidth*($ratio2-$rat);		// 高さ(higth)は幅(Width)を基準にセット
		 $clip='clip:rect(0px,'.$imgwidth.'px,'.$imgwidth.'px,0px);position:absolute;';		// 画像クリップ width:{width}px;position:absolute;clip:rect({Up}px {rigth}px {lower}px {left}px);
		 }
	else {
		 $rat=$ratio*$correct;
		 $imghigth=$imgwidth;						// 高さ(higth)は幅(Width)を基準にセット
		 $imgwidth=$imgwidth*($ratio-$rat);			// 幅は比率を考慮 // 表示エリア(正方形)に対して扁平にクリップと表示をし、見た目縦横比のを戻す。(Widthが表示域より大きくなる)
		 $clip='clip:rect(0px,'.$imgwidth.'px,'.$imghigth.'px,0px);';		// 画像クリップ width:{width}px;position:absolute;clip:rect({Up}px {rigth}px {lower}px {left}px);
		 }
	return($width);
	}

/* -----------------------------------------------------------------------------
	GetEnvCommon() : Environment Common Set
	$XML_File = "setting/mpdconfig.xml";←変更可能
----------------------------------------------------------------------------- */
function GetEnvCommon($mode="") {
	global $ARG,$REQ_MODULE,$XML_CONF,$SERVERMD,$CALLBACK,$ERSTR,$IDMSGBOX,$IDTIPRE;	// $ARG:起動引数 $REQ_MODULE:起動Module $XML_CONF:XML $SERVERMD/$CALLBACK/$ERSTR:PostForm/$IDMSGBOX:MessageBoxid $IDTIPRE:Thumbnail Image id Prefix
	global $REQ_UA,$REQ_VENDOR,$REQ_BROWSER,$REQ_PREFIX,$MPDHOST,$HTTP_HOST;			// $REQ_UA:PC|Phone , $REQ_VENDOR:IE|Chromeなど,$REQ_BROWSER;User任意,$REQ_PREFIX:-ms-|-webkit-など
	global $XML_FUNCTION,$XML_NET,$XML_DISP,$XML_DISPATTR,$XML_HISTORY,$XML_ADDPARMKEY,$XML_ADDPARMATTR,$XML_THUMBNAIL;		// XML Setting $XML_FUNCTION:XML Used Function , $XML_NET: ,$XML_DISP,$XML_DISPATTR,$XML_HISTORY,$XML_ADDPARMKEY,$XML_THUMBNAIL:Thumnnail展開設定
	global $XML_IMGSETHOST,$XML_IMGSETLOCAL,$XML_EXCLUSIVE,$XML_EXCEPTION,$XML_IMGSET,$XML_IMAGE,$XML_ViewExtend;	// XML Setting

	$ERSTR="ERR";											// Post ErrorMessage Prefix
	$IDMSGBOX ='idMsgBox';									// Message Box id
	$IDTIPRE ="s";											// Thumbnail Image id Prefix
	$MPDHOST="";if (($REQ_MODULE=="mpdweb.php")||((strpos($_SERVER['REQUEST_URI'],"burl=") !== false)&&($REQ_MODULE=="index.php"))) { _GetEnvCommonMpdhost(); }
	$ret="";
	$XML_File = "setting/mpdartlist.xml";
	try {
		$XML_CONF = get_myloadconfig($XML_File);	// XML File Get FileNameはLibrary標準
		} catch( Exception $e ) {
	  $ret=$e->getMessage();
	  $XML_CONF=array();
	  }
	if ($mode=="load") { return($ret); }	// Loading Mode ：Main以外でチェック&Loading // 全処理で使用する環境との判定"load"時終了

	$HTTP_HOST=$_SERVER["HTTP_HOST"];						// $HTTP_HOST:HTTP HOST Display Name:IPv4,IPv6対応
	$tmp=trim(rtrim($_SERVER["HTTP_HOST"],"]"),"[");
	if (Commn_isIPv6($tmp)) {
		$ary=Commn_IPv6inf($tmp);
		$HTTP_HOST=$ary["ifid"];
		}
	if($MPDHOST=="Local Host") { $HTTP_HOST=$MPDHOST; } 	// 外部ネットワークに名称を見せない
	$XML = get_object_vars($XML_CONF);
// Function設定からURL:&burlがあるとき $REQ_MODULEがない場合、index.phpからのケースがあるので補正
	if (isset($XML["BackModuleDefault"])) {
		 $ary = explode("|",$XML["BackModuleDefault"], 2);
		 }
	else {
		 $ary[0] = "index.php";
		 }
	if (isset($ARG[$XML_HISTORY["BackTag"]])) {
		if ($REQ_MODULE =="") {			// Topがモジュール指定なし 呼び出し元:振替モジュール
			 if (isset($ary[1])) {
			 $REQ_MODULE=$ary[1]; } else { $REQ_MODULE=$ary[0]; }
			 }
		else if ((isset($ary[1]))&&($REQ_MODULE == $ary[0])) {	// 呼び出し元がDefaultモジュール時:振替モジュールに振替
			 $REQ_MODULE=$ary[1];
			 }
		}
// Post Reqest形式を作成しておく
	$SERVERMD="RequestByPost('".$_SERVER['PHP_SELF']."','mod=".$REQ_MODULE."&%p1%','%p2%');";	// onclickなどJavaScript Server起動モジュールリンク %p1%:URLParameter %2%:CallBackなし時NULL
	$CALLBACK="function () { %func% }";						// Callback形式
// History Back設定
	$XML_HISTORY=array("HistoryBack"=>"3","URL_Length"=>"2000","URL_ForceTop"=>"on","URL_ForceDel"=>"&b=","BackTag"=>"burl","BackTag_".$REQ_MODULE=>"url");	// HistoryBackの設定
	get_config("History",$XML_HISTORY);			// 本ProgramのHistoryBackは設定させない。($ARG解析でURLの戻りから相手のモジュール名を取得しLibraryを決定するためmpd関連関数が使用できない)
	$XML_HISTORY["BackTag_Ary"][0]=$XML_HISTORY["BackTag"];
	if ($REQ_MODULE !== "") {
		$XML_HISTORY["BackTag_Req"]=$XML_HISTORY["BackTag_".$REQ_MODULE];
		$XML_HISTORY["BackTag_Ary"][1]=$XML_HISTORY["BackTag_".$REQ_MODULE];
		}
	if ($XML_HISTORY["HistoryBack"] < "2") { $XML_HISTORY["HistoryBack"]="2";print "<BR><BR><BR><BR><BR><BR>HistoryBack(".$XML_HISTORY["HistoryBack"].")<BR>"; } 
// XML Additional_Func複数Functionを #{n}を付加しコピー(個別に使用できるように名称を付ける) $XML_ADDPARMKEYに付加キーをキープ
	$i=0;$tampary["key"]=array();$tampary["val"]=array();
	if ($REQ_MODULE !== "") {
		$i=0;$tampary["key"]=array();$tampary["val"]=array();
		$atary=get_xml_attri_array($XML["Additional_Func"]);	// 同一Key/Attribute対応
		foreach ($atary['Tag'] as $key=> $val) {
			$tampary["key"][$i]=$val;
			$tampary["val"][$i]=$atary['Val'][$key];
			if (isset($atary['Att'][$key])) {
				foreach ($atary['Att'][$key] as $attr=> $v) {	// Attributeを設定 適用条件を設定
					$tampary["Attr"][$i][$attr]=(string)$v;
					}
				}
			$i=$i+1;
			}
		}
	$i=0;$XML_ADDPARMKEY=array();
	foreach($tampary["key"] as $x => $key) {		// XML定義 <Art_Path> String
		$val=$tampary["val"][$x];
		$i=$i+1;
		$newkey=$key."#".$i;												// コピーキ―#{n}を付加しAttributeを付加。(#がないのは,Orignal定義)
		$XML_ADDPARMKEY[]=$newkey;
		$xml_name=$XML_CONF->getName();										// XMLの先頭名を取得
		$target = $XML_CONF->xpath("/".$xml_name."/"."Additional_Func");	// XPathを設定
		$text = htmlspecialchars($val);										// 特殊文字を HTML エンティティに変換 &→&amp
		$item = $target[0]->addChild($newkey,$text);						// コピーキ―#{n}:オリジナル内容で付加
		if(isset($tampary["Attr"][$x])) {
			$XML_ADDPARMATTR[$newkey]=$tampary["Attr"][$x];
			}
		}
//foreach($XML["Additional_Func"] as $key => $val) {		// XML定義 <Art_Path> String
//	print 'Key:'.$key."<BR>";
//	}
// Function設定
	$XML_FUNCTION=array();$set_count=0;
	if ((isset($ARG[$XML_HISTORY["BackTag"]]))&&($REQ_MODULE !=="")) {	// BackURLがあれば対象Functionを有効
		if (isset($XML["Function_".$REQ_MODULE])) {
			$XML_FUNCTION=$XML["Function_".$REQ_MODULE];
			$set_count=count($XML["Function_".$REQ_MODULE]);
			}
		}
	if (($set_count == 0)&&(isset($XML["Function"]))) {
		$XML_FUNCTION=$XML["Function"];
		}
// Display 初期値
	$XML_DISP=array("ButtunGap"=>"5","Position"=>"on","ArtNo"=>"3","ImgCloseMin"=>"on","ImgDragOn"=>"on","ImgTitleBar"=>"PC","ImgSelectConti"=>"on","ImgPost"=>"off","MagnifyRatio"=>"5","MagnifySize"=>"2000","LoadDispWSec"=>"3","Status"=>"on","Status_Scrollbar"=>"on","ArtList"=>"","Back"=>"","Path_Value"=>"","Path_Style"=>"","Sort_Capital"=>"off","File_DirLayer"=>"");	// 設定のWordがHTTP_USER_AGENTあれば,Phoneと扱う
	get_config("DISP_Config",$XML_DISP);
	$XML_DISPATTR=array();
	foreach($XML_DISP as $key => $val) {					// XML定義 <DISP_Config width={} name={}> 属性取得
		$xml_temp=array($key."_".$REQ_MODULE=>NULL);
		$sec=$key;
		get_config("DISP_Config",$xml_temp);
		if (!is_null($xml_temp[$key."_".$REQ_MODULE])) {
			 $sec=$key."_".$REQ_MODULE;
			 $XML_DISP[$key]=$xml_temp[$sec];
			 }
		$attri=array("width"=>60,"name"=>NULL);
		$retary=get_xml_attribute($XML["DISP_Config"],$sec,$attri);						// XML Keyの属性形式 width={value} //XML属性切出し方法に知恵
		$XML_DISPATTR[$key]=$attri;
		$XML_DISPATTR["xml"][$key]=$retary;
		}
// Image設定
	$XML_IMGSET=array("Extension"=>"jpg,jpeg,png,bmp","View_onclick"=>"","Thread"=>"2,200","ThreadMin"=>"0");	// View_onclickは拡張Viewerを使用する
	get_config("Image",$XML_IMGSET);						// XML File Image設定
	$ary = explode(",",$XML_IMGSET["Thread"], 2);			// Format <Thread>{n},{FileSize} Post:on/midは適用外
	if (isset($ary[1])) {
		$XML_IMGSET["ThreadMin"]=$ary[1];					// Thread:{n},{FileSize}:ThreadMin指定と尾内
		$XML_IMGSET["Thread"]=$ary[0];
		}
// ViewThumbnail
	$xmltmp=array();													// Thumbnail設定
	if (isset($XML["Image"])) {											// 重複時は後ろ優先
		foreach($XML["Image"]  as $key=> $val) {						// <Image><ViewThumbnail name="{name}" func/class="{ImagEncFunction}" size="50">:func:関数チェック存在してれば有効,size:ファイルサイズ
			if(strpos($key,'ViewThumbnail') === 0){
				$xmltmp[$key]["val"]=strval($val);
				$attri=array("size"=>"0","func"=>"","class"=>"","Extension"=>"","name"=>"");
				$att=get_xml_attribute($XML["Image"],$key,$attri);		// XML Keyの属性形式 width={value} //XML属性切出し方法に知恵
				$xmltmp[$key]["size"]  =$attri["size"];
				$xmltmp[$key]["func"]  =$attri["func"];
				$xmltmp[$key]["class"]  =$attri["class"];
				$xmltmp[$key]["Extension"]=$attri["Extension"];
				$xmltmp[$key]["name"]=$attri["name"];
				}
			}
		}
	$XML_THUMBNAIL=array();$no=0;$one="";
	if(count($xmltmp)==1) { $one="on"; }
	foreach($xmltmp as $key=> $val) {
		if ($xmltmp[$key]["func"] !=="") {
			if (!function_exists($xmltmp[$key]["func"])) { continue; }
			}
		if ($xmltmp[$key]["class"] !=="") {
			if (!class_exists($xmltmp[$key]["class"])) { continue; }
			}
		if ($one =="") {												// 同じFilesize設定を有効にするためダミー小数点を付加
			 $thumkey=intval($xmltmp[$key]["size"]).".".$no;
			 }
		else {															// 設定が単一のときは,KeyはSizeそのまま使用
			 $thumkey=intval($xmltmp[$key]["size"]);
			 }
		$XML_THUMBNAIL[$thumkey]["url"] =strval($xmltmp[$key]["val"]);
		$XML_THUMBNAIL[$thumkey]["ext"] =strval($xmltmp[$key]["Extension"]);
		$XML_THUMBNAIL[$thumkey]["name"] =strval($xmltmp[$key]["name"]);
		$no=$no+1;
		}
	krsort($XML_THUMBNAIL);				// Filesize降順Sort
// 拡張View Extension
// $XML_ViewExtend[{No}]:Extension / ViewExtend[{Extension}]:Kind / ViewExtend[Func][{Kind]]:Function
	$XML_ViewExtend=array();
	if (isset($XML["ViewExtend"])) {
		foreach($XML["ViewExtend"]  as $key=> $val) {			// XML定義 <Art_Path> String
			$part = explode(',',$val);
			foreach($part as $v) {
				$XML_ViewExtend["key"][(strtolower($v))]=$key;	// $key [Kind]
				$XML_ViewExtend["val"][]=strtolower($v);
				}
			$attri=array("Func"=>"","Init"=>"","require"=>"","include"=>"");
			$att=get_xml_attribute($XML["ViewExtend"],$key,$attri);		// XML Keyの属性形式 width={value} //XML属性切出し方法に知恵
			$XML_ViewExtend["Func"][$key]=$attri["Func"];	// Thumbnailの表示用関数
			$XML_ViewExtend["Init"][$key]=$attri["Init"];	// Viewの表示用初期関数
			$XML_ViewExtend["mode"][$key]="0";				// Source指定なし
			if ($attri["require"] !=="") {					// mode=1:require
				$XML_ViewExtend["mode"][$key]="1";
				$XML_ViewExtend["source"][$key]=$attri["require"];
				}
			if ($attri["include"] !=="") {
				$XML_ViewExtend["mode"][$key]="2";			// mode=2:include
				$XML_ViewExtend["source"][$key]=$attri["include"];
				}
			if ($XML_ViewExtend["mode"][$key] !="0") {		// mode=9:sourceなし
				if (!file_exists($XML_ViewExtend["source"][$key])) {
					$XML_ViewExtend["mode"][$key]="9";
					}
				}
			}
		}
// Path設定
	$Art_Path="Art_Path";									// 形式 local:{Local Path},host:{URL Art PAth},rel:{Relative Path(Request)}{default}
	if (isset($XML[$Art_Path."_".$REQ_MODULE])) {			// モジュール毎の設定があるか判定
		 $Art_Path=$Art_Path."_".$REQ_MODULE;
		 }
	else if (!isset($XML[$Art_Path])) {						// 何も設定されていない場合のデフォルト(RasPi以外は意味がない)
		 $XML[$Art_Path]["Path"] = "local:/var/www/html/Music,host:http://localhost/Music/,rel:";	// コマンド実行時: # ln -s /var/lib/mpd/music /var/www/html/Music
		 }
	$i=0;
	foreach($XML[$Art_Path]  as $tagkey=> $val) {			// XML定義 <Art_Path> String
		$key=$tagkey."_".$i;
		$i=$i+1;
		$keypt = explode('_',$key, 2);
		if ($keypt[0] !== "Path") { continue; }
		if (false !== strpos($val,"%DOCUMENT_ROOT%")) {		// Pathに"%DOCUMENT_ROOT%"が含まれる場合,Document_Rootを設定する
			$val=str_replace("%DOCUMENT_ROOT%",$_SERVER['DOCUMENT_ROOT'],$val);
			}
		$part = explode(',',$val);
		$def_home="";
		foreach($part as $par_path) {
			$par = explode(':',$par_path,2);
			$XML_IMGSETHOST[$key][$par[0]] ="";
			if (isset($par[1])) {
				if(($par[0]=="host")||($par[0]=="wan")) {			// Alter設定 host|wan
					if ($par[0]=="host") { $tmptag="path"; } else { $tmptag="wanpath"; }
					$par[1]=_GetEnvReGet($par[1],$tmptag,$par[1]);	// Alter設定時 Form:{(XMLPath):(Section)/(Tag)}
					}
				if (in_array("default",$part) == true) { 				// 引数 homeがないときのデフォルト設定がある
					if ($par[0] == "rel") { $def_home=$par[1]; }		//   編集前の "rel" デフォルトをキープ
					}
				if (($par[1] !=="")&&(substr($par[1],(strlen($par[1])-1),1) !== "/")) {
					 $par[1]=$par[1]."/";
					 }
				if ((($par[0] =="local")||($par[0] =="rel"))&&(($par[1] =="")||(substr($par[1],0,1) !== "/"))) {
					 $par[1]="/".$par[1];
					 }
				if ($par[0] =="host") {
					$par[1] = str_replace("//localhost","",$par[1]);	// path:localhostに設定時,shell実行のAddressを設定
					}
				$XML_IMGSETHOST[$key][$par[0]] = $par[1];	// [local]:Web Server Art Local Path ,[host];Return Art Path ,[rel]:Art Request
				}
			}
		if (in_array("default",$part) == true) {			// 引数 homeがないときのデフォルト設定がある
			$XML_IMGSETHOST[$key]["default"]=$def_home;		//   編集前の "rel" デフォルトをキープした値をhomeにする
			}
		}
	$XML_NET=array("netmask"=>"");							// 設定のWordがHTTP_USER_AGENTあれば,Phoneと扱う
	get_config($Art_Path,$XML_NET);
	$XML_NET["netmask"]=_GetEnvReGet($XML_NET["netmask"],"netmask","");	// Alter設定時 Form:{(XMLPath):(Section)/(Tag)}
// 表示名置換設定
	$XML_IMGSETLOCAL["\count"]=0;
	foreach($XML_IMGSETHOST as $key=> $val) {				// XML定義派生 $XML_IMGSETLOCAL[loaclpath]:表示Path
		$part = explode('/',$XML_IMGSETHOST[$key]["rel"]);
		$XML_IMGSETLOCAL[$XML_IMGSETHOST[$key]["local"]]=$part[(count($part)-2)];
		$p = explode('/',$XML_IMGSETHOST[$key]["local"]);
		if ((count($p)) > $XML_IMGSETLOCAL['\count']) {
			$XML_IMGSETLOCAL['\count'] = count($p);			// 置換設定のPath階層数をセット
			}
		}
// 対象外ディレクトリ設定
	$XML_EXCLUSIVE=array();$XML_EXCEPTION=array();			// <Exception>:例外設定(/var/www/xxxxx:/var/www/除外,xxxxx:対象),<Directory>:除外設定
	$Exclusive="Exclusive";									// 形式 local:{Local Path},host:{URL Art PAth},rel:{Relative Path(Request)}{default}
	if (isset($XML[$Exclusive."_".$REQ_MODULE])) {			// モジュール毎の設定があるか判定
		$Exclusive=$Exclusive."_".$REQ_MODULE;
	 	}
	if (isset($XML[$Exclusive])) {
		foreach($XML[$Exclusive]  as $key=> $val) {		// XML定義 <Art_Path> String
			if (false !== strpos($val,"%DOCUMENT_ROOT%")) {	// Pathに"%DOCUMENT_ROOT%"が含まれる場合,Document_Rootを設定する
				$val=str_replace("%DOCUMENT_ROOT%",$_SERVER['DOCUMENT_ROOT'],$val);
				}
			if (0 === strpos($key,"Directory")) {			// 除外設定
				$part = explode(',',$val);
				$XML_EXCLUSIVE=array_merge($XML_EXCLUSIVE,$part);
				}
			if (0 === strpos($key,"Exception")) {			// 除外例外
				$part = explode(',',$val);
				$XML_EXCEPTION=array_merge($XML_EXCEPTION,$part);
				$e=array();
				foreach($part as $sval) {					// XML定義 <Art_Path> String
					$p = explode('/',$sval);$bpath="";
					for($i=0;$i< (count($p)-1);$i++) {
						if ($p[$i] !== "") {
							$bpath=$bpath."/".$p[$i];
							}
						}
					$e[]=$bpath;
					}
				$XML_EXCLUSIVE=array_merge($XML_EXCLUSIVE,$e);
				}
			}
		}
// イメージファイル表示設定
	$XML_IMAGE["ImageRatio"][0]="";							// Image設定
	$tmp = get_object_vars($XML_CONF);
	if (isset($tmp["DispImage"])) {
		foreach($tmp["DispImage"] as $key=> $part) {		// XML"DispImage"を展開
			$XML_IMAGE[$key][0]=$part;						// $XML_IMAGE[ImageRatio_{Disp}][0]:Orignal
			$keypt = explode(',',$part);
			if (isset($keypt[1])) {							// Ratio Min/Maxの間を同じ比として表示する
				$XML_IMAGE[$key][1]=$keypt[0];				// $XML_IMAGE[ImageRatio_{Disp}][1]:Ratio Min
				$XML_IMAGE[$key][2]=$keypt[1];				// $XML_IMAGE[ImageRatio_{Disp}][2]:Ratio Max
				}
			if (isset($keypt[2])) {
				$XML_IMAGE[$key][3]=$keypt[2];				// $XML_IMAGE[ImageRatio_{Disp}][3]:表示サイズ
				}
			if (isset($keypt[3])) {
				$XML_IMAGE[$key][4]=$keypt[3];				// $XML_IMAGE[ImageRatio_{Disp}][4]:Ratio Min/MaxOverのカット時の補正率
				}
			if (isset($keypt[4])) {
				$XML_IMAGE[$key][5]=$keypt[4];				// $XML_IMAGE[ImageRatio_{Disp}][5]:min:{CompRatio}%:画像が小さいときの扱い
				}
			}
		}
	$xml_ua=array("ua_phone"=>"iPhone,iPod,Android");		// 設定のWordがHTTP_USER_AGENTあれば,Phoneと扱う
	GetAlterConfig("php_config",$xml_ua);					// Alternative get_config
	ArgVendorPrefix($XML_CONF,$xml_ua["ua_phone"],$count);	// VendorPrefix Get
	if ($count==0) {
		$item="";
		$setsts=GetAlterConfig("VendorPrefix",$item);		// Alternative VendorPrefix Get
		if ($setsts["AltXml"] !=="") {
			GetAlterVendorPrefix($setsts["AltXml"],$xml_ua["ua_phone"]);	// Alternative get_config
			}
		}
//print "<BR><BR><BR><BR><BR>-------------------------------------------------<BR>";
//print '$XML_HISTORY : ';print_r($XML_HISTORY);print '<BR';
//print '$XML_IMGSETHOST : ';print_r($XML_IMGSETHOST);print '<BR>$XML_IMGSETLOCAL : ';print_r($XML_IMGSETLOCAL);
//print '$XML_IMGSET : ';print_r($XML_IMGSET);print '<BR>$XML_EXCLUSIVE : ';print_r($XML_EXCLUSIVE);print '<BR>$XML_EXCEPTION : ';print_r($XML_EXCEPTION);
//print '$XML_DISP : ';print_r($XML_DISP);print '<BR>$XML_DISPATTR : ';print_r($XML_DISPATTR);print '<BR>$XML_FUNCTION : ';print_r($XML_FUNCTION);
//print '<BR>$XML_NET : ';print_r($XML_NET);print "<BR>";print 'UA['.$REQ_UA.']<BR>';
//print '$XML_THUMBNAIL : ';print_r($XML_THUMBNAIL);print "count(".count($XML_THUMBNAIL).")<BR>";
	return($ret);
	}

/*
	_GetEnvCommonMpdhost() : MPDHost Address Get
	 mpdweb.phpからCall時, global $MPDHOST Replase %Module%
*/
function _GetEnvCommonMpdhost() {
	global $MPDHOST,$XML_CONF,$XML_CONF_ARY;		// XML Setting

	$sv_conf=$XML_CONF;
	$MPDHOST="";
	if (!isset($XML_CONF_ARY["setting/mpdconfig.xml"])) {
		return;
		}
	$XML_CONF=$XML_CONF_ARY["setting/mpdconfig.xml"];
	if (($tmp=_get_loadconfig_Alter($XML_CONF)) !==false) { $XML_CONF=$tmp; }		// Session開始前はSessionを使用しての置換前なので,<XMLAlternative>を反映する
	$XML_CONF_ARY["setting/mpdconfig.xml"]=$XML_CONF;
	$xml_mpdnet=array("host"=>"localhost");
	get_config("Mpd_net",$xml_mpdnet);				// Net_Common Property mpdconfig.xmlから設定
	$xml_mpdnet["netmask"]="";
	get_config("Mpd_exclusive",$xml_mpdnet);
	$MPDHOST=$xml_mpdnet["host"];

	if (!Commn_Subnet($xml_mpdnet["netmask"],$_SERVER['REMOTE_ADDR'])) {
		 $MPDHOST="Local Host";
		 }
	$XML_CONF=$sv_conf;
	}

/*
	_GetEnvReGet($str,$deftag) : XML Value Get
	 $str   : i  : XML Path String Fromat : [Str1]{[XMLFilePath]}|{[Section]}/{[Tag]}[Str2]
	 $deftag: i  : XML Tag Default , "":Default Non Setting
	 $defval: i  : XML Tag Value Default : $strから編集時,XMLFilePathに未設定時($strのFormatが正しいときに使用)
	 @return: o  : New Value 成功時:[Str1][SetValue][Str2]
*/
function _GetEnvReGet($str,$deftag="",$defval="") {
	global $XML_CONF,$XML_CONF_ARY;

	$result = preg_match_all('/{(.*?)}/s',$str,$part,PREG_SET_ORDER);	// Result:正規表現:{ }を検出 $part[n][0]:{Item} [1]:Value
	if (!isset($part[0][1])) {				// 形式{}がないので[$str]を採用する
		 return($str);
		 }
	$setstr=$part[0][1];
	$xmlset=explode("|",$setstr,2);		// {[Path]|xxxx}
	$xmlpath=$xmlset[0];
	if ((!isset($xmlset[1]))||($xmlset[1] =="")) {	// {XMLFile}|{Tag} 形式チェック:
		return($str);
		}
	$xmlset[1]=trim($xmlset[1],"/");				// /形式{section}/{tag}
	$tmp=explode("/",$xmlset[1]);
	$xmlsec=$tmp[0];
	$xmltag=$deftag;								// 引数Tagをdefault
	if ((isset($tmp[1]))&&($tmp[1] !=="")) {		// {XMLFile}:{Tag} 形式チェック:
		$xmltag=$tmp[1];
		}
	if (($xmltag=="")) {							// {Tag} 形式チェック:_GetEnvReGet()呼び出し元でTagをセットすれば発生しない
		return($str);
		}
	$ret="";
	$sv_conf=$XML_CONF;						// XML globalを保存し終了時戻す(CommonLibを使用するための対処)
	if (isset($XML_CONF_ARY[$xmlpath])) {			// 取得済のXMLはGetしない
		 $XML_CONF=$XML_CONF_ARY[$xmlpath];
		 }
	else {
		 try {
			 $XML_CONF = get_loadconfig($xmlpath);	// XML File Get FileNameはLibrary標準
			 } catch( Exception $e ) {
			 $XML_CONF=$sv_conf;					// XML globalを戻す
			 return($str);
			 }
	     }
	$tmp=array($xmltag=>$defval);					// default:引数にする
	get_config($xmlsec,$tmp);
	$tagstr=$tmp[$xmltag];
	$ret=str_replace("{".$setstr."}",$tagstr,$str);		// TagValue xxx{Str}xxx を置換する ==> xxx(Value)xxx
	$XML_CONF=$sv_conf;							// XML globalを戻す
	return($ret);
	}

/* -----------------------------------------------------------------------------
	GetSessionConfig() : php Session Config
	 @return: o  : $SESSION_CONF Session Array
----------------------------------------------------------------------------- */
function GetSessionConfig() {
	global $XML_CONF,$XML_CONF_ARY;

	$sv_conf=$XML_CONF;
	$SESSION_CONF=array("sesion_id"=>"mpdweb","href_waitmsec"=>"50","maxlifetime"=>"1440");
	GetAlterConfig("php_session",$SESSION_CONF);						// php config php_session
	if(isset($XML_CONF_ARY["setting/mpdconfig.xml"])) {					// 他の設定でmpdconfig.xmlを取得しているとき。
		 $XML_CONF=$XML_CONF_ARY["setting/mpdconfig.xml"];
		 }
	else if(strpos($_SERVER['REQUEST_URI'],"burl=") !== false) {
		 $altsec=array("AlterSection"=>"setting/mpdconfig.xml");
		 GetAlterConfig("Mpd_net",$altsec);								// ダミーでmpdartlist.xmlに"Mpd_net"の設定があるようにしてmpdconfig.xmlを取得
		 $XML_CONF=$XML_CONF_ARY["setting/mpdconfig.xml"];
	 	 }
	else {
		 $XML_CONF="";													// mpdwebと関連なく動作している
		 }
	$SESSION_CONF=ArgSessionConf($SESSION_CONF);						// mpdweb:Session id 作成 : Used mpdcmnses.lib.php
	$XML_CONF=$sv_conf;
	return($SESSION_CONF);
	}

/* -----------------------------------------------------------------------------
	GetReserveStruct($mode="js") : 変換用予約語配列設定
	 $mode     : i  : 配列のRequestモード , ""|php:PHP用配列 / js: (Call元は慣例的にいずれか設定)
	 @return   : o  : 変換用予約配列
	 Parameter設定で自URL,変換配列を設定
----------------------------------------------------------------------------- */
function GetReserveStruct($mode="js") {
	global $REQ_MODULE,$REQ_PATH;					// XML Setting

	if ($_SERVER['SERVER_PORT'] !== '80') { $port=":".$_SERVER['SERVER_PORT']; } else { $port=""; }
	if ($mode == "js") {
		 $TBLCHG= array('$SERVERMD$'=>"'".$_SERVER['PHP_SELF']."'",'$SelfURL$'=>(empty($_SERVER["HTTPS"]) ? "http://" : "https://").$_SERVER["HTTP_HOST"].$port.'\'+REQUEST_URI+\'','$HTTP_HOST$'=>(empty($_SERVER["HTTPS"]) ? "http://" : "https://").$_SERVER["HTTP_HOST"]."/",'$REQ_MODULE$'=>$REQ_MODULE,'$REQ_PATH$'=>$REQ_PATH);		// 変換予約語(Js)
		 }
	else {
		 $TBLCHG= array('$SERVERMD$'=>"'".$_SERVER['PHP_SELF']."'",'$SelfURL$'=>(empty($_SERVER["HTTPS"]) ? "http://" : "https://").$_SERVER["HTTP_HOST"].$port.$_SERVER['REQUEST_URI'],'$HTTP_HOST$'=>(empty($_SERVER["HTTPS"]) ? "http://" : "https://").$_SERVER["HTTP_HOST"]."/",'$REQ_MODULE$'=>$REQ_MODULE,'$REQ_PATH$'=>$REQ_PATH);	// 変換予約語(php)
		 }
	return($TBLCHG);
	}

/*
	GetReserveChange($str,$tblchg) : 文字列を指定配列より変換
	 $str      : i  : 変換対象文字列
	 $tblchg   : i  : 変換配列 $tblchg[変換対象]=>{変換後文字列}
	 @return   : o  : 変換後文字列
	※局面,効率より全てでこの関数を使用していないことに注意
*/
function GetReserveChange($str,$tblchg) {
	$str_org=$str;						// 変換前の文字列をKeep
	$tblchg_key = array_keys($tblchg);
	$str=str_replace($tblchg_key,$tblchg,$str);		// 無条件変換

	$enctbl=array("Enc","B64","Hex");				// Encode対象配列
	foreach($enctbl as $enc) {
		if(($pos=strpos($str_org,$enc)) !== false) {			// 変換文字列にEncode指定があったとき変換する(含まれていた場合も考えないとりあえず変換してみる)
			$othkey=array();			// $tblchg_key:Encode対象	{x}{Enc}:
			$othval=array();			// $tblchg    :Encode文字列
			foreach($tblchg as $key => $val) {	// $tblchgを全て Encode結果の配列にする
				$deli=substr($key,0,1);				// 先頭1文字をデリミッタ文字とする ${key}$ / {key} / %{key}%
				$chgstr=substr($key,1);
				if ($enc=="Enc") {
					 $othval[]=urlencode($val);			// URLEncode
					 }
				else {
					 $othval[]=ArgEncode($val,$enc);	// 当システム固有Encode
					 }
				$othkey[]=$deli.$enc.":".$chgstr;		// 変換対象文字 "$"{Enc}:{char}
				}
			$str=str_replace($othkey,$othval,$str);
			}
		}
	return($str);
	}

/* -----------------------------------------------------------------------------
	GetEnvAddFunc($AddFunc) : Environment XML"Additional_Func" Init
	追加機能「Add/Play.....」の機能ごと初期設定
	$AddFunc : i  : XML"Additional_Func Name" <Additional_Func><{$AddFunc}>
	@return  : o  : $XML_ADDPARM: ["dset"][]:%{Item}% ,["enc"][]:"Enc/B64/Hex/Jsp" ,["prefix"][]:Prefix ,["sour"][]:Item ,["line"]:XML Line ,["SetNo"]:Set数
----------------------------------------------------------------------------- */
function GetEnvAddFunc($AddFunc) {
	$XML_ADDPARM=array();
	$funcstr =array($AddFunc=> "");
	$XML_ADDPARM["SetNo"]=get_config("Additional_Func",$funcstr);											// XML File,MPD_META設定
	$str_line=$funcstr[$AddFunc];
	$XML_ADDPARM["line"]=$str_line;$XML_ADDPARM["sour"]=array();
	$result = preg_match_all('/%(.*?)%/',$str_line,$dest,PREG_SET_ORDER);
	if(false!==$result){
		foreach($dest as $key => $destary){
			$XML_ADDPARM["dset"][]=$destary[0];							// $XML_ADDPARM["dset"][]:%xxxx% : str_replace用の配列にする
			$dest_str=explode(":",$destary[1]);
			$XML_ADDPARM["sour"][] =$dest_str[(count($dest_str)-1)];	// $XML_ADDPARM["enc][]:%xxxx%
			if(($i =array_searchs(array("B64","Hex","Enc","Jsp"),$dest_str)) !== false) {
				 $dst_sour =$dest_str[($i+1)];
				 $XML_ADDPARM["enc"][] =$dest_str[$i];
				 if (count($dest_str) > 2) { $XML_ADDPARM["prefix"][] =$dest_str[0]; } else { $XML_ADDPARM["prefix"][] =""; }
				 }
			else {
				 $XML_ADDPARM["enc"][] ="";
				 if (count($dest_str) > 1) { $XML_ADDPARM["prefix"][] =$dest_str[0]; } else { $XML_ADDPARM["prefix"][] =""; }
				 }
			}
		}
	return($XML_ADDPARM);
	}

/*
	array_searchs($str_search,$ds_aray) : array_search search's verstion
	$str_search: i  : Search String Array $ds_aray内でいずれか一致を検索する。
	$ds_aray   : i  : Search Array
	@return    : o  : 最初に一致したインデックス 一致しない場合:false
*/
function array_searchs($str_search,$ds_aray) {
	$ret=false;
	foreach($str_search as $srch) {		// 配列よりSearch
		if(($i =array_search($srch,$ds_aray)) !== false) { $ret=$i; break; }
		}
	return($ret);
	}

/*
	GetEnvAddFuncGrp($AddFunc,$default) : Environment XML"Additional_Func" Init Group (GetEnvAddFunc Group)
	$AddFunc : i  : XML"Additional_Func Name" <Additional_Func><{$AddFunc}>
	$default : i  : XML"Additional_Func Name($AddFunc)が未設定時のデフォルト
	@return  : o  : $XML_ADDPARM_ARY  : ["PARM"] $XML_ADDPARM ["SetNo"] SetNo
*/
function GetEnvAddFuncGrp($AddFunc,$default) {
	global $XML_ADDPARMKEY,$XML_ADDPARMATTR;	// XML Setting	// $XML_ADDPARMKEY:XML Additional_Func複数Function,$XML_ADDPARMATTR:XML Additional_Func属性

	$XML_ADDPARM_ARY["SetNo"]=0;
	foreach($XML_ADDPARMKEY as $key => $val) {				// XML定義 <Art_Path> String
		if (((strpos($val,$default) !== 0)&&(strpos($val,$default.'#') !== 0)) &&					// 指定Tag($AddFunc) & Defaultが有効
		 ((strpos($val,$AddFunc.'_') !== 0)&&(strpos($val,$AddFunc.'#') !== 0))) { continue; }		// #がないのは,Orignal定義
		$XML_ADDPARM=GetEnvAddFunc($val);		// 外部I/F Add Moduleごと
		if ($XML_ADDPARM["SetNo"] == 0) { continue; }
		$XML_ADDPARM_ARY["PARM"][$val]=$XML_ADDPARM;
		$XML_ADDPARM_ARY["Extension"][$val]="";
		if (isset($XML_ADDPARMATTR[$val]["Extension"])) {
			$XML_ADDPARM_ARY["Extension"][$val]=$XML_ADDPARMATTR[$val]["Extension"];				// GetEnvAddFuncSetGrpで使用するとき拡張子チェック用
			}
		$XML_ADDPARM_ARY["SetNo"]+=1;
		}
	return($XML_ADDPARM_ARY);
	}

/* -----------------------------------------------------------------------------
	GetEnvAddFuncSet($output,&$XML_ADDPARM) : Environment XML"Additional_Func" Set
	追加機能「Add/Play.....」の機能設定
	$output     : i  : MPD Output Array
	$XML_ADDPARM: io : ["dset"][] :%{Item}% ,["enc"][]:"Enc/B64/Hex" ,["sour"][]:Item ,["line"]:XML Line Rep ,["SetNo"]:Set数 
	               o   ["valid"][]:when ,MPD Item Valid,"1" ,["val"][]:MPD Item ,["click"]:onclick string ,["js"]:onclick stringからonclickを除いたもの ,["name"]:HTML Name(Value)
	@return     : o  : 0:Jsなし,1:Jsあり
----------------------------------------------------------------------------- */
function GetEnvAddFuncSet($output,&$XML_ADDPARM) {
	global $REQ_MODULE,$REQ_PATH;					// XML Setting

	$TBLCHG=GetReserveStruct("js");					// 自URL,変換配列を設定
	$XML_ADDPARM["click"]="";$XML_ADDPARM["js"]="";$XML_ADDPARM["name"]="";$Artist="";
	if ($XML_ADDPARM["line"] == "") { return(-1); }
	foreach($XML_ADDPARM["sour"] as $skey => $sou) {
		$XML_ADDPARM["val"][$skey]="";$XML_ADDPARM["valid"][$skey]=0;$Artist="";
		if (isset($output[$XML_ADDPARM["sour"][$skey]])) {									// Output ArrayからSourceの内容を編集
			 if ($output[$XML_ADDPARM["sour"][$skey]] !== "") { $XML_ADDPARM["valid"][$skey]=1; }
			 $qey_val=$output[$XML_ADDPARM["sour"][$skey]];
			 }
		if ($XML_ADDPARM["valid"][$skey] == 1) {
			if (($XML_ADDPARM["enc"][$skey] =="B64")||($XML_ADDPARM["enc"][$skey] =="Hex")) {		// Prefix指定時の編集 %{Prefix}:{Encode:B64,Hex,Enc}:{String}
				 $qey_val=ArgEncode($qey_val,$XML_ADDPARM["enc"][$skey]);
				 }
			else if ($XML_ADDPARM["enc"][$skey] =="Enc") { $qey_val=urlencode($qey_val); }
			else if ($XML_ADDPARM["enc"][$skey] =="Jsp") {
				 $qey_val=str_replace("'","\'",$qey_val);		// JSP/PHPで使用するための変換後,URLEncode
				 $qey_val=urlencode($qey_val);
				 }
			if ($XML_ADDPARM["prefix"][$skey] !== "") {												// Prefix指定時の編集 %{Prefix}:{String}
				   $XML_ADDPARM["val"][$skey] =$XML_ADDPARM["prefix"][$skey].":".$qey_val; }
			else { $XML_ADDPARM["val"][$skey] =$qey_val; }
			}
		}
	foreach($TBLCHG as $CHGKEY => $CHGWRD) { $XML_ADDPARM["dset"][]=$CHGKEY; $XML_ADDPARM["val"][]=$CHGWRD; }	// 変換Word(予約語)を追加
	$XML_ADDPARM["conv"]=str_replace($XML_ADDPARM["dset"],$XML_ADDPARM["val"],$XML_ADDPARM["line"]);			// Source変数「%{Filed}%」を変換
	$str=explode("onclick=",$XML_ADDPARM["conv"]);													// <{filed}> [%{Filed}%] onclick={js}
	$XML_ADDPARM["name"]=$str[0];																	// OnclickとValue(Name)を分離
	if (isset($str[1])) { $XML_ADDPARM["click"]='onclick="'.$str[1].'"';$XML_ADDPARM["js"]=$str[1]; $ret=1; } else { $ret=0; }	// Onclick(JS)ありRetrun(1)
	return($ret);
	}

/*
	GetEnvAddFuncSetGrp($SOURCE,$XML_ADDPARM_ARY) : Environment XML"Additional_Func" Set Group (GetEnvAddFuncSet Group) : 複数設定対応
	$SOURCE         : i  : MPD Output Array
	$XML_ADDPARM_ARY: io : ["PARM"] $XML_ADDPARM ["Return"]:GetEnvAddFuncSet Return
	$query          : i  : "":チェックなし, セット時:XML Attribure:Extensionに含まれるかチェック
	@return         : o  : 有効数(今回拡張子チェックを加味した値) , $XML_ADDPARM_ARY["SetNo"]:$XML_ADDPARM_ARY(共有配列)の有効数
*/
function GetEnvAddFuncSetGrp($SOURCE,&$XML_ADDPARM_ARY,$query="") {
	$count=0;
	if ($XML_ADDPARM_ARY["SetNo"] > 0) {
		foreach($XML_ADDPARM_ARY["PARM"] as $key => $XML_ADDPARM) {			// XML定義 <Art_Path> String
			$XML_ADDPARM_ARY["Return"][$key]=false;
			if (($XML_ADDPARM_ARY["Extension"][$key] =="")||(strpos($XML_ADDPARM_ARY["Extension"][$key],$query)!==false))  {
				$ret=GetEnvAddFuncSet($SOURCE,$XML_ADDPARM);			// 外部I/F Add
				$XML_ADDPARM_ARY["PARM"][$key]=$XML_ADDPARM;
				$XML_ADDPARM_ARY["Return"][$key]=$ret;
				$count=$count+1;
				}
			}
		}
	return($count);
	}

/* -----------------------------------------------------------------------------
	DispDirAlbum($home,$tbno) : File System
	 $home   : io : Request Path (default時再設定)
	 $trns   : i  : Request Path (変異分) home+trnsで実際のRequest
	 $burl   : i  : Back URL
	 $tbno   : i  : DispFileAlbum TableNo Art数(XMLConfif)
	 $pos    : i  : Positioning "on"/"off"
	 $value  : i  : Positioning 位置 (Value)

	※global $ARYDIR=$dir_ary;$ARYLIST: 各種外部Programで使用できる項目
	  $ARYDIR:Directory Array (".",".."は含まない) ,  $ARYLIST:Directory/File Array , $FILE_LAYER:DirctoryCount
----------------------------------------------------------------------------- */
function DispDirAlbum(&$home="",$trns="",$burl="",$tbno=3,$pos="on",$value="") {
	global $XML_IMGSETHOST,$XML_IMGSET,$XML_DISP,$XML_ViewExtend;				// $XML_CONF:XML
	global $SOURCE,$REQ_MODULE,$SERVERMD,$CALLBACK,$REQ_UA,$IDTIPRE,$MPDHOST;	// Option Function // Post
	global $DSP_SEQID;$DSP_SEQID=array();										// ImageSource Array $DSP_SEQID[HTML-id][url]/[ins]:object instance (Used JS)

//print "<BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR>Thread[".$XML_IMGSET["Thread"]."][".$XML_IMGSET["ThreadMin"]."kb] ImgPost[".$XML_DISP["ImgPost"]."]<BR>";
//print "<BR><BR><BR><BR><BR>-------------------------------------------------<BR>";
//print_r($XML_ViewExtend);
	$remote_path=DirStringMerge($home,$trns);
	$xml_path=DispDirAlbumSelect($remote_path,$home,$trns);
	$dir= explode("/",$xml_path["request"]);
// GetEnvAddFunc Paramter (Basic) literal
	$SOURCE=array();
	$SOURCE["Module"]=$REQ_MODULE;
	$SOURCE["Backurl"]=$burl;
	$SOURCE["RequestDir"]=rtrim($xml_path["request"],"/");
	$SOURCE["LocalDir"]=rtrim($remote_path,"/");
	$SOURCE["MpdHost"]=$MPDHOST;

	if ($_SERVER['SERVER_PORT'] !== '80') { $port=":".$_SERVER['SERVER_PORT']; } else { $port=""; }
//	$SOURCE["RequestURI"]=$http.$_SERVER['SERVER_ADDR'].$port.$_SERVER['REQUEST_URI'];		// Request ServerName , PHPバージョンで機能しない場合を使用い
	$http=(empty($_SERVER['HTTPS']) ? 'http://' : 'https://');
	if ($_SERVER['SERVER_NAME']=="_") {														// nginx 初期で'_'が帰る
		 $SOURCE["RequestURI"]=$http.$_SERVER["HTTP_HOST"].$_SERVER['REQUEST_URI'];			// $_SERVER['SERVER_ADDR']がLocal IPのみ返すようになったので[ServerName]を使用したい
		 }
	else {
		 $SOURCE["RequestURI"]=$http.$_SERVER['SERVER_NAME'].$port.$_SERVER['REQUEST_URI'];	// Request ServerName , PHPバージョンで機能しない場合上記を使用
		 }
// Header 
  ob_start();			// Standerd Out Buffer Start
	print '<title>ArtList ('.$_SERVER["HTTP_HOST"].')</title>';
	DispDirAlbumHeader($home,$trns,$xml_path,$burl,$tbno,$pos);
	$local_path=$remote_path;
	$dirName = preg_quote($xml_path["rel"], "/");		// 正規表現"/"コンバート
	$local_path=preg_replace("/".$dirName."/",$xml_path["local"],$local_path,1);
	$SOURCE["LocalDir"]=rtrim($local_path,"/");
	DispState();
	if (substr($local_path,(strlen($local_path)-1),1) !== "/") { $local_path=$local_path."/"; }		// Local Path Last"/" 
	$file_ary="";
	if (file_exists($local_path)) {						// Directory存在チェック
		$file_ary=scandir($local_path);					// **** Directory List Get ****
		}
// HTML Output
	$idtop=NULL;$idlast="";$idpostion="";$str="";		// $idtop:Lastポジション用先頭id , $idlast:Lastポジション用最終id , $idpostion:Positon Point
	if (($value!=="")&&($pos == "on")) {
		$str='style="display:none;"';					// 指定位置Position 最後に表示するので非表示にする要求
		}
	print '<div id=grpartls '.$str.'>';
	JsListLoadDisp($pos,$value,"grpartls");				// 時計マーク表示
	$dir_ary=DispDirAlbumDirectory($home,$trns,$local_path,$file_ary,$xml_path,$idtop,$idlast,$value,$idpostion);
	global $ARYDIR,$ARYLIST,$FILE_LAYER;$ARYDIR=$dir_ary;$ARYLIST=$file_ary;$FILE_LAYER=sizeof((array)$dir);
	if (is_array($dir_ary)) {
		$dir_ary["."]=".";$dir_ary[".."]="..";			// ".",".."を配列に追加(Ary初期化も兼ねる:$dir_ary[{Dir}]:Dir|"":使用後 (DirectoryとFileは同じ名前は作成できないが)
		}
// Path Thumbnail
	global $XML_ADDPARM_ARY;							// Option Function
	$XML_ADDPARM_ARY=GetEnvAddFuncGrp("Image_".$REQ_MODULE,"Image");
	$SOURCE["RequestPath"]=rtrim($xml_path["request"],"/");

	$heightadjust=4;		// Album Artがないとき,Art部にOverleyボタンの高さ調整(微妙にずれる)
	$widthadjust=4;			// 幅がBorder分ずれるので部調整   1:474 2:471 3:468,4:465,5:462 6:459 3pxきざみ
	$tbwidth=(477-$tbno*$widthadjust)/$tbno;			// Album Art基準は:1行(117px) 4アルバム表示 //	$tbno=4;	//	$tbwidth=116;
	$extend = explode(',',$XML_IMGSET["Extension"]);	// 拡張子設定を配列
	$tbcnt=999;
	$idscrl=0;
	$GImgfile=NULL;$Gimagesize=NULL;$arrival_kind=array();
	if (!is_array($file_ary)) {							// Directoryが存在しないときは終了
		print '<div style="color:#f08080;font-size:12px;"><BR>&nbsp;&nbsp;No such file or directory </div></div>';
		$buffer = ob_get_contents();					// Standerd Out Buffer Output
		ob_end_clean();
		echo $buffer;
		return;
		}

	print '<table border="0" cellpadding="0" bgcolor="#000000" frame="void" style="Display:block;">';
	$id_ary["kind"]=array();							// 他機能へのI/F用にimage file idを作成する
	$tnimgary=array();									// DispThumbnail_Image()対象の配列
	foreach ($file_ary as $fno => $file) {
		$ext_kind="";$ext_find=1;						// ※ViewExtendでイメージデータを設定し$ext_kindを与えれば,別途Viewerを使用できる。
		$filesize=NULL;$encname="";						// FileSize 物理ファイルからの情報なのでレスポンスより必要になったときにGetし,継承する。 $encname:画像LibraryのNameがある場合
		if ((isset($dir_ary[$file]))&&($dir_ary[$file]==$file)) {	// Directoryを除外
			$dir_ary[$file]="";				// Directoryと同じFileNameがあった場合を考慮し,除外マーク
			continue;
			}
 		$path_parts = pathinfo($file);
		if ($path_parts['extension']=="") { continue; }		// ['extension']拡張子がない場合は表示方法が判断できないので対象外
		if (in_array(strtolower($path_parts['extension']),array_map('strtolower',$XML_ViewExtend["val"])) ===true) { $ext_kind=$XML_ViewExtend["key"][(strtolower($path_parts['extension']))]; }
		else if (in_array(strtolower($path_parts['extension']),array_map('strtolower',$extend)) ===true) { $ext_kind="Image";$ext_find=0; } 
		else { continue; }					// 対象外拡張子判定(大文字小文字を区別しない)
		if ($tbcnt >= $tbno) {				// 1 Line End
			if ($tbcnt !== 999) {
				print '</tr>';
				}
			print '<tr>';					// n個置きに tr /tr
			$tbcnt=0;
			}
// 1 Line Edit -------------------------------
		$tbcnt=$tbcnt+1;
		print '<td>';
		$idscrl=$idscrl+1;
		$id="divimg".$idscrl;							// <div id : divimg{n}
		$idimg="idimg".$idscrl;							// image file id : idimg{n}
		if (is_null($idtop)) { $idtop=$id; } 			// 指定位置Position 先頭,最後のid設定
		$idlast=$id;
		$id_ary["kind"][$fno]=$ext_kind;				// 他機能へのI/F用にimage file : kindをSaveする
		$id_ary["id"][$fno]=$idimg;						// 他機能へのI/F用にimage file : idをSaveする
		print '<div id="'.$id.'" style="font-size:11px;width:'.$tbwidth.'px;height:'.$tbwidth.'px;overflow:hidden;margin:0px 0px 0px -1px;">';
		$dirName = preg_quote($xml_path["local"], "/");				// 正規表現"/"コンバート	// 画像Path生成
		$Img_file=rtrim(DirStringMerge($local_path,$file),'/');
		$urlstr=preg_replace("/".$dirName."/",$xml_path["host"],$Img_file,1);
		$urlstr=URLHTMLEncode($urlstr);
		if ($XML_ADDPARM_ARY["SetNo"] !== 0) {						// Used Add Function, Image Function literal
			$SOURCE["File"]=$file;
			$SOURCE["RemotePath"]=$urlstr;
			$SOURCE["LocalPath"]=$Img_file;
			$SOURCE["RequestPath"]=rtrim($xml_path["request"],'/')."/".$file;
			$SOURCE["IdImg"]=$idimg;
			}
		$urlstr_js=str_replace(array("\\","'",'"',"&"),array("\\\\","\'",'&quot;',"%26"),$urlstr);			// jsで使用するためコンスタント ',"→\',\"
		$file_js=str_replace(array("\\","'",'"',"&"),array("\\\\","\'",'&quot;',"%26"),$file);				// jsで使用するためのFile名コンスタント ',"→\',\"
// Thumbnail --------------------------------
		$retwidth="";$rethigth="";$EditAspect="";													// 拡張子と関連ThumbnailViewの判定
		if ((isset($XML_ViewExtend["Func"][$ext_kind]))&&($XML_ViewExtend["Func"][$ext_kind] !=="")&&($ext_find ==1)) {		/*---------- [外部View使用] --------*/
			 $arrival_kind[$ext_kind]="3";						// 出現したKindをKeep
			 $ext_func=(string)$XML_ViewExtend["Func"][$ext_kind];		// Function Name
			 $mode=$XML_ViewExtend["mode"][$ext_kind];			// 0:なし 1:require,2:include,9:Sourceなし
			 $source=(string)$XML_ViewExtend["source"][$ext_kind];
			 DispThumbnail_External($ext_func,$mode,$source,$idimg,$ext_kind,$tbno,$Img_file,$file,$file_js,$tbwidth,$urlstr,$urlstr_js,$retwidth,$rethigth);	// 拡張外部View
			 }
		else if ($ext_find ==1) {																	/*---------- [内部拡張汎用View](設定が検出時) --------*/
			 $arrival_kind[$ext_kind]="2";						// 出現したKindをKeep
			 DispThumbnail_Extend($idimg,$ext_kind,$tbno,$Img_file,$file,$file_js,$tbwidth,$urlstr,$urlstr_js,$retwidth,$rethigth); }	// 拡張汎用View
		else {																						/*---------- [内部ImageView](設定未検出,Image拡張子が一致時) -----*/
			 $arrival_kind[$ext_kind]="1";						// 出現したKindをKeep
			 $re=DispThumbnail_Image($idimg,$ext_kind,$tbno,$Img_file,$file,$file_js,$tbwidth,$urlstr,$urlstr_js,$retwidth,$rethigth,$filesize,$encname);		// Image Display Thumbnail
			 $EditAspect=_DispDirAlbumEditAspect($retwidth,$rethigth);
			 if (($XML_IMGSET["View_onclick"] =="")&&($re != -1)) { $tnimgary[]=$IDTIPRE.$idimg; }		// DispThumbnail_Imageのid Array
			 if (($XML_IMGSET["View_onclick"] !=="")&&($re != -1)) { $arrival_kind[$ext_kind]="2"; }	// $XML_IMGSET["View_onclick"]の設定が失敗の場合は内蔵Viewerを使用
			 }
		print '</div>';
// Part Text -------------------------------
		print '<div style="position:relative;top:3px;">';
		if ($REQ_UA !=='PC') { $hdef="16"; } else { $hdef="14"; }
		print '<p class="ellipsis DTTEXT" style="width:'.$tbwidth.'px;height:30px;line-height:'.$hdef.'px;word-break:break-all;">&nbsp;'.(str_replace(' ', '&nbsp;',$file)).'</p>';
		print '</div>';											// background-color:rgba(0,0,0,0.0);透明Style
// Function --------------------------------
		print '<div class=artpd style="margin:-35px 0px 0px 0px;">';
		$id_func='idfunc_'.$idscrl;
		if (($XML_DISP["ImgPost"] == "on")||($XML_DISP["ImgPost"] == "mid")) {							/* 速度によりFile情報をPostでGet */
			 $dsp='if (document.getElementById(\'P'.$id_func.'\')) { document.getElementById(\'P'.$id_func.'\').innerHTML=EditAspect; }';
			 $dsp=$dsp.'document.getElementById(\'S'.$id_func.'\').innerHTML=imgsize;document.getElementById(\'M'.$id_func.'\').innerHTML=imgmodi;';
			 $post = str_replace('%p1%','p=imginfo&file='.(ArgEncode($Img_file)),$SERVERMD);			// Command Repeat
			 $func = str_replace('%func%',$dsp.'RequestBoxDisp(\''.$id_func.'\');',$CALLBACK);			// Callback設定
			 $post = str_replace('\'%p2%\'',$func,$post);												// Post設定
			 print '<button type=submit id="FL'.$file.'" onclick="'.$post.';" class="music artfn" style="width:'.$tbwidth.';height:34px"></button>';
			 if ($ext_kind =="Image") { $EditAspect='Aspect&nbsp;:'; }
			 }
		else {																							/* Loop中にFile情報をPostでGet */
			 print '<button type=submit id="FL'.$file.'" onclick="RequestBoxDisp(\''.$id_func.'\');" class="music artfn" style="width:'.$tbwidth.';height:34px"></button>';
			 }
		print '</div>';									// background-color:rgba(0,0,0,0.0);透明Style
		print '</td>';
		DispDirAlbumFunc($home,$trns,$local_path,$file,$xml_path,$path_parts['extension'],$retwidth,$rethigth,$id_func,200,170,$EditAspect,$filesize,$encname);
		}
// End processing -------------------------
	if ($tbcnt !== 999) { print '</tr>'; }
	print '</table>';
	$init_func=array();									// Viewer判定
	foreach ($arrival_kind as $key => $val) {
		if ((isset($XML_ViewExtend["Init"][$key]))&&($XML_ViewExtend["Init"][$key] !=="")) {
			$init_func[$XML_ViewExtend["Init"][$key]]=$val; }
		}
	if (in_array("1",$arrival_kind)) { DispView_Image(); }	// 拡大画像Box
	if ((in_array("2",$arrival_kind))||(in_array("3",$arrival_kind))) { DispView_Extend(); }	// 内部拡張Viewer
	if (count($init_func) > 0) { DispView_External($init_func); }	// 外部Viewer
	DispEndFunc($local_path,$file_ary,$id_ary);			// End Proc:HTML Output
	print '</div>';
	if (!is_null($idtop)) {
		 JsListLastPosition($idtop,$idlast,76,0);		// 最終位置Position
		 }
	JsListPosition($pos,$idpostion,'grpartls',76);		// 時計マークUnload,指定位置Position
// ImageThumbnail作成後 EndProcess  <Tabel含む親<Div脱出後
	$TBLCHG=GetReserveStruct("js");						// 自URL,変換配列を設定
	foreach($SOURCE as  $key => $val) { $chg["%".$key."%"] = $val; }
	$chg=array_merge($TBLCHG,$chg);
	ArgJsBuiltin("TermHTML",0,$chg);
  $buffer = ob_get_contents();							// Standerd Out Buffer Output
	ob_end_clean();
	echo $buffer;
	if (count($tnimgary) > 0) {							// Thumbnail Image Array JS
		$sp="";$str="";
		 foreach($tnimgary as $val) { $str .=$sp."'".$val."'";$sp=","; }
		 print '<script type="text/javascript">';
		 print 'var TNUMGARY = new Array('.$str.');';
		 print '</script>';
		 }
	else {
		 print '<script type="text/javascript">';
		 print 'var TNUMGARY = new Array();';
		 print '</script>'."\n";
		 }
// $XML_IMGSET["Thread"]数 単位でのThumbnail Imageを表示する
	$id="";$img="";$ins="";$sp="";
	foreach($DSP_SEQID as  $key => $val) {
		$id =$id.$sp.'"'.$key.'"';				// HTML-id
		$img=$img.$sp.'"'.$val["url"].'"';		// Image URL
		$ins=$ins.$sp.'"'.$val["ins"].'"';		// Object instance (.src)
		$sp=",";
		}
	if ($XML_IMGSET["Thread"] > 0) {			// 同時画像Load数
		echo <<<EOM

<script type="text/javascript">;
/* -----------------------------------------------------------------------------
	画像Thread Control EventListenerより .onload Eventの方がResourceが軽い
	がThread数を指定するので,EventListenerで作成する
-------------------------------------------------------------------------------*/

/* -----------------------------------------------------------------------------
    Thumbnail Thread Array
 ----------------------------------------------------------------------------- */
imgid = [ {$id} ];					// Array HTML-id
imgNum= [ {$img} ];					// Image URL
imgins= [ {$ins} ];					// Object instance

/* -----------------------------------------------------------------------------
    Thumbnail Thread Listener
 ----------------------------------------------------------------------------- */
var count  = 0;
if (imgNum.length > 0) {
	for (var i=0;i< imgNum.length;i++) {
		document.getElementById(imgid[i]).addEventListener("load",					// Image Load後発火
			function ArgImgEnd(event) {
//				alert(event.target.id);		// idを取得
				event.currentTarget.removeEventListener(event.type,ArgImgEnd);		// IE未対応のため removeEventListener
				DispLoadImage();
				},
			{ once: true }
			);
		}
	}

/* -----------------------------------------------------------------------------
    Thumbnail Thread Load Kick
 ----------------------------------------------------------------------------- */
function DispLoadImage() {
	var endcount=count+1;
	if (count==0) {
		 endcount={$XML_IMGSET["Thread"]};
		 }
	for (;count < imgNum.length;) {
		if (imgins[count]=="src") {		// Objectがsrc(image)
			document.getElementById(imgid[count]).style.display ="block";
			document.getElementById(imgid[count]+'ld').classList.remove('loading-icon');		// Load-icon Classを削除 (表示完了Event消したいが,Postionがずれるため)
			document.getElementById(imgid[count]).src = imgNum[count];
			}
		count++;
		if(count >= endcount) {
			break;
			}
		}
	}
</script>
EOM;
		}
	}

/*
	_DispDirAlbumEditAspect($width,$higth) : Edit Image Info
	 $width     : i  : 画像Width
	 $higth     : i  : 画像Higth
	 @return    : o  : String Edit Image Info
*/
function _DispDirAlbumEditAspect($width,$higth) {
	$str='';
	$str='Aspect&nbsp;:&nbsp;'.$width.'px&nbsp;x&nbsp;'.$higth.'px';
	return($str);
	}

/* -----------------------------------------------------------------------------
    Thumbnail Viewer  DispThumbnail_Image / DispThumbnail_Extend / DispThumbnail_External
 ----------------------------------------------------------------------------- */
/* Setting for each extension (同レベルの関数は引数を同じにしている) --------- */
/*
	DispThumbnail_Image($idimg,$kind,$tbno,$Img_file,$file,$file_js,$tbwidth,$urlstr,$urlstr_js,$retwidth,$rethigth,$filesize,$encname) : Display Thumbnail Image
	 $idimg    : i  : "<img" Tagのidに設定用
	 $kind     : i  : Data Kind (拡張子種別:Image)
	 $tbno     : i  : DispFileAlbum TableNo Art数(XMLConfif)
	 $Img_file : i  : File Path
	 $file     : i  : File Name
	 $file_js  : i  : jsで使用するためのFile名(',"→\',\")
	 $tbwidth  : i  : Display Width
	 $urlstr   : i  : URL File Path (URL Encode)
	 $urlstr_js: i  : URL(JS) File Path (URL Encode JS Escape)
	 $retwidth : io : Image Data width
	 $rethigth : io : Image Data higth
	 $filesize : io : FileSize 物理ファイルからの情報なのでレスポンスより必要になったときにGetし,継承する。
	 $encname  : io : Image EncodeLibraryを使用時,Nameが設定されていた場合設定
	 @return   : o  : 標準出力用HTML (-1:Tagが未設定時)
*/
function DispThumbnail_Image($idimg,$kind,$tbno,$Img_file,$file,$file_js,$tbwidth,$urlstr,$urlstr_js,&$retwidth,&$rethigth,&$filesize,&$encname) {
	global $XML_DISP,$XML_IMGSET,$SOURCE,$REQ_MODULE,$SERVERMD,$CALLBACK,$IDTIPRE;		// XML定義 // Option Function // Post
	global $XML_THUMBNAIL,$DSP_SEQID;			// $XML_THUMBNAIL[FileSize]["url"]:Thumnail Script,[FileSize]["ext"]:extension,$DSP_SEQIDを順に表示(Used JS),ImageSource Array $DSP_SEQID[HTML-id][url]/[ins]:object instance (Used JS)

	$retwidth="";$rethigth="";$clip=NULL;$onclick="";$ret="";if (isset($encname)) { $encname=""; }
	if ($XML_IMGSET["View_onclick"] !== "") {						// $XML_IMGSET["View_onclick"]の設定がある場合.Viewerは拡張版を使用する
		$xml_view=array("View_".$kind =>"{$urlstr_js}");
		get_config("ViewExtend",$xml_view);							// <ViewExtend> <View_{$kind}:Thumbnail On Click Viewer Kick shell
		$xml_view["View_".$kind]=URLHTMLEncode($xml_view["View_".$kind]);
		$change=array('{$View}'=>$xml_view["View_".$kind]);
		$fldary = compact("idimg","Img_file","file","file_js","tbwidth","urlstr","urlstr_js","retwidth","rethigth","tbno");
		$sel=array("View_onclick"=>"1");							// XML:セレクト対象Tag , 1:指定文字列を含む前方一致
		$ret=ArgXML2HTMLStr("Image",$sel,$fldary,$change,"","");
		if ($ret !==-1) { $onclick = $ret; }
		}
	if ($onclick =="") {		// $onclick=""は内蔵のViewerを使用する				// dispsize:JSPで使用の項目、画像の幅高さの実質サイズ ※高さを明示的に指定していないと値がとれないためファイルから取得する処置
		$file_rep=str_replace(array("\\","'",'"'),array("\\\\","\'",'&quot;'),$file);			// jsで使用するためコンスタント ',"→\',\"
		$onclick='RequestBoxImage(\''.$urlstr_js.'\',dispsize,\''.$file_rep.'\');';
		}
	$jsfunc='DispImagePos(\''.($IDTIPRE.$idimg).'\');';
	if ((($XML_DISP["ImgPost"] == "on")||($XML_DISP["ImgPost"] == "mid"))&&(strpos($onclick,'dispsize') !== false)) {	// Post時,ImageFile情報はPost処理(dispsizeを含んでいる場合)
		 $post = str_replace('%p1%','p=imgsize&file='.(ArgEncode($Img_file)),$SERVERMD);			// Command Repeat
		 $func = str_replace('%func%',$onclick,$CALLBACK);							// Callback設定
		 $post = str_replace('\'%p2%\'',$func,$post);								// Post設定
		 print '<div id='.($IDTIPRE.$idimg).' onclick="'.$post.$jsfunc.'" style="cursor:pointer;">';
		 }
	else {
		 $dispsize=ArgImageSize($Img_file,"474:aspect","Image",$imgwidth,$imghigth,$clip,$retwidth,$rethigth);	// 速度の点より,LocalPathでサイズを求める
		 $urlstr_size='imgwidth='.$retwidth.';imgheight='.$rethigth.';dispsize='.$dispsize.';';
		 print '<div id='.($IDTIPRE.$idimg).' onclick="'.$urlstr_size.$onclick.$jsfunc.'" style="cursor:pointer;width:'.$tbwidth.'px; height:'.$tbwidth.'px; overflow:hidden;">';
		 }
	$clip="";
	if ($XML_DISP["ImgPost"] == "on") {												// Post時,サムネイルは正方形に固定する
		 $imghigth=$tbwidth;
		 $imgwidth=$tbwidth;
		 }
	else {																			// サムネイルはImgPost == off/midのとき設定が有効
		 ArgImageSize($Img_file,$tbwidth.":fix","File",$imgwidth,$imghigth,$clip);	// 速度の点より,LocalPathでサイズを求める
		 }
	if ($clip !== "") { $style='style="'.$clip.'overflow:hidden;"'; } else { $style=''; }

	$url="";$extension="";$opt="";$threadon="on";									// $pot=on: path=""を使用する src=が外部Thumbnailモジュールのとき($urlstr以外) ,$threadon:on:ImageThread数管理,"":Image即表示
	$filepath = pathinfo($Img_file);
	if (isset($filepath['extension'])) { $extension=$filepath['extension']; }		// 画像形式ごとに対応
	if ((($XML_DISP["ImgPost"] == "on")||($XML_DISP["ImgPost"] == "mid"))||(count($XML_THUMBNAIL)==0))  {		// Thumbnail設定を適用しない
		 $url=$urlstr;
		 }																// 1件の設定時,拡張子が一致する/ファイルサイズが指定されていなければ採用
	else if ((count($XML_THUMBNAIL)==1)&&(isset($XML_THUMBNAIL["0"]["url"]))&& (($XML_THUMBNAIL["0"]["ext"]=="")||(stripos($XML_THUMBNAIL["0"]["ext"],$extension) !== false)) ) {		// Fileサイズ指定なしのみ設定
		 $url="";
		 eval('$url=\''.$XML_THUMBNAIL["0"]["url"].'\';');				// 1件の設定を展開
		 if ($url !==$urlstr) { $opt="on"; }
	 	 }
	else {
		 if (is_null($filesize)) { $filesize=filesize($Img_file); }		// filesizeがなければGet
		 $size=$filesize / 1000;			// KByte扱い
		 if ($size <= $XML_IMGSET["ThreadMin"]) {						// Thread範囲,指定ファイルサイズ以下は完了Event適用外
			 $threadon="";
			 }
		 foreach ($XML_THUMBNAIL as $key => $val) {						// Key:Filesize 9999.x x:連番
			$keysize=intval($key);										// 拡張子が一致する側近のファイルサイズを探す。
			if (($size >=$keysize)&&(($XML_THUMBNAIL[$key]["ext"]=="")||(stripos($XML_THUMBNAIL[$key]["ext"],$extension) !== false))) {
				if ($XML_THUMBNAIL[$key]["url"]=="false") {									// Sizeが大きいため表示しない
					 $url="false";
					 }
				else {													// 一致する設定を展開
					 $url="";
					 if (isset($encname)) { $encname=$XML_THUMBNAIL[$key]["name"]; }
					 eval('$url=\''.$XML_THUMBNAIL[$key]["url"].'\';');
					 if ($url !==$urlstr) { $opt="on"; }
					 }
				break;
				}
			}
		 }
	if ($url=="") { $url=$urlstr; }				// 条件が不一致時のDefault
	$src="";									// <img src={$src}
	if ($url !=="false") {
		if (($XML_IMGSET["Thread"] > 0)&&($threadon=="on")) {	// 同時画像Load数:Thread数 Thumbnail Imageを表示する(Js) : Post:on/midはThread設定対象(Filesizeを見ないので0扱い)
			 $DSP_SEQID[$idimg]["url"]=$url;	// 配列を完了Eventで監視
			 $DSP_SEQID[$idimg]["ins"]="src";	// <img Tagを示す
			 if ($style !== "") { $style=(rtrim($style,'"')).'hidden;display:none;"'; } else { $style='style="display:none;"'; }	// LoadEventで表示するため初期は表示しない
			 }
		else {									// Thread設定:一回で表示するためダイレクトに指定
			 $src=$url;
			 }
		}
	$altname=$filepath['basename'];
	$mright=0;if ($clip !="") { $mright=$imgwidth+2; }								// Thumbnail表示時の縦横長時の右補正値
	$mload=30;if ($tbno >=8) { $mload=10; } else if ($tbno >=5) { $mload=20; } 		// 時計マークのTopMargin
	$fonttop=' style="position:relative;top:'.(($tbwidth-30)/2-10).'px;"';$font=14;if ($tbno > 6) { $font=7;$fonttop=''; } else if ($tbno > 2) { $font=11; }
	if ($url =="false") {					// Sizeが大きいため表示しない
		 print '<div id="'.$idimg.'" path="'.$urlstr.'" align=center style="background-color:#1e3333;font-size:'.$font.'px;color:#f0e68c;border:0px solid #333333;width:'.$tbwidth.'px;height:'.$tbwidth.'px;margin:-8px 0px 0px 0px;"><div style="margin:7px 0px 0px 0px;">';
		 print '<div'.$fonttop.'>Click to See!!<BR>Hide because File is large </div></div></div>';
		 }
	else if ($opt=="") {					// Default(標準)の表示
		 print '<div align=center style="background-color:#585858;font-size:'.$font.'px;border:0px solid #333333;width:'.$tbwidth.'px;height:'.$tbwidth.'px;margin:-8px 0px 0px 0px;"><div style="margin:7px '.$mright.'px 0px 0px;">';
		 print '<img id="'.$idimg.'" path="'.$urlstr.'" alt="'.$altname.'" src="'.$src.'" width="'.$imgwidth.'" height='.$imghigth.' border="0" '.$style.' />';			// Thumb nail(小画像を)使用しないので速度は望めない
		 $str=' style="position:relative;top:'.($tbwidth/2-$mload).'px;"';
		 if ($clip !="") {
			 $str=' style="position:relative;top:'.($tbwidth/2-$mload).'px;left:'.(($tbwidth-30)/2-10).'px;"';
		 	 }
		 if ($src =="") {					// ダイレクト(完了Event監視なし)は,時計マークを表示しない
		 	print '<div id="'.$idimg.'ld" class="loading-icon" '.$str.'></div>';
			}
		 print '</div></div>';
		 }
	else {									// Option表示 (設定でThumbnail URLを編集時)
		 print '<div align=center style="background-color:#585858;font-size:'.$font.'px;border:0px solid #333333;width:'.$tbwidth.'px;height:'.$tbwidth.'px;margin:-8px 0px 0px 0px;"><div style="margin:7px '.$mright.'px 0px 0px;">';
		 print '<img id="'.$idimg.'" path="'.$urlstr.'" alt="'.$altname.'" src="'.$src.'" width="'.$imgwidth.'" height='.$imghigth.' border="0" '.$style.' />';				// Thumb nail(小画像を)使用しないので速度は望めない
		 $str=' style="position:relative;top:'.($tbwidth/2-$mload).'px;"';
		 if ($clip !="") {
			 $str=' style="position:relative;top:'.($tbwidth/2-$mload).'px;left:'.(($tbwidth-20)/2-10).'px;"';
			 }
		 if ($src =="") {					// ダイレクト(完了Event監視なし)は,時計マークを表示しない
			 print '<div id="'.$idimg.'ld" class="loading-icon" '.$str.'></div>';
			 }
		 print '</div></div>';
		 }
	print '</div>';
	return($ret);
	}

/*
	DispThumbnail_Extend($idimg,$kind,$tbno,$Img_file,$file,$file_js,$tbwidth,$urlstr,$urlstr_js,$retwidth,$rethigth) : Display Thumbnail Image :内部拡張
	 $idimg    : i  : Tagのidに設定する場合に使用
	 $kind     : i  : Data Kind (拡張子種別:Image)
	 $tbno     : i  : DispFileAlbum TableNo Art数(XMLConfif)
	 $Img_file : i  : File Path
	 $file     : i  : File Name
	 $file_js  : i  : jsで使用するためのFile名(',"→\',\")
	 $tbwidth  : i  : Display Width
	 $urlstr   : i  : URL File Path (URL Encode)
	 $urlstr_js: i  : URL(JS) File Path (URL Encode JS Escape)
	 $retwidth : io : Image Data width
	 $rethigth : io : Image Data higth
*/
function DispThumbnail_Extend($idimg,$kind,$tbno,$Img_file,$file,$file_js,$tbwidth,$urlstr="",$urlstr_js="",&$retwidth=NULL,&$rethigth=NULL) {
	$xml_view=array("ViewThumbnail_".$kind =>"{$urlstr_js}","View_".$kind =>"{$urlstr_js}");
	get_config("ViewExtend",$xml_view);								// <ViewExtend> <ViewThumbnail_{kind}>:Thumbnail Viewer /<View_{$kind}:Thumbnail On Click Viewer Kick shell
	$change=array('{$ViewThumbnail}'=>$xml_view["ViewThumbnail_".$kind],'{$View}'=>$xml_view["View_".$kind]);
// Select条件を設定
	$selifinit='$setno_now=-1;$kind="'.$kind.'";';							// セットしているNo($selif使用の初期値) $kind:をセレクトのため値を受け渡す
	$selif[]='if (($ext=array_search("Extend",$at_itm,true)) !== false) {	// 有効判定 : 属性=Extendがあるとき
				if ($attri["Val"][$i][$ext] !== $kind) { return false; }	//  $Kind(対象種別)が違えば対象外
				}
				return true;';
	$selif[]='if (($idx=array_search("No",$at_itm,true)) === false) { $setno=0;return true; } else {	// 属性=Noがないときは,個数定義としないのでtrue
				 $setno = $attri["Val"][$i][$idx]; }				// 表示個数から有効判定 : 属性=Noがあるとき
				 if ($setno_now > $setno) { ;return false; }		// 現在セットしている値より小さいと無視:側近を採用
				 if ($setno > $tbno) { return false; }				// 表示個数より大きい設定は対象外
				 $setno_now=$setno; return true;';			// セットした$setno(表示個数)をKeep
// Filedの継続 : XML{Filed}の設定 & "tbno":$selifにあるため
	$fldary = compact("idimg","Img_file","file","file_js","tbwidth","urlstr","urlstr_js","retwidth","rethigth","tbno");
	$sel=array("Thumbnail"=>"1");	// XML:セレクト対象Tag , 1:指定文字列を含む前方一致
	$ret=ArgXML2HTMLStr("ViewExtend",$sel,$fldary,$change,$selifinit,$selif);
	if ($ret !==-1) {
echo <<<EOM
{$ret}
EOM;
		}
	}

/*
	DispThumbnail_External($ext_func,$mode,$source,$idimg,$kind,$tbno,$Img_file,$file,$file_js,$tbwidth,$urlstr,$urlstr_js,$retwidth,$rethigth) : Display Thumbnail 外部モジュール
	 $ext_func : i  : 関数名
	 $mode     : i  : 0:なし 1:require,2:include,9:Sourceなし
	 $source   : i  : require/include Source
	 $idimg    : i  : Tagのidに設定する場合に使用
	 $kind     : i  : Data Kind (拡張子種別:Image)
	 $tbno     : i  : DispFileAlbum TableNo Art数(XMLConfif)
	 $Img_file : i  : File Path
	 $file     : i  : File Name
	 $file_js  : i  : jsで使用するためのFile名(',"→\',\")
	 $tbwidth  : i  : Display Width
	 $urlstr   : i  : URL File Path (URL Encode)
	 $urlstr_js: i  : URL(JS) File Path (URL Encode JS Escape)
	 $retwidth : io : Image Data width
	 $rethigth : io : Image Data higth
*/
function DispThumbnail_External($ext_func,$mode,$source,$idimg,$kind,$tbno,$Img_file,$file,$file_js,$tbwidth,$urlstr="",$urlstr_js="",&$retwidth=NULL,&$rethigth=NULL) {		// 拡張外部View
//	print "Kind[".$kind."] Function[".$ext_func."] Source[".$source."] mode[".$mode."]<BR>";
	if ($mode=="9") {
		 print '<BR><div style="color:pink">XML:not find the external Source :'.$source.'</div>';
		 }
	if (function_exists($ext_func)) { 								// <{Kind} Func="{Function}">				// 外部関数の呼び出し
		 $ext_func($idimg,$kind,$tbno,$Img_file,$file,$file_js,$tbwidth,$urlstr,$urlstr_js,$retwidth,$rethigth);		//  引数はImage / 内部拡張と同じ
		 }
	else {
		 print '<BR><div style="color:pink">XML:not find the external function :'.$ext_func.'</div>';
		 }

	}

/* -----------------------------------------------------------------------------
    Viewer  DispView_Image / DispView_Extend / DispView_External
 ----------------------------------------------------------------------------- */
/*
	DispView_Image($top,$left,$width): Display View Image Box
	 $top   : i  : HTML Positon Top
	 $left  : i  : HTML Positon Left
	 $width : i  : HTML Width
*/
function DispView_Image($top=48,$left=1,$width=474) {
	global $REQ_UA,$REQ_VENDOR,$REQ_BROWSER,$REQ_PREFIX,$XML_DISP;		// XML設定<VendorPrefix>参照:$REQ_UA:PC|Phone , $REQ_VENDOR:IE|Chromeなど,$REQ_BROWSER;User任意,$REQ_PREFIX:-ms-|-webkit-など
	global $REQ_MODULE,$SOURCE;

	$SORTMP=$SOURCE;$SORTMP["IdBoxImg"]="boximg";
	$XML_ADDPARM=GetEnvAddFunc("ImgBox_".$REQ_MODULE);						// 外部I/F Add Moduleごと
	if ($XML_ADDPARM["SetNo"] == 0) {
		$XML_ADDPARM=GetEnvAddFunc("ImgBox");								// 外部I/F Add
		}
	$AddJsp='onclick="RequestBoxtUnLoad(\'image\');RequestBoxtUnLoad(\'imgFrame\');"';	// id:ImgBox Default Function
	$ret=GetEnvAddFuncSet($SORTMP,$XML_ADDPARM);							// 外部I/F Add
	if ($XML_ADDPARM["line"] !== "")  { $name=$XML_ADDPARM["name"]; }
	if ($XML_ADDPARM["click"] !== "") { $AddJsp=$XML_ADDPARM["click"]; }
	$AddJsp=str_replace('onclick="','function() { ',$AddJsp);$AddJsp=(rtrim($AddJsp,'"')).' }';	// Jspで実行のためfunction()に変換

	if ($REQ_UA !=='PC') {
		 $box_top=-36;$box_height=14;$rang_top=-13;$rang_label=10;$cls_top=-20;$cls_pos=50;$bgpos=-2;	// Android Chome
		 }
	else if ($REQ_VENDOR=='IE') {		// IE:"MSIE" / "Trident"がある
		 $box_top=-60;$box_height=42;$rang_top=-14;$rang_label=33;$cls_top=-32;$cls_pos=52;$bgpos=-2;	// IE 調整値 (slideのデザイン差)
		 }
	else if ($REQ_VENDOR=='Edge') {		//  IE:"Edgs"
		 $box_top=-60;$box_height=42;$rang_top=-5;$rang_label=33;$cls_top=-28;$cls_pos=52;$bgpos=-2;	// Edgs
		 }
	else if ($REQ_VENDOR=='Firefox') {	//  IE:"FierFox"
		 $box_top=-60;$box_height=14;$rang_top=-14;$rang_label=10;$cls_top=-16;$cls_pos=52;$bgpos=-2;	// FierFox
		 }
	else {
		 $box_top=-64;$box_height=14;$rang_top=-12;$rang_label=10;$cls_top=-18;$cls_pos=52;$bgpos=-26;$top=$top+25;	// PC Chome
		 }
	print '<div id=image class=box style="position:fixed;top:'.$top.'px;left:'.$left.'px;width:'.$width.'px;height:30px;border:#000000 solid 0.7px;background:rgba(0,0,0,0.0);border-style:none;z-index:999;">';
	print '<div style="position:relative;top:'.$bgpos.'px;width:'.($width+2).'px;height:30px;background:rgba(0,0,0,0.5);"></div>';
	print '<div style="position:relative;top:'.$box_top.'px;width:'.($width+2).'px;height:'.$box_height.'px;">';
	print '<div id=imgrande onclick="DispImagePosReload();this.blur();" class="buttn relod" style="position:relative;top:'.$rang_label.'px;left:3px;width:36px;height:16px;font-size:12px;text-align:center;line-height:140%;color:#ffffff;groove 2px #696969;overflow:hidden;"></div>';
	print '<input type="range" id=boxslide min="0" max="2000" step="10" value="1000" onmouseup="changeSize(this.value)" onchange="changeSize(this.value)" style="position:relative;top:'.$rang_top.'px;left:44px;width:'.($width-200).'px;">';
	print '<input id=idrotate type=button onclick="changeRotate(90);this.blur();" value=0 class=rotat style="position:relative;top:'.$cls_top.'px;left:46px;">';
	print '<button id=idprev type=submit onclick="DispImagePosPrev();this.blur();" class="buttn fpos" style="position:relative;top:'.$cls_top.'px;left:'.($cls_pos+4).'px;">&lt;</button>';
	print '<button id=idnext type=submit onclick="DispImagePosNext();this.blur();" class="buttn fpos" style="position:relative;top:'.$cls_top.'px;left:'.($cls_pos+12).'px">&gt;</button>';
	print '<button type=submit onclick="RequestBoxtUnLoad(\'image\');RequestBoxtUnLoad(\'imgFrame\');" class=buttn style="position:relative;top:'.$cls_top.'px;left:'.($cls_pos+20).'px;width:44px;height:20px;">Close</button>';
	$bar=0;$bar_mrgn="";			// TitleBar表示を設定
	if ((($REQ_UA !=='PC')&&(stripos($XML_DISP["ImgTitleBar"],'Phone') !== false))		// PC以外でTitleBarあり
	 ||(($REQ_UA =='PC')&&(stripos($XML_DISP["ImgTitleBar"],'PC') !== false))){			// PCでTitleBarあり
		$bar=24;$bar_top=$top+14+12;$bar_left=$left+2;
		print '<div id="idimgbar" onMousedown="MoveDragOn(\'idimgbar\',\'imgFrame\',-120,-5,\'changeMoveObj()\');" style="position:fixed;top:'.$bar_top.'px;left:'.$bar_left.'px;width:'.$width.'px;height:'.$bar.'px;background-color:#f5f5f5;margin:3px 0px 0px 0px;">';
		print '<div id="idimgbartit" style="position:absolute;left:2px;font-size:11px;color:#000000;margin:6px 0px 0px 10px;cursor:default;"></div>';
		print '<div class="select" onclick="RequestBoxtUnLoad(\'image\');RequestBoxtUnLoad(\'imgFrame\');" style="position:absolute;right:10px;font-size:15px;color:#000000;margin:3px 0px 0px 10px;">X</div>';
		if ($REQ_UA !=='PC') {		// !=PC & Bar はChildにする
			print '</div>';
		 	}
		 }
	print '</div>';
	if ($REQ_UA =='PC') {			// Dragを使用するときは,SlidbarのChildにするので <divを継続
		 print '</div>';
		 }
	if ($REQ_UA !=='PC') {			// !=PCはDragはできない
		 if (stripos($XML_DISP["ImgTitleBar"],'Phone') !== false){	// Phoneで要TitleBar
			$bar_mrgn="margin:24 0 0 2;";
			}
		 print '<div id="imgFrame" style="position:relative;top:-18;overflow:scroll;width:'.($width+16).'px;height:100vh;'.$bar_mrgn.'">';
		 }
	else {
		 $frm_top=50+$bar;$frm_mrg=122+$bar;
		 if ($XML_DISP["ImgDragOn"] == "on") {						// Image部でDragOn移動を有効
			  print '<div id="imgFrame" onMousedown="MoveDragOn(\'imgFrame\',null,null,null,\'changeMoveBar()\');" style="position:fixed;top:'.$frm_top.'px;left:4px;background:rgba(0,0,0,0.0);margin:'.$frm_mrg.' 0 0 4;display:none;z-index:106;">';
			  }
		 else {
			  print '<div id="imgFrame" style="position:fixed;top:'.$frm_top.'px;left:4px;background:rgba(0,0,0,0.0);margin:'.$frm_mrg.' 0 0 4;display:none;z-index:106;">';
			  }
		 }
	print '<img id=boximg alt="" style="border:groove 2px #7fffd4;">';				// ボーダをなしにする場合 <img id=boximg alt="" border="0" >
	if ($REQ_UA !=='PC') {			// スクロールを使用する時
		print '<div id=imgscrl style="height:200px;"></div>';		// スクロール時に最後まで表示しないため底上げする
		print '</div>';
		}
	print '</div>';
	if (stripos($XML_DISP["ImgTitleBar"],'PC') !== false){	// PC,要TitleBar:</Div>(Close)
		print '</div>';
		}
	if (($REQ_UA !=='PC')&&(stripos($XML_DISP["ImgTitleBar"],'Phone') !== false)){	// !=PC & Bar はChildにしたため</Div>(Close)
		print '</div>';		// !=PC & Bar
		}
echo <<<EOM
<script type="text/javascript">
var SCREEN_WIDTH={$width};	// Header編集時,Phoneの幅を設定
var BOXIMG_FUNC={$AddJsp};	// AddFunc Boximg Function
</script>
EOM;
	}

/*
	DispView_Extend(): Display View Extend Box : 内部拡張Viewer
*/
function DispView_Extend() {
// Viewerの初期値 XML設定されない場合の値
	$top=60;$left=3;$width=478;$height=634;					// 設定値
	$bar=24;$top_def=-12;$frmwidth_def=6;$frmheight_def=8;	// 設定固定値 $bar:タイトルバーの高さ, $top_def:タイトルバー下の調整値 ,$frmwidth_de,$frmheight_def:iFreme内の調整値
	$waptop=$top+($bar+$top_def);$frmwidth=$width-$frmwidth_def;$frmheight=$height-$frmheight_def;	// 設定値と設定固定値で計算
	$minWidth=350;$minHeight=($width/$height)*$minWidth;	// 拡張用の項目
	$func="";				// XML設定に初期化関数指定があるとき
// XML設定からHTMLを展開
	$fldary = compact("width","height","minWidth","minHeight","frmwidth_def","frmheight_def","frmwidth","frmheight","func");
	$sel=array("Viewer"=>"1");	// XML:セレクト対象Tag , 1:指定文字列を含む前方一致
	$ret_frame=ArgXML2HTMLStr("ViewExtend",$sel,$fldary,"");
//if ($ret_frame == -1) { return; }
	if(is_array($fldary)) { extract($fldary,EXTR_OVERWRITE); }	// EXTR_OVERWRITE: 既に同名の変数が存在する場合上書き
	if (($func !== "")&&(function_exists($func))) { 								// <{Kind} Func="{Function}">				// 外部関数の呼び出し
		eval($func.'($fldary);');
		if (error_get_last()) {
			ArgErrorEdit("DispView_Extend","eval()");
			}
		}
echo <<<EOM
<script type="text/javascript">
exd_top={$top};exd_left={$left};exd_width={$width};				// タイトルバー[-]クリック時戻すサイズ(初期値)。XMLでの設定で変更できる
waptop={$waptop};wapheight={$height};frmwidth={$frmwidth};frmheight={$frmheight};
</script>
<!-- タイトルバー(通常) -->
<div id="idExtend" onMousedown="MoveDragOn('idExtend','idExtendWap',10);" class="box" style="position:fixed;top:{$top}px;left:{$left}px;width:{$width}px;height:{$bar}px;border:#000000 solid 0.7px;background:rgba(0,0,0,0.0);border-style:none;cursor:pointer;z-index:999;">
 <div id="idExtendMe" style="position:absolute;left:0px;top:{$top_def}px;width:{$width}px;height:{$bar}px;background-color:#f5f5f5;">
  <div id="idExtendTit" style="position:absolute;left:2px;font-size:11px;color:#000000;margin:6px 0px 0px 10px;"></div>
  <div id="idExtendTool" class="select" onclick="ExtendToolLoad('idExtendTool');" value="" file="" style="position:absolute;top:0px;right:70px;width:50px;white-space:nowrap;overflow:hidden;font-size:12px;color:#00008b;text-decoration:underline;margin:5px 0px 0px 10px;display:none;">Tool</div><!-- Tool Functionを使用時 display;block, value="{kind}" file="{Source}"をセット -->
  <div class="select" onclick="DispExtendWinRst();" style="position:absolute;right:55px;font-size:15px;color:#000000;margin:3px 0px 0px 10px;">-</div>
  <div class="select" onclick="DispExtendWinMax();RequestBoxtUnLoad('idExtend');RequestBoxDisp('idExtendMax');" style="position:absolute;right:30px;border: 1px solid #333333;width:11px;height:11px;margin:6px 0px 0px 0px;"></div>
  <div class="select" onclick="RequestBoxtUnLoad('idExtend');RequestBoxtUnLoad('idExtendWap');ExtendToolUnload(1);" style="position:absolute;right:10px;font-size:15px;color:#000000;margin:3px 0px 0px 10px;">X</div>
 </div>
</div>
<!-- フレーム -->
<div id="idExtendWap" class="box" style="position:fixed;top:{$waptop}px;left:{$left}px;width:{$width}px;height:{$height}px;background-color:#fffaf0;overflow:hidden;z-index:999;">
{$ret_frame}
</div>
<!-- タイトルバー(最大化) -->
<div id="idExtendMax" class="box" style="position:fixed;top:0px;left:3px;width:{$width}px;height:{$bar}px;border:#000000 solid 0.7px;background:rgba(0,0,0,0.0);border-style:none;cursor:pointer;z-index:999;">
 <div id="idExtendBar" style="position:fixd;top:0px;left:0px;width:{$width}px;height:{$bar}px;background-color:#f5f5f5;">
  <div id="idExtendTitMax" style="position:absolute;left:2px;font-size:11px;color:#000000;margin:6px 0px 0px 10px;"></div>
  <div style="position:absolute;right:30px;border: 1px solid #333333;width:11px;height:11px;margin:6px 4px 0px 0px;"></div>
  <div id="idExtendToolMax" class="select" onclick="ExtendToolLoad('idExtendToolMax');" value="" style="position:absolute;top:0px;right:76px;width:50px;white-space:nowrap;overflow:hidden;font-size:12px;color:#00008b;text-decoration:underline;margin:5px 0px 0px 10px;display:none;">Tool</div><!-- Tool Functionを使用時 display;block, value="{kind}"をセット -->
  <div class="select" onclick="RequestBoxtUnLoad('idExtendMax');DispExtendWinRst();RequestBoxDisp('idExtend');" style="position:absolute;right:60px;font-size:15px;color:#000000;margin:3px 0px 0px 10px;">-</div>
  <div class="select" onclick="DispExtendWin();RequestBoxDisp('idExtend');RequestBoxtUnLoad('idExtendMax');" style="position:absolute;right:30px;border: 1px solid #333333;width:11px;height:11px;margin:4px 2px 0px 0px;"></div>
  <div class="select" onclick="RequestBoxtUnLoad('idExtendMax');RequestBoxtUnLoad('idExtendWap');ExtendToolUnload(1);" style="position:absolute;right:10px;font-size:15px;color:#000000;margin:3px 0px 0px 10px;">X</div>
 </div>
</div>

EOM;
	DispView_ExtendFunc();
	}

/*
	DispView_ExtendFunc() : View Extend Function Box
	ViewExtendでCallする受け渡し項目
	  global $ViewExtFunc : i  : Kind毎 Function key:Kind
	をセットする
  ※使用例)
	<ViewExtend><Viewer_{any}><?php global $ViewExtFunc; 
	  $ViewExtFunc
	  $ViewExtFunc[{kind}]["id"]               : Function Box id 省略時:idExt_{kind}
	  $ViewExtFunc[{kind}]["title"]            : Function Box Title
	  $ViewExtFunc[{kind}]["width"]            : Function Box Width
	  $ViewExtFunc[{kind}]["func"][{n]["val"]  : Name Value
	  $ViewExtFunc[{kind}]["func"][{n]["js"]   : js Function
	  {kind}:Text,HTML...
*/
function DispView_ExtendFunc() {
	global $ViewExtFunc;

	if(!isset($ViewExtFunc)) { $ViewExtFunc=array(); }
	if ((is_array($ViewExtFunc))&&(count($ViewExtFunc) > 0)) {
		foreach($ViewExtFunc as $kind => $func) {
			$id="idExt_".$kind;$title="Function";$width="80";
			if (isset($ViewExtFunc[$kind]["id"])) { $id=$ViewExtFunc[$kind]["id"]; }
			if (isset($ViewExtFunc[$kind]["title"])) { $title=$ViewExtFunc[$kind]["title"]; }
			if (isset($ViewExtFunc[$kind]["width"])) { $width=$ViewExtFunc[$kind]["width"]; }
			$unload = 'ExtendToolUnload();';
			if (is_array($func["func"])) {
			$top=30;$oneline=26;
			$height=count($func["func"])*$oneline+$top+50;
			$line=$top;
			print '<div id='.$id.' class=box style="position:fixed;top:50px;left:140px;width:'.($width+22).'px;height:'.$height.'px;background-color:#ffffff;color:#000000;z-index:2000;">';
			print '<div class=boxtitle style="width:'.($width+2).'px;background-color:#4169e1;color:#ffffff;">'.$title.'</div>';
				foreach($func["func"] as $key => $chdval) {
					$js="";$val="";
					if (isset($chdval["val"])) { $val=$chdval["val"]; };if (isset($chdval["js"])) { $js=rtrim($chdval["js"],";").";".$unload; };	// 機能後無条件でUnload
					if ($val=="") { continue; }
					print '<div class="boxtext" onclick="'.$js.'" style="height:16;top:'.$line.'px;width:'.$width.'px;background-color:#e0ffff;color:#000000;border: 1px solid #acacac;font-weight:normal;cursor:pointer;">'.$val.'</div>';
					$line=$line+$oneline;
					}
				}
			print '<input type="button" name="Submit" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" style="background-color:#c0c0c0;border:1px outset #d3d3d3;color:#000000;" />';
			print '</div>';
			}
		}
	$str="";$sp="";
	foreach($ViewExtFunc as $kind => $ary) {
		if (isset($ViewExtFunc[$kind]["id"])) {
			 $kindid =$ViewExtFunc[$kind]["id"];
			 }
		else {
			 $kindid ="idExt_".$kind;
			 }
		$str= $str.$sp."'".$kind."': '".$kindid."'";
		$sp=", ";
		}
	$str ="HashViewExtid={ ".$str." }";

echo <<<EOM
<script type="text/javascript">
{$str}
/*
	ExtendToolBox(kind,name) : Display ToolBox Button
	 kind  : i  : 拡張子種別 Text,HTML...
	 name  : i  : Button Name
	HTML:id:'idExtendTool'   :value:kind / file:source[DispExtendWinCreate()]
	        'idExtendToolMax':value:kind 
	        にセットする
*/
function ExtendToolBox(kind,name) {
	if (!HashViewExtid[kind]) { return; }
	RequestBoxDisp('idExtendTool');
	RequestBoxDisp('idExtendToolMax');
	if (name != null) {
		document.getElementById("idExtendTool").innerText=name;
		document.getElementById("idExtendToolMax").innerText=name;
		document.getElementById("idExtendTool").value=kind;
		document.getElementById("idExtendToolMax").value=kind;
		}
	}

/*
	ExtendToolLoad(eventid) : Display ToolBox
	 eventid: i  : Event Button id
*/
function ExtendToolLoad(eventid) {
	var kind=document.getElementById(eventid).value;
	if (!HashViewExtid[kind]) { return; }
	var left_def=-30;var top_def=0;var poswidth=0;var frmid="";
	if (eventid== 'idExtendTool') {
		 frmid= "idExtend";
		 poswidth=parseInt(document.getElementById(frmid).style.width);
		 }
	else {
		 frmid= "idExtendMax";
		 poswidth=parseInt(document.body.scrollWidth);
		 top_def=12;
		 }
	document.getElementById(HashViewExtid[kind]).style.top=parseInt(document.getElementById(frmid).style.top)+top_def;
	document.getElementById(HashViewExtid[kind]).style.left=poswidth+parseInt(document.getElementById(frmid).style.left)-parseInt(document.getElementById(HashViewExtid[kind]).style.width)+left_def;
	RequestBoxDisp(HashViewExtid[kind]);
	}

/*
	ExtendToolUnload(mode) : Unload ToolBox
	 mode  : i  : 1:all unload / not : Box unload
*/
function ExtendToolUnload(mode) {
	var kind=document.getElementById('idExtendTool').value;
	if (!HashViewExtid[kind]) { return; }
	RequestBoxtUnLoad(HashViewExtid[kind]);
	if ((mode != null)&&(mode==1)) {
		document.getElementById('idExtendTool').value="";
		document.getElementById('idExtendToolMax').value="";
		}
	}
</script>
EOM;

	}

/*
	DispView_External(): Display View External Box : 外部Viewer モジュール
	 $funcary: i  : Viewer機能 初期化関数 Array key:Function
*/
function DispView_External($funcary) {
	foreach ($funcary as $func => $val) {
		if (function_exists($func)) {
			$func();
			}
		}
	}

/* -----------------------------------------------------------------------------
	DispDirAlbumSelect($remote_path) : XML Setting Select
	 $remote_path: io : Request Path(変換後)
	 $home       : io : Request Path (default時再設定)(URL Parameter)
	 $trns       : i  : Request Path (変異分) home+trnsで実際のRequest (URL Parameter)
	 @return     : o  : Output Select Setting $XML_IMGSETHOST(XML定義)対象Point + $xml_path["request"]を追加：Request側のPath(home+trans)
----------------------------------------------------------------------------- */
function DispDirAlbumSelect(&$remote_path,&$home,$trns) {
	global $XML_IMGSETHOST,$XML_NET;										// $XML_IMGSETHOST:XML(Art_Path)編集済

	$default="";$find="";
	$xml_path=array("local"=>"","host"=>"","rel"=>"","wan"=>"");
	foreach($XML_IMGSETHOST as $key=> $val) {								// XML定義 <Art_Path>から判定順配列 
		$XML_IMGSETHOST_SORT[$key]=strlen($XML_IMGSETHOST[$key]["rel"]);	// Lengthを取得し,短い設定を下にする
		if (isset($XML_IMGSETHOST[$key]["default"])) { $default=$key; }		// defaultを探しておく
		}
	if (($default!=="")&&(($home=="")&&($trns==""))) { } else {
		arsort($XML_IMGSETHOST_SORT);
		foreach($XML_IMGSETHOST_SORT as $key=> $val) {						// XML定義 <Art_Path>
			if (0 === strpos($remote_path,$XML_IMGSETHOST[$key]["rel"])) {	// XML:rel設定と一致のRequestから設定ポイントを取得
				$find=$key;
				break;
				}
			}
		}
	if ($find !== "") {							// 対象設定が見つかった
		 $xml_path=$XML_IMGSETHOST[$find];
		 }
	else if ($default !=="") {					// 対象設定がないときデフォルトがあれば置き換え
		 $xml_path=$XML_IMGSETHOST[$default];
		 $home=$xml_path["default"];
		 $remote_path=$xml_path["rel"];
		 }
	if (!Commn_isIPv6($_SERVER['SERVER_ADDR'])) {	// IPv6時は置き換えなし
		if (!Commn_Subnet($XML_NET["netmask"],$_SERVER['REMOTE_ADDR'])) {		// Networkが異なるとき [Wan]が設定されている
			if ($xml_path["wan"] !=="") {
				$xml_path["host"]=$xml_path["wan"];	// hostにwanを採用する
				}
			}
		}
	if (($home == "")&&($trns == "")) {
		 $reqpath=""; }
	else if (($home !== "")&&($trns !== "")) {
			$reqpath=rtrim($home, '/')."/".ltrim(rtrim($trns,'/'), '/'); }
	else if ($home !== "") {
			 $reqpath=rtrim($home, '/'); }
	else {
		 $reqpath=rtrim($trns,'/'); }
	$xml_path["request"]=$reqpath;

	return($xml_path);
	}

/* -----------------------------------------------------------------------------
	DispDirAlbumDirectory($home,$trns,$local_path,$file_ary,$xml_path) : File System Directory
	 $home      : io : Request Path (default時再設定)
	 $trns      : i  : Request Path (変異分) home+trnsで実際のRequest
	 $local_path: i  : Request Local Path
	 $file_ary  : io : Path list : Sort後をOutput(置換設定が反映されている)
	 $xml_path  : i  : Path 設定情報
	 $idtop		: io : Directory 表示の先頭 HTML id
	 $idlast	: io : Directory 表示の最終 HTML id
	 @return    : o  : Directory Array 形式:ary[{Directory}]:{Directory}
	※置換設定があった場合,階層以下に置換後の名称と同様のFileがあったとしても対象としない。
----------------------------------------------------------------------------- */
function DispDirAlbumDirectory($home,$trns,$local_path,&$file_ary,$xml_path,&$idtop,&$idlast,$value,&$idpostion) {
	global $XML_IMGSETHOST,$XML_IMGSETLOCAL,$XML_EXCLUSIVE,$XML_EXCEPTION,$XML_IMGSET,$XML_DISP,$SOURCE,$REQ_MODULE;		// $XML_CONF:XML

	$XML_ADDPARM=GetEnvAddFunc("Dir_".$REQ_MODULE);						// 外部I/F Add Moduleごと
	if ($XML_ADDPARM["SetNo"] == 0) {
		$XML_ADDPARM=GetEnvAddFunc("Dir");								// 外部I/F Add
		}
	global $XML_ADDPARM_ARY;			// Option Function
	$XML_ADDPARM_ARY=GetEnvAddFuncGrp("DirFunc_".$REQ_MODULE,"DirFunc");
// Directory Replase,Name
	$prev="";$prev_path="";$prev_disp="";								// Return Directory
	$str=rtrim($trns, '/');
	$pr = explode('/',$str);
	if ((count($pr)-1) >=0) {
		$prev=$pr[(count($pr)-1)];										// Return Directory
		if (isset($pr[(count($pr)-2)])) { $ary=array_slice($pr,0,-1);$prev_disp=implode("/",$ary); }
		for($i=0;$i < (count($pr)-1);$i++) {							// Return Path
			if ($pr[$i]=="") { continue; }
			if (($prev_path=="")&&(($trns!=="")&&(substr($trns,0,1) !== "/"))) {
				 $prev_path=$pr[$i];
				 }
			else {
				 $prev_path=$prev_path."/".$pr[$i];
				 }
			}
		}
	$p = explode('/',$local_path);

	if ((is_array($file_ary))&&($XML_IMGSETLOCAL['\count'] >= count($p))) {						// 置換設定の階層以下のディレクトリは置換後Sortする
		$file_org=array();$file_str=array();
		foreach ($file_ary as $key => $file) {
			$mrg_path=$local_path.$file;
			if (in_array($mrg_path,$XML_EXCLUSIVE)===true) { continue; }
			if (is_dir($mrg_path) !== true) { continue; }
			$val=$file;
			if (isset($XML_IMGSETLOCAL[$mrg_path."/"])) {				// FileName置換
				$val=$XML_IMGSETLOCAL[$mrg_path."/"];
				$file_org[$val]=$file;
				}
			$file_str[$key]=$val;										// 元のFileNameを逆引き用に作成
			}
		if ($XML_DISP["Sort_Capital"] !== "on") {						// 大小文字を区別しない場合,Sortするので,ここでSortしない
			sort($file_str);
			}
		$file_ary=$file_str;
		}
	if ($XML_DISP["Sort_Capital"] == "on") {							// 大小文字を区別しない場合Sort
		 $file_sort["Org"]=$file_ary;
		 $file_sort["Sort"]=array();
		 foreach ($file_sort["Org"] as $key => $val) {
			$file_sort["Sort"][$key]=strtoupper($val);					// 大文字変換
			}
		 $file_res=Sort_Table($file_sort,"Sort");
		 $file_ary=$file_res["Org"];
		 }
	print '<div class=head style="clear:both;top:44;height:18px;z-index:3;margin:4px 0px 0px 2px;">';	// DispFile Function Box
	$arg=array();
	if ($prev !=="") { 
		 $str=rtrim($local_path, '/');
		 $pr = explode('/',$str);
		 $arg["val"]=urlencode($pr[count($pr)-1]);
		 if ($prev_disp !== "") {
			  $val="[Previous]&nbsp;".$prev_disp;
			  }
		 else {
			  $val="[Previous]&nbsp;Home";
			  }
		 $arg["home"]=urlencode($home);
		 $arg["trns"]=urlencode($prev_path);
		 $url=URLQueryReplase($arg);
		 $url='location.href=\''.$url.'\';RequestLoadDisp(0);';
		 }
	else {
		 $val="[Home Top Directory]";
		 $url='';
		 }
	print '<button type=submit name=perdir onclick="'.$url.'" class="music DTPREV">'.$val.'</button>';
	print '</div>';
	print '<div style="clear:both;width:150px;height:30px;"></div>';

	if (!is_array($file_ary)) {	// Directoryが存在しない時終了
		return($file_ary);
		}
// Display Directory
	print '<table border="0" id=grpfile cellpadding="0" bgcolor="#000000" frame=void style="Display:block;">';
	$idscrl=0;$arg=array();$file_ret=array();
	foreach ($file_ary as $file) {
		$mrg_path=$local_path.$file;
		if (in_array($mrg_path,$XML_EXCLUSIVE)===true) { continue; }
		$true_file=$file;
		if ($XML_IMGSETLOCAL['\count'] < count($p)) {					// FileNameを置換したときはチェックすみ
			 if (is_dir($mrg_path) !== true) { continue; }
			 }
		else if (isset($file_org[$file])) {
			 $true_file=$file_org[$file];								// 名前を逆引きし元のFileNameを取得
			 }
		if (in_array(rtrim($local_path, '/'),$XML_EXCLUSIVE)===true) {
			if (in_array($local_path.$true_file,$XML_EXCEPTION)===true) { }
			else { continue; }
			}
		if ($file==".") { continue; }
		if ($file=="..") { continue; }
		$file_ret[$file]=$file;												// return用にDirectory配列を作成
		$val=$file;
		$arg["home"]=urlencode($home);
		if ($trns == "") { $arg["trns"]=ArgEncode($val); } else {
			 $arg["trns"]=ArgEncode($trns.'/'.$val);
			 }
		$urlstr=URLQueryReplase($arg);
		$url='location.href=\''.$urlstr.'\';RequestLoadDisp(0);';
		if ($XML_ADDPARM["SetNo"] !== 0) {
			$SOURCE["File"]=$file;
			$SOURCE["RemotePath"]=$urlstr;
			$SOURCE["LocalPath"]=$local_path.$file;
			if ($xml_path["request"] == "") { $SOURCE["RequestPath"]=$file; }
			else { $SOURCE["RequestPath"]=rtrim($xml_path["request"],'/')."/".$file; }
			}
		$idscrl=$idscrl+1;
		$id="iddir".$idscrl;
		$idBdir="idBdir".$idscrl;
		if (is_null($idtop)) { $idtop=$id; }								// 指定位置Position 先頭,最後のid設定
		$idlast=$id;
		if (rtrim($value) == rtrim($val)) {									// ポジション位置判定
			$idpostion=$id;
			}
		print '<tr>';
		$ret=GetEnvAddFuncSet($SOURCE,$XML_ADDPARM);						// 外部I/F Add
		if ($XML_ADDPARM["line"] !== "")  { $name=$XML_ADDPARM["name"]; }
		if ($XML_ADDPARM["click"] !== "") { $jsp =$XML_ADDPARM["click"];
			 $width=444;
			 if ($XML_ADDPARM_ARY["SetNo"] !== 0) { $width=421.5; }
			 print '<td id="'.$id.'"><button type=submit name=perdir id="'.$idBdir.'" onclick="'.$url.'" value="'.$true_file.'" class="music DTBOTN" style="width:'.$width.'px;">'.$val.'</button></td>';
			 print '<td><button type=submit '.$jsp.' class="music DTBOTN DIRBAD">'.$name.'</button></td>';
			 }
		else {
			 $style="";
			 if ($XML_ADDPARM_ARY["SetNo"] !== 0) { $style=' style="width:455px;"'; }
			 print '<td id="'.$id.'"><button type=submit name=perdir id="'.$idBdir.'" onclick="'.$url.'" value="'.$true_file.'" class="music DTBOTN"'.$style.'>'.$val.'</button></td>';
			 }
		if ($XML_ADDPARM_ARY["SetNo"] !== 0) {
			 $idfunc="F".$id;
			 print '<td><button type=submit onclick="RequestBoxDisp(\''.$idfunc.'\');" class="music bfunc DTBOTN">...</button>';
			 DispDirAlbumDirectoryFunc($home,$trns,$local_path,$file,$xml_path,$idfunc,200,170);
			 }
		print '</tr>';
		}
	print '</table>';
	return($file_ret);
	}

/* -----------------------------------------------------------------------------
	DispDirAlbumFunc($home,$trns,$local_path,$file,$xml_path,$extension,$width,$higth,$id,$top,$left,$EditAspect,$filesize,$encname) : DispAlbum FunctionDisplay
	 $home      : i  : Request Path (URL Parameter)
	 $trns      : i  : Request Path (変異分) home+trnsで実際のRequest (URL Parameter)
	 $local_path: i  : Request Local Path
	 $file      : i  : Directory / File Query
	 $xml_path  : i  : Path 設定情報
	 $extension
	 $width     : i  : 画像Width
	 $higth     : i  : 画像Higth
	 $id        : i  : buttonのid名   File/DirectoryHeaderからCall時,$id:"func_file"
	 $top       : i  : 表示位置 top
	 $left      : i  : 表示位置 left
	 $EditAspect: i  : Infomation (Used Image Pixel)
	 $filesize  : io : FileSize 物理ファイルからの情報なのでレスポンスより必要になったときにGetし,継承する。
	 $encname   : i  : Image EncodeLibraryを使用時,Nameが設定されていた場合設定
----------------------------------------------------------------------------- */
function DispDirAlbumFunc($home,$trns,$local_path,$file,$xml_path,$extension,$width,$higth,$id,$top=200,$left=170,$EditAspect="",&$filesize,$encname) {
	global $SOURCE,$XML_ADDPARM_ARY,$XML_DISP;			// Option Function
	$Line=28;

	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	$SOURCE["Unload"]=$unload;

	$tmpary=$XML_ADDPARM_ARY;								// 共有領域だが,拡張子ごとに使用配列が変化するためコピー
	$count=GetEnvAddFuncSetGrp($SOURCE,$tmpary,$extension);
	print '<div id='.$id.' class=box style="height:'.(204+$count*$Line).'px;position:fixed;top:'.$top.'px;left:'.$left.';">';
	print '<div class=boxtitle>'.$file.'</div>';
	$str=rtrim($xml_path["request"],"/")."/".$file;
	print '<div class="ellipsis boxtext" style="height:58;top:32px;width:278px;line-height:12px;word-break:break-all;background-color:#000000;border: 1px solid #acacac;">'.$str.'&nbsp;</div>';
	$size=0;$time=0;
	if ($XML_DISP["ImgPost"] !== "on") {		// Post On時 FileSize/Modifi/AspectはPost処理で行う
		if (is_null($filesize)) { $filesize=filesize($local_path.$file); }		// filesizeがなければGet
		$size=$filesize;
		$time=filemtime($local_path.$file);
		}
	if ($size < 1000) {
		$fstr=$size.'&nbsp;byte';
		}
	elseif($size < 1000000) {
		$fstr=(floor($size/10)/100).'&nbsp;Kbyte';
		}
	else{ 
		$fstr=(floor($size/10000)/100).'&nbsp;Mbyte';
		}
	print '<div id=S'.$id.' class="boxtext boxattri" style="height:16;top:100px;">Size&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;:&nbsp;'.$fstr.'</div>';
	print '<div id=M'.$id.' class="boxtext boxattri" style="height:16;top:124px;">Modifi&nbsp;&nbsp;:&nbsp;'.(date('Y/m/d H:i:s',$time)).'</div>';
	if ($EditAspect !== "") {
		print '<div id=P'.$id.' class="boxtext  boxattri" style="height:16;top:148px;">'.$EditAspect.'</div>';
		}
	$i=0;
	if ($XML_ADDPARM_ARY["SetNo"] > 0) {
		foreach ($tmpary["PARM"] as $key=> $XML_ADDPARM) {					// Fucntion Add 複数行対応
			$name="";$jsp="";
			if (!isset($XML_ADDPARM["click"])) { continue; }
			if ((isset($XML_ADDPARM["return"]))&&($XML_ADDPARM["return"]===false)) { continue; }
			if ($XML_ADDPARM["name"]  !== "") { $name=$XML_ADDPARM["name"]; }
			if ($XML_ADDPARM["click"] !== "") { $jsp =$XML_ADDPARM["click"]; }
			if ($jsp !== "") {
				print '<div type=submit class="boxtext boxefunc" '.$jsp.' style="height:16;top:'.(148+($i+=$Line)).'px;">'.$name.'</div>';
				}
			}
		}
	if ((isset($encname))&&($encname !=="")) {								// Image LibrayNameが設定時
		print '<div class="boxtext boxencnm">ImageEncode['.$encname.']</div>';
		}
	print '<input type="button" name="Submit" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" />';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DispDirAlbumDirectoryFunc($home,$trns,$local_path,$file,$xml_path,$width,$higth,$id,$top,$left) : DispDirectory FunctionDisplay
	 $home      : i  : Request Path (URL Parameter)
	 $trns      : i  : Request Path (変異分) home+trnsで実際のRequest (URL Parameter)
	 $local_path: i  : Request Local Path
	 $file      : i  : Directory / File Query
	 $xml_path  : i  : Path 設定情報
	 $width     : i  : 画像Width
	 $higth     : i  : 画像Higth
	 $id        : i  : buttonのid名   File/DirectoryHeaderからCall時,$id:"func_file"
	 $top       : i  : 表示位置 top
	 $left      : i  : 表示位置 left
----------------------------------------------------------------------------- */
function DispDirAlbumDirectoryFunc($home,$trns,$local_path,$file,$xml_path,$id,$top=200,$left=170) {
	global $SOURCE,$XML_ADDPARM_ARY;			// Option Function
	$Line=28;$def=0;

	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	$SOURCE["Unload"]=$unload;
	if ($XML_ADDPARM_ARY["SetNo"] > 5) {
		$def=$Line*(($XML_ADDPARM_ARY["SetNo"]) - 5);
		}
	print '<div id='.$id.' class=box style="height:'.(210+$def).'px;position:fixed;top:'.$top.'px;left:'.$left.';">';
	print '<div class=boxtitle>'.$file.'</div>';
	GetEnvAddFuncSetGrp($SOURCE,$XML_ADDPARM_ARY);
	$i=0;
	if ($XML_ADDPARM_ARY["SetNo"] > 0) {
		foreach ($XML_ADDPARM_ARY["PARM"] as $key=> $XML_ADDPARM) {					// Fucntion Add 複数行対応
			$name="";$jsp="";
			if ($XML_ADDPARM["line"]  !== "") { $name=$XML_ADDPARM["name"]; }
			if ($XML_ADDPARM["click"] !== "") { $jsp =$XML_ADDPARM["click"]; }
			if ($jsp !== "") {
				print '<div type=submit class="boxtext boxefunc" '.$jsp.' style="height:16;top:'.(5+($i+=$Line)).'px;">'.$name.'</div>';
				}
			}
		}
	print '<input type="button" name="Submit" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" />';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DispDirAlbumHeader($home,$xml_path) : File System Directory
	 $home    : io : Request Path (URL Parameter)
	 $trns    : i  : Request Path (変異分) home+trnsで実際のRequest (URL Parameter)
	 $xml_path: i  : Path 設定情報
	 $burl    : i  : Back URL
	 $tbno    : i  : DispFileAlbum TableNo Art数(XMLConfif)
	 $pos     : i  : Positioning "on"/"off"
---------------------------------------------------------------------------- */
function DispDirAlbumHeader($home,$trns,$xml_path,$burl,$tbno,$pos) {
	global $XML_FUNCTION,$SOURCE,$REQ_MODULE,$XML_DISP,$XML_DISPATTR;				// Option Function

	$TBLCHG=GetReserveStruct("php");
// Header Line
	$def=$XML_DISP["ButtunGap"];													// Button間Gap
	print '<div class=head style="position:fixed;left:1px;width:480px;height:24px;z-index:4;">';
	if (is_array(($XML_FUNC=get_xml_attri_array($XML_FUNCTION)))) {					// XMLを属性を含め展開
		 $left=4;$bwidth=60;$i=0;
		 foreach ($XML_FUNC["Tag"] as $key=> $tag) {
			$i=$i+1;
			if ((isset($XML_FUNC["Att"][$key]["gap"]))&&($XML_FUNC["Att"][$key]["gap"]!=="")) { $gap=$XML_FUNC["Att"][$key]["gap"]; } else { $gap = $def;}		// 属性 gap Button間のギャップ
			if ($tag !== 'Value') {
				 $width=$bwidth;$val="";$att_width="";
				 if (isset($XML_FUNC["Val"][$key])) { $val=$XML_FUNC["Val"][$key]; }		// XML Keyの属性 widthを使用
				 if ((isset($XML_FUNC["Att"][$key]["width"]))&&($XML_FUNC["Att"][$key]["width"]!=="")) { $att_width="width:".$XML_FUNC["Att"][$key]["width"].'px;'; }		// XML Keyの属性 widthが優先される
				 $ret=str_intoreplace('style="position:fixed;top:0px;left:'.$left.'px;width:'.$width.'px;background-color:#642EFE;color:#CED8F6;"','style="','"',$XML_FUNC["Val"][$key],0,$style,$valstr,':',';',$att_width);
				 $cntval="width";
				 $width=str_value_parametar($style,$cntval,":",";",1);
				 $val=$tag;
				 if ((isset($XML_FUNC["Att"][$key]["value"]))&&($XML_FUNC["Att"][$key]["value"]!=="")) { $val=$XML_FUNC["Att"][$key]["value"]; }		// 属性 valueを指定時 名称はtagよりvalueが優先される
				 $valstr=GetReserveChange((trim($valstr)),$TBLCHG);
				 print '<button type=submit name=Current class=buttn onclick="'.$valstr.'" '.$style.'>'.$val.'</button>';
				 $tmp=$width+$gap;
				 if ((isset($XML_FUNC["Att"][$key]["id"]))&&($XML_FUNC["Att"][$key]["id"]!=="")) {		// 属性 idを指定時 id={FunctionBox} & HTML:id FunctionBox:Used Additional_Func Box Name:tagが使用される
					 DispFunc($XML_FUNC["Att"][$key]["id"],$tag,22,178);
					 }
				 }
			else {
				 $txwidth=$bwidth;$style="";$val="";$att_width="";
				 if (count($XML_FUNC["Tag"]) == $i) {
					$txwidth=447-$left;
					}
				 if (isset($XML_FUNC["Val"][$key])) { $val=$XML_FUNC["Val"][$key]; }		// XML Keyの属性 widthを使用
				 $att_width="";$valstr="";$style="";
				 if ((isset($XML_FUNC["Att"][$key]["width"]))&&($XML_FUNC["Att"][$key]["width"]!=="")) { $att_width="width:".$XML_FUNC["Att"][$key]["width"].'px;'; }		// XML Keyの属性 widthが優先される
				 $ret=str_intoreplace('style="position:fixed;left:'.$left.'px;line-height:160%;height:20px;width:'.$txwidth.'px;"','style="','"',$XML_FUNC["Val"][$key],0,$style,$valstr,':',';',$att_width);
				 $cntval="width";
				 $txwidth=str_value_parametar($style,$cntval,":",";",1);
				 print '<div class=HDTEXT '.$style.'>'.$valstr.'</div>';
				 $tmp=$txwidth+$gap+7;
				 }
			$left=$left+$tmp;
			}
		 }
	else {
		 print '<div class=HDTEXT style="position:fixed;top:0px;left:0px;width:447px;height:19px;font-size:12px;border: 2px ridge #888888;background:rgb(192,192,192);color:#4d4d4d;border-radius:4px;line-height:170%;font-weight:bold;">&emsp;&emsp;Directory Art List</div>';
		 }
	$id='idHeaderFunc';
	print '<button type=submit name=function onclick="document.getElementById(\'MYJSVER\').innerText=MYJS_VERSION;document.getElementById(\'MYAJAXVER\').innerText=MYJSVER_AJAX;RequestBoxDisp(\''.$id.'\');" class="comnd HDFUNC" style="top:0px;left:459px;">...</button>';
	DispHeaderFunc($id,22,178);
	print '</div>';
	print '<div style="clear:both;"></div>';
// Header LS Art Line
	print '<div class=head style="position:fixed;left:1px;top:24;height:24px;width:490px;z-index:3;">';
	$path_left=$def;$button_left=$def;
// Function Add Parameter
	if ($xml_path["request"] == "") { $SOURCE["RequestPath"]=""; }		// Function Add RequestPath Set
	else { $SOURCE["RequestPath"]=rtrim($xml_path["request"],'/'); }

	$XML_ADDPARM=GetEnvAddFunc("Header_".$REQ_MODULE);			// 外部I/F Add Moduleごと
	if ($XML_ADDPARM["SetNo"] == 0) {
		$XML_ADDPARM=GetEnvAddFunc("Header");					// 外部I/F Add
		}
	$jsp="";$name="";
	$ret=GetEnvAddFuncSet($SOURCE,$XML_ADDPARM);				// 外部I/F Add
	if ($XML_ADDPARM["line"] !== "")  { $name=$XML_ADDPARM["name"]; }
	if ($XML_ADDPARM["click"] !== "") { $jsp=$XML_ADDPARM["click"]; }
// Renew Function
	if ($XML_DISP["ArtList"] !== "off") {
		$att_width="";
		$width=$XML_DISPATTR["ArtList"]["width"];										// XML Keyの属性 widthを使用
		$value="ArtList";if (isset($XML_DISPATTR["ArtList"]["name"])) { $value=$XML_DISPATTR["ArtList"]["name"];}
		$New_uri=ArgURLCounterRep($_SERVER['REQUEST_URI']);
		$selfurl='location.href=\''.$New_uri.'\';RequestLoadDisp(0);';					// 設定がなければReNew機能
		$style='style="position:fixed;left: 4px;width:'.$width.'px;background-color:#008000;color:#dbebc4;"';
		if (($XML_DISP["ArtList"] !== "")&&($XML_DISP["ArtList"] !== "on")) {
			if (isset($XML_DISPATTR["xml"]["ArtList"]["width"])) {						// 初期値でなくXML設定の判断
				if ($XML_DISPATTR["ArtList"]["width"] !=="") { $att_width="width:".$XML_DISPATTR["ArtList"]["width"].'px;'; }		// XML Keyの属性 widthが優先される
				}
			$tmpstyle="";$valstr="";$str="left";
			$ret=str_value_parametar($XML_DISP["ArtList"],$str,":",";",1);		// styleにleftが指定時位置計算に使用する
			if ($ret > 0) { $button_left=$ret;$path_left=$ret; }
			$ret=str_intoreplace($style,'style="','"',$XML_DISP["ArtList"],0,$tmpstyle,$valstr,':',';',$att_width);
			$cntval="width";
			$width=str_value_parametar($style,$cntval,":",";",1);
			$style=$tmpstyle;
			if (trim($valstr) !=="") { $selfurl=trim($valstr); }
			$selfurl=GetReserveChange($selfurl,$TBLCHG);
			}
		print '<button type=submit name=Current value=Current class=buttn onclick="'.$selfurl.'" '.$style.'>'.$value.'</button>';
		$button_left=+$button_left+$width+$def;											// Back Buttonの調整
		$path_left=$path_left+$width+$def;												// Pathの位置調整
		}
// Back Function
	if ($XML_DISP["Back"] !== "off") {
		$width=$XML_DISPATTR["Back"]["width"];											// XML Keyの属性 widthを使用
		$value="Back";if (isset($XML_DISPATTR["Back"]["name"])) { $value=$XML_DISPATTR["Back"]["name"];}
		$back="";$tmpstyle="";$valstr="";$att_width="";
		$style='style="position:fixed;left:'.$button_left.'px;width:'.$width.'px;background-color:#642EFE;color:#CED8F6;"';
		if (($XML_DISP["Back"] !== "")&&($XML_DISP["Back"] !== "on")) {
			if (isset($XML_DISPATTR["xml"]["Back"]["width"])) {							// 初期値でなくXML設定の判断
				if ($XML_DISPATTR["Back"]["width"] !=="") { $att_width="width:".$XML_DISPATTR["Back"]["width"].'px;'; }		// XML Keyの属性 widthが優先される
				}
			$str="left";
			$ret=str_value_parametar($XML_DISP["Back"],$str,":",";",1);			//  styleにleftが指定時位置計算に使用する
			if ($ret > 0) { $path_left=$ret; }
			$ret=str_intoreplace($style,'style="','"',$XML_DISP["Back"],0,$tmpstyle,$valstr,':',';',$att_width);
			$cntval="width";
			$width=str_value_parametar($style,$cntval,":",";",1);
			$style=$tmpstyle;
			if ((strpos($valstr,'history.back()') === false) ||							// history.back()がない
				((strpos($valstr,'history.back()') !== false)&&(!empty($_SERVER["HTTP_REFERER"])))) {	//history.back()&戻り先がある
				if (trim($valstr) !=="") { $back=trim($valstr);$back=GetReserveChange($back,$TBLCHG); }
				}
			}
		if ((trim($valstr) =="")&&($burl !== "")) {										// XML onClick設定がなく、URL:&burlがある
			$back='location.href=\''.$burl.'\';RequestLoadDisp(0);';					// 設定がなければ戻る機能
			}
		if (($back !=="") ||															// 戻りがある
			 ((isset($XML_DISPATTR["Back"]["disp"]))&&($XML_DISPATTR["Back"]["disp"]=="on"))) { // 常時ON <back disp="on">指定
			print '<button type=submit name='.$value.' value=Current class=buttn onclick="'.$back.'" '.$style.'>'.$value.'</button>';
			$path_left=$path_left+$width;												// Pathの位置調整
			}
		}
// Path Callum
	$Disp_Home="";
	if (($home == "")&&($trns == "")) {					// File構造($home:"")による指定のTop
		 $str=" [Top Directory] /";
		 $Disp_Home=$str;
		 }
	else if (($home !== "")&&($trns !== "")) {			// Home以前に戻らない指定:Directory($trns)下を表示
			$str=rtrim($home, '/')."/"."&nbsp".ltrim(rtrim($trns,'/'), '/');
			$ary = explode('/',rtrim($trns,"/"));
			$Disp_Home=$ary[count($ary)-1];
			}
	else if ($home !== "") {							// Home以前に戻らない指定:Top(Home)を表示
			 $str=rtrim($home, '/');
			 }
	else {												// 指定Path($trnsを表示
		 $str=rtrim($trns,'/');
		 $ary = explode('/',rtrim($trns,"/"));
		 $Disp_Home=$ary[count($ary)-1];
		 }
	if($Disp_Home=="") { $Disp_Home="Home"; }			// Home以前に戻らない指定:Topは"Home"表示
	$tmpstyle="";$valstr="";$att_width="";$p_width=30;									// Path編集
	if (isset($XML_DISPATTR["xml"]["Path_Value"]["width"])) {							// 初期値でなくXML設定の判断
		if ($XML_DISPATTR["Path_Value"]["width"] !=="") { $att_width="width:".$XML_DISPATTR["Path_Value"]["width"].'px;'; }		// XML Keyの属性 widthが優先される
		}
	$ret=str_intoreplace('style="position:fixed;left:'.$path_left.'px;width:'.$p_width.'px;"','style="','"',$XML_DISP["Path_Value"],0,$tmpstyle,$valstr,':',';',$att_width);
	$value="Path";if ($valstr!=="") { $value= $valstr; }								// タイトル設定orデフォルト
	if (isset($XML_DISPATTR["Path_Value"]["name"])) { $value=$XML_DISPATTR["Path_Value"]["name"]; }
	print '<div class=HDCNST '.$tmpstyle.'>'.$value.'</div>';	// 128
	$cntval=array("width"=>"","left"=>"");
	$ret=str_value_parametar($tmpstyle,$cntval,":",";");
	if ($cntval["width"] !=="") { $p_width=$cntval["width"]; }
	if ($cntval["left"] !=="") { $path_left=$cntval["left"]; }
	$path_width=403-(preg_replace( '/[^\p{Nd}]/u', '',$path_left)+preg_replace( '/[^\p{Nd}]/u', '',$p_width)+$def*2);		// $path_width=403-($path_left+$p_width+$def*2);
	$tmpstyle="";$valstr="";$att_width="";;									// Path編集
	if (isset($XML_DISPATTR["xml"]["Path_Value"]["width"])) {							// 初期値でなくXML設定の判断
		if ($XML_DISPATTR["Path_Style"]["width"] !=="") { $att_width="width:".$XML_DISPATTR["Path_Style"]["width"].'px;'; }		// XML Keyの属性 widthが優先される
		}
// $str2 = preg_replace( '/[^\p{Nd}]/u', '', $str2); 文字列を取り除く方法
	$ret=str_intoreplace('style="position:fixed;px;left:'.(preg_replace( '/[^\p{Nd}]/u', '', $path_left)+preg_replace( '/[^\p{Nd}]/u', '', $p_width)+$def).'px;width:'.$path_width.'px;"','style="','"',$XML_DISP["Path_Style"],0,$tmpstyle,$valstr,':',';',$att_width);
//	$ret=str_intoreplace('style="position:fixed;px;left:'.($path_left+$p_width+$def).'px;width:'.$path_width.'px;"','style="','"',$XML_DISP["Path_Style"],0,$tmpstyle,$valstr,':',';',$att_width);
	$overid="albumover";
	$overid_str=$overid."p";
	$RollPara=$str;			// RollOver Point
	$js='if (RequestHTMLLength(\''.$overid_str.'\',\'12.5px\',\'180%\') > 0) { RequestHTMLLength(\''.$overid_str.'\',\'\',\'230%\'); };';
	print '<div type=submit class="HDPATH music" onclick="RequestBoxDisp(\''.$overid.'\');'.$js.'" '.$tmpstyle.'>&nbsp;'.$Disp_Home.'</div>';
// Function Callum
	if ($jsp !== "") {		// Function Add
		print '<button class="buttn HEDBAD" '.$jsp.' align=center style="position:fixed;left:406px;font-size:11px;margin:1px 0px 0px 0px;">'.$name.'</button>';
		}
	$id='idApplFunc';
	print '<button type=submit name=function value=function onclick="RequestBoxDisp(\''.$id.'\');" class="comnd HDFUNC" style="left:459px;background-color:#008000;margin:2px 0px 0px 0px;">...</button>';
	print '</div>';
	DispApplFunc($id,46,178,$tbno,$pos);			// RollOver Display
// RollOver Callum
	DispRollOver($overid,$RollPara,20,70,384,26,"","background-color:#242424;border:#BDBDBD solid 0.7px;margin:-0.7px 0px 0px 0px;",$overid_str);
	print '<div style="clear:both;width:150px;height:38px;"></div>';
	}

/* -----------------------------------------------------------------------------
	str_intoreplace($str,$ptnStart,$ptnStop,$rep,$mode,$retStr,$retRep,$dlm,$dlmStop,$def) : 文字間パラメータ置換
 	 $str     : i  : Original 文字列
	 $ptnStart: i  : Search文字列(開始)
	 $ptnStop : i  : Search文字列(終了) : Search文字列(開始)～(終了)間を対象 Ex: 'style="' ～置換対象～ '"'
	 $rep     : i  : Destination 文字列 (目的) 形式が検知できない/Search文字列が""のときは$str(Original 文字列)を復帰する($retStrにセット)
	 $mode    : i  : 0:1$repを形式に従い$strに追加する / 1:$repを形式に従い$strに挿入する。(入れ換え)
	 $retStr  : o  : Replase Original: Destination文字列を Search文字列で検索しOriginalを置換
	 $retRep  : o  : Destination 文字列からSearch文字列で検索した内容をクリア
	 $dlm     : i  : デリミタ文字(パラメータと値) Ex: width:60px; -> ":"
	 $dlmStop : i  : デリミタ文字(パラメータ)     Ex: width:60px; -> ";"
	 $def     : i  : パラメータ固定値 (置換または追加) デリミタ文字で修飾されていること
	 @return  : o  : 0:$rep Search文字列の解析成功  1:$rep Search文字列未検出($retRep=$rep,$retStr=$str) 2:$str Search文字列未検出($retStr←$rep可能な限り)

	使用関数)
	  str_unique:文字間パラメータ重複削除 /str_uniqueadd:文字間パラメータ値セット (置換または追加)
	※Sumple
	 $ret=str_intoreplace('style="position:fixed;width:10px;"','style="','"','style="border:1px solid;width:80px;"Oh!',0,$retStr,$retRep,':',';',"width:90px;");
	 print '$retStr['.$retStr.'] $retRep['.$retRep.']<BR>';
	 $retStr[style="position:fixed;border:1px solid;width:90px;"] $retRep[Oh!]
----------------------------------------------------------------------------- */
function str_intoreplace($str,$ptnStart,$ptnStop,$rep,$mode,&$retStr,&$retRep,$dlm=NULL,$dlmStop="",$def="") {
	$retStr=$str;
	$retRep=$rep;
	$res_str = preg_match_all('/'.$ptnStart.'(.*?)'.$ptnStop.'/',$str,$orgn,PREG_SET_ORDER);		// Original Source:正規化Search '/{StringStart}(.*?){StringStop}/'
	$res_rep = preg_match_all('/'.$ptnStart.'(.*?)'.$ptnStop.'/',$rep,$dest,PREG_SET_ORDER);		// Destination(目的):正規化:'/{StringStart}(.*?){StringStop}/'
	$org="";$tmp="";$ret=1;
	if ($res_str > 0) {								//  Originalが有効のとき
		$org=$orgn[0][1];
		$tmp=$org;
		}
	if ($res_rep > 0) {								// Destinationになければ置換しない
		$ret=0;$tmp=$dest[0][1];
		if ($mode==0) {
			if (!is_null($dlm)) {
				$org=str_unique($org,$dest[0][1],$dlm,$dlmStop);
				}
			$tmp=$org.$dest[0][1];					// OriginalにDestinationを追加
			}
		 }
	if (!is_null($dlm)) {							// パラメータの置換または追加
		$tmp=str_uniqueadd($tmp,$def,$dlm,$dlmStop);
		}
	if ($org !=="") {
		 $retStr=preg_replace('/('.$ptnStart.').+?('.$ptnStop.')/','$1'.$tmp.'$2',$str,1);		// OriginalにDestination:$ptnStart～$ptnStop間を置換 正規化:'/({StringStart:$1}).+?({StringStart:$2})/' , '$1{$string}$2'
		 }
	else {											// Originalが""のとき
		 $ret=2;
		 $retStr=preg_replace('/'.$ptnStart.$ptnStop.'/',$ptnStart.$tmp.$ptnStop,$str,1);		// OriginalにDestination:$ptnStart～$ptnStop間を被せる
		 }
	$retRep=preg_replace('/'.$ptnStart.'(.*?)'.$ptnStop.'/',"",$rep);							// 処理済の正規化Searchをクリアする
	return($ret);
	}

/*
	str_unique($str,$base,$dlm,$dlmStop) : 文字間パラメータ重複削除
	 $str     : i  : チェック文字列&重複削除文字列
	 $base    : i  : チェック文字列
	 $dlm     : i  : デリミタ文字(パラメータと値) Ex: width:60px; -> ":"
	 $dlmStop : i  : デリミタ文字(パラメータ)     Ex: width:60px; -> ";"
	 @return  : o  : $strから重複を削除
*/
function str_unique($str,$base,$dlm,$dlmStop) {
	$ar_bas = explode($dlmStop,$base);
	$ret=$str;
	foreach ($ar_bas as $bas) {					// Fucntion Add 複数行対応
		if ($bas == "") { continue; }
		$ar_b = explode($dlm,$bas);
		$res = preg_match_all('/'.$ar_b[0].'(.*?)'.$dlm.'/',$str,$dest,PREG_SET_ORDER);		// Destination(目的):正規化:'/{StringStart}(.*?){StringStop}/'
		if ($res > 0) {
			$ret=preg_replace('/'.$ar_b[0].'(.*?)'.$dlmStop.'/','',$ret);					// 処理済の正規化Searchをクリアする
			}
		}
	return($ret);
	}

/*
	str_unique($str,$base,$dlm,$dlmStop) : 文字間パラメータ値セット (置換または追加)
	 $str     : i  : チェック文字列&重複削除文字列
	 $def     : i  : デフォルト文字列 デリミタ文字で修飾されていること width:60px;
	 $dlm     : i  : デリミタ文字(パラメータと値) Ex: width:60px; -> ":"
	 $dlmStop : i  : デリミタ文字(パラメータ)     Ex: width:60px; -> ";"
	 @return  : o  : $strから重複を削除
*/
function str_uniqueadd($str,$def,$dlm,$dlmStop) {
	$ar_def = explode($dlmStop,$def);
	$ret=$str;
	foreach ($ar_def as $df) {					// Fucntion Add 複数行対応
		if ($df == "") { continue; }
		$ar_d = explode($dlm,$df);
		$tmpdlm = "";
		$tmpdef = "";
		$sour=$ar_d[0];
		if (isset($ar_d[1])) {
			 $tmpdlm = $dlm;
			 $tmpdef = $ar_d[1];
			 $sour=$sour.$dlm;
			 }
		$res = preg_match_all('/'.$sour.'(.*?)'.$dlmStop.'/',$str,$dest,PREG_SET_ORDER);		// Destination(目的):正規化:'/{StringStart}(.*?){StringStop}/'
		if ($res > 0) {
			 $ret=preg_replace('/'.$sour.'.+?'.$dlmStop.'/',$sour.$tmpdef.$dlmStop,$ret);		// 処理済の正規化Searchをクリアする
			 }
		else {
			 $ret=$ret.$df.$dlmStop;
			 }
		}
	return($ret);
	}

/*
	str_value_parametar($str,$cntval,$dlm,$dlmStop) : 文字間パラメータ値Get
	 $str     : i  : チェック文字列
	 $cntval  : io : Reqest カウント文字列(パラメータ)復帰時に内容、ない場合,NULL($num=1時'0'), 配列時:Keyにパラメータ ,文字列時変数を経由すること。
	 $dlm     : i  : デリミタ文字(パラメータと値) Ex: width:60px; -> ":"
	 $dlmStop : i  : デリミタ文字(パラメータ)     Ex: width:60px; -> ";"
	 $num     ; i  ; 1:数値のみ返す。0:文字列
	 @return  : o  : $cntvalが文字列時時値を次返す。見つからないとき"" ($num=1時'0')
	
	※Sumple Array
	 $cntval=array( "width"=>"","left"=>"");				<= Keyにセット
	 $ret=str_value_parametar($style,$cntval,":",";");
	 =>Array ([width] => 90px[left] => 306px )				<= 値を復帰
	※Sumple Not Array
	 $ret=str_value_parametar($style,$str="width",":",";"); <= $str="width" 変数を経由
	 print $ret=>90px
*/
function str_value_parametar($str,&$cntval,$dlm,$dlmStop,$num=0) {
	$ret="";
	if (is_array($cntval)) {
		 $arycnt=$cntval;
		 }
	else {
		 $arycnt[$cntval]="";
		 if ($num == 1) { $ret=0; }
		 }
	foreach ($arycnt as $key => $cnt) {								// $cntval["正規化表現"]:NULL対象の値 / 定数初置換
		$result = preg_match_all('/'.$key.$dlm.'(.*?)'.$dlmStop.'/',$str,$cntno,PREG_SET_ORDER);	// 復帰文字列から指定文字列の値を取得
		if ($result > 0) {											// 指定文字列のカウント
			$val=$cntno[0][1];
			if ($num == 1) {
				$val=preg_replace('/[^0-9]/','',$cntno[0][1]);
				}
			if (is_array($cntval)) {								// Reqestが配列時
				 $cntval[$key]=$val;
			 	 }
			else {													// Reqestが配列でない
				 $ret=$val;
				 }
			 }
		else if (is_array($cntval)) {								// 指定文字列が見つからない
				 if ($num == 1) {
					  $cntval[$key]=0;
					  }
				 else {
			 		  $cntval[$key]=NULL;
					  }
			 }
		}
	return($ret);
	}

/* -----------------------------------------------------------------------------
	DispFunc($id,$top,$left): Function Display
	 $id    : i  : buttonのid名
	 $title : i  : Box Title
	 $top   : i  : 表示位置 top
	 $left  : i  : 表示位置 left
----------------------------------------------------------------------------- */
function DispFunc($id,$title,$top=22,$left=178) {
	global $SOURCE,$REQ_MODULE;

	$Line=28;$def=0;
	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	$SOURCE["Unload"]=$unload;

	$id=rtrim($id);
	$XML_ADDPARM_ARY=GetEnvAddFuncGrp($id."_".$REQ_MODULE,$id);
	$def=$Line*($XML_ADDPARM_ARY["SetNo"]);
	if ($def < 64) { $def=64; }
	print '<div id='.$id.' class=box style="position:fixed;top:'.$top.'px;left:'.$left.';height:'.(64+$def).'px;">';
	print '<div align="left" class=boxtitle>'.$title.'</div>';

	GetEnvAddFuncSetGrp($SOURCE,$XML_ADDPARM_ARY);
	$i=0;$f=0;
	if ($XML_ADDPARM_ARY["SetNo"] > 0) {
		foreach ($XML_ADDPARM_ARY["PARM"] as $key=> $XML_ADDPARM) {					// Fucntion Add 複数行対応
			$name="";$jsp="";
			if ($XML_ADDPARM["line"]  !== "") { $name=$XML_ADDPARM["name"]; }
			if ($XML_ADDPARM["click"] !== "") { $jsp =$XML_ADDPARM["click"]; }
			if ($jsp !== "") {
				print '<div id="idExFnc'.$f.'" class="boxtext" '.$jsp.' style="height:16;top:'.(6+($i+=$Line)).'px;width:278px;background-color:#08084d;border: 1px solid #acacac;cursor:pointer;">'.$name.'</div>';
				$f=$f+1;
				}
			}
		}
	print '<input type="button" name="Submit" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" />';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DispHeaderFunc($id,$top,$left): Function Display
	 $id    : i  : buttonのid名
	 $top   : i  : 表示位置 top
	 $left  : i  : 表示位置 left
----------------------------------------------------------------------------- */
function DispHeaderFunc($id='idHeaderFunc',$top=22,$left=178) {
	global $MY_VERSION,$SOURCE,$REQ_MODULE,$REQ_UA,$REQ_VENDOR;
	$Line=28;$def=0;

	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	$SOURCE["Unload"]=$unload;

	$XML_ADDPARM_ARY=GetEnvAddFuncGrp("TopHead_".$REQ_MODULE,"TopHead");
	$def=$Line*($XML_ADDPARM_ARY["SetNo"]);
	print '<div id='.$id.' class=box style="position:fixed;top:'.$top.'px;left:'.$left.';height:'.(260+$def).'px;">';
	print '<div align="left" class=boxtitle>'."Information".'</div>';

	GetEnvAddFuncSetGrp($SOURCE,$XML_ADDPARM_ARY);
	$i=0;
	if ($XML_ADDPARM_ARY["SetNo"] > 0) {
		foreach ($XML_ADDPARM_ARY["PARM"] as $key=> $XML_ADDPARM) {					// Fucntion Add 複数行対応
			$name="";$jsp="";
			if ($XML_ADDPARM["line"]  !== "") { $name=$XML_ADDPARM["name"]; }
			if ($XML_ADDPARM["click"] !== "") { $jsp =$XML_ADDPARM["click"]; }
			if ($jsp !== "") {
				print '<div type=submit class="boxtext" '.$jsp.' style="height:16;top:'.(6+($i+=$Line)).'px;width:278px;font-size:11px;background-color:#08084d;border: 1px solid #acacac;cursor:pointer;">'.$name.'</div>';
				}
			}
		}
	print '<div class="boxtext" style="top:'.($top+$def+12).'px;left:0px;font-size:9px;">PHP Ver: '.phpversion().'</div>';

	$tmp=$_SERVER['REMOTE_ADDR'];
	if(strlen($tmp) >15) { $tmp=substr($tmp,0,15).".."; } else { $tmp=$tmp.'&nbsp;&nbsp;'; }
	print '<div class="boxtext" style="top:'.($top+$def+26).'px;left:0px;width:280px;font-size:9px;">REMOTE_ADDR:&nbsp;'.$tmp.'['.$REQ_UA.']['.$REQ_VENDOR.']</div>';
	$str="HTTP_USER_AGENT is missing";
	if (isset($_SERVER['HTTP_USER_AGENT'])) {
		$str=$_SERVER['HTTP_USER_AGENT'];
		}
	print '<div class="boxtext" style="height:50;top:'.($top+$def+40).'px;width:278px;font-size:9px;color:#b0c4de;">Information:&nbsp;'.$str.'</div>';

	$mem = sprintf('%.2f',((memory_get_usage()) / 100000));
	$mem = number_format($mem,2);
	print '<div class="boxtext" style="top:'.($top+$def+98).'px;font-size:9px;">PHP Used Memory : '.$mem.' MB</div>';

	print '<div class="boxtext" style="top:'.($top+$def+110).'px;font-size:9px;color:#98fb98;">'.$MY_VERSION.'</div>';
	print '<div class="boxtext" style="top:'.($top+$def+122).'px;font-size:9px;">'.(apl_version()).'</div>';
	print '<div class="boxtext" style="top:'.($top+$def+136).'px;font-size:9px;">'.(lib_version()).'</div>';
	print '<div class="boxtext" style="top:'.($top+$def+148).'px;font-size:9px;">'.(cmnses_version()).'</div>';
	print '<div id=MYJSVER class="boxtext" style="top:'.($top+$def+160).'px;font-size:9px;"></div>';
	print '<div id=MYAJAXVER class="boxtext" style="top:'.($top+$def+172).'px;font-size:9px;"></div>';
	print '<div class="boxtext MYCSS_VERSION" style="top:'.($top+$def+184).'px;font-size:9px;"></div>';
	print '<div class="boxtext" style="bottom:-2px;font-size:9px;">'."(C)2019 by Mikio Shiratori".'</div>';

	print '<input type="button" name="Submit" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" />';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DispApplFunc($id,$top,$left,$tbno,$pos): Application Function Display
	 $id    : i  : buttonのid名
	 $top   : i  : 表示位置 top
	 $left  : i  : 表示位置 left
	 $tbno  : i  : DispFileAlbum TableNo Art数(XMLConfif)
	 $pos   : i  : Positioning "on"/"off"
----------------------------------------------------------------------------- */
function DispApplFunc($id='idApplFunc',$top=46,$left=178,$tbno,$pos) {
	global $SOURCE,$REQ_MODULE;
	$Line=28;$def=0;

	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	$SOURCE["Unload"]=$unload;

	$XML_ADDPARM_ARY=GetEnvAddFuncGrp("AppHead_".$REQ_MODULE,"AppHead");
	if ($XML_ADDPARM_ARY["SetNo"] > 3) {
		$def=$Line*(($XML_ADDPARM_ARY["SetNo"]) - 3);
		}
	print '<div id='.$id.' class=box style="position:fixed;top:'.$top.'px;left:'.$left.';height:'.(210+$def).'px;">';
	print '<div align="left" class=boxtitle>'."Function".'</div>';
	print DispApplFuncTbno($tbno);
	if ($pos !=='on') {
		 $arg["pos"]='on';
		 }
	else {
		 $arg["pos"]='off';
		 }
	$url=URLQueryReplase($arg);
	$url='location.href=\''.$url.'\';RequestLoadDisp(0);';
	print '<input type=button onclick="'.$url.'" value="Postion&nbsp;:&nbsp;'.$arg["pos"].'" class="boxline boxblin2">';

	GetEnvAddFuncSetGrp($SOURCE,$XML_ADDPARM_ARY);
	$i=0;
	if ($XML_ADDPARM_ARY["SetNo"] > 0) {
		foreach ($XML_ADDPARM_ARY["PARM"] as $key=> $XML_ADDPARM) {					// Fucntion Add 複数行対応
			$name="";$jsp="";
			if ($XML_ADDPARM["line"]  !== "") { $name=$XML_ADDPARM["name"]; }
			if ($XML_ADDPARM["click"] !== "") { $jsp =$XML_ADDPARM["click"]; }
			if ($jsp !== "") {
				print '<div type=submit class="boxtext" '.$jsp.' style="height:16;top:'.(64+($i+=$Line)).'px;width:278px;background-color:#08084d;border: 1px solid #acacac;cursor:pointer;">'.$name.'</div>';
				}
			}
		}
	print '<input type="button" name="Submit" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" />';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DispFileFuncTbno($tbno): DispFile Function Display TableNo (Art数)
	 $tbno  : i  : DispFile TableNo Art数(Combo/XMLConfif)
----------------------------------------------------------------------------- */
function DispApplFuncTbno($tbno) {
	print '<div class="boxline boxblin1" style="width:278px;height:18px;cursor:auto;">Art No';
	for($i = 1;$i < 11 ;$i++) { $select["Text"][]=$i; }
	$defstr=$tbno;
	$select["style"]["position"]="position:absolute;";
	$style="background-color:#d3d3d3;color:#3d3d3d;font-size:15px;";
	MakeSelectBox("get",$select,$defstr,"idtbno",1.5,160,80,"","idArtLNoSel","",$style);
	print '<form action="javascript:RequestLoadDisp(0)">';
	$arg["tbno"]=FALSE;										// URLから&tbnoを削除
	$url=URLQueryReplase($arg);
	$url='location.href=\''.$url.'\'+\'&tbno=\'+document.getElementById(\'idtbno\').value;RequestLoadDisp(0);';		// Form入力値を &tbnoにセット
	print '<button type=submit name="TbnoSubmit" id=idArtLNoSel onclick="'.$url.'" value="Submit" style="position:absolute;top:4px;left:238px;border-style:none;width:55px;height:21px;margin:-3px 0px 0px 6px;cursor:pointer;">Submit</button>';
	print '</div>';
	print '</form>';
	}

/* -----------------------------------------------------------------------------
	DispRollOver($id,$str,$top,$left,$width,$height,$class,$style): Display Text Over Roll Alteration
	 $id    : i  : id名
	 $str   : i  : String '<div'が含まれる場合,そのまま表示、修飾は呼び元に依存する
	 $top   : i  : 表示位置 top 'top:{pos}'/'bottom:{pos}'/"{pos}":Topのときは省略可
	 $left  : i  : 表示位置 left
	 $width : i  : 表示位置 width
	 $heigh : i  : 表示位置 heigh
	 $class : i  : Box表示 class
	 $style : i  : Box追加 Style
	 $pid     : i  : String id (When ,Not Space)
------------------------------------------------------------------------------ */
function DispRollOver($id,$str,$top=4,$left=50,$width=420,$height=20,$unloadjs="",$style="background-color:#fffacd;color:#000000",$pid="") {	// background-color:クリーム,文字:黒
	$unload = 'RequestBoxtUnLoad(\''.$id.'\');'.$unloadjs;

	$pos=$top;
	$ret = explode(":",$top);
	if (!isset($ret[1])) {
		$pos="top:".$top;							// top:{pos} / bottom:{pos}形式 以外はtopとする
		}
	print '<div id='.$id.' style="position:fixed;'.$pos.'px;left:'.$left.';width:'.$width.'px;height:'.$height.'px;'.$style.';border: 1px solid #888888;display:none;z-index:400">';
	if (strpos($str,"<div") !== false) {			// HTML修飾されているときはそのまま使用
		 print $str;
		 }
	else {
		 if($pid !=="") { $pstrid=' id="'.$pid.'" '; } else { $pstrid=""; }
		 print '<p '.$pstrid.'class=RollTex style="width:'.$width.'px;">'.$str.'</p>';
		 }
	print '<button onclick="'.$unload.'" class=rollo style="position:fixed;'.$pos.'px;left:'.$left.';width:'.$width.'px;height:'.$height.'px;"></button>';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DispState() : Disp Status Area
----------------------------------------------------------------------------- */
function DispState() {
	global $XML_DISP,$STS_MESSAGE;

	if ($XML_DISP["Status"] =="on") {						// Statusを表示するかの設定
		 $style = 'style="display:block;"';
		 }
	else {
		 $style = 'style="display:none;"';
		 }
	if ($XML_DISP["Status_Scrollbar"] =="on") { } else { $style=(rtrim($style,'"')).'overflow:hidden;"'; }
	print '<div id="IdState" class=botom style="left:2px;bottom:-1px;width:479px;font-size:11px;z-index:100">';	// RequestLoadDispよりz-indexを上げている
	print '<textarea cols="56" rows="1" readonly id="status" class=StatusL '.$style.'>'.$STS_MESSAGE.'</textarea>';				// Using Debug
	print '</div>';

	global $REQ_MODULE,$REQ_PATH,$SOURCE;					// $SOURCE:ArgJsBuiltin XML Settingの変換用
	$TBLCHG=GetReserveStruct("js");							// 自URL,変換配列を設定
	foreach($SOURCE as  $key => $val) { $chg["%".$key."%"] = $val; }
	$chg=array_merge($TBLCHG,$chg);
	ArgJsBuiltin("AddHTML",0,$chg);
	}

/* -----------------------------------------------------------------------------
	DispEndFunc() : Disp End Function
----------------------------------------------------------------------------- */
function DispEndFunc($local_path,$file_ary,$id_ary) {
	global $REQ_MODULE,$REQ_PATH,$SOURCE;					// $SOURCE:ArgJsBuiltin XML Settingの変換用

	global $DIRCTORY,$FILE,$ID;								// $SOURCE:ArgJsBuiltin XML Settingの変換用
	$DIRCTORY=$local_path;$FILE=$file_ary;$ID=$id_ary;		// 明記的に項目セット

	$TBLCHG=GetReserveStruct("js");							// 自URL,変換配列を設定
	foreach($SOURCE as  $key => $val) { $chg["%".$key."%"] = $val; }
	$chg=array_merge($TBLCHG,$chg);
	ArgJsBuiltin("EndHTML",0,$chg);
	}

/* -----------------------------------------------------------------------------
	DispSureBox($message): Display Error Box
	 $message: i  : Message
----------------------------------------------------------------------------- */
function DispErrorBox($message) {
	print '<div id=idError style="border: 1px solid #888888;position:fixed;top:130px;left:40px;width:420px;height:200px;font-size:12p;z-index:5;background-color:#2f2f2f;">';
	print '<div class=boxtitle align=left style="background-color:#0000FF;color:#CEECF5;width:400px;">MPDWeb Error Message</div>';
	print '<div align=left style="width:400px;height:100px;font-size:16px;position:absolute;top:40px;left:20px;background-color:#2f2f2f;color:#ffffff">'.$message.'</div>';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DirStringMerge($Path1,$Path2) : Directory Path String Mearge
	 $Path1  : i  : Directory Path String Lower
	 $Path2  : i  : Directory Path String Upper
	 @return : o  : Output Merge Path
----------------------------------------------------------------------------- */
function DirStringMerge($Path1,$Path2) {
	$str1=rtrim($Path1, '/');
	$str1=ltrim($str1, '/');
	$str2=rtrim($Path2, '/');
	$str2=ltrim($str2, '/');
	$str=$str1."/".$str2;
	if (($str!=="")&&(substr($str,(strlen($str)-1),1) !== "/")) {
		$str=$str."/"; }
	if (($str!=="")&&(substr($str,0,1) !== "/")) {
		$str="/".$str;
		}
	if ($str=="") { $str="/"; }
	return($str);
	}

/***************************************************************************************
	mpdartlist.php Common Function
****************************************************************************************/
/* -----------------------------------------------------------------------------
	URLHTMLEncode($str) : URL HTML Encode
	 $str    : i  : Directory Path String Lower
	 @return : o  : Encode String
	※FileSystemをEncodeする際,"/"などPath構成の文字を残したいので文字を選んでいる。
----------------------------------------------------------------------------- */
function URLHTMLEncode($str) {
	$url_char=array(' ', '#',"'");			// URL Encode
	$rep_char=array('%20', '%23' ,'%27');		// URL Replace

	$str = str_replace($url_char,$rep_char,$str);
	$str=Commn_UrlEncode($str);
	return($str);
	}

/* -----------------------------------------------------------------------------
	URLQueryReplase($arg) : URL Parameter(パス&クエリ) 置換
	 $arg   : i  : URL Parameter Array ["key"]:Value &key=Valueで同一keyを置換 Value:FALSEはURLから削除
	 @return: o  : New URL
----------------------------------------------------------------------------- */
function URLQueryReplase($arg) {
	$new=$arg;											// 新URLパラメータキー配列
	$para="";
	$prg = explode('?',$_SERVER['REQUEST_URI']);
	if (isset($prg[1])) {
		$para=$prg[1];
		}
	$part = explode('&',$para);
	foreach ($part as $p) {								// 現在のURLパラメータキーが新URLパラメータになければ$new配列にキーを追加
		$a = explode('=',$p);
		if ((isset($a[1]))&&($a[1] !== "")) {
			if (!isset($new[$a[0]])) {					// $new配列に追加
				 $new[$a[0]]=$a[1];
				 }
			}
		}
	$url_para="";
	foreach ($new as $nk => $n) {						// $new配列をStringにしてURLパラメータを作成
		if ($n===FALSE) { continue; }					// $new FALSEは対象にしない(URLから削除)
		if ($url_para !=="") {
			$url_para=$url_para."&";
			}
		$url_para=$url_para.$nk."=".$n;
		}
	$url_para=$prg[0]."?".$url_para;					// モジュール名はREQUEST_URIを使用する
	return($url_para);
	}

/* -----------------------------------------------------------------------------
	JsListLastPosition($idtop,$idlast,$pos.$left): JsExec Last Position Display
	 $idtop  : i  : Html 1St id value   先頭のHTML id
	 $idlast : i  : Html Last id value  最後のHTML id
	 $pos    : i  : Position Correction (Header Higth)
	 $left   : i  : Postion時 Left位置 "auto"時自動,他(数値時)はLeftを強制的にセットする
	JS RequestScrollStopのパラメータを設定
	スクロール:テーブルの最終位置Position (最後のid,先頭のidの差にHeader部を加味してPosition)
----------------------------------------------------------------------------- */
function JsListLastPosition($idtop,$idlast,$pos,$left="auto") {
	$str1=str_replace(array("\\","'",'"'),array("\\\\","\'",'&quot;'),$idtop);	// 先頭のHtml id
	$str2=str_replace(array("\\","'",'"'),array("\\\\","\'",'&quot;'),$idlast);	// 最後のHtml id
	print <<<EOM
<div style="height:2000px;"></div>			// スクロール範囲を設定
<script type="text/javascript">
<!--
var HeadPos = '{$pos}';
var idTop='{$str1}';
var idLast='{$str2}';
var lastleft='{$left}';
-->
</script>
EOM;
	}

/* -----------------------------------------------------------------------------
	JsPHPServerVar(): Jsでの使用のためPHPシステム変数を作成
----------------------------------------------------------------------------- */
function JsPHPServerVar() {
	global $ARG,$XML_HISTORY;

	$PHP_SELF=$_SERVER['PHP_SELF'];
	$QUERY_STRING=$_SERVER['QUERY_STRING'];
	$REQUEST_URI =$_SERVER['REQUEST_URI'];
	$REMOTE_ADDR =$_SERVER['REMOTE_ADDR'];
	if (isset($ARG[$XML_HISTORY["BackTag"]])) { $burl=$ARG[$XML_HISTORY["BackTag"]]; } else { $burl=""; }
	$str=ArgPartURL($burl,$_SERVER['QUERY_STRING'],$_SERVER['REQUEST_URI']);
	$QUERY_STRING_OMIT=$_SERVER['QUERY_STRING'];
	echo <<<EOM
// Jsでの使用のためPHPシステム変数
var PHP_SELF    ='{$PHP_SELF}';			// 実行しているPHPScript Filename
var QUERY_STRING='{$QUERY_STRING}';		// アクセスの検索引数
var REQUEST_URI ='{$REQUEST_URI}';		// ページにアクセスに指定された ('/index.html')
var REMOTE_ADDR ='{$REMOTE_ADDR}'	;	// 現在ページをみているIP アドレス
var QUERY_STRING_OMIT='{$QUERY_STRING_OMIT}';	// アクセスの検索引数(&URL:Historyカット版)
EOM;
	}

/* -----------------------------------------------------------------------------
	JsListLoadDisp($pos,$value,$id): JsExec RequestLoadDisp Clockmark Display
	 $pos    : i  : Positioning "on"/"off"
	 $value  : i  : Positioning 位置
	 $id     : i  : Target id
	時計マーク表示 (テーブル表示時に使用)
----------------------------------------------------------------------------- */
function JsListLoadDisp($pos,$value,$id) {
	if (($value!=="")&&($pos == "on")) {	// Positioning指定時
		print <<<EOM
<script type="text/javascript">
<!--
var id = '{$id}';
RequestLoadDisp(0);
setTimeout(function() { document.getElementById(id).style.display='block'; },5000);
-->
</script>
EOM;
		}
	}

/* -----------------------------------------------------------------------------
	JsListPosition($pos,$value,$id,$high,$left): JsExec Value Position Display
	 $pos    : i  : Positioning "on"/"off"
	 $value  : i  : Positioning 位置
	 $id     : i  : Target id
	 $high   : i  : Position Correction (Header Higth)
	 $left   : i  : left Correction
	指定位置Position 時計マークUnload
----------------------------------------------------------------------------- */
function JsListPosition($pos,$value,$id,$high,$left=0) {
	$str=str_replace(array("\\","'",'"'),array("\\\\","\'",'&quot;'),$value);
	print <<<EOM
<script type="text/javascript">
<!--
var id = '{$id}';
var val = '{$str}';
var valhigh = '{$high}';
var valleft = '{$left}';
-->
</script>
EOM;
	if ($pos == "on") {		// Positioning指定時
		print <<<EOM
<script type="text/javascript">
<!--

RequestUnLoadDisp();

document.getElementById(id).style.display='block';
if (val !== "") {							// Spaceに位置付けする場合idがあれば通常同様位置付けるが、なければそのままにする(Spaceは先頭と解釈する)
	RequestScrollPositon();
	}
-->
</script>
EOM;
		}
	}

/* *****************************************************************************
	mpdweb.lib_appli.phpの共通関数を定義
	namespace MyProject;で区別する
	require_onceのモジュール名決定で即使用するため定義し,namespaceで区別する
****************************************************************************** */
/* mpdweb.lib_appli.php (SameModule) */
/* -----------------------------------------------------------------------------
	ArgDecode($strx) : String Decode Request
	 $str : i  : before Decode Req.String
	             Encode Method String  "Hex:" Or "B64:"
	 @return   : After Decode String
----------------------------------------------------------------------------- */
function ArgDecode($strx) {
	$str = explode(':', $strx, 2);
	if ((!isset($str[0]))||(!isset($str[1]))) { // Hex EncodeのマークがなければそのままReturn
		return($strx);
		}
	if ($str[0] == "B64") {				// Base64変換
		$str[1] = str_replace(array('_','-', '.'),array('+', '/', '='),$str[1]);
		$dec=base64_decode($str[1]);
		return($dec);
		}
	if ($str[0] == "Hex") {				// Hex変換
		if (!ctype_xdigit($str[1])) {	// 文字列がHexでなければそのままReturn ($metho追加時テストできるように形式が合わなければRetrun)
			return($strx);
			}
		$str_hex=pack("H*", $str[1]);	// Hex変換を復元する hex2bin PHP Ver5.5からなので代わり
		return($str_hex);
		}
	return($strx);						// 文字列が形式不明ならそのままReturn
	}
/* -----------------------------------------------------------------------------
  mpdweb.lib.php (SameModule)
----------------------------------------------------------------------------- */
/*
	get_myloadconfig($xml_file) : XMLパラメータ : Get get_loadconfig→ Get get_myloadconfig
	 $xml_file : i  : XML FileNam
	 $Exception: i  :"on" : Error時停止, "off":Error続行
	 @return   : o  : $XML_CONF(XML Array)  : Error時,Error内容
*/
function get_myloadconfig($xml_file,$Exception="on") {
	global $XML_CONF;

	if (!isset($XML_CONF)) {
		if (file_exists($xml_file)) {
			 $XML_CONF = simplexml_load_file($xml_file);
			 if ($XML_CONF === false) {
				$errstr="Failed loading XML";
				if ($Exception=="on") {
					 throw new Exception("Failed loading XML Parser Error"."\t"."[Warning: See simplexml_load_filew !!]");
					 }
				else {
				 	 $XML_CONF="Failed loading XML Parser Error [See simplexml_load_filew !!]".$xml_file;
				 	 }
				 }
			 }
		else {
			 if ($Exception=="on") {
				  throw new Exception("Failed File Open File Exists Error : ".$xml_file."\n");
				  }
			 else {
				  $XML_CONF="Failed File Open File Exists Error : ".$xml_file;
				  }
			 }
		}
	return($XML_CONF);
	}

/*
	get_config($section,$item) : XMLパラメータ設定
	  $item 	: io  : パラメータ取得項目配列
	  $XML_CONF	: i   : Config XML Data

	※Sumple
	XML <ArtList>List onclick=alert()</ArtList>
	$xmlary=array("ArtList"=>on);		// 初期値 関数呼び出し後,取得値に置き換える
	get_config("DISP_Config",$xmlary);
	print $xmlary["ArtList"];
*/
function get_config($section,&$item) {
	global $XML_CONF;

	$ret=0;
	foreach($item as $key => $val ) {
		if(isset($XML_CONF->$section->$key)) {
		   trim($XML_CONF->$key);
		   $item[$key]=(string)$XML_CONF->$section->$key;
		   $ret+=1;
		   }
		}
	return($ret);
	}

//----- Source End --------------------------------------------------------------
?>

</body>
</html>
